#include <rf_core.hh>
#include <refal/Apply.hh>
#include <refal/Box.hh>
#include <refal/Arithm.hh>
#include <refal/Compare.hh>
#include <refal/StdIO.hh>
#include <refal/List.hh>
#include "rfp_helper.hh"
#include <refal/Table.hh>
#include <refal/Class.hh>

namespace refal
{

using namespace rfrt;

namespace rfp__asail2asail
{

static Expr Idx;

RF_DECL (Simplify_m_ASAIL);

RF_DECL (Simplify);

static Expr Blocks;

static Expr Breaks;

static Expr Last_m_Breaks;

RF_DECL (GetR);

RF_DECL (Remove_m_Unreachable);

RF_DECL (Remove_m_Dupl_m_Decl);

RF_DECL (Process_m_Var);

RF_DECL (Simplify_m_Infix);

RF_DECL (Simplify_m_Arithm);

RF_DECL (Eval_sp__a_);

RF_DECL (Eval_sp__p_);

RF_DECL (Eval_sp__s_);

RF_DECL (Eval_sp__percnt_);

RF_DECL (Eval_sp__m_);

RF_DECL (Simplify_m_Cmp);

RF_DECL (Cmp);

RF_DECL (Free_m_Idx);

RF_DECL (_p___0);

RF_DECL (Int_q___0);

RF_DECL (_lt___0);

RF_DECL (_s__eq___0);

RF_DECL (Simplify_m_Infix__0);

RF_DECL (_gt___0);

static Expr _c_0;

static Expr _c_1;

static Expr _c_2;

static Expr _c_3;

static Expr _c_4;

static Expr _c_5;

static Expr _c_6;

static Expr _c_7;

static Expr _c_8;

static Expr _c_9;

static Expr _c_10;

static Expr _c_11;

static Expr _c_12;

static Expr _c_13;

static Expr _c_14;

static Expr _c_15;

static Expr _c_16;

static Expr _c_17;

static Expr _c_18;

static Expr _c_19;

static Expr _c_20;

static Expr _c_21;

static Expr _c_22;

static Expr _c_23;

static Expr _c_24;

static Expr _c_25;

static Expr _c_26;

static Expr _c_40;

static Expr _c_27;

static Expr _c_28;

static Expr _c_29;

static Expr _c_30;

static Expr _c_31;

static Expr _c_32;

static Expr _c_33;

static Expr _c_34;

static Expr _c_35;

static Expr _c_36;

static Expr _c_37;

static Expr _c_38;

static Expr _c_39;

static Expr _c_41;

static Expr _c_42;

static Expr _c_43;

static Expr _c_44;

static Expr _c_45;

static Expr _c_46;

static Expr _c_47;

static Expr _c_48;

static Expr _c_49;

static Expr _c_50;

static Expr _c_51;

RF_FUNC (Simplify_m_ASAIL, (RF_ARG _ve_asail;;), (RF_RES _v_res1;;))
  RF_CALL (Box::Store, (Idx, empty), /*void*/);
  Expr _ge_auxcall1;
  RF_CALL (Simplify, _ve_asail, _ge_auxcall1);
  Expr _ge_auxcall2;
  RF_CALL (Remove_m_Unreachable, _ge_auxcall1, _ge_auxcall2);
  RF_TAILCALL (Remove_m_Dupl_m_Decl, (empty, empty, _ge_auxcall2), _v_res1);
RF_END

RF_FUNC (Simplify, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  {
    {
      uintptr_t _v_len1 = _ge_arg1.get_len ();
      uintptr_t _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__rest = (_v_len1 - _v_len2);
      Expr _vt_first (_ge_arg1, 0, 1);
      Expr _ve_rest (_ge_arg1, (0 + 1), _v_len__rest);
      Expr _ge_first__3;
      {
        {
          if (_vt_first.symbol_at (0))
          {
            goto _block2__branch1;
          }
          Expr _v_deref__first (_vt_first, 0);
          uintptr_t _v_len3 = _v_deref__first.get_len ();
          uintptr_t _v_len4 = 4;
          if (_v_len3 < _v_len4)
          {
            goto _block2__branch1;
          }
          uintptr_t _v_len__body = (_v_len3 - _v_len4);
          if (_v_deref__first.symbol_at ((0 + 1 + 1)))
          {
            goto _block2__branch1;
          }
          if (_v_deref__first.symbol_at ((0 + 1 + 1 + 1)))
          {
            goto _block2__branch1;
          }
          Expr _v_deref__deref__first (_v_deref__first, (0 + 1 + 1));
          Expr _v_deref__deref__first2 (_v_deref__first, (0 + 1 + 1 + 1));
          uintptr_t _v_len5 = _v_deref__deref__first2.get_len ();
          uintptr_t _v_len6 = 0;
          if (_v_len5 < _v_len6)
          {
            goto _block2__branch1;
          }
          uintptr_t _v_len__arg2 = (_v_len5 - _v_len6);
          uintptr_t _v_len7 = _v_deref__deref__first.get_len ();
          uintptr_t _v_len8 = 0;
          if (_v_len7 < _v_len8)
          {
            goto _block2__branch1;
          }
          uintptr_t _v_len__arg1 = (_v_len7 - _v_len8);
          if (!_c_0.term_eq (_v_deref__first, 0))
          {
            goto _block2__branch1;
          }
          if (!_v_deref__first.symbol_at ((0 + 1)))
          {
            goto _block2__branch1;
          }
          Expr _vs_op (_v_deref__first, (0 + 1), 1);
          Expr _ve_body (_v_deref__first, (0 + 1 + 1 + 1 + 1), _v_len__body);
          Expr _ve_arg1 (_v_deref__deref__first, 0, _v_len__arg1);
          Expr _ve_arg2 (_v_deref__deref__first2, 0, _v_len__arg2);
          {
            {
              Expr _ge_auxcall1;
              RF_CALL (Simplify_m_Arithm, _ve_arg1 (), _ge_auxcall1);
              Expr _ge_auxcall2;
              RF_CALL (Simplify_m_Arithm, _ve_arg2 (), _ge_auxcall2);
              Expr _v_Simplify_m_Cmp1;
              if (!RF_CALL (Simplify_m_Cmp, (_vs_op, _ge_auxcall1, _ge_auxcall2), _v_Simplify_m_Cmp1))
              {
                goto _block3__branch1;
              }
              {
                {
                  if (_v_Simplify_m_Cmp1.get_len () != 2)
                  {
                    goto _block4__branch1;
                  }
                  if (_v_Simplify_m_Cmp1.symbol_at (0))
                  {
                    goto _block4__branch1;
                  }
                  if (_v_Simplify_m_Cmp1.symbol_at ((0 + 1)))
                  {
                    goto _block4__branch1;
                  }
                  Expr _v_deref__Simplify_m_Cmp1 (_v_Simplify_m_Cmp1, 0);
                  Expr _v_deref__Simplify_m_Cmp12 (_v_Simplify_m_Cmp1, (0 + 1));
                  uintptr_t _v_len9 = _v_deref__Simplify_m_Cmp12.get_len ();
                  uintptr_t _v_len10 = 0;
                  if (_v_len9 < _v_len10)
                  {
                    goto _block4__branch1;
                  }
                  uintptr_t _v_len__2 = (_v_len9 - _v_len10);
                  uintptr_t _v_len11 = _v_deref__Simplify_m_Cmp1.get_len ();
                  uintptr_t _v_len12 = 0;
                  if (_v_len11 < _v_len12)
                  {
                    goto _block4__branch1;
                  }
                  uintptr_t _v_len__1 = (_v_len11 - _v_len12);
                  Expr _ve_1 (_v_deref__Simplify_m_Cmp1, 0, _v_len__1);
                  Expr _ve_2 (_v_deref__Simplify_m_Cmp12, 0, _v_len__2);
                  Expr _ge_auxcall3;
                  RF_CALL (Simplify, _ve_body, _ge_auxcall3);
                  _ge_first__3 = (_c_0 + _vs_op + _ve_1 () + _ve_2 () + _ge_auxcall3) ();
                  goto _block4;
                }
              _block4__branch1: {}
                if (_v_Simplify_m_Cmp1.get_len () != 0)
                {
                  RF_FUNC_ERROR (unexpected_fail);
                }
                RF_CALL (Simplify, _ve_body, _ge_first__3);
              }
            _block4: {}
              goto _block3;
            }
          _block3__branch1: {}
            _ge_first__3 = empty;
          }
        _block3: {}
          goto _block2;
        }
      _block2__branch1: {}
        {
          if (_vt_first.symbol_at (0))
          {
            goto _block2__branch2;
          }
          Expr _v_deref__first2 (_vt_first, 0);
          uintptr_t _v_len13 = _v_deref__first2.get_len ();
          uintptr_t _v_len14 = 2;
          if (_v_len13 < _v_len14)
          {
            goto _block2__branch2;
          }
          uintptr_t _v_len__body2 = (_v_len13 - _v_len14);
          if (!_c_1.term_eq (_v_deref__first2, 0))
          {
            goto _block2__branch2;
          }
          Expr _vt_cond (_v_deref__first2, (0 + 1), 1);
          Expr _ve_body (_v_deref__first2, (0 + 1 + 1), _v_len__body2);
          Expr _ge_auxcall4;
          RF_CALL (Simplify, _ve_body, _ge_auxcall4);
          _ge_first__3 = (_c_1 + _vt_cond + _ge_auxcall4) ();
          goto _block2;
        }
      _block2__branch2: {}
        {
          if (_vt_first.symbol_at (0))
          {
            goto _block2__branch3;
          }
          Expr _v_deref__first3 (_vt_first, 0);
          uintptr_t _v_len15 = _v_deref__first3.get_len ();
          uintptr_t _v_len16 = 2;
          if (_v_len15 < _v_len16)
          {
            goto _block2__branch3;
          }
          uintptr_t _v_len__expr = (_v_len15 - _v_len16);
          if (!_c_2.term_eq (_v_deref__first3, 0))
          {
            goto _block2__branch3;
          }
          Expr _vt_var (_v_deref__first3, (0 + 1), 1);
          Expr _ve_expr (_v_deref__first3, (0 + 1 + 1), _v_len__expr);
          Expr _ge_auxcall5;
          RF_CALL (Simplify_m_Arithm, _ve_expr (), _ge_auxcall5);
          _ge_first__3 = (_c_2 + _vt_var + _ge_auxcall5) ();
          goto _block2;
        }
      _block2__branch3: {}
        {
          if (_vt_first.symbol_at (0))
          {
            goto _block2__branch4;
          }
          Expr _v_deref__first4 (_vt_first, 0);
          uintptr_t _v_len17 = _v_deref__first4.get_len ();
          uintptr_t _v_len18 = 0;
          if (_v_len17 < _v_len18)
          {
            goto _block2__branch4;
          }
          uintptr_t _v_len__12 = (_v_len17 - _v_len18);
          Expr _ve_1 (_v_deref__first4, 0, _v_len__12);
          Expr _ge_auxcall6;
          RF_CALL (Simplify, _ve_1, _ge_auxcall6);
          _ge_first__3 = _ge_auxcall6 ();
          goto _block2;
        }
      _block2__branch4: {}
        if (!_vt_first.symbol_at (0))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        Expr _vs_1 (_vt_first, 0, 1);
        _ge_first__3 = _vs_1;
      }
    _block2: {}
      Expr _v_Simplify1;
      RF_CALL (Simplify, _ve_rest, _v_Simplify1);
      _v_res1 = (_ge_first__3 + _v_Simplify1);
      goto _block1;
    }
  _block1__branch1: {}
    if (_ge_arg1.get_len () != 0)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    _v_res1 = empty;
  }
_block1: {}
RF_END

RF_FUNC (GetR, (RF_ARG _vs_box;;), (RF_RES _v_res1;;))
  Expr _v__q_1;
  RF_CALL (Box::_q_, _vs_box, _v__q_1);
  uintptr_t _v_len1 = _v__q_1.get_len ();
  uintptr_t _v_len2 = 1;
  if (_v_len1 < _v_len2)
  {
    RF_RETFAIL;
  }
  uintptr_t _v_len__1 = (_v_len1 - _v_len2);
  Expr _ve_1 (_v__q_1, 0, _v_len__1);
  Expr _vt_2 (_v__q_1, (0 + _v_len__1), 1);
  RF_CALL (Box::Store, (_vs_box, _ve_1), /*void*/);
  _v_res1 = _vt_2;
RF_END

RF_FUNC (Remove_m_Unreachable, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  {
    {
      uintptr_t _v_len1 = _ge_arg1.get_len ();
      uintptr_t _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__2 = (_v_len1 - _v_len2);
      Expr _vt_1 (_ge_arg1, 0, 1);
      Expr _ve_2 (_ge_arg1, (0 + 1), _v_len__2);
      Expr _ve_body;
      {
        {
          if (_vt_1.symbol_at (0))
          {
            goto _block2__branch1;
          }
          Expr _v_deref__1 (_vt_1, 0);
          uintptr_t _v_len3 = _v_deref__1.get_len ();
          uintptr_t _v_len4 = 4;
          if (_v_len3 < _v_len4)
          {
            goto _block2__branch1;
          }
          uintptr_t _v_len__body__4 = (_v_len3 - _v_len4);
          if (!_c_3.term_eq (_v_deref__1, 0))
          {
            goto _block2__branch1;
          }
          Expr _vt_name (_v_deref__1, (0 + 1), 1);
          Expr _vt_in (_v_deref__1, (0 + 1 + 1), 1);
          Expr _vt_out (_v_deref__1, (0 + 1 + 1 + 1), 1);
          Expr _ge_body__4 (_v_deref__1, (0 + 1 + 1 + 1 + 1), _v_len__body__4);
          RF_CALL (Box::Put, (Blocks, (_c_3 + _vt_name + _vt_in + _vt_out) ()), /*void*/);
          RF_CALL (rfp__helper::RFP_m_Clear_m_Table, Breaks, /*void*/);
          _ve_body = _ge_body__4;
          goto _block2;
        }
      _block2__branch1: {}
        {
          if (_vt_1.symbol_at (0))
          {
            goto _block2__branch2;
          }
          Expr _v_deref__12 (_vt_1, 0);
          uintptr_t _v_len5 = _v_deref__12.get_len ();
          uintptr_t _v_len6 = 4;
          if (_v_len5 < _v_len6)
          {
            goto _block2__branch2;
          }
          uintptr_t _v_len__body__42 = (_v_len5 - _v_len6);
          if (!_c_4.term_eq (_v_deref__12, 0))
          {
            goto _block2__branch2;
          }
          Expr _vt_name (_v_deref__12, (0 + 1), 1);
          Expr _vt_in (_v_deref__12, (0 + 1 + 1), 1);
          Expr _vt_out (_v_deref__12, (0 + 1 + 1 + 1), 1);
          Expr _ge_body__4 (_v_deref__12, (0 + 1 + 1 + 1 + 1), _v_len__body__42);
          RF_CALL (Box::Put, (Blocks, (_c_4 + _vt_name + _vt_in + _vt_out) ()), /*void*/);
          RF_CALL (rfp__helper::RFP_m_Clear_m_Table, Breaks, /*void*/);
          _ve_body = _ge_body__4;
          goto _block2;
        }
      _block2__branch2: {}
        {
          if (_vt_1.symbol_at (0))
          {
            goto _block2__branch3;
          }
          Expr _v_deref__13 (_vt_1, 0);
          uintptr_t _v_len7 = _v_deref__13.get_len ();
          uintptr_t _v_len8 = 5;
          if (_v_len7 < _v_len8)
          {
            goto _block2__branch3;
          }
          uintptr_t _v_len__body__43 = (_v_len7 - _v_len8);
          if (_v_deref__13.symbol_at ((0 + 1)))
          {
            goto _block2__branch3;
          }
          if (_v_deref__13.symbol_at ((0 + 1 + 1)))
          {
            goto _block2__branch3;
          }
          if (_v_deref__13.symbol_at ((0 + 1 + 1 + 1)))
          {
            goto _block2__branch3;
          }
          if (_v_deref__13.symbol_at ((0 + 1 + 1 + 1 + 1)))
          {
            goto _block2__branch3;
          }
          Expr _v_deref__deref__13 (_v_deref__13, (0 + 1));
          Expr _v_deref__deref__132 (_v_deref__13, (0 + 1 + 1));
          Expr _v_deref__deref__133 (_v_deref__13, (0 + 1 + 1 + 1));
          Expr _v_deref__deref__134 (_v_deref__13, (0 + 1 + 1 + 1 + 1));
          uintptr_t _v_len9 = _v_deref__deref__13.get_len ();
          uintptr_t _v_len10 = 0;
          if (_v_len9 < _v_len10)
          {
            goto _block2__branch3;
          }
          uintptr_t _v_len__cont = (_v_len9 - _v_len10);
          uintptr_t _v_len11 = _v_deref__deref__132.get_len ();
          uintptr_t _v_len12 = 0;
          if (_v_len11 < _v_len12)
          {
            goto _block2__branch3;
          }
          uintptr_t _v_len__break = (_v_len11 - _v_len12);
          uintptr_t _v_len13 = _v_deref__deref__134.get_len ();
          uintptr_t _v_len14 = 0;
          if (_v_len13 < _v_len14)
          {
            goto _block2__branch3;
          }
          uintptr_t _v_len__step = (_v_len13 - _v_len14);
          uintptr_t _v_len15 = _v_deref__deref__133.get_len ();
          uintptr_t _v_len16 = 0;
          if (_v_len15 < _v_len16)
          {
            goto _block2__branch3;
          }
          uintptr_t _v_len__cond = (_v_len15 - _v_len16);
          if (!_c_5.term_eq (_v_deref__13, 0))
          {
            goto _block2__branch3;
          }
          Expr _ge_body__4 (_v_deref__13, (0 + 1 + 1 + 1 + 1 + 1), _v_len__body__43);
          Expr _ve_cont (_v_deref__deref__13, 0, _v_len__cont);
          Expr _ve_break (_v_deref__deref__132, 0, _v_len__break);
          Expr _ve_cond (_v_deref__deref__133, 0, _v_len__cond);
          Expr _ve_step (_v_deref__deref__134, 0, _v_len__step);
          RF_CALL (Box::Put, (Blocks, (_c_5 + _ve_cont () + _ve_break () + _ve_cond () + _ve_step ()) ()), /*void*/);
          _ve_body = _ge_body__4;
          goto _block2;
        }
      _block2__branch3: {}
        {
          if (_vt_1.symbol_at (0))
          {
            goto _block2__branch4;
          }
          Expr _v_deref__14 (_vt_1, 0);
          uintptr_t _v_len17 = _v_deref__14.get_len ();
          uintptr_t _v_len18 = 2;
          if (_v_len17 < _v_len18)
          {
            goto _block2__branch4;
          }
          uintptr_t _v_len__body__44 = (_v_len17 - _v_len18);
          if (_v_deref__14.symbol_at ((0 + 1)))
          {
            goto _block2__branch4;
          }
          Expr _v_deref__deref__14 (_v_deref__14, (0 + 1));
          if (_v_deref__deref__14.get_len () != 1)
          {
            goto _block2__branch4;
          }
          if (!_c_6.term_eq (_v_deref__14, 0))
          {
            goto _block2__branch4;
          }
          Expr _ge_body__4 (_v_deref__14, (0 + 1 + 1), _v_len__body__44);
          Expr _vt_label (_v_deref__deref__14, 0, 1);
          RF_CALL (Box::Put, (Blocks, (_c_6 + _vt_label ()) ()), /*void*/);
          _ve_body = _ge_body__4;
          goto _block2;
        }
      _block2__branch4: {}
        {
          if (_vt_1.symbol_at (0))
          {
            goto _block2__branch5;
          }
          Expr _v_deref__15 (_vt_1, 0);
          uintptr_t _v_len19 = _v_deref__15.get_len ();
          uintptr_t _v_len20 = 2;
          if (_v_len19 < _v_len20)
          {
            goto _block2__branch5;
          }
          uintptr_t _v_len__body__45 = (_v_len19 - _v_len20);
          if (!_c_1.term_eq (_v_deref__15, 0))
          {
            goto _block2__branch5;
          }
          Expr _vt_cond (_v_deref__15, (0 + 1), 1);
          Expr _ge_body__4 (_v_deref__15, (0 + 1 + 1), _v_len__body__45);
          RF_CALL (Box::Put, (Blocks, (_c_1 + _vt_cond) ()), /*void*/);
          _ve_body = _ge_body__4;
          goto _block2;
        }
      _block2__branch5: {}
        {
          if (_vt_1.symbol_at (0))
          {
            goto _block2__branch6;
          }
          Expr _v_deref__16 (_vt_1, 0);
          uintptr_t _v_len21 = _v_deref__16.get_len ();
          uintptr_t _v_len22 = 4;
          if (_v_len21 < _v_len22)
          {
            goto _block2__branch6;
          }
          uintptr_t _v_len__body__46 = (_v_len21 - _v_len22);
          if (!_c_0.term_eq (_v_deref__16, 0))
          {
            goto _block2__branch6;
          }
          if (!_v_deref__16.symbol_at ((0 + 1)))
          {
            goto _block2__branch6;
          }
          Expr _vs_op (_v_deref__16, (0 + 1), 1);
          Expr _vt_arg1 (_v_deref__16, (0 + 1 + 1), 1);
          Expr _vt_arg2 (_v_deref__16, (0 + 1 + 1 + 1), 1);
          Expr _ge_body__4 (_v_deref__16, (0 + 1 + 1 + 1 + 1), _v_len__body__46);
          RF_CALL (Box::Put, (Blocks, (_c_0 + _vs_op + _vt_arg1 + _vt_arg2) ()), /*void*/);
          _ve_body = _ge_body__4;
          goto _block2;
        }
      _block2__branch6: {}
        {
          if (_vt_1.symbol_at (0))
          {
            goto _block2__branch7;
          }
          Expr _v_deref__17 (_vt_1, 0);
          uintptr_t _v_len23 = _v_deref__17.get_len ();
          uintptr_t _v_len24 = 1;
          if (_v_len23 < _v_len24)
          {
            goto _block2__branch7;
          }
          uintptr_t _v_len__body__47 = (_v_len23 - _v_len24);
          if (!_c_7.term_eq (_v_deref__17, 0))
          {
            goto _block2__branch7;
          }
          Expr _ge_body__4 (_v_deref__17, (0 + 1), _v_len__body__47);
          RF_CALL (Box::Put, (Blocks, _c_8), /*void*/);
          _ve_body = _ge_body__4;
          goto _block2;
        }
      _block2__branch7: {}
        if (_vt_1.symbol_at (0))
        {
          goto _block1__branch1;
        }
        Expr _v_deref__18 (_vt_1, 0);
        uintptr_t _v_len25 = _v_deref__18.get_len ();
        uintptr_t _v_len26 = 1;
        if (_v_len25 < _v_len26)
        {
          goto _block1__branch1;
        }
        uintptr_t _v_len__body__48 = (_v_len25 - _v_len26);
        if (!_c_9.term_eq (_v_deref__18, 0))
        {
          goto _block1__branch1;
        }
        Expr _ge_body__4 (_v_deref__18, (0 + 1), _v_len__body__48);
        RF_CALL (Box::Put, (Blocks, _c_10), /*void*/);
        _ve_body = _ge_body__4;
      }
    _block2: {}
      RF_CALL (Box::Put, (Last_m_Breaks, _c_11), /*void*/);
      RF_CALL (Remove_m_Unreachable, _ve_body, _ve_body);
      Expr _v_GetR1;
      if (!RF_CALL (GetR, Blocks, _v_GetR1))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      Expr _ve_t1;
      Expr _ge_2__4;
      {
        {
          if (_v_GetR1.symbol_at (0))
          {
            goto _block3__branch1;
          }
          Expr _v_deref__GetR1 (_v_GetR1, 0);
          if (_v_deref__GetR1.get_len () != 2)
          {
            goto _block3__branch1;
          }
          if (_v_deref__GetR1.symbol_at ((0 + 1)))
          {
            goto _block3__branch1;
          }
          Expr _v_deref__deref__GetR1 (_v_deref__GetR1, (0 + 1));
          if (_v_deref__deref__GetR1.get_len () != 1)
          {
            goto _block3__branch1;
          }
          if (!_c_6.term_eq (_v_deref__GetR1, 0))
          {
            goto _block3__branch1;
          }
          Expr _vt_label (_v_deref__deref__GetR1, 0, 1);
          {
            {
              if (!RF_CALL (Table::In_m_Table_q_, (Breaks, _vt_label), /*void*/))
              {
                goto _block4__branch1;
              }
              _ve_t1 = (_c_6 + _vt_label () + _ve_body) ();
              _ge_2__4 = _ve_2;
              goto _block4;
            }
          _block4__branch1: {}
            {
              {
                Expr _v__q_1;
                RF_CALL (Box::_q_, Blocks, _v__q_1);
                uintptr_t _v_len27 = _v__q_1.get_len ();
                uintptr_t _v_len28 = 1;
                if (_v_len27 < _v_len28)
                {
                  goto _block5__branch1;
                }
                uintptr_t _v_len___e__e_tmp_m_rfp__asail2asailrf_m_83_m_26 = (_v_len27 - _v_len28);
                if (_v__q_1.symbol_at ((0 + _v_len___e__e_tmp_m_rfp__asail2asailrf_m_83_m_26)))
                {
                  goto _block5__branch1;
                }
                Expr _v_deref___q_1 (_v__q_1, (0 + _v_len___e__e_tmp_m_rfp__asail2asailrf_m_83_m_26));
                if (_v_deref___q_1.get_len () != 2)
                {
                  goto _block5__branch1;
                }
                if (_v_deref___q_1.symbol_at ((0 + 1)))
                {
                  goto _block5__branch1;
                }
                Expr _v_deref__deref___q_1 (_v_deref___q_1, (0 + 1));
                if (_v_deref__deref___q_1.get_len () != 1)
                {
                  goto _block5__branch1;
                }
                if (!_c_6.term_eq (_v_deref___q_1, 0))
                {
                  goto _block5__branch1;
                }
                Expr _ve__e__e_tmp_m_rfp__asail2asailrf_m_83_m_26 (_v__q_1, 0, _v_len___e__e_tmp_m_rfp__asail2asailrf_m_83_m_26);
                Expr _vt_other_m_label (_v_deref__deref___q_1, 0, 1);
                Expr _v_Lookup1;
                if (!RF_CALL (Table::Lookup, (Breaks, _vt_other_m_label), _v_Lookup1))
                {
                  goto _block5__branch1;
                }
                if (_v_Lookup1.get_len () != 0)
                {
                  goto _block5__branch1;
                }
                RF_CALL (Table::Unbind, (Breaks, _vt_other_m_label), /*void*/);
                goto _block5;
              }
            _block5__branch1: {}
            }
          _block5: {}
            _ve_t1 = empty;
            _ge_2__4 = (_ve_body + _ve_2);
          }
        _block4: {}
          goto _block3;
        }
      _block3__branch1: {}
        {
          if (_v_GetR1.symbol_at (0))
          {
            goto _block3__branch2;
          }
          Expr _v_deref__GetR12 (_v_GetR1, 0);
          if (_v_deref__GetR12.get_len () != 5)
          {
            goto _block3__branch2;
          }
          if (_v_deref__GetR12.symbol_at ((0 + 1)))
          {
            goto _block3__branch2;
          }
          if (_v_deref__GetR12.symbol_at ((0 + 1 + 1)))
          {
            goto _block3__branch2;
          }
          if (_v_deref__GetR12.symbol_at ((0 + 1 + 1 + 1 + 1)))
          {
            goto _block3__branch2;
          }
          Expr _v_deref__deref__GetR12 (_v_deref__GetR12, (0 + 1));
          Expr _v_deref__deref__GetR122 (_v_deref__GetR12, (0 + 1 + 1));
          Expr _v_deref__deref__GetR123 (_v_deref__GetR12, (0 + 1 + 1 + 1 + 1));
          uintptr_t _v_len29 = _v_deref__deref__GetR12.get_len ();
          uintptr_t _v_len30 = 0;
          if (_v_len29 < _v_len30)
          {
            goto _block3__branch2;
          }
          uintptr_t _v_len__cont2 = (_v_len29 - _v_len30);
          uintptr_t _v_len31 = _v_deref__deref__GetR123.get_len ();
          uintptr_t _v_len32 = 0;
          if (_v_len31 < _v_len32)
          {
            goto _block3__branch2;
          }
          uintptr_t _v_len__step2 = (_v_len31 - _v_len32);
          uintptr_t _v_len33 = _v_deref__deref__GetR122.get_len ();
          uintptr_t _v_len34 = 0;
          if (_v_len33 < _v_len34)
          {
            goto _block3__branch2;
          }
          uintptr_t _v_len__break2 = (_v_len33 - _v_len34);
          if (!_c_5.term_eq (_v_deref__GetR12, 0))
          {
            goto _block3__branch2;
          }
          if (!_c_11.term_eq (_v_deref__GetR12, (0 + 1 + 1 + 1)))
          {
            goto _block3__branch2;
          }
          Expr _ve_cont (_v_deref__deref__GetR12, 0, _v_len__cont2);
          Expr _ve_break (_v_deref__deref__GetR122, 0, _v_len__break2);
          Expr _ve_step (_v_deref__deref__GetR123, 0, _v_len__step2);
          {
            {
              if (!RF_CALL (Table::In_m_Table_q_, (Breaks, _ve_break), /*void*/))
              {
                goto _block6__branch1;
              }
              _ve_t1 = (_c_5 + _ve_cont () + _ve_break () + _c_11 + _ve_step () + _ve_body) ();
              _ge_2__4 = _ve_2;
              goto _block6;
            }
          _block6__branch1: {}
            _ve_t1 = (_c_5 + _ve_cont () + _ve_break () + _c_11 + _ve_step () + _ve_body) ();
            _ge_2__4 = empty;
          }
        _block6: {}
          goto _block3;
        }
      _block3__branch2: {}
        {
          if (!_v_GetR1.term_eq (_c_8, 0))
          {
            goto _block3__branch3;
          }
          {
            {
              Expr _v__q_2;
              RF_CALL (Box::_q_, Last_m_Breaks, _v__q_2);
              uintptr_t _v_len35 = _v__q_2.get_len ();
              uintptr_t _v_len36 = 1;
              if (_v_len35 < _v_len36)
              {
                goto _block7__branch1;
              }
              uintptr_t _v_len___e__e_tmp_m_rfp__asail2asailrf_m_95_m_29 = (_v_len35 - _v_len36);
              if (_v__q_2.symbol_at ((0 + _v_len___e__e_tmp_m_rfp__asail2asailrf_m_95_m_29)))
              {
                goto _block7__branch1;
              }
              Expr _v_deref___q_2 (_v__q_2, (0 + _v_len___e__e_tmp_m_rfp__asail2asailrf_m_95_m_29));
              uintptr_t _v_len37 = _v_deref___q_2.get_len ();
              uintptr_t _v_len38 = 1;
              if (_v_len37 < _v_len38)
              {
                goto _block7__branch1;
              }
              uintptr_t _v_len___e__e_tmp_m_rfp__asail2asailrf_m_95_m_32 = (_v_len37 - _v_len38);
              if (!_c_12.term_eq (_v_deref___q_2, (0 + _v_len___e__e_tmp_m_rfp__asail2asailrf_m_95_m_32)))
              {
                goto _block7__branch1;
              }
              Expr _ve__e__e_tmp_m_rfp__asail2asailrf_m_95_m_29 (_v__q_2, 0, _v_len___e__e_tmp_m_rfp__asail2asailrf_m_95_m_29);
              Expr _ve__e__e_tmp_m_rfp__asail2asailrf_m_95_m_32 (_v_deref___q_2, 0, _v_len___e__e_tmp_m_rfp__asail2asailrf_m_95_m_32);
              _ve_t1 = (_c_7 + _ve_body) ();
              _ge_2__4 = _ve_2;
              goto _block7;
            }
          _block7__branch1: {}
            uintptr_t _v_len39 = _v_len__2;
            uintptr_t _v_len40 = 1;
            if (_v_len39 < _v_len40)
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            uintptr_t _v_len__3 = (_v_len39 - _v_len40);
            if (_ve_2.symbol_at (0))
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            Expr _v_deref__2 (_ve_2, 0);
            uintptr_t _v_len41 = _v_deref__2.get_len ();
            uintptr_t _v_len42 = 1;
            if (_v_len41 < _v_len42)
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            uintptr_t _v_len__catch_m_body = (_v_len41 - _v_len42);
            if (!_c_9.term_eq (_v_deref__2, 0))
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            Expr _ve_3 (_ve_2, (0 + 1), _v_len__3);
            Expr _ve_catch_m_body (_v_deref__2, (0 + 1), _v_len__catch_m_body);
            _ve_t1 = (_c_7 + _ve_body) ();
            _ge_2__4 = (_c_9 + _ve_catch_m_body + _ve_3) ();
          }
        _block7: {}
          goto _block3;
        }
      _block3__branch3: {}
        if (_v_GetR1.symbol_at (0))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        Expr _v_deref__GetR13 (_v_GetR1, 0);
        uintptr_t _v_len43 = _v_deref__GetR13.get_len ();
        uintptr_t _v_len44 = 0;
        if (_v_len43 < _v_len44)
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        uintptr_t _v_len__item = (_v_len43 - _v_len44);
        Expr _ve_item (_v_deref__GetR13, 0, _v_len__item);
        _ve_t1 = (_ve_item + _ve_body) ();
        _ge_2__4 = _ve_2;
      }
    _block3: {}
      Expr _vt_breaks;
      if (!RF_CALL (GetR, Last_m_Breaks, _vt_breaks))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      {
        uintptr_t _v_len45 = _ve_t1.get_len ();
        uintptr_t _v_len46 = 0;
        if (_v_len45 < (_v_len46 + 1))
        {
          goto _block8__branch1;
        }
        uintptr_t _v_len___e__e_tmp_m_rfp__asail2asailrf_m_104_m_15 = (_v_len45 - _v_len46);
        if (_vt_breaks.symbol_at (0))
        {
          goto _block8__branch1;
        }
        Expr _v_deref__breaks (_vt_breaks, 0);
        if (_v_deref__breaks.get_len () < 1)
        {
          goto _block8__branch1;
        }
        Expr _vv__e__e_tmp_m_rfp__asail2asailrf_m_104_m_15 (_ve_t1, 0, _v_len___e__e_tmp_m_rfp__asail2asailrf_m_104_m_15);
        RF_lsplit (_v_deref__breaks, 0, _ve__e__e_tmp_m_rfp__asail2asailrf_m_105_m_22, _v_lsplit__deref__breaks);
        for ( ; ; RF_iter(_v_deref__breaks)++)
        {
          {
            if (!RF_iter(_v_deref__breaks))
            {
              goto _block8__branch1;
            }
            uintptr_t _v_len47 = _v_lsplit__deref__breaks.get_len ();
            uintptr_t _v_len48 = 1;
            if (_v_len47 < _v_len48)
            {
              goto _block8__branch1;
            }
            uintptr_t _v_len___e__e_tmp_m_rfp__asail2asailrf_m_105_m_28 = (_v_len47 - _v_len48);
            Expr _vt_l (_v_lsplit__deref__breaks, 0, 1);
            Expr _ve__e__e_tmp_m_rfp__asail2asailrf_m_105_m_28 (_v_lsplit__deref__breaks, (0 + 1), _v_len___e__e_tmp_m_rfp__asail2asailrf_m_105_m_28);
            RF_CALL (Table::Bind, (Breaks, _vt_l, _c_13), /*void*/);
          }
      _continue1: {}
        }
      _exit1: {}
      }
    _block8__branch1: {}
      Expr _v_Remove_m_Unreachable1;
      RF_CALL (Remove_m_Unreachable, _ge_2__4, _v_Remove_m_Unreachable1);
      _v_res1 = (_ve_t1 + _v_Remove_m_Unreachable1);
      goto _block1;
    }
  _block1__branch1: {}
    {
      uintptr_t _v_len49 = _ge_arg1.get_len ();
      uintptr_t _v_len50 = 1;
      if (_v_len49 < _v_len50)
      {
        goto _block1__branch2;
      }
      uintptr_t _v_len__22 = (_v_len49 - _v_len50);
      Expr _vt_1 (_ge_arg1, 0, 1);
      Expr _ve_2 (_ge_arg1, (0 + 1), _v_len__22);
      {
        {
          if (_vt_1.symbol_at (0))
          {
            goto _block9__branch1;
          }
          Expr _v_deref__19 (_vt_1, 0);
          if (_v_deref__19.get_len () != 2)
          {
            goto _block9__branch1;
          }
          if (!_c_14.term_eq (_v_deref__19, 0))
          {
            goto _block9__branch1;
          }
          Expr _vt_label (_v_deref__19, (0 + 1), 1);
          Expr _v_GetR2;
          if (!RF_CALL (GetR, Last_m_Breaks, _v_GetR2))
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          if (_v_GetR2.symbol_at (0))
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          Expr _v_deref__GetR2 (_v_GetR2, 0);
          uintptr_t _v_len51 = _v_deref__GetR2.get_len ();
          uintptr_t _v_len52 = 0;
          if (_v_len51 < _v_len52)
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          uintptr_t _v_len__breaks = (_v_len51 - _v_len52);
          Expr _ve_breaks (_v_deref__GetR2, 0, _v_len__breaks);
          RF_CALL (Box::Put, (Last_m_Breaks, (_ve_breaks + _vt_label) ()), /*void*/);
          {
            {
              Expr _v__q_3;
              RF_CALL (Box::_q_, Blocks, _v__q_3);
              uintptr_t _v_len53 = _v__q_3.get_len ();
              uintptr_t _v_len54 = 1;
              if (_v_len53 < _v_len54)
              {
                goto _block10__branch1;
              }
              uintptr_t _v_len___e__e_tmp_m_rfp__asail2asailrf_m_115_m_24 = (_v_len53 - _v_len54);
              if (_v__q_3.symbol_at ((0 + _v_len___e__e_tmp_m_rfp__asail2asailrf_m_115_m_24)))
              {
                goto _block10__branch1;
              }
              Expr _v_deref___q_3 (_v__q_3, (0 + _v_len___e__e_tmp_m_rfp__asail2asailrf_m_115_m_24));
              if (_v_deref___q_3.get_len () != 2)
              {
                goto _block10__branch1;
              }
              if (_v_deref___q_3.symbol_at ((0 + 1)))
              {
                goto _block10__branch1;
              }
              Expr _v_deref__deref___q_3 (_v_deref___q_3, (0 + 1));
              if (_v_deref__deref___q_3.get_len () != 1)
              {
                goto _block10__branch1;
              }
              if (!_c_6.term_eq (_v_deref___q_3, 0))
              {
                goto _block10__branch1;
              }
              if (!_vt_label.term_eq (_v_deref__deref___q_3, 0))
              {
                goto _block10__branch1;
              }
              Expr _ve__e__e_tmp_m_rfp__asail2asailrf_m_115_m_24 (_v__q_3, 0, _v_len___e__e_tmp_m_rfp__asail2asailrf_m_115_m_24);
              _v_res1 = empty;
              goto _block10;
            }
          _block10__branch1: {}
            RF_CALL (Table::Bind, (Breaks, _vt_label, empty), /*void*/);
            _v_res1 = _vt_1;
          }
        _block10: {}
          goto _block9;
        }
      _block9__branch1: {}
        {
          if (_vt_1.symbol_at (0))
          {
            goto _block9__branch2;
          }
          Expr _v_deref__110 (_vt_1, 0);
          if (_v_deref__110.get_len () != 2)
          {
            goto _block9__branch2;
          }
          if (!_c_15.term_eq (_v_deref__110, 0))
          {
            goto _block9__branch2;
          }
          Expr _vt_label (_v_deref__110, (0 + 1), 1);
          {
            {
              Expr _v__q_4;
              RF_CALL (Box::_q_, Blocks, _v__q_4);
              uintptr_t _v_len55 = _v__q_4.get_len ();
              uintptr_t _v_len56 = 1;
              if (_v_len55 < _v_len56)
              {
                goto _block11__branch1;
              }
              uintptr_t _v_len___e__e_tmp_m_rfp__asail2asailrf_m_119_m_22 = (_v_len55 - _v_len56);
              if (_v__q_4.symbol_at ((0 + _v_len___e__e_tmp_m_rfp__asail2asailrf_m_119_m_22)))
              {
                goto _block11__branch1;
              }
              Expr _v_deref___q_4 (_v__q_4, (0 + _v_len___e__e_tmp_m_rfp__asail2asailrf_m_119_m_22));
              if (_v_deref___q_4.get_len () != 5)
              {
                goto _block11__branch1;
              }
              if (_v_deref___q_4.symbol_at ((0 + 1)))
              {
                goto _block11__branch1;
              }
              if (_v_deref___q_4.symbol_at ((0 + 1 + 1)))
              {
                goto _block11__branch1;
              }
              if (_v_deref___q_4.symbol_at ((0 + 1 + 1 + 1)))
              {
                goto _block11__branch1;
              }
              if (_v_deref___q_4.symbol_at ((0 + 1 + 1 + 1 + 1)))
              {
                goto _block11__branch1;
              }
              Expr _v_deref__deref___q_4 (_v_deref___q_4, (0 + 1));
              Expr _v_deref__deref___q_42 (_v_deref___q_4, (0 + 1 + 1));
              Expr _v_deref__deref___q_43 (_v_deref___q_4, (0 + 1 + 1 + 1));
              Expr _v_deref__deref___q_44 (_v_deref___q_4, (0 + 1 + 1 + 1 + 1));
              if (_v_deref__deref___q_4.get_len () != 1)
              {
                goto _block11__branch1;
              }
              uintptr_t _v_len57 = _v_deref__deref___q_42.get_len ();
              uintptr_t _v_len58 = 0;
              if (_v_len57 < _v_len58)
              {
                goto _block11__branch1;
              }
              uintptr_t _v_len__break3 = (_v_len57 - _v_len58);
              uintptr_t _v_len59 = _v_deref__deref___q_44.get_len ();
              uintptr_t _v_len60 = 0;
              if (_v_len59 < _v_len60)
              {
                goto _block11__branch1;
              }
              uintptr_t _v_len__step3 = (_v_len59 - _v_len60);
              uintptr_t _v_len61 = _v_deref__deref___q_43.get_len ();
              uintptr_t _v_len62 = 0;
              if (_v_len61 < _v_len62)
              {
                goto _block11__branch1;
              }
              uintptr_t _v_len__cond2 = (_v_len61 - _v_len62);
              if (!_c_5.term_eq (_v_deref___q_4, 0))
              {
                goto _block11__branch1;
              }
              if (!_vt_label.term_eq (_v_deref__deref___q_4, 0))
              {
                goto _block11__branch1;
              }
              Expr _ve__e__e_tmp_m_rfp__asail2asailrf_m_119_m_22 (_v__q_4, 0, _v_len___e__e_tmp_m_rfp__asail2asailrf_m_119_m_22);
              Expr _ve_break (_v_deref__deref___q_42, 0, _v_len__break3);
              Expr _ve_cond (_v_deref__deref___q_43, 0, _v_len__cond2);
              Expr _ve_step (_v_deref__deref___q_44, 0, _v_len__step3);
              _v_res1 = empty;
              goto _block11;
            }
          _block11__branch1: {}
            _v_res1 = _vt_1;
          }
        _block11: {}
          goto _block9;
        }
      _block9__branch2: {}
        {
          if (!_vt_1.term_eq (_c_16, 0))
          {
            goto _block9__branch3;
          }
          _v_res1 = _vt_1;
          goto _block9;
        }
      _block9__branch3: {}
        {
          if (_vt_1.symbol_at (0))
          {
            goto _block9__branch4;
          }
          Expr _v_deref__111 (_vt_1, 0);
          uintptr_t _v_len63 = _v_deref__111.get_len ();
          uintptr_t _v_len64 = 1;
          if (_v_len63 < _v_len64)
          {
            goto _block9__branch4;
          }
          uintptr_t _v_len___e__e_tmp_m_rfp__asail2asailrf_m_123_m_13 = (_v_len63 - _v_len64);
          if (!_c_17.term_eq (_v_deref__111, 0))
          {
            goto _block9__branch4;
          }
          Expr _ve__e__e_tmp_m_rfp__asail2asailrf_m_123_m_13 (_v_deref__111, (0 + 1), _v_len___e__e_tmp_m_rfp__asail2asailrf_m_123_m_13);
          _v_res1 = _vt_1;
          goto _block9;
        }
      _block9__branch4: {}
        if (!_vt_1.term_eq (_c_18, 0))
        {
          goto _block1__branch2;
        }
        _v_res1 = _vt_1;
      }
    _block9: {}
      goto _block1;
    }
  _block1__branch2: {}
    {
      uintptr_t _v_len65 = _ge_arg1.get_len ();
      uintptr_t _v_len66 = 1;
      if (_v_len65 < _v_len66)
      {
        goto _block1__branch3;
      }
      uintptr_t _v_len__23 = (_v_len65 - _v_len66);
      Expr _vt_1 (_ge_arg1, 0, 1);
      Expr _ve_2 (_ge_arg1, (0 + 1), _v_len__23);
      Expr _v_Remove_m_Unreachable2;
      RF_CALL (Remove_m_Unreachable, _ve_2, _v_Remove_m_Unreachable2);
      _v_res1 = (_vt_1 + _v_Remove_m_Unreachable2);
      goto _block1;
    }
  _block1__branch3: {}
    if (_ge_arg1.get_len () != 0)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    {
      {
        Expr _v_GetR3;
        if (!RF_CALL (GetR, Last_m_Breaks, _v_GetR3))
        {
          goto _block12__branch1;
        }
        if (_v_GetR3.symbol_at (0))
        {
          goto _block12__branch1;
        }
        Expr _v_deref__GetR3 (_v_GetR3, 0);
        uintptr_t _v_len67 = _v_deref__GetR3.get_len ();
        uintptr_t _v_len68 = 0;
        if (_v_len67 < _v_len68)
        {
          goto _block12__branch1;
        }
        uintptr_t _v_len__breaks2 = (_v_len67 - _v_len68);
        Expr _ve_breaks (_v_deref__GetR3, 0, _v_len__breaks2);
        RF_CALL (Box::Put, (Last_m_Breaks, (_ve_breaks + _c_12) ()), /*void*/);
        _v_res1 = empty;
        goto _block12;
      }
    _block12__branch1: {}
      _v_res1 = empty;
    }
  _block12: {}
  }
_block1: {}
RF_END

RF_FUNC (Remove_m_Dupl_m_Decl, (RF_ARG _ve_decls, _ve_subst, _ve_items;;), (RF_RES _v_res1;;))
  {
    {
      uintptr_t _v_len1 = _ve_items.get_len ();
      uintptr_t _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__rest = (_v_len1 - _v_len2);
      Expr _vt_1 (_ve_items, 0, 1);
      Expr _ve_rest (_ve_items, (0 + 1), _v_len__rest);
      {
        {
          if (_vt_1.symbol_at (0))
          {
            goto _block2__branch1;
          }
          Expr _v_deref__1 (_vt_1, 0);
          if (_v_deref__1.get_len () != 3)
          {
            goto _block2__branch1;
          }
          if (!_c_19.term_eq (_v_deref__1, 0))
          {
            goto _block2__branch1;
          }
          if (!_v_deref__1.symbol_at ((0 + 1)))
          {
            goto _block2__branch1;
          }
          Expr _vs_type (_v_deref__1, (0 + 1), 1);
          Expr _vt_var (_v_deref__1, (0 + 1 + 1), 1);
          Expr _ve_d;
          Expr _ge_decls__4;
          Expr _ge_subst__4;
          RF_CALL (Process_m_Var, (_ve_decls, _ve_subst, _vs_type, _vt_var), (_ve_d, _ge_decls__4, _ge_subst__4));
          Expr _v_Remove_m_Dupl_m_Decl1;
          RF_CALL (Remove_m_Dupl_m_Decl, (_ge_decls__4, _ge_subst__4, _ve_rest), _v_Remove_m_Dupl_m_Decl1);
          _v_res1 = (_ve_d + _v_Remove_m_Dupl_m_Decl1);
          goto _block2;
        }
      _block2__branch1: {}
        {
          if (_vt_1.symbol_at (0))
          {
            goto _block2__branch2;
          }
          Expr _v_deref__12 (_vt_1, 0);
          uintptr_t _v_len3 = _v_deref__12.get_len ();
          uintptr_t _v_len4 = 2;
          if (_v_len3 < _v_len4)
          {
            goto _block2__branch2;
          }
          uintptr_t _v_len__expr = (_v_len3 - _v_len4);
          if (!_c_20.term_eq (_v_deref__12, 0))
          {
            goto _block2__branch2;
          }
          Expr _vt_var (_v_deref__12, (0 + 1), 1);
          Expr _ve_expr (_v_deref__12, (0 + 1 + 1), _v_len__expr);
          Expr _ve_d;
          Expr _ve_decls2;
          Expr _ve_subst2;
          RF_CALL (Process_m_Var, (_ve_decls, _ve_subst, _c_21, _vt_var), (_ve_d, _ve_decls2, _ve_subst2));
          {
            {
              if (_ve_d.get_len () != 1)
              {
                goto _block3__branch1;
              }
              if (_ve_d.symbol_at (0))
              {
                goto _block3__branch1;
              }
              Expr _v_deref__d (_ve_d, 0);
              if (_v_deref__d.get_len () != 3)
              {
                goto _block3__branch1;
              }
              if (!_c_19.term_eq (_v_deref__d, 0))
              {
                goto _block3__branch1;
              }
              if (!_v_deref__d.symbol_at ((0 + 1)))
              {
                goto _block3__branch1;
              }
              Expr _vs__e__e_tmp_m_rfp__asail2asailrf_m_143_m_22 (_v_deref__d, (0 + 1), 1);
              Expr _vt_new_m_var (_v_deref__d, (0 + 1 + 1), 1);
              Expr _ge_auxcall1;
              RF_CALL (Remove_m_Dupl_m_Decl, (_ve_decls, _ve_subst, _ve_expr), _ge_auxcall1);
              Expr _v_Remove_m_Dupl_m_Decl2;
              RF_CALL (Remove_m_Dupl_m_Decl, (_ve_decls2, _ve_subst2, _ve_rest), _v_Remove_m_Dupl_m_Decl2);
              _v_res1 = ((_c_20 + _vt_new_m_var + _ge_auxcall1) () + _v_Remove_m_Dupl_m_Decl2);
              goto _block3;
            }
          _block3__branch1: {}
            Expr _ge_auxcall2;
            RF_CALL (Remove_m_Dupl_m_Decl, (_ve_decls, _ve_subst, _ve_expr), _ge_auxcall2);
            Expr _v_Remove_m_Dupl_m_Decl3;
            RF_CALL (Remove_m_Dupl_m_Decl, (_ve_decls2, _ve_subst2, _ve_rest), _v_Remove_m_Dupl_m_Decl3);
            _v_res1 = ((_c_22 + _vt_var + _ge_auxcall2) () + _v_Remove_m_Dupl_m_Decl3);
          }
        _block3: {}
          goto _block2;
        }
      _block2__branch2: {}
        {
          if (_vt_1.symbol_at (0))
          {
            goto _block2__branch3;
          }
          Expr _v_deref__13 (_vt_1, 0);
          uintptr_t _v_len5 = _v_deref__13.get_len ();
          uintptr_t _v_len6 = 4;
          if (_v_len5 < _v_len6)
          {
            goto _block2__branch3;
          }
          uintptr_t _v_len__xpr = (_v_len5 - _v_len6);
          if (_v_deref__13.symbol_at ((0 + 1 + _v_len__xpr)))
          {
            goto _block2__branch3;
          }
          Expr _v_deref__deref__13 (_v_deref__13, (0 + 1 + _v_len__xpr));
          uintptr_t _v_len7 = _v_deref__deref__13.get_len ();
          uintptr_t _v_len8 = 0;
          if (_v_len7 < _v_len8)
          {
            goto _block2__branch3;
          }
          uintptr_t _v_len__len = (_v_len7 - _v_len8);
          if (!_v_deref__13.symbol_at (0))
          {
            goto _block2__branch3;
          }
          Expr _vs_split (_v_deref__13, 0, 1);
          Expr _ve_xpr (_v_deref__13, (0 + 1), _v_len__xpr);
          Expr _vt_var1 (_v_deref__13, (0 + 1 + _v_len__xpr + 1), 1);
          Expr _vt_var2 (_v_deref__13, (0 + 1 + _v_len__xpr + 1 + 1), 1);
          Expr _ve_len (_v_deref__deref__13, 0, _v_len__len);
          {
            {
              if (!_vs_split.term_eq (_c_23, 0))
              {
                goto _block4__branch1;
              }
              goto _block4;
            }
          _block4__branch1: {}
            if (!_vs_split.term_eq (_c_24, 0))
            {
              goto _block2__branch3;
            }
          }
        _block4: {}
          RF_CALL (Remove_m_Dupl_m_Decl, (_ve_decls, _ve_subst, (_ve_xpr + _ve_len ())), _ve_xpr);
          Expr _ve_decl1;
          Expr _ge_decls__4;
          Expr _ge_subst__4;
          RF_CALL (Process_m_Var, (_ve_decls, _ve_subst, _c_25, _vt_var1), (_ve_decl1, _ge_decls__4, _ge_subst__4));
          Expr _gt_var1__5;
          {
            {
              if (_ve_decl1.get_len () != 1)
              {
                goto _block5__branch1;
              }
              if (_ve_decl1.symbol_at (0))
              {
                goto _block5__branch1;
              }
              Expr _v_deref__decl1 (_ve_decl1, 0);
              if (_v_deref__decl1.get_len () != 3)
              {
                goto _block5__branch1;
              }
              if (!_c_19.term_eq (_v_deref__decl1, 0))
              {
                goto _block5__branch1;
              }
              if (!_v_deref__decl1.symbol_at ((0 + 1)))
              {
                goto _block5__branch1;
              }
              Expr _vs_type (_v_deref__decl1, (0 + 1), 1);
              Expr _vt_new_m_var (_v_deref__decl1, (0 + 1 + 1), 1);
              _gt_var1__5 = _vt_new_m_var;
              goto _block5;
            }
          _block5__branch1: {}
            _gt_var1__5 = _vt_var1;
          }
        _block5: {}
          Expr _ve_decl2;
          Expr _ge_decls__4__5;
          Expr _ge_subst__4__5;
          RF_CALL (Process_m_Var, (_ge_decls__4, _ge_subst__4, _c_25, _vt_var2), (_ve_decl2, _ge_decls__4__5, _ge_subst__4__5));
          Expr _gt_var2__6;
          {
            {
              if (_ve_decl2.get_len () != 1)
              {
                goto _block6__branch1;
              }
              if (_ve_decl2.symbol_at (0))
              {
                goto _block6__branch1;
              }
              Expr _v_deref__decl2 (_ve_decl2, 0);
              if (_v_deref__decl2.get_len () != 3)
              {
                goto _block6__branch1;
              }
              if (!_c_19.term_eq (_v_deref__decl2, 0))
              {
                goto _block6__branch1;
              }
              if (!_v_deref__decl2.symbol_at ((0 + 1)))
              {
                goto _block6__branch1;
              }
              Expr _vs_type (_v_deref__decl2, (0 + 1), 1);
              Expr _vt_new_m_var (_v_deref__decl2, (0 + 1 + 1), 1);
              _gt_var2__6 = _vt_new_m_var;
              goto _block6;
            }
          _block6__branch1: {}
            _gt_var2__6 = _vt_var2;
          }
        _block6: {}
          Expr _v_Remove_m_Dupl_m_Decl4;
          RF_CALL (Remove_m_Dupl_m_Decl, (_ge_decls__4__5, _ge_subst__4__5, _ve_rest), _v_Remove_m_Dupl_m_Decl4);
          _v_res1 = ((_vs_split + _ve_xpr + _gt_var1__5 + _gt_var2__6) () + _v_Remove_m_Dupl_m_Decl4);
          goto _block2;
        }
      _block2__branch3: {}
        {
          if (_ve_subst.get_len () < 1)
          {
            goto _block2__branch4;
          }
          RF_lsplit (_ve_subst, 0, _ve__e__e_tmp_m_rfp__asail2asailrf_m_162_m_16, _v_lsplit__subst);
          for ( ; ; RF_iter(_ve_subst)++)
          {
            {
              if (!RF_iter(_ve_subst))
              {
                goto _block2__branch4;
              }
              uintptr_t _v_len9 = _v_lsplit__subst.get_len ();
              uintptr_t _v_len10 = 1;
              if (_v_len9 < _v_len10)
              {
                goto _block2__branch4;
              }
              uintptr_t _v_len___e__e_tmp_m_rfp__asail2asailrf_m_162_m_33 = (_v_len9 - _v_len10);
              if (_v_lsplit__subst.symbol_at (0))
              {
                goto _continue1;
              }
              Expr _v_deref__lsplit__subst (_v_lsplit__subst, 0);
              if (_v_deref__lsplit__subst.get_len () != 2)
              {
                goto _continue1;
              }
              if (!_vt_1.term_eq (_v_deref__lsplit__subst, 0))
              {
                goto _continue1;
              }
              Expr _ve__e__e_tmp_m_rfp__asail2asailrf_m_162_m_33 (_v_lsplit__subst, (0 + 1), _v_len___e__e_tmp_m_rfp__asail2asailrf_m_162_m_33);
              Expr _vt_new_m_var (_v_deref__lsplit__subst, (0 + 1), 1);
              RF_TAILCALL (Remove_m_Dupl_m_Decl, (_ve_decls, _ve_subst, (_vt_new_m_var + _ve_rest)), _v_res1);
              goto _exit1;
            }
        _continue1: {}
          }
        _exit1: {}
          goto _block2;
        }
      _block2__branch4: {}
        {
          if (_vt_1.symbol_at (0))
          {
            goto _block2__branch5;
          }
          Expr _v_deref__14 (_vt_1, 0);
          uintptr_t _v_len11 = _v_deref__14.get_len ();
          uintptr_t _v_len12 = 0;
          if (_v_len11 < _v_len12)
          {
            goto _block2__branch5;
          }
          uintptr_t _v_len__2 = (_v_len11 - _v_len12);
          Expr _ve_2 (_v_deref__14, 0, _v_len__2);
          Expr _ge_auxcall3;
          RF_CALL (Remove_m_Dupl_m_Decl, (_ve_decls, _ve_subst, _ve_2), _ge_auxcall3);
          Expr _v_Remove_m_Dupl_m_Decl5;
          RF_CALL (Remove_m_Dupl_m_Decl, (_ve_decls, _ve_subst, _ve_rest), _v_Remove_m_Dupl_m_Decl5);
          _v_res1 = (_ge_auxcall3 () + _v_Remove_m_Dupl_m_Decl5);
          goto _block2;
        }
      _block2__branch5: {}
        Expr _v_Remove_m_Dupl_m_Decl6;
        RF_CALL (Remove_m_Dupl_m_Decl, (_ve_decls, _ve_subst, _ve_rest), _v_Remove_m_Dupl_m_Decl6);
        _v_res1 = (_vt_1 + _v_Remove_m_Dupl_m_Decl6);
      }
    _block2: {}
      goto _block1;
    }
  _block1__branch1: {}
    if (_ve_items.get_len () != 0)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    _v_res1 = empty;
  }
_block1: {}
RF_END

RF_FUNC (Process_m_Var, (RF_ARG _ve_decls, _ve_subst, _vs_type, _vt_var;;), (RF_RES _v_res1, _v_res2, _v_res3;;))
  {
    {
      if (_ve_decls.get_len () < 1)
      {
        goto _block1__branch1;
      }
      RF_rsplit (_ve_decls, 0, _v_rsplit__decls, _ve__e__e_tmp_m_rfp__asail2asailrf_m_172_m_43);
      for ( ; ; RF_iter(_ve_decls)--)
      {
        {
          if (!RF_iter(_ve_decls))
          {
            goto _block1__branch1;
          }
          uintptr_t _v_len1 = _v_rsplit__decls.get_len ();
          uintptr_t _v_len2 = 1;
          if (_v_len1 < _v_len2)
          {
            goto _block1__branch1;
          }
          uintptr_t _v_len___e__e_tmp_m_rfp__asail2asailrf_m_172_m_17 = (_v_len1 - _v_len2);
          if (_v_rsplit__decls.symbol_at ((0 + _v_len___e__e_tmp_m_rfp__asail2asailrf_m_172_m_17)))
          {
            goto _continue1;
          }
          Expr _v_deref__rsplit__decls (_v_rsplit__decls, (0 + _v_len___e__e_tmp_m_rfp__asail2asailrf_m_172_m_17));
          if (_v_deref__rsplit__decls.get_len () != 3)
          {
            goto _continue1;
          }
          if (!_c_19.term_eq (_v_deref__rsplit__decls, 0))
          {
            goto _continue1;
          }
          if (!_v_deref__rsplit__decls.symbol_at ((0 + 1)))
          {
            goto _continue1;
          }
          if (!_vt_var.term_eq (_v_deref__rsplit__decls, (0 + 1 + 1)))
          {
            goto _continue1;
          }
          Expr _ve__e__e_tmp_m_rfp__asail2asailrf_m_172_m_17 (_v_rsplit__decls, 0, _v_len___e__e_tmp_m_rfp__asail2asailrf_m_172_m_17);
          Expr _vs_type_m_old (_v_deref__rsplit__decls, (0 + 1), 1);
          {
            {
              if (!_vs_type_m_old.term_eq (_vs_type, 0))
              {
                goto _block2__branch1;
              }
              _v_res1 = empty;
              _v_res2 = _ve_decls;
              _v_res3 = _ve_subst;
              goto _block2;
            }
          _block2__branch1: {}
            if (_vt_var.symbol_at (0))
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            Expr _v_deref__var (_vt_var, 0);
            uintptr_t _v_len3 = _v_deref__var.get_len ();
            uintptr_t _v_len4 = 2;
            if (_v_len3 < _v_len4)
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            uintptr_t _v_len___e__e_tmp_m_rfp__asail2asailrf_m_174_m_21 = (_v_len3 - _v_len4);
            if (_v_deref__var.symbol_at ((0 + 1 + _v_len___e__e_tmp_m_rfp__asail2asailrf_m_174_m_21)))
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            Expr _v_deref__deref__var (_v_deref__var, (0 + 1 + _v_len___e__e_tmp_m_rfp__asail2asailrf_m_174_m_21));
            uintptr_t _v_len5 = _v_deref__deref__var.get_len ();
            uintptr_t _v_len6 = 0;
            if (_v_len5 < _v_len6)
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            uintptr_t _v_len__name = (_v_len5 - _v_len6);
            if (!_v_deref__var.symbol_at (0))
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            Expr _vs_tag (_v_deref__var, 0, 1);
            Expr _ve__e__e_tmp_m_rfp__asail2asailrf_m_174_m_21 (_v_deref__var, (0 + 1), _v_len___e__e_tmp_m_rfp__asail2asailrf_m_174_m_21);
            Expr _ve_name (_v_deref__deref__var, 0, _v_len__name);
            Expr _gs_auxcall1;
            RF_CALL (Free_m_Idx, /*void*/, _gs_auxcall1);
            Expr _vt_new_m_var ((_vs_tag + _c_26 + (_ve_name + _gs_auxcall1) ()) ());
            Expr _vt_decl ((_c_19 + _vs_type + _vt_new_m_var) ());
            _v_res1 = _vt_decl;
            _v_res2 = (_ve_decls + _vt_decl);
            _v_res3 = (_ve_subst + (_vt_var + _vt_new_m_var) ());
          }
        _block2: {}
          goto _exit1;
        }
    _continue1: {}
      }
    _exit1: {}
      goto _block1;
    }
  _block1__branch1: {}
    _v_res1 = (_c_19 + _vs_type + _vt_var) ();
    _v_res2 = (_ve_decls + (_c_19 + _vs_type + _vt_var) ());
    _v_res3 = _ve_subst;
  }
_block1: {}
RF_END

RF_FUNC (Simplify_m_Infix, (RF_ARG _gt_arg1;;), (RF_RES _v_res1;;))
  {
    {
      if (_gt_arg1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__arg1 (_gt_arg1, 0);
      uintptr_t _v_len1 = _v_deref__arg1.get_len ();
      uintptr_t _v_len2 = 2;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__args = (_v_len1 - _v_len2);
      if (!_c_27.term_eq (_v_deref__arg1, 0))
      {
        goto _block1__branch1;
      }
      if (!_v_deref__arg1.symbol_at ((0 + 1)))
      {
        goto _block1__branch1;
      }
      Expr _vs_op (_v_deref__arg1, (0 + 1), 1);
      Expr _ve_args (_v_deref__arg1, (0 + 1 + 1), _v_len__args);
      Expr _ge_auxalt6;
      {
        {
          if (!_vs_op.term_eq (_c_28, 0))
          {
            goto _block2__branch1;
          }
          Expr _ge_auxcall1;
          if (!RF_CALL (List::Map, (_c_29, empty, _ve_args), _ge_auxcall1))
          {
            goto _block1__branch1;
          }
          RF_CALL (List::Foldr1, (_c_30, empty, _ge_auxcall1), _ge_auxalt6);
          goto _block2;
        }
      _block2__branch1: {}
        {
          if (!_vs_op.term_eq (_c_31, 0))
          {
            goto _block2__branch2;
          }
          Expr _ge_auxcall2;
          if (!RF_CALL (List::Map, (_c_29, empty, _ve_args), _ge_auxcall2))
          {
            goto _block1__branch1;
          }
          RF_CALL (List::Foldr1, (_c_32, empty, _ge_auxcall2), _ge_auxalt6);
          goto _block2;
        }
      _block2__branch2: {}
        {
          if (!_vs_op.term_eq (_c_33, 0))
          {
            goto _block2__branch3;
          }
          Expr _ge_auxcall3;
          if (!RF_CALL (List::Map, (_c_29, empty, _ve_args), _ge_auxcall3))
          {
            goto _block1__branch1;
          }
          RF_CALL (List::Foldr1, (_c_34, empty, _ge_auxcall3), _ge_auxalt6);
          goto _block2;
        }
      _block2__branch3: {}
        {
          if (!_vs_op.term_eq (_c_35, 0))
          {
            goto _block2__branch4;
          }
          Expr _ge_auxcall4;
          if (!RF_CALL (List::Map, (_c_29, empty, _ve_args), _ge_auxcall4))
          {
            goto _block1__branch1;
          }
          RF_CALL (List::Foldr1, (_c_36, empty, _ge_auxcall4), _ge_auxalt6);
          goto _block2;
        }
      _block2__branch4: {}
        {
          if (!_vs_op.term_eq (_c_37, 0))
          {
            goto _block2__branch5;
          }
          Expr _ge_auxcall5;
          if (!RF_CALL (List::Map, (_c_29, empty, _ve_args), _ge_auxcall5))
          {
            goto _block1__branch1;
          }
          RF_CALL (List::Foldr1, (_c_38, empty, _ge_auxcall5), _ge_auxalt6);
          goto _block2;
        }
      _block2__branch5: {}
        if (!_vs_op.symbol_at (0))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        Expr _vs__e__e_tmp_m_rfp__asail2asailrf_m_196_m_6 (_vs_op, 0, 1);
        if (!RF_CALL (List::Map, (_c_29, empty, _ve_args), _ge_auxalt6))
        {
          goto _block1__branch1;
        }
      }
    _block2: {}
      {
        {
          if (_ge_auxalt6.get_len () != 1)
          {
            goto _block3__branch1;
          }
          Expr _vt_1 (_ge_auxalt6, 0, 1);
          _v_res1 = _vt_1;
          goto _block3;
        }
      _block3__branch1: {}
        uintptr_t _v_len3 = _ge_auxalt6.get_len ();
        uintptr_t _v_len4 = 0;
        if (_v_len3 < _v_len4)
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        uintptr_t _v_len__1 = (_v_len3 - _v_len4);
        Expr _ve_1 (_ge_auxalt6, 0, _v_len__1);
        Expr _ge_auxcall7;
        RF_CALL (List::Paren, _ve_1, _ge_auxcall7);
        _v_res1 = (_c_27 + _vs_op + _ge_auxcall7) ();
      }
    _block3: {}
      goto _block1;
    }
  _block1__branch1: {}
    {
      if (_gt_arg1.symbol_at (0))
      {
        goto _block1__branch2;
      }
      Expr _v_deref__arg12 (_gt_arg1, 0);
      uintptr_t _v_len5 = _v_deref__arg12.get_len ();
      uintptr_t _v_len6 = 0;
      if (_v_len5 < _v_len6)
      {
        goto _block1__branch2;
      }
      uintptr_t _v_len__12 = (_v_len5 - _v_len6);
      Expr _ve_1 (_v_deref__arg12, 0, _v_len__12);
      Expr _ge_auxcall8;
      if (!RF_CALL (List::Map, (_c_39, empty, _ve_1), _ge_auxcall8))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      _v_res1 = _ge_auxcall8 ();
      goto _block1;
    }
  _block1__branch2: {}
    if (!_gt_arg1.symbol_at (0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _vs_1 (_gt_arg1, 0, 1);
    _v_res1 = _vs_1;
  }
_block1: {}
RF_END

RF_FUNC (Simplify_m_Arithm, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  if (_ge_arg1.get_len () != 1)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (_ge_arg1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _v_deref__arg1 (_ge_arg1, 0);
  uintptr_t _v_len1 = _v_deref__arg1.get_len ();
  uintptr_t _v_len2 = 0;
  if (_v_len1 < _v_len2)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len__args = (_v_len1 - _v_len2);
  Expr _ve_args (_v_deref__arg1, 0, _v_len__args);
  Expr _ge_auxcall1;
  if (!RF_CALL (List::Map, (_c_39, empty, _ve_args), _ge_auxcall1))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _v_Foldr11;
  RF_CALL (List::Foldr1, (_c_36, empty, _ge_auxcall1), _v_Foldr11);
  {
    {
      if (_v_Foldr11.get_len () != 1)
      {
        goto _block1__branch1;
      }
      Expr _vt_1 (_v_Foldr11, 0, 1);
      _v_res1 = _vt_1;
      goto _block1;
    }
  _block1__branch1: {}
    uintptr_t _v_len3 = _v_Foldr11.get_len ();
    uintptr_t _v_len4 = 0;
    if (_v_len3 < _v_len4)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    uintptr_t _v_len__1 = (_v_len3 - _v_len4);
    Expr _ve_1 (_v_Foldr11, 0, _v_len__1);
    Expr _ge_auxcall2;
    RF_CALL (List::Paren, _ve_1, _ge_auxcall2);
    _v_res1 = (_c_40 + _ge_auxcall2) ();
  }
_block1: {}
RF_END

RF_FUNC (Eval_sp__a_, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  {
    {
      uintptr_t _v_len1 = _ge_arg1.get_len ();
      uintptr_t _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len___e__e_tmp_m_rfp__asail2asailrf_m_212_m_7 = (_v_len1 - _v_len2);
      if (!_c_41.term_eq (_ge_arg1, 0))
      {
        goto _block1__branch1;
      }
      Expr _ve__e__e_tmp_m_rfp__asail2asailrf_m_212_m_7 (_ge_arg1, (0 + 1), _v_len___e__e_tmp_m_rfp__asail2asailrf_m_212_m_7);
      _v_res1 = _c_41;
      goto _block1;
    }
  _block1__branch1: {}
    {
      uintptr_t _v_len3 = _ge_arg1.get_len ();
      uintptr_t _v_len4 = 1;
      if (_v_len3 < _v_len4)
      {
        goto _block1__branch2;
      }
      uintptr_t _v_len___e__e_tmp_m_rfp__asail2asailrf_m_213_m_4 = (_v_len3 - _v_len4);
      if (!_c_41.term_eq (_ge_arg1, (0 + _v_len___e__e_tmp_m_rfp__asail2asailrf_m_213_m_4)))
      {
        goto _block1__branch2;
      }
      Expr _ve__e__e_tmp_m_rfp__asail2asailrf_m_213_m_4 (_ge_arg1, 0, _v_len___e__e_tmp_m_rfp__asail2asailrf_m_213_m_4);
      _v_res1 = _c_41;
      goto _block1;
    }
  _block1__branch2: {}
    {
      uintptr_t _v_len5 = _ge_arg1.get_len ();
      uintptr_t _v_len6 = 1;
      if (_v_len5 < _v_len6)
      {
        goto _block1__branch3;
      }
      uintptr_t _v_len__2 = (_v_len5 - _v_len6);
      if (!_c_42.term_eq (_ge_arg1, 0))
      {
        goto _block1__branch3;
      }
      Expr _ve_2 (_ge_arg1, (0 + 1), _v_len__2);
      _v_res1 = _ve_2;
      goto _block1;
    }
  _block1__branch3: {}
    {
      uintptr_t _v_len7 = _ge_arg1.get_len ();
      uintptr_t _v_len8 = 1;
      if (_v_len7 < _v_len8)
      {
        goto _block1__branch4;
      }
      uintptr_t _v_len__1 = (_v_len7 - _v_len8);
      if (!_c_42.term_eq (_ge_arg1, (0 + _v_len__1)))
      {
        goto _block1__branch4;
      }
      Expr _ve_1 (_ge_arg1, 0, _v_len__1);
      _v_res1 = _ve_1;
      goto _block1;
    }
  _block1__branch4: {}
    {
      uintptr_t _v_len9 = _ge_arg1.get_len ();
      uintptr_t _v_len10 = 2;
      if (_v_len9 < _v_len10)
      {
        goto _block1__branch5;
      }
      uintptr_t _v_len__22 = (_v_len9 - _v_len10);
      if (!_ge_arg1.symbol_at (0))
      {
        goto _block1__branch5;
      }
      if (!_ge_arg1.symbol_at ((0 + 1 + _v_len__22)))
      {
        goto _block1__branch5;
      }
      Expr _vs_1 (_ge_arg1, 0, 1);
      Expr _ve_2 (_ge_arg1, (0 + 1), _v_len__22);
      Expr _vs_3 (_ge_arg1, (0 + 1 + _v_len__22), 1);
      Expr _v__a_1;
      RF_CALL (Arithm::_a_, (_vs_1, _vs_3), _v__a_1);
      _v_res1 = (_ve_2 + _v__a_1);
      goto _block1;
    }
  _block1__branch5: {}
    {
      uintptr_t _v_len11 = _ge_arg1.get_len ();
      uintptr_t _v_len12 = 1;
      if (_v_len11 < _v_len12)
      {
        goto _block1__branch6;
      }
      uintptr_t _v_len__23 = (_v_len11 - _v_len12);
      if (!_ge_arg1.symbol_at (0))
      {
        goto _block1__branch6;
      }
      Expr _vs_1 (_ge_arg1, 0, 1);
      Expr _ve_2 (_ge_arg1, (0 + 1), _v_len__23);
      _v_res1 = (_ve_2 + _vs_1);
      goto _block1;
    }
  _block1__branch6: {}
    _v_res1 = _ge_arg1;
  }
_block1: {}
RF_END

RF_FUNC (Eval_sp__p_, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  {
    {
      uintptr_t _v_len1 = _ge_arg1.get_len ();
      uintptr_t _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__2 = (_v_len1 - _v_len2);
      if (!_c_41.term_eq (_ge_arg1, 0))
      {
        goto _block1__branch1;
      }
      Expr _ve_2 (_ge_arg1, (0 + 1), _v_len__2);
      _v_res1 = _ve_2;
      goto _block1;
    }
  _block1__branch1: {}
    {
      uintptr_t _v_len3 = _ge_arg1.get_len ();
      uintptr_t _v_len4 = 1;
      if (_v_len3 < _v_len4)
      {
        goto _block1__branch2;
      }
      uintptr_t _v_len__1 = (_v_len3 - _v_len4);
      if (!_c_41.term_eq (_ge_arg1, (0 + _v_len__1)))
      {
        goto _block1__branch2;
      }
      Expr _ve_1 (_ge_arg1, 0, _v_len__1);
      _v_res1 = _ve_1;
      goto _block1;
    }
  _block1__branch2: {}
    {
      uintptr_t _v_len5 = _ge_arg1.get_len ();
      uintptr_t _v_len6 = 2;
      if (_v_len5 < _v_len6)
      {
        goto _block1__branch3;
      }
      uintptr_t _v_len__22 = (_v_len5 - _v_len6);
      if (!_ge_arg1.symbol_at (0))
      {
        goto _block1__branch3;
      }
      if (!_ge_arg1.symbol_at ((0 + 1 + _v_len__22)))
      {
        goto _block1__branch3;
      }
      Expr _vs_1 (_ge_arg1, 0, 1);
      Expr _ve_2 (_ge_arg1, (0 + 1), _v_len__22);
      Expr _vs_3 (_ge_arg1, (0 + 1 + _v_len__22), 1);
      Expr _v__p_1;
      RF_CALL (Arithm::_p_, (_vs_1, _vs_3), _v__p_1);
      _v_res1 = (_ve_2 + _v__p_1);
      goto _block1;
    }
  _block1__branch3: {}
    {
      uintptr_t _v_len7 = _ge_arg1.get_len ();
      uintptr_t _v_len8 = 1;
      if (_v_len7 < _v_len8)
      {
        goto _block1__branch4;
      }
      uintptr_t _v_len__23 = (_v_len7 - _v_len8);
      if (!_ge_arg1.symbol_at (0))
      {
        goto _block1__branch4;
      }
      Expr _vs_1 (_ge_arg1, 0, 1);
      Expr _ve_2 (_ge_arg1, (0 + 1), _v_len__23);
      _v_res1 = (_ve_2 + _vs_1);
      goto _block1;
    }
  _block1__branch4: {}
    _v_res1 = _ge_arg1;
  }
_block1: {}
RF_END

RF_FUNC (Eval_sp__s_, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  {
    {
      uintptr_t _v_len1 = _ge_arg1.get_len ();
      uintptr_t _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__1 = (_v_len1 - _v_len2);
      if (!_c_42.term_eq (_ge_arg1, (0 + _v_len__1)))
      {
        goto _block1__branch1;
      }
      Expr _ve_1 (_ge_arg1, 0, _v_len__1);
      _v_res1 = _ve_1;
      goto _block1;
    }
  _block1__branch1: {}
    _v_res1 = _ge_arg1;
  }
_block1: {}
RF_END

RF_FUNC (Eval_sp__percnt_, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  {
    {
      uintptr_t _v_len1 = _ge_arg1.get_len ();
      uintptr_t _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__1 = (_v_len1 - _v_len2);
      if (!_c_42.term_eq (_ge_arg1, (0 + _v_len__1)))
      {
        goto _block1__branch1;
      }
      Expr _ve_1 (_ge_arg1, 0, _v_len__1);
      _v_res1 = _c_41;
      goto _block1;
    }
  _block1__branch1: {}
    _v_res1 = _ge_arg1;
  }
_block1: {}
RF_END

RF_FUNC (Eval_sp__m_, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  {
    {
      uintptr_t _v_len1 = _ge_arg1.get_len ();
      uintptr_t _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__1 = (_v_len1 - _v_len2);
      if (!_c_41.term_eq (_ge_arg1, (0 + _v_len__1)))
      {
        goto _block1__branch1;
      }
      Expr _ve_1 (_ge_arg1, 0, _v_len__1);
      _v_res1 = _ve_1;
      goto _block1;
    }
  _block1__branch1: {}
    _v_res1 = _ge_arg1;
  }
_block1: {}
RF_END

RF_FUNC (Simplify_m_Cmp, (RF_ARG _vs_op, _ve_xpr1, _ve_xpr2;;), (RF_RES _v_res1;;))
  Expr _gs_op__1;
  {
    {
      if (!_vs_op.term_eq (_c_43, 0))
      {
        goto _block1__branch1;
      }
      _gs_op__1 = _c_44;
      goto _block1;
    }
  _block1__branch1: {}
    {
      if (!_vs_op.term_eq (_c_45, 0))
      {
        goto _block1__branch2;
      }
      _gs_op__1 = _c_46;
      goto _block1;
    }
  _block1__branch2: {}
    if (!_vs_op.term_eq (_c_47, 0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    _gs_op__1 = _c_48;
  }
_block1: {}
  RF_TAILCALL (Cmp, (_gs_op__1, _ve_xpr1, _ve_xpr2), _v_res1);
RF_END

RF_FUNC (Cmp, (RF_ARG _gs_arg1, _ge_arg2, _ge_arg3;;), (RF_RES _v_res1;;))
  {
    {
      Expr _v_compose1 ((_gs_arg1 + _ge_arg2 () + _ge_arg3 ()));
      if (_v_compose1.symbol_at ((0 + 1)))
      {
        goto _block1__branch1;
      }
      if (_v_compose1.symbol_at ((0 + 1 + 1)))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__compose1 (_v_compose1, (0 + 1));
      Expr _v_deref__compose12 (_v_compose1, (0 + 1 + 1));
      if (_v_deref__compose12.get_len () < 1)
      {
        goto _block1__branch1;
      }
      if (_v_deref__compose1.get_len () < 1)
      {
        goto _block1__branch1;
      }
      if (!_v_compose1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _vs_fn (_v_compose1, 0, 1);
      RF_lsplit (_v_deref__compose1, 0, _ve_11, _v_lsplit__deref__compose1);
      for ( ; ; RF_iter(_v_deref__compose1)++)
      {
        {
          if (!RF_iter(_v_deref__compose1))
          {
            goto _block1__branch1;
          }
          uintptr_t _v_len1 = _v_lsplit__deref__compose1.get_len ();
          uintptr_t _v_len2 = 1;
          if (_v_len1 < _v_len2)
          {
            goto _block1__branch1;
          }
          uintptr_t _v_len__12 = (_v_len1 - _v_len2);
          Expr _vt_x (_v_lsplit__deref__compose1, 0, 1);
          Expr _ve_12 (_v_lsplit__deref__compose1, (0 + 1), _v_len__12);
          RF_lsplit (_v_deref__compose12, 0, _ve_21, _v_lsplit__deref__compose12);
          for ( ; ; RF_iter(_v_deref__compose12)++)
          {
            {
              if (!RF_iter(_v_deref__compose12))
              {
                goto _continue1;
              }
              uintptr_t _v_len3 = _v_lsplit__deref__compose12.get_len ();
              uintptr_t _v_len4 = 1;
              if (_v_len3 < _v_len4)
              {
                goto _continue1;
              }
              uintptr_t _v_len__22 = (_v_len3 - _v_len4);
              if (!_vt_x.term_eq (_v_lsplit__deref__compose12, 0))
              {
                goto _continue2;
              }
              Expr _ve_22 (_v_lsplit__deref__compose12, (0 + 1), _v_len__22);
              RF_TAILCALL (Cmp, (_vs_fn, (_ve_11 + _ve_12), (_ve_21 + _ve_22)), _v_res1);
              goto _exit2;
            }
        _continue2: {}
          }
        _exit2: {}
          goto _exit1;
        }
    _continue1: {}
      }
    _exit1: {}
      goto _block1;
    }
  _block1__branch1: {}
    {
      if (!RF_CALL (List::All, (_c_49, empty, _ge_arg2), /*void*/))
      {
        goto _block1__branch2;
      }
      if (!RF_CALL (List::All, (_c_49, empty, _ge_arg3), /*void*/))
      {
        goto _block1__branch2;
      }
      Expr _ge_auxcall1;
      RF_CALL (List::Foldr1, (_c_50, empty, _ge_arg2), _ge_auxcall1);
      Expr _ge_auxcall2;
      RF_CALL (List::Foldr1, (_c_50, empty, _ge_arg3), _ge_auxcall2);
      RF_TAILCALL (Apply::Apply, (_gs_arg1, (_ge_auxcall1 () + _ge_auxcall2 ())), _v_res1);
      goto _block1;
    }
  _block1__branch2: {}
    _v_res1 = (_ge_arg2 () + _ge_arg3 ());
  }
_block1: {}
RF_END

RF_FUNC (Free_m_Idx, RF_VOID, (RF_RES _v_res1;;))
  Expr _vs_1;
  {
    {
      Expr _v__q_1;
      RF_CALL (Box::_q_, Idx, _v__q_1);
      if (_v__q_1.get_len () != 1)
      {
        goto _block1__branch1;
      }
      if (!_v__q_1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _gs_1__2 (_v__q_1, 0, 1);
      RF_CALL (Arithm::_p_, (_gs_1__2, _c_42), _vs_1);
      goto _block1;
    }
  _block1__branch1: {}
    _vs_1 = _c_42;
  }
_block1: {}
  RF_CALL (Box::Store, (Idx, _vs_1), /*void*/);
  _v_res1 = _vs_1;
RF_END

RF_FUNC (_p___0, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  if (_ge_arg1.get_len () != 2)
  {
    RF_ERROR (_c_51);
  }
  if (!_ge_arg1.symbol_at (0))
  {
    RF_ERROR (_c_51);
  }
  if (!_ge_arg1.symbol_at ((0 + 1)))
  {
    RF_ERROR (_c_51);
  }
  Expr _v_stub1 (_ge_arg1, 0, 1);
  Expr _v_stub2 (_ge_arg1, (0 + 1), 1);
  RF_CALL (Arithm::_p_, (_v_stub1, _v_stub2), _v_res1);
RF_END

RF_FUNC (Int_q___0, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  uintptr_t _v_len1 = _ge_arg1.get_len ();
  uintptr_t _v_len2 = 0;
  if (_v_len1 < _v_len2)
  {
    RF_ERROR (_c_51);
  }
  uintptr_t _v_len__stub1 = (_v_len1 - _v_len2);
  Expr _v_stub1 (_ge_arg1, 0, _v_len__stub1);
  if (!RF_CALL (Class::Int_q_, _v_stub1, /*void*/))
  {
    RF_RETFAIL;
  }
  _v_res1 = empty;
RF_END

RF_FUNC (_lt___0, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  if (_ge_arg1.get_len () != 2)
  {
    RF_ERROR (_c_51);
  }
  if (_ge_arg1.symbol_at (0))
  {
    RF_ERROR (_c_51);
  }
  if (_ge_arg1.symbol_at ((0 + 1)))
  {
    RF_ERROR (_c_51);
  }
  Expr _v_deref__arg1 (_ge_arg1, 0);
  Expr _v_deref__arg12 (_ge_arg1, (0 + 1));
  uintptr_t _v_len1 = _v_deref__arg12.get_len ();
  uintptr_t _v_len2 = 0;
  if (_v_len1 < _v_len2)
  {
    RF_ERROR (_c_51);
  }
  uintptr_t _v_len__stub1 = (_v_len1 - _v_len2);
  uintptr_t _v_len3 = _v_deref__arg1.get_len ();
  uintptr_t _v_len4 = 0;
  if (_v_len3 < _v_len4)
  {
    RF_ERROR (_c_51);
  }
  uintptr_t _v_len__stub2 = (_v_len3 - _v_len4);
  Expr _v_stub2 (_v_deref__arg1, 0, _v_len__stub2);
  Expr _v_stub1 (_v_deref__arg12, 0, _v_len__stub1);
  if (!RF_CALL (Compare::_lt_, (_v_stub2, _v_stub1), /*void*/))
  {
    RF_RETFAIL;
  }
  _v_res1 = empty;
RF_END

RF_FUNC (_s__eq___0, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  if (_ge_arg1.get_len () != 2)
  {
    RF_ERROR (_c_51);
  }
  if (_ge_arg1.symbol_at (0))
  {
    RF_ERROR (_c_51);
  }
  if (_ge_arg1.symbol_at ((0 + 1)))
  {
    RF_ERROR (_c_51);
  }
  Expr _v_deref__arg1 (_ge_arg1, 0);
  Expr _v_deref__arg12 (_ge_arg1, (0 + 1));
  uintptr_t _v_len1 = _v_deref__arg12.get_len ();
  uintptr_t _v_len2 = 0;
  if (_v_len1 < _v_len2)
  {
    RF_ERROR (_c_51);
  }
  uintptr_t _v_len__stub1 = (_v_len1 - _v_len2);
  uintptr_t _v_len3 = _v_deref__arg1.get_len ();
  uintptr_t _v_len4 = 0;
  if (_v_len3 < _v_len4)
  {
    RF_ERROR (_c_51);
  }
  uintptr_t _v_len__stub2 = (_v_len3 - _v_len4);
  Expr _v_stub2 (_v_deref__arg1, 0, _v_len__stub2);
  Expr _v_stub1 (_v_deref__arg12, 0, _v_len__stub1);
  if (!RF_CALL (Compare::_s__eq_, (_v_stub2, _v_stub1), /*void*/))
  {
    RF_RETFAIL;
  }
  _v_res1 = empty;
RF_END

RF_FUNC (Simplify_m_Infix__0, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  if (_ge_arg1.get_len () != 1)
  {
    RF_ERROR (_c_51);
  }
  Expr _v_stub1 (_ge_arg1, 0, 1);
  RF_CALL (Simplify_m_Infix, _v_stub1, _v_res1);
RF_END

RF_FUNC (_gt___0, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  if (_ge_arg1.get_len () != 2)
  {
    RF_ERROR (_c_51);
  }
  if (_ge_arg1.symbol_at (0))
  {
    RF_ERROR (_c_51);
  }
  if (_ge_arg1.symbol_at ((0 + 1)))
  {
    RF_ERROR (_c_51);
  }
  Expr _v_deref__arg1 (_ge_arg1, 0);
  Expr _v_deref__arg12 (_ge_arg1, (0 + 1));
  uintptr_t _v_len1 = _v_deref__arg12.get_len ();
  uintptr_t _v_len2 = 0;
  if (_v_len1 < _v_len2)
  {
    RF_ERROR (_c_51);
  }
  uintptr_t _v_len__stub1 = (_v_len1 - _v_len2);
  uintptr_t _v_len3 = _v_deref__arg1.get_len ();
  uintptr_t _v_len4 = 0;
  if (_v_len3 < _v_len4)
  {
    RF_ERROR (_c_51);
  }
  uintptr_t _v_len__stub2 = (_v_len3 - _v_len4);
  Expr _v_stub2 (_v_deref__arg1, 0, _v_len__stub2);
  Expr _v_stub1 (_v_deref__arg12, 0, _v_len__stub1);
  if (!RF_CALL (Compare::_gt_, (_v_stub2, _v_stub1), /*void*/))
  {
    RF_RETFAIL;
  }
  _v_res1 = empty;
RF_END

}

namespace rfp__asail2asail
{

static void init_ ()
{
  Idx = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Idx");
  Blocks = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Blocks");
  Breaks = new rftype::StaticObject<rftype::Table>(L"Breaks");
  Last_m_Breaks = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Last-Breaks");
  _c_0 = Expr::create<rftype::Word>("IF-INT-CMP");
  _c_1 = Expr::create<rftype::Word>("IF");
  _c_2 = Expr::create<rftype::Word>("INT");
  _c_3 = Expr::create<rftype::Word>("FUNC");
  _c_4 = Expr::create<rftype::Word>("FUNC?");
  _c_5 = Expr::create<rftype::Word>("FOR");
  _c_6 = Expr::create<rftype::Word>("LABEL");
  _c_7 = Expr::create<rftype::Word>("TRY");
  _c_8 = (_c_7) ();
  _c_9 = Expr::create<rftype::Word>("CATCH-ERROR");
  _c_10 = (_c_9) ();
  _c_11 = (empty) ();
  _c_12 = Expr::create<rftype::Word>("Normal-Exit");
  _c_13 = Expr::create<rftype::Word>("Persistent");
  _c_14 = Expr::create<rftype::Word>("BREAK");
  _c_15 = Expr::create<rftype::Word>("CONTINUE");
  _c_16 = Expr::create<rftype::Word>("RETFAIL");
  _c_17 = Expr::create<rftype::Word>("ERROR");
  _c_18 = Expr::create<rftype::Word>("FATAL");
  _c_19 = Expr::create<rftype::Word>("DECL");
  _c_20 = Expr::create<rftype::Word>("EXPR");
  _c_21 = Expr::create<rftype::Word>("Expr");
  _c_22 = Expr::create<rftype::Word>("ASSIGN");
  _c_23 = Expr::create<rftype::Word>("LSPLIT");
  _c_24 = Expr::create<rftype::Word>("RSPLIT");
  _c_25 = Expr::create<rftype::Word>("Split");
  _c_26 = rftype::Char::create_expr (L"dd");
  _c_40 = Expr::create<rftype::Word>("INFIX") + Expr::create<rftype::Word>("+");
  _c_27 = Expr (_c_40, 0, 1);
  _c_28 = Expr::create<rftype::Word>("*");
  _c_29 = Expr::create_sym<rftype::Func> (Simplify_m_Arithm);
  _c_30 = Expr::create_sym<rftype::Func> (Eval_sp__a_);
  _c_31 = Expr::create<rftype::Word>("/");
  _c_32 = Expr::create_sym<rftype::Func> (Eval_sp__s_);
  _c_33 = Expr::create<rftype::Word>("%");
  _c_34 = Expr::create_sym<rftype::Func> (Eval_sp__percnt_);
  _c_35 = Expr (_c_40, 1, 1);
  _c_36 = Expr::create_sym<rftype::Func> (Eval_sp__p_);
  _c_37 = Expr::create<rftype::Word>("-");
  _c_38 = Expr::create_sym<rftype::Func> (Eval_sp__m_);
  _c_39 = Expr::create_sym<rftype::Func> (Simplify_m_Infix__0);
  _c_41 = Expr::create<rftype::Integer>("0");
  _c_42 = Expr::create<rftype::Integer>("1");
  _c_43 = Expr::create<rftype::Word>("!=");
  _c_44 = Expr::create_sym<rftype::Func> (_s__eq___0);
  _c_45 = Expr::create<rftype::Word>(">");
  _c_46 = Expr::create_sym<rftype::Func> (_gt___0);
  _c_47 = Expr::create<rftype::Word>("<");
  _c_48 = Expr::create_sym<rftype::Func> (_lt___0);
  _c_49 = Expr::create_sym<rftype::Func> (Int_q___0);
  _c_50 = Expr::create_sym<rftype::Func> (_p___0);
  _c_51 = Expr::create<rftype::Word>("Apply") + Expr::create<rftype::Word>("Apply") + Expr::create<rftype::Word>("Unexpected fail");
}

static AtStart init_registrator_ (&init_);

}

}
