#include <rf_core.hh>
#include <refal/Access.hh>
#include <refal/Arithm.hh>
#include <refal/Compare.hh>
#include <refal/List.hh>
#include <refal/Convert.hh>
#include <refal/Box.hh>
#include <refal/Table.hh>
#include "rfp_err.hh"
#include "rfp_compile.hh"
#include <refal/StdIO.hh>
#include "rfp_helper.hh"
#include "rfpc.hh"
#include "rfp_vars.hh"
#include "rfp_format.hh"

namespace refal
{

using namespace rfrt;

namespace rfp__check
{

RF_DECL (RFP_m_Check);

RF_DECL (Satisfies_m_Format_q_);

RF_DECL (Check_m_Inputs);

RF_DECL (Check_m_Vars);

RF_DECL (Update_m_Vars);

RF_DECL (Get_m_Cuts);

RF_DECL (Print_m_Error);

RF_DECL (Print_m_Pragma);

RF_DECL (AS_m_To_m_Ref);

static Expr _c_0;

static Expr _c_1;

static Expr _c_2;

static Expr _c_3;

static Expr _c_4;

static Expr _c_41;

static Expr _c_5;

static Expr _c_59;

static Expr _c_6;

static Expr _c_7;

static Expr _c_31;

static Expr _c_8;

static Expr _c_9;

static Expr _c_10;

static Expr _c_11;

static Expr _c_12;

static Expr _c_13;

static Expr _c_14;

static Expr _c_15;

static Expr _c_16;

static Expr _c_17;

static Expr _c_18;

static Expr _c_19;

static Expr _c_20;

static Expr _c_45;

static Expr _c_21;

static Expr _c_22;

static Expr _c_23;

static Expr _c_24;

static Expr _c_25;

static Expr _c_26;

static Expr _c_27;

static Expr _c_28;

static Expr _c_43;

static Expr _c_29;

static Expr _c_30;

static Expr _c_32;

static Expr _c_33;

static Expr _c_34;

static Expr _c_55;

static Expr _c_35;

static Expr _c_49;

static Expr _c_36;

static Expr _c_52;

static Expr _c_37;

static Expr _c_38;

static Expr _c_39;

static Expr _c_40;

static Expr _c_42;

static Expr _c_44;

static Expr _c_46;

static Expr _c_47;

static Expr _c_48;

static Expr _c_50;

static Expr _c_51;

static Expr _c_53;

static Expr _c_54;

static Expr _c_56;

static Expr _c_57;

static Expr _c_58;

static Expr _c_60;

static Expr _c_61;

static Expr _c_62;

static Expr _c_63;

static Expr _c_64;

static Expr _c_65;

static Expr _c_66;

static Expr _c_67;

static Expr _c_68;

static Expr _c_69;

static Expr _c_70;

RF_FUNC (RFP_m_Check, (RF_ARG _ve_Items;;), RF_VOID)
  {
    if (_ve_Items.get_len () < 1)
    {
      goto _block1__branch1;
    }
    RF_lsplit (_ve_Items, 0, _ve__e__e_tmp_m_rfp__checkrf_m_41_m_14, _v_lsplit__Items);
    for ( ; ; RF_iter(_ve_Items)++)
    {
      {
        if (!RF_iter(_ve_Items))
        {
          goto _block1__branch1;
        }
        uintptr_t _v_len1 = _v_lsplit__Items.get_len ();
        uintptr_t _v_len2 = 1;
        if (_v_len1 < _v_len2)
        {
          goto _block1__branch1;
        }
        uintptr_t _v_len___e__e_tmp_m_rfp__checkrf_m_41_m_23 = (_v_len1 - _v_len2);
        Expr _vt_item (_v_lsplit__Items, 0, 1);
        Expr _ve__e__e_tmp_m_rfp__checkrf_m_41_m_23 (_v_lsplit__Items, (0 + 1), _v_len___e__e_tmp_m_rfp__checkrf_m_41_m_23);
        {
          {
            Expr _v_Lookup1;
            if (!RF_CALL (Table::Lookup, (rfp__helper::RFP_m_Options, _c_0), _v_Lookup1))
            {
              goto _block2__branch1;
            }
            uintptr_t _v_len3 = _v_Lookup1.get_len ();
            uintptr_t _v_len4 = 0;
            if (_v_len3 < (_v_len4 + 1))
            {
              goto _block2__branch1;
            }
            uintptr_t _v_len__targets = (_v_len3 - _v_len4);
            Expr _vv_targets (_v_Lookup1, 0, _v_len__targets);
            if (_v_len__targets < 1)
            {
              goto _continue1;
            }
            if (_vt_item.symbol_at (0))
            {
              goto _continue1;
            }
            Expr _v_deref__item (_vt_item, 0);
            uintptr_t _v_len5 = _v_deref__item.get_len ();
            uintptr_t _v_len6 = 4;
            if (_v_len5 < _v_len6)
            {
              goto _continue1;
            }
            uintptr_t _v_len___e__e_tmp_m_rfp__checkrf_m_45_m_33 = (_v_len5 - _v_len6);
            Expr _vt__e__e_tmp_m_rfp__checkrf_m_45_m_20 (_v_deref__item, 0, 1);
            Expr _vt__e__e_tmp_m_rfp__checkrf_m_45_m_22 (_v_deref__item, (0 + 1), 1);
            Expr _vt__e__e_tmp_m_rfp__checkrf_m_45_m_24 (_v_deref__item, (0 + 1 + 1), 1);
            Expr _vt_name (_v_deref__item, (0 + 1 + 1 + 1), 1);
            Expr _ve__e__e_tmp_m_rfp__checkrf_m_45_m_33 (_v_deref__item, (0 + 1 + 1 + 1 + 1), _v_len___e__e_tmp_m_rfp__checkrf_m_45_m_33);
            RF_lsplit (_vv_targets, 0, _ve__e__e_tmp_m_rfp__checkrf_m_44_m_22, _v_lsplit__targets);
            for ( ; ; RF_iter(_vv_targets)++)
            {
              {
                if (!RF_iter(_vv_targets))
                {
                  goto _continue1;
                }
                uintptr_t _v_len7 = _v_lsplit__targets.get_len ();
                uintptr_t _v_len8 = 1;
                if (_v_len7 < _v_len8)
                {
                  goto _continue1;
                }
                uintptr_t _v_len___e__e_tmp_m_rfp__checkrf_m_44_m_31 = (_v_len7 - _v_len8);
                if (!_vt_name.term_eq (_v_lsplit__targets, 0))
                {
                  goto _continue2;
                }
                Expr _ve__e__e_tmp_m_rfp__checkrf_m_44_m_31 (_v_lsplit__targets, (0 + 1), _v_len___e__e_tmp_m_rfp__checkrf_m_44_m_31);
                goto _exit2;
              }
          _continue2: {}
            }
          _exit2: {}
            goto _block2;
          }
        _block2__branch1: {}
        }
      _block2: {}
        if (_vt_item.symbol_at (0))
        {
          goto _continue1;
        }
        Expr _v_deref__item2 (_vt_item, 0);
        if (_v_deref__item2.get_len () != 7)
        {
          goto _continue1;
        }
        if (_v_deref__item2.symbol_at ((0 + 1 + 1 + 1 + 1)))
        {
          goto _continue1;
        }
        if (_v_deref__item2.symbol_at ((0 + 1 + 1 + 1 + 1 + 1)))
        {
          goto _continue1;
        }
        Expr _v_deref__deref__item2 (_v_deref__item2, (0 + 1 + 1 + 1 + 1));
        Expr _v_deref__deref__item22 (_v_deref__item2, (0 + 1 + 1 + 1 + 1 + 1));
        uintptr_t _v_len9 = _v_deref__deref__item22.get_len ();
        uintptr_t _v_len10 = 0;
        if (_v_len9 < _v_len10)
        {
          goto _continue1;
        }
        uintptr_t _v_len__out = (_v_len9 - _v_len10);
        uintptr_t _v_len11 = _v_deref__deref__item2.get_len ();
        uintptr_t _v_len12 = 0;
        if (_v_len11 < _v_len12)
        {
          goto _continue1;
        }
        uintptr_t _v_len__in = (_v_len11 - _v_len12);
        if (!_v_deref__item2.symbol_at (0))
        {
          goto _continue1;
        }
        if (!_v_deref__item2.symbol_at ((0 + 1)))
        {
          goto _continue1;
        }
        Expr _vs_linkage (_v_deref__item2, 0, 1);
        Expr _vs_tag (_v_deref__item2, (0 + 1), 1);
        Expr _vt_pragma (_v_deref__item2, (0 + 1 + 1), 1);
        Expr _vt_name (_v_deref__item2, (0 + 1 + 1 + 1), 1);
        Expr _vt_branch (_v_deref__item2, (0 + 1 + 1 + 1 + 1 + 1 + 1), 1);
        Expr _ve_in (_v_deref__deref__item2, 0, _v_len__in);
        Expr _ve_out (_v_deref__deref__item22, 0, _v_len__out);
        {
          {
            if (!_vs_tag.term_eq (_c_1, 0))
            {
              goto _block3__branch1;
            }
            goto _block3;
          }
        _block3__branch1: {}
          {
            if (!_vs_tag.term_eq (_c_2, 0))
            {
              goto _block3__branch2;
            }
            goto _block3;
          }
        _block3__branch2: {}
          if (!_vs_tag.term_eq (_c_3, 0))
          {
            goto _continue1;
          }
        }
      _block3: {}
        {
          {
            Expr _ge_auxcall1;
            RF_CALL (rfp__format::Format_m_Exp, _ve_in, _ge_auxcall1);
            Expr _ge_auxcall2;
            RF_CALL (rfp__format::Format_m_Exp, _ve_out, _ge_auxcall2);
            if (!RF_CALL (Satisfies_m_Format_q_, (_ge_auxcall1, _ge_auxcall2, _vt_branch), /*void*/))
            {
              goto _block4__branch1;
            }
            goto _block4;
          }
        _block4__branch1: {}
        }
      _block4: {}
        Expr _ge_auxcall3;
        RF_CALL (rfp__vars::Vars, _ve_in, _ge_auxcall3);
        RF_CALL (Check_m_Vars, (_ge_auxcall3, _vt_branch), /*void*/);
        {
          {
            Expr _ge_auxcall4;
            if (!RF_CALL (Get_m_Cuts, _vt_branch, _ge_auxcall4))
            {
              goto _block5__branch1;
            }
            Expr _gt_auxcall5;
            if (!RF_CALL (Access::R, (_c_4, _ge_auxcall4), _gt_auxcall5))
            {
              goto _block5__branch1;
            }
            RF_CALL (Print_m_Error, (_c_5, _c_6, _gt_auxcall5), /*void*/);
            goto _block5;
          }
        _block5__branch1: {}
        }
      _block5: {}
      }
  _continue1: {}
    }
  _exit1: {}
  }
_block1__branch1: {}
RF_END

RF_FUNC (Satisfies_m_Format_q_, (RF_ARG _ve_InFormat, _ve_OutFormat, _ve_Sentence;;), RF_VOID)
  {
    {
      if (_ve_Sentence.get_len () < 1)
      {
        goto _block1__branch1;
      }
      RF_rsplit (_ve_Sentence, 0, _v_rsplit__Sentence, _ve_queue);
      for ( ; ; RF_iter(_ve_Sentence)--)
      {
        {
          if (!RF_iter(_ve_Sentence))
          {
            goto _block1__branch1;
          }
          uintptr_t _v_len1 = _v_rsplit__Sentence.get_len ();
          uintptr_t _v_len2 = 1;
          if (_v_len1 < _v_len2)
          {
            goto _block1__branch1;
          }
          uintptr_t _v_len__Snt = (_v_len1 - _v_len2);
          if (_v_rsplit__Sentence.symbol_at ((0 + _v_len__Snt)))
          {
            goto _continue1;
          }
          Expr _v_deref__rsplit__Sentence (_v_rsplit__Sentence, (0 + _v_len__Snt));
          if (_v_deref__rsplit__Sentence.get_len () != 2)
          {
            goto _continue1;
          }
          if (!_c_7.term_eq (_v_deref__rsplit__Sentence, 0))
          {
            goto _continue1;
          }
          Expr _ve_Snt (_v_rsplit__Sentence, 0, _v_len__Snt);
          Expr _vt__e__e_tmp_m_rfp__checkrf_m_63_m_33 (_v_deref__rsplit__Sentence, (0 + 1), 1);
          if (!RF_CALL (Satisfies_m_Format_q_, (empty, _c_8, _ve_queue), /*void*/))
          {
            RF_RETFAIL;
          }
          RF_TAILCALL (Satisfies_m_Format_q_, (_ve_InFormat, empty, _ve_Snt), /*void*/);
          goto _exit1;
        }
    _continue1: {}
      }
    _exit1: {}
      goto _block1;
    }
  _block1__branch1: {}
    Expr _ge_Sentence__2 (_ve_Sentence);
    Expr _ge_OutFormat__2 (_ve_OutFormat);
    for ( ; ; )
    {
      {
        if (_ge_Sentence__2.get_len () != 0)
        {
          goto _iter1;
        }
        goto _exit__iter1;
      }
    _iter1: {}
      uintptr_t _v_len3 = _ge_Sentence__2.get_len ();
      uintptr_t _v_len4 = 1;
      if (_v_len3 < _v_len4)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      uintptr_t _v_len__Snt2 = (_v_len3 - _v_len4);
      Expr _ve_Snt (_ge_Sentence__2, 0, _v_len__Snt2);
      Expr _vt_Statement (_ge_Sentence__2, (0 + _v_len__Snt2), 1);
      {
        {
          if (_vt_Statement.symbol_at (0))
          {
            goto _block3__branch1;
          }
          Expr _v_deref__Statement (_vt_Statement, 0);
          uintptr_t _v_len5 = _v_deref__Statement.get_len ();
          uintptr_t _v_len6 = 2;
          if (_v_len5 < _v_len6)
          {
            goto _block3__branch1;
          }
          uintptr_t _v_len__ResultExpression = (_v_len5 - _v_len6);
          if (!_c_9.term_eq (_v_deref__Statement, 0))
          {
            goto _block3__branch1;
          }
          Expr _vt_Pragma (_v_deref__Statement, (0 + 1), 1);
          Expr _ve_ResultExpression (_v_deref__Statement, (0 + 1 + 1), _v_len__ResultExpression);
          {
            {
              if (_v_len__ResultExpression != 1)
              {
                goto _block4__branch1;
              }
              if (_ve_ResultExpression.symbol_at (0))
              {
                goto _block4__branch1;
              }
              Expr _v_deref__ResultExpression (_ve_ResultExpression, 0);
              uintptr_t _v_len7 = _v_deref__ResultExpression.get_len ();
              uintptr_t _v_len8 = 1;
              if (_v_len7 < _v_len8)
              {
                goto _block4__branch1;
              }
              uintptr_t _v_len___e__e_tmp_m_rfp__checkrf_m_71_m_44 = (_v_len7 - _v_len8);
              if (!_v_deref__ResultExpression.symbol_at (0))
              {
                goto _block4__branch1;
              }
              Expr _vs_block (_v_deref__ResultExpression, 0, 1);
              Expr _ve__e__e_tmp_m_rfp__checkrf_m_71_m_44 (_v_deref__ResultExpression, (0 + 1), _v_len___e__e_tmp_m_rfp__checkrf_m_71_m_44);
              {
                {
                  if (!_vs_block.term_eq (_c_10, 0))
                  {
                    goto _block5__branch1;
                  }
                  goto _block5;
                }
              _block5__branch1: {}
                if (!_vs_block.term_eq (_c_11, 0))
                {
                  goto _block4__branch1;
                }
              }
            _block5: {}
              if (!RF_CALL (Satisfies_m_Format_q_, (empty, _ge_OutFormat__2, _ve_ResultExpression), /*void*/))
              {
                RF_RETFAIL;
              }
              _ge_Sentence__2 = _ve_Snt;
              _ge_OutFormat__2 = empty;
              goto _block4;
            }
          _block4__branch1: {}
            {
              Expr _ge_auxcall1;
              RF_CALL (rfp__format::Format_m_Exp, _ve_ResultExpression, _ge_auxcall1);
              if (!RF_CALL (rfp__format::Subformat_q_, (_ge_OutFormat__2, _ge_auxcall1), /*void*/))
              {
                goto _block4__branch2;
              }
              RF_CALL (Check_m_Inputs, _ve_ResultExpression, /*void*/);
              _ge_Sentence__2 = _ve_Snt;
              _ge_OutFormat__2 = empty;
              goto _block4;
            }
          _block4__branch2: {}
            RF_CALL (Print_m_Error, (_c_5, _c_12, _vt_Pragma), /*void*/);
            RF_RETFAIL;
          }
        _block4: {}
          goto _block3;
        }
      _block3__branch1: {}
        {
          if (_vt_Statement.symbol_at (0))
          {
            goto _block3__branch2;
          }
          Expr _v_deref__Statement2 (_vt_Statement, 0);
          uintptr_t _v_len9 = _v_deref__Statement2.get_len ();
          uintptr_t _v_len10 = 2;
          if (_v_len9 < _v_len10)
          {
            goto _block3__branch2;
          }
          uintptr_t _v_len__HardExpression = (_v_len9 - _v_len10);
          if (!_c_13.term_eq (_v_deref__Statement2, 0))
          {
            goto _block3__branch2;
          }
          Expr _vt_Pragma (_v_deref__Statement2, (0 + 1), 1);
          Expr _ve_HardExpression (_v_deref__Statement2, (0 + 1 + 1), _v_len__HardExpression);
          Expr _ge_auxcall2;
          RF_CALL (rfp__format::Format_m_Exp, _ve_HardExpression, _ge_auxcall2);
          _ge_Sentence__2 = _ve_Snt;
          _ge_OutFormat__2 = _ge_auxcall2;
          goto _block3;
        }
      _block3__branch2: {}
        {
          if (_vt_Statement.symbol_at (0))
          {
            goto _block3__branch3;
          }
          Expr _v_deref__Statement3 (_vt_Statement, 0);
          uintptr_t _v_len11 = _v_deref__Statement3.get_len ();
          uintptr_t _v_len12 = 2;
          if (_v_len11 < _v_len12)
          {
            goto _block3__branch3;
          }
          uintptr_t _v_len__Branches = (_v_len11 - _v_len12);
          if (!_v_deref__Statement3.symbol_at (0))
          {
            goto _block3__branch3;
          }
          Expr _vs_block (_v_deref__Statement3, 0, 1);
          Expr _vt__e__e_tmp_m_rfp__checkrf_m_91_m_19 (_v_deref__Statement3, (0 + 1), 1);
          Expr _ve_Branches (_v_deref__Statement3, (0 + 1 + 1), _v_len__Branches);
          {
            {
              if (!_vs_block.term_eq (_c_10, 0))
              {
                goto _block6__branch1;
              }
              goto _block6;
            }
          _block6__branch1: {}
            if (!_vs_block.term_eq (_c_11, 0))
            {
              goto _block3__branch3;
            }
          }
        _block6: {}
          Expr _ve_pref;
          {
            {
              if (_v_len__Snt2 != 0)
              {
                goto _block7__branch1;
              }
              _ve_pref = empty;
              goto _block7;
            }
          _block7__branch1: {}
            _ve_pref = _c_14;
          }
        _block7: {}
          {
            if (_v_len__Branches < 1)
            {
              goto _block8__branch1;
            }
            RF_lsplit (_ve_Branches, 0, _ve__e__e_tmp_m_rfp__checkrf_m_97_m_27, _v_lsplit__Branches);
            for ( ; ; RF_iter(_ve_Branches)++)
            {
              {
                if (!RF_iter(_ve_Branches))
                {
                  goto _block8__branch1;
                }
                uintptr_t _v_len13 = _v_lsplit__Branches.get_len ();
                uintptr_t _v_len14 = 1;
                if (_v_len13 < _v_len14)
                {
                  goto _block8__branch1;
                }
                uintptr_t _v_len___e__e_tmp_m_rfp__checkrf_m_97_m_47 = (_v_len13 - _v_len14);
                if (_v_lsplit__Branches.symbol_at (0))
                {
                  goto _continue2;
                }
                Expr _v_deref__lsplit__Branches (_v_lsplit__Branches, 0);
                uintptr_t _v_len15 = _v_deref__lsplit__Branches.get_len ();
                uintptr_t _v_len16 = 2;
                if (_v_len15 < _v_len16)
                {
                  goto _continue2;
                }
                uintptr_t _v_len__Snt1 = (_v_len15 - _v_len16);
                if (!_c_15.term_eq (_v_deref__lsplit__Branches, 0))
                {
                  goto _continue2;
                }
                Expr _ve__e__e_tmp_m_rfp__checkrf_m_97_m_47 (_v_lsplit__Branches, (0 + 1), _v_len___e__e_tmp_m_rfp__checkrf_m_97_m_47);
                Expr _vt__e__e_tmp_m_rfp__checkrf_m_97_m_37 (_v_deref__lsplit__Branches, (0 + 1), 1);
                Expr _ve_Snt1 (_v_deref__lsplit__Branches, (0 + 1 + 1), _v_len__Snt1);
                if (!RF_CALL (Satisfies_m_Format_q_, (_ve_InFormat, _ge_OutFormat__2, (_ve_pref + _ve_Snt1)), /*void*/))
                {
                  goto _continue2;
                }
              }
          _continue2: {}
            }
          _exit2: {}
          }
        _block8__branch1: {}
          _ge_Sentence__2 = _ve_Snt;
          _ge_OutFormat__2 = _c_8;
          goto _block3;
        }
      _block3__branch3: {}
        {
          if (_vt_Statement.symbol_at (0))
          {
            goto _block3__branch4;
          }
          Expr _v_deref__Statement4 (_vt_Statement, 0);
          if (_v_deref__Statement4.get_len () != 2)
          {
            goto _block3__branch4;
          }
          if (_v_deref__Statement4.symbol_at ((0 + 1)))
          {
            goto _block3__branch4;
          }
          Expr _v_deref__deref__Statement4 (_v_deref__Statement4, (0 + 1));
          uintptr_t _v_len17 = _v_deref__deref__Statement4.get_len ();
          uintptr_t _v_len18 = 2;
          if (_v_len17 < _v_len18)
          {
            goto _block3__branch4;
          }
          uintptr_t _v_len__Snt12 = (_v_len17 - _v_len18);
          if (!_c_16.term_eq (_v_deref__Statement4, 0))
          {
            goto _block3__branch4;
          }
          if (!_c_15.term_eq (_v_deref__deref__Statement4, 0))
          {
            goto _block3__branch4;
          }
          Expr _vt__e__e_tmp_m_rfp__checkrf_m_102_m_23 (_v_deref__deref__Statement4, (0 + 1), 1);
          Expr _ve_Snt1 (_v_deref__deref__Statement4, (0 + 1 + 1), _v_len__Snt12);
          {
            {
              if (!RF_CALL (rfp__format::Subformat_q_, (_ge_OutFormat__2, empty), /*void*/))
              {
                goto _block9__branch1;
              }
              _ge_Sentence__2 = (_ve_Snt + _ve_Snt1);
              _ge_OutFormat__2 = empty;
              goto _block9;
            }
          _block9__branch1: {}
            RF_CALL (Print_m_Error, (_c_5, _c_12, _vt_Statement), /*void*/);
            RF_RETFAIL;
          }
        _block9: {}
          goto _block3;
        }
      _block3__branch4: {}
        {
          if (_vt_Statement.symbol_at (0))
          {
            goto _block3__branch5;
          }
          Expr _v_deref__Statement5 (_vt_Statement, 0);
          if (_v_deref__Statement5.get_len () != 4)
          {
            goto _block3__branch5;
          }
          if (_v_deref__Statement5.symbol_at ((0 + 1)))
          {
            goto _block3__branch5;
          }
          if (_v_deref__Statement5.symbol_at ((0 + 1 + 1)))
          {
            goto _block3__branch5;
          }
          if (_v_deref__Statement5.symbol_at ((0 + 1 + 1 + 1)))
          {
            goto _block3__branch5;
          }
          Expr _v_deref__deref__Statement5 (_v_deref__Statement5, (0 + 1));
          Expr _v_deref__deref__Statement52 (_v_deref__Statement5, (0 + 1 + 1));
          Expr _v_deref__deref__Statement53 (_v_deref__Statement5, (0 + 1 + 1 + 1));
          uintptr_t _v_len19 = _v_deref__deref__Statement5.get_len ();
          uintptr_t _v_len20 = 2;
          if (_v_len19 < _v_len20)
          {
            goto _block3__branch5;
          }
          uintptr_t _v_len__Snt13 = (_v_len19 - _v_len20);
          uintptr_t _v_len21 = _v_deref__deref__Statement53.get_len ();
          uintptr_t _v_len22 = 2;
          if (_v_len21 < _v_len22)
          {
            goto _block3__branch5;
          }
          uintptr_t _v_len__Snt22 = (_v_len21 - _v_len22);
          uintptr_t _v_len23 = _v_deref__deref__Statement52.get_len ();
          uintptr_t _v_len24 = 2;
          if (_v_len23 < _v_len24)
          {
            goto _block3__branch5;
          }
          uintptr_t _v_len__HardExp = (_v_len23 - _v_len24);
          if (!_c_17.term_eq (_v_deref__Statement5, 0))
          {
            goto _block3__branch5;
          }
          if (!_c_15.term_eq (_v_deref__deref__Statement5, 0))
          {
            goto _block3__branch5;
          }
          if (!_c_13.term_eq (_v_deref__deref__Statement52, 0))
          {
            goto _block3__branch5;
          }
          if (!_c_15.term_eq (_v_deref__deref__Statement53, 0))
          {
            goto _block3__branch5;
          }
          Expr _vt__e__e_tmp_m_rfp__checkrf_m_108_m_24 (_v_deref__deref__Statement5, (0 + 1), 1);
          Expr _ve_Snt1 (_v_deref__deref__Statement5, (0 + 1 + 1), _v_len__Snt13);
          Expr _vt_Pragma (_v_deref__deref__Statement52, (0 + 1), 1);
          Expr _ve_HardExp (_v_deref__deref__Statement52, (0 + 1 + 1), _v_len__HardExp);
          Expr _vt__e__e_tmp_m_rfp__checkrf_m_108_m_70 (_v_deref__deref__Statement53, (0 + 1), 1);
          Expr _ve_Snt2 (_v_deref__deref__Statement53, (0 + 1 + 1), _v_len__Snt22);
          Expr _ve_HardFormat;
          RF_CALL (rfp__format::Format_m_Exp, _ve_HardExp, _ve_HardFormat);
          if (!RF_CALL (Satisfies_m_Format_q_, (empty, _ve_HardFormat, _ve_Snt1), /*void*/))
          {
            RF_RETFAIL;
          }
          _ge_Sentence__2 = (_ve_Snt + (_c_13 + _vt_Pragma + _ve_HardExp) () + _ve_Snt2);
          goto _block3;
        }
      _block3__branch5: {}
        {
          if (_vt_Statement.symbol_at (0))
          {
            goto _block3__branch6;
          }
          Expr _v_deref__Statement6 (_vt_Statement, 0);
          uintptr_t _v_len25 = _v_deref__Statement6.get_len ();
          uintptr_t _v_len26 = 3;
          if (_v_len25 < _v_len26)
          {
            goto _block3__branch6;
          }
          uintptr_t _v_len__NOFAIL = (_v_len25 - _v_len26);
          if (_v_deref__Statement6.symbol_at ((0 + 1)))
          {
            goto _block3__branch6;
          }
          Expr _v_deref__deref__Statement6 (_v_deref__Statement6, (0 + 1));
          uintptr_t _v_len27 = _v_deref__deref__Statement6.get_len ();
          uintptr_t _v_len28 = 2;
          if (_v_len27 < _v_len28)
          {
            goto _block3__branch6;
          }
          uintptr_t _v_len__Snt14 = (_v_len27 - _v_len28);
          if (!_c_18.term_eq (_v_deref__Statement6, 0))
          {
            goto _block3__branch6;
          }
          if (!_c_15.term_eq (_v_deref__deref__Statement6, 0))
          {
            goto _block3__branch6;
          }
          Expr _ve_NOFAIL (_v_deref__Statement6, (0 + 1 + 1), _v_len__NOFAIL);
          Expr _vt_CatchBlock (_v_deref__Statement6, (0 + 1 + 1 + _v_len__NOFAIL), 1);
          Expr _vt__e__e_tmp_m_rfp__checkrf_m_112_m_23 (_v_deref__deref__Statement6, (0 + 1), 1);
          Expr _ve_Snt1 (_v_deref__deref__Statement6, (0 + 1 + 1), _v_len__Snt14);
          if (!RF_CALL (Satisfies_m_Format_q_, (empty, _ge_OutFormat__2, _ve_Snt1), /*void*/))
          {
            RF_RETFAIL;
          }
          if (!RF_CALL (Satisfies_m_Format_q_, (_c_8, _ge_OutFormat__2, _vt_CatchBlock), /*void*/))
          {
            RF_RETFAIL;
          }
          _ge_Sentence__2 = _ve_Snt;
          _ge_OutFormat__2 = empty;
          goto _block3;
        }
      _block3__branch6: {}
        {
          if (_vt_Statement.symbol_at (0))
          {
            goto _block3__branch7;
          }
          Expr _v_deref__Statement7 (_vt_Statement, 0);
          uintptr_t _v_len29 = _v_deref__Statement7.get_len ();
          uintptr_t _v_len30 = 2;
          if (_v_len29 < _v_len30)
          {
            goto _block3__branch7;
          }
          uintptr_t _v_len__PatternExpression = (_v_len29 - _v_len30);
          if (!_v_deref__Statement7.symbol_at (0))
          {
            goto _block3__branch7;
          }
          Expr _vs_tag (_v_deref__Statement7, 0, 1);
          Expr _vt_Pragma (_v_deref__Statement7, (0 + 1), 1);
          Expr _ve_PatternExpression (_v_deref__Statement7, (0 + 1 + 1), _v_len__PatternExpression);
          {
            {
              if (!_vs_tag.term_eq (_c_19, 0))
              {
                goto _block10__branch1;
              }
              goto _block10;
            }
          _block10__branch1: {}
            if (!_vs_tag.term_eq (_c_20, 0))
            {
              goto _block3__branch7;
            }
          }
        _block10: {}
          {
            {
              if (_v_len__Snt2 != 0)
              {
                goto _block11__branch1;
              }
              Expr _ve_PatternFormat;
              RF_CALL (rfp__format::Format_m_Exp, _ve_PatternExpression, _ve_PatternFormat);
              {
                {
                  if (!RF_CALL (rfp__format::Subformat_q_, (_ve_InFormat, _ve_PatternFormat), /*void*/))
                  {
                    goto _block12__branch1;
                  }
                  _ge_Sentence__2 = empty;
                  _ge_OutFormat__2 = empty;
                  goto _block12;
                }
              _block12__branch1: {}
                RF_CALL (Print_m_Error, (_c_5, _c_21, _vt_Pragma), /*void*/);
                RF_RETFAIL;
              }
            _block12: {}
              goto _block11;
            }
          _block11__branch1: {}
            _ge_Sentence__2 = _ve_Snt;
            _ge_OutFormat__2 = _c_8;
          }
        _block11: {}
          goto _block3;
        }
      _block3__branch7: {}
        {
          if (!_vt_Statement.term_eq (_c_22, 0))
          {
            goto _block3__branch8;
          }
          _ge_Sentence__2 = _ve_Snt;
          _ge_OutFormat__2 = empty;
          goto _block3;
        }
      _block3__branch8: {}
        {
          if (_vt_Statement.symbol_at (0))
          {
            goto _block3__branch9;
          }
          Expr _v_deref__Statement8 (_vt_Statement, 0);
          if (_v_deref__Statement8.get_len () != 2)
          {
            goto _block3__branch9;
          }
          if (!_c_23.term_eq (_v_deref__Statement8, 0))
          {
            goto _block3__branch9;
          }
          Expr _vt__e__e_tmp_m_rfp__checkrf_m_132_m_16 (_v_deref__Statement8, (0 + 1), 1);
          _ge_Sentence__2 = _ve_Snt;
          _ge_OutFormat__2 = empty;
          goto _block3;
        }
      _block3__branch9: {}
        {
          if (_vt_Statement.symbol_at (0))
          {
            goto _block3__branch10;
          }
          Expr _v_deref__Statement9 (_vt_Statement, 0);
          if (_v_deref__Statement9.get_len () != 2)
          {
            goto _block3__branch10;
          }
          if (!_c_24.term_eq (_v_deref__Statement9, 0))
          {
            goto _block3__branch10;
          }
          Expr _vt__e__e_tmp_m_rfp__checkrf_m_133_m_18 (_v_deref__Statement9, (0 + 1), 1);
          _ge_Sentence__2 = _ve_Snt;
          _ge_OutFormat__2 = empty;
          goto _block3;
        }
      _block3__branch10: {}
        {
          if (_vt_Statement.symbol_at (0))
          {
            goto _block3__branch11;
          }
          Expr _v_deref__Statement10 (_vt_Statement, 0);
          if (_v_deref__Statement10.get_len () != 2)
          {
            goto _block3__branch11;
          }
          if (!_c_25.term_eq (_v_deref__Statement10, 0))
          {
            goto _block3__branch11;
          }
          Expr _vt__e__e_tmp_m_rfp__checkrf_m_134_m_15 (_v_deref__Statement10, (0 + 1), 1);
          _ge_Sentence__2 = _ve_Snt;
          _ge_OutFormat__2 = empty;
          goto _block3;
        }
      _block3__branch11: {}
        {
          if (_vt_Statement.symbol_at (0))
          {
            goto _block3__branch12;
          }
          Expr _v_deref__Statement11 (_vt_Statement, 0);
          if (_v_deref__Statement11.get_len () != 2)
          {
            goto _block3__branch12;
          }
          if (!_c_26.term_eq (_v_deref__Statement11, 0))
          {
            goto _block3__branch12;
          }
          Expr _vt__e__e_tmp_m_rfp__checkrf_m_135_m_17 (_v_deref__Statement11, (0 + 1), 1);
          _ge_Sentence__2 = _ve_Snt;
          _ge_OutFormat__2 = empty;
          goto _block3;
        }
      _block3__branch12: {}
        {
          if (_vt_Statement.symbol_at (0))
          {
            goto _block3__branch13;
          }
          Expr _v_deref__Statement12 (_vt_Statement, 0);
          uintptr_t _v_len31 = _v_deref__Statement12.get_len ();
          uintptr_t _v_len32 = 2;
          if (_v_len31 < _v_len32)
          {
            goto _block3__branch13;
          }
          uintptr_t _v_len__Snt15 = (_v_len31 - _v_len32);
          if (!_c_15.term_eq (_v_deref__Statement12, 0))
          {
            goto _block3__branch13;
          }
          Expr _vt__e__e_tmp_m_rfp__checkrf_m_136_m_18 (_v_deref__Statement12, (0 + 1), 1);
          Expr _ve_Snt1 (_v_deref__Statement12, (0 + 1 + 1), _v_len__Snt15);
          if (!RF_CALL (Satisfies_m_Format_q_, (_ve_InFormat, _ge_OutFormat__2, _ve_Snt1), /*void*/))
          {
            RF_RETFAIL;
          }
          _ge_Sentence__2 = empty;
          _ge_OutFormat__2 = empty;
          goto _block3;
        }
      _block3__branch13: {}
        if (!_vt_Statement.term_eq (_c_14, 0))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        _ge_Sentence__2 = empty;
        _ge_OutFormat__2 = empty;
      }
    _block3: {}
    }
  _exit__iter1: {}
  }
_block1: {}
RF_END

RF_FUNC (Check_m_Inputs, (RF_ARG _ge_arg1;;), RF_VOID)
  {
    {
      uintptr_t _v_len1 = _ge_arg1.get_len ();
      uintptr_t _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__rest = (_v_len1 - _v_len2);
      Expr _vt_first (_ge_arg1, 0, 1);
      Expr _ve_rest (_ge_arg1, (0 + 1), _v_len__rest);
      {
        {
          if (_vt_first.symbol_at (0))
          {
            goto _block2__branch1;
          }
          Expr _v_deref__first (_vt_first, 0);
          uintptr_t _v_len3 = _v_deref__first.get_len ();
          uintptr_t _v_len4 = 3;
          if (_v_len3 < _v_len4)
          {
            goto _block2__branch1;
          }
          uintptr_t _v_len__ResultExpression = (_v_len3 - _v_len4);
          if (!_c_27.term_eq (_v_deref__first, 0))
          {
            goto _block2__branch1;
          }
          Expr _vt_Pragma (_v_deref__first, (0 + 1), 1);
          Expr _vt_Fname (_v_deref__first, (0 + 1 + 1), 1);
          Expr _ve_ResultExpression (_v_deref__first, (0 + 1 + 1 + 1), _v_len__ResultExpression);
          {
            {
              Expr _gs_auxcall1;
              Expr _gs_auxcall2;
              Expr _gt_auxcall3;
              Expr _ge_auxcall4;
              Expr _ge_auxcall5;
              if (!RF_CALL (rfp__compile::Lookup_m_Func, _vt_Fname, (_gs_auxcall1, _gs_auxcall2, _gt_auxcall3, _ge_auxcall4, _ge_auxcall5)))
              {
                goto _block3__branch1;
              }
              Expr _v_L1;
              if (!RF_CALL (Access::L, (_c_28, (_gs_auxcall1 + _gs_auxcall2 + _gt_auxcall3 + _ge_auxcall4 () + _ge_auxcall5 ())), _v_L1))
              {
                goto _block3__branch1;
              }
              if (_v_L1.symbol_at (0))
              {
                goto _block3__branch1;
              }
              Expr _v_deref__L1 (_v_L1, 0);
              uintptr_t _v_len5 = _v_deref__L1.get_len ();
              uintptr_t _v_len6 = 0;
              if (_v_len5 < _v_len6)
              {
                goto _block3__branch1;
              }
              uintptr_t _v_len__Fin = (_v_len5 - _v_len6);
              Expr _ve_Fin (_v_deref__L1, 0, _v_len__Fin);
              {
                Expr _ge_auxcall6;
                RF_CALL (rfp__format::Format_m_Exp, _ve_ResultExpression, _ge_auxcall6);
                if (!RF_CALL (rfp__format::Subformat_q_, (_ve_Fin, _ge_auxcall6), /*void*/))
                {
                  goto _negation1;
                }
                goto _block3__branch1;
              }
            _negation1: {}
              RF_CALL (Print_m_Error, (_c_5, _c_29, _vt_Pragma), /*void*/);
              goto _block3;
            }
          _block3__branch1: {}
          }
        _block3: {}
          RF_CALL (Check_m_Inputs, _ve_ResultExpression, /*void*/);
          goto _block2;
        }
      _block2__branch1: {}
        {
          if (_vt_first.symbol_at (0))
          {
            goto _block2__branch2;
          }
          Expr _v_deref__first2 (_vt_first, 0);
          uintptr_t _v_len7 = _v_deref__first2.get_len ();
          uintptr_t _v_len8 = 1;
          if (_v_len7 < _v_len8)
          {
            goto _block2__branch2;
          }
          uintptr_t _v_len__paren_m_expr = (_v_len7 - _v_len8);
          if (!_c_30.term_eq (_v_deref__first2, 0))
          {
            goto _block2__branch2;
          }
          Expr _ve_paren_m_expr (_v_deref__first2, (0 + 1), _v_len__paren_m_expr);
          RF_CALL (Check_m_Inputs, _ve_paren_m_expr, /*void*/);
          goto _block2;
        }
      _block2__branch2: {}
        Expr _vt_var_m_or_m_symbol (_vt_first, 0, 1);
      }
    _block2: {}
      RF_TAILCALL (Check_m_Inputs, _ve_rest, /*void*/);
      goto _block1;
    }
  _block1__branch1: {}
    if (_ge_arg1.get_len () != 0)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
  }
_block1: {}
RF_END

RF_FUNC (Check_m_Vars, (RF_ARG _ve_vars, _ve_Sentence;;), RF_VOID)
  Expr _ge_vars__0 (_ve_vars);
  Expr _ge_Sentence__0 (_ve_Sentence);
  for ( ; ; )
  {
    {
      if (_ge_Sentence__0.get_len () != 0)
      {
        goto _iter1;
      }
      goto _exit__iter1;
    }
  _iter1: {}
    uintptr_t _v_len1 = _ge_Sentence__0.get_len ();
    uintptr_t _v_len2 = 1;
    if (_v_len1 < _v_len2)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    uintptr_t _v_len__Snt = (_v_len1 - _v_len2);
    Expr _vt_Statement (_ge_Sentence__0, 0, 1);
    Expr _ve_Snt (_ge_Sentence__0, (0 + 1), _v_len__Snt);
    Expr _ge_vars__0__3;
    {
      {
        if (_vt_Statement.symbol_at (0))
        {
          goto _block2__branch1;
        }
        Expr _v_deref__Statement (_vt_Statement, 0);
        uintptr_t _v_len3 = _v_deref__Statement.get_len ();
        uintptr_t _v_len4 = 2;
        if (_v_len3 < _v_len4)
        {
          goto _block2__branch1;
        }
        uintptr_t _v_len__Re = (_v_len3 - _v_len4);
        if (!_c_9.term_eq (_v_deref__Statement, 0))
        {
          goto _block2__branch1;
        }
        Expr _vt__e__e_tmp_m_rfp__checkrf_m_172_m_18 (_v_deref__Statement, (0 + 1), 1);
        Expr _ve_Re (_v_deref__Statement, (0 + 1 + 1), _v_len__Re);
        RF_CALL (Check_m_Vars, (_ge_vars__0, _ve_Re), /*void*/);
        _ge_vars__0__3 = _ge_vars__0;
        goto _block2;
      }
    _block2__branch1: {}
      {
        if (_vt_Statement.symbol_at (0))
        {
          goto _block2__branch2;
        }
        Expr _v_deref__Statement2 (_vt_Statement, 0);
        uintptr_t _v_len5 = _v_deref__Statement2.get_len ();
        uintptr_t _v_len6 = 1;
        if (_v_len5 < _v_len6)
        {
          goto _block2__branch2;
        }
        uintptr_t _v_len__Re2 = (_v_len5 - _v_len6);
        if (!_c_30.term_eq (_v_deref__Statement2, 0))
        {
          goto _block2__branch2;
        }
        Expr _ve_Re (_v_deref__Statement2, (0 + 1), _v_len__Re2);
        RF_CALL (Check_m_Vars, (_ge_vars__0, _ve_Re), /*void*/);
        _ge_vars__0__3 = _ge_vars__0;
        goto _block2;
      }
    _block2__branch2: {}
      {
        if (_vt_Statement.symbol_at (0))
        {
          goto _block2__branch3;
        }
        Expr _v_deref__Statement3 (_vt_Statement, 0);
        uintptr_t _v_len7 = _v_deref__Statement3.get_len ();
        uintptr_t _v_len8 = 3;
        if (_v_len7 < _v_len8)
        {
          goto _block2__branch3;
        }
        uintptr_t _v_len__Re3 = (_v_len7 - _v_len8);
        if (!_c_27.term_eq (_v_deref__Statement3, 0))
        {
          goto _block2__branch3;
        }
        Expr _vt__e__e_tmp_m_rfp__checkrf_m_174_m_16 (_v_deref__Statement3, (0 + 1), 1);
        Expr _vt__e__e_tmp_m_rfp__checkrf_m_174_m_18 (_v_deref__Statement3, (0 + 1 + 1), 1);
        Expr _ve_Re (_v_deref__Statement3, (0 + 1 + 1 + 1), _v_len__Re3);
        RF_CALL (Check_m_Vars, (_ge_vars__0, _ve_Re), /*void*/);
        _ge_vars__0__3 = _ge_vars__0;
        goto _block2;
      }
    _block2__branch3: {}
      {
        if (_vt_Statement.symbol_at (0))
        {
          goto _block2__branch4;
        }
        Expr _v_deref__Statement4 (_vt_Statement, 0);
        uintptr_t _v_len9 = _v_deref__Statement4.get_len ();
        uintptr_t _v_len10 = 2;
        if (_v_len9 < _v_len10)
        {
          goto _block2__branch4;
        }
        uintptr_t _v_len__name = (_v_len9 - _v_len10);
        if (!_v_deref__Statement4.symbol_at (0))
        {
          goto _block2__branch4;
        }
        Expr _vs_type (_v_deref__Statement4, 0, 1);
        Expr _vt_Pragma (_v_deref__Statement4, (0 + 1), 1);
        Expr _ve_name (_v_deref__Statement4, (0 + 1 + 1), _v_len__name);
        {
          {
            if (!_vs_type.term_eq (_c_31, 0))
            {
              goto _block3__branch1;
            }
            goto _block3;
          }
        _block3__branch1: {}
          {
            if (!_vs_type.term_eq (_c_32, 0))
            {
              goto _block3__branch2;
            }
            goto _block3;
          }
        _block3__branch2: {}
          {
            if (!_vs_type.term_eq (_c_33, 0))
            {
              goto _block3__branch3;
            }
            goto _block3;
          }
        _block3__branch3: {}
          if (!_vs_type.term_eq (_c_34, 0))
          {
            goto _block2__branch4;
          }
        }
      _block3: {}
        {
          {
            if (_ge_vars__0.get_len () < 1)
            {
              goto _block4__branch1;
            }
            RF_lsplit (_ge_vars__0, 0, _ve__e__e_tmp_m_rfp__checkrf_m_177_m_23, _v_lsplit__vars__0);
            for ( ; ; RF_iter(_ge_vars__0)++)
            {
              {
                if (!RF_iter(_ge_vars__0))
                {
                  goto _block4__branch1;
                }
                uintptr_t _v_len11 = _v_lsplit__vars__0.get_len ();
                uintptr_t _v_len12 = 1;
                if (_v_len11 < _v_len12)
                {
                  goto _block4__branch1;
                }
                uintptr_t _v_len___e__e_tmp_m_rfp__checkrf_m_177_m_42 = (_v_len11 - _v_len12);
                if (_v_lsplit__vars__0.symbol_at (0))
                {
                  goto _continue1;
                }
                Expr _v_deref__lsplit__vars__0 (_v_lsplit__vars__0, 0);
                if (_v_deref__lsplit__vars__0.get_len () != (_v_len__name + 2))
                {
                  goto _continue1;
                }
                if (!_v_deref__lsplit__vars__0.symbol_at (0))
                {
                  goto _continue1;
                }
                if (!_ve_name.eq (_v_deref__lsplit__vars__0, (0 + 1 + 1)))
                {
                  goto _continue1;
                }
                Expr _ve__e__e_tmp_m_rfp__checkrf_m_177_m_42 (_v_lsplit__vars__0, (0 + 1), _v_len___e__e_tmp_m_rfp__checkrf_m_177_m_42);
                Expr _vs_t (_v_deref__lsplit__vars__0, 0, 1);
                Expr _vt_p (_v_deref__lsplit__vars__0, (0 + 1), 1);
                {
                  {
                    if (!_vs_type.term_eq (_vs_t, 0))
                    {
                      goto _block5__branch1;
                    }
                    goto _block5;
                  }
                _block5__branch1: {}
                  RF_CALL (Print_m_Error, (_c_5, (_c_35 + (_vs_t + _vt_p + _ve_name) () + _vs_type), _vt_Pragma), /*void*/);
                }
              _block5: {}
                goto _exit1;
              }
          _continue1: {}
            }
          _exit1: {}
            goto _block4;
          }
        _block4__branch1: {}
          RF_CALL (Print_m_Error, (_c_5, (_c_36 + (_vs_type + _vt_Pragma + _ve_name) ()), _vt_Pragma), /*void*/);
        }
      _block4: {}
        _ge_vars__0__3 = _ge_vars__0;
        goto _block2;
      }
    _block2__branch4: {}
      {
        if (_vt_Statement.symbol_at (0))
        {
          goto _block2__branch5;
        }
        Expr _v_deref__Statement5 (_vt_Statement, 0);
        uintptr_t _v_len13 = _v_deref__Statement5.get_len ();
        uintptr_t _v_len14 = 2;
        if (_v_len13 < _v_len14)
        {
          goto _block2__branch5;
        }
        uintptr_t _v_len__He = (_v_len13 - _v_len14);
        if (!_c_13.term_eq (_v_deref__Statement5, 0))
        {
          goto _block2__branch5;
        }
        Expr _vt__e__e_tmp_m_rfp__checkrf_m_185_m_18 (_v_deref__Statement5, (0 + 1), 1);
        Expr _ve_He (_v_deref__Statement5, (0 + 1 + 1), _v_len__He);
        Expr _v_Vars1;
        RF_CALL (rfp__vars::Vars, _ve_He, _v_Vars1);
        uintptr_t _v_len15 = _v_Vars1.get_len ();
        uintptr_t _v_len16 = 0;
        if (_v_len15 < _v_len16)
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        uintptr_t _v_len__He_m_vars = (_v_len15 - _v_len16);
        Expr _ve_He_m_vars (_v_Vars1, 0, _v_len__He_m_vars);
        {
          if (_v_len__He_m_vars < 2)
          {
            goto _block6__branch1;
          }
          RF_lsplit (_ve_He_m_vars, 0, _ve__e__e_tmp_m_rfp__checkrf_m_188_m_29, _v_lsplit__He_m_vars);
          for ( ; ; RF_iter(_ve_He_m_vars)++)
          {
            {
              if (!RF_iter(_ve_He_m_vars))
              {
                goto _block6__branch1;
              }
              if (_v_lsplit__He_m_vars.get_len () < 2)
              {
                goto _block6__branch1;
              }
              if (_v_lsplit__He_m_vars.symbol_at (0))
              {
                goto _continue2;
              }
              Expr _v_deref__lsplit__He_m_vars (_v_lsplit__He_m_vars, 0);
              uintptr_t _v_len17 = _v_deref__lsplit__He_m_vars.get_len ();
              uintptr_t _v_len18 = 2;
              if (_v_len17 < _v_len18)
              {
                goto _continue2;
              }
              uintptr_t _v_len__3 = (_v_len17 - _v_len18);
              if (!_v_deref__lsplit__He_m_vars.symbol_at (0))
              {
                goto _continue2;
              }
              Expr _vs_1 (_v_deref__lsplit__He_m_vars, 0, 1);
              Expr _vt_p1 (_v_deref__lsplit__He_m_vars, (0 + 1), 1);
              Expr _ve_3 (_v_deref__lsplit__He_m_vars, (0 + 1 + 1), _v_len__3);
              Expr _v_subexpr__lsplit__He_m_vars (_v_lsplit__He_m_vars, (0 + 1), (_v_lsplit__He_m_vars.get_len () - (0 + 1 + 0)));
              RF_lsplit (_v_subexpr__lsplit__He_m_vars, 0, _ve__e__e_tmp_m_rfp__checkrf_m_188_m_44, _v_lsplit__lsplit__He_m_vars);
              for ( ; ; RF_iter(_v_subexpr__lsplit__He_m_vars)++)
              {
                {
                  if (!RF_iter(_v_subexpr__lsplit__He_m_vars))
                  {
                    goto _continue2;
                  }
                  uintptr_t _v_len19 = _v_lsplit__lsplit__He_m_vars.get_len ();
                  uintptr_t _v_len20 = 1;
                  if (_v_len19 < _v_len20)
                  {
                    goto _continue2;
                  }
                  uintptr_t _v_len__4 = (_v_len19 - _v_len20);
                  if (_v_lsplit__lsplit__He_m_vars.symbol_at (0))
                  {
                    goto _continue3;
                  }
                  Expr _v_deref__lsplit__lsplit__He_m_vars (_v_lsplit__lsplit__He_m_vars, 0);
                  if (_v_deref__lsplit__lsplit__He_m_vars.get_len () != (_v_len__3 + 2))
                  {
                    goto _continue3;
                  }
                  if (!_v_deref__lsplit__lsplit__He_m_vars.symbol_at (0))
                  {
                    goto _continue3;
                  }
                  if (!_ve_3.eq (_v_deref__lsplit__lsplit__He_m_vars, (0 + 1 + 1)))
                  {
                    goto _continue3;
                  }
                  Expr _ve_4 (_v_lsplit__lsplit__He_m_vars, (0 + 1), _v_len__4);
                  Expr _vs_2 (_v_deref__lsplit__lsplit__He_m_vars, 0, 1);
                  Expr _vt_p2 (_v_deref__lsplit__lsplit__He_m_vars, (0 + 1), 1);
                  {
                    {
                      if (!_vs_2.term_eq (_vs_1, 0))
                      {
                        goto _block7__branch1;
                      }
                      goto _block7;
                    }
                  _block7__branch1: {}
                    RF_CALL (Print_m_Error, (_c_5, (_c_35 + (_vs_1 + _vt_p1 + _ve_3) () + _vs_2), _vt_p2), /*void*/);
                  }
                _block7: {}
                  RF_CALL (Print_m_Error, (_c_5, (_c_37 + (_vs_1 + _vt_p1 + _ve_3) ()), _vt_p2), /*void*/);
                  if (_v_len__4 != 0)
                  {
                    goto _continue3;
                  }
                  goto _block6__branch1;
                }
            _continue3: {}
              }
            _exit3: {}
            }
        _continue2: {}
          }
        _exit2: {}
        }
      _block6__branch1: {}
        Expr _ge_auxcall1;
        RF_CALL (List::Reverse, _ve_He_m_vars, _ge_auxcall1);
        RF_CALL (Update_m_Vars, (_c_38, _ge_vars__0, _ge_auxcall1), _ge_vars__0__3);
        goto _block2;
      }
    _block2__branch5: {}
      {
        if (_vt_Statement.symbol_at (0))
        {
          goto _block2__branch6;
        }
        Expr _v_deref__Statement6 (_vt_Statement, 0);
        uintptr_t _v_len21 = _v_deref__Statement6.get_len ();
        uintptr_t _v_len22 = 2;
        if (_v_len21 < _v_len22)
        {
          goto _block2__branch6;
        }
        uintptr_t _v_len__Pe = (_v_len21 - _v_len22);
        if (!_c_19.term_eq (_v_deref__Statement6, 0))
        {
          goto _block2__branch6;
        }
        Expr _vt__e__e_tmp_m_rfp__checkrf_m_197_m_17 (_v_deref__Statement6, (0 + 1), 1);
        Expr _ve_Pe (_v_deref__Statement6, (0 + 1 + 1), _v_len__Pe);
        Expr _ge_auxcall2;
        RF_CALL (rfp__vars::Vars, _ve_Pe, _ge_auxcall2);
        RF_CALL (Update_m_Vars, (_c_21, _ge_vars__0, _ge_auxcall2), _ge_vars__0__3);
        goto _block2;
      }
    _block2__branch6: {}
      {
        if (_vt_Statement.symbol_at (0))
        {
          goto _block2__branch7;
        }
        Expr _v_deref__Statement7 (_vt_Statement, 0);
        uintptr_t _v_len23 = _v_deref__Statement7.get_len ();
        uintptr_t _v_len24 = 2;
        if (_v_len23 < _v_len24)
        {
          goto _block2__branch7;
        }
        uintptr_t _v_len__Pe2 = (_v_len23 - _v_len24);
        if (!_c_20.term_eq (_v_deref__Statement7, 0))
        {
          goto _block2__branch7;
        }
        Expr _vt__e__e_tmp_m_rfp__checkrf_m_198_m_17 (_v_deref__Statement7, (0 + 1), 1);
        Expr _ve_Pe (_v_deref__Statement7, (0 + 1 + 1), _v_len__Pe2);
        Expr _ge_auxcall3;
        RF_CALL (rfp__vars::Vars, _ve_Pe, _ge_auxcall3);
        RF_CALL (Update_m_Vars, (_c_21, _ge_vars__0, _ge_auxcall3), _ge_vars__0__3);
        goto _block2;
      }
    _block2__branch7: {}
      {
        if (_vt_Statement.symbol_at (0))
        {
          goto _block2__branch8;
        }
        Expr _v_deref__Statement8 (_vt_Statement, 0);
        uintptr_t _v_len25 = _v_deref__Statement8.get_len ();
        uintptr_t _v_len26 = 2;
        if (_v_len25 < _v_len26)
        {
          goto _block2__branch8;
        }
        uintptr_t _v_len__Branches = (_v_len25 - _v_len26);
        if (!_v_deref__Statement8.symbol_at (0))
        {
          goto _block2__branch8;
        }
        Expr _vs_block (_v_deref__Statement8, 0, 1);
        Expr _vt__e__e_tmp_m_rfp__checkrf_m_199_m_19 (_v_deref__Statement8, (0 + 1), 1);
        Expr _ve_Branches (_v_deref__Statement8, (0 + 1 + 1), _v_len__Branches);
        {
          {
            if (!_vs_block.term_eq (_c_10, 0))
            {
              goto _block8__branch1;
            }
            goto _block8;
          }
        _block8__branch1: {}
          if (!_vs_block.term_eq (_c_11, 0))
          {
            goto _block2__branch8;
          }
        }
      _block8: {}
        {
          if (_v_len__Branches < 1)
          {
            goto _block9__branch1;
          }
          RF_lsplit (_ve_Branches, 0, _ve__e__e_tmp_m_rfp__checkrf_m_201_m_27, _v_lsplit__Branches);
          for ( ; ; RF_iter(_ve_Branches)++)
          {
            {
              if (!RF_iter(_ve_Branches))
              {
                goto _block9__branch1;
              }
              uintptr_t _v_len27 = _v_lsplit__Branches.get_len ();
              uintptr_t _v_len28 = 1;
              if (_v_len27 < _v_len28)
              {
                goto _block9__branch1;
              }
              uintptr_t _v_len___e__e_tmp_m_rfp__checkrf_m_201_m_38 = (_v_len27 - _v_len28);
              Expr _vt_branch (_v_lsplit__Branches, 0, 1);
              Expr _ve__e__e_tmp_m_rfp__checkrf_m_201_m_38 (_v_lsplit__Branches, (0 + 1), _v_len___e__e_tmp_m_rfp__checkrf_m_201_m_38);
              RF_CALL (Check_m_Vars, (_ge_vars__0, _vt_branch), /*void*/);
            }
        _continue4: {}
          }
        _exit4: {}
        }
      _block9__branch1: {}
        _ge_vars__0__3 = _ge_vars__0;
        goto _block2;
      }
    _block2__branch8: {}
      {
        if (_vt_Statement.symbol_at (0))
        {
          goto _block2__branch9;
        }
        Expr _v_deref__Statement9 (_vt_Statement, 0);
        uintptr_t _v_len29 = _v_deref__Statement9.get_len ();
        uintptr_t _v_len30 = 2;
        if (_v_len29 < _v_len30)
        {
          goto _block2__branch9;
        }
        uintptr_t _v_len__Snt1 = (_v_len29 - _v_len30);
        if (!_c_15.term_eq (_v_deref__Statement9, 0))
        {
          goto _block2__branch9;
        }
        Expr _vt__e__e_tmp_m_rfp__checkrf_m_206_m_18 (_v_deref__Statement9, (0 + 1), 1);
        Expr _ve_Snt1 (_v_deref__Statement9, (0 + 1 + 1), _v_len__Snt1);
        RF_CALL (Check_m_Vars, (_ge_vars__0, _ve_Snt1), /*void*/);
        _ge_vars__0__3 = _ge_vars__0;
        goto _block2;
      }
    _block2__branch9: {}
      {
        if (_vt_Statement.symbol_at (0))
        {
          goto _block2__branch10;
        }
        Expr _v_deref__Statement10 (_vt_Statement, 0);
        if (_v_deref__Statement10.get_len () != 4)
        {
          goto _block2__branch10;
        }
        if (!_c_17.term_eq (_v_deref__Statement10, 0))
        {
          goto _block2__branch10;
        }
        Expr _vt_IterBody (_v_deref__Statement10, (0 + 1), 1);
        Expr _vt_IterVars (_v_deref__Statement10, (0 + 1 + 1), 1);
        Expr _vt_IterCondition (_v_deref__Statement10, (0 + 1 + 1 + 1), 1);
        RF_CALL (Check_m_Vars, (_ge_vars__0, (_vt_IterVars + _vt_IterBody)), /*void*/);
        if (_vt_IterVars.symbol_at (0))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        Expr _v_deref__IterVars (_vt_IterVars, 0);
        uintptr_t _v_len31 = _v_deref__IterVars.get_len ();
        uintptr_t _v_len32 = 2;
        if (_v_len31 < _v_len32)
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        uintptr_t _v_len__He2 = (_v_len31 - _v_len32);
        if (!_c_13.term_eq (_v_deref__IterVars, 0))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        Expr _vt__e__e_tmp_m_rfp__checkrf_m_211_m_33 (_v_deref__IterVars, (0 + 1), 1);
        Expr _ve_He (_v_deref__IterVars, (0 + 1 + 1), _v_len__He2);
        Expr _ge_auxcall4;
        RF_CALL (rfp__vars::Vars, _ve_He, _ge_auxcall4);
        Expr _ge_vars__0__4;
        RF_CALL (Update_m_Vars, (_c_38, _ge_vars__0, _ge_auxcall4), _ge_vars__0__4);
        RF_CALL (Check_m_Vars, (_ge_vars__0__4, _vt_IterCondition), /*void*/);
        _ge_vars__0__3 = _ge_vars__0__4;
        goto _block2;
      }
    _block2__branch10: {}
      {
        if (_vt_Statement.symbol_at (0))
        {
          goto _block2__branch11;
        }
        Expr _v_deref__Statement11 (_vt_Statement, 0);
        uintptr_t _v_len33 = _v_deref__Statement11.get_len ();
        uintptr_t _v_len34 = 3;
        if (_v_len33 < _v_len34)
        {
          goto _block2__branch11;
        }
        uintptr_t _v_len__NOFAIL = (_v_len33 - _v_len34);
        if (!_c_18.term_eq (_v_deref__Statement11, 0))
        {
          goto _block2__branch11;
        }
        Expr _vt_TryBranch (_v_deref__Statement11, (0 + 1), 1);
        Expr _ve_NOFAIL (_v_deref__Statement11, (0 + 1 + 1), _v_len__NOFAIL);
        Expr _vt_CatchBlock (_v_deref__Statement11, (0 + 1 + 1 + _v_len__NOFAIL), 1);
        RF_CALL (Check_m_Vars, (_ge_vars__0, _vt_TryBranch), /*void*/);
        RF_CALL (Check_m_Vars, (_ge_vars__0, _vt_CatchBlock), /*void*/);
        _ge_vars__0__3 = _ge_vars__0;
        goto _block2;
      }
    _block2__branch11: {}
      Expr _vt_any_m_other (_vt_Statement, 0, 1);
      _ge_vars__0__3 = _ge_vars__0;
    }
  _block2: {}
    _ge_vars__0 = _ge_vars__0__3;
    _ge_Sentence__0 = _ve_Snt;
  }
_exit__iter1: {}
RF_END

RF_FUNC (Update_m_Vars, (RF_ARG _vs_format_q_, _ve_vars, _ve_new_m_vars;;), (RF_RES _v_res1;;))
  Expr _ge_vars__0 (_ve_vars);
  Expr _ge_new_m_vars__0 (_ve_new_m_vars);
  for ( ; ; )
  {
    {
      if (_ge_new_m_vars__0.get_len () != 0)
      {
        goto _iter1;
      }
      _v_res1 = _ge_vars__0;
      goto _exit__iter1;
    }
  _iter1: {}
    uintptr_t _v_len1 = _ge_new_m_vars__0.get_len ();
    uintptr_t _v_len2 = 1;
    if (_v_len1 < _v_len2)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    uintptr_t _v_len__rest = (_v_len1 - _v_len2);
    if (_ge_new_m_vars__0.symbol_at (0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _v_deref__new_m_vars__0 (_ge_new_m_vars__0, 0);
    uintptr_t _v_len3 = _v_deref__new_m_vars__0.get_len ();
    uintptr_t _v_len4 = 2;
    if (_v_len3 < _v_len4)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    uintptr_t _v_len__name = (_v_len3 - _v_len4);
    if (!_v_deref__new_m_vars__0.symbol_at (0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _ve_rest (_ge_new_m_vars__0, (0 + 1), _v_len__rest);
    Expr _vs_type (_v_deref__new_m_vars__0, 0, 1);
    Expr _vt_p2 (_v_deref__new_m_vars__0, (0 + 1), 1);
    Expr _ve_name (_v_deref__new_m_vars__0, (0 + 1 + 1), _v_len__name);
    {
      {
        if (_ge_vars__0.get_len () < 1)
        {
          goto _block2__branch1;
        }
        RF_lsplit (_ge_vars__0, 0, _ve__e__e_tmp_m_rfp__checkrf_m_233_m_10, _v_lsplit__vars__0);
        for ( ; ; RF_iter(_ge_vars__0)++)
        {
          {
            if (!RF_iter(_ge_vars__0))
            {
              goto _block2__branch1;
            }
            uintptr_t _v_len5 = _v_lsplit__vars__0.get_len ();
            uintptr_t _v_len6 = 1;
            if (_v_len5 < _v_len6)
            {
              goto _block2__branch1;
            }
            uintptr_t _v_len___e__e_tmp_m_rfp__checkrf_m_233_m_30 = (_v_len5 - _v_len6);
            if (_v_lsplit__vars__0.symbol_at (0))
            {
              goto _continue1;
            }
            Expr _v_deref__lsplit__vars__0 (_v_lsplit__vars__0, 0);
            if (_v_deref__lsplit__vars__0.get_len () != (_v_len__name + 2))
            {
              goto _continue1;
            }
            if (!_vs_type.term_eq (_v_deref__lsplit__vars__0, 0))
            {
              goto _continue1;
            }
            if (!_ve_name.eq (_v_deref__lsplit__vars__0, (0 + 1 + 1)))
            {
              goto _continue1;
            }
            Expr _ve__e__e_tmp_m_rfp__checkrf_m_233_m_30 (_v_lsplit__vars__0, (0 + 1), _v_len___e__e_tmp_m_rfp__checkrf_m_233_m_30);
            Expr _vt__e__e_tmp_m_rfp__checkrf_m_233_m_20 (_v_deref__lsplit__vars__0, (0 + 1), 1);
            _ge_new_m_vars__0 = _ve_rest;
            goto _exit1;
          }
      _continue1: {}
        }
      _exit1: {}
        goto _block2;
      }
    _block2__branch1: {}
      {
        if (_ge_vars__0.get_len () < 1)
        {
          goto _block2__branch2;
        }
        RF_lsplit (_ge_vars__0, 0, _ve_1, _v_lsplit__vars__02);
        for ( ; ; RF_iter(_ge_vars__0)++)
        {
          {
            if (!RF_iter(_ge_vars__0))
            {
              goto _block2__branch2;
            }
            uintptr_t _v_len7 = _v_lsplit__vars__02.get_len ();
            uintptr_t _v_len8 = 1;
            if (_v_len7 < _v_len8)
            {
              goto _block2__branch2;
            }
            uintptr_t _v_len__2 = (_v_len7 - _v_len8);
            if (_v_lsplit__vars__02.symbol_at (0))
            {
              goto _continue2;
            }
            Expr _v_deref__lsplit__vars__02 (_v_lsplit__vars__02, 0);
            if (_v_deref__lsplit__vars__02.get_len () != (_v_len__name + 2))
            {
              goto _continue2;
            }
            if (!_v_deref__lsplit__vars__02.symbol_at (0))
            {
              goto _continue2;
            }
            if (!_ve_name.eq (_v_deref__lsplit__vars__02, (0 + 1 + 1)))
            {
              goto _continue2;
            }
            Expr _ve_2 (_v_lsplit__vars__02, (0 + 1), _v_len__2);
            Expr _vs_t (_v_deref__lsplit__vars__02, 0, 1);
            Expr _vt_p1 (_v_deref__lsplit__vars__02, (0 + 1), 1);
            {
              {
                if (!_vs_format_q_.term_eq (_c_38, 0))
                {
                  goto _block3__branch1;
                }
                _ge_vars__0 = (_ve_1 + _ve_2 + (_vs_type + _vt_p2 + _ve_name) ());
                _ge_new_m_vars__0 = _ve_rest;
                goto _block3;
              }
            _block3__branch1: {}
              RF_CALL (Print_m_Error, (_c_5, (_c_35 + (_vs_t + _vt_p1 + _ve_name) () + _vs_type), _vt_p2), /*void*/);
              _ge_new_m_vars__0 = _ve_rest;
            }
          _block3: {}
            goto _exit2;
          }
      _continue2: {}
        }
      _exit2: {}
        goto _block2;
      }
    _block2__branch2: {}
      uintptr_t _v_len9 = _ge_vars__0.get_len ();
      uintptr_t _v_len10 = 0;
      if (_v_len9 < _v_len10)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      uintptr_t _v_len___e__e_tmp_m_rfp__checkrf_m_240_m_10 = (_v_len9 - _v_len10);
      Expr _ve__e__e_tmp_m_rfp__checkrf_m_240_m_10 (_ge_vars__0, 0, _v_len___e__e_tmp_m_rfp__checkrf_m_240_m_10);
      _ge_vars__0 = (_ge_vars__0 + (_vs_type + _vt_p2 + _ve_name) ());
      _ge_new_m_vars__0 = _ve_rest;
    }
  _block2: {}
  }
_exit__iter1: {}
RF_END

RF_FUNC (Get_m_Cuts, (RF_ARG _vt_arg;;), (RF_RES _v_res1;;))
  Expr _ve_cuts;
  Expr _ve_Sentence;
  {
    {
      if (_vt_arg.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__arg (_vt_arg, 0);
      uintptr_t _v_len1 = _v_deref__arg.get_len ();
      uintptr_t _v_len2 = 2;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__Sentence = (_v_len1 - _v_len2);
      if (!_c_15.term_eq (_v_deref__arg, 0))
      {
        goto _block1__branch1;
      }
      Expr _vt__e__e_tmp_m_rfp__checkrf_m_254_m_12 (_v_deref__arg, (0 + 1), 1);
      _ve_Sentence = Expr (_v_deref__arg, (0 + 1 + 1), _v_len__Sentence);
      _ve_cuts = empty;
      goto _block1;
    }
  _block1__branch1: {}
    Expr _vt_Block (_vt_arg, 0, 1);
    _ve_cuts = empty;
    _ve_Sentence = _vt_Block;
  }
_block1: {}
  for ( ; ; )
  {
    {
      if (_ve_Sentence.get_len () != 0)
      {
        goto _iter1;
      }
      _v_res1 = _ve_cuts;
      goto _exit__iter1;
    }
  _iter1: {}
    uintptr_t _v_len3 = _ve_Sentence.get_len ();
    uintptr_t _v_len4 = 1;
    if (_v_len3 < _v_len4)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    uintptr_t _v_len__Snt = (_v_len3 - _v_len4);
    Expr _ve_Snt (_ve_Sentence, 0, _v_len__Snt);
    Expr _vt_Statement (_ve_Sentence, (0 + _v_len__Snt), 1);
    {
      {
        {
          {
            if (_vt_Statement.symbol_at (0))
            {
              goto _block4__branch1;
            }
            Expr _v_deref__Statement (_vt_Statement, 0);
            if (_v_deref__Statement.get_len () != 2)
            {
              goto _block4__branch1;
            }
            if (!_c_24.term_eq (_v_deref__Statement, 0))
            {
              goto _block4__branch1;
            }
            Expr _vt__e__e_tmp_m_rfp__checkrf_m_258_m_31 (_v_deref__Statement, (0 + 1), 1);
            goto _block4;
          }
        _block4__branch1: {}
          if (_vt_Statement.symbol_at (0))
          {
            goto _block3__branch1;
          }
          Expr _v_deref__Statement2 (_vt_Statement, 0);
          if (_v_deref__Statement2.get_len () != 2)
          {
            goto _block3__branch1;
          }
          if (!_c_7.term_eq (_v_deref__Statement2, 0))
          {
            goto _block3__branch1;
          }
          Expr _vt__e__e_tmp_m_rfp__checkrf_m_258_m_42 (_v_deref__Statement2, (0 + 1), 1);
        }
      _block4: {}
        {
          Expr _gt_auxcall1;
          if (!RF_CALL (Access::R, (_c_4, _ve_cuts), _gt_auxcall1))
          {
            goto _block5__branch1;
          }
          RF_CALL (Print_m_Error, (_c_5, _c_6, _gt_auxcall1), /*void*/);
          RF_RETFAIL;
        }
      _block5__branch1: {}
        _ve_cuts = empty;
        _ve_Sentence = _ve_Snt;
        goto _block3;
      }
    _block3__branch1: {}
      Expr _ge_cuts__5;
      {
        {
          if (_vt_Statement.symbol_at (0))
          {
            goto _block6__branch1;
          }
          Expr _v_deref__Statement3 (_vt_Statement, 0);
          if (_v_deref__Statement3.get_len () != 2)
          {
            goto _block6__branch1;
          }
          if (!_c_25.term_eq (_v_deref__Statement3, 0))
          {
            goto _block6__branch1;
          }
          Expr _vt_Pragma (_v_deref__Statement3, (0 + 1), 1);
          _ge_cuts__5 = (_ve_cuts + _vt_Pragma);
          goto _block6;
        }
      _block6__branch1: {}
        {
          if (_vt_Statement.symbol_at (0))
          {
            goto _block6__branch2;
          }
          Expr _v_deref__Statement4 (_vt_Statement, 0);
          if (_v_deref__Statement4.get_len () != 2)
          {
            goto _block6__branch2;
          }
          if (!_c_26.term_eq (_v_deref__Statement4, 0))
          {
            goto _block6__branch2;
          }
          Expr _vt__e__e_tmp_m_rfp__checkrf_m_265_m_15 (_v_deref__Statement4, (0 + 1), 1);
          {
            {
              if (!RF_CALL (Access::Middle, (_c_4, _c_39, _ve_cuts), _ge_cuts__5))
              {
                goto _block7__branch1;
              }
              goto _block7;
            }
          _block7__branch1: {}
            _ge_cuts__5 = empty;
          }
        _block7: {}
          goto _block6;
        }
      _block6__branch2: {}
        {
          if (_vt_Statement.symbol_at (0))
          {
            goto _block6__branch3;
          }
          Expr _v_deref__Statement5 (_vt_Statement, 0);
          if (_v_deref__Statement5.get_len () != 2)
          {
            goto _block6__branch3;
          }
          if (!_c_16.term_eq (_v_deref__Statement5, 0))
          {
            goto _block6__branch3;
          }
          Expr _vt_Branch (_v_deref__Statement5, (0 + 1), 1);
          {
            {
              Expr _ge_auxcall2;
              if (!RF_CALL (Get_m_Cuts, _vt_Branch, _ge_auxcall2))
              {
                goto _block8__branch1;
              }
              Expr _gt_auxcall3;
              if (!RF_CALL (Access::R, (_c_4, _ge_auxcall2), _gt_auxcall3))
              {
                goto _block8__branch1;
              }
              RF_CALL (Print_m_Error, (_c_5, _c_6, _gt_auxcall3), /*void*/);
              goto _block8;
            }
          _block8__branch1: {}
          }
        _block8: {}
          _ge_cuts__5 = _ve_cuts;
          goto _block6;
        }
      _block6__branch3: {}
        {
          if (_vt_Statement.symbol_at (0))
          {
            goto _block6__branch4;
          }
          Expr _v_deref__Statement6 (_vt_Statement, 0);
          uintptr_t _v_len5 = _v_deref__Statement6.get_len ();
          uintptr_t _v_len6 = 2;
          if (_v_len5 < _v_len6)
          {
            goto _block6__branch4;
          }
          uintptr_t _v_len__Branches = (_v_len5 - _v_len6);
          if (!_v_deref__Statement6.symbol_at (0))
          {
            goto _block6__branch4;
          }
          Expr _vs_block (_v_deref__Statement6, 0, 1);
          Expr _vt__e__e_tmp_m_rfp__checkrf_m_269_m_17 (_v_deref__Statement6, (0 + 1), 1);
          Expr _ve_Branches (_v_deref__Statement6, (0 + 1 + 1), _v_len__Branches);
          {
            {
              if (!_vs_block.term_eq (_c_10, 0))
              {
                goto _block9__branch1;
              }
              goto _block9;
            }
          _block9__branch1: {}
            if (!_vs_block.term_eq (_c_11, 0))
            {
              goto _block6__branch4;
            }
          }
        _block9: {}
          Expr _ve_longest_m_cuts (empty);
          for ( ; ; )
          {
            {
              if (_ve_Branches.get_len () != 0)
              {
                goto _iter2;
              }
              {
                {
                  Expr _gs_auxcall6;
                  RF_CALL (Access::Length, _ve_cuts, _gs_auxcall6);
                  Expr _gs_auxcall7;
                  RF_CALL (Access::Length, _ve_longest_m_cuts, _gs_auxcall7);
                  if (!RF_CALL (Compare::_gt_, (_gs_auxcall6, _gs_auxcall7), /*void*/))
                  {
                    goto _block10__branch1;
                  }
                  _ge_cuts__5 = _ve_cuts;
                  goto _block10;
                }
              _block10__branch1: {}
                _ge_cuts__5 = _ve_longest_m_cuts;
              }
            _block10: {}
              goto _exit__iter2;
            }
          _iter2: {}
            uintptr_t _v_len7 = _ve_Branches.get_len ();
            uintptr_t _v_len8 = 1;
            if (_v_len7 < _v_len8)
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            uintptr_t _v_len__rest = (_v_len7 - _v_len8);
            Expr _vt_Branch (_ve_Branches, 0, 1);
            Expr _ve_rest (_ve_Branches, (0 + 1), _v_len__rest);
            Expr _ve_branch_m_cuts;
            {
              {
                if (!RF_CALL (Get_m_Cuts, _vt_Branch, _ve_branch_m_cuts))
                {
                  goto _block12__branch1;
                }
                goto _block12;
              }
            _block12__branch1: {}
              _ve_branch_m_cuts = empty;
            }
          _block12: {}
            {
              {
                Expr _gs_auxcall4;
                RF_CALL (Access::Length, _ve_branch_m_cuts, _gs_auxcall4);
                Expr _gs_auxcall5;
                RF_CALL (Access::Length, _ve_longest_m_cuts, _gs_auxcall5);
                if (!RF_CALL (Compare::_gt_, (_gs_auxcall4, _gs_auxcall5), /*void*/))
                {
                  goto _block13__branch1;
                }
                _ve_longest_m_cuts = _ve_branch_m_cuts;
                _ve_Branches = _ve_rest;
                goto _block13;
              }
            _block13__branch1: {}
              _ve_Branches = _ve_rest;
            }
          _block13: {}
          }
        _exit__iter2: {}
          goto _block6;
        }
      _block6__branch4: {}
        {
          if (_vt_Statement.symbol_at (0))
          {
            goto _block6__branch5;
          }
          Expr _v_deref__Statement7 (_vt_Statement, 0);
          if (_v_deref__Statement7.get_len () != 4)
          {
            goto _block6__branch5;
          }
          if (!_c_17.term_eq (_v_deref__Statement7, 0))
          {
            goto _block6__branch5;
          }
          Expr _vt_IterBody (_v_deref__Statement7, (0 + 1), 1);
          Expr _vt_IterVars (_v_deref__Statement7, (0 + 1 + 1), 1);
          Expr _vt_IterCond (_v_deref__Statement7, (0 + 1 + 1 + 1), 1);
          Expr _ge_cuts__6;
          if (!RF_CALL (Get_m_Cuts, _vt_IterCond, _ge_cuts__6))
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          Expr _ve_body_m_cuts;
          if (!RF_CALL (Get_m_Cuts, _vt_IterBody, _ve_body_m_cuts))
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          {
            {
              Expr _gs_auxcall8;
              RF_CALL (Access::Length, _ge_cuts__6, _gs_auxcall8);
              Expr _gs_auxcall9;
              RF_CALL (Access::Length, _ve_body_m_cuts, _gs_auxcall9);
              if (!RF_CALL (Compare::_gt_, (_gs_auxcall8, _gs_auxcall9), /*void*/))
              {
                goto _block14__branch1;
              }
              _ge_cuts__5 = _ge_cuts__6;
              goto _block14;
            }
          _block14__branch1: {}
            _ge_cuts__5 = _ve_body_m_cuts;
          }
        _block14: {}
          goto _block6;
        }
      _block6__branch5: {}
        {
          if (_vt_Statement.symbol_at (0))
          {
            goto _block6__branch6;
          }
          Expr _v_deref__Statement8 (_vt_Statement, 0);
          uintptr_t _v_len9 = _v_deref__Statement8.get_len ();
          uintptr_t _v_len10 = 3;
          if (_v_len9 < _v_len10)
          {
            goto _block6__branch6;
          }
          uintptr_t _v_len__NOFAIL = (_v_len9 - _v_len10);
          if (!_c_18.term_eq (_v_deref__Statement8, 0))
          {
            goto _block6__branch6;
          }
          Expr _vt_TryBranch (_v_deref__Statement8, (0 + 1), 1);
          Expr _ve_NOFAIL (_v_deref__Statement8, (0 + 1 + 1), _v_len__NOFAIL);
          Expr _vt_CatchBlock (_v_deref__Statement8, (0 + 1 + 1 + _v_len__NOFAIL), 1);
          {
            {
              Expr _ge_auxcall10;
              if (!RF_CALL (Get_m_Cuts, _vt_TryBranch, _ge_auxcall10))
              {
                goto _block15__branch1;
              }
              Expr _gt_auxcall11;
              if (!RF_CALL (Access::R, (_c_4, _ge_auxcall10), _gt_auxcall11))
              {
                goto _block15__branch1;
              }
              RF_CALL (Print_m_Error, (_c_5, _c_6, _gt_auxcall11), /*void*/);
              goto _block15;
            }
          _block15__branch1: {}
          }
        _block15: {}
          if (!RF_CALL (Get_m_Cuts, _vt_CatchBlock, _ge_cuts__5))
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          goto _block6;
        }
      _block6__branch6: {}
        Expr _vt_any_m_other (_vt_Statement, 0, 1);
        _ge_cuts__5 = _ve_cuts;
      }
    _block6: {}
      _ve_cuts = _ge_cuts__5;
      _ve_Sentence = _ve_Snt;
    }
  _block3: {}
  }
_exit__iter1: {}
RF_END

RF_FUNC (Print_m_Error, (RF_ARG _vs_WE, _ve_Descrip, _vt_Pragma;;), RF_VOID)
  Expr _vs_n;
  {
    {
      Expr _v__q_1;
      RF_CALL (Box::_q_, rfp__err::Error_m_Counter, _v__q_1);
      if (_v__q_1.get_len () != 1)
      {
        goto _block1__branch1;
      }
      if (!_v__q_1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _gs_n__2 (_v__q_1, 0, 1);
      _vs_n = _gs_n__2;
      goto _block1;
    }
  _block1__branch1: {}
    _vs_n = _c_4;
  }
_block1: {}
  Expr _gs_auxcall1;
  RF_CALL (Arithm::_p_, (_vs_n, _c_39), _gs_auxcall1);
  RF_CALL (Box::Store, (rfp__err::Error_m_Counter, _gs_auxcall1), /*void*/);
  RF_CALL (Print_m_Pragma, (StdIO::StdErr, _vt_Pragma), /*void*/);
  RF_CALL (StdIO::Print_e_, (StdIO::StdErr, (_c_40 + _vs_WE + _c_40)), /*void*/);
  {
    {
      if ((_ve_Descrip.get_len () + 1) != 2)
      {
        goto _block2__branch1;
      }
      Expr _v_compose1 ((_vs_WE + _ve_Descrip));
      if (!_c_41.eq (_v_compose1, 0))
      {
        goto _block2__branch1;
      }
      RF_TAILCALL (StdIO::PrintLN_e_, (StdIO::StdErr, _c_42), /*void*/);
      goto _block2;
    }
  _block2__branch1: {}
    {
      if ((_ve_Descrip.get_len () + 1) != 2)
      {
        goto _block2__branch2;
      }
      Expr _v_compose2 ((_vs_WE + _ve_Descrip));
      if (!_c_43.eq (_v_compose2, 0))
      {
        goto _block2__branch2;
      }
      RF_TAILCALL (StdIO::PrintLN_e_, (StdIO::StdErr, _c_44), /*void*/);
      goto _block2;
    }
  _block2__branch2: {}
    {
      if ((_ve_Descrip.get_len () + 1) != 2)
      {
        goto _block2__branch3;
      }
      Expr _v_compose3 ((_vs_WE + _ve_Descrip));
      if (!_c_45.eq (_v_compose3, 0))
      {
        goto _block2__branch3;
      }
      RF_TAILCALL (StdIO::PrintLN_e_, (StdIO::StdErr, _c_46), /*void*/);
      goto _block2;
    }
  _block2__branch3: {}
    {
      if ((_ve_Descrip.get_len () + 1) != 2)
      {
        goto _block2__branch4;
      }
      Expr _v_compose4 ((_vs_WE + _ve_Descrip));
      if (!_c_47.eq (_v_compose4, 0))
      {
        goto _block2__branch4;
      }
      RF_TAILCALL (StdIO::PrintLN_e_, (StdIO::StdErr, _c_48), /*void*/);
      goto _block2;
    }
  _block2__branch4: {}
    {
      if ((_ve_Descrip.get_len () + 1) != 3)
      {
        goto _block2__branch5;
      }
      Expr _v_compose5 ((_vs_WE + _ve_Descrip));
      if (!_c_49.eq (_v_compose5, 0))
      {
        goto _block2__branch5;
      }
      Expr _vt_var (_v_compose5, (0 + 1 + 1), 1);
      Expr _ge_auxcall2;
      RF_CALL (AS_m_To_m_Ref, _vt_var, _ge_auxcall2);
      RF_TAILCALL (StdIO::PrintLN_e_, (StdIO::StdErr, (_c_51 + _ge_auxcall2 + _c_50)), /*void*/);
      goto _block2;
    }
  _block2__branch5: {}
    {
      if ((_ve_Descrip.get_len () + 1) != 3)
      {
        goto _block2__branch6;
      }
      Expr _v_compose6 ((_vs_WE + _ve_Descrip));
      if (!_c_52.eq (_v_compose6, 0))
      {
        goto _block2__branch6;
      }
      Expr _vt_var (_v_compose6, (0 + 1 + 1), 1);
      Expr _ge_auxcall3;
      RF_CALL (AS_m_To_m_Ref, _vt_var, _ge_auxcall3);
      RF_TAILCALL (StdIO::PrintLN_e_, (StdIO::StdErr, (_c_54 + _ge_auxcall3 + _c_53)), /*void*/);
      goto _block2;
    }
  _block2__branch6: {}
    {
      if ((_ve_Descrip.get_len () + 1) != 4)
      {
        goto _block2__branch7;
      }
      Expr _v_compose7 ((_vs_WE + _ve_Descrip));
      if (!_c_55.eq (_v_compose7, 0))
      {
        goto _block2__branch7;
      }
      if (!_v_compose7.symbol_at ((0 + 1 + 1 + 1)))
      {
        goto _block2__branch7;
      }
      Expr _vt_var (_v_compose7, (0 + 1 + 1), 1);
      Expr _vs_type (_v_compose7, (0 + 1 + 1 + 1), 1);
      Expr _ge_auxcall4;
      RF_CALL (AS_m_To_m_Ref, _vs_type, _ge_auxcall4);
      Expr _ge_auxcall5;
      RF_CALL (AS_m_To_m_Ref, _vt_var, _ge_auxcall5);
      RF_TAILCALL (StdIO::PrintLN_e_, (StdIO::StdErr, (_c_58 + _ge_auxcall4 + _c_57 + _ge_auxcall5 + _c_56)), /*void*/);
      goto _block2;
    }
  _block2__branch7: {}
    if ((_ve_Descrip.get_len () + 1) != 2)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _v_compose8 ((_vs_WE + _ve_Descrip));
    if (!_c_59.eq (_v_compose8, 0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    RF_TAILCALL (StdIO::PrintLN_e_, (StdIO::StdErr, _c_60), /*void*/);
  }
_block2: {}
RF_END

RF_FUNC (Print_m_Pragma, (RF_ARG _gs_arg1, _gt_arg2;;), RF_VOID)
  Expr _v_compose1 ((_gs_arg1 + _gt_arg2));
  if (_v_compose1.symbol_at ((0 + 1)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _v_deref__compose1 (_v_compose1, (0 + 1));
  uintptr_t _v_len1 = _v_deref__compose1.get_len ();
  uintptr_t _v_len2 = 1;
  if (_v_len1 < _v_len2)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len__pragmas = (_v_len1 - _v_len2);
  if (!_v_compose1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_c_61.term_eq (_v_deref__compose1, 0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _vs_channel (_v_compose1, 0, 1);
  Expr _ve_pragmas (_v_deref__compose1, (0 + 1), _v_len__pragmas);
  {
    if (_v_len__pragmas < 1)
    {
      goto _block1__branch1;
    }
    RF_lsplit (_ve_pragmas, 0, _ve__e__e_tmp_m_rfp__checkrf_m_339_m_6, _v_lsplit__pragmas);
    for ( ; ; RF_iter(_ve_pragmas)++)
    {
      {
        if (!RF_iter(_ve_pragmas))
        {
          goto _block1__branch1;
        }
        uintptr_t _v_len3 = _v_lsplit__pragmas.get_len ();
        uintptr_t _v_len4 = 1;
        if (_v_len3 < _v_len4)
        {
          goto _block1__branch1;
        }
        uintptr_t _v_len___e__e_tmp_m_rfp__checkrf_m_339_m_27 = (_v_len3 - _v_len4);
        if (_v_lsplit__pragmas.symbol_at (0))
        {
          goto _continue1;
        }
        Expr _v_deref__lsplit__pragmas (_v_lsplit__pragmas, 0);
        uintptr_t _v_len5 = _v_deref__lsplit__pragmas.get_len ();
        uintptr_t _v_len6 = 1;
        if (_v_len5 < _v_len6)
        {
          goto _continue1;
        }
        uintptr_t _v_len__file_m_name = (_v_len5 - _v_len6);
        if (!_c_62.term_eq (_v_deref__lsplit__pragmas, 0))
        {
          goto _continue1;
        }
        Expr _ve__e__e_tmp_m_rfp__checkrf_m_339_m_27 (_v_lsplit__pragmas, (0 + 1), _v_len___e__e_tmp_m_rfp__checkrf_m_339_m_27);
        Expr _ve_file_m_name (_v_deref__lsplit__pragmas, (0 + 1), _v_len__file_m_name);
        RF_CALL (StdIO::Print_e_, (_vs_channel, _ve_file_m_name), /*void*/);
      }
  _continue1: {}
    }
  _exit1: {}
  }
_block1__branch1: {}
  {
    if (_v_len__pragmas < 1)
    {
      goto _block1__branch2;
    }
    RF_lsplit (_ve_pragmas, 0, _ve__e__e_tmp_m_rfp__checkrf_m_340_m_6, _v_lsplit__pragmas2);
    for ( ; ; RF_iter(_ve_pragmas)++)
    {
      {
        if (!RF_iter(_ve_pragmas))
        {
          goto _block1__branch2;
        }
        uintptr_t _v_len7 = _v_lsplit__pragmas2.get_len ();
        uintptr_t _v_len8 = 1;
        if (_v_len7 < _v_len8)
        {
          goto _block1__branch2;
        }
        uintptr_t _v_len___e__e_tmp_m_rfp__checkrf_m_340_m_28 = (_v_len7 - _v_len8);
        if (_v_lsplit__pragmas2.symbol_at (0))
        {
          goto _continue2;
        }
        Expr _v_deref__lsplit__pragmas2 (_v_lsplit__pragmas2, 0);
        if (_v_deref__lsplit__pragmas2.get_len () != 3)
        {
          goto _continue2;
        }
        if (!_c_63.term_eq (_v_deref__lsplit__pragmas2, 0))
        {
          goto _continue2;
        }
        if (!_v_deref__lsplit__pragmas2.symbol_at ((0 + 1)))
        {
          goto _continue2;
        }
        if (!_v_deref__lsplit__pragmas2.symbol_at ((0 + 1 + 1)))
        {
          goto _continue2;
        }
        Expr _ve__e__e_tmp_m_rfp__checkrf_m_340_m_28 (_v_lsplit__pragmas2, (0 + 1), _v_len___e__e_tmp_m_rfp__checkrf_m_340_m_28);
        Expr _vs_line (_v_deref__lsplit__pragmas2, (0 + 1), 1);
        Expr _vs_col (_v_deref__lsplit__pragmas2, (0 + 1 + 1), 1);
        RF_CALL (StdIO::Print_e_, (_vs_channel, (_vs_line + _c_64 + _vs_col) ()), /*void*/);
      }
  _continue2: {}
    }
  _exit2: {}
  }
_block1__branch2: {}
  uintptr_t _v_len9 = _v_len__pragmas;
  uintptr_t _v_len10 = 0;
  if (_v_len9 < _v_len10)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len___e__e_tmp_m_rfp__checkrf_m_341_m_6 = (_v_len9 - _v_len10);
  Expr _ve__e__e_tmp_m_rfp__checkrf_m_341_m_6 (_ve_pragmas, 0, _v_len___e__e_tmp_m_rfp__checkrf_m_341_m_6);
  RF_TAILCALL (StdIO::Print_e_, (_vs_channel, _c_65), /*void*/);
RF_END

RF_FUNC (AS_m_To_m_Ref, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  {
    {
      if (_ge_arg1.get_len () != 1)
      {
        goto _block1__branch1;
      }
      if (!_c_32.term_eq (_ge_arg1, 0))
      {
        goto _block1__branch1;
      }
      _v_res1 = _c_66;
      goto _block1;
    }
  _block1__branch1: {}
    {
      if (_ge_arg1.get_len () != 1)
      {
        goto _block1__branch2;
      }
      if (!_c_33.term_eq (_ge_arg1, 0))
      {
        goto _block1__branch2;
      }
      _v_res1 = _c_67;
      goto _block1;
    }
  _block1__branch2: {}
    {
      if (_ge_arg1.get_len () != 1)
      {
        goto _block1__branch3;
      }
      if (!_c_34.term_eq (_ge_arg1, 0))
      {
        goto _block1__branch3;
      }
      _v_res1 = _c_68;
      goto _block1;
    }
  _block1__branch3: {}
    {
      if (_ge_arg1.get_len () != 1)
      {
        goto _block1__branch4;
      }
      if (!_c_31.term_eq (_ge_arg1, 0))
      {
        goto _block1__branch4;
      }
      _v_res1 = _c_69;
      goto _block1;
    }
  _block1__branch4: {}
    if (_ge_arg1.get_len () != 1)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    if (_ge_arg1.symbol_at (0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _v_deref__arg1 (_ge_arg1, 0);
    if (_v_deref__arg1.get_len () != 3)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    if (_v_deref__arg1.symbol_at ((0 + 1 + 1)))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _v_deref__deref__arg1 (_v_deref__arg1, (0 + 1 + 1));
    uintptr_t _v_len1 = _v_deref__deref__arg1.get_len ();
    uintptr_t _v_len2 = 0;
    if (_v_len1 < _v_len2)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    uintptr_t _v_len__name = (_v_len1 - _v_len2);
    if (!_v_deref__arg1.symbol_at (0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _vs_tag (_v_deref__arg1, 0, 1);
    Expr _vt__e__e_tmp_m_rfp__checkrf_m_349_m_11 (_v_deref__arg1, (0 + 1), 1);
    Expr _ve_name (_v_deref__deref__arg1, 0, _v_len__name);
    Expr _ge_auxcall1;
    RF_CALL (AS_m_To_m_Ref, _vs_tag, _ge_auxcall1);
    Expr _v_To_m_Chars1;
    RF_CALL (Convert::To_m_Chars, _ve_name, _v_To_m_Chars1);
    _v_res1 = (_ge_auxcall1 + _c_70 + _v_To_m_Chars1);
  }
_block1: {}
RF_END

}

namespace rfp__check
{

static void init_ ()
{
  _c_0 = Expr::create<rftype::Word>("ITEMS");
  _c_1 = Expr::create<rftype::Word>("FUNC");
  _c_2 = Expr::create<rftype::Word>("FUNC?");
  _c_3 = Expr::create<rftype::Word>("TFUNC");
  _c_4 = Expr::create<rftype::Integer>("0");
  _c_41 = Expr::create<rftype::Word>("Error!") + Expr::create<rftype::Word>("Re");
  _c_5 = Expr (_c_41, 0, 1);
  _c_59 = Expr::create<rftype::Word>("Error!") + Expr::create<rftype::Word>("Cut");
  _c_6 = Expr (_c_59, 1, 1);
  _c_7 = Expr::create<rftype::Word>("ERROR");
  _c_31 = Expr::create<rftype::Word>("EVAR");
  _c_8 = (_c_31) ();
  _c_9 = Expr::create<rftype::Word>("RESULT");
  _c_10 = Expr::create<rftype::Word>("BLOCK");
  _c_11 = Expr::create<rftype::Word>("BLOCK?");
  _c_12 = Expr (_c_41, 1, 1);
  _c_13 = Expr::create<rftype::Word>("FORMAT");
  _c_14 = (Expr::create<rftype::Word>("Comp") + Expr::create<rftype::Word>("Branch")) ();
  _c_15 = Expr::create<rftype::Word>("BRANCH");
  _c_16 = Expr::create<rftype::Word>("NOT");
  _c_17 = Expr::create<rftype::Word>("ITER");
  _c_18 = Expr::create<rftype::Word>("TRY");
  _c_19 = Expr::create<rftype::Word>("LEFT");
  _c_20 = Expr::create<rftype::Word>("RIGHT");
  _c_45 = Expr::create<rftype::Word>("Error!") + Expr::create<rftype::Word>("Pattern");
  _c_21 = Expr (_c_45, 1, 1);
  _c_22 = Expr::create<rftype::Word>("NOFAIL");
  _c_23 = Expr::create<rftype::Word>("FAIL");
  _c_24 = Expr::create<rftype::Word>("CUTALL");
  _c_25 = Expr::create<rftype::Word>("CUT");
  _c_26 = Expr::create<rftype::Word>("STAKE");
  _c_27 = Expr::create<rftype::Word>("CALL");
  _c_28 = Expr::create<rftype::Integer>("3");
  _c_43 = Expr::create<rftype::Word>("Error!") + Expr::create<rftype::Word>("Call");
  _c_29 = Expr (_c_43, 1, 1);
  _c_30 = Expr::create<rftype::Word>("PAREN");
  _c_32 = Expr::create<rftype::Word>("SVAR");
  _c_33 = Expr::create<rftype::Word>("TVAR");
  _c_34 = Expr::create<rftype::Word>("VVAR");
  _c_55 = Expr::create<rftype::Word>("Error!") + Expr::create<rftype::Word>("Var-Type");
  _c_35 = Expr (_c_55, 1, 1);
  _c_49 = Expr::create<rftype::Word>("Error!") + Expr::create<rftype::Word>("Var-Re");
  _c_36 = Expr (_c_49, 1, 1);
  _c_52 = Expr::create<rftype::Word>("Error!") + Expr::create<rftype::Word>("Var-Hard");
  _c_37 = Expr (_c_52, 1, 1);
  _c_38 = Expr::create<rftype::Word>("Format");
  _c_39 = Expr::create<rftype::Integer>("1");
  _c_40 = Expr::create<rftype::Word>(" ");
  _c_42 = Expr::create<rftype::Word>("Wrong format of result expression");
  _c_44 = Expr::create<rftype::Word>("Wrong argument format in function call");
  _c_46 = Expr::create<rftype::Word>("Wrong format of pattern expression");
  _c_47 = Expr::create<rftype::Word>("Warning!") + Expr::create<rftype::Word>("Pattern");
  _c_48 = Expr::create<rftype::Word>("Clash can't be solved");
  _c_50 = Expr::create<rftype::Word>("' in result expression");
  _c_51 = Expr::create<rftype::Word>("Unknown variable '");
  _c_53 = Expr::create<rftype::Word>("' in hard expression");
  _c_54 = Expr::create<rftype::Word>("Repeated occurence of the variable '");
  _c_56 = Expr::create<rftype::Word>("'");
  _c_57 = Expr::create<rftype::Word>("' of the variable '");
  _c_58 = Expr::create<rftype::Word>("Incorrect type '");
  _c_60 = Expr::create<rftype::Word>("'\\!' without corresponding '\\?'");
  _c_61 = Expr::create<rftype::Word>("PRAGMA");
  _c_62 = Expr::create<rftype::Word>("FILE");
  _c_63 = Expr::create<rftype::Word>("LINE");
  _c_64 = Expr::create<rftype::Word>(", ");
  _c_65 = Expr::create<rftype::Word>(":");
  _c_66 = rftype::Char::create_expr (L"s");
  _c_67 = rftype::Char::create_expr (L"t");
  _c_68 = rftype::Char::create_expr (L"v");
  _c_69 = rftype::Char::create_expr (L"e");
  _c_70 = rftype::Char::create_expr (L".");
}

static AtStart init_registrator_ (&init_);

}

}
