#include <rf_core.hh>
#include <refal/Access.hh>
#include <refal/Arithm.hh>
#include <refal/Apply.hh>
#include <refal/Compare.hh>
#include <refal/Box.hh>
#include <refal/StdIO.hh>
#include "rfp_compile.hh"
#include <refal/Table.hh>
#include "rfp_helper.hh"
#include "rfp_vars.hh"
#include "rfp_const.hh"
#include <refal/List.hh>

namespace refal
{

using namespace rfrt;

namespace rfp__clashes
{

Expr Known_m_Lengths;

Expr Compute_m_Length;

Expr Unknown_m_Lengths;

Expr Checked_m_Lengths;

Expr Eqs;

static Expr Clashes;

static Expr Hard_m_Parts;

static Expr Parenth;

static Expr Unready_m_Source;

RF_DECL (Add_m_Clash_m_To_m_Var);

RF_DECL (Classify_m_Lengths);

RF_DECL (Reclassify_m_Clash);

static Expr FreeIdx;

RF_DECL (Free_m_Index);

RF_DECL (Init_m_Clashes);

RF_DECL (Compose_m_Clashes);

RF_DECL (Update_m_Hard_m_Parts);

RF_DECL (UHP);

RF_DECL (UHP_m_Clash);

RF_DECL (Prepare_m_Source);

RF_DECL (Define_m_Vars);

RF_DECL (Not_m_Idx);

RF_DECL (Compose_m_Source);

RF_DECL (Find_m_SFD);

RF_DECL (Not_m_Instantiated_m_Var);

RF_DECL (Get_m_Cycle);

RF_DECL (Get_m_Known_m_Length);

static Expr Const_m_Len;

RF_DECL (Ref_m_Len);

RF_DECL (R__0);

RF_DECL (L__0);

static Expr _c_0;

static Expr _c_1;

static Expr _c_2;

static Expr _c_3;

static Expr _c_4;

static Expr _c_5;

static Expr _c_37;

static Expr _c_6;

static Expr _c_7;

static Expr _c_8;

static Expr _c_9;

static Expr _c_10;

static Expr _c_11;

static Expr _c_12;

static Expr _c_13;

static Expr _c_14;

static Expr _c_15;

static Expr _c_16;

static Expr _c_17;

static Expr _c_18;

static Expr _c_19;

static Expr _c_20;

static Expr _c_21;

static Expr _c_22;

static Expr _c_23;

static Expr _c_24;

static Expr _c_25;

static Expr _c_26;

static Expr _c_27;

static Expr _c_28;

static Expr _c_29;

static Expr _c_30;

static Expr _c_31;

static Expr _c_32;

static Expr _c_33;

static Expr _c_34;

static Expr _c_35;

static Expr _c_36;

RF_FUNC (Add_m_Clash_m_To_m_Var, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  if (_ge_arg1.get_len () != 2)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _vt_clash (_ge_arg1, 0, 1);
  Expr _vt_var (_ge_arg1, (0 + 1), 1);
  Expr _ge_auxcall1;
  if (!RF_CALL (rfp__vars::Get_m_Var, (_c_0, _vt_var), _ge_auxcall1))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  RF_CALL (rfp__vars::Set_m_Var, ((_c_0 + _ge_auxcall1 + _vt_clash) (), _vt_var), /*void*/);
  _v_res1 = empty;
RF_END

RF_FUNC (Classify_m_Lengths, (RF_ARG _gt_arg1;;), (RF_RES _v_res1;;))
  if (_gt_arg1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _v_deref__arg1 (_gt_arg1, 0);
  uintptr_t _v_len1 = _v_deref__arg1.get_len ();
  uintptr_t _v_len2 = 3;
  if (_v_len1 < _v_len2)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len___e__e_tmp_m_rfp__clashesrf_m_69_m_46 = (_v_len1 - _v_len2);
  if (_v_deref__arg1.symbol_at ((0 + 1)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (_v_deref__arg1.symbol_at ((0 + 1 + 1)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _v_deref__deref__arg1 (_v_deref__arg1, (0 + 1));
  Expr _v_deref__deref__arg12 (_v_deref__arg1, (0 + 1 + 1));
  uintptr_t _v_len3 = _v_deref__deref__arg12.get_len ();
  uintptr_t _v_len4 = 1;
  if (_v_len3 < _v_len4)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len__Pe = (_v_len3 - _v_len4);
  uintptr_t _v_len5 = _v_deref__deref__arg1.get_len ();
  uintptr_t _v_len6 = 0;
  if (_v_len5 < _v_len6)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len__Re = (_v_len5 - _v_len6);
  if (!_v_deref__arg1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_v_deref__deref__arg12.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _vs_idx (_v_deref__arg1, 0, 1);
  Expr _ve__e__e_tmp_m_rfp__clashesrf_m_69_m_46 (_v_deref__arg1, (0 + 1 + 1 + 1), _v_len___e__e_tmp_m_rfp__clashesrf_m_69_m_46);
  Expr _ve_Re (_v_deref__deref__arg1, 0, _v_len__Re);
  Expr _vs_dir (_v_deref__deref__arg12, 0, 1);
  Expr _ve_Pe (_v_deref__deref__arg12, (0 + 1), _v_len__Pe);
  Expr _ve_len_m_Re;
  Expr _ve_vars_m_Re;
  RF_CALL (Get_m_Known_m_Length, _ve_Re, (_ve_len_m_Re, _ve_vars_m_Re));
  Expr _ve_len_m_Pe;
  Expr _ve_vars_m_Pe;
  RF_CALL (Get_m_Known_m_Length, _ve_Pe, (_ve_len_m_Pe, _ve_vars_m_Pe));
  {
    {
      if (_ve_vars_m_Pe.get_len () != 0)
      {
        goto _block1__branch1;
      }
      if (_ve_vars_m_Re.get_len () != 0)
      {
        goto _block1__branch1;
      }
      RF_CALL (Table::Bind, (Known_m_Lengths, _vs_idx, (_ve_len_m_Re () + _ve_len_m_Pe ())), /*void*/);
      _v_res1 = Known_m_Lengths;
      goto _block1;
    }
  _block1__branch1: {}
    {
      Expr _gs_auxcall1;
      RF_CALL (Access::Length, _ve_vars_m_Re, _gs_auxcall1);
      Expr _gs_auxcall2;
      RF_CALL (Access::Length, _ve_vars_m_Pe, _gs_auxcall2);
      Expr _vs_diff;
      RF_CALL (Arithm::_m_, (_gs_auxcall1, _gs_auxcall2), _vs_diff);
      if (!RF_CALL (Compare::_s__eq_, (_vs_diff, _c_1), /*void*/))
      {
        goto _block1__branch2;
      }
      Expr _v_Nub1;
      RF_CALL (List::Nub, (_ve_vars_m_Re + _ve_vars_m_Pe), _v_Nub1);
      if (_v_Nub1.get_len () != 1)
      {
        goto _block1__branch2;
      }
      Expr _vt_var (_v_Nub1, 0, 1);
      Expr _vs_mult;
      Expr _ve_minuend;
      Expr _ve_subtrahend;
      {
        {
          if (!RF_CALL (Compare::_lt_, (_vs_diff, _c_1), /*void*/))
          {
            goto _block2__branch1;
          }
          Expr _gs_auxcall3;
          RF_CALL (Arithm::_a_, (_vs_diff, _c_2), _gs_auxcall3);
          _vs_mult = _gs_auxcall3;
          _ve_minuend = _ve_len_m_Re;
          _ve_subtrahend = _ve_len_m_Pe;
          goto _block2;
        }
      _block2__branch1: {}
        _vs_mult = _vs_diff;
        _ve_minuend = _ve_len_m_Pe;
        _ve_subtrahend = _ve_len_m_Re;
      }
    _block2: {}
      Expr _v_Map1;
      if (!RF_CALL (List::Map, (_c_3, _vs_idx, (_ve_vars_m_Re + _ve_vars_m_Pe)), _v_Map1))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      uintptr_t _v_len7 = _v_Map1.get_len ();
      uintptr_t _v_len8 = 0;
      if (_v_len7 < _v_len8)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      uintptr_t _v_len___e__e_tmp_m_rfp__clashesrf_m_94_m_62 = (_v_len7 - _v_len8);
      Expr _ve__e__e_tmp_m_rfp__clashesrf_m_94_m_62 (_v_Map1, 0, _v_len___e__e_tmp_m_rfp__clashesrf_m_94_m_62);
      RF_CALL (Table::Bind, (Compute_m_Length, _vs_idx, (_vt_var + _vs_mult + _ve_minuend () + _ve_subtrahend ())), /*void*/);
      _v_res1 = Compute_m_Length;
      goto _block1;
    }
  _block1__branch2: {}
    Expr _v_Map2;
    if (!RF_CALL (List::Map, (_c_3, _vs_idx, (_ve_vars_m_Re + _ve_vars_m_Pe)), _v_Map2))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    uintptr_t _v_len9 = _v_Map2.get_len ();
    uintptr_t _v_len10 = 0;
    if (_v_len9 < _v_len10)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    uintptr_t _v_len___e__e_tmp_m_rfp__clashesrf_m_104_m_60 = (_v_len9 - _v_len10);
    Expr _ve__e__e_tmp_m_rfp__clashesrf_m_104_m_60 (_v_Map2, 0, _v_len___e__e_tmp_m_rfp__clashesrf_m_104_m_60);
    RF_CALL (Table::Bind, (Unknown_m_Lengths, _vs_idx, (_ve_len_m_Re () + _ve_len_m_Pe () + _ve_vars_m_Re () + _ve_vars_m_Pe ())), /*void*/);
    _v_res1 = Unknown_m_Lengths;
  }
_block1: {}
RF_END

RF_FUNC (Reclassify_m_Clash, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  if (_ge_arg1.get_len () != 1)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_ge_arg1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _vs_idx (_ge_arg1, 0, 1);
  {
    {
      Expr _v__q_1;
      RF_CALL (Box::_q_, Clashes, _v__q_1);
      if (_v__q_1.get_len () < 1)
      {
        goto _block1__branch1;
      }
      RF_lsplit (_v__q_1, 0, _ve_1, _v_lsplit___q_1);
      for ( ; ; RF_iter(_v__q_1)++)
      {
        {
          if (!RF_iter(_v__q_1))
          {
            goto _block1__branch1;
          }
          uintptr_t _v_len1 = _v_lsplit___q_1.get_len ();
          uintptr_t _v_len2 = 1;
          if (_v_len1 < _v_len2)
          {
            goto _block1__branch1;
          }
          uintptr_t _v_len__2 = (_v_len1 - _v_len2);
          if (_v_lsplit___q_1.symbol_at (0))
          {
            goto _continue1;
          }
          Expr _v_deref__lsplit___q_1 (_v_lsplit___q_1, 0);
          uintptr_t _v_len3 = _v_deref__lsplit___q_1.get_len ();
          uintptr_t _v_len4 = 3;
          if (_v_len3 < _v_len4)
          {
            goto _continue1;
          }
          uintptr_t _v_len__boxes = (_v_len3 - _v_len4);
          if (_v_deref__lsplit___q_1.symbol_at ((0 + 1)))
          {
            goto _continue1;
          }
          if (_v_deref__lsplit___q_1.symbol_at ((0 + 1 + 1)))
          {
            goto _continue1;
          }
          Expr _v_deref__deref__lsplit___q_1 (_v_deref__lsplit___q_1, (0 + 1));
          Expr _v_deref__deref__lsplit___q_12 (_v_deref__lsplit___q_1, (0 + 1 + 1));
          uintptr_t _v_len5 = _v_deref__deref__lsplit___q_12.get_len ();
          uintptr_t _v_len6 = 1;
          if (_v_len5 < _v_len6)
          {
            goto _continue1;
          }
          uintptr_t _v_len__Pe = (_v_len5 - _v_len6);
          uintptr_t _v_len7 = _v_deref__deref__lsplit___q_1.get_len ();
          uintptr_t _v_len8 = 0;
          if (_v_len7 < _v_len8)
          {
            goto _continue1;
          }
          uintptr_t _v_len__Re = (_v_len7 - _v_len8);
          if (!_vs_idx.term_eq (_v_deref__lsplit___q_1, 0))
          {
            goto _continue1;
          }
          if (!_v_deref__deref__lsplit___q_12.symbol_at (0))
          {
            goto _continue1;
          }
          Expr _ve_2 (_v_lsplit___q_1, (0 + 1), _v_len__2);
          Expr _ve_boxes (_v_deref__lsplit___q_1, (0 + 1 + 1 + 1), _v_len__boxes);
          Expr _ve_Re (_v_deref__deref__lsplit___q_1, 0, _v_len__Re);
          Expr _vs_dir (_v_deref__deref__lsplit___q_12, 0, 1);
          Expr _ve_Pe (_v_deref__deref__lsplit___q_12, (0 + 1), _v_len__Pe);
          Expr _ve_boxes1;
          RF_CALL (List::Sub, (_ve_boxes, _c_4), _ve_boxes1);
          RF_CALL (Table::Unbind, (Compute_m_Length, _vs_idx), /*void*/);
          RF_CALL (Table::Unbind, (Unknown_m_Lengths, _vs_idx), /*void*/);
          Expr _ve_boxes2;
          RF_CALL (Classify_m_Lengths, (_vs_idx + _ve_Re () + (_vs_dir + _ve_Pe) ()) (), _ve_boxes2);
          RF_CALL (Box::Store, (Clashes, (_ve_1 + (_vs_idx + _ve_Re () + (_vs_dir + _ve_Pe) () + _ve_boxes1 + _ve_boxes2) () + _ve_2)), /*void*/);
          _v_res1 = empty;
          goto _exit1;
        }
    _continue1: {}
      }
    _exit1: {}
      goto _block1;
    }
  _block1__branch1: {}
    _v_res1 = empty;
  }
_block1: {}
RF_END

RF_FUNC (Free_m_Index, RF_VOID, (RF_RES _v_res1;;))
  Expr _v__q_1;
  RF_CALL (Box::_q_, FreeIdx, _v__q_1);
  if (_v__q_1.get_len () != 1)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_v__q_1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _vs_idx (_v__q_1, 0, 1);
  Expr _gs_auxcall1;
  RF_CALL (Arithm::_p_, (_vs_idx, _c_5), _gs_auxcall1);
  RF_CALL (Box::Store, (FreeIdx, _gs_auxcall1), /*void*/);
  _v_res1 = _vs_idx;
RF_END

RF_FUNC (Init_m_Clashes, (RF_ARG _ve_clashes;;), RF_VOID)
  RF_CALL (rfp__helper::RFP_m_Clear_m_Table, Known_m_Lengths, /*void*/);
  RF_CALL (rfp__helper::RFP_m_Clear_m_Table, Compute_m_Length, /*void*/);
  RF_CALL (rfp__helper::RFP_m_Clear_m_Table, Unknown_m_Lengths, /*void*/);
  RF_CALL (Box::Store, (Checked_m_Lengths, empty), /*void*/);
  RF_CALL (Box::Store, (Eqs, empty), /*void*/);
  RF_CALL (Box::Store, (Parenth, empty), /*void*/);
  RF_CALL (Box::Store, (Unready_m_Source, empty), /*void*/);
  RF_CALL (rfp__helper::RFP_m_Clear_m_Table, Hard_m_Parts, /*void*/);
  RF_CALL (Box::Store, (FreeIdx, _c_1), /*void*/);
  Expr _ge_auxcall1;
  RF_CALL (Compose_m_Clashes, _ve_clashes, _ge_auxcall1);
  RF_TAILCALL (Box::Store, (Clashes, _ge_auxcall1), /*void*/);
RF_END

RF_FUNC (Compose_m_Clashes, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  {
    {
      uintptr_t _v_len1 = _ge_arg1.get_len ();
      uintptr_t _v_len2 = 2;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__rest = (_v_len1 - _v_len2);
      if (_ge_arg1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      if (_ge_arg1.symbol_at ((0 + 1)))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__arg1 (_ge_arg1, 0);
      Expr _v_deref__arg12 (_ge_arg1, (0 + 1));
      uintptr_t _v_len3 = _v_deref__arg12.get_len ();
      uintptr_t _v_len4 = 1;
      if (_v_len3 < _v_len4)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__Pe = (_v_len3 - _v_len4);
      uintptr_t _v_len5 = _v_deref__arg1.get_len ();
      uintptr_t _v_len6 = 0;
      if (_v_len5 < _v_len6)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__Re = (_v_len5 - _v_len6);
      if (!_v_deref__arg12.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _ve_rest (_ge_arg1, (0 + 1 + 1), _v_len__rest);
      Expr _ve_Re (_v_deref__arg1, 0, _v_len__Re);
      Expr _vs_dir (_v_deref__arg12, 0, 1);
      Expr _ve_Pe (_v_deref__arg12, (0 + 1), _v_len__Pe);
      Expr _vs_idx;
      RF_CALL (Free_m_Index, /*void*/, _vs_idx);
      Expr _ve_boxes;
      RF_CALL (Classify_m_Lengths, (_vs_idx + _ve_Re () + (_vs_dir + _ve_Pe) ()) (), _ve_boxes);
      {
        {
          {
            {
              Expr _v_Get_m_Var1;
              if (!RF_CALL (rfp__vars::Get_m_Var, (_c_6, _ve_Re), _v_Get_m_Var1))
              {
                goto _block3__branch1;
              }
              if (_v_Get_m_Var1.get_len () != 1)
              {
                goto _block3__branch1;
              }
              if (!_c_7.term_eq (_v_Get_m_Var1, 0))
              {
                goto _block3__branch1;
              }
              goto _block3;
            }
          _block3__branch1: {}
            {
              if (_v_len__Re != 1)
              {
                goto _block3__branch2;
              }
              if (_ve_Re.symbol_at (0))
              {
                goto _block3__branch2;
              }
              Expr _v_deref__Re (_ve_Re, 0);
              uintptr_t _v_len7 = _v_deref__Re.get_len ();
              uintptr_t _v_len8 = 1;
              if (_v_len7 < _v_len8)
              {
                goto _block3__branch2;
              }
              uintptr_t _v_len___e__e_tmp_m_rfp__clashesrf_m_162_m_22 = (_v_len7 - _v_len8);
              if (!_c_8.term_eq (_v_deref__Re, 0))
              {
                goto _block3__branch2;
              }
              Expr _ve__e__e_tmp_m_rfp__clashesrf_m_162_m_22 (_v_deref__Re, (0 + 1), _v_len___e__e_tmp_m_rfp__clashesrf_m_162_m_22);
              goto _block3;
            }
          _block3__branch2: {}
            if (_v_len__Re != 1)
            {
              goto _block2__branch1;
            }
            if (_ve_Re.symbol_at (0))
            {
              goto _block2__branch1;
            }
            Expr _v_deref__Re2 (_ve_Re, 0);
            uintptr_t _v_len9 = _v_deref__Re2.get_len ();
            uintptr_t _v_len10 = 1;
            if (_v_len9 < _v_len10)
            {
              goto _block2__branch1;
            }
            uintptr_t _v_len___e__e_tmp_m_rfp__clashesrf_m_163_m_25 = (_v_len9 - _v_len10);
            if (!_c_9.term_eq (_v_deref__Re2, 0))
            {
              goto _block2__branch1;
            }
            Expr _ve__e__e_tmp_m_rfp__clashesrf_m_163_m_25 (_v_deref__Re2, (0 + 1), _v_len___e__e_tmp_m_rfp__clashesrf_m_163_m_25);
          }
        _block3: {}
          goto _block2;
        }
      _block2__branch1: {}
        {
          if (_v_len__Pe < 1)
          {
            goto _block2__branch2;
          }
          RF_lsplit (_ve_Pe, 0, _ve_1, _v_lsplit__Pe);
          for ( ; ; RF_iter(_ve_Pe)++)
          {
            {
              if (!RF_iter(_ve_Pe))
              {
                goto _block2__branch2;
              }
              uintptr_t _v_len11 = _v_lsplit__Pe.get_len ();
              uintptr_t _v_len12 = 1;
              if (_v_len11 < _v_len12)
              {
                goto _block2__branch2;
              }
              uintptr_t _v_len__2 = (_v_len11 - _v_len12);
              if (_v_lsplit__Pe.symbol_at (0))
              {
                goto _continue1;
              }
              Expr _v_deref__lsplit__Pe (_v_lsplit__Pe, 0);
              uintptr_t _v_len13 = _v_deref__lsplit__Pe.get_len ();
              uintptr_t _v_len14 = 1;
              if (_v_len13 < _v_len14)
              {
                goto _continue1;
              }
              uintptr_t _v_len___e__e_tmp_m_rfp__clashesrf_m_165_m_25 = (_v_len13 - _v_len14);
              if (!_c_10.term_eq (_v_deref__lsplit__Pe, 0))
              {
                goto _continue1;
              }
              Expr _ve_2 (_v_lsplit__Pe, (0 + 1), _v_len__2);
              Expr _ve__e__e_tmp_m_rfp__clashesrf_m_165_m_25 (_v_deref__lsplit__Pe, (0 + 1), _v_len___e__e_tmp_m_rfp__clashesrf_m_165_m_25);
              Expr _ve_Re_m_vars;
              RF_CALL (rfp__vars::Vars, _ve_Re, _ve_Re_m_vars);
              Expr _ge_auxcall1;
              RF_CALL (rfp__vars::Vars, _ve_1, _ge_auxcall1);
              RF_CALL (Box::Put, (Parenth, (_vs_idx + _ve_Re_m_vars () + _ge_auxcall1) ()), /*void*/);
              {
                {
                  if (_v_len__2 < 1)
                  {
                    goto _block4__branch1;
                  }
                  RF_rsplit (_ve_2, 0, _v_rsplit__2, _ve_3);
                  for ( ; ; RF_iter(_ve_2)--)
                  {
                    {
                      if (!RF_iter(_ve_2))
                      {
                        goto _block4__branch1;
                      }
                      uintptr_t _v_len15 = _v_rsplit__2.get_len ();
                      uintptr_t _v_len16 = 1;
                      if (_v_len15 < _v_len16)
                      {
                        goto _block4__branch1;
                      }
                      uintptr_t _v_len___e__e_tmp_m_rfp__clashesrf_m_169_m_20 = (_v_len15 - _v_len16);
                      if (_v_rsplit__2.symbol_at ((0 + _v_len___e__e_tmp_m_rfp__clashesrf_m_169_m_20)))
                      {
                        goto _continue2;
                      }
                      Expr _v_deref__rsplit__2 (_v_rsplit__2, (0 + _v_len___e__e_tmp_m_rfp__clashesrf_m_169_m_20));
                      uintptr_t _v_len17 = _v_deref__rsplit__2.get_len ();
                      uintptr_t _v_len18 = 1;
                      if (_v_len17 < _v_len18)
                      {
                        goto _continue2;
                      }
                      uintptr_t _v_len___e__e_tmp_m_rfp__clashesrf_m_169_m_29 = (_v_len17 - _v_len18);
                      if (!_c_10.term_eq (_v_deref__rsplit__2, 0))
                      {
                        goto _continue2;
                      }
                      Expr _ve__e__e_tmp_m_rfp__clashesrf_m_169_m_20 (_v_rsplit__2, 0, _v_len___e__e_tmp_m_rfp__clashesrf_m_169_m_20);
                      Expr _ve__e__e_tmp_m_rfp__clashesrf_m_169_m_29 (_v_deref__rsplit__2, (0 + 1), _v_len___e__e_tmp_m_rfp__clashesrf_m_169_m_29);
                      Expr _ge_auxcall2;
                      RF_CALL (rfp__vars::Vars, _ve_3, _ge_auxcall2);
                      RF_CALL (Box::Put, (Parenth, (_vs_idx + _ve_Re_m_vars () + _ge_auxcall2) ()), /*void*/);
                      goto _exit2;
                    }
                _continue2: {}
                  }
                _exit2: {}
                  goto _block4;
                }
              _block4__branch1: {}
              }
            _block4: {}
              RF_CALL (Box::Put, (Unready_m_Source, (_vs_idx + _ve_Re_m_vars) ()), /*void*/);
              goto _exit1;
            }
        _continue1: {}
          }
        _exit1: {}
          goto _block2;
        }
      _block2__branch2: {}
        Expr _ge_auxcall3;
        RF_CALL (rfp__vars::Vars, _ve_Re, _ge_auxcall3);
        RF_CALL (Box::Put, (Unready_m_Source, (_vs_idx + _ge_auxcall3) ()), /*void*/);
      }
    _block2: {}
      Expr _v_Compose_m_Clashes1;
      RF_CALL (Compose_m_Clashes, _ve_rest, _v_Compose_m_Clashes1);
      _v_res1 = ((_vs_idx + _ve_Re () + (_vs_dir + _ve_Pe) () + _ve_boxes) () + _v_Compose_m_Clashes1);
      goto _block1;
    }
  _block1__branch1: {}
    if (_ge_arg1.get_len () != 0)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    _v_res1 = empty;
  }
_block1: {}
RF_END

RF_FUNC (Update_m_Hard_m_Parts, RF_VOID, (RF_RES _v_res1;;))
  Expr _ge_auxcall1;
  RF_CALL (Box::_q_, Clashes, _ge_auxcall1);
  Expr _ve_clashes;
  Expr _ve_actions;
  RF_CALL (UHP, (empty, empty, _ge_auxcall1), (_ve_clashes, _ve_actions));
  RF_CALL (Box::Store, (Clashes, _ve_clashes), /*void*/);
  _v_res1 = _ve_actions;
RF_END

RF_FUNC (UHP, (RF_ARG _ve_conds, _ve_assigns, _ve_clashes;;), (RF_RES _v_res1, _v_res2;;))
  {
    {
      uintptr_t _v_len1 = _ve_clashes.get_len ();
      uintptr_t _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__rest = (_v_len1 - _v_len2);
      Expr _vt_clash (_ve_clashes, 0, 1);
      Expr _ve_rest (_ve_clashes, (0 + 1), _v_len__rest);
      if (_vt_clash.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__clash (_vt_clash, 0);
      uintptr_t _v_len3 = _v_deref__clash.get_len ();
      uintptr_t _v_len4 = 3;
      if (_v_len3 < _v_len4)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len___e__e_tmp_m_rfp__clashesrf_m_205_m_43 = (_v_len3 - _v_len4);
      if (_v_deref__clash.symbol_at ((0 + 1)))
      {
        goto _block1__branch1;
      }
      if (_v_deref__clash.symbol_at ((0 + 1 + 1)))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__deref__clash (_v_deref__clash, (0 + 1));
      Expr _v_deref__deref__clash2 (_v_deref__clash, (0 + 1 + 1));
      if (_v_deref__deref__clash.get_len () != 1)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len5 = _v_deref__deref__clash2.get_len ();
      uintptr_t _v_len6 = 1;
      if (_v_len5 < _v_len6)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__Pe = (_v_len5 - _v_len6);
      if (!_v_deref__clash.symbol_at (0))
      {
        goto _block1__branch1;
      }
      if (!_v_deref__deref__clash2.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _vs_idx (_v_deref__clash, 0, 1);
      Expr _ve__e__e_tmp_m_rfp__clashesrf_m_205_m_43 (_v_deref__clash, (0 + 1 + 1 + 1), _v_len___e__e_tmp_m_rfp__clashesrf_m_205_m_43);
      Expr _vt_Re (_v_deref__deref__clash, 0, 1);
      Expr _vs_dir (_v_deref__deref__clash2, 0, 1);
      Expr _ve_Pe (_v_deref__deref__clash2, (0 + 1), _v_len__Pe);
      {
        {
          Expr _v_Get_m_Var1;
          if (!RF_CALL (rfp__vars::Get_m_Var, (_c_6, _vt_Re), _v_Get_m_Var1))
          {
            goto _block2__branch1;
          }
          if (_v_Get_m_Var1.get_len () != 1)
          {
            goto _block2__branch1;
          }
          if (!_c_7.term_eq (_v_Get_m_Var1, 0))
          {
            goto _block2__branch1;
          }
          goto _block2;
        }
      _block2__branch1: {}
        {
          if (_vt_Re.symbol_at (0))
          {
            goto _block2__branch2;
          }
          Expr _v_deref__Re (_vt_Re, 0);
          uintptr_t _v_len7 = _v_deref__Re.get_len ();
          uintptr_t _v_len8 = 1;
          if (_v_len7 < _v_len8)
          {
            goto _block2__branch2;
          }
          uintptr_t _v_len___e__e_tmp_m_rfp__clashesrf_m_208_m_20 = (_v_len7 - _v_len8);
          if (!_c_8.term_eq (_v_deref__Re, 0))
          {
            goto _block2__branch2;
          }
          Expr _ve__e__e_tmp_m_rfp__clashesrf_m_208_m_20 (_v_deref__Re, (0 + 1), _v_len___e__e_tmp_m_rfp__clashesrf_m_208_m_20);
          goto _block2;
        }
      _block2__branch2: {}
        if (_vt_Re.symbol_at (0))
        {
          goto _block1__branch1;
        }
        Expr _v_deref__Re2 (_vt_Re, 0);
        uintptr_t _v_len9 = _v_deref__Re2.get_len ();
        uintptr_t _v_len10 = 1;
        if (_v_len9 < _v_len10)
        {
          goto _block1__branch1;
        }
        uintptr_t _v_len___e__e_tmp_m_rfp__clashesrf_m_209_m_23 = (_v_len9 - _v_len10);
        if (!_c_9.term_eq (_v_deref__Re2, 0))
        {
          goto _block1__branch1;
        }
        Expr _ve__e__e_tmp_m_rfp__clashesrf_m_209_m_23 (_v_deref__Re2, (0 + 1), _v_len___e__e_tmp_m_rfp__clashesrf_m_209_m_23);
      }
    _block2: {}
      Expr _ge_auxalt1;
      {
        {
          if (!RF_CALL (Table::Lookup, (Hard_m_Parts, _vs_idx), _ge_auxalt1))
          {
            goto _block3__branch1;
          }
          goto _block3;
        }
      _block3__branch1: {}
        _ge_auxalt1 = (_c_11 + _ve_Pe);
      }
    _block3: {}
      uintptr_t _v_len11 = _ge_auxalt1.get_len ();
      uintptr_t _v_len12 = 2;
      if (_v_len11 < _v_len12)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      uintptr_t _v_len__xpr = (_v_len11 - _v_len12);
      if (_ge_auxalt1.symbol_at (0))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      if (_ge_auxalt1.symbol_at ((0 + 1)))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      Expr _v_deref__auxalt1 (_ge_auxalt1, 0);
      Expr _v_deref__auxalt12 (_ge_auxalt1, (0 + 1));
      uintptr_t _v_len13 = _v_deref__auxalt12.get_len ();
      uintptr_t _v_len14 = 0;
      if (_v_len13 < _v_len14)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      uintptr_t _v_len__right = (_v_len13 - _v_len14);
      uintptr_t _v_len15 = _v_deref__auxalt1.get_len ();
      uintptr_t _v_len16 = 0;
      if (_v_len15 < _v_len16)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      uintptr_t _v_len__left = (_v_len15 - _v_len16);
      Expr _ve_xpr (_ge_auxalt1, (0 + 1 + 1), _v_len__xpr);
      Expr _ve_left (_v_deref__auxalt1, 0, _v_len__left);
      Expr _ve_right (_v_deref__auxalt12, 0, _v_len__right);
      Expr _ve_l_m_clashes;
      Expr _ve_l_m_conds;
      Expr _ve_l_m_assigns;
      RF_CALL (UHP_m_Clash, (_c_12, _c_13, _c_5, _c_1, empty, empty, _ve_left, _vt_Re, _ve_xpr), (_ve_l_m_clashes, _ve_l_m_conds, _ve_l_m_assigns, _ve_left, _ve_xpr));
      Expr _ve_r_m_clashes;
      Expr _ve_r_m_conds;
      Expr _ve_r_m_assigns;
      RF_CALL (UHP_m_Clash, (_c_14, _c_15, _c_1, _c_5, empty, empty, _ve_right, _vt_Re, _ve_xpr), (_ve_r_m_clashes, _ve_r_m_conds, _ve_r_m_assigns, _ve_right, _ve_xpr));
      RF_CALL (Table::Bind, (Hard_m_Parts, _vs_idx, (_ve_left () + _ve_right () + _ve_xpr)), /*void*/);
      Expr _ge_auxcall2;
      RF_CALL (Compose_m_Clashes, _ve_l_m_clashes, _ge_auxcall2);
      Expr _ge_auxcall3;
      RF_CALL (Compose_m_Clashes, _ve_r_m_clashes, _ge_auxcall3);
      Expr _v_UHP1;
      RF_CALL (UHP, ((_ve_conds + _ve_l_m_conds + _ve_r_m_conds), (_ve_assigns + _ve_l_m_assigns + _ve_r_m_assigns), _ve_rest), (_v_UHP1, _v_res2));
      _v_res1 = (_ge_auxcall2 + _vt_clash + _ge_auxcall3 + _v_UHP1);
      goto _block1;
    }
  _block1__branch1: {}
    {
      uintptr_t _v_len17 = _ve_clashes.get_len ();
      uintptr_t _v_len18 = 1;
      if (_v_len17 < _v_len18)
      {
        goto _block1__branch2;
      }
      uintptr_t _v_len__rest2 = (_v_len17 - _v_len18);
      Expr _vt_unready_m_clash (_ve_clashes, 0, 1);
      Expr _ve_rest (_ve_clashes, (0 + 1), _v_len__rest2);
      Expr _v_UHP2;
      RF_CALL (UHP, (_ve_conds, _ve_assigns, _ve_rest), (_v_UHP2, _v_res2));
      _v_res1 = (_vt_unready_m_clash + _v_UHP2);
      goto _block1;
    }
  _block1__branch2: {}
    if (_ve_clashes.get_len () != 0)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    _v_res1 = empty;
    _v_res2 = (_ve_conds + _ve_assigns);
  }
_block1: {}
RF_END

RF_FUNC (UHP_m_Clash, (RF_ARG _vs_dir, _vs_fun, _vs_l, _vs_r, _ve_conds, _ve_assigns, _ve_pos, _ve_Re, _ve_Pe;;), (RF_RES _v_res1, _v_res2, _v_res3, _v_res4, _v_res5;;))
  {
    {
      Expr _v_Apply1;
      if (!RF_CALL (Apply::Apply, (_vs_fun, (_c_1 + _ve_Pe)), _v_Apply1))
      {
        goto _block1__branch1;
      }
      if (_v_Apply1.get_len () != 1)
      {
        goto _block1__branch1;
      }
      Expr _vt_Pt (_v_Apply1, 0, 1);
      {
        {
          Expr _v_Get_m_Known_m_Length1;
          Expr _v_Get_m_Known_m_Length2;
          RF_CALL (Get_m_Known_m_Length, _vt_Pt, (_v_Get_m_Known_m_Length1, _v_Get_m_Known_m_Length2));
          uintptr_t _v_len1 = (_v_Get_m_Known_m_Length1.get_len () + 1);
          uintptr_t _v_len2 = 1;
          if (_v_len1 < _v_len2)
          {
            goto _block2__branch1;
          }
          uintptr_t _v_len__len = (_v_len1 - _v_len2);
          Expr _v_compose1 ((_v_Get_m_Known_m_Length1 + _v_Get_m_Known_m_Length2 ()));
          if (!_c_16.term_eq (_v_compose1, (0 + _v_len__len)))
          {
            goto _block2__branch1;
          }
          Expr _ve_len (_v_compose1, 0, _v_len__len);
          Expr _ve_cond;
          Expr _ve_assign;
          Expr _ve_clash;
          {
            {
              if (_vt_Pt.symbol_at (0))
              {
                goto _block3__branch1;
              }
              Expr _v_deref__Pt (_vt_Pt, 0);
              uintptr_t _v_len3 = _v_deref__Pt.get_len ();
              uintptr_t _v_len4 = 1;
              if (_v_len3 < _v_len4)
              {
                goto _block3__branch1;
              }
              uintptr_t _v_len__xpr = (_v_len3 - _v_len4);
              if (!_c_10.term_eq (_v_deref__Pt, 0))
              {
                goto _block3__branch1;
              }
              Expr _ve_xpr (_v_deref__Pt, (0 + 1), _v_len__xpr);
              Expr _v_Gener_m_Vars1;
              RF_CALL (rfp__vars::Gener_m_Vars, (_c_17, (_c_18 + _ve_Re)), _v_Gener_m_Vars1);
              if (_v_Gener_m_Vars1.get_len () != 1)
              {
                goto _block2__branch1;
              }
              Expr _vt_var (_v_Gener_m_Vars1, 0, 1);
              RF_CALL (rfp__vars::Set_m_Var, (_c_19, _vt_var), /*void*/);
              _ve_cond = (_c_20 + _ve_Re + (_vs_dir + _ve_pos) ()) ();
              _ve_assign = (_c_21 + _vt_var + _ve_Re + (_vs_dir + _ve_pos) ()) ();
              _ve_clash = (_vt_var () + (_vs_dir + _ve_xpr) ());
              goto _block3;
            }
          _block3__branch1: {}
            RF_CALL (Box::Put, (Eqs, (_ve_Re () + (_vs_dir + _ve_pos) () + _vt_Pt + _ve_len ()) ()), /*void*/);
            _ve_cond = empty;
            _ve_assign = empty;
            _ve_clash = empty;
          }
        _block3: {}
          Expr _ge_auxcall1;
          if (!RF_CALL (Access::Middle, (_vs_l, _vs_r, _ve_Pe), _ge_auxcall1))
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          Expr _v_UHP_m_Clash1;
          RF_CALL (UHP_m_Clash, (_vs_dir, _vs_fun, _vs_l, _vs_r, (_ve_conds + _ve_cond), (_ve_assigns + _ve_assign), (_ve_pos + _ve_len), _ve_Re, _ge_auxcall1), (_v_UHP_m_Clash1, _v_res2, _v_res3, _v_res4, _v_res5));
          _v_res1 = (_ve_clash + _v_UHP_m_Clash1);
          goto _block2;
        }
      _block2__branch1: {}
        _v_res1 = empty;
        _v_res2 = _ve_conds;
        _v_res3 = _ve_assigns;
        _v_res4 = _ve_pos;
        _v_res5 = _ve_Pe;
      }
    _block2: {}
      goto _block1;
    }
  _block1__branch1: {}
    _v_res1 = empty;
    _v_res2 = _ve_conds;
    _v_res3 = _ve_assigns;
    _v_res4 = _ve_pos;
    _v_res5 = empty;
  }
_block1: {}
RF_END

RF_FUNC (Prepare_m_Source, (RF_ARG _ge_arg1;;), (RF_RES _v_res1, _v_res2;;))
  {
    {
      if (_ge_arg1.get_len () != 1)
      {
        goto _block1__branch1;
      }
      Expr _vt_Re (_ge_arg1, 0, 1);
      {
        {
          Expr _v_Get_m_Var1;
          if (!RF_CALL (rfp__vars::Get_m_Var, (_c_6, _vt_Re), _v_Get_m_Var1))
          {
            goto _block2__branch1;
          }
          if (_v_Get_m_Var1.get_len () != 1)
          {
            goto _block2__branch1;
          }
          if (!_c_7.term_eq (_v_Get_m_Var1, 0))
          {
            goto _block2__branch1;
          }
          goto _block2;
        }
      _block2__branch1: {}
        {
          if (_vt_Re.symbol_at (0))
          {
            goto _block2__branch2;
          }
          Expr _v_deref__Re (_vt_Re, 0);
          uintptr_t _v_len1 = _v_deref__Re.get_len ();
          uintptr_t _v_len2 = 1;
          if (_v_len1 < _v_len2)
          {
            goto _block2__branch2;
          }
          uintptr_t _v_len___e__e_tmp_m_rfp__clashesrf_m_266_m_18 = (_v_len1 - _v_len2);
          if (!_c_8.term_eq (_v_deref__Re, 0))
          {
            goto _block2__branch2;
          }
          Expr _ve__e__e_tmp_m_rfp__clashesrf_m_266_m_18 (_v_deref__Re, (0 + 1), _v_len___e__e_tmp_m_rfp__clashesrf_m_266_m_18);
          goto _block2;
        }
      _block2__branch2: {}
        if (_vt_Re.symbol_at (0))
        {
          goto _block1__branch1;
        }
        Expr _v_deref__Re2 (_vt_Re, 0);
        uintptr_t _v_len3 = _v_deref__Re2.get_len ();
        uintptr_t _v_len4 = 1;
        if (_v_len3 < _v_len4)
        {
          goto _block1__branch1;
        }
        uintptr_t _v_len___e__e_tmp_m_rfp__clashesrf_m_267_m_21 = (_v_len3 - _v_len4);
        if (!_c_9.term_eq (_v_deref__Re2, 0))
        {
          goto _block1__branch1;
        }
        Expr _ve__e__e_tmp_m_rfp__clashesrf_m_267_m_21 (_v_deref__Re2, (0 + 1), _v_len___e__e_tmp_m_rfp__clashesrf_m_267_m_21);
      }
    _block2: {}
      _v_res1 = _vt_Re;
      _v_res2 = empty;
      goto _block1;
    }
  _block1__branch1: {}
    {
      if (_ge_arg1.get_len () != 1)
      {
        goto _block1__branch2;
      }
      Expr _vt_Re (_ge_arg1, 0, 1);
      if (!RF_CALL (rfp__vars::Var_q_, _vt_Re, /*void*/))
      {
        goto _block1__branch2;
      }
      RF_CALL (Define_m_Vars, _vt_Re, _v_res2);
      _v_res1 = _vt_Re;
      goto _block1;
    }
  _block1__branch2: {}
    Expr _v_Gener_m_Vars1;
    RF_CALL (rfp__vars::Gener_m_Vars, (_c_22, _c_23), _v_Gener_m_Vars1);
    if (_v_Gener_m_Vars1.get_len () != 1)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _vt_var (_v_Gener_m_Vars1, 0, 1);
    RF_CALL (rfp__vars::Set_m_Var, (_c_19, _vt_var), /*void*/);
    Expr _v_Vars_m_Decl1;
    RF_CALL (rfp__vars::Vars_m_Decl, (_c_24, _vt_var), _v_Vars_m_Decl1);
    uintptr_t _v_len5 = _v_Vars_m_Decl1.get_len ();
    uintptr_t _v_len6 = 0;
    if (_v_len5 < _v_len6)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    uintptr_t _v_len___e__e_tmp_m_rfp__clashesrf_m_275_m_31 = (_v_len5 - _v_len6);
    Expr _ve__e__e_tmp_m_rfp__clashesrf_m_275_m_31 (_v_Vars_m_Decl1, 0, _v_len___e__e_tmp_m_rfp__clashesrf_m_275_m_31);
    Expr _ge_auxcall1;
    RF_CALL (rfp__vars::Vars, _ge_arg1, _ge_auxcall1);
    Expr _ge_auxcall2;
    RF_CALL (Define_m_Vars, _ge_auxcall1, _ge_auxcall2);
    Expr _ge_auxcall3;
    RF_CALL (rfp__vars::Vars_m_Print, _vt_var, _ge_auxcall3);
    _v_res1 = _vt_var;
    _v_res2 = (_ge_auxcall2 + (_c_25 + _ge_auxcall3 + _ge_arg1) ());
  }
_block1: {}
RF_END

RF_FUNC (Define_m_Vars, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  {
    {
      uintptr_t _v_len1 = _ge_arg1.get_len ();
      uintptr_t _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__rest = (_v_len1 - _v_len2);
      Expr _vt_var (_ge_arg1, 0, 1);
      Expr _ve_rest (_ge_arg1, (0 + 1), _v_len__rest);
      {
        {
          Expr _v_Get_m_Var1;
          if (!RF_CALL (rfp__vars::Get_m_Var, (_c_6, _vt_var), _v_Get_m_Var1))
          {
            goto _block2__branch1;
          }
          if (_v_Get_m_Var1.get_len () != 1)
          {
            goto _block2__branch1;
          }
          if (!_c_7.term_eq (_v_Get_m_Var1, 0))
          {
            goto _block2__branch1;
          }
          RF_TAILCALL (Define_m_Vars, _ve_rest, _v_res1);
          goto _block2;
        }
      _block2__branch1: {}
        Expr _v__q_1;
        RF_CALL (Box::_q_, Eqs, _v__q_1);
        if (_v__q_1.get_len () < 1)
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        RF_lsplit (_v__q_1, 0, _ve_1, _v_lsplit___q_1);
        for ( ; ; RF_iter(_v__q_1)++)
        {
          {
            if (!RF_iter(_v__q_1))
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            uintptr_t _v_len3 = _v_lsplit___q_1.get_len ();
            uintptr_t _v_len4 = 1;
            if (_v_len3 < _v_len4)
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            uintptr_t _v_len__2 = (_v_len3 - _v_len4);
            if (_v_lsplit___q_1.symbol_at (0))
            {
              goto _continue1;
            }
            Expr _v_deref__lsplit___q_1 (_v_lsplit___q_1, 0);
            if (_v_deref__lsplit___q_1.get_len () != 4)
            {
              goto _continue1;
            }
            if (!_vt_var.term_eq (_v_deref__lsplit___q_1, (0 + 1 + 1)))
            {
              goto _continue1;
            }
            Expr _ve_2 (_v_lsplit___q_1, (0 + 1), _v_len__2);
            Expr _vt_Re (_v_deref__lsplit___q_1, 0, 1);
            Expr _vt_pos (_v_deref__lsplit___q_1, (0 + 1), 1);
            Expr _vt_len (_v_deref__lsplit___q_1, (0 + 1 + 1 + 1), 1);
            RF_CALL (Box::Store, (Eqs, (_ve_1 + _ve_2)), /*void*/);
            Expr _v_Define_m_Vars1;
            RF_CALL (Define_m_Vars, _ve_rest, _v_Define_m_Vars1);
            _v_res1 = ((_vt_Re + _vt_pos + _vt_var + _vt_len) () + _v_Define_m_Vars1);
            goto _exit1;
          }
      _continue1: {}
        }
      _exit1: {}
      }
    _block2: {}
      goto _block1;
    }
  _block1__branch1: {}
    if (_ge_arg1.get_len () != 0)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    _v_res1 = empty;
  }
_block1: {}
RF_END

RF_FUNC (Not_m_Idx, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  {
    if (_ge_arg1.get_len () != 2)
    {
      goto _block1__branch1;
    }
    if (_ge_arg1.symbol_at ((0 + 1)))
    {
      goto _block1__branch1;
    }
    Expr _v_deref__arg1 (_ge_arg1, (0 + 1));
    uintptr_t _v_len1 = _v_deref__arg1.get_len ();
    uintptr_t _v_len2 = 1;
    if (_v_len1 < _v_len2)
    {
      goto _block1__branch1;
    }
    uintptr_t _v_len___e__e_tmp_m_rfp__clashesrf_m_299_m_17 = (_v_len1 - _v_len2);
    if (!_ge_arg1.symbol_at (0))
    {
      goto _block1__branch1;
    }
    Expr _vs_idx (_ge_arg1, 0, 1);
    if (!_vs_idx.term_eq (_v_deref__arg1, 0))
    {
      goto _block1__branch1;
    }
    Expr _ve__e__e_tmp_m_rfp__clashesrf_m_299_m_17 (_v_deref__arg1, (0 + 1), _v_len___e__e_tmp_m_rfp__clashesrf_m_299_m_17);
    RF_RETFAIL;
  }
_block1__branch1: {}
  _v_res1 = empty;
RF_END

RF_FUNC (Compose_m_Source, RF_VOID, (RF_RES _v_res1;;))
  Expr _vs_idx;
  {
    {
      Expr _ge_auxcall1;
      RF_CALL (Box::_q_, Parenth, _ge_auxcall1);
      Expr _v_Find_m_SFD1;
      Expr _v_Find_m_SFD2;
      RF_CALL (Find_m_SFD, _ge_auxcall1, (_v_Find_m_SFD1, _v_Find_m_SFD2));
      uintptr_t _v_len1 = (_v_Find_m_SFD1.get_len () + 1);
      uintptr_t _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__parenth = (_v_len1 - _v_len2);
      Expr _v_compose1 ((_v_Find_m_SFD1 + _v_Find_m_SFD2 ()));
      if (_v_compose1.symbol_at ((0 + _v_len__parenth)))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__compose1 (_v_compose1, (0 + _v_len__parenth));
      if (_v_deref__compose1.get_len () != 1)
      {
        goto _block1__branch1;
      }
      if (!_v_deref__compose1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _ve_parenth (_v_compose1, 0, _v_len__parenth);
      Expr _gs_idx__2 (_v_deref__compose1, 0, 1);
      RF_CALL (Box::Store, (Parenth, _ve_parenth), /*void*/);
      Expr _ge_auxcall2;
      RF_CALL (Box::_q_, Unready_m_Source, _ge_auxcall2);
      Expr _ge_auxcall3;
      RF_CALL (List::Filter, (_c_26, _gs_idx__2, _ge_auxcall2), _ge_auxcall3);
      RF_CALL (Box::Store, (Unready_m_Source, _ge_auxcall3), /*void*/);
      _vs_idx = _gs_idx__2;
      goto _block1;
    }
  _block1__branch1: {}
    Expr _v__q_1;
    RF_CALL (Box::_q_, Unready_m_Source, _v__q_1);
    if (_v__q_1.get_len () < 1)
    {
      RF_RETFAIL;
    }
    RF_lsplit (_v__q_1, 0, _ve_l, _v_lsplit___q_1);
    for ( ; ; RF_iter(_v__q_1)++)
    {
      {
        if (!RF_iter(_v__q_1))
        {
          RF_RETFAIL;
        }
        uintptr_t _v_len3 = _v_lsplit___q_1.get_len ();
        uintptr_t _v_len4 = 1;
        if (_v_len3 < _v_len4)
        {
          RF_RETFAIL;
        }
        uintptr_t _v_len__r = (_v_len3 - _v_len4);
        if (_v_lsplit___q_1.symbol_at (0))
        {
          goto _continue1;
        }
        Expr _v_deref__lsplit___q_1 (_v_lsplit___q_1, 0);
        uintptr_t _v_len5 = _v_deref__lsplit___q_1.get_len ();
        uintptr_t _v_len6 = 1;
        if (_v_len5 < _v_len6)
        {
          goto _continue1;
        }
        uintptr_t _v_len__vars = (_v_len5 - _v_len6);
        if (!_v_deref__lsplit___q_1.symbol_at (0))
        {
          goto _continue1;
        }
        Expr _ve_r (_v_lsplit___q_1, (0 + 1), _v_len__r);
        Expr _gs_idx__2 (_v_deref__lsplit___q_1, 0, 1);
        Expr _ve_vars (_v_deref__lsplit___q_1, (0 + 1), _v_len__vars);
        Expr _v_Filter1;
        RF_CALL (List::Filter, (_c_27, empty, _ve_vars), _v_Filter1);
        if (_v_Filter1.get_len () != 0)
        {
          goto _continue1;
        }
        RF_CALL (Box::Store, (Unready_m_Source, (_ve_l + _ve_r)), /*void*/);
        Expr _ge_auxcall4;
        RF_CALL (Box::_q_, Parenth, _ge_auxcall4);
        Expr _ge_auxcall5;
        RF_CALL (List::Filter, (_c_26, _gs_idx__2, _ge_auxcall4), _ge_auxcall5);
        RF_CALL (Box::Store, (Parenth, _ge_auxcall5), /*void*/);
        _vs_idx = _gs_idx__2;
        goto _exit1;
      }
  _continue1: {}
    }
  _exit1: {}
  }
_block1: {}
  Expr _v__q_2;
  RF_CALL (Box::_q_, Clashes, _v__q_2);
  if (_v__q_2.get_len () < 1)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  RF_lsplit (_v__q_2, 0, _ve_1, _v_lsplit___q_2);
  for ( ; ; RF_iter(_v__q_2)++)
  {
    {
      if (!RF_iter(_v__q_2))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      uintptr_t _v_len7 = _v_lsplit___q_2.get_len ();
      uintptr_t _v_len8 = 1;
      if (_v_len7 < _v_len8)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      uintptr_t _v_len__2 = (_v_len7 - _v_len8);
      if (_v_lsplit___q_2.symbol_at (0))
      {
        goto _continue2;
      }
      Expr _v_deref__lsplit___q_2 (_v_lsplit___q_2, 0);
      uintptr_t _v_len9 = _v_deref__lsplit___q_2.get_len ();
      uintptr_t _v_len10 = 3;
      if (_v_len9 < _v_len10)
      {
        goto _continue2;
      }
      uintptr_t _v_len__boxes = (_v_len9 - _v_len10);
      if (_v_deref__lsplit___q_2.symbol_at ((0 + 1)))
      {
        goto _continue2;
      }
      if (_v_deref__lsplit___q_2.symbol_at ((0 + 1 + 1)))
      {
        goto _continue2;
      }
      Expr _v_deref__deref__lsplit___q_2 (_v_deref__lsplit___q_2, (0 + 1));
      Expr _v_deref__deref__lsplit___q_22 (_v_deref__lsplit___q_2, (0 + 1 + 1));
      uintptr_t _v_len11 = _v_deref__deref__lsplit___q_22.get_len ();
      uintptr_t _v_len12 = 1;
      if (_v_len11 < _v_len12)
      {
        goto _continue2;
      }
      uintptr_t _v_len__Pe = (_v_len11 - _v_len12);
      uintptr_t _v_len13 = _v_deref__deref__lsplit___q_2.get_len ();
      uintptr_t _v_len14 = 0;
      if (_v_len13 < _v_len14)
      {
        goto _continue2;
      }
      uintptr_t _v_len__Re = (_v_len13 - _v_len14);
      if (!_vs_idx.term_eq (_v_deref__lsplit___q_2, 0))
      {
        goto _continue2;
      }
      if (!_v_deref__deref__lsplit___q_22.symbol_at (0))
      {
        goto _continue2;
      }
      Expr _ve_2 (_v_lsplit___q_2, (0 + 1), _v_len__2);
      Expr _ve_boxes (_v_deref__lsplit___q_2, (0 + 1 + 1 + 1), _v_len__boxes);
      Expr _ve_Re (_v_deref__deref__lsplit___q_2, 0, _v_len__Re);
      Expr _vs_dir (_v_deref__deref__lsplit___q_22, 0, 1);
      Expr _ve_Pe (_v_deref__deref__lsplit___q_22, (0 + 1), _v_len__Pe);
      Expr _vt_var;
      Expr _ve_assign;
      RF_CALL (Prepare_m_Source, _ve_Re, (_vt_var, _ve_assign));
      RF_CALL (Box::Store, (Clashes, (_ve_1 + (_vs_idx + _vt_var () + (_vs_dir + _ve_Pe) () + _ve_boxes) () + _ve_2)), /*void*/);
      _v_res1 = _ve_assign;
      goto _exit2;
    }
_continue2: {}
  }
_exit2: {}
RF_END

RF_FUNC (Find_m_SFD, (RF_ARG _ge_arg1;;), (RF_RES _v_res1, _v_res2;;))
  {
    {
      uintptr_t _v_len1 = _ge_arg1.get_len ();
      uintptr_t _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__rest = (_v_len1 - _v_len2);
      if (_ge_arg1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__arg1 (_ge_arg1, 0);
      uintptr_t _v_len3 = _v_deref__arg1.get_len ();
      uintptr_t _v_len4 = 2;
      if (_v_len3 < _v_len4)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__Pe_m_vars = (_v_len3 - _v_len4);
      if (_v_deref__arg1.symbol_at ((0 + 1)))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__deref__arg1 (_v_deref__arg1, (0 + 1));
      uintptr_t _v_len5 = _v_deref__deref__arg1.get_len ();
      uintptr_t _v_len6 = 0;
      if (_v_len5 < _v_len6)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__Re_m_vars = (_v_len5 - _v_len6);
      if (!_v_deref__arg1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _ve_rest (_ge_arg1, (0 + 1), _v_len__rest);
      Expr _vs_idx (_v_deref__arg1, 0, 1);
      Expr _ve_Pe_m_vars (_v_deref__arg1, (0 + 1 + 1), _v_len__Pe_m_vars);
      Expr _ve_Re_m_vars (_v_deref__deref__arg1, 0, _v_len__Re_m_vars);
      Expr _v_Filter1;
      RF_CALL (List::Filter, (_c_27, empty, _ve_Re_m_vars), _v_Filter1);
      {
        {
          uintptr_t _v_len7 = _v_Filter1.get_len ();
          uintptr_t _v_len8 = 0;
          if (_v_len7 < (_v_len8 + 1))
          {
            goto _block2__branch1;
          }
          uintptr_t _v_len__r_m_vars = (_v_len7 - _v_len8);
          Expr _vv_r_m_vars (_v_Filter1, 0, _v_len__r_m_vars);
          Expr _v_Find_m_SFD1;
          RF_CALL (Find_m_SFD, _ve_rest, (_v_Find_m_SFD1, _v_res2));
          _v_res1 = ((_vs_idx + _vv_r_m_vars () + _ve_Pe_m_vars) () + _v_Find_m_SFD1);
          goto _block2;
        }
      _block2__branch1: {}
        if (_v_Filter1.get_len () != 0)
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        Expr _v_Get_m_Known_m_Length1;
        Expr _v_Get_m_Known_m_Length2;
        RF_CALL (Get_m_Known_m_Length, _ve_Pe_m_vars, (_v_Get_m_Known_m_Length1, _v_Get_m_Known_m_Length2));
        {
          {
            uintptr_t _v_len9 = (_v_Get_m_Known_m_Length1.get_len () + 1);
            uintptr_t _v_len10 = 1;
            if (_v_len9 < _v_len10)
            {
              goto _block3__branch1;
            }
            uintptr_t _v_len___e__e_tmp_m_rfp__clashesrf_m_326_m_10 = (_v_len9 - _v_len10);
            Expr _v_compose1 ((_v_Get_m_Known_m_Length1 + _v_Get_m_Known_m_Length2 ()));
            if (_v_compose1.symbol_at ((0 + _v_len___e__e_tmp_m_rfp__clashesrf_m_326_m_10)))
            {
              goto _block3__branch1;
            }
            Expr _v_deref__compose1 (_v_compose1, (0 + _v_len___e__e_tmp_m_rfp__clashesrf_m_326_m_10));
            uintptr_t _v_len11 = _v_deref__compose1.get_len ();
            uintptr_t _v_len12 = 0;
            if (_v_len11 < (_v_len12 + 1))
            {
              goto _block3__branch1;
            }
            uintptr_t _v_len__p_m_vars = (_v_len11 - _v_len12);
            Expr _ve__e__e_tmp_m_rfp__clashesrf_m_326_m_10 (_v_compose1, 0, _v_len___e__e_tmp_m_rfp__clashesrf_m_326_m_10);
            Expr _vv_p_m_vars (_v_deref__compose1, 0, _v_len__p_m_vars);
            Expr _v_Find_m_SFD2;
            RF_CALL (Find_m_SFD, _ve_rest, (_v_Find_m_SFD2, _v_res2));
            _v_res1 = ((_vs_idx + _c_16 + _vv_p_m_vars) () + _v_Find_m_SFD2);
            goto _block3;
          }
        _block3__branch1: {}
          uintptr_t _v_len13 = (_v_Get_m_Known_m_Length1.get_len () + 1);
          uintptr_t _v_len14 = 1;
          if (_v_len13 < _v_len14)
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          uintptr_t _v_len___e__e_tmp_m_rfp__clashesrf_m_327_m_10 = (_v_len13 - _v_len14);
          Expr _v_compose2 ((_v_Get_m_Known_m_Length1 + _v_Get_m_Known_m_Length2 ()));
          if (!_c_16.term_eq (_v_compose2, (0 + _v_len___e__e_tmp_m_rfp__clashesrf_m_327_m_10)))
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          Expr _ve__e__e_tmp_m_rfp__clashesrf_m_327_m_10 (_v_compose2, 0, _v_len___e__e_tmp_m_rfp__clashesrf_m_327_m_10);
          Expr _ge_auxcall1;
          RF_CALL (List::Filter, (_c_26, _vs_idx, _ve_rest), _ge_auxcall1);
          _v_res1 = _ge_auxcall1;
          _v_res2 = _vs_idx;
        }
      _block3: {}
      }
    _block2: {}
      goto _block1;
    }
  _block1__branch1: {}
    if (_ge_arg1.get_len () != 0)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    _v_res1 = empty;
    _v_res2 = empty;
  }
_block1: {}
RF_END

RF_FUNC (Not_m_Instantiated_m_Var, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  if (_ge_arg1.get_len () != 1)
  {
    RF_RETFAIL;
  }
  Expr _vt_var (_ge_arg1, 0, 1);
  {
    {
      {
        Expr _v_Get_m_Var1;
        if (!RF_CALL (rfp__vars::Get_m_Var, (_c_6, _vt_var), _v_Get_m_Var1))
        {
          goto _block1__branch1;
        }
        if (_v_Get_m_Var1.get_len () != 1)
        {
          goto _block1__branch1;
        }
        if (!_c_7.term_eq (_v_Get_m_Var1, 0))
        {
          goto _block1__branch1;
        }
        goto _block1;
      }
    _block1__branch1: {}
      Expr _v__q_1;
      RF_CALL (Box::_q_, Eqs, _v__q_1);
      if (_v__q_1.get_len () < 1)
      {
        goto _negation1;
      }
      RF_lsplit (_v__q_1, 0, _ve__e__e_tmp_m_rfp__clashesrf_m_335_m_15, _v_lsplit___q_1);
      for ( ; ; RF_iter(_v__q_1)++)
      {
        {
          if (!RF_iter(_v__q_1))
          {
            goto _negation1;
          }
          uintptr_t _v_len1 = _v_lsplit___q_1.get_len ();
          uintptr_t _v_len2 = 1;
          if (_v_len1 < _v_len2)
          {
            goto _negation1;
          }
          uintptr_t _v_len___e__e_tmp_m_rfp__clashesrf_m_335_m_31 = (_v_len1 - _v_len2);
          if (_v_lsplit___q_1.symbol_at (0))
          {
            goto _continue1;
          }
          Expr _v_deref__lsplit___q_1 (_v_lsplit___q_1, 0);
          if (_v_deref__lsplit___q_1.get_len () != 4)
          {
            goto _continue1;
          }
          if (!_vt_var.term_eq (_v_deref__lsplit___q_1, (0 + 1 + 1)))
          {
            goto _continue1;
          }
          Expr _ve__e__e_tmp_m_rfp__clashesrf_m_335_m_31 (_v_lsplit___q_1, (0 + 1), _v_len___e__e_tmp_m_rfp__clashesrf_m_335_m_31);
          Expr _vt__e__e_tmp_m_rfp__clashesrf_m_335_m_18 (_v_deref__lsplit___q_1, 0, 1);
          Expr _vt__e__e_tmp_m_rfp__clashesrf_m_335_m_20 (_v_deref__lsplit___q_1, (0 + 1), 1);
          Expr _vt__e__e_tmp_m_rfp__clashesrf_m_335_m_28 (_v_deref__lsplit___q_1, (0 + 1 + 1 + 1), 1);
          goto _exit1;
        }
    _continue1: {}
      }
    _exit1: {}
    }
  _block1: {}
    RF_RETFAIL;
  }
_negation1: {}
  _v_res1 = empty;
RF_END

RF_FUNC (Get_m_Cycle, RF_VOID, (RF_RES _v_res1, _v_res2, _v_res3, _v_res4, _v_res5, _v_res6, _v_res7;;))
  Expr _v__q_1;
  RF_CALL (Box::_q_, Clashes, _v__q_1);
  if (_v__q_1.get_len () < 1)
  {
    RF_RETFAIL;
  }
  RF_lsplit (_v__q_1, 0, _ve__e__e_tmp_m_rfp__clashesrf_m_341_m_19, _v_lsplit___q_1);
  for ( ; ; RF_iter(_v__q_1)++)
  {
    {
      if (!RF_iter(_v__q_1))
      {
        RF_RETFAIL;
      }
      uintptr_t _v_len1 = _v_lsplit___q_1.get_len ();
      uintptr_t _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        RF_RETFAIL;
      }
      uintptr_t _v_len__rest = (_v_len1 - _v_len2);
      if (_v_lsplit___q_1.symbol_at (0))
      {
        goto _continue1;
      }
      Expr _v_deref__lsplit___q_1 (_v_lsplit___q_1, 0);
      if (_v_deref__lsplit___q_1.get_len () < 4)
      {
        goto _continue1;
      }
      if (_v_deref__lsplit___q_1.symbol_at ((0 + 1)))
      {
        goto _continue1;
      }
      if (_v_deref__lsplit___q_1.symbol_at ((0 + 1 + 1)))
      {
        goto _continue1;
      }
      Expr _v_deref__deref__lsplit___q_1 (_v_deref__lsplit___q_1, (0 + 1));
      Expr _v_deref__deref__lsplit___q_12 (_v_deref__lsplit___q_1, (0 + 1 + 1));
      if (_v_deref__deref__lsplit___q_1.get_len () != 1)
      {
        goto _continue1;
      }
      uintptr_t _v_len3 = _v_deref__deref__lsplit___q_12.get_len ();
      uintptr_t _v_len4 = 1;
      if (_v_len3 < _v_len4)
      {
        goto _continue1;
      }
      uintptr_t _v_len__Pe = (_v_len3 - _v_len4);
      if (!_v_deref__lsplit___q_1.symbol_at (0))
      {
        goto _continue1;
      }
      if (!_v_deref__deref__lsplit___q_12.symbol_at (0))
      {
        goto _continue1;
      }
      Expr _ve_rest (_v_lsplit___q_1, (0 + 1), _v_len__rest);
      Expr _vs_idx (_v_deref__lsplit___q_1, 0, 1);
      Expr _vt_var (_v_deref__deref__lsplit___q_1, 0, 1);
      Expr _vs_dir (_v_deref__deref__lsplit___q_12, 0, 1);
      Expr _ve_Pe (_v_deref__deref__lsplit___q_12, (0 + 1), _v_len__Pe);
      Expr _v_subexpr__deref__lsplit___q_1 (_v_deref__lsplit___q_1, (0 + 1 + 1 + 1), (_v_deref__lsplit___q_1.get_len () - (0 + 1 + 1 + 1 + 0)));
      RF_lsplit (_v_subexpr__deref__lsplit___q_1, 0, _ve_b1, _v_lsplit__deref__lsplit___q_1);
      for ( ; ; RF_iter(_v_subexpr__deref__lsplit___q_1)++)
      {
        {
          if (!RF_iter(_v_subexpr__deref__lsplit___q_1))
          {
            goto _continue1;
          }
          uintptr_t _v_len5 = _v_lsplit__deref__lsplit___q_1.get_len ();
          uintptr_t _v_len6 = 1;
          if (_v_len5 < _v_len6)
          {
            goto _continue1;
          }
          uintptr_t _v_len__b2 = (_v_len5 - _v_len6);
          if (!Unknown_m_Lengths.term_eq (_v_lsplit__deref__lsplit___q_1, 0))
          {
            goto _continue2;
          }
          Expr _ve_b2 (_v_lsplit__deref__lsplit___q_1, (0 + 1), _v_len__b2);
          Expr _v_Get_m_Known_m_Length1;
          Expr _v_Get_m_Known_m_Length2;
          RF_CALL (Get_m_Known_m_Length, _vt_var, (_v_Get_m_Known_m_Length1, _v_Get_m_Known_m_Length2));
          uintptr_t _v_len7 = (_v_Get_m_Known_m_Length1.get_len () + 1);
          uintptr_t _v_len8 = 1;
          if (_v_len7 < _v_len8)
          {
            RF_RETFAIL;
          }
          uintptr_t _v_len__len = (_v_len7 - _v_len8);
          Expr _v_compose1 ((_v_Get_m_Known_m_Length1 + _v_Get_m_Known_m_Length2 ()));
          if (!_c_16.term_eq (_v_compose1, (0 + _v_len__len)))
          {
            RF_RETFAIL;
          }
          Expr _ve_len (_v_compose1, 0, _v_len__len);
          Expr _v_Lookup1;
          if (!RF_CALL (Table::Lookup, (Hard_m_Parts, _vs_idx), _v_Lookup1))
          {
            RF_RETFAIL;
          }
          uintptr_t _v_len9 = _v_Lookup1.get_len ();
          uintptr_t _v_len10 = 2;
          if (_v_len9 < _v_len10)
          {
            RF_RETFAIL;
          }
          uintptr_t _v_len__expr = (_v_len9 - _v_len10);
          if (_v_Lookup1.symbol_at (0))
          {
            RF_RETFAIL;
          }
          if (_v_Lookup1.symbol_at ((0 + 1)))
          {
            RF_RETFAIL;
          }
          Expr _v_deref__Lookup1 (_v_Lookup1, 0);
          Expr _v_deref__Lookup12 (_v_Lookup1, (0 + 1));
          uintptr_t _v_len11 = _v_deref__Lookup12.get_len ();
          uintptr_t _v_len12 = 0;
          if (_v_len11 < _v_len12)
          {
            RF_RETFAIL;
          }
          uintptr_t _v_len__right = (_v_len11 - _v_len12);
          uintptr_t _v_len13 = _v_deref__Lookup1.get_len ();
          uintptr_t _v_len14 = 0;
          if (_v_len13 < _v_len14)
          {
            RF_RETFAIL;
          }
          uintptr_t _v_len__left = (_v_len13 - _v_len14);
          Expr _ve_expr (_v_Lookup1, (0 + 1 + 1), _v_len__expr);
          Expr _ve_left (_v_deref__Lookup1, 0, _v_len__left);
          Expr _ve_right (_v_deref__Lookup12, 0, _v_len__right);
          Expr _vs_split;
          Expr _vt_var_m_e1;
          Expr _vs_pref_m_e2;
          Expr _ve_Pe_m_rest;
          {
            {
              if (!_vs_dir.term_eq (_c_12, 0))
              {
                goto _block1__branch1;
              }
              uintptr_t _v_len15 = _v_len__expr;
              uintptr_t _v_len16 = 1;
              if (_v_len15 < _v_len16)
              {
                RF_RETFAIL;
              }
              uintptr_t _v_len__Pe_m_rest__2 = (_v_len15 - _v_len16);
              Expr _gt_var_m_e1__2 (_ve_expr, 0, 1);
              Expr _ge_Pe_m_rest__2 (_ve_expr, (0 + 1), _v_len__Pe_m_rest__2);
              _vs_split = _c_28;
              _vt_var_m_e1 = _gt_var_m_e1__2;
              _vs_pref_m_e2 = _c_29;
              _ve_Pe_m_rest = _ge_Pe_m_rest__2;
              goto _block1;
            }
          _block1__branch1: {}
            if (!_vs_dir.term_eq (_c_14, 0))
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            uintptr_t _v_len17 = _v_len__expr;
            uintptr_t _v_len18 = 1;
            if (_v_len17 < _v_len18)
            {
              RF_RETFAIL;
            }
            uintptr_t _v_len__Pe_m_rest__22 = (_v_len17 - _v_len18);
            Expr _ge_Pe_m_rest__2 (_ve_expr, 0, _v_len__Pe_m_rest__22);
            Expr _gt_var_m_e1__2 (_ve_expr, (0 + _v_len__Pe_m_rest__22), 1);
            _vs_split = _c_30;
            _vt_var_m_e1 = _gt_var_m_e1__2;
            _vs_pref_m_e2 = _c_31;
            _ve_Pe_m_rest = _ge_Pe_m_rest__2;
          }
        _block1: {}
          Expr _ge_auxalt2;
          Expr _ge_auxalt3;
          Expr _gs_auxalt4;
          Expr _ge_auxalt5;
          {
            {
              if (!RF_CALL (rfp__vars::Var_q_, _ve_Pe_m_rest, /*void*/))
              {
                goto _block2__branch1;
              }
              Expr _gt_auxcall1;
              RF_CALL (rfp__vars::Gener_m_Len_m_Var, _ve_Pe_m_rest, _gt_auxcall1);
              RF_CALL (rfp__vars::Vars_m_Reset, _ve_Pe_m_rest, /*void*/);
              _ge_auxalt2 = _ve_Pe_m_rest;
              _ge_auxalt3 = _ve_Pe_m_rest;
              _gs_auxalt4 = _vs_dir;
              _ge_auxalt5 = _gt_auxcall1;
              goto _block2;
            }
          _block2__branch1: {}
            Expr _v_Gener_m_Vars1;
            RF_CALL (rfp__vars::Gener_m_Vars, (_c_17, (_vs_pref_m_e2 + _vt_var)), _v_Gener_m_Vars1);
            if (_v_Gener_m_Vars1.get_len () != 1)
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            Expr _vt_var_m_e2 (_v_Gener_m_Vars1, 0, 1);
            _ge_auxalt2 = _vt_var_m_e2;
            _ge_auxalt3 = _vt_var_m_e2;
            _gs_auxalt4 = _vs_dir;
            _ge_auxalt5 = _ve_Pe_m_rest;
          }
        _block2: {}
          if ((_ge_auxalt2.get_len () + 1) != 2)
          {
            RF_RETFAIL;
          }
          Expr _v_compose2 ((_ge_auxalt2 + (_ge_auxalt3 () + (_gs_auxalt4 + _ge_auxalt5) ()) ()));
          if (_v_compose2.symbol_at ((0 + 1)))
          {
            RF_RETFAIL;
          }
          Expr _v_deref__compose2 (_v_compose2, (0 + 1));
          uintptr_t _v_len19 = _v_deref__compose2.get_len ();
          uintptr_t _v_len20 = 0;
          if (_v_len19 < _v_len20)
          {
            RF_RETFAIL;
          }
          uintptr_t _v_len__clash = (_v_len19 - _v_len20);
          Expr _vt_var_m_e2 (_v_compose2, 0, 1);
          Expr _ve_clash (_v_deref__compose2, 0, _v_len__clash);
          RF_CALL (rfp__vars::Set_m_Var, (_c_19, _vt_var_m_e1), /*void*/);
          RF_CALL (rfp__vars::Set_m_Var, (_c_19, _vt_var_m_e2), /*void*/);
          Expr _ge_auxcall6;
          RF_CALL (Compose_m_Clashes, _ve_clash, _ge_auxcall6);
          RF_CALL (Box::Store, (Clashes, (_ge_auxcall6 + _ve_rest)), /*void*/);
          Expr _ve_clashes;
          if (!RF_CALL (rfp__vars::Get_m_Var, (_c_0, _vt_var_m_e1), _ve_clashes))
          {
            RF_RETFAIL;
          }
          Expr _ge_auxcall7;
          RF_CALL (Box::_q_, Checked_m_Lengths, _ge_auxcall7);
          Expr _ge_auxcall8;
          RF_CALL (List::Sub, (_ve_clashes, _ge_auxcall7), _ge_auxcall8);
          Expr _v_Map1;
          if (!RF_CALL (List::Map, (_c_32, empty, _ge_auxcall8), _v_Map1))
          {
            RF_RETFAIL;
          }
          uintptr_t _v_len21 = _v_Map1.get_len ();
          uintptr_t _v_len22 = 0;
          if (_v_len21 < _v_len22)
          {
            RF_RETFAIL;
          }
          uintptr_t _v_len___e__e_tmp_m_rfp__clashesrf_m_363_m_71 = (_v_len21 - _v_len22);
          Expr _ve__e__e_tmp_m_rfp__clashesrf_m_363_m_71 (_v_Map1, 0, _v_len___e__e_tmp_m_rfp__clashesrf_m_363_m_71);
          _v_res1 = _vs_split;
          _v_res2 = _ve_left;
          _v_res3 = _ve_right;
          _v_res4 = _ve_len;
          _v_res5 = _vt_var;
          _v_res6 = _vt_var_m_e1;
          _v_res7 = _vt_var_m_e2;
          goto _exit2;
        }
    _continue2: {}
      }
    _exit2: {}
      goto _exit1;
    }
_continue1: {}
  }
_exit1: {}
RF_END

RF_FUNC (Get_m_Known_m_Length, (RF_ARG _ve_Re;;), (RF_RES _v_res1, _v_res2;;))
  Expr _ge_Re__0 (_ve_Re);
  Expr _ve_length (empty);
  Expr _ve_unknown_m_vars (empty);
  for ( ; ; )
  {
    {
      if (_ge_Re__0.get_len () != 0)
      {
        goto _iter1;
      }
      {
        {
          if (_ve_length.get_len () != 0)
          {
            goto _block1__branch1;
          }
          _v_res1 = _c_1;
          _v_res2 = _ve_unknown_m_vars;
          goto _block1;
        }
      _block1__branch1: {}
        _v_res1 = _ve_length;
        _v_res2 = _ve_unknown_m_vars;
      }
    _block1: {}
      goto _exit__iter1;
    }
  _iter1: {}
    uintptr_t _v_len1 = _ge_Re__0.get_len ();
    uintptr_t _v_len2 = 1;
    if (_v_len1 < _v_len2)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    uintptr_t _v_len__rest = (_v_len1 - _v_len2);
    Expr _vt_Rt (_ge_Re__0, 0, 1);
    Expr _ve_rest (_ge_Re__0, (0 + 1), _v_len__rest);
    Expr _ve_len;
    Expr _ve_var;
    {
      {
        if (!_vt_Rt.symbol_at (0))
        {
          goto _block3__branch1;
        }
        Expr _vs_ObjectSymbol (_vt_Rt, 0, 1);
        _ve_len = _c_5;
        _ve_var = empty;
        goto _block3;
      }
    _block3__branch1: {}
      {
        if (_vt_Rt.symbol_at (0))
        {
          goto _block3__branch2;
        }
        Expr _v_deref__Rt (_vt_Rt, 0);
        uintptr_t _v_len3 = _v_deref__Rt.get_len ();
        uintptr_t _v_len4 = 1;
        if (_v_len3 < _v_len4)
        {
          goto _block3__branch2;
        }
        uintptr_t _v_len___e__e_tmp_m_rfp__clashesrf_m_382_m_15 = (_v_len3 - _v_len4);
        if (!_c_10.term_eq (_v_deref__Rt, 0))
        {
          goto _block3__branch2;
        }
        Expr _ve__e__e_tmp_m_rfp__clashesrf_m_382_m_15 (_v_deref__Rt, (0 + 1), _v_len___e__e_tmp_m_rfp__clashesrf_m_382_m_15);
        _ve_len = _c_5;
        _ve_var = empty;
        goto _block3;
      }
    _block3__branch2: {}
      {
        if (_vt_Rt.symbol_at (0))
        {
          goto _block3__branch3;
        }
        Expr _v_deref__Rt2 (_vt_Rt, 0);
        uintptr_t _v_len5 = _v_deref__Rt2.get_len ();
        uintptr_t _v_len6 = 1;
        if (_v_len5 < _v_len6)
        {
          goto _block3__branch3;
        }
        uintptr_t _v_len___e__e_tmp_m_rfp__clashesrf_m_383_m_14 = (_v_len5 - _v_len6);
        if (!_c_33.term_eq (_v_deref__Rt2, 0))
        {
          goto _block3__branch3;
        }
        Expr _ve__e__e_tmp_m_rfp__clashesrf_m_383_m_14 (_v_deref__Rt2, (0 + 1), _v_len___e__e_tmp_m_rfp__clashesrf_m_383_m_14);
        _ve_len = _c_5;
        _ve_var = empty;
        goto _block3;
      }
    _block3__branch3: {}
      {
        if (_vt_Rt.symbol_at (0))
        {
          goto _block3__branch4;
        }
        Expr _v_deref__Rt3 (_vt_Rt, 0);
        if (_v_deref__Rt3.get_len () != 2)
        {
          goto _block3__branch4;
        }
        if (!_c_8.term_eq (_v_deref__Rt3, 0))
        {
          goto _block3__branch4;
        }
        Expr _vt_name (_v_deref__Rt3, (0 + 1), 1);
        Expr _ge_auxcall1;
        RF_CALL (Ref_m_Len, _vt_name, _ge_auxcall1);
        _ve_len = _ge_auxcall1;
        _ve_var = empty;
        goto _block3;
      }
    _block3__branch4: {}
      {
        if (_vt_Rt.symbol_at (0))
        {
          goto _block3__branch5;
        }
        Expr _v_deref__Rt4 (_vt_Rt, 0);
        if (_v_deref__Rt4.get_len () != 2)
        {
          goto _block3__branch5;
        }
        if (!_c_9.term_eq (_v_deref__Rt4, 0))
        {
          goto _block3__branch5;
        }
        Expr _vt_name (_v_deref__Rt4, (0 + 1), 1);
        Expr _ge_auxcall2;
        RF_CALL (rfp__const::Get_m_Static, _vt_Rt, _ge_auxcall2);
        RF_CALL (Get_m_Known_m_Length, _ge_auxcall2, (_ve_len, _ve_var));
        goto _block3;
      }
    _block3__branch5: {}
      Expr _vt__e__e_tmp_m_rfp__clashesrf_m_386_m_8 (_vt_Rt, 0, 1);
      if (!RF_CALL (rfp__vars::Var_q_, _vt_Rt, /*void*/))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      {
        {
          Expr _v_Get_m_Var1;
          if (!RF_CALL (rfp__vars::Get_m_Var, (_c_34, _vt_Rt), _v_Get_m_Var1))
          {
            goto _block4__branch1;
          }
          uintptr_t _v_len7 = _v_Get_m_Var1.get_len ();
          uintptr_t _v_len8 = 0;
          if (_v_len7 < (_v_len8 + 1))
          {
            goto _block4__branch1;
          }
          uintptr_t _v_len__len__6 = (_v_len7 - _v_len8);
          Expr _gv_len__6 (_v_Get_m_Var1, 0, _v_len__len__6);
          _ve_len = _gv_len__6;
          _ve_var = empty;
          goto _block4;
        }
      _block4__branch1: {}
        _ve_len = empty;
        _ve_var = _vt_Rt;
      }
    _block4: {}
    }
  _block3: {}
    _ge_Re__0 = _ve_rest;
    _ve_length = (_ve_length + _ve_len);
    _ve_unknown_m_vars = (_ve_unknown_m_vars + _ve_var);
  }
_exit__iter1: {}
RF_END

RF_FUNC (Ref_m_Len, (RF_ARG _vt_name;;), (RF_RES _v_res1;;))
  {
    {
      if (!RF_CALL (Table::Lookup, (Const_m_Len, _vt_name), _v_res1))
      {
        goto _block1__branch1;
      }
      goto _block1;
    }
  _block1__branch1: {}
    {
      Expr _ge_auxcall1;
      if (!RF_CALL (Table::Lookup, (rfp__compile::Const, _vt_name), _ge_auxcall1))
      {
        goto _block1__branch2;
      }
      Expr _ge_auxcall2;
      if (!RF_CALL (Access::Middle, (_c_35, _c_1, _ge_auxcall1), _ge_auxcall2))
      {
        goto _block1__branch2;
      }
      Expr _ve_len;
      Expr _v_Get_m_Known_m_Length1;
      RF_CALL (Get_m_Known_m_Length, _ge_auxcall2, (_ve_len, _v_Get_m_Known_m_Length1));
      Expr _vt__e__e_tmp_m_rfp__clashesrf_m_403_m_68 (_v_Get_m_Known_m_Length1 ());
      RF_CALL (Table::Bind, (Const_m_Len, _vt_name, _ve_len), /*void*/);
      _v_res1 = _ve_len;
      goto _block1;
    }
  _block1__branch2: {}
    _v_res1 = _c_5;
  }
_block1: {}
RF_END

RF_FUNC (R__0, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  uintptr_t _v_len1 = _ge_arg1.get_len ();
  uintptr_t _v_len2 = 1;
  if (_v_len1 < _v_len2)
  {
    RF_ERROR (_c_36);
  }
  uintptr_t _v_len__stub1 = (_v_len1 - _v_len2);
  if (!_ge_arg1.symbol_at (0))
  {
    RF_ERROR (_c_36);
  }
  Expr _v_stub2 (_ge_arg1, 0, 1);
  Expr _v_stub1 (_ge_arg1, (0 + 1), _v_len__stub1);
  if (!RF_CALL (Access::R, (_v_stub2, _v_stub1), _v_res1))
  {
    RF_RETFAIL;
  }
RF_END

RF_FUNC (L__0, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  uintptr_t _v_len1 = _ge_arg1.get_len ();
  uintptr_t _v_len2 = 1;
  if (_v_len1 < _v_len2)
  {
    RF_ERROR (_c_36);
  }
  uintptr_t _v_len__stub1 = (_v_len1 - _v_len2);
  if (!_ge_arg1.symbol_at (0))
  {
    RF_ERROR (_c_36);
  }
  Expr _v_stub2 (_ge_arg1, 0, 1);
  Expr _v_stub1 (_ge_arg1, (0 + 1), _v_len__stub1);
  if (!RF_CALL (Access::L, (_v_stub2, _v_stub1), _v_res1))
  {
    RF_RETFAIL;
  }
RF_END

}

namespace rfp__clashes
{

static void init_ ()
{
  Known_m_Lengths = new rftype::StaticObject<rftype::Table>(L"Known-Lengths");
  Compute_m_Length = new rftype::StaticObject<rftype::Table>(L"Compute-Length");
  Unknown_m_Lengths = new rftype::StaticObject<rftype::Table>(L"Unknown-Lengths");
  Checked_m_Lengths = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Checked-Lengths");
  Eqs = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Eqs");
  Clashes = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Clashes");
  Hard_m_Parts = new rftype::StaticObject<rftype::Table>(L"Hard-Parts");
  Parenth = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Parenth");
  Unready_m_Source = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Unready-Source");
  FreeIdx = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"FreeIdx");
  Const_m_Len = new rftype::StaticObject<rftype::Table>(L"Const-Len");
  _c_0 = Expr::create<rftype::Word>("Clashes");
  _c_1 = Expr::create<rftype::Integer>("0");
  _c_2 = Expr::create<rftype::Integer>("-1");
  _c_3 = Expr::create_sym<rftype::Func> (Add_m_Clash_m_To_m_Var);
  _c_4 = Compute_m_Length + Unknown_m_Lengths;
  _c_5 = Expr::create<rftype::Integer>("1");
  _c_37 = Expr::create<rftype::Word>("Instantiated?") + Expr::create<rftype::Word>("True");
  _c_6 = Expr (_c_37, 0, 1);
  _c_7 = Expr (_c_37, 1, 1);
  _c_8 = Expr::create<rftype::Word>("REF");
  _c_9 = Expr::create<rftype::Word>("STATIC");
  _c_10 = Expr::create<rftype::Word>("PAREN");
  _c_11 = (_c_1) () + (_c_1) ();
  _c_12 = Expr::create<rftype::Word>("LEFT");
  _c_13 = Expr::create_sym<rftype::Func> (L__0);
  _c_14 = Expr::create<rftype::Word>("RIGHT");
  _c_15 = Expr::create_sym<rftype::Func> (R__0);
  _c_16 = (empty) ();
  _c_17 = (Expr::create<rftype::Word>("VAR")) ();
  _c_18 = Expr::create<rftype::Word>("deref_");
  _c_19 = (_c_37) ();
  _c_20 = Expr::create<rftype::Word>("SYMBOL?");
  _c_21 = Expr::create<rftype::Word>("DEREF");
  _c_22 = (Expr::create<rftype::Word>("EVAR")) ();
  _c_23 = Expr::create<rftype::Word>("compose");
  _c_24 = Expr::create<rftype::Word>("Expr");
  _c_25 = Expr::create<rftype::Word>("EXPR");
  _c_26 = Expr::create_sym<rftype::Func> (Not_m_Idx);
  _c_27 = Expr::create_sym<rftype::Func> (Not_m_Instantiated_m_Var);
  _c_28 = Expr::create<rftype::Word>("LSPLIT");
  _c_29 = Expr::create<rftype::Word>("lsplit_");
  _c_30 = Expr::create<rftype::Word>("RSPLIT");
  _c_31 = Expr::create<rftype::Word>("rsplit_");
  _c_32 = Expr::create_sym<rftype::Func> (Reclassify_m_Clash);
  _c_33 = Expr::create<rftype::Word>("FUNC");
  _c_34 = Expr::create<rftype::Word>("Length");
  _c_35 = Expr::create<rftype::Integer>("3");
  _c_36 = Expr::create<rftype::Word>("Apply") + Expr::create<rftype::Word>("Apply") + Expr::create<rftype::Word>("Unexpected fail");
}

static AtStart init_registrator_ (&init_);

}

}
