#include <rf_core.hh>
#include <refal/Access.hh>
#include <refal/Box.hh>
#include <refal/Arithm.hh>
#include <refal/Compare.hh>
#include <refal/Class.hh>
#include <refal/Table.hh>
#include <refal/StdIO.hh>

namespace refal
{

using namespace rfrt;

namespace rfp__helper
{

Expr RFP_m_Options;

Expr RFP_m_Module_m_Subst;

static Expr Empty_m_Table;

RF_DECL (RFP_m_Clear_m_Table);

RF_DECL (RFP_m_Debug_q_);

RF_DECL (RFP_m_Double_m_Copy);

RF_DECL (RFP_m_Double_m_Unbind);

RF_DECL (RFP_m_Extract_m_Qualifiers);

RF_DECL (Del_m_Pragmas);

RF_DECL (Subst);

RF_DECL (In_q_);

static Expr _c_0;

static Expr _c_1;

RF_FUNC (RFP_m_Clear_m_Table, (RF_ARG _vs_tbl;;), RF_VOID)
  RF_TAILCALL (Table::Replace_m_Table, (_vs_tbl, Empty_m_Table), /*void*/);
RF_END

RF_FUNC (RFP_m_Debug_q_, RF_VOID, RF_VOID)
  RF_TAILCALL (Table::In_m_Table_q_, (RFP_m_Options, _c_0), /*void*/);
RF_END

RF_FUNC (RFP_m_Double_m_Copy, (RF_ARG _vs_tab;;), (RF_RES _v_res1;;))
  Expr _vs_new_m_tab;
  RF_CALL (Table::Table, /*void*/, _vs_new_m_tab);
  {
    Expr _v_Domain1;
    RF_CALL (Table::Domain, _vs_tab, _v_Domain1);
    if (_v_Domain1.get_len () < 1)
    {
      goto _block1__branch1;
    }
    RF_lsplit (_v_Domain1, 0, _ve__e__e_tmp_m_rfp__helperrf_m_24_m_23, _v_lsplit__Domain1);
    for ( ; ; RF_iter(_v_Domain1)++)
    {
      {
        if (!RF_iter(_v_Domain1))
        {
          goto _block1__branch1;
        }
        uintptr_t _v_len1 = _v_lsplit__Domain1.get_len ();
        uintptr_t _v_len2 = 1;
        if (_v_len1 < _v_len2)
        {
          goto _block1__branch1;
        }
        uintptr_t _v_len___e__e_tmp_m_rfp__helperrf_m_24_m_33 = (_v_len1 - _v_len2);
        if (_v_lsplit__Domain1.symbol_at (0))
        {
          goto _continue1;
        }
        Expr _v_deref__lsplit__Domain1 (_v_lsplit__Domain1, 0);
        uintptr_t _v_len3 = _v_deref__lsplit__Domain1.get_len ();
        uintptr_t _v_len4 = 0;
        if (_v_len3 < _v_len4)
        {
          goto _continue1;
        }
        uintptr_t _v_len__key = (_v_len3 - _v_len4);
        Expr _ve__e__e_tmp_m_rfp__helperrf_m_24_m_33 (_v_lsplit__Domain1, (0 + 1), _v_len___e__e_tmp_m_rfp__helperrf_m_24_m_33);
        Expr _ve_key (_v_deref__lsplit__Domain1, 0, _v_len__key);
        Expr _v_Lookup1;
        if (!RF_CALL (Table::Lookup, (_vs_tab, _ve_key), _v_Lookup1))
        {
          goto _continue1;
        }
        if (_v_Lookup1.get_len () != 1)
        {
          goto _continue1;
        }
        if (!_v_Lookup1.symbol_at (0))
        {
          goto _continue1;
        }
        Expr _vs_tab1 (_v_Lookup1, 0, 1);
        Expr _gs_auxcall1;
        RF_CALL (Table::Table_m_Copy, _vs_tab1, _gs_auxcall1);
        RF_CALL (Table::Bind, (_vs_new_m_tab, _ve_key, _gs_auxcall1), /*void*/);
      }
  _continue1: {}
    }
  _exit1: {}
  }
_block1__branch1: {}
  _v_res1 = _vs_new_m_tab;
RF_END

RF_FUNC (RFP_m_Double_m_Unbind, (RF_ARG _vs_tab, _ve_keys;;), RF_VOID)
  {
    if (_ve_keys.get_len () < 1)
    {
      goto _block1__branch1;
    }
    RF_lsplit (_ve_keys, 0, _ve__e__e_tmp_m_rfp__helperrf_m_33_m_15, _v_lsplit__keys);
    for ( ; ; RF_iter(_ve_keys)++)
    {
      {
        if (!RF_iter(_ve_keys))
        {
          goto _block1__branch1;
        }
        uintptr_t _v_len1 = _v_lsplit__keys.get_len ();
        uintptr_t _v_len2 = 1;
        if (_v_len1 < _v_len2)
        {
          goto _block1__branch1;
        }
        uintptr_t _v_len___e__e_tmp_m_rfp__helperrf_m_33_m_23 = (_v_len1 - _v_len2);
        Expr _vt_key (_v_lsplit__keys, 0, 1);
        Expr _ve__e__e_tmp_m_rfp__helperrf_m_33_m_23 (_v_lsplit__keys, (0 + 1), _v_len___e__e_tmp_m_rfp__helperrf_m_33_m_23);
        RF_CALL (Table::Unbind, (_vs_tab, _vt_key), /*void*/);
      }
  _continue1: {}
    }
  _exit1: {}
  }
_block1__branch1: {}
RF_END

RF_FUNC (RFP_m_Extract_m_Qualifiers, (RF_ARG _gt_arg1;;), (RF_RES _v_res1, _v_res2;;))
  {
    {
      if (_gt_arg1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__arg1 (_gt_arg1, 0);
      if (_v_deref__arg1.get_len () < 2)
      {
        goto _block1__branch1;
      }
      RF_lsplit (_v_deref__arg1, 0, _ve_1, _v_lsplit__deref__arg1);
      for ( ; ; RF_iter(_v_deref__arg1)++)
      {
        {
          if (!RF_iter(_v_deref__arg1))
          {
            goto _block1__branch1;
          }
          uintptr_t _v_len1 = _v_lsplit__deref__arg1.get_len ();
          uintptr_t _v_len2 = 2;
          if (_v_len1 < _v_len2)
          {
            goto _block1__branch1;
          }
          uintptr_t _v_len__4 = (_v_len1 - _v_len2);
          if (!_v_lsplit__deref__arg1.symbol_at (0))
          {
            goto _continue1;
          }
          if (!_v_lsplit__deref__arg1.symbol_at ((0 + 1)))
          {
            goto _continue1;
          }
          Expr _vs_2 (_v_lsplit__deref__arg1, 0, 1);
          Expr _vs_3 (_v_lsplit__deref__arg1, (0 + 1), 1);
          Expr _ve_4 (_v_lsplit__deref__arg1, (0 + 1 + 1), _v_len__4);
          if (!RF_CALL (Class::Int_q_, _vs_3, /*void*/))
          {
            goto _continue1;
          }
          _v_res1 = _ve_1;
          _v_res2 = (_vs_2 + _vs_3 + _ve_4);
          goto _exit1;
        }
    _continue1: {}
      }
    _exit1: {}
      goto _block1;
    }
  _block1__branch1: {}
    {
      if (_gt_arg1.symbol_at (0))
      {
        goto _block1__branch2;
      }
      Expr _v_deref__arg12 (_gt_arg1, 0);
      uintptr_t _v_len3 = _v_deref__arg12.get_len ();
      uintptr_t _v_len4 = 1;
      if (_v_len3 < _v_len4)
      {
        goto _block1__branch2;
      }
      uintptr_t _v_len__1 = (_v_len3 - _v_len4);
      if (!_v_deref__arg12.symbol_at ((0 + _v_len__1)))
      {
        goto _block1__branch2;
      }
      Expr _ve_1 (_v_deref__arg12, 0, _v_len__1);
      Expr _vs_2 (_v_deref__arg12, (0 + _v_len__1), 1);
      _v_res1 = _ve_1;
      _v_res2 = _vs_2;
      goto _block1;
    }
  _block1__branch2: {}
    if (_gt_arg1.symbol_at (0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _v_deref__arg13 (_gt_arg1, 0);
    uintptr_t _v_len5 = _v_deref__arg13.get_len ();
    uintptr_t _v_len6 = 0;
    if (_v_len5 < _v_len6)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    uintptr_t _v_len__12 = (_v_len5 - _v_len6);
    Expr _ve_1 (_v_deref__arg13, 0, _v_len__12);
    _v_res1 = empty;
    _v_res2 = _ve_1;
  }
_block1: {}
RF_END

RF_FUNC (Del_m_Pragmas, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  {
    {
      if (_ge_arg1.get_len () < 1)
      {
        goto _block1__branch1;
      }
      RF_lsplit (_ge_arg1, 0, _ve_L, _v_lsplit__arg1);
      for ( ; ; RF_iter(_ge_arg1)++)
      {
        {
          if (!RF_iter(_ge_arg1))
          {
            goto _block1__branch1;
          }
          uintptr_t _v_len1 = _v_lsplit__arg1.get_len ();
          uintptr_t _v_len2 = 1;
          if (_v_len1 < _v_len2)
          {
            goto _block1__branch1;
          }
          uintptr_t _v_len__R = (_v_len1 - _v_len2);
          Expr _vt_Item (_v_lsplit__arg1, 0, 1);
          Expr _ve_R (_v_lsplit__arg1, (0 + 1), _v_len__R);
          {
            {
              if (_vt_Item.symbol_at (0))
              {
                goto _block2__branch1;
              }
              Expr _v_deref__Item (_vt_Item, 0);
              uintptr_t _v_len3 = _v_deref__Item.get_len ();
              uintptr_t _v_len4 = 1;
              if (_v_len3 < _v_len4)
              {
                goto _block2__branch1;
              }
              uintptr_t _v_len___e__e_tmp_m_rfp__helperrf_m_46_m_14 = (_v_len3 - _v_len4);
              if (!_c_1.term_eq (_v_deref__Item, 0))
              {
                goto _block2__branch1;
              }
              Expr _ve__e__e_tmp_m_rfp__helperrf_m_46_m_14 (_v_deref__Item, (0 + 1), _v_len___e__e_tmp_m_rfp__helperrf_m_46_m_14);
              Expr _v_Del_m_Pragmas1;
              RF_CALL (Del_m_Pragmas, _ve_R, _v_Del_m_Pragmas1);
              _v_res1 = (_ve_L + _v_Del_m_Pragmas1);
              goto _block2;
            }
          _block2__branch1: {}
            if (_vt_Item.symbol_at (0))
            {
              goto _continue1;
            }
            Expr _v_deref__Item2 (_vt_Item, 0);
            uintptr_t _v_len5 = _v_deref__Item2.get_len ();
            uintptr_t _v_len6 = 0;
            if (_v_len5 < _v_len6)
            {
              goto _continue1;
            }
            uintptr_t _v_len__xpr = (_v_len5 - _v_len6);
            Expr _ve_xpr (_v_deref__Item2, 0, _v_len__xpr);
            Expr _ge_auxcall1;
            RF_CALL (Del_m_Pragmas, _ve_xpr, _ge_auxcall1);
            Expr _v_Del_m_Pragmas2;
            RF_CALL (Del_m_Pragmas, _ve_R, _v_Del_m_Pragmas2);
            _v_res1 = (_ve_L + _ge_auxcall1 () + _v_Del_m_Pragmas2);
          }
        _block2: {}
          goto _exit1;
        }
    _continue1: {}
      }
    _exit1: {}
      goto _block1;
    }
  _block1__branch1: {}
    _v_res1 = _ge_arg1;
  }
_block1: {}
RF_END

RF_FUNC (Subst, (RF_ARG _ve_patterns, _ve_replaces, _ve_xpr;;), (RF_RES _v_res1;;))
  {
    {
      if (_ve_xpr.get_len () < 1)
      {
        goto _block1__branch1;
      }
      RF_lsplit (_ve_xpr, 0, _ve_1, _v_lsplit__xpr);
      for ( ; ; RF_iter(_ve_xpr)++)
      {
        {
          if (!RF_iter(_ve_xpr))
          {
            goto _block1__branch1;
          }
          uintptr_t _v_len1 = _v_lsplit__xpr.get_len ();
          uintptr_t _v_len2 = 1;
          if (_v_len1 < _v_len2)
          {
            goto _block1__branch1;
          }
          uintptr_t _v_len__3 = (_v_len1 - _v_len2);
          Expr _vt_2 (_v_lsplit__xpr, 0, 1);
          Expr _ve_3 (_v_lsplit__xpr, (0 + 1), _v_len__3);
          Expr _ve_9;
          Expr _ve_10;
          {
            {
              if (_ve_patterns.get_len () < 1)
              {
                goto _block2__branch1;
              }
              RF_rsplit (_ve_patterns, 0, _v_rsplit__patterns, _ve_5);
              for ( ; ; RF_iter(_ve_patterns)--)
              {
                {
                  if (!RF_iter(_ve_patterns))
                  {
                    goto _block2__branch1;
                  }
                  uintptr_t _v_len3 = _v_rsplit__patterns.get_len ();
                  uintptr_t _v_len4 = 1;
                  if (_v_len3 < _v_len4)
                  {
                    goto _block2__branch1;
                  }
                  uintptr_t _v_len__4 = (_v_len3 - _v_len4);
                  if (!_vt_2.term_eq (_v_rsplit__patterns, (0 + _v_len__4)))
                  {
                    goto _continue2;
                  }
                  Expr _ve_4 (_v_rsplit__patterns, 0, _v_len__4);
                  Expr _gs_auxcall1;
                  RF_CALL (Access::Length, _ve_4, _gs_auxcall1);
                  Expr _v_L1;
                  if (!RF_CALL (Access::L, (_gs_auxcall1, _ve_replaces), _v_L1))
                  {
                    goto _continue1;
                  }
                  if (_v_L1.symbol_at (0))
                  {
                    goto _continue1;
                  }
                  Expr _v_deref__L1 (_v_L1, 0);
                  uintptr_t _v_len5 = _v_deref__L1.get_len ();
                  uintptr_t _v_len6 = 0;
                  if (_v_len5 < _v_len6)
                  {
                    goto _continue1;
                  }
                  uintptr_t _v_len__6 = (_v_len5 - _v_len6);
                  Expr _ve_6 (_v_deref__L1, 0, _v_len__6);
                  _ve_9 = _ve_1;
                  _ve_10 = (_ve_6 + _ve_3);
                  goto _exit2;
                }
            _continue2: {}
              }
            _exit2: {}
              goto _block2;
            }
          _block2__branch1: {}
            if (_vt_2.symbol_at (0))
            {
              goto _continue1;
            }
            Expr _v_deref__2 (_vt_2, 0);
            uintptr_t _v_len7 = _v_deref__2.get_len ();
            uintptr_t _v_len8 = 0;
            if (_v_len7 < _v_len8)
            {
              goto _continue1;
            }
            uintptr_t _v_len__7 = (_v_len7 - _v_len8);
            Expr _ve_7 (_v_deref__2, 0, _v_len__7);
            Expr _v_Subst1;
            RF_CALL (Subst, (_ve_patterns, _ve_replaces, _ve_7), _v_Subst1);
            {
              {
                if (_v_Subst1.get_len () != _v_len__7)
                {
                  goto _block3__branch1;
                }
                if (!_ve_7.eq (_v_Subst1, 0))
                {
                  goto _block3__branch1;
                }
                _ve_9 = (_ve_1 + _vt_2);
                _ve_10 = _ve_3;
                goto _block3;
              }
            _block3__branch1: {}
              uintptr_t _v_len9 = _v_Subst1.get_len ();
              uintptr_t _v_len10 = 0;
              if (_v_len9 < _v_len10)
              {
                RF_FUNC_ERROR (unexpected_fail);
              }
              uintptr_t _v_len__8 = (_v_len9 - _v_len10);
              Expr _ve_8 (_v_Subst1, 0, _v_len__8);
              _ve_9 = _ve_1;
              _ve_10 = (_ve_8 () + _ve_3);
            }
          _block3: {}
          }
        _block2: {}
          Expr _v_Subst2;
          RF_CALL (Subst, (_ve_patterns, _ve_replaces, _ve_10), _v_Subst2);
          _v_res1 = (_ve_9 + _v_Subst2);
          goto _exit1;
        }
    _continue1: {}
      }
    _exit1: {}
      goto _block1;
    }
  _block1__branch1: {}
    _v_res1 = _ve_xpr;
  }
_block1: {}
RF_END

RF_FUNC (In_q_, (RF_ARG _ge_arg1, _ge_arg2;;), RF_VOID)
  {
    {
      if ((_ge_arg2.get_len () + 1) < 1)
      {
        goto _block1__branch1;
      }
      Expr _v_compose1 ((_ge_arg1 () + _ge_arg2));
      if (_v_compose1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__compose1 (_v_compose1, 0);
      uintptr_t _v_len1 = _v_deref__compose1.get_len ();
      uintptr_t _v_len2 = 0;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__pattern = (_v_len1 - _v_len2);
      if (_v_compose1.get_len () < (_v_len__pattern + 1))
      {
        goto _block1__branch1;
      }
      Expr _ve_pattern (_v_deref__compose1, 0, _v_len__pattern);
      Expr _v_subexpr__compose1 (_v_compose1, (0 + 1), (_v_compose1.get_len () - (0 + 1 + 0)));
      RF_lsplit (_v_subexpr__compose1, 0, _ve__e__e_tmp_m_rfp__helperrf_m_79_m_16, _v_lsplit__compose1);
      for ( ; ; RF_iter(_v_subexpr__compose1)++)
      {
        {
          if (!RF_iter(_v_subexpr__compose1))
          {
            goto _block1__branch1;
          }
          uintptr_t _v_len3 = _v_lsplit__compose1.get_len ();
          uintptr_t _v_len4 = _v_len__pattern;
          if (_v_len3 < _v_len4)
          {
            goto _block1__branch1;
          }
          uintptr_t _v_len___e__e_tmp_m_rfp__helperrf_m_79_m_28 = (_v_len3 - _v_len4);
          if (!_ve_pattern.eq (_v_lsplit__compose1, 0))
          {
            goto _continue1;
          }
          Expr _ve__e__e_tmp_m_rfp__helperrf_m_79_m_28 (_v_lsplit__compose1, (0 + _v_len__pattern), _v_len___e__e_tmp_m_rfp__helperrf_m_79_m_28);
          goto _exit1;
        }
    _continue1: {}
      }
    _exit1: {}
      goto _block1;
    }
  _block1__branch1: {}
    if ((_ge_arg2.get_len () + 1) < 2)
    {
      RF_RETFAIL;
    }
    Expr _v_compose2 ((_ge_arg1 () + _ge_arg2));
    if (_v_compose2.symbol_at (0))
    {
      RF_RETFAIL;
    }
    Expr _v_deref__compose2 (_v_compose2, 0);
    uintptr_t _v_len5 = _v_deref__compose2.get_len ();
    uintptr_t _v_len6 = 0;
    if (_v_len5 < _v_len6)
    {
      RF_RETFAIL;
    }
    uintptr_t _v_len__pattern2 = (_v_len5 - _v_len6);
    Expr _ve_pattern (_v_deref__compose2, 0, _v_len__pattern2);
    Expr _v_subexpr__compose2 (_v_compose2, (0 + 1), (_v_compose2.get_len () - (0 + 1 + 0)));
    RF_lsplit (_v_subexpr__compose2, 0, _ve__e__e_tmp_m_rfp__helperrf_m_80_m_16, _v_lsplit__compose2);
    for ( ; ; RF_iter(_v_subexpr__compose2)++)
    {
      {
        if (!RF_iter(_v_subexpr__compose2))
        {
          RF_RETFAIL;
        }
        uintptr_t _v_len7 = _v_lsplit__compose2.get_len ();
        uintptr_t _v_len8 = 1;
        if (_v_len7 < _v_len8)
        {
          RF_RETFAIL;
        }
        uintptr_t _v_len___e__e_tmp_m_rfp__helperrf_m_80_m_25 = (_v_len7 - _v_len8);
        if (_v_lsplit__compose2.symbol_at (0))
        {
          goto _continue2;
        }
        Expr _v_deref__lsplit__compose2 (_v_lsplit__compose2, 0);
        uintptr_t _v_len9 = _v_deref__lsplit__compose2.get_len ();
        uintptr_t _v_len10 = 0;
        if (_v_len9 < _v_len10)
        {
          goto _continue2;
        }
        uintptr_t _v_len__xpr = (_v_len9 - _v_len10);
        Expr _ve__e__e_tmp_m_rfp__helperrf_m_80_m_25 (_v_lsplit__compose2, (0 + 1), _v_len___e__e_tmp_m_rfp__helperrf_m_80_m_25);
        Expr _ve_xpr (_v_deref__lsplit__compose2, 0, _v_len__xpr);
        if (!RF_CALL (In_q_, (_ve_pattern, _ve_xpr), /*void*/))
        {
          goto _continue2;
        }
        goto _exit2;
      }
  _continue2: {}
    }
  _exit2: {}
  }
_block1: {}
RF_END

}

namespace rfp__helper
{

static void init_ ()
{
  RFP_m_Options = new rftype::StaticObject<rftype::Table>(L"RFP-Options");
  RFP_m_Module_m_Subst = new rftype::StaticObject<rftype::Table>(L"RFP-Module-Subst");
  Empty_m_Table = new rftype::StaticObject<rftype::Table>(L"Empty-Table");
  _c_0 = Expr::create<rftype::Word>("DEBUG");
  _c_1 = Expr::create<rftype::Word>("PRAGMA");
}

static AtStart init_registrator_ (&init_);

}

}
