#include <rf_core.hh>
#include <refal/Access.hh>
#include <refal/Arithm.hh>
#include <refal/Apply.hh>
#include <refal/Class.hh>
#include <refal/Dir.hh>
#include <refal/Convert.hh>
#include <refal/Compare.hh>
#include <refal/Box.hh>
#include <refal/File.hh>
#include <refal/StdIO.hh>
#include <refal/Table.hh>
#include <refal/List.hh>
#include "rfp_helper.hh"
#include "rfpc.hh"
#include "rfp_src.hh"
#include "rfp_err.hh"
#include <refal/Dos.hh>

namespace refal
{

using namespace rfrt;

namespace rfp__lex
{

static Expr Source;

static Expr Position;

static Expr Source_m_Index;

static Expr Saved_m_Sources;

static Expr Src_m_Counter;

RF_DECL (RFP_m_Lexer);

RF_DECL (Find_m_Includes);

RF_DECL (Push_m_Source);

RF_DECL (Pop_m_Source_q_);

RF_DECL (Scan_m_Tokens);

RF_DECL (Scan_m_Token);

RF_DECL (Get_m_Source_m_Line);

RF_DECL (Blank_q_);

RF_DECL (Skip_m_Blank);

RF_DECL (Scan_m_Keyword_q_);

RF_DECL (Scan_m_Keyword_m_Rest);

RF_DECL (Scan_m_Variable_q_);

RF_DECL (Scan_m_Number_q_);

RF_DECL (Scan_m_Number_m_Rest);

RF_DECL (Scan_m_Identifier_q_);

RF_DECL (Scan_m_Identifier_m_Rest);

RF_DECL (Scan_m_Word_q_);

RF_DECL (Scan_m_String_q_);

RF_DECL (Scan_m_String_m_Rest);

RF_DECL (Skip_m_Comment);

RF_DECL (Next_m_Column);

RF_DECL (Next_m_Row);

RF_DECL (Uppercase_m_Letter_q_);

RF_DECL (Source_m_File_m_Name);

RF_DECL (Print_m_File_m_Name);

RF_DECL (Token_m_Position);

RF_DECL (Find_m_Include_q_);

RF_DECL (Try_m_Open);

RF_DECL (Interface_m_Name_q_);

RF_DECL (Apply__0);

RF_DECL (Next_m_Column__0);

static Expr _c_0;

static Expr _c_1;

static Expr _c_2;

static Expr _c_3;

static Expr _c_4;

static Expr _c_5;

static Expr _c_6;

static Expr _c_7;

static Expr _c_104;

static Expr _c_8;

static Expr _c_47;

static Expr _c_9;

static Expr _c_10;

static Expr _c_11;

static Expr _c_12;

static Expr _c_13;

static Expr _c_14;

static Expr _c_15;

static Expr _c_16;

static Expr _c_17;

static Expr _c_18;

static Expr _c_19;

static Expr _c_20;

static Expr _c_21;

static Expr _c_22;

static Expr _c_23;

static Expr _c_24;

static Expr _c_25;

static Expr _c_106;

static Expr _c_26;

static Expr _c_27;

static Expr _c_28;

static Expr _c_29;

static Expr _c_30;

static Expr _c_31;

static Expr _c_32;

static Expr _c_33;

static Expr _c_34;

static Expr _c_35;

static Expr _c_36;

static Expr _c_37;

static Expr _c_38;

static Expr _c_39;

static Expr _c_40;

static Expr _c_41;

static Expr _c_42;

static Expr _c_43;

static Expr _c_44;

static Expr _c_45;

static Expr _c_46;

static Expr _c_48;

static Expr _c_49;

static Expr _c_50;

static Expr _c_51;

static Expr _c_52;

static Expr _c_53;

static Expr _c_79;

static Expr _c_54;

static Expr _c_55;

static Expr _c_122;

static Expr _c_56;

static Expr _c_57;

static Expr _c_58;

static Expr _c_59;

static Expr _c_60;

static Expr _c_61;

static Expr _c_139;

static Expr _c_62;

static Expr _c_63;

static Expr _c_64;

static Expr _c_65;

static Expr _c_66;

static Expr _c_67;

static Expr _c_68;

static Expr _c_69;

static Expr _c_70;

static Expr _c_71;

static Expr _c_72;

static Expr _c_73;

static Expr _c_74;

static Expr _c_75;

static Expr _c_76;

static Expr _c_77;

static Expr _c_78;

static Expr _c_80;

static Expr _c_81;

static Expr _c_82;

static Expr _c_83;

static Expr _c_84;

static Expr _c_85;

static Expr _c_86;

static Expr _c_87;

static Expr _c_88;

static Expr _c_89;

static Expr _c_90;

static Expr _c_91;

static Expr _c_92;

static Expr _c_93;

static Expr _c_94;

static Expr _c_95;

static Expr _c_96;

static Expr _c_99;

static Expr _c_97;

static Expr _c_98;

static Expr _c_100;

static Expr _c_101;

static Expr _c_102;

static Expr _c_103;

static Expr _c_105;

static Expr _c_107;

static Expr _c_108;

static Expr _c_109;

static Expr _c_110;

static Expr _c_111;

static Expr _c_112;

static Expr _c_113;

static Expr _c_114;

static Expr _c_115;

static Expr _c_116;

static Expr _c_117;

static Expr _c_118;

static Expr _c_119;

static Expr _c_120;

static Expr _c_121;

static Expr _c_123;

static Expr _c_124;

static Expr _c_125;

static Expr _c_127;

static Expr _c_126;

static Expr _c_128;

static Expr _c_129;

static Expr _c_130;

static Expr _c_131;

static Expr _c_132;

static Expr _c_133;

static Expr _c_134;

static Expr _c_135;

static Expr _c_136;

static Expr _c_137;

static Expr _c_138;

static Expr _c_140;

static Expr _c_141;

static Expr _c_142;

static Expr _c_143;

static Expr _c_144;

static Expr _c_145;

static Expr _c_146;

static Expr _c_147;

RF_FUNC (RFP_m_Lexer, (RF_ARG _ve_filename;;), (RF_RES _v_res1;;))
  RF_CALL (Box::Store, (Source, empty), /*void*/);
  RF_CALL (Box::Store, (Saved_m_Sources, empty), /*void*/);
  RF_CALL (Box::Store, (Position, empty), /*void*/);
  RF_CALL (Box::Store, (Source_m_Index, empty), /*void*/);
  RF_CALL (Box::Store, (Src_m_Counter, _c_0), /*void*/);
  RF_CALL (rfp__helper::RFP_m_Clear_m_Table, rfp__src::RFP_m_Sources, /*void*/);
  Expr _ve_source;
  {
    {
      uintptr_t _v_len1 = _ve_filename.get_len ();
      uintptr_t _v_len2 = 0;
      if (_v_len1 < (_v_len2 + 1))
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len___e__e_tmp_m_rfp__lexrf_m_86_m_19 = (_v_len1 - _v_len2);
      Expr _vv__e__e_tmp_m_rfp__lexrf_m_86_m_19 (_ve_filename, 0, _v_len___e__e_tmp_m_rfp__lexrf_m_86_m_19);
      {
        {
          if (!RF_CALL (rfp__src::RFP_m_Src_m_Open_m_File, _ve_filename, _ve_source))
          {
            goto _block2__branch1;
          }
          goto _block2;
        }
      _block2__branch1: {}
        RF_CALL (StdIO::PrintLN_e_, (StdIO::StdErr, (_c_1 + _ve_filename)), /*void*/);
        RF_CALL (Dos::Exit, _c_2, /*void*/);
        _ve_source = empty;
      }
    _block2: {}
      goto _block1;
    }
  _block1__branch1: {}
    if (!RF_CALL (rfp__src::RFP_m_Src_m_Open_m_StdIN, /*void*/, _ve_source))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
  }
_block1: {}
  {
    {
      uintptr_t _v_len3 = _ve_source.get_len ();
      uintptr_t _v_len4 = 2;
      if (_v_len3 < _v_len4)
      {
        goto _block3__branch1;
      }
      uintptr_t _v_len___e__e_tmp_m_rfp__lexrf_m_94_m_17 = (_v_len3 - _v_len4);
      if (_ve_source.symbol_at ((0 + _v_len___e__e_tmp_m_rfp__lexrf_m_94_m_17)))
      {
        goto _block3__branch1;
      }
      if (_ve_source.symbol_at ((0 + _v_len___e__e_tmp_m_rfp__lexrf_m_94_m_17 + 1)))
      {
        goto _block3__branch1;
      }
      Expr _v_deref__source (_ve_source, (0 + _v_len___e__e_tmp_m_rfp__lexrf_m_94_m_17));
      Expr _v_deref__source2 (_ve_source, (0 + _v_len___e__e_tmp_m_rfp__lexrf_m_94_m_17 + 1));
      uintptr_t _v_len5 = _v_deref__source2.get_len ();
      uintptr_t _v_len6 = 0;
      if (_v_len5 < _v_len6)
      {
        goto _block3__branch1;
      }
      uintptr_t _v_len___e__e_tmp_m_rfp__lexrf_m_94_m_31 = (_v_len5 - _v_len6);
      uintptr_t _v_len7 = _v_deref__source.get_len ();
      uintptr_t _v_len8 = 4;
      if (_v_len7 < _v_len8)
      {
        goto _block3__branch1;
      }
      uintptr_t _v_len___e__e_tmp_m_rfp__lexrf_m_94_m_20 = (_v_len7 - _v_len8);
      if (!_c_3.eq (_v_deref__source, (0 + _v_len___e__e_tmp_m_rfp__lexrf_m_94_m_20)))
      {
        goto _block3__branch1;
      }
      Expr _ve__e__e_tmp_m_rfp__lexrf_m_94_m_17 (_ve_source, 0, _v_len___e__e_tmp_m_rfp__lexrf_m_94_m_17);
      Expr _ve__e__e_tmp_m_rfp__lexrf_m_94_m_20 (_v_deref__source, 0, _v_len___e__e_tmp_m_rfp__lexrf_m_94_m_20);
      Expr _ve__e__e_tmp_m_rfp__lexrf_m_94_m_31 (_v_deref__source2, 0, _v_len___e__e_tmp_m_rfp__lexrf_m_94_m_31);
      RF_CALL (Push_m_Source, (_ve_source, _c_4, _c_0, _c_2), /*void*/);
      goto _block3;
    }
  _block3__branch1: {}
    RF_CALL (Push_m_Source, (_ve_source, _c_5, _c_0, _c_2), /*void*/);
  }
_block3: {}
  Expr _ve_ts;
  {
    {
      Expr _ge_auxcall1;
      if (!RF_CALL (Interface_m_Name_q_, _ve_source, _ge_auxcall1))
      {
        goto _block4__branch1;
      }
      Expr _ge_source__3;
      if (!RF_CALL (rfp__src::RFP_m_Src_m_Open_m_File, _ge_auxcall1, _ge_source__3))
      {
        goto _block4__branch1;
      }
      RF_CALL (Push_m_Source, (_ge_source__3, _c_4, _c_0, _c_2), /*void*/);
      RF_CALL (Scan_m_Tokens, empty, _ve_ts);
      goto _block4;
    }
  _block4__branch1: {}
    _ve_ts = empty;
  }
_block4: {}
  Expr _v_Scan_m_Tokens1;
  RF_CALL (Scan_m_Tokens, empty, _v_Scan_m_Tokens1);
  _v_res1 = (_ve_ts + _v_Scan_m_Tokens1);
RF_END

RF_FUNC (Find_m_Includes, (RF_ARG _ve_filename;;), (RF_RES _v_res1;;))
  RF_CALL (Box::Store, (Source, empty), /*void*/);
  RF_CALL (Box::Store, (Saved_m_Sources, empty), /*void*/);
  RF_CALL (Box::Store, (Position, empty), /*void*/);
  RF_CALL (Box::Store, (Source_m_Index, empty), /*void*/);
  RF_CALL (Box::Store, (Src_m_Counter, _c_0), /*void*/);
  Expr _ve_source;
  {
    {
      if (!RF_CALL (rfp__src::RFP_m_Src_m_Open_m_File, _ve_filename, _ve_source))
      {
        goto _block1__branch1;
      }
      goto _block1;
    }
  _block1__branch1: {}
    RF_CALL (StdIO::PrintLN_e_, (StdIO::StdErr, (_c_1 + _ve_filename)), /*void*/);
    RF_CALL (Dos::Exit, _c_2, /*void*/);
    _ve_source = empty;
  }
_block1: {}
  RF_CALL (Push_m_Source, (_ve_source, _c_5, _c_0, _c_2), /*void*/);
  Expr _ve_includes (empty);
  Expr _ve_line (empty);
  Expr _ve_stop_q_ (empty);
  for ( ; ; )
  {
    {
      if (_ve_stop_q_.get_len () != 1)
      {
        goto _iter1;
      }
      if (!_c_6.term_eq (_ve_stop_q_, 0))
      {
        goto _iter1;
      }
      _v_res1 = _ve_includes;
      goto _exit__iter1;
    }
  _iter1: {}
    Expr _v_Scan_m_Token1;
    Expr _v_Scan_m_Token2;
    RF_CALL (Scan_m_Token, _ve_line, (_v_Scan_m_Token1, _v_Scan_m_Token2));
    {
      {
        uintptr_t _v_len1 = 2;
        uintptr_t _v_len2 = 1;
        if (_v_len1 < _v_len2)
        {
          goto _block2__branch1;
        }
        uintptr_t _v_len___e__e_tmp_m_rfp__lexrf_m_116_m_18 = (_v_len1 - _v_len2);
        Expr _v_compose1 ((_v_Scan_m_Token1 () + _v_Scan_m_Token2 ()));
        if (_v_compose1.symbol_at (0))
        {
          goto _block2__branch1;
        }
        Expr _v_deref__compose1 (_v_compose1, 0);
        if (_v_deref__compose1.get_len () != 1)
        {
          goto _block2__branch1;
        }
        if (_v_deref__compose1.symbol_at (0))
        {
          goto _block2__branch1;
        }
        Expr _v_deref__deref__compose1 (_v_deref__compose1, 0);
        uintptr_t _v_len3 = _v_deref__deref__compose1.get_len ();
        uintptr_t _v_len4 = 1;
        if (_v_len3 < _v_len4)
        {
          goto _block2__branch1;
        }
        uintptr_t _v_len___e__e_tmp_m_rfp__lexrf_m_116_m_8 = (_v_len3 - _v_len4);
        if (!_c_7.term_eq (_v_deref__deref__compose1, (0 + _v_len___e__e_tmp_m_rfp__lexrf_m_116_m_8)))
        {
          goto _block2__branch1;
        }
        Expr _ve__e__e_tmp_m_rfp__lexrf_m_116_m_18 (_v_compose1, (0 + 1), _v_len___e__e_tmp_m_rfp__lexrf_m_116_m_18);
        Expr _ve__e__e_tmp_m_rfp__lexrf_m_116_m_8 (_v_deref__deref__compose1, 0, _v_len___e__e_tmp_m_rfp__lexrf_m_116_m_8);
        _ve_line = empty;
        _ve_stop_q_ = _c_6;
        goto _block2;
      }
    _block2__branch1: {}
      {
        Expr _v_compose2 ((_v_Scan_m_Token1 () + _v_Scan_m_Token2 ()));
        if (_v_compose2.symbol_at (0))
        {
          goto _block2__branch2;
        }
        if (_v_compose2.symbol_at ((0 + 1)))
        {
          goto _block2__branch2;
        }
        Expr _v_deref__compose2 (_v_compose2, 0);
        Expr _v_deref__compose22 (_v_compose2, (0 + 1));
        if (_v_deref__compose2.get_len () != 1)
        {
          goto _block2__branch2;
        }
        uintptr_t _v_len5 = _v_deref__compose22.get_len ();
        uintptr_t _v_len6 = 0;
        if (_v_len5 < _v_len6)
        {
          goto _block2__branch2;
        }
        uintptr_t _v_len__ln = (_v_len5 - _v_len6);
        if (_v_deref__compose2.symbol_at (0))
        {
          goto _block2__branch2;
        }
        Expr _v_deref__deref__compose2 (_v_deref__compose2, 0);
        uintptr_t _v_len7 = _v_deref__deref__compose2.get_len ();
        uintptr_t _v_len8 = 1;
        if (_v_len7 < _v_len8)
        {
          goto _block2__branch2;
        }
        uintptr_t _v_len___e__e_tmp_m_rfp__lexrf_m_117_m_8 = (_v_len7 - _v_len8);
        if (!_c_8.term_eq (_v_deref__deref__compose2, (0 + _v_len___e__e_tmp_m_rfp__lexrf_m_117_m_8)))
        {
          goto _block2__branch2;
        }
        Expr _ve_ln (_v_deref__compose22, 0, _v_len__ln);
        Expr _ve__e__e_tmp_m_rfp__lexrf_m_117_m_8 (_v_deref__deref__compose2, 0, _v_len___e__e_tmp_m_rfp__lexrf_m_117_m_8);
        Expr _ve_incs (empty);
        Expr _ve_st_q_ (empty);
        for ( ; ; )
        {
          {
            if (_ve_st_q_.get_len () != 1)
            {
              goto _iter2;
            }
            if (!_c_6.term_eq (_ve_st_q_, 0))
            {
              goto _iter2;
            }
            _ve_includes = (_ve_includes + _ve_incs);
            _ve_line = _ve_ln;
            _ve_stop_q_ = empty;
            goto _exit__iter2;
          }
        _iter2: {}
          Expr _v_Scan_m_Token3;
          Expr _v_Scan_m_Token4;
          RF_CALL (Scan_m_Token, _ve_ln, (_v_Scan_m_Token3, _v_Scan_m_Token4));
          {
            {
              Expr _v_compose3 ((_v_Scan_m_Token3 () + _v_Scan_m_Token4 ()));
              if (_v_compose3.symbol_at (0))
              {
                goto _block3__branch1;
              }
              if (_v_compose3.symbol_at ((0 + 1)))
              {
                goto _block3__branch1;
              }
              Expr _v_deref__compose3 (_v_compose3, 0);
              Expr _v_deref__compose32 (_v_compose3, (0 + 1));
              if (_v_deref__compose3.get_len () != 1)
              {
                goto _block3__branch1;
              }
              uintptr_t _v_len9 = _v_deref__compose32.get_len ();
              uintptr_t _v_len10 = 0;
              if (_v_len9 < _v_len10)
              {
                goto _block3__branch1;
              }
              uintptr_t _v_len__l = (_v_len9 - _v_len10);
              if (_v_deref__compose3.symbol_at (0))
              {
                goto _block3__branch1;
              }
              Expr _v_deref__deref__compose3 (_v_deref__compose3, 0);
              uintptr_t _v_len11 = _v_deref__deref__compose3.get_len ();
              uintptr_t _v_len12 = 1;
              if (_v_len11 < _v_len12)
              {
                goto _block3__branch1;
              }
              uintptr_t _v_len___e__e_tmp_m_rfp__lexrf_m_119_m_12 = (_v_len11 - _v_len12);
              if (!_c_9.term_eq (_v_deref__deref__compose3, (0 + _v_len___e__e_tmp_m_rfp__lexrf_m_119_m_12)))
              {
                goto _block3__branch1;
              }
              Expr _ve_l (_v_deref__compose32, 0, _v_len__l);
              Expr _ve__e__e_tmp_m_rfp__lexrf_m_119_m_12 (_v_deref__deref__compose3, 0, _v_len___e__e_tmp_m_rfp__lexrf_m_119_m_12);
              _ve_ln = _ve_l;
              _ve_st_q_ = _c_6;
              goto _block3;
            }
          _block3__branch1: {}
            {
              Expr _v_compose4 ((_v_Scan_m_Token3 () + _v_Scan_m_Token4 ()));
              if (_v_compose4.symbol_at (0))
              {
                goto _block3__branch2;
              }
              if (_v_compose4.symbol_at ((0 + 1)))
              {
                goto _block3__branch2;
              }
              Expr _v_deref__compose4 (_v_compose4, 0);
              Expr _v_deref__compose42 (_v_compose4, (0 + 1));
              if (_v_deref__compose4.get_len () != 1)
              {
                goto _block3__branch2;
              }
              uintptr_t _v_len13 = _v_deref__compose42.get_len ();
              uintptr_t _v_len14 = 0;
              if (_v_len13 < _v_len14)
              {
                goto _block3__branch2;
              }
              uintptr_t _v_len__l2 = (_v_len13 - _v_len14);
              if (_v_deref__compose4.symbol_at (0))
              {
                goto _block3__branch2;
              }
              Expr _v_deref__deref__compose4 (_v_deref__compose4, 0);
              if (_v_deref__deref__compose4.get_len () != 2)
              {
                goto _block3__branch2;
              }
              if (_v_deref__deref__compose4.symbol_at (0))
              {
                goto _block3__branch2;
              }
              if (_v_deref__deref__compose4.symbol_at ((0 + 1)))
              {
                goto _block3__branch2;
              }
              Expr _v_deref__deref__deref__compose4 (_v_deref__deref__compose4, 0);
              Expr _v_deref__deref__deref__compose42 (_v_deref__deref__compose4, (0 + 1));
              uintptr_t _v_len15 = _v_deref__deref__deref__compose42.get_len ();
              uintptr_t _v_len16 = 1;
              if (_v_len15 < _v_len16)
              {
                goto _block3__branch2;
              }
              uintptr_t _v_len__s = (_v_len15 - _v_len16);
              uintptr_t _v_len17 = _v_deref__deref__deref__compose4.get_len ();
              uintptr_t _v_len18 = 0;
              if (_v_len17 < _v_len18)
              {
                goto _block3__branch2;
              }
              uintptr_t _v_len__p = (_v_len17 - _v_len18);
              if (!_v_deref__deref__deref__compose42.symbol_at (0))
              {
                goto _block3__branch2;
              }
              Expr _ve_l (_v_deref__compose42, 0, _v_len__l2);
              Expr _ve_p (_v_deref__deref__deref__compose4, 0, _v_len__p);
              Expr _vs_WORD_m_or_m_QWORD (_v_deref__deref__deref__compose42, 0, 1);
              Expr _ve_s (_v_deref__deref__deref__compose42, (0 + 1), _v_len__s);
              {
                {
                  if (!_vs_WORD_m_or_m_QWORD.term_eq (_c_10, 0))
                  {
                    goto _block4__branch1;
                  }
                  goto _block4;
                }
              _block4__branch1: {}
                if (!_vs_WORD_m_or_m_QWORD.term_eq (_c_11, 0))
                {
                  goto _block3__branch2;
                }
              }
            _block4: {}
              _ve_incs = (_ve_incs + _ve_s ());
              _ve_ln = _ve_l;
              _ve_st_q_ = empty;
              goto _block3;
            }
          _block3__branch2: {}
            RF_FUNC_ERROR (unexpected_fail);
          }
        _block3: {}
        }
      _exit__iter2: {}
        goto _block2;
      }
    _block2__branch2: {}
      uintptr_t _v_len25 = 2;
      uintptr_t _v_len26 = 1;
      if (_v_len25 < _v_len26)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      uintptr_t _v_len___e__e_tmp_m_rfp__lexrf_m_134_m_6 = (_v_len25 - _v_len26);
      Expr _v_compose7 ((_v_Scan_m_Token1 () + _v_Scan_m_Token2 ()));
      if (_v_compose7.symbol_at ((0 + _v_len___e__e_tmp_m_rfp__lexrf_m_134_m_6)))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      Expr _v_deref__compose7 (_v_compose7, (0 + _v_len___e__e_tmp_m_rfp__lexrf_m_134_m_6));
      uintptr_t _v_len27 = _v_deref__compose7.get_len ();
      uintptr_t _v_len28 = 0;
      if (_v_len27 < _v_len28)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      uintptr_t _v_len__ln2 = (_v_len27 - _v_len28);
      Expr _ve__e__e_tmp_m_rfp__lexrf_m_134_m_6 (_v_compose7, 0, _v_len___e__e_tmp_m_rfp__lexrf_m_134_m_6);
      Expr _ve_ln (_v_deref__compose7, 0, _v_len__ln2);
      _ve_line = _ve_ln;
      _ve_stop_q_ = empty;
    }
  _block2: {}
  }
_exit__iter1: {}
RF_END

RF_FUNC (Push_m_Source, (RF_ARG _ve_source, _vs_type, _vs_row, _vs_col;;), RF_VOID)
  Expr _v__q_1;
  RF_CALL (Box::_q_, Src_m_Counter, _v__q_1);
  if (_v__q_1.get_len () != 1)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_v__q_1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _vs_n (_v__q_1, 0, 1);
  RF_CALL (Arithm::_p_, (_vs_n, _c_2), _vs_n);
  RF_CALL (Box::Store, (Src_m_Counter, _vs_n), /*void*/);
  Expr _ge_auxcall1;
  RF_CALL (Box::_q_, Saved_m_Sources, _ge_auxcall1);
  Expr _ge_auxcall2;
  RF_CALL (Box::_q_, Source, _ge_auxcall2);
  Expr _ge_auxcall3;
  RF_CALL (Box::_q_, Source_m_Index, _ge_auxcall3);
  Expr _ge_auxcall4;
  RF_CALL (Box::_q_, Position, _ge_auxcall4);
  RF_CALL (Box::Store, (Saved_m_Sources, (_ge_auxcall1 + (_ge_auxcall2 + _ge_auxcall3 + _ge_auxcall4) ())), /*void*/);
  RF_CALL (Box::Store, (Source, _ve_source), /*void*/);
  Expr _ge_auxcall5;
  RF_CALL (Source_m_File_m_Name, /*void*/, _ge_auxcall5);
  RF_CALL (Table::Bind, (rfp__src::RFP_m_Sources, _vs_n, _ge_auxcall5), /*void*/);
  RF_CALL (Box::Store, (Source_m_Index, (_vs_n + _vs_type)), /*void*/);
  RF_TAILCALL (Box::Store, (Position, (_vs_row + _vs_col)), /*void*/);
RF_END

RF_FUNC (Pop_m_Source_q_, RF_VOID, RF_VOID)
  Expr _ge_auxcall1;
  RF_CALL (Box::_q_, Source, _ge_auxcall1);
  RF_CALL (rfp__src::RFP_m_Src_m_Close, _ge_auxcall1, /*void*/);
  Expr _v__q_1;
  RF_CALL (Box::_q_, Saved_m_Sources, _v__q_1);
  uintptr_t _v_len1 = _v__q_1.get_len ();
  uintptr_t _v_len2 = 0;
  if (_v_len1 < _v_len2)
  {
    RF_RETFAIL;
  }
  uintptr_t _v_len__1 = (_v_len1 - _v_len2);
  uintptr_t _v_len3 = _v_len__1;
  uintptr_t _v_len4 = 1;
  if (_v_len3 < _v_len4)
  {
    RF_RETFAIL;
  }
  uintptr_t _v_len__saved = (_v_len3 - _v_len4);
  Expr _ve_1 (_v__q_1, 0, _v_len__1);
  if (_ve_1.symbol_at ((0 + _v_len__saved)))
  {
    RF_RETFAIL;
  }
  Expr _v_deref__1 (_ve_1, (0 + _v_len__saved));
  uintptr_t _v_len5 = _v_deref__1.get_len ();
  uintptr_t _v_len6 = 4;
  if (_v_len5 < _v_len6)
  {
    RF_RETFAIL;
  }
  uintptr_t _v_len__source = (_v_len5 - _v_len6);
  if (!_v_deref__1.symbol_at ((0 + _v_len__source)))
  {
    RF_RETFAIL;
  }
  if (!_v_deref__1.symbol_at ((0 + _v_len__source + 1)))
  {
    RF_RETFAIL;
  }
  if (!_v_deref__1.symbol_at ((0 + _v_len__source + 1 + 1)))
  {
    RF_RETFAIL;
  }
  if (!_v_deref__1.symbol_at ((0 + _v_len__source + 1 + 1 + 1)))
  {
    RF_RETFAIL;
  }
  Expr _ve_saved (_ve_1, 0, _v_len__saved);
  Expr _ve_source (_v_deref__1, 0, _v_len__source);
  Expr _vs_n (_v_deref__1, (0 + _v_len__source), 1);
  Expr _vs_type (_v_deref__1, (0 + _v_len__source + 1), 1);
  Expr _vs_row (_v_deref__1, (0 + _v_len__source + 1 + 1), 1);
  Expr _vs_col (_v_deref__1, (0 + _v_len__source + 1 + 1 + 1), 1);
  RF_CALL (Box::Store, (Saved_m_Sources, _ve_saved), /*void*/);
  RF_CALL (Box::Store, (Source, _ve_source), /*void*/);
  RF_CALL (Box::Store, (Source_m_Index, (_vs_n + _vs_type)), /*void*/);
  RF_TAILCALL (Box::Store, (Position, (_vs_row + _vs_col)), /*void*/);
RF_END

RF_FUNC (Scan_m_Tokens, (RF_ARG _ve_line;;), (RF_RES _v_res1;;))
  Expr _ve_t;
  Expr _ge_line__0;
  RF_CALL (Scan_m_Token, _ve_line, (_ve_t, _ge_line__0));
  {
    {
      if (_ve_t.get_len () != 1)
      {
        goto _block1__branch1;
      }
      if (_ve_t.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__t (_ve_t, 0);
      if (_v_deref__t.get_len () != 2)
      {
        goto _block1__branch1;
      }
      if (_v_deref__t.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__deref__t (_v_deref__t, 0);
      uintptr_t _v_len1 = _v_deref__deref__t.get_len ();
      uintptr_t _v_len2 = 0;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len___e__e_tmp_m_rfp__lexrf_m_163_m_8 = (_v_len1 - _v_len2);
      if (!_c_7.term_eq (_v_deref__t, (0 + 1)))
      {
        goto _block1__branch1;
      }
      Expr _ve__e__e_tmp_m_rfp__lexrf_m_163_m_8 (_v_deref__deref__t, 0, _v_len___e__e_tmp_m_rfp__lexrf_m_163_m_8);
      {
        {
          if (!RF_CALL (Pop_m_Source_q_, /*void*/, /*void*/))
          {
            goto _block2__branch1;
          }
          _v_res1 = empty;
          goto _block2;
        }
      _block2__branch1: {}
        _v_res1 = _ve_t;
      }
    _block2: {}
      goto _block1;
    }
  _block1__branch1: {}
    {
      if (_ve_t.get_len () != 1)
      {
        goto _block1__branch2;
      }
      if (_ve_t.symbol_at (0))
      {
        goto _block1__branch2;
      }
      Expr _v_deref__t2 (_ve_t, 0);
      if (_v_deref__t2.get_len () != 2)
      {
        goto _block1__branch2;
      }
      if (_v_deref__t2.symbol_at (0))
      {
        goto _block1__branch2;
      }
      Expr _v_deref__deref__t2 (_v_deref__t2, 0);
      uintptr_t _v_len3 = _v_deref__deref__t2.get_len ();
      uintptr_t _v_len4 = 0;
      if (_v_len3 < _v_len4)
      {
        goto _block1__branch2;
      }
      uintptr_t _v_len___e__e_tmp_m_rfp__lexrf_m_168_m_8 = (_v_len3 - _v_len4);
      if (!_c_8.term_eq (_v_deref__t2, (0 + 1)))
      {
        goto _block1__branch2;
      }
      Expr _ve__e__e_tmp_m_rfp__lexrf_m_168_m_8 (_v_deref__deref__t2, 0, _v_len___e__e_tmp_m_rfp__lexrf_m_168_m_8);
      {
        if (!RF_CALL (Table::In_m_Table_q_, (rfp__helper::RFP_m_Options, _c_16), /*void*/))
        {
          goto _negation1;
        }
        goto _block1__branch2;
      }
    _negation1: {}
      Expr _ve_nts (empty);
      Expr _ge_line__0__4 (_ge_line__0);
      Expr _vs_1 (_c_17);
      for ( ; ; )
      {
        {
          if (!_vs_1.term_eq (_c_18, 0))
          {
            goto _iter1;
          }
          Expr _v_Scan_m_Tokens1;
          RF_CALL (Scan_m_Tokens, _ge_line__0__4, _v_Scan_m_Tokens1);
          _v_res1 = (_ve_nts + _v_Scan_m_Tokens1);
          goto _exit__iter1;
        }
      _iter1: {}
        Expr _ge_t__6;
        Expr _ge_line__0__4__6;
        RF_CALL (Scan_m_Token, _ge_line__0__4, (_ge_t__6, _ge_line__0__4__6));
        {
          {
            if (_ge_t__6.get_len () != 1)
            {
              goto _block5__branch1;
            }
            if (_ge_t__6.symbol_at (0))
            {
              goto _block5__branch1;
            }
            Expr _v_deref__t__6 (_ge_t__6, 0);
            if (_v_deref__t__6.get_len () != 2)
            {
              goto _block5__branch1;
            }
            if (_v_deref__t__6.symbol_at (0))
            {
              goto _block5__branch1;
            }
            Expr _v_deref__deref__t__6 (_v_deref__t__6, 0);
            uintptr_t _v_len5 = _v_deref__deref__t__6.get_len ();
            uintptr_t _v_len6 = 0;
            if (_v_len5 < _v_len6)
            {
              goto _block5__branch1;
            }
            uintptr_t _v_len___e__e_tmp_m_rfp__lexrf_m_172_m_14 = (_v_len5 - _v_len6);
            if (!_c_9.term_eq (_v_deref__t__6, (0 + 1)))
            {
              goto _block5__branch1;
            }
            Expr _ve__e__e_tmp_m_rfp__lexrf_m_172_m_14 (_v_deref__deref__t__6, 0, _v_len___e__e_tmp_m_rfp__lexrf_m_172_m_14);
            _ge_line__0__4 = _ge_line__0__4__6;
            _vs_1 = _c_18;
            goto _block5;
          }
        _block5__branch1: {}
          {
            if (_ge_t__6.get_len () != 1)
            {
              goto _block5__branch2;
            }
            if (_ge_t__6.symbol_at (0))
            {
              goto _block5__branch2;
            }
            Expr _v_deref__t__62 (_ge_t__6, 0);
            if (_v_deref__t__62.get_len () != 2)
            {
              goto _block5__branch2;
            }
            if (_v_deref__t__62.symbol_at (0))
            {
              goto _block5__branch2;
            }
            if (_v_deref__t__62.symbol_at ((0 + 1)))
            {
              goto _block5__branch2;
            }
            Expr _v_deref__deref__t__62 (_v_deref__t__62, 0);
            Expr _v_deref__deref__t__622 (_v_deref__t__62, (0 + 1));
            uintptr_t _v_len7 = _v_deref__deref__t__622.get_len ();
            uintptr_t _v_len8 = 1;
            if (_v_len7 < _v_len8)
            {
              goto _block5__branch2;
            }
            uintptr_t _v_len__s = (_v_len7 - _v_len8);
            uintptr_t _v_len9 = _v_deref__deref__t__62.get_len ();
            uintptr_t _v_len10 = 0;
            if (_v_len9 < _v_len10)
            {
              goto _block5__branch2;
            }
            uintptr_t _v_len__p = (_v_len9 - _v_len10);
            if (!_v_deref__deref__t__622.symbol_at (0))
            {
              goto _block5__branch2;
            }
            Expr _ve_p (_v_deref__deref__t__62, 0, _v_len__p);
            Expr _vs_WORD_m_or_m_QWORD (_v_deref__deref__t__622, 0, 1);
            Expr _ve_s (_v_deref__deref__t__622, (0 + 1), _v_len__s);
            Expr _vs_ci_q_;
            {
              {
                if (!_vs_WORD_m_or_m_QWORD.term_eq (_c_10, 0))
                {
                  goto _block6__branch1;
                }
                _vs_ci_q_ = _c_19;
                goto _block6;
              }
            _block6__branch1: {}
              if (!_vs_WORD_m_or_m_QWORD.term_eq (_c_11, 0))
              {
                goto _block5__branch2;
              }
              _vs_ci_q_ = _c_20;
            }
          _block6: {}
            Expr _ge_s__10;
            {
              {
                if (!RF_CALL (Table::Lookup, (rfp__helper::RFP_m_Module_m_Subst, _ve_s), _ge_s__10))
                {
                  goto _block7__branch1;
                }
                goto _block7;
              }
            _block7__branch1: {}
              _ge_s__10 = _ve_s;
            }
          _block7: {}
            {
              {
                if (!RF_CALL (rfp__helper::RFP_m_Debug_q_, /*void*/, /*void*/))
                {
                  goto _block8__branch1;
                }
                RF_CALL (StdIO::PrintLN, (_c_21 + _ge_s__10), /*void*/);
                goto _block8;
              }
            _block8__branch1: {}
            }
          _block8: {}
            Expr _ge_nts__11;
            {
              {
                Expr _ve_include;
                if (!RF_CALL (Find_m_Include_q_, (_ge_s__10, _vs_ci_q_), _ve_include))
                {
                  goto _block9__branch1;
                }
                RF_CALL (Push_m_Source, (_ve_include, _c_4, _c_0, _c_2), /*void*/);
                Expr _v_Scan_m_Tokens2;
                RF_CALL (Scan_m_Tokens, empty, _v_Scan_m_Tokens2);
                _ge_nts__11 = (_ve_nts + _v_Scan_m_Tokens2);
                goto _block9;
              }
            _block9__branch1: {}
              RF_CALL (rfp__err::RFP_m_Error, (_ve_p, (_c_23 + _ge_s__10 + _c_22)), /*void*/);
              _ge_nts__11 = _ve_nts;
            }
          _block9: {}
            _ve_nts = _ge_nts__11;
            _ge_line__0__4 = _ge_line__0__4__6;
            _vs_1 = _c_17;
            goto _block5;
          }
        _block5__branch2: {}
          {
            if (_ge_t__6.get_len () != 1)
            {
              goto _block5__branch3;
            }
            if (_ge_t__6.symbol_at (0))
            {
              goto _block5__branch3;
            }
            Expr _v_deref__t__63 (_ge_t__6, 0);
            if (_v_deref__t__63.get_len () != 2)
            {
              goto _block5__branch3;
            }
            if (_v_deref__t__63.symbol_at (0))
            {
              goto _block5__branch3;
            }
            Expr _v_deref__deref__t__63 (_v_deref__t__63, 0);
            uintptr_t _v_len11 = _v_deref__deref__t__63.get_len ();
            uintptr_t _v_len12 = 0;
            if (_v_len11 < _v_len12)
            {
              goto _block5__branch3;
            }
            uintptr_t _v_len__p2 = (_v_len11 - _v_len12);
            if (!_c_7.term_eq (_v_deref__t__63, (0 + 1)))
            {
              goto _block5__branch3;
            }
            Expr _ve_p (_v_deref__deref__t__63, 0, _v_len__p2);
            RF_CALL (rfp__err::RFP_m_Error, (_ve_p, _c_24), /*void*/);
            _ge_line__0__4 = _ge_line__0__4__6;
            _vs_1 = _c_18;
            goto _block5;
          }
        _block5__branch3: {}
          if (_ge_t__6.get_len () != 1)
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          if (_ge_t__6.symbol_at (0))
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          Expr _v_deref__t__64 (_ge_t__6, 0);
          if (_v_deref__t__64.get_len () != 2)
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          if (_v_deref__t__64.symbol_at (0))
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          if (_v_deref__t__64.symbol_at ((0 + 1)))
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          Expr _v_deref__deref__t__64 (_v_deref__t__64, 0);
          Expr _v_deref__deref__t__642 (_v_deref__t__64, (0 + 1));
          uintptr_t _v_len13 = _v_deref__deref__t__642.get_len ();
          uintptr_t _v_len14 = 0;
          if (_v_len13 < _v_len14)
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          uintptr_t _v_len__tag = (_v_len13 - _v_len14);
          uintptr_t _v_len15 = _v_deref__deref__t__64.get_len ();
          uintptr_t _v_len16 = 0;
          if (_v_len15 < _v_len16)
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          uintptr_t _v_len__p3 = (_v_len15 - _v_len16);
          Expr _ve_p (_v_deref__deref__t__64, 0, _v_len__p3);
          Expr _ve_tag (_v_deref__deref__t__642, 0, _v_len__tag);
          RF_CALL (rfp__err::RFP_m_Error, (_ve_p, (_c_25 + _ve_tag)), /*void*/);
          _ge_line__0__4 = _ge_line__0__4__6;
          _vs_1 = _c_17;
        }
      _block5: {}
      }
    _exit__iter1: {}
      goto _block1;
    }
  _block1__branch2: {}
    {
      if (_ve_t.get_len () != 1)
      {
        goto _block1__branch3;
      }
      if (_ve_t.symbol_at (0))
      {
        goto _block1__branch3;
      }
      Expr _v_deref__t3 (_ve_t, 0);
      if (_v_deref__t3.get_len () != 2)
      {
        goto _block1__branch3;
      }
      if (_v_deref__t3.symbol_at (0))
      {
        goto _block1__branch3;
      }
      Expr _v_deref__deref__t3 (_v_deref__t3, 0);
      uintptr_t _v_len17 = _v_deref__deref__t3.get_len ();
      uintptr_t _v_len18 = 0;
      if (_v_len17 < _v_len18)
      {
        goto _block1__branch3;
      }
      uintptr_t _v_len___e__e_tmp_m_rfp__lexrf_m_204_m_8 = (_v_len17 - _v_len18);
      if (!_c_26.term_eq (_v_deref__t3, (0 + 1)))
      {
        goto _block1__branch3;
      }
      Expr _ve__e__e_tmp_m_rfp__lexrf_m_204_m_8 (_v_deref__deref__t3, 0, _v_len___e__e_tmp_m_rfp__lexrf_m_204_m_8);
      Expr _ve_nts (empty);
      Expr _ge_line__0__4 (_ge_line__0);
      Expr _vs_1 (_c_17);
      for ( ; ; )
      {
        {
          if (!_vs_1.term_eq (_c_18, 0))
          {
            goto _iter2;
          }
          Expr _v_Scan_m_Tokens3;
          RF_CALL (Scan_m_Tokens, _ge_line__0__4, _v_Scan_m_Tokens3);
          _v_res1 = (_ve_nts + _v_Scan_m_Tokens3);
          goto _exit__iter2;
        }
      _iter2: {}
        Expr _ge_t__6;
        Expr _ge_line__0__4__6;
        RF_CALL (Scan_m_Token, _ge_line__0__4, (_ge_t__6, _ge_line__0__4__6));
        {
          {
            if (_ge_t__6.get_len () != 1)
            {
              goto _block12__branch1;
            }
            if (_ge_t__6.symbol_at (0))
            {
              goto _block12__branch1;
            }
            Expr _v_deref__t__65 (_ge_t__6, 0);
            if (_v_deref__t__65.get_len () != 2)
            {
              goto _block12__branch1;
            }
            if (_v_deref__t__65.symbol_at (0))
            {
              goto _block12__branch1;
            }
            Expr _v_deref__deref__t__65 (_v_deref__t__65, 0);
            uintptr_t _v_len19 = _v_deref__deref__t__65.get_len ();
            uintptr_t _v_len20 = 0;
            if (_v_len19 < _v_len20)
            {
              goto _block12__branch1;
            }
            uintptr_t _v_len___e__e_tmp_m_rfp__lexrf_m_208_m_14 = (_v_len19 - _v_len20);
            if (!_c_9.term_eq (_v_deref__t__65, (0 + 1)))
            {
              goto _block12__branch1;
            }
            Expr _ve__e__e_tmp_m_rfp__lexrf_m_208_m_14 (_v_deref__deref__t__65, 0, _v_len___e__e_tmp_m_rfp__lexrf_m_208_m_14);
            _ge_line__0__4 = _ge_line__0__4__6;
            _vs_1 = _c_18;
            goto _block12;
          }
        _block12__branch1: {}
          {
            if (_ge_t__6.get_len () != 1)
            {
              goto _block12__branch2;
            }
            if (_ge_t__6.symbol_at (0))
            {
              goto _block12__branch2;
            }
            Expr _v_deref__t__66 (_ge_t__6, 0);
            if (_v_deref__t__66.get_len () != 2)
            {
              goto _block12__branch2;
            }
            if (_v_deref__t__66.symbol_at (0))
            {
              goto _block12__branch2;
            }
            if (_v_deref__t__66.symbol_at ((0 + 1)))
            {
              goto _block12__branch2;
            }
            Expr _v_deref__deref__t__66 (_v_deref__t__66, 0);
            Expr _v_deref__deref__t__662 (_v_deref__t__66, (0 + 1));
            uintptr_t _v_len21 = _v_deref__deref__t__662.get_len ();
            uintptr_t _v_len22 = 1;
            if (_v_len21 < _v_len22)
            {
              goto _block12__branch2;
            }
            uintptr_t _v_len__s2 = (_v_len21 - _v_len22);
            uintptr_t _v_len23 = _v_deref__deref__t__66.get_len ();
            uintptr_t _v_len24 = 0;
            if (_v_len23 < _v_len24)
            {
              goto _block12__branch2;
            }
            uintptr_t _v_len__p4 = (_v_len23 - _v_len24);
            if (!_v_deref__deref__t__662.symbol_at (0))
            {
              goto _block12__branch2;
            }
            Expr _ve_p (_v_deref__deref__t__66, 0, _v_len__p4);
            Expr _vs_WORD_m_or_m_QWORD (_v_deref__deref__t__662, 0, 1);
            Expr _ve_s (_v_deref__deref__t__662, (0 + 1), _v_len__s2);
            Expr _vs_ci_q_;
            {
              {
                if (!_vs_WORD_m_or_m_QWORD.term_eq (_c_10, 0))
                {
                  goto _block13__branch1;
                }
                _vs_ci_q_ = _c_19;
                goto _block13;
              }
            _block13__branch1: {}
              if (!_vs_WORD_m_or_m_QWORD.term_eq (_c_11, 0))
              {
                goto _block12__branch2;
              }
              _vs_ci_q_ = _c_20;
            }
          _block13: {}
            Expr _ge_s__9 ((_c_27 + _ve_s));
            {
              {
                if (!RF_CALL (rfp__helper::RFP_m_Debug_q_, /*void*/, /*void*/))
                {
                  goto _block14__branch1;
                }
                RF_CALL (StdIO::PrintLN, (_c_21 + _ge_s__9), /*void*/);
                goto _block14;
              }
            _block14__branch1: {}
            }
          _block14: {}
            Expr _ge_nts__10;
            {
              {
                Expr _ve_include;
                if (!RF_CALL (Find_m_Include_q_, (_ge_s__9, _vs_ci_q_), _ve_include))
                {
                  goto _block15__branch1;
                }
                RF_CALL (Push_m_Source, (_ve_include, _c_4, _c_0, _c_2), /*void*/);
                Expr _v_Scan_m_Tokens4;
                RF_CALL (Scan_m_Tokens, empty, _v_Scan_m_Tokens4);
                _ge_nts__10 = (_ve_nts + _v_Scan_m_Tokens4);
                goto _block15;
              }
            _block15__branch1: {}
              RF_CALL (rfp__err::RFP_m_Error, (_ve_p, (_c_23 + _ge_s__9 + _c_22)), /*void*/);
              _ge_nts__10 = _ve_nts;
            }
          _block15: {}
            _ve_nts = _ge_nts__10;
            _ge_line__0__4 = _ge_line__0__4__6;
            _vs_1 = _c_17;
            goto _block12;
          }
        _block12__branch2: {}
          {
            if (_ge_t__6.get_len () != 1)
            {
              goto _block12__branch3;
            }
            if (_ge_t__6.symbol_at (0))
            {
              goto _block12__branch3;
            }
            Expr _v_deref__t__67 (_ge_t__6, 0);
            if (_v_deref__t__67.get_len () != 2)
            {
              goto _block12__branch3;
            }
            if (_v_deref__t__67.symbol_at (0))
            {
              goto _block12__branch3;
            }
            Expr _v_deref__deref__t__67 (_v_deref__t__67, 0);
            uintptr_t _v_len25 = _v_deref__deref__t__67.get_len ();
            uintptr_t _v_len26 = 0;
            if (_v_len25 < _v_len26)
            {
              goto _block12__branch3;
            }
            uintptr_t _v_len__p5 = (_v_len25 - _v_len26);
            if (!_c_7.term_eq (_v_deref__t__67, (0 + 1)))
            {
              goto _block12__branch3;
            }
            Expr _ve_p (_v_deref__deref__t__67, 0, _v_len__p5);
            RF_CALL (rfp__err::RFP_m_Error, (_ve_p, _c_24), /*void*/);
            _ge_line__0__4 = _ge_line__0__4__6;
            _vs_1 = _c_18;
            goto _block12;
          }
        _block12__branch3: {}
          if (_ge_t__6.get_len () != 1)
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          if (_ge_t__6.symbol_at (0))
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          Expr _v_deref__t__68 (_ge_t__6, 0);
          if (_v_deref__t__68.get_len () != 2)
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          if (_v_deref__t__68.symbol_at (0))
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          if (_v_deref__t__68.symbol_at ((0 + 1)))
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          Expr _v_deref__deref__t__68 (_v_deref__t__68, 0);
          Expr _v_deref__deref__t__682 (_v_deref__t__68, (0 + 1));
          uintptr_t _v_len27 = _v_deref__deref__t__682.get_len ();
          uintptr_t _v_len28 = 0;
          if (_v_len27 < _v_len28)
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          uintptr_t _v_len__tag2 = (_v_len27 - _v_len28);
          uintptr_t _v_len29 = _v_deref__deref__t__68.get_len ();
          uintptr_t _v_len30 = 0;
          if (_v_len29 < _v_len30)
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          uintptr_t _v_len__p6 = (_v_len29 - _v_len30);
          Expr _ve_p (_v_deref__deref__t__68, 0, _v_len__p6);
          Expr _ve_tag (_v_deref__deref__t__682, 0, _v_len__tag2);
          RF_CALL (rfp__err::RFP_m_Error, (_ve_p, (_c_25 + _ve_tag)), /*void*/);
          _ge_line__0__4 = _ge_line__0__4__6;
          _vs_1 = _c_17;
        }
      _block12: {}
      }
    _exit__iter2: {}
      goto _block1;
    }
  _block1__branch3: {}
    uintptr_t _v_len31 = _ve_t.get_len ();
    uintptr_t _v_len32 = 0;
    if (_v_len31 < _v_len32)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    uintptr_t _v_len___e__e_tmp_m_rfp__lexrf_m_237_m_6 = (_v_len31 - _v_len32);
    Expr _ve__e__e_tmp_m_rfp__lexrf_m_237_m_6 (_ve_t, 0, _v_len___e__e_tmp_m_rfp__lexrf_m_237_m_6);
    Expr _v_Scan_m_Tokens5;
    RF_CALL (Scan_m_Tokens, _ge_line__0, _v_Scan_m_Tokens5);
    _v_res1 = (_ve_t + _v_Scan_m_Tokens5);
  }
_block1: {}
RF_END

RF_FUNC (Scan_m_Token, (RF_ARG _ve_line;;), (RF_RES _v_res1, _v_res2;;))
  {
    {
      if (_ve_line.get_len () != 0)
      {
        goto _block1__branch1;
      }
      {
        {
          Expr _ge_line__4;
          if (!RF_CALL (Get_m_Source_m_Line, /*void*/, _ge_line__4))
          {
            goto _block2__branch1;
          }
          RF_TAILCALL (Scan_m_Token, _ge_line__4, (_v_res1, _v_res2));
          goto _block2;
        }
      _block2__branch1: {}
        Expr _ge_auxcall1;
        RF_CALL (Token_m_Position, /*void*/, _ge_auxcall1);
        _v_res1 = (_ge_auxcall1 () + _c_7) ();
        _v_res2 = empty;
      }
    _block2: {}
      goto _block1;
    }
  _block1__branch1: {}
    uintptr_t _v_len1 = _ve_line.get_len ();
    uintptr_t _v_len2 = 1;
    if (_v_len1 < _v_len2)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    uintptr_t _v_len__rest = (_v_len1 - _v_len2);
    if (!_ve_line.symbol_at (0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _vs_char (_ve_line, 0, 1);
    Expr _ve_rest (_ve_line, (0 + 1), _v_len__rest);
    Expr _ve_saved_m_position;
    RF_CALL (Token_m_Position, /*void*/, _ve_saved_m_position);
    {
      {
        if (!RF_CALL (Blank_q_, _vs_char, /*void*/))
        {
          goto _block3__branch1;
        }
        RF_CALL (Next_m_Column, /*void*/, /*void*/);
        RF_TAILCALL (Scan_m_Token, _ve_rest, (_v_res1, _v_res2));
        goto _block3;
      }
    _block3__branch1: {}
      {
        Expr _vs_tk;
        {
          {
            if (!_vs_char.term_eq (_c_28, 0))
            {
              goto _block4__branch1;
            }
            _vs_tk = _c_29;
            goto _block4;
          }
        _block4__branch1: {}
          {
            if (!_vs_char.term_eq (_c_30, 0))
            {
              goto _block4__branch2;
            }
            _vs_tk = _c_31;
            goto _block4;
          }
        _block4__branch2: {}
          {
            if (!_vs_char.term_eq (_c_32, 0))
            {
              goto _block4__branch3;
            }
            _vs_tk = _c_33;
            goto _block4;
          }
        _block4__branch3: {}
          {
            if (!_vs_char.term_eq (_c_34, 0))
            {
              goto _block4__branch4;
            }
            _vs_tk = _c_35;
            goto _block4;
          }
        _block4__branch4: {}
          {
            if (!_vs_char.term_eq (_c_36, 0))
            {
              goto _block4__branch5;
            }
            _vs_tk = _c_37;
            goto _block4;
          }
        _block4__branch5: {}
          {
            if (!_vs_char.term_eq (_c_38, 0))
            {
              goto _block4__branch6;
            }
            _vs_tk = _c_39;
            goto _block4;
          }
        _block4__branch6: {}
          {
            if (!_vs_char.term_eq (_c_40, 0))
            {
              goto _block4__branch7;
            }
            _vs_tk = _c_41;
            goto _block4;
          }
        _block4__branch7: {}
          {
            if (!_vs_char.term_eq (_c_42, 0))
            {
              goto _block4__branch8;
            }
            _vs_tk = _c_43;
            goto _block4;
          }
        _block4__branch8: {}
          {
            if (!_vs_char.term_eq (_c_44, 0))
            {
              goto _block4__branch9;
            }
            _vs_tk = _c_45;
            goto _block4;
          }
        _block4__branch9: {}
          {
            if (!_vs_char.term_eq (_c_46, 0))
            {
              goto _block4__branch10;
            }
            _vs_tk = _c_47;
            goto _block4;
          }
        _block4__branch10: {}
          if (!_vs_char.term_eq (_c_48, 0))
          {
            goto _block3__branch2;
          }
          _vs_tk = _c_49;
        }
      _block4: {}
        RF_CALL (Next_m_Column, /*void*/, /*void*/);
        _v_res1 = (_ve_saved_m_position () + _vs_tk ()) ();
        _v_res2 = _ve_rest;
        goto _block3;
      }
    _block3__branch2: {}
      {
        {
          {
            if (!_vs_char.term_eq (_c_50, 0))
            {
              goto _block5__branch1;
            }
            RF_CALL (Next_m_Column, /*void*/, /*void*/);
            {
              {
                uintptr_t _v_len3 = _v_len__rest;
                uintptr_t _v_len4 = 1;
                if (_v_len3 < _v_len4)
                {
                  goto _block6__branch1;
                }
                uintptr_t _v_len__rest2 = (_v_len3 - _v_len4);
                if (!_c_50.term_eq (_ve_rest, 0))
                {
                  goto _block6__branch1;
                }
                Expr _ve_rest2 (_ve_rest, (0 + 1), _v_len__rest2);
                RF_CALL (Next_m_Column, /*void*/, /*void*/);
                _v_res1 = (_ve_saved_m_position () + _c_51) ();
                _v_res2 = _ve_rest2;
                goto _block6;
              }
            _block6__branch1: {}
              _v_res1 = (_ve_saved_m_position () + _c_52) ();
              _v_res2 = _ve_rest;
            }
          _block6: {}
            goto _block5;
          }
        _block5__branch1: {}
          {
            if (!_vs_char.term_eq (_c_53, 0))
            {
              goto _block5__branch2;
            }
            RF_CALL (Next_m_Column, /*void*/, /*void*/);
            {
              {
                uintptr_t _v_len5 = _v_len__rest;
                uintptr_t _v_len6 = 1;
                if (_v_len5 < _v_len6)
                {
                  goto _block7__branch1;
                }
                uintptr_t _v_len__rest22 = (_v_len5 - _v_len6);
                if (!_ve_rest.symbol_at (0))
                {
                  goto _block7__branch1;
                }
                Expr _vs_char2 (_ve_rest, 0, 1);
                Expr _ve_rest2 (_ve_rest, (0 + 1), _v_len__rest22);
                {
                  {
                    Expr _vs_tk;
                    {
                      {
                        if (!_vs_char2.term_eq (_c_54, 0))
                        {
                          goto _block9__branch1;
                        }
                        _vs_tk = _c_55;
                        goto _block9;
                      }
                    _block9__branch1: {}
                      {
                        if (!_vs_char2.term_eq (_c_56, 0))
                        {
                          goto _block9__branch2;
                        }
                        _vs_tk = _c_57;
                        goto _block9;
                      }
                    _block9__branch2: {}
                      if (!_vs_char2.term_eq (_c_36, 0))
                      {
                        goto _block8__branch1;
                      }
                      _vs_tk = _c_58;
                    }
                  _block9: {}
                    RF_CALL (Next_m_Column, /*void*/, /*void*/);
                    _v_res1 = (_ve_saved_m_position () + _vs_tk ()) ();
                    _v_res2 = _ve_rest2;
                    goto _block8;
                  }
                _block8__branch1: {}
                  Expr _ge_auxcall2;
                  RF_CALL (Token_m_Position, /*void*/, _ge_auxcall2);
                  RF_CALL (rfp__err::RFP_m_Error, (_ge_auxcall2, (_c_60 + _vs_char2 + _c_59)), /*void*/);
                  RF_CALL (Next_m_Column, /*void*/, /*void*/);
                  RF_TAILCALL (Scan_m_Token, _ve_rest2, (_v_res1, _v_res2));
                }
              _block8: {}
                goto _block7;
              }
            _block7__branch1: {}
              Expr _ge_auxcall3;
              RF_CALL (Token_m_Position, /*void*/, _ge_auxcall3);
              RF_CALL (rfp__err::RFP_m_Error, (_ge_auxcall3, _c_61), /*void*/);
              RF_TAILCALL (Scan_m_Token, empty, (_v_res1, _v_res2));
            }
          _block7: {}
            goto _block5;
          }
        _block5__branch2: {}
          {
            if (!_vs_char.term_eq (_c_62, 0))
            {
              goto _block5__branch3;
            }
            RF_CALL (Next_m_Column, /*void*/, /*void*/);
            {
              {
                uintptr_t _v_len7 = _v_len__rest;
                uintptr_t _v_len8 = 1;
                if (_v_len7 < _v_len8)
                {
                  goto _block10__branch1;
                }
                uintptr_t _v_len__rest23 = (_v_len7 - _v_len8);
                if (!_c_62.term_eq (_ve_rest, 0))
                {
                  goto _block10__branch1;
                }
                Expr _ve_rest2 (_ve_rest, (0 + 1), _v_len__rest23);
                RF_TAILCALL (Scan_m_Token, empty, (_v_res1, _v_res2));
                goto _block10;
              }
            _block10__branch1: {}
              {
                uintptr_t _v_len9 = _v_len__rest;
                uintptr_t _v_len10 = 1;
                if (_v_len9 < _v_len10)
                {
                  goto _block10__branch2;
                }
                uintptr_t _v_len__rest24 = (_v_len9 - _v_len10);
                if (!_c_63.term_eq (_ve_rest, 0))
                {
                  goto _block10__branch2;
                }
                Expr _ve_rest2 (_ve_rest, (0 + 1), _v_len__rest24);
                RF_CALL (Next_m_Column, /*void*/, /*void*/);
                Expr _ge_auxcall4;
                if (!RF_CALL (Skip_m_Comment, _ve_rest2, _ge_auxcall4))
                {
                  RF_FUNC_ERROR (unexpected_fail);
                }
                RF_TAILCALL (Scan_m_Token, _ge_auxcall4, (_v_res1, _v_res2));
                goto _block10;
              }
            _block10__branch2: {}
              {
                uintptr_t _v_len11 = _v_len__rest;
                uintptr_t _v_len12 = 1;
                if (_v_len11 < _v_len12)
                {
                  goto _block10__branch3;
                }
                uintptr_t _v_len__rest25 = (_v_len11 - _v_len12);
                if (!_ve_rest.symbol_at (0))
                {
                  goto _block10__branch3;
                }
                Expr _vs_err (_ve_rest, 0, 1);
                Expr _ve_rest2 (_ve_rest, (0 + 1), _v_len__rest25);
                Expr _ge_auxcall5;
                RF_CALL (Token_m_Position, /*void*/, _ge_auxcall5);
                RF_CALL (rfp__err::RFP_m_Error, (_ge_auxcall5, (_c_60 + _vs_err + _c_59)), /*void*/);
                RF_CALL (Next_m_Column, /*void*/, /*void*/);
                RF_TAILCALL (Scan_m_Token, _ve_rest2, (_v_res1, _v_res2));
                goto _block10;
              }
            _block10__branch3: {}
              if (_v_len__rest != 0)
              {
                RF_FUNC_ERROR (unexpected_fail);
              }
              Expr _ge_auxcall6;
              RF_CALL (Token_m_Position, /*void*/, _ge_auxcall6);
              RF_CALL (rfp__err::RFP_m_Error, (_ge_auxcall6, _c_61), /*void*/);
              RF_TAILCALL (Scan_m_Token, empty, (_v_res1, _v_res2));
            }
          _block10: {}
            goto _block5;
          }
        _block5__branch3: {}
          if (!_vs_char.term_eq (_c_63, 0))
          {
            goto _block3__branch3;
          }
          RF_TAILCALL (Scan_m_Token, empty, (_v_res1, _v_res2));
        }
      _block5: {}
        goto _block3;
      }
    _block3__branch3: {}
      {
        Expr _ve_tk;
        Expr _ve_new_m_line;
        {
          {
            if (!RF_CALL (Scan_m_Keyword_q_, _ve_line, (_ve_tk, _ve_new_m_line)))
            {
              goto _block11__branch1;
            }
            goto _block11;
          }
        _block11__branch1: {}
          {
            if (!RF_CALL (Scan_m_Identifier_q_, _ve_line, (_ve_tk, _ve_new_m_line)))
            {
              goto _block11__branch2;
            }
            goto _block11;
          }
        _block11__branch2: {}
          {
            if (!RF_CALL (Scan_m_Variable_q_, _ve_line, (_ve_tk, _ve_new_m_line)))
            {
              goto _block11__branch3;
            }
            goto _block11;
          }
        _block11__branch3: {}
          {
            if (!RF_CALL (Scan_m_Word_q_, _ve_line, (_ve_tk, _ve_new_m_line)))
            {
              goto _block11__branch4;
            }
            goto _block11;
          }
        _block11__branch4: {}
          {
            if (!RF_CALL (Scan_m_String_q_, _ve_line, (_ve_tk, _ve_new_m_line)))
            {
              goto _block11__branch5;
            }
            goto _block11;
          }
        _block11__branch5: {}
          if (!RF_CALL (Scan_m_Number_q_, _ve_line, (_ve_tk, _ve_new_m_line)))
          {
            goto _block3__branch4;
          }
        }
      _block11: {}
        _v_res1 = (_ve_saved_m_position () + _ve_tk ()) ();
        _v_res2 = _ve_new_m_line;
        goto _block3;
      }
    _block3__branch4: {}
      Expr _ge_auxcall7;
      RF_CALL (Token_m_Position, /*void*/, _ge_auxcall7);
      RF_CALL (rfp__err::RFP_m_Error, (_ge_auxcall7, (_c_60 + _vs_char + _c_59)), /*void*/);
      RF_CALL (Next_m_Column, /*void*/, /*void*/);
      RF_TAILCALL (Scan_m_Token, _ve_rest, (_v_res1, _v_res2));
    }
  _block3: {}
  }
_block1: {}
RF_END

RF_FUNC (Get_m_Source_m_Line, RF_VOID, (RF_RES _v_res1;;))
  Expr _ge_auxcall1;
  RF_CALL (Box::_q_, Source, _ge_auxcall1);
  Expr _ve_line;
  if (!RF_CALL (rfp__src::RFP_m_Src_m_Get_m_Line, _ge_auxcall1, _ve_line))
  {
    RF_RETFAIL;
  }
  RF_CALL (Next_m_Row, /*void*/, /*void*/);
  _v_res1 = _ve_line;
RF_END

RF_FUNC (Blank_q_, (RF_ARG _vs_char;;), RF_VOID)
  RF_lsplit (_c_64, 0, _ve__e__e_tmp_m_rfp__lexrf_m_328_m_14, _v_lsplit__64);
  for ( ; ; RF_iter(_c_64)++)
  {
    {
      if (!RF_iter(_c_64))
      {
        RF_RETFAIL;
      }
      uintptr_t _v_len1 = _v_lsplit__64.get_len ();
      uintptr_t _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        RF_RETFAIL;
      }
      uintptr_t _v_len___e__e_tmp_m_rfp__lexrf_m_328_m_23 = (_v_len1 - _v_len2);
      if (!_vs_char.term_eq (_v_lsplit__64, 0))
      {
        goto _continue1;
      }
      Expr _ve__e__e_tmp_m_rfp__lexrf_m_328_m_23 (_v_lsplit__64, (0 + 1), _v_len___e__e_tmp_m_rfp__lexrf_m_328_m_23);
      goto _exit1;
    }
_continue1: {}
  }
_exit1: {}
RF_END

RF_FUNC (Skip_m_Blank, (RF_ARG _ve_line;;), (RF_RES _v_res1;;))
  {
    {
      if (_ve_line.get_len () != 0)
      {
        goto _block1__branch1;
      }
      Expr _ge_auxcall1;
      if (!RF_CALL (Get_m_Source_m_Line, /*void*/, _ge_auxcall1))
      {
        RF_RETFAIL;
      }
      RF_TAILCALL (Skip_m_Blank, _ge_auxcall1, _v_res1);
      goto _block1;
    }
  _block1__branch1: {}
    uintptr_t _v_len1 = _ve_line.get_len ();
    uintptr_t _v_len2 = 1;
    if (_v_len1 < _v_len2)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    uintptr_t _v_len__rest = (_v_len1 - _v_len2);
    if (!_ve_line.symbol_at (0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _vs_char (_ve_line, 0, 1);
    Expr _ve_rest (_ve_line, (0 + 1), _v_len__rest);
    {
      {
        if (!RF_CALL (Blank_q_, _vs_char, /*void*/))
        {
          goto _block2__branch1;
        }
        RF_CALL (Next_m_Column, /*void*/, /*void*/);
        RF_TAILCALL (Skip_m_Blank, _ve_rest, _v_res1);
        goto _block2;
      }
    _block2__branch1: {}
      _v_res1 = _ve_line;
    }
  _block2: {}
  }
_block1: {}
RF_END

RF_FUNC (Scan_m_Keyword_q_, (RF_ARG _ge_arg1;;), (RF_RES _v_res1, _v_res2;;))
  uintptr_t _v_len1 = _ge_arg1.get_len ();
  uintptr_t _v_len2 = 1;
  if (_v_len1 < _v_len2)
  {
    RF_RETFAIL;
  }
  uintptr_t _v_len__rest = (_v_len1 - _v_len2);
  if (!_c_65.term_eq (_ge_arg1, 0))
  {
    RF_RETFAIL;
  }
  Expr _ve_rest (_ge_arg1, (0 + 1), _v_len__rest);
  RF_CALL (Next_m_Column, /*void*/, /*void*/);
  Expr _ve_ident;
  Expr _ve_line;
  RF_CALL (Scan_m_Keyword_m_Rest, (_c_65, _ve_rest), (_ve_ident, _ve_line));
  Expr _ge_auxalt1;
  {
    {
      if (!RF_CALL (Table::In_m_Table_q_, (rfp__helper::RFP_m_Options, _c_66), /*void*/))
      {
        goto _block1__branch1;
      }
      RF_CALL (Convert::To_m_Lower, _ve_ident, _ge_auxalt1);
      goto _block1;
    }
  _block1__branch1: {}
    _ge_auxalt1 = _ve_ident;
  }
_block1: {}
  Expr _vs_key;
  {
    {
      if (_ge_auxalt1.get_len () != 4)
      {
        goto _block2__branch1;
      }
      if (!_c_67.eq (_ge_auxalt1, 0))
      {
        goto _block2__branch1;
      }
      _vs_key = _c_68;
      goto _block2;
    }
  _block2__branch1: {}
    {
      if (_ge_auxalt1.get_len () != 8)
      {
        goto _block2__branch2;
      }
      if (!_c_69.eq (_ge_auxalt1, 0))
      {
        goto _block2__branch2;
      }
      _vs_key = _c_70;
      goto _block2;
    }
  _block2__branch2: {}
    {
      if (_ge_auxalt1.get_len () != 6)
      {
        goto _block2__branch3;
      }
      if (!_c_71.eq (_ge_auxalt1, 0))
      {
        goto _block2__branch3;
      }
      _vs_key = _c_72;
      goto _block2;
    }
  _block2__branch3: {}
    {
      if (_ge_auxalt1.get_len () != 6)
      {
        goto _block2__branch4;
      }
      if (!_c_73.eq (_ge_auxalt1, 0))
      {
        goto _block2__branch4;
      }
      _vs_key = _c_74;
      goto _block2;
    }
  _block2__branch4: {}
    {
      if (_ge_auxalt1.get_len () != 5)
      {
        goto _block2__branch5;
      }
      if (!_c_75.eq (_ge_auxalt1, 0))
      {
        goto _block2__branch5;
      }
      _vs_key = _c_76;
      goto _block2;
    }
  _block2__branch5: {}
    {
      if (_ge_auxalt1.get_len () != 5)
      {
        goto _block2__branch6;
      }
      if (!_c_77.eq (_ge_auxalt1, 0))
      {
        goto _block2__branch6;
      }
      _vs_key = _c_78;
      goto _block2;
    }
  _block2__branch6: {}
    {
      if (_ge_auxalt1.get_len () != 6)
      {
        goto _block2__branch7;
      }
      if (!_c_79.eq (_ge_auxalt1, 0))
      {
        goto _block2__branch7;
      }
      _vs_key = _c_80;
      goto _block2;
    }
  _block2__branch7: {}
    {
      if (_ge_auxalt1.get_len () != 6)
      {
        goto _block2__branch8;
      }
      if (!_c_81.eq (_ge_auxalt1, 0))
      {
        goto _block2__branch8;
      }
      {
        {
          if (!RF_CALL (Table::In_m_Table_q_, (rfp__helper::RFP_m_Options, _c_82), /*void*/))
          {
            goto _block3__branch1;
          }
          _vs_key = _c_83;
          goto _block3;
        }
      _block3__branch1: {}
        Expr _ge_auxcall2;
        RF_CALL (Token_m_Position, /*void*/, _ge_auxcall2);
        RF_CALL (rfp__err::RFP_m_Error, (_ge_auxcall2, _c_84), /*void*/);
        _vs_key = _c_83;
      }
    _block3: {}
      goto _block2;
    }
  _block2__branch8: {}
    {
      if (_ge_auxalt1.get_len () != 7)
      {
        goto _block2__branch9;
      }
      if (!_c_85.eq (_ge_auxalt1, 0))
      {
        goto _block2__branch9;
      }
      _vs_key = _c_86;
      goto _block2;
    }
  _block2__branch9: {}
    {
      if (_ge_auxalt1.get_len () != 5)
      {
        goto _block2__branch10;
      }
      if (!_c_87.eq (_ge_auxalt1, 0))
      {
        goto _block2__branch10;
      }
      _vs_key = _c_88;
      goto _block2;
    }
  _block2__branch10: {}
    {
      if (_ge_auxalt1.get_len () != 2)
      {
        goto _block2__branch11;
      }
      if (!_c_89.eq (_ge_auxalt1, 0))
      {
        goto _block2__branch11;
      }
      _vs_key = _c_90;
      goto _block2;
    }
  _block2__branch11: {}
    {
      if (_ge_auxalt1.get_len () != 2)
      {
        goto _block2__branch12;
      }
      if (!_c_91.eq (_ge_auxalt1, 0))
      {
        goto _block2__branch12;
      }
      _vs_key = _c_92;
      goto _block2;
    }
  _block2__branch12: {}
    {
      if (_ge_auxalt1.get_len () != 7)
      {
        goto _block2__branch13;
      }
      if (!_c_93.eq (_ge_auxalt1, 0))
      {
        goto _block2__branch13;
      }
      _vs_key = _c_94;
      goto _block2;
    }
  _block2__branch13: {}
    {
      if (_ge_auxalt1.get_len () != 6)
      {
        goto _block2__branch14;
      }
      if (!_c_95.eq (_ge_auxalt1, 0))
      {
        goto _block2__branch14;
      }
      _vs_key = _c_96;
      goto _block2;
    }
  _block2__branch14: {}
    {
      if (_ge_auxalt1.get_len () != 6)
      {
        goto _block2__branch15;
      }
      if (!_c_97.eq (_ge_auxalt1, 0))
      {
        goto _block2__branch15;
      }
      _vs_key = _c_98;
      goto _block2;
    }
  _block2__branch15: {}
    {
      if (_ge_auxalt1.get_len () != 9)
      {
        goto _block2__branch16;
      }
      if (!_c_99.eq (_ge_auxalt1, 0))
      {
        goto _block2__branch16;
      }
      _vs_key = _c_100;
      goto _block2;
    }
  _block2__branch16: {}
    {
      if (_ge_auxalt1.get_len () != 5)
      {
        goto _block2__branch17;
      }
      if (!_c_101.eq (_ge_auxalt1, 0))
      {
        goto _block2__branch17;
      }
      _vs_key = _c_102;
      goto _block2;
    }
  _block2__branch17: {}
    {
      if (_ge_auxalt1.get_len () != 4)
      {
        goto _block2__branch18;
      }
      if (!_c_103.eq (_ge_auxalt1, 0))
      {
        goto _block2__branch18;
      }
      _vs_key = _c_104;
      goto _block2;
    }
  _block2__branch18: {}
    {
      if (_ge_auxalt1.get_len () != 7)
      {
        goto _block2__branch19;
      }
      if (!_c_105.eq (_ge_auxalt1, 0))
      {
        goto _block2__branch19;
      }
      _vs_key = _c_106;
      goto _block2;
    }
  _block2__branch19: {}
    {
      if (_ge_auxalt1.get_len () != 7)
      {
        goto _block2__branch20;
      }
      if (!_c_107.eq (_ge_auxalt1, 0))
      {
        goto _block2__branch20;
      }
      _vs_key = _c_108;
      goto _block2;
    }
  _block2__branch20: {}
    if (_ge_auxalt1.get_len () != 5)
    {
      RF_RETFAIL;
    }
    if (!_c_109.eq (_ge_auxalt1, 0))
    {
      RF_RETFAIL;
    }
    _vs_key = _c_110;
  }
_block2: {}
  _v_res1 = _vs_key;
  _v_res2 = _ve_line;
RF_END

RF_FUNC (Scan_m_Keyword_m_Rest, (RF_ARG _ve_start, _ve_line;;), (RF_RES _v_res1, _v_res2;;))
  Expr _ve_w (_ve_start);
  Expr _ve_l (_ve_line);
  Expr _vs_cond (_c_17);
  for ( ; ; )
  {
    {
      if (!_vs_cond.term_eq (_c_18, 0))
      {
        goto _iter1;
      }
      _v_res1 = _ve_w;
      _v_res2 = _ve_l;
      goto _exit__iter1;
    }
  _iter1: {}
    {
      {
        uintptr_t _v_len1 = _ve_l.get_len ();
        uintptr_t _v_len2 = 1;
        if (_v_len1 < _v_len2)
        {
          goto _block1__branch1;
        }
        uintptr_t _v_len__rest = (_v_len1 - _v_len2);
        if (!_ve_l.symbol_at (0))
        {
          goto _block1__branch1;
        }
        Expr _vs_first (_ve_l, 0, 1);
        Expr _ve_rest (_ve_l, (0 + 1), _v_len__rest);
        {
          {
            if (!RF_CALL (Class::Letter_q_, _vs_first, /*void*/))
            {
              goto _block2__branch1;
            }
            goto _block2;
          }
        _block2__branch1: {}
          {
            {
              if (!_vs_first.term_eq (_c_54, 0))
              {
                goto _block3__branch1;
              }
              goto _block3;
            }
          _block3__branch1: {}
            if (!_vs_first.term_eq (_c_56, 0))
            {
              goto _block1__branch1;
            }
          }
        _block3: {}
        }
      _block2: {}
        RF_CALL (Next_m_Column, /*void*/, /*void*/);
        _ve_w = (_ve_w + _vs_first);
        _ve_l = _ve_rest;
        _vs_cond = _c_17;
        goto _block1;
      }
    _block1__branch1: {}
      _vs_cond = _c_18;
    }
  _block1: {}
  }
_exit__iter1: {}
RF_END

RF_FUNC (Scan_m_Variable_q_, (RF_ARG _ve_line;;), (RF_RES _v_res1, _v_res2;;))
  uintptr_t _v_len1 = _ve_line.get_len ();
  uintptr_t _v_len2 = 1;
  if (_v_len1 < _v_len2)
  {
    RF_RETFAIL;
  }
  uintptr_t _v_len__rest = (_v_len1 - _v_len2);
  if (!_ve_line.symbol_at (0))
  {
    RF_RETFAIL;
  }
  Expr _vs_first (_ve_line, 0, 1);
  Expr _ve_rest (_ve_line, (0 + 1), _v_len__rest);
  Expr _vs_type;
  {
    {
      if (!_vs_first.term_eq (_c_111, 0))
      {
        goto _block1__branch1;
      }
      _vs_type = _c_112;
      goto _block1;
    }
  _block1__branch1: {}
    {
      if (!_vs_first.term_eq (_c_113, 0))
      {
        goto _block1__branch2;
      }
      _vs_type = _c_114;
      goto _block1;
    }
  _block1__branch2: {}
    {
      if (!_vs_first.term_eq (_c_115, 0))
      {
        goto _block1__branch3;
      }
      _vs_type = _c_116;
      goto _block1;
    }
  _block1__branch3: {}
    if (!_vs_first.term_eq (_c_117, 0))
    {
      RF_RETFAIL;
    }
    _vs_type = _c_118;
  }
_block1: {}
  RF_CALL (Next_m_Column, /*void*/, /*void*/);
  Expr _ve_name;
  Expr _ve_new_m_line;
  {
    {
      uintptr_t _v_len3 = _v_len__rest;
      uintptr_t _v_len4 = 1;
      if (_v_len3 < _v_len4)
      {
        goto _block2__branch1;
      }
      uintptr_t _v_len__rest2 = (_v_len3 - _v_len4);
      if (!_c_119.term_eq (_ve_rest, 0))
      {
        goto _block2__branch1;
      }
      Expr _ve_rest2 (_ve_rest, (0 + 1), _v_len__rest2);
      RF_CALL (Next_m_Column, /*void*/, /*void*/);
      RF_CALL (Scan_m_Identifier_m_Rest, (_c_120, empty, _ve_rest2), (_ve_name, _ve_new_m_line));
      goto _block2;
    }
  _block2__branch1: {}
    RF_CALL (Scan_m_Identifier_m_Rest, (_c_120, empty, _ve_rest), (_ve_name, _ve_new_m_line));
  }
_block2: {}
  {
    {
      if (_ve_name.get_len () != 0)
      {
        goto _block3__branch1;
      }
      Expr _v__q_1;
      RF_CALL (Box::_q_, Position, _v__q_1);
      if (_v__q_1.get_len () != 2)
      {
        RF_RETFAIL;
      }
      if (!_v__q_1.symbol_at (0))
      {
        RF_RETFAIL;
      }
      if (!_v__q_1.symbol_at ((0 + 1)))
      {
        RF_RETFAIL;
      }
      Expr _vs_r (_v__q_1, 0, 1);
      Expr _vs_c (_v__q_1, (0 + 1), 1);
      Expr _ge_auxcall1;
      RF_CALL (Source_m_File_m_Name, /*void*/, _ge_auxcall1);
      Expr _ge_auxcall2;
      RF_CALL (Convert::To_m_Chars, (_ge_auxcall1 + _c_121 + _vs_r + _c_121 + _vs_c), _ge_auxcall2);
      _v_res1 = (_vs_type + _c_122 + _ge_auxcall2);
      _v_res2 = _ve_new_m_line;
      goto _block3;
    }
  _block3__branch1: {}
    _v_res1 = (_vs_type + _ve_name);
    _v_res2 = _ve_new_m_line;
  }
_block3: {}
RF_END

RF_FUNC (Scan_m_Number_q_, (RF_ARG _ve_line;;), (RF_RES _v_res1, _v_res2;;))
  uintptr_t _v_len1 = _ve_line.get_len ();
  uintptr_t _v_len2 = 1;
  if (_v_len1 < _v_len2)
  {
    RF_RETFAIL;
  }
  uintptr_t _v_len__rest = (_v_len1 - _v_len2);
  if (!_ve_line.symbol_at (0))
  {
    RF_RETFAIL;
  }
  Expr _vs_first (_ve_line, 0, 1);
  Expr _ve_rest (_ve_line, (0 + 1), _v_len__rest);
  {
    {
      if (!RF_CALL (Class::Digit_q_, _vs_first, /*void*/))
      {
        goto _block2__branch1;
      }
      goto _block2;
    }
  _block2__branch1: {}
    {
      {
        if (!_vs_first.term_eq (_c_123, 0))
        {
          goto _block3__branch1;
        }
        goto _block3;
      }
    _block3__branch1: {}
      if (!_vs_first.term_eq (_c_121, 0))
      {
        RF_RETFAIL;
      }
    }
  _block3: {}
  }
_block2: {}
  RF_CALL (Next_m_Column, /*void*/, /*void*/);
  Expr _ve_num;
  Expr _ge_rest__2;
  RF_CALL (Scan_m_Number_m_Rest, (_vs_first, _ve_rest), (_ve_num, _ge_rest__2));
  Expr _gs_auxcall1;
  if (!RF_CALL (Convert::To_m_Int, _ve_num, _gs_auxcall1))
  {
    RF_RETFAIL;
  }
  _v_res1 = (_c_124 + _gs_auxcall1);
  _v_res2 = _ge_rest__2;
RF_END

RF_FUNC (Scan_m_Number_m_Rest, (RF_ARG _ve_start, _ve_line;;), (RF_RES _v_res1, _v_res2;;))
  {
    {
      if (_ve_line.get_len () != 1)
      {
        goto _block1__branch1;
      }
      if (!_c_53.term_eq (_ve_line, 0))
      {
        goto _block1__branch1;
      }
      Expr _ge_auxcall1;
      if (!RF_CALL (Get_m_Source_m_Line, /*void*/, _ge_auxcall1))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      RF_TAILCALL (Scan_m_Number_m_Rest, (_ve_start, _ge_auxcall1), (_v_res1, _v_res2));
      goto _block1;
    }
  _block1__branch1: {}
    Expr _ve_w (_ve_start);
    Expr _ve_l (_ve_line);
    Expr _vs_cond (_c_17);
    for ( ; ; )
    {
      {
        if (!_vs_cond.term_eq (_c_18, 0))
        {
          goto _iter1;
        }
        _v_res1 = _ve_w;
        _v_res2 = _ve_l;
        goto _exit__iter1;
      }
    _iter1: {}
      {
        {
          uintptr_t _v_len1 = _ve_l.get_len ();
          uintptr_t _v_len2 = 1;
          if (_v_len1 < _v_len2)
          {
            goto _block2__branch1;
          }
          uintptr_t _v_len__rest = (_v_len1 - _v_len2);
          if (!_ve_l.symbol_at (0))
          {
            goto _block2__branch1;
          }
          Expr _vs_first (_ve_l, 0, 1);
          Expr _ve_rest (_ve_l, (0 + 1), _v_len__rest);
          if (!RF_CALL (Class::Digit_q_, _vs_first, /*void*/))
          {
            goto _block2__branch1;
          }
          RF_CALL (Next_m_Column, /*void*/, /*void*/);
          _ve_w = (_ve_w + _vs_first);
          _ve_l = _ve_rest;
          _vs_cond = _c_17;
          goto _block2;
        }
      _block2__branch1: {}
        _vs_cond = _c_18;
      }
    _block2: {}
    }
  _exit__iter1: {}
  }
_block1: {}
RF_END

RF_FUNC (Scan_m_Identifier_q_, (RF_ARG _ve_line;;), (RF_RES _v_res1, _v_res2;;))
  uintptr_t _v_len1 = _ve_line.get_len ();
  uintptr_t _v_len2 = 1;
  if (_v_len1 < _v_len2)
  {
    RF_RETFAIL;
  }
  uintptr_t _v_len__rest = (_v_len1 - _v_len2);
  if (!_ve_line.symbol_at (0))
  {
    RF_RETFAIL;
  }
  Expr _vs_first (_ve_line, 0, 1);
  Expr _ve_rest (_ve_line, (0 + 1), _v_len__rest);
  {
    {
      if (!RF_CALL (Uppercase_m_Letter_q_, _vs_first, /*void*/))
      {
        goto _block2__branch1;
      }
      goto _block2;
    }
  _block2__branch1: {}
    {
      {
        if (!_vs_first.term_eq (_c_54, 0))
        {
          goto _block3__branch1;
        }
        goto _block3;
      }
    _block3__branch1: {}
      if (!_vs_first.term_eq (_c_56, 0))
      {
        RF_RETFAIL;
      }
    }
  _block3: {}
  }
_block2: {}
  RF_CALL (Next_m_Column, /*void*/, /*void*/);
  Expr _ve_word;
  Expr _ge_rest__2;
  RF_CALL (Scan_m_Identifier_m_Rest, (_c_125, _vs_first, _ve_rest), (_ve_word, _ge_rest__2));
  _v_res1 = (_c_10 + _ve_word);
  _v_res2 = _ge_rest__2;
RF_END

RF_FUNC (Scan_m_Identifier_m_Rest, (RF_ARG _vs_obj, _ve_start, _ve_line;;), (RF_RES _v_res1, _v_res2;;))
  Expr _ve_extra;
  {
    {
      if (!_vs_obj.term_eq (_c_120, 0))
      {
        goto _block1__branch1;
      }
      _ve_extra = _c_126;
      goto _block1;
    }
  _block1__branch1: {}
    if (!_vs_obj.term_eq (_c_125, 0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    _ve_extra = _c_127;
  }
_block1: {}
  Expr _ve_w (_ve_start);
  Expr _ve_l (_ve_line);
  Expr _vs_cond (_c_17);
  for ( ; ; )
  {
    {
      if (!_vs_cond.term_eq (_c_18, 0))
      {
        goto _iter1;
      }
      _v_res1 = _ve_w;
      _v_res2 = _ve_l;
      goto _exit__iter1;
    }
  _iter1: {}
    {
      {
        uintptr_t _v_len1 = _ve_l.get_len ();
        uintptr_t _v_len2 = 1;
        if (_v_len1 < _v_len2)
        {
          goto _block3__branch1;
        }
        uintptr_t _v_len__rest = (_v_len1 - _v_len2);
        if (!_ve_l.symbol_at (0))
        {
          goto _block3__branch1;
        }
        Expr _vs_first (_ve_l, 0, 1);
        Expr _ve_rest (_ve_l, (0 + 1), _v_len__rest);
        {
          {
            if (!RF_CALL (Class::Letter_q_, _vs_first, /*void*/))
            {
              goto _block4__branch1;
            }
            goto _block4;
          }
        _block4__branch1: {}
          {
            if (!RF_CALL (Class::Digit_q_, _vs_first, /*void*/))
            {
              goto _block4__branch2;
            }
            goto _block4;
          }
        _block4__branch2: {}
          if (_ve_extra.get_len () < 1)
          {
            goto _block3__branch1;
          }
          RF_lsplit (_ve_extra, 0, _ve__e__e_tmp_m_rfp__lexrf_m_469_m_20, _v_lsplit__extra);
          for ( ; ; RF_iter(_ve_extra)++)
          {
            {
              if (!RF_iter(_ve_extra))
              {
                goto _block3__branch1;
              }
              uintptr_t _v_len3 = _v_lsplit__extra.get_len ();
              uintptr_t _v_len4 = 1;
              if (_v_len3 < _v_len4)
              {
                goto _block3__branch1;
              }
              uintptr_t _v_len___e__e_tmp_m_rfp__lexrf_m_469_m_30 = (_v_len3 - _v_len4);
              if (!_vs_first.term_eq (_v_lsplit__extra, 0))
              {
                goto _continue1;
              }
              Expr _ve__e__e_tmp_m_rfp__lexrf_m_469_m_30 (_v_lsplit__extra, (0 + 1), _v_len___e__e_tmp_m_rfp__lexrf_m_469_m_30);
              goto _exit1;
            }
        _continue1: {}
          }
        _exit1: {}
        }
      _block4: {}
        RF_CALL (Next_m_Column, /*void*/, /*void*/);
        _ve_w = (_ve_w + _vs_first);
        _ve_l = _ve_rest;
        _vs_cond = _c_17;
        goto _block3;
      }
    _block3__branch1: {}
      _vs_cond = _c_18;
    }
  _block3: {}
  }
_exit__iter1: {}
RF_END

RF_FUNC (Scan_m_Word_q_, (RF_ARG _ve_line;;), (RF_RES _v_res1, _v_res2;;))
  uintptr_t _v_len1 = _ve_line.get_len ();
  uintptr_t _v_len2 = 1;
  if (_v_len1 < _v_len2)
  {
    RF_RETFAIL;
  }
  uintptr_t _v_len__rest = (_v_len1 - _v_len2);
  if (!_c_128.term_eq (_ve_line, 0))
  {
    RF_RETFAIL;
  }
  Expr _ve_rest (_ve_line, (0 + 1), _v_len__rest);
  RF_CALL (Next_m_Column, /*void*/, /*void*/);
  Expr _ve_word;
  Expr _ge_rest__2;
  RF_CALL (Scan_m_String_m_Rest, (empty, _ve_rest, _c_128), (_ve_word, _ge_rest__2));
  _v_res1 = (_c_11 + _ve_word);
  _v_res2 = _ge_rest__2;
RF_END

RF_FUNC (Scan_m_String_q_, (RF_ARG _ve_line;;), (RF_RES _v_res1, _v_res2;;))
  uintptr_t _v_len1 = _ve_line.get_len ();
  uintptr_t _v_len2 = 1;
  if (_v_len1 < _v_len2)
  {
    RF_RETFAIL;
  }
  uintptr_t _v_len__rest = (_v_len1 - _v_len2);
  if (!_c_129.term_eq (_ve_line, 0))
  {
    RF_RETFAIL;
  }
  Expr _ve_rest (_ve_line, (0 + 1), _v_len__rest);
  RF_CALL (Next_m_Column, /*void*/, /*void*/);
  Expr _ve_str;
  Expr _ge_rest__2;
  RF_CALL (Scan_m_String_m_Rest, (empty, _ve_rest, _c_129), (_ve_str, _ge_rest__2));
  _v_res1 = (_c_130 + _ve_str);
  _v_res2 = _ge_rest__2;
RF_END

RF_FUNC (Scan_m_String_m_Rest, (RF_ARG _ve_start, _ve_line, _vs_term;;), (RF_RES _v_res1, _v_res2;;))
  Expr _ve_s (_ve_start);
  Expr _ve_l (_ve_line);
  Expr _vs_cond (_c_17);
  for ( ; ; )
  {
    {
      if (!_vs_cond.term_eq (_c_18, 0))
      {
        goto _iter1;
      }
      _v_res1 = _ve_s;
      _v_res2 = _ve_l;
      goto _exit__iter1;
    }
  _iter1: {}
    {
      {
        uintptr_t _v_len1 = _ve_l.get_len ();
        uintptr_t _v_len2 = 1;
        if (_v_len1 < _v_len2)
        {
          goto _block1__branch1;
        }
        uintptr_t _v_len__rest = (_v_len1 - _v_len2);
        if (!_ve_l.symbol_at (0))
        {
          goto _block1__branch1;
        }
        Expr _vs_first (_ve_l, 0, 1);
        Expr _ve_rest (_ve_l, (0 + 1), _v_len__rest);
        RF_CALL (Next_m_Column, /*void*/, /*void*/);
        {
          {
            if (!_vs_term.term_eq (_vs_first, 0))
            {
              goto _block2__branch1;
            }
            _ve_l = _ve_rest;
            _vs_cond = _c_18;
            goto _block2;
          }
        _block2__branch1: {}
          {
            if (!_vs_first.term_eq (_c_53, 0))
            {
              goto _block2__branch2;
            }
            {
              {
                uintptr_t _v_len3 = _v_len__rest;
                uintptr_t _v_len4 = 1;
                if (_v_len3 < _v_len4)
                {
                  goto _block3__branch1;
                }
                uintptr_t _v_len__rest2 = (_v_len3 - _v_len4);
                if (!_ve_rest.symbol_at (0))
                {
                  goto _block3__branch1;
                }
                Expr _vs_first2 (_ve_rest, 0, 1);
                Expr _ve_rest2 (_ve_rest, (0 + 1), _v_len__rest2);
                RF_CALL (Next_m_Column, /*void*/, /*void*/);
                {
                  {
                    if (!_vs_first2.term_eq (_c_117, 0))
                    {
                      goto _block4__branch1;
                    }
                    _ve_s = (_ve_s + _c_131);
                    _ve_l = _ve_rest2;
                    _vs_cond = _c_17;
                    goto _block4;
                  }
                _block4__branch1: {}
                  {
                    if (!_vs_first2.term_eq (_c_132, 0))
                    {
                      goto _block4__branch2;
                    }
                    _ve_s = (_ve_s + _c_133);
                    _ve_l = _ve_rest2;
                    _vs_cond = _c_17;
                    goto _block4;
                  }
                _block4__branch2: {}
                  {
                    if (!_vs_first2.term_eq (_c_134, 0))
                    {
                      goto _block4__branch3;
                    }
                    _ve_s = (_ve_s + _c_135);
                    _ve_l = _ve_rest2;
                    _vs_cond = _c_17;
                    goto _block4;
                  }
                _block4__branch3: {}
                  {
                    if (!_vs_first2.term_eq (_c_53, 0))
                    {
                      goto _block4__branch4;
                    }
                    _ve_s = (_ve_s + _c_53);
                    _ve_l = _ve_rest2;
                    _vs_cond = _c_17;
                    goto _block4;
                  }
                _block4__branch4: {}
                  {
                    if (!_vs_first2.term_eq (_c_129, 0))
                    {
                      goto _block4__branch5;
                    }
                    _ve_s = (_ve_s + _c_129);
                    _ve_l = _ve_rest2;
                    _vs_cond = _c_17;
                    goto _block4;
                  }
                _block4__branch5: {}
                  {
                    if (!_vs_first2.term_eq (_c_128, 0))
                    {
                      goto _block4__branch6;
                    }
                    _ve_s = (_ve_s + _c_128);
                    _ve_l = _ve_rest2;
                    _vs_cond = _c_17;
                    goto _block4;
                  }
                _block4__branch6: {}
                  if (!_vs_first2.symbol_at (0))
                  {
                    goto _block3__branch1;
                  }
                  Expr _vs__e__e_tmp_m_rfp__lexrf_m_513_m_16 (_vs_first2, 0, 1);
                  Expr _ge_auxcall1;
                  RF_CALL (Token_m_Position, /*void*/, _ge_auxcall1);
                  RF_CALL (rfp__err::RFP_m_Warning, (_ge_auxcall1, (_c_136 + _vs_first2 + _c_59)), /*void*/);
                  _ve_s = (_ve_s + _vs_first2);
                  _ve_l = _ve_rest2;
                  _vs_cond = _c_17;
                }
              _block4: {}
                goto _block3;
              }
            _block3__branch1: {}
              {
                Expr _ge_auxcall2;
                if (!RF_CALL (Get_m_Source_m_Line, /*void*/, _ge_auxcall2))
                {
                  goto _block3__branch2;
                }
                _ve_l = _ge_auxcall2;
                _vs_cond = _c_17;
                goto _block3;
              }
            _block3__branch2: {}
              Expr _ge_auxcall3;
              RF_CALL (Token_m_Position, /*void*/, _ge_auxcall3);
              RF_CALL (rfp__err::RFP_m_Error, (_ge_auxcall3, _c_137), /*void*/);
              _ve_l = empty;
              _vs_cond = _c_18;
            }
          _block3: {}
            goto _block2;
          }
        _block2__branch2: {}
          if (!_vs_first.symbol_at (0))
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          Expr _vs__e__e_tmp_m_rfp__lexrf_m_521_m_10 (_vs_first, 0, 1);
          _ve_s = (_ve_s + _vs_first);
          _ve_l = _ve_rest;
          _vs_cond = _c_17;
        }
      _block2: {}
        goto _block1;
      }
    _block1__branch1: {}
      {
        Expr _ge_auxcall4;
        if (!RF_CALL (Get_m_Source_m_Line, /*void*/, _ge_auxcall4))
        {
          goto _block1__branch2;
        }
        _ve_s = (_ve_s + _c_133);
        _ve_l = _ge_auxcall4;
        _vs_cond = _c_17;
        goto _block1;
      }
    _block1__branch2: {}
      Expr _ge_auxcall5;
      RF_CALL (Token_m_Position, /*void*/, _ge_auxcall5);
      RF_CALL (rfp__err::RFP_m_Error, (_ge_auxcall5, _c_138), /*void*/);
      _ve_l = empty;
      _vs_cond = _c_18;
    }
  _block1: {}
  }
_exit__iter1: {}
RF_END

RF_FUNC (Skip_m_Comment, (RF_ARG _ve_line;;), (RF_RES _v_res1;;))
  {
    {
      if (_ve_line.get_len () < 2)
      {
        goto _block1__branch1;
      }
      RF_lsplit (_ve_line, 0, _ve_1, _v_lsplit__line);
      for ( ; ; RF_iter(_ve_line)++)
      {
        {
          if (!RF_iter(_ve_line))
          {
            goto _block1__branch1;
          }
          uintptr_t _v_len1 = _v_lsplit__line.get_len ();
          uintptr_t _v_len2 = 2;
          if (_v_len1 < _v_len2)
          {
            goto _block1__branch1;
          }
          uintptr_t _v_len__rest = (_v_len1 - _v_len2);
          if (!_c_139.eq (_v_lsplit__line, 0))
          {
            goto _continue1;
          }
          Expr _ve_rest (_v_lsplit__line, (0 + 1 + 1), _v_len__rest);
          Expr _gs_auxcall1;
          RF_CALL (Access::Length, (_ve_1 + _c_139), _gs_auxcall1);
          Expr _ge_auxcall2;
          RF_CALL (List::Replicate, (_gs_auxcall1, _c_140), _ge_auxcall2);
          Expr _v_Map1;
          if (!RF_CALL (List::Map, (_c_141, empty, _ge_auxcall2), _v_Map1))
          {
            RF_RETFAIL;
          }
          uintptr_t _v_len3 = _v_Map1.get_len ();
          uintptr_t _v_len4 = 0;
          if (_v_len3 < _v_len4)
          {
            RF_RETFAIL;
          }
          uintptr_t _v_len___e__e_tmp_m_rfp__lexrf_m_531_m_89 = (_v_len3 - _v_len4);
          Expr _ve__e__e_tmp_m_rfp__lexrf_m_531_m_89 (_v_Map1, 0, _v_len___e__e_tmp_m_rfp__lexrf_m_531_m_89);
          _v_res1 = _ve_rest;
          goto _exit1;
        }
    _continue1: {}
      }
    _exit1: {}
      goto _block1;
    }
  _block1__branch1: {}
    {
      Expr _ge_auxcall3;
      if (!RF_CALL (Get_m_Source_m_Line, /*void*/, _ge_auxcall3))
      {
        goto _block1__branch2;
      }
      if (!RF_CALL (Skip_m_Comment, _ge_auxcall3, _v_res1))
      {
        goto _block1__branch2;
      }
      goto _block1;
    }
  _block1__branch2: {}
    Expr _ge_auxcall4;
    RF_CALL (Token_m_Position, /*void*/, _ge_auxcall4);
    RF_CALL (rfp__err::RFP_m_Error, (_ge_auxcall4, _c_24), /*void*/);
    _v_res1 = empty;
  }
_block1: {}
RF_END

RF_FUNC (Next_m_Column, RF_VOID, RF_VOID)
  Expr _ge_auxcall1;
  RF_CALL (Box::_q_, Position, _ge_auxcall1);
  Expr _ge_auxcall2;
  RF_CALL (rfp__src::RFP_m_Next_m_Column, _ge_auxcall1, _ge_auxcall2);
  RF_TAILCALL (Box::Store, (Position, _ge_auxcall2), /*void*/);
RF_END

RF_FUNC (Next_m_Row, RF_VOID, RF_VOID)
  Expr _ge_auxcall1;
  RF_CALL (Box::_q_, Position, _ge_auxcall1);
  Expr _ge_auxcall2;
  RF_CALL (rfp__src::RFP_m_Next_m_Row, _ge_auxcall1, _ge_auxcall2);
  RF_TAILCALL (Box::Store, (Position, _ge_auxcall2), /*void*/);
RF_END

RF_FUNC (Uppercase_m_Letter_q_, (RF_ARG _vs_letter;;), RF_VOID)
  if (!RF_CALL (Class::Letter_q_, _vs_letter, /*void*/))
  {
    RF_RETFAIL;
  }
  Expr _ge_auxcall1;
  RF_CALL (Convert::To_m_Upper, _vs_letter, _ge_auxcall1);
  RF_TAILCALL (Compare::_eq_, (_ge_auxcall1, _vs_letter), /*void*/);
RF_END

RF_FUNC (Source_m_File_m_Name, RF_VOID, (RF_RES _v_res1;;))
  Expr _v__q_1;
  RF_CALL (Box::_q_, Source, _v__q_1);
  if (_v__q_1.get_len () != 4)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (_v__q_1.symbol_at ((0 + 1 + 1)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (_v__q_1.symbol_at ((0 + 1 + 1 + 1)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _v_deref___q_1 (_v__q_1, (0 + 1 + 1));
  Expr _v_deref___q_12 (_v__q_1, (0 + 1 + 1 + 1));
  uintptr_t _v_len1 = _v_deref___q_12.get_len ();
  uintptr_t _v_len2 = 0;
  if (_v_len1 < _v_len2)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len__src = (_v_len1 - _v_len2);
  uintptr_t _v_len3 = _v_deref___q_1.get_len ();
  uintptr_t _v_len4 = 0;
  if (_v_len3 < _v_len4)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len__name = (_v_len3 - _v_len4);
  if (!_v__q_1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_v__q_1.symbol_at ((0 + 1)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _vs_srctype (_v__q_1, 0, 1);
  Expr _vs_getline_m_func (_v__q_1, (0 + 1), 1);
  Expr _ve_name (_v_deref___q_1, 0, _v_len__name);
  Expr _ve_src (_v_deref___q_12, 0, _v_len__src);
  _v_res1 = _ve_name;
RF_END

RF_FUNC (Print_m_File_m_Name, RF_VOID, RF_VOID)
  Expr _ge_auxcall1;
  RF_CALL (Source_m_File_m_Name, /*void*/, _ge_auxcall1);
  RF_TAILCALL (StdIO::Print, _ge_auxcall1, /*void*/);
RF_END

RF_FUNC (Token_m_Position, RF_VOID, (RF_RES _v_res1;;))
  Expr _ge_auxcall1;
  RF_CALL (Box::_q_, Source_m_Index, _ge_auxcall1);
  Expr _v__q_1;
  RF_CALL (Box::_q_, Position, _v__q_1);
  _v_res1 = (_ge_auxcall1 + _v__q_1);
RF_END

RF_FUNC (Find_m_Include_q_, (RF_ARG _ve_name, _vs_ci_q_;;), (RF_RES _v_res1;;))
  Expr _v__q_1;
  RF_CALL (Box::_q_, File::Dir_m_Separator, _v__q_1);
  if (_v__q_1.get_len () != 1)
  {
    RF_RETFAIL;
  }
  if (!_v__q_1.symbol_at (0))
  {
    RF_RETFAIL;
  }
  Expr _vs_dir_m_separator (_v__q_1, 0, 1);
  Expr _ve_NAME;
  RF_CALL (Convert::To_m_Upper, _ve_name, _ve_NAME);
  Expr _ve_path;
  {
    {
      uintptr_t _v_len1 = _ve_name.get_len ();
      uintptr_t _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len___e__e_tmp_m_rfp__lexrf_m_559_m_31 = (_v_len1 - _v_len2);
      if (!_vs_dir_m_separator.term_eq (_ve_name, 0))
      {
        goto _block1__branch1;
      }
      Expr _ve__e__e_tmp_m_rfp__lexrf_m_559_m_31 (_ve_name, (0 + 1), _v_len___e__e_tmp_m_rfp__lexrf_m_559_m_31);
      _ve_path = _c_142;
      goto _block1;
    }
  _block1__branch1: {}
    {
      uintptr_t _v_len3 = _ve_name.get_len ();
      uintptr_t _v_len4 = 1;
      if (_v_len3 < _v_len4)
      {
        goto _block1__branch2;
      }
      uintptr_t _v_len___e__e_tmp_m_rfp__lexrf_m_560_m_19 = (_v_len3 - _v_len4);
      if (!_c_119.term_eq (_ve_name, 0))
      {
        goto _block1__branch2;
      }
      Expr _ve__e__e_tmp_m_rfp__lexrf_m_560_m_19 (_ve_name, (0 + 1), _v_len___e__e_tmp_m_rfp__lexrf_m_560_m_19);
      Expr _ge_auxcall1;
      RF_CALL (Source_m_File_m_Name, /*void*/, _ge_auxcall1);
      Expr _ge_auxcall2;
      RF_CALL (rfp__src::RFP_m_Dir_m_Name, _ge_auxcall1, _ge_auxcall2);
      _ve_path = _ge_auxcall2 ();
      goto _block1;
    }
  _block1__branch2: {}
    Expr _ge_auxcall3;
    RF_CALL (Source_m_File_m_Name, /*void*/, _ge_auxcall3);
    Expr _ge_auxcall4;
    RF_CALL (rfp__src::RFP_m_Dir_m_Name, _ge_auxcall3, _ge_auxcall4);
    Expr _v__q_2;
    RF_CALL (Box::_q_, rfpc::RFP_m_Include_m_Path, _v__q_2);
    _ve_path = (_ge_auxcall4 () + _v__q_2);
  }
_block1: {}
  if (_ve_path.get_len () < 1)
  {
    RF_RETFAIL;
  }
  RF_lsplit (_ve_path, 0, _ve__e__e_tmp_m_rfp__lexrf_m_563_m_13, _v_lsplit__path);
  for ( ; ; RF_iter(_ve_path)++)
  {
    {
      if (!RF_iter(_ve_path))
      {
        RF_RETFAIL;
      }
      uintptr_t _v_len5 = _v_lsplit__path.get_len ();
      uintptr_t _v_len6 = 1;
      if (_v_len5 < _v_len6)
      {
        RF_RETFAIL;
      }
      uintptr_t _v_len___e__e_tmp_m_rfp__lexrf_m_563_m_27 = (_v_len5 - _v_len6);
      if (_v_lsplit__path.symbol_at (0))
      {
        goto _continue1;
      }
      Expr _v_deref__lsplit__path (_v_lsplit__path, 0);
      uintptr_t _v_len7 = _v_deref__lsplit__path.get_len ();
      uintptr_t _v_len8 = 0;
      if (_v_len7 < _v_len8)
      {
        goto _continue1;
      }
      uintptr_t _v_len__dirname = (_v_len7 - _v_len8);
      Expr _ve__e__e_tmp_m_rfp__lexrf_m_563_m_27 (_v_lsplit__path, (0 + 1), _v_len___e__e_tmp_m_rfp__lexrf_m_563_m_27);
      Expr _ve_dirname (_v_deref__lsplit__path, 0, _v_len__dirname);
      Expr _ve_dirn;
      {
        {
          uintptr_t _v_len9 = _v_len__dirname;
          uintptr_t _v_len10 = 1;
          if (_v_len9 < _v_len10)
          {
            goto _block2__branch1;
          }
          uintptr_t _v_len___e__e_tmp_m_rfp__lexrf_m_565_m_6 = (_v_len9 - _v_len10);
          if (!_vs_dir_m_separator.term_eq (_ve_dirname, (0 + _v_len___e__e_tmp_m_rfp__lexrf_m_565_m_6)))
          {
            goto _block2__branch1;
          }
          Expr _ve__e__e_tmp_m_rfp__lexrf_m_565_m_6 (_ve_dirname, 0, _v_len___e__e_tmp_m_rfp__lexrf_m_565_m_6);
          _ve_dirn = _ve_dirname;
          goto _block2;
        }
      _block2__branch1: {}
        {
          uintptr_t _v_len11 = _v_len__dirname;
          uintptr_t _v_len12 = 0;
          if (_v_len11 < (_v_len12 + 1))
          {
            goto _block2__branch2;
          }
          uintptr_t _v_len___e__e_tmp_m_rfp__lexrf_m_566_m_6 = (_v_len11 - _v_len12);
          Expr _vv__e__e_tmp_m_rfp__lexrf_m_566_m_6 (_ve_dirname, 0, _v_len___e__e_tmp_m_rfp__lexrf_m_566_m_6);
          _ve_dirn = (_ve_dirname + _vs_dir_m_separator);
          goto _block2;
        }
      _block2__branch2: {}
        uintptr_t _v_len13 = _v_len__dirname;
        uintptr_t _v_len14 = 0;
        if (_v_len13 < _v_len14)
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        uintptr_t _v_len___e__e_tmp_m_rfp__lexrf_m_567_m_6 = (_v_len13 - _v_len14);
        Expr _ve__e__e_tmp_m_rfp__lexrf_m_567_m_6 (_ve_dirname, 0, _v_len___e__e_tmp_m_rfp__lexrf_m_567_m_6);
        _ve_dirn = (_c_119 + _vs_dir_m_separator);
      }
    _block2: {}
      Expr _ge_name__3;
      Expr _ge_name__4 (_ve_name);
      for ( ; ; )
      {
        {
          {
            if (_ge_name__4.get_len () < 1)
            {
              goto _negation1;
            }
            RF_lsplit (_ge_name__4, 0, _ve_1, _v_lsplit__name__4);
            for ( ; ; RF_iter(_ge_name__4)++)
            {
              {
                if (!RF_iter(_ge_name__4))
                {
                  goto _negation1;
                }
                uintptr_t _v_len15 = _v_lsplit__name__4.get_len ();
                uintptr_t _v_len16 = 1;
                if (_v_len15 < _v_len16)
                {
                  goto _negation1;
                }
                uintptr_t _v_len__2 = (_v_len15 - _v_len16);
                if (!_c_119.term_eq (_v_lsplit__name__4, 0))
                {
                  goto _continue2;
                }
                Expr _ve_2 (_v_lsplit__name__4, (0 + 1), _v_len__2);
                goto _exit2;
              }
          _continue2: {}
            }
          _exit2: {}
            goto _iter1;
          }
        _negation1: {}
          _ge_name__3 = _ge_name__4;
          goto _exit__iter1;
        }
      _iter1: {}
        if (_ge_name__4.get_len () < 1)
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        RF_lsplit (_ge_name__4, 0, _ve_1, _v_lsplit__name__42);
        for ( ; ; RF_iter(_ge_name__4)++)
        {
          {
            if (!RF_iter(_ge_name__4))
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            uintptr_t _v_len17 = _v_lsplit__name__42.get_len ();
            uintptr_t _v_len18 = 1;
            if (_v_len17 < _v_len18)
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            uintptr_t _v_len__22 = (_v_len17 - _v_len18);
            if (!_c_119.term_eq (_v_lsplit__name__42, 0))
            {
              goto _continue3;
            }
            Expr _ve_2 (_v_lsplit__name__42, (0 + 1), _v_len__22);
            _ge_name__4 = (_ve_1 + _vs_dir_m_separator + _ve_2);
            goto _exit3;
          }
      _continue3: {}
        }
      _exit3: {}
      }
    _exit__iter1: {}
      Expr _ve_source;
      {
        {
          if (!RF_CALL (Table::In_m_Table_q_, (rfp__helper::RFP_m_Options, _c_66), /*void*/))
          {
            goto _block6__branch1;
          }
          Expr _gs_auxalt5;
          RF_TRAP
          {
            RF_CALL (Dir::Open_m_Dir, _ve_dirn, _gs_auxalt5);
          }
          RF_WITH
          {
            RF_CLEANUP;
            uintptr_t _v_len19 = err.get_len ();
            uintptr_t _v_len20 = 0;
            if (_v_len19 < _v_len20)
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            uintptr_t _v_len___e__e_tmp_m_rfp__lexrf_m_577_m_12 = (_v_len19 - _v_len20);
            Expr _ve__e__e_tmp_m_rfp__lexrf_m_577_m_12 (err, 0, _v_len___e__e_tmp_m_rfp__lexrf_m_577_m_12);
            goto _continue1;
          }
          if (!_gs_auxalt5.symbol_at (0))
          {
            goto _continue1;
          }
          Expr _vs_dir (_gs_auxalt5, 0, 1);
          Expr _ve_res (empty);
          for ( ; ; )
          {
            {
              if (_ve_res.get_len () != 1)
              {
                goto _iter2;
              }
              if (_ve_res.symbol_at (0))
              {
                goto _iter2;
              }
              Expr _v_deref__res (_ve_res, 0);
              uintptr_t _v_len21 = _v_deref__res.get_len ();
              uintptr_t _v_len22 = 0;
              if (_v_len21 < _v_len22)
              {
                goto _iter2;
              }
              uintptr_t _v_len__source__6 = (_v_len21 - _v_len22);
              Expr _ge_source__6 (_v_deref__res, 0, _v_len__source__6);
              _ve_source = _ge_source__6;
              goto _exit__iter2;
            }
          _iter2: {}
            Expr _ve_filename;
            if (!RF_CALL (Dir::Read_m_Dir, _vs_dir, _ve_filename))
            {
              goto _continue1;
            }
            {
              {
                uintptr_t _v_len23 = _ve_filename.get_len ();
                uintptr_t _v_len24 = 4;
                if (_v_len23 < _v_len24)
                {
                  goto _block10__branch1;
                }
                uintptr_t _v_len__basename = (_v_len23 - _v_len24);
                if (!_c_3.eq (_ve_filename, (0 + _v_len__basename)))
                {
                  goto _block10__branch1;
                }
                Expr _ve_basename (_ve_filename, 0, _v_len__basename);
                {
                  {
                    if (_v_len__basename != _ge_name__3.get_len ())
                    {
                      goto _block11__branch1;
                    }
                    if (!_ge_name__3.eq (_ve_basename, 0))
                    {
                      goto _block11__branch1;
                    }
                    goto _block11;
                  }
                _block11__branch1: {}
                  if (!_vs_ci_q_.term_eq (_c_19, 0))
                  {
                    goto _block10__branch1;
                  }
                  Expr _v_To_m_Upper1;
                  RF_CALL (Convert::To_m_Upper, _ve_basename, _v_To_m_Upper1);
                  if (_v_To_m_Upper1.get_len () != _ve_NAME.get_len ())
                  {
                    goto _block10__branch1;
                  }
                  if (!_ve_NAME.eq (_v_To_m_Upper1, 0))
                  {
                    goto _block10__branch1;
                  }
                }
              _block11: {}
                Expr _ge_auxcall6;
                if (!RF_CALL (Try_m_Open, (_ve_dirn + _ve_basename + _c_3), _ge_auxcall6))
                {
                  goto _continue1;
                }
                _ve_res = _ge_auxcall6 ();
                goto _block10;
              }
            _block10__branch1: {}
              _ve_res = empty;
            }
          _block10: {}
          }
        _exit__iter2: {}
          goto _block6;
        }
      _block6__branch1: {}
        if (!RF_CALL (Try_m_Open, (_ve_dirn + _ge_name__3 + _c_3), _ve_source))
        {
          goto _continue1;
        }
      }
    _block6: {}
      _v_res1 = _ve_source;
      goto _exit1;
    }
_continue1: {}
  }
_exit1: {}
RF_END

RF_FUNC (Try_m_Open, (RF_ARG _ve_filename;;), (RF_RES _v_res1;;))
  {
    {
      if (!RF_CALL (rfp__helper::RFP_m_Debug_q_, /*void*/, /*void*/))
      {
        goto _block1__branch1;
      }
      RF_CALL (StdIO::PrintLN, (_c_143 + _ve_filename + _c_59), /*void*/);
      goto _block1;
    }
  _block1__branch1: {}
  }
_block1: {}
  Expr _ve_source;
  if (!RF_CALL (rfp__src::RFP_m_Src_m_Open_m_File, _ve_filename, _ve_source))
  {
    RF_RETFAIL;
  }
  {
    {
      if (!RF_CALL (rfp__helper::RFP_m_Debug_q_, /*void*/, /*void*/))
      {
        goto _block2__branch1;
      }
      RF_CALL (StdIO::PrintLN, (_c_59 + _ve_filename + _c_144), /*void*/);
      goto _block2;
    }
  _block2__branch1: {}
  }
_block2: {}
  _v_res1 = _ve_source;
RF_END

RF_FUNC (Interface_m_Name_q_, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  if (_ge_arg1.get_len () != 4)
  {
    RF_RETFAIL;
  }
  if (_ge_arg1.symbol_at ((0 + 1 + 1)))
  {
    RF_RETFAIL;
  }
  if (_ge_arg1.symbol_at ((0 + 1 + 1 + 1)))
  {
    RF_RETFAIL;
  }
  Expr _v_deref__arg1 (_ge_arg1, (0 + 1 + 1));
  Expr _v_deref__arg12 (_ge_arg1, (0 + 1 + 1 + 1));
  uintptr_t _v_len1 = _v_deref__arg12.get_len ();
  uintptr_t _v_len2 = 0;
  if (_v_len1 < _v_len2)
  {
    RF_RETFAIL;
  }
  uintptr_t _v_len___e__e_tmp_m_rfp__lexrf_m_606_m_35 = (_v_len1 - _v_len2);
  uintptr_t _v_len3 = _v_deref__arg1.get_len ();
  uintptr_t _v_len4 = 0;
  if (_v_len3 < _v_len4)
  {
    RF_RETFAIL;
  }
  uintptr_t _v_len__name = (_v_len3 - _v_len4);
  if (!_c_145.term_eq (_ge_arg1, 0))
  {
    RF_RETFAIL;
  }
  if (!_ge_arg1.symbol_at ((0 + 1)))
  {
    RF_RETFAIL;
  }
  Expr _vs__e__e_tmp_m_rfp__lexrf_m_606_m_23 (_ge_arg1, (0 + 1), 1);
  Expr _ve_name (_v_deref__arg1, 0, _v_len__name);
  Expr _ve__e__e_tmp_m_rfp__lexrf_m_606_m_35 (_v_deref__arg12, 0, _v_len___e__e_tmp_m_rfp__lexrf_m_606_m_35);
  uintptr_t _v_len5 = _v_len__name;
  uintptr_t _v_len6 = 3;
  if (_v_len5 < _v_len6)
  {
    RF_RETFAIL;
  }
  uintptr_t _v_len__base = (_v_len5 - _v_len6);
  if (!_c_146.eq (_ve_name, (0 + _v_len__base)))
  {
    RF_RETFAIL;
  }
  Expr _ve_base (_ve_name, 0, _v_len__base);
  _v_res1 = (_ve_base + _c_3);
RF_END

RF_FUNC (Apply__0, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  uintptr_t _v_len1 = _ge_arg1.get_len ();
  uintptr_t _v_len2 = 1;
  if (_v_len1 < _v_len2)
  {
    RF_ERROR (_c_147);
  }
  uintptr_t _v_len__stub1 = (_v_len1 - _v_len2);
  if (!_ge_arg1.symbol_at (0))
  {
    RF_ERROR (_c_147);
  }
  Expr _v_stub2 (_ge_arg1, 0, 1);
  Expr _v_stub1 (_ge_arg1, (0 + 1), _v_len__stub1);
  RF_TAILCALL (Apply::Apply, (_v_stub2, _v_stub1), _v_res1);
RF_END

RF_FUNC (Next_m_Column__0, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  if (_ge_arg1.get_len () != 0)
  {
    RF_ERROR (_c_147);
  }
  RF_CALL (Next_m_Column, /*void*/, /*void*/);
  _v_res1 = empty;
RF_END

}

namespace rfp__lex
{

static void init_ ()
{
  Source = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Source");
  Position = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Position");
  Source_m_Index = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Source-Index");
  Saved_m_Sources = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Saved-Sources");
  Src_m_Counter = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Src-Counter");
  _c_0 = Expr::create<rftype::Integer>("0");
  _c_1 = rftype::Char::create_expr (L"Error: cannot open source file ");
  _c_2 = Expr::create<rftype::Integer>("1");
  _c_3 = rftype::Char::create_expr (L".rfi");
  _c_4 = Expr::create<rftype::Word>("I");
  _c_5 = Expr::create<rftype::Word>("S");
  _c_6 = Expr::create<rftype::Word>("STOP");
  _c_7 = (Expr::create<rftype::Word>("EOF")) ();
  _c_104 = Expr::create<rftype::Word>("USE");
  _c_8 = (_c_104) ();
  _c_47 = Expr::create<rftype::Word>("SEMICOLON");
  _c_9 = (_c_47) ();
  _c_10 = Expr::create<rftype::Word>("WORD");
  _c_11 = Expr::create<rftype::Word>("QWORD");
  _c_12 = rftype::Char::create_expr (L"Error: unexpected end of file during $use parsing");
  _c_13 = Expr::create<rftype::Integer>("2");
  _c_14 = Expr (_c_12, 29, 20);
  _c_15 = rftype::Char::create_expr (L"Error: unexpected token ");
  _c_16 = Expr::create<rftype::Word>("NO-ELABORATE");
  _c_17 = Expr::create<rftype::Word>("T");
  _c_18 = Expr::create<rftype::Word>("F");
  _c_19 = Expr::create<rftype::Word>("CI");
  _c_20 = Expr::create<rftype::Word>("NOT-CI");
  _c_21 = Expr::create<rftype::Word>("Processing ");
  _c_22 = Expr::create<rftype::Word>(".rfi'");
  _c_23 = Expr::create<rftype::Word>("Unable to find include file '");
  _c_24 = Expr::create<rftype::Word>("Unexpected end of file");
  _c_25 = Expr::create<rftype::Word>("Unexpected token ");
  _c_106 = Expr::create<rftype::Word>("IMPORT");
  _c_26 = (_c_106) ();
  _c_27 = rftype::Char::create_expr (L"org.refal.plus.wrappers.");
  _c_28 = rftype::Char::create_expr (L"(");
  _c_29 = Expr::create<rftype::Word>("LPAREN");
  _c_30 = rftype::Char::create_expr (L")");
  _c_31 = Expr::create<rftype::Word>("RPAREN");
  _c_32 = rftype::Char::create_expr (L"<");
  _c_33 = Expr::create<rftype::Word>("LBRACKET");
  _c_34 = rftype::Char::create_expr (L">");
  _c_35 = Expr::create<rftype::Word>("RBRACKET");
  _c_36 = rftype::Char::create_expr (L"{");
  _c_37 = Expr::create<rftype::Word>("LBRACE");
  _c_38 = rftype::Char::create_expr (L"}");
  _c_39 = Expr::create<rftype::Word>("RBRACE");
  _c_40 = rftype::Char::create_expr (L"#");
  _c_41 = Expr::create<rftype::Word>("NOT");
  _c_42 = rftype::Char::create_expr (L"&");
  _c_43 = Expr::create<rftype::Word>("REF");
  _c_44 = rftype::Char::create_expr (L",");
  _c_45 = Expr::create<rftype::Word>("COMMA");
  _c_46 = rftype::Char::create_expr (L";");
  _c_48 = rftype::Char::create_expr (L"=");
  _c_49 = Expr::create<rftype::Word>("EQUAL");
  _c_50 = Expr (_c_15, 5, 1);
  _c_51 = (Expr::create<rftype::Word>("DCOLON")) ();
  _c_52 = (Expr::create<rftype::Word>("COLON")) ();
  _c_53 = rftype::Char::create_expr (L"\\");
  _c_79 = rftype::Char::create_expr (L"$func?");
  _c_54 = Expr (_c_79, 5, 1);
  _c_55 = Expr::create<rftype::Word>("STAKE");
  _c_122 = rftype::Char::create_expr (L"!!tmp-");
  _c_56 = Expr (_c_122, 0, 1);
  _c_57 = Expr::create<rftype::Word>("CUT");
  _c_58 = Expr::create<rftype::Word>("TLBRACE");
  _c_59 = Expr::create<rftype::Word>("'");
  _c_60 = Expr::create<rftype::Word>("Invalid character '");
  _c_61 = Expr::create<rftype::Word>("Unexpected end of line");
  _c_139 = rftype::Char::create_expr (L"*/");
  _c_62 = Expr (_c_139, 1, 1);
  _c_63 = Expr (_c_139, 0, 1);
  _c_64 = rftype::Char::create_expr (L" \n\t");
  _c_65 = Expr (_c_14, 8, 1);
  _c_66 = Expr::create<rftype::Word>("CASE-INSENSITIVE");
  _c_67 = rftype::Char::create_expr (L"$box");
  _c_68 = Expr::create<rftype::Word>("BOX");
  _c_69 = rftype::Char::create_expr (L"$channel");
  _c_70 = Expr::create<rftype::Word>("CHANNEL");
  _c_71 = rftype::Char::create_expr (L"$const");
  _c_72 = Expr::create<rftype::Word>("CONST");
  _c_73 = rftype::Char::create_expr (L"$error");
  _c_74 = Expr::create<rftype::Word>("ERROR");
  _c_75 = rftype::Char::create_expr (L"$fail");
  _c_76 = Expr::create<rftype::Word>("FAIL");
  _c_77 = Expr (_c_79, 0, 5);
  _c_78 = Expr::create<rftype::Word>("FUNC");
  _c_80 = Expr::create<rftype::Word>("FUNC?");
  _c_81 = rftype::Char::create_expr (L"$tfunc");
  _c_82 = Expr::create<rftype::Word>("TPP");
  _c_83 = Expr::create<rftype::Word>("TFUNC");
  _c_84 = Expr::create<rftype::Word>("Incorrect using of t-function \n");
  _c_85 = rftype::Char::create_expr (L"$extern");
  _c_86 = Expr::create<rftype::Word>("EXTERN");
  _c_87 = rftype::Char::create_expr (L"$iter");
  _c_88 = Expr::create<rftype::Word>("ITER");
  _c_89 = rftype::Char::create_expr (L"$l");
  _c_90 = Expr::create<rftype::Word>("L");
  _c_91 = rftype::Char::create_expr (L"$r");
  _c_92 = Expr::create<rftype::Word>("R");
  _c_93 = rftype::Char::create_expr (L"$string");
  _c_94 = Expr::create<rftype::Word>("STRING");
  _c_95 = rftype::Char::create_expr (L"$table");
  _c_96 = Expr::create<rftype::Word>("TABLE");
  _c_99 = rftype::Char::create_expr (L"$traceall");
  _c_97 = Expr (_c_99, 0, 6);
  _c_98 = Expr::create<rftype::Word>("TRACE");
  _c_100 = Expr::create<rftype::Word>("TRACEALL");
  _c_101 = rftype::Char::create_expr (L"$trap");
  _c_102 = Expr::create<rftype::Word>("TRAP");
  _c_103 = Expr (_c_14, 8, 4);
  _c_105 = rftype::Char::create_expr (L"$import");
  _c_107 = rftype::Char::create_expr (L"$vector");
  _c_108 = Expr::create<rftype::Word>("VECTOR");
  _c_109 = rftype::Char::create_expr (L"$with");
  _c_110 = Expr::create<rftype::Word>("WITH");
  _c_111 = Expr (_c_103, 2, 1);
  _c_112 = Expr::create<rftype::Word>("SVAR");
  _c_113 = Expr (_c_103, 3, 1);
  _c_114 = Expr::create<rftype::Word>("EVAR");
  _c_115 = Expr (_c_107, 1, 1);
  _c_116 = Expr::create<rftype::Word>("VVAR");
  _c_117 = Expr (_c_87, 2, 1);
  _c_118 = Expr::create<rftype::Word>("TVAR");
  _c_119 = Expr (_c_3, 0, 1);
  _c_120 = Expr::create<rftype::Word>("Var");
  _c_121 = Expr (_c_122, 5, 1);
  _c_123 = rftype::Char::create_expr (L"+");
  _c_124 = Expr::create<rftype::Word>("NUMBER");
  _c_125 = Expr::create<rftype::Word>("Fun");
  _c_127 = rftype::Char::create_expr (L"?!-.");
  _c_126 = Expr (_c_127, 0, 3);
  _c_128 = rftype::Char::create_expr (L"\"");
  _c_129 = rftype::Char::create_expr (L"'");
  _c_130 = Expr::create<rftype::Word>("SYMBOLS");
  _c_131 = Expr (_c_64, 2, 1);
  _c_132 = Expr (_c_77, 3, 1);
  _c_133 = Expr (_c_64, 1, 1);
  _c_134 = Expr (_c_91, 1, 1);
  _c_135 = rftype::Char::create_expr (L"\r");
  _c_136 = Expr::create<rftype::Word>("Unknown control sequence '\\");
  _c_137 = Expr::create<rftype::Word>("Error") + Expr::create<rftype::Word>("Unterminated string detected");
  _c_138 = Expr (_c_137, 1, 1);
  _c_140 = Expr::create_sym<rftype::Func> (Next_m_Column__0);
  _c_141 = Expr::create_sym<rftype::Func> (Apply__0);
  _c_142 = (empty) ();
  _c_143 = Expr::create<rftype::Word>("Trying to open '");
  _c_144 = Expr::create<rftype::Word>("' successfully opened");
  _c_145 = Expr::create<rftype::Word>("FILE");
  _c_146 = Expr (_c_3, 0, 3);
  _c_147 = Expr::create<rftype::Word>("Apply") + Expr::create<rftype::Word>("Apply") + Expr::create<rftype::Word>("Unexpected fail");
}

static AtStart init_registrator_ (&init_);

}

}
