#include <rf_core.hh>
#include <refal/Access.hh>
#include <refal/Box.hh>
#include <refal/Convert.hh>
#include <refal/Compare.hh>
#include <refal/Arithm.hh>
#include <refal/Table.hh>
#include "rfp_helper.hh"
#include "rfpc.hh"
#include "rfp_src.hh"
#include "rfp_err.hh"
#include <refal/StdIO.hh>

namespace refal
{

using namespace rfrt;

namespace rfp__parse
{

static Expr Module_m_Name_m_Box;

static Expr Saved_m_Position;

static Expr Unget_m_Stack;

static Expr Constants;

static Expr Names;

static Expr Traceall_q_;

RF_DECL (Token_m_Descr);

RF_DECL (Get_m_Token);

RF_DECL (Unget_m_Token);

RF_DECL (Expect_m_Token);

RF_DECL (RFP_m_Parser);

RF_DECL (Module_m_Name);

RF_DECL (Interface_q_);

RF_DECL (Parse_m_Body);

RF_DECL (Parse_m_Imports);

RF_DECL (Parse_m_Object_m_Decls);

RF_DECL (Parse_m_Const_m_Expr);

RF_DECL (Parse_m_Const_m_Term);

RF_DECL (Parse_m_Const_m_Decls);

RF_DECL (Lookup_m_Name);

RF_DECL (Lookup_m_Check);

RF_DECL (Bind_m_Name);

RF_DECL (Parse_m_Extern_m_Names);

RF_DECL (Parse_m_Func_m_Decl);

RF_DECL (Parse_m_Format);

RF_DECL (Parse_m_Format_m_Terms);

RF_DECL (Parse_m_Hard_m_Expr);

RF_DECL (Parse_m_Hard_m_Expr_m_Terms);

RF_DECL (Parse_m_Trace_m_Names);

RF_DECL (Parse_m_Func_m_Def);

RF_DECL (Parse_m_Alt);

RF_DECL (Parse_m_Sentence);

RF_DECL (Tail_q_);

RF_DECL (Parse_m_Tail);

RF_DECL (Parse_m_Path);

RF_DECL (Parse_m_Source);

RF_DECL (Parse_m_Result);

RF_DECL (Parse_m_Result_m_Term);

RF_DECL (Parse_m_Pattern);

RF_DECL (Parse_m_Pattern_m_Expr);

RF_DECL (Parse_m_Pattern_m_Term);

RF_DECL (Parse_m_Ref);

RF_DECL (Make_m_Name);

RF_DECL (Make_m_Name2);

RF_DECL (Canonical_m_Name);

RF_DECL (Canonical_m_Word);

RF_DECL (Pragma);

static Expr _c_89;

static Expr _c_0;

static Expr _c_1;

static Expr _c_132;

static Expr _c_2;

static Expr _c_3;

static Expr _c_4;

static Expr _c_5;

static Expr _c_71;

static Expr _c_6;

static Expr _c_7;

static Expr _c_137;

static Expr _c_117;

static Expr _c_8;

static Expr _c_9;

static Expr _c_118;

static Expr _c_10;

static Expr _c_11;

static Expr _c_12;

static Expr _c_13;

static Expr _c_14;

static Expr _c_15;

static Expr _c_85;

static Expr _c_16;

static Expr _c_17;

static Expr _c_18;

static Expr _c_19;

static Expr _c_20;

static Expr _c_21;

static Expr _c_122;

static Expr _c_22;

static Expr _c_23;

static Expr _c_24;

static Expr _c_25;

static Expr _c_69;

static Expr _c_26;

static Expr _c_27;

static Expr _c_99;

static Expr _c_28;

static Expr _c_29;

static Expr _c_30;

static Expr _c_31;

static Expr _c_100;

static Expr _c_32;

static Expr _c_33;

static Expr _c_34;

static Expr _c_35;

static Expr _c_36;

static Expr _c_37;

static Expr _c_38;

static Expr _c_39;

static Expr _c_40;

static Expr _c_41;

static Expr _c_42;

static Expr _c_43;

static Expr _c_44;

static Expr _c_45;

static Expr _c_46;

static Expr _c_47;

static Expr _c_48;

static Expr _c_49;

static Expr _c_50;

static Expr _c_51;

static Expr _c_52;

static Expr _c_53;

static Expr _c_54;

static Expr _c_55;

static Expr _c_56;

static Expr _c_57;

static Expr _c_58;

static Expr _c_59;

static Expr _c_60;

static Expr _c_61;

static Expr _c_62;

static Expr _c_63;

static Expr _c_64;

static Expr _c_65;

static Expr _c_66;

static Expr _c_67;

static Expr _c_68;

static Expr _c_70;

static Expr _c_72;

static Expr _c_73;

static Expr _c_112;

static Expr _c_74;

static Expr _c_146;

static Expr _c_114;

static Expr _c_75;

static Expr _c_76;

static Expr _c_77;

static Expr _c_78;

static Expr _c_79;

static Expr _c_80;

static Expr _c_81;

static Expr _c_82;

static Expr _c_83;

static Expr _c_84;

static Expr _c_86;

static Expr _c_87;

static Expr _c_88;

static Expr _c_90;

static Expr _c_91;

static Expr _c_92;

static Expr _c_93;

static Expr _c_94;

static Expr _c_95;

static Expr _c_96;

static Expr _c_97;

static Expr _c_98;

static Expr _c_101;

static Expr _c_102;

static Expr _c_103;

static Expr _c_104;

static Expr _c_105;

static Expr _c_106;

static Expr _c_107;

static Expr _c_108;

static Expr _c_109;

static Expr _c_110;

static Expr _c_111;

static Expr _c_113;

static Expr _c_115;

static Expr _c_116;

static Expr _c_119;

static Expr _c_120;

static Expr _c_121;

static Expr _c_123;

static Expr _c_124;

static Expr _c_125;

static Expr _c_126;

static Expr _c_127;

static Expr _c_128;

static Expr _c_129;

static Expr _c_130;

static Expr _c_131;

static Expr _c_133;

static Expr _c_134;

static Expr _c_135;

static Expr _c_136;

static Expr _c_138;

static Expr _c_139;

static Expr _c_140;

static Expr _c_141;

static Expr _c_142;

static Expr _c_143;

static Expr _c_144;

static Expr _c_145;

RF_FUNC (Token_m_Descr, (RF_ARG _gs_arg1;;), (RF_RES _v_res1;;))
  {
    {
      if (!_gs_arg1.term_eq (_c_0, 0))
      {
        goto _block1__branch1;
      }
      _v_res1 = _c_1;
      goto _block1;
    }
  _block1__branch1: {}
    {
      if (!_gs_arg1.term_eq (_c_2, 0))
      {
        goto _block1__branch2;
      }
      _v_res1 = _c_3;
      goto _block1;
    }
  _block1__branch2: {}
    {
      if (!_gs_arg1.term_eq (_c_4, 0))
      {
        goto _block1__branch3;
      }
      _v_res1 = _c_5;
      goto _block1;
    }
  _block1__branch3: {}
    {
      if (!_gs_arg1.term_eq (_c_6, 0))
      {
        goto _block1__branch4;
      }
      _v_res1 = _c_7;
      goto _block1;
    }
  _block1__branch4: {}
    {
      if (!_gs_arg1.term_eq (_c_8, 0))
      {
        goto _block1__branch5;
      }
      _v_res1 = _c_9;
      goto _block1;
    }
  _block1__branch5: {}
    {
      if (!_gs_arg1.term_eq (_c_10, 0))
      {
        goto _block1__branch6;
      }
      _v_res1 = _c_11;
      goto _block1;
    }
  _block1__branch6: {}
    {
      if (!_gs_arg1.term_eq (_c_12, 0))
      {
        goto _block1__branch7;
      }
      _v_res1 = _c_13;
      goto _block1;
    }
  _block1__branch7: {}
    {
      if (!_gs_arg1.term_eq (_c_14, 0))
      {
        goto _block1__branch8;
      }
      _v_res1 = _c_15;
      goto _block1;
    }
  _block1__branch8: {}
    {
      if (!_gs_arg1.term_eq (_c_16, 0))
      {
        goto _block1__branch9;
      }
      _v_res1 = _c_17;
      goto _block1;
    }
  _block1__branch9: {}
    {
      if (!_gs_arg1.term_eq (_c_18, 0))
      {
        goto _block1__branch10;
      }
      _v_res1 = _c_19;
      goto _block1;
    }
  _block1__branch10: {}
    {
      if (!_gs_arg1.term_eq (_c_20, 0))
      {
        goto _block1__branch11;
      }
      _v_res1 = _c_21;
      goto _block1;
    }
  _block1__branch11: {}
    {
      if (!_gs_arg1.term_eq (_c_22, 0))
      {
        goto _block1__branch12;
      }
      _v_res1 = _c_23;
      goto _block1;
    }
  _block1__branch12: {}
    {
      if (!_gs_arg1.term_eq (_c_24, 0))
      {
        goto _block1__branch13;
      }
      _v_res1 = _c_25;
      goto _block1;
    }
  _block1__branch13: {}
    {
      if (!_gs_arg1.term_eq (_c_26, 0))
      {
        goto _block1__branch14;
      }
      _v_res1 = _c_27;
      goto _block1;
    }
  _block1__branch14: {}
    {
      if (!_gs_arg1.term_eq (_c_28, 0))
      {
        goto _block1__branch15;
      }
      _v_res1 = _c_29;
      goto _block1;
    }
  _block1__branch15: {}
    {
      if (!_gs_arg1.term_eq (_c_30, 0))
      {
        goto _block1__branch16;
      }
      _v_res1 = _c_31;
      goto _block1;
    }
  _block1__branch16: {}
    {
      if (!_gs_arg1.term_eq (_c_32, 0))
      {
        goto _block1__branch17;
      }
      _v_res1 = _c_33;
      goto _block1;
    }
  _block1__branch17: {}
    {
      if (!_gs_arg1.term_eq (_c_34, 0))
      {
        goto _block1__branch18;
      }
      _v_res1 = _c_35;
      goto _block1;
    }
  _block1__branch18: {}
    {
      if (!_gs_arg1.term_eq (_c_36, 0))
      {
        goto _block1__branch19;
      }
      _v_res1 = _c_37;
      goto _block1;
    }
  _block1__branch19: {}
    {
      if (!_gs_arg1.term_eq (_c_38, 0))
      {
        goto _block1__branch20;
      }
      _v_res1 = _c_39;
      goto _block1;
    }
  _block1__branch20: {}
    {
      if (!_gs_arg1.term_eq (_c_40, 0))
      {
        goto _block1__branch21;
      }
      _v_res1 = _c_41;
      goto _block1;
    }
  _block1__branch21: {}
    {
      if (!_gs_arg1.term_eq (_c_42, 0))
      {
        goto _block1__branch22;
      }
      _v_res1 = _c_43;
      goto _block1;
    }
  _block1__branch22: {}
    {
      if (!_gs_arg1.term_eq (_c_44, 0))
      {
        goto _block1__branch23;
      }
      _v_res1 = _c_45;
      goto _block1;
    }
  _block1__branch23: {}
    {
      if (!_gs_arg1.term_eq (_c_46, 0))
      {
        goto _block1__branch24;
      }
      _v_res1 = _c_47;
      goto _block1;
    }
  _block1__branch24: {}
    {
      if (!_gs_arg1.term_eq (_c_48, 0))
      {
        goto _block1__branch25;
      }
      _v_res1 = _c_49;
      goto _block1;
    }
  _block1__branch25: {}
    {
      if (!_gs_arg1.term_eq (_c_50, 0))
      {
        goto _block1__branch26;
      }
      _v_res1 = _c_51;
      goto _block1;
    }
  _block1__branch26: {}
    {
      if (!_gs_arg1.term_eq (_c_52, 0))
      {
        goto _block1__branch27;
      }
      _v_res1 = _c_53;
      goto _block1;
    }
  _block1__branch27: {}
    {
      if (!_gs_arg1.term_eq (_c_54, 0))
      {
        goto _block1__branch28;
      }
      _v_res1 = _c_55;
      goto _block1;
    }
  _block1__branch28: {}
    {
      if (!_gs_arg1.term_eq (_c_56, 0))
      {
        goto _block1__branch29;
      }
      _v_res1 = _c_57;
      goto _block1;
    }
  _block1__branch29: {}
    {
      if (!_gs_arg1.term_eq (_c_58, 0))
      {
        goto _block1__branch30;
      }
      _v_res1 = _c_59;
      goto _block1;
    }
  _block1__branch30: {}
    _v_res1 = (_c_60 + _gs_arg1);
  }
_block1: {}
RF_END

RF_FUNC (Get_m_Token, RF_VOID, (RF_RES _v_res1, _v_res2, _v_res3;;))
  {
    {
      Expr _v__q_1;
      RF_CALL (Box::_q_, Unget_m_Stack, _v__q_1);
      if (_v__q_1.get_len () != 2)
      {
        goto _block1__branch1;
      }
      if (_v__q_1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      if (_v__q_1.symbol_at ((0 + 1)))
      {
        goto _block1__branch1;
      }
      Expr _v_deref___q_1 (_v__q_1, 0);
      Expr _v_deref___q_12 (_v__q_1, (0 + 1));
      if (_v_deref___q_12.get_len () != 2)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len1 = _v_deref___q_1.get_len ();
      uintptr_t _v_len2 = 0;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__tokens = (_v_len1 - _v_len2);
      if (_v_deref___q_12.symbol_at (0))
      {
        goto _block1__branch1;
      }
      if (_v_deref___q_12.symbol_at ((0 + 1)))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__deref___q_12 (_v_deref___q_12, 0);
      Expr _v_deref__deref___q_122 (_v_deref___q_12, (0 + 1));
      uintptr_t _v_len3 = _v_deref__deref___q_122.get_len ();
      uintptr_t _v_len4 = 1;
      if (_v_len3 < _v_len4)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__value = (_v_len3 - _v_len4);
      uintptr_t _v_len5 = _v_deref__deref___q_12.get_len ();
      uintptr_t _v_len6 = 0;
      if (_v_len5 < _v_len6)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__pos = (_v_len5 - _v_len6);
      if (!_v_deref__deref___q_122.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _ve_tokens (_v_deref___q_1, 0, _v_len__tokens);
      Expr _ve_pos (_v_deref__deref___q_12, 0, _v_len__pos);
      Expr _vs_type (_v_deref__deref___q_122, 0, 1);
      Expr _ve_value (_v_deref__deref___q_122, (0 + 1), _v_len__value);
      RF_CALL (Box::Store, (Unget_m_Stack, _ve_tokens), /*void*/);
      _v_res1 = _ve_pos;
      _v_res2 = _vs_type;
      _v_res3 = _ve_value;
      goto _block1;
    }
  _block1__branch1: {}
    Expr _v__q_2;
    RF_CALL (Box::_q_, rfpc::RFP_m_Token_m_Stack, _v__q_2);
    uintptr_t _v_len7 = _v__q_2.get_len ();
    uintptr_t _v_len8 = 1;
    if (_v_len7 < _v_len8)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    uintptr_t _v_len__rest = (_v_len7 - _v_len8);
    if (_v__q_2.symbol_at (0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _v_deref___q_2 (_v__q_2, 0);
    uintptr_t _v_len9 = _v_deref___q_2.get_len ();
    uintptr_t _v_len10 = 0;
    if (_v_len9 < _v_len10)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    uintptr_t _v_len__token = (_v_len9 - _v_len10);
    Expr _ve_rest (_v__q_2, (0 + 1), _v_len__rest);
    Expr _ve_token (_v_deref___q_2, 0, _v_len__token);
    RF_CALL (Box::Store, (rfpc::RFP_m_Token_m_Stack, _ve_rest), /*void*/);
    if (_v_len__token != 2)
    {
      RF_RETFAIL;
    }
    if (_ve_token.symbol_at (0))
    {
      RF_RETFAIL;
    }
    if (_ve_token.symbol_at ((0 + 1)))
    {
      RF_RETFAIL;
    }
    Expr _v_deref__token (_ve_token, 0);
    Expr _v_deref__token2 (_ve_token, (0 + 1));
    uintptr_t _v_len11 = _v_deref__token2.get_len ();
    uintptr_t _v_len12 = 1;
    if (_v_len11 < _v_len12)
    {
      RF_RETFAIL;
    }
    uintptr_t _v_len__value2 = (_v_len11 - _v_len12);
    uintptr_t _v_len13 = _v_deref__token.get_len ();
    uintptr_t _v_len14 = 0;
    if (_v_len13 < _v_len14)
    {
      RF_RETFAIL;
    }
    uintptr_t _v_len__pos2 = (_v_len13 - _v_len14);
    if (!_v_deref__token2.symbol_at (0))
    {
      RF_RETFAIL;
    }
    Expr _ve_pos (_v_deref__token, 0, _v_len__pos2);
    Expr _vs_type (_v_deref__token2, 0, 1);
    Expr _ve_value (_v_deref__token2, (0 + 1), _v_len__value2);
    _v_res1 = _ve_pos;
    _v_res2 = _vs_type;
    _v_res3 = _ve_value;
  }
_block1: {}
RF_END

RF_FUNC (Unget_m_Token, (RF_ARG _ve_token;;), RF_VOID)
  Expr _ge_auxcall1;
  RF_CALL (Box::_q_, Unget_m_Stack, _ge_auxcall1);
  RF_TAILCALL (Box::Store, (Unget_m_Stack, (_ge_auxcall1 () + _ve_token ())), /*void*/);
RF_END

RF_FUNC (Expect_m_Token, (RF_ARG _ve_types;;), (RF_RES _v_res1, _v_res2, _v_res3;;))
  Expr _ve_pos;
  Expr _vs_type;
  Expr _ve_value;
  if (!RF_CALL (Get_m_Token, /*void*/, (_ve_pos, _vs_type, _ve_value)))
  {
    RF_RETFAIL;
  }
  Expr _vs_message (_c_61);
  for ( ; ; )
  {
    {
      {
        {
          if (_ve_types.get_len () < 1)
          {
            goto _block1__branch1;
          }
          RF_lsplit (_ve_types, 0, _ve__e__e_tmp_m_rfp__parserf_m_153_m_13, _v_lsplit__types);
          for ( ; ; RF_iter(_ve_types)++)
          {
            {
              if (!RF_iter(_ve_types))
              {
                goto _block1__branch1;
              }
              uintptr_t _v_len1 = _v_lsplit__types.get_len ();
              uintptr_t _v_len2 = 1;
              if (_v_len1 < _v_len2)
              {
                goto _block1__branch1;
              }
              uintptr_t _v_len___e__e_tmp_m_rfp__parserf_m_153_m_22 = (_v_len1 - _v_len2);
              if (!_vs_type.term_eq (_v_lsplit__types, 0))
              {
                goto _continue1;
              }
              Expr _ve__e__e_tmp_m_rfp__parserf_m_153_m_22 (_v_lsplit__types, (0 + 1), _v_len___e__e_tmp_m_rfp__parserf_m_153_m_22);
              _v_res1 = _ve_pos;
              _v_res2 = _vs_type;
              _v_res3 = _ve_value;
              goto _exit1;
            }
        _continue1: {}
          }
        _exit1: {}
          goto _block1;
        }
      _block1__branch1: {}
        if (_ve_types.get_len () < 1)
        {
          goto _iter1;
        }
        RF_lsplit (_ve_types, 0, _ve__e__e_tmp_m_rfp__parserf_m_156_m_13, _v_lsplit__types2);
        for ( ; ; RF_iter(_ve_types)++)
        {
          {
            if (!RF_iter(_ve_types))
            {
              goto _iter1;
            }
            uintptr_t _v_len3 = _v_lsplit__types2.get_len ();
            uintptr_t _v_len4 = 1;
            if (_v_len3 < _v_len4)
            {
              goto _iter1;
            }
            uintptr_t _v_len___e__e_tmp_m_rfp__parserf_m_156_m_21 = (_v_len3 - _v_len4);
            if (!_c_62.term_eq (_v_lsplit__types2, 0))
            {
              goto _continue2;
            }
            Expr _ve__e__e_tmp_m_rfp__parserf_m_156_m_21 (_v_lsplit__types2, (0 + 1), _v_len___e__e_tmp_m_rfp__parserf_m_156_m_21);
            RF_CALL (Unget_m_Token, (_ve_pos () + (_vs_type + _ve_value) ()), /*void*/);
            _v_res1 = _ve_pos;
            _v_res2 = _c_62;
            _v_res3 = empty;
            goto _exit2;
          }
      _continue2: {}
        }
      _exit2: {}
      }
    _block1: {}
      goto _exit__iter1;
    }
  _iter1: {}
    {
      {
        {
          if (!_vs_message.term_eq (_c_61, 0))
          {
            goto _block3__branch1;
          }
          goto _block3;
        }
      _block3__branch1: {}
        if (!_vs_type.term_eq (_c_26, 0))
        {
          goto _block2__branch1;
        }
      }
    _block3: {}
      Expr _ge_auxcall1;
      RF_CALL (Token_m_Descr, _vs_type, _ge_auxcall1);
      RF_CALL (rfp__err::RFP_m_Error, (_ve_pos, (_c_63 + _ge_auxcall1)), /*void*/);
    }
  _block2__branch1: {}
    if (!RF_CALL (Get_m_Token, /*void*/, (_ve_pos, _vs_type, _ve_value)))
    {
      RF_RETFAIL;
    }
    _vs_message = _c_64;
  }
_exit__iter1: {}
RF_END

RF_FUNC (RFP_m_Parser, RF_VOID, (RF_RES _v_res1;;))
  RF_CALL (rfp__helper::RFP_m_Clear_m_Table, Constants, /*void*/);
  RF_CALL (rfp__helper::RFP_m_Clear_m_Table, Names, /*void*/);
  RF_CALL (Box::Store, (Unget_m_Stack, empty), /*void*/);
  Expr _ge_auxcall1;
  if (!RF_CALL (Table::Lookup, (rfp__src::RFP_m_Sources, _c_65), _ge_auxcall1))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _ge_auxcall2;
  RF_CALL (rfp__src::RFP_m_Module_m_Name, _ge_auxcall1, _ge_auxcall2);
  RF_CALL (Box::Store, (Module_m_Name_m_Box, _ge_auxcall2), /*void*/);
  {
    {
      if (!RF_CALL (Interface_q_, /*void*/, /*void*/))
      {
        goto _block1__branch1;
      }
      Expr _ge_auxcall3;
      RF_CALL (Module_m_Name, /*void*/, _ge_auxcall3);
      Expr _gt_auxcall4;
      RF_CALL (Make_m_Name, _ge_auxcall3, _gt_auxcall4);
      Expr _ge_auxcall5;
      RF_CALL (Parse_m_Body, /*void*/, _ge_auxcall5);
      _v_res1 = (_c_66 + _gt_auxcall4 + _ge_auxcall5) ();
      goto _block1;
    }
  _block1__branch1: {}
    Expr _ge_auxcall6;
    RF_CALL (Module_m_Name, /*void*/, _ge_auxcall6);
    Expr _gt_auxcall7;
    RF_CALL (Make_m_Name, _ge_auxcall6, _gt_auxcall7);
    Expr _ge_auxcall8;
    RF_CALL (Parse_m_Body, /*void*/, _ge_auxcall8);
    _v_res1 = (_c_67 + _gt_auxcall7 + _ge_auxcall8) ();
  }
_block1: {}
RF_END

RF_FUNC (Module_m_Name, RF_VOID, (RF_RES _v_res1;;))
  RF_TAILCALL (Box::_q_, Module_m_Name_m_Box, _v_res1);
RF_END

RF_FUNC (Interface_q_, RF_VOID, RF_VOID)
  Expr _v_RFP_m_Source_m_File_m_Name1;
  RF_CALL (rfp__src::RFP_m_Source_m_File_m_Name, _c_65, _v_RFP_m_Source_m_File_m_Name1);
  uintptr_t _v_len1 = _v_RFP_m_Source_m_File_m_Name1.get_len ();
  uintptr_t _v_len2 = 4;
  if (_v_len1 < _v_len2)
  {
    RF_RETFAIL;
  }
  uintptr_t _v_len___e__e_tmp_m_rfp__parserf_m_183_m_33 = (_v_len1 - _v_len2);
  if (!_c_68.eq (_v_RFP_m_Source_m_File_m_Name1, (0 + _v_len___e__e_tmp_m_rfp__parserf_m_183_m_33)))
  {
    RF_RETFAIL;
  }
  Expr _ve__e__e_tmp_m_rfp__parserf_m_183_m_33 (_v_RFP_m_Source_m_File_m_Name1, 0, _v_len___e__e_tmp_m_rfp__parserf_m_183_m_33);
RF_END

RF_FUNC (Parse_m_Body, RF_VOID, (RF_RES _v_res1;;))
  {
    {
      Expr _ve_pos;
      Expr _vs_type;
      Expr _ve_value;
      if (!RF_CALL (Expect_m_Token, _c_69, (_ve_pos, _vs_type, _ve_value)))
      {
        goto _block1__branch1;
      }
      RF_CALL (Box::Store, (Saved_m_Position, _ve_pos), /*void*/);
      Expr _ve_items;
      {
        {
          {
            {
              if (!_vs_type.term_eq (_c_36, 0))
              {
                goto _block3__branch1;
              }
              goto _block3;
            }
          _block3__branch1: {}
            {
              if (!_vs_type.term_eq (_c_38, 0))
              {
                goto _block3__branch2;
              }
              goto _block3;
            }
          _block3__branch2: {}
            {
              if (!_vs_type.term_eq (_c_40, 0))
              {
                goto _block3__branch3;
              }
              goto _block3;
            }
          _block3__branch3: {}
            {
              if (!_vs_type.term_eq (_c_42, 0))
              {
                goto _block3__branch4;
              }
              goto _block3;
            }
          _block3__branch4: {}
            if (!_vs_type.term_eq (_c_52, 0))
            {
              goto _block2__branch1;
            }
          }
        _block3: {}
          RF_CALL (Parse_m_Object_m_Decls, _vs_type, _ve_items);
          goto _block2;
        }
      _block2__branch1: {}
        {
          if (!_vs_type.term_eq (_c_54, 0))
          {
            goto _block2__branch2;
          }
          RF_CALL (Parse_m_Imports, /*void*/, _ve_items);
          goto _block2;
        }
      _block2__branch2: {}
        {
          if (!_vs_type.term_eq (_c_70, 0))
          {
            goto _block2__branch3;
          }
          RF_CALL (Parse_m_Const_m_Decls, /*void*/, _ve_items);
          goto _block2;
        }
      _block2__branch3: {}
        {
          if (!_vs_type.term_eq (_c_56, 0))
          {
            goto _block2__branch4;
          }
          RF_CALL (Parse_m_Trace_m_Names, /*void*/, _ve_items);
          goto _block2;
        }
      _block2__branch4: {}
        {
          if (!_vs_type.term_eq (_c_58, 0))
          {
            goto _block2__branch5;
          }
          RF_CALL (Box::Store, (Traceall_q_, _c_58), /*void*/);
          Expr _v_Expect_m_Token1;
          Expr _v_Expect_m_Token2;
          Expr _v_Expect_m_Token3;
          if (!RF_CALL (Expect_m_Token, _c_71, (_v_Expect_m_Token1, _v_Expect_m_Token2, _v_Expect_m_Token3)))
          {
            goto _block1__branch1;
          }
          uintptr_t _v_len1 = 2;
          uintptr_t _v_len2 = 0;
          if (_v_len1 < _v_len2)
          {
            goto _block1__branch1;
          }
          uintptr_t _v_len___e__e_tmp_m_rfp__parserf_m_212_m_43 = (_v_len1 - _v_len2);
          Expr _v_compose1 ((_v_Expect_m_Token1 () + (_v_Expect_m_Token2 + _v_Expect_m_Token3) ()));
          Expr _ve__e__e_tmp_m_rfp__parserf_m_212_m_43 (_v_compose1, 0, _v_len___e__e_tmp_m_rfp__parserf_m_212_m_43);
          _ve_items = empty;
          goto _block2;
        }
      _block2__branch5: {}
        {
          if (!_vs_type.term_eq (_c_50, 0))
          {
            goto _block2__branch6;
          }
          RF_CALL (Parse_m_Extern_m_Names, /*void*/, _ve_items);
          goto _block2;
        }
      _block2__branch6: {}
        {
          {
            {
              if (!_vs_type.term_eq (_c_44, 0))
              {
                goto _block4__branch1;
              }
              goto _block4;
            }
          _block4__branch1: {}
            {
              if (!_vs_type.term_eq (_c_46, 0))
              {
                goto _block4__branch2;
              }
              goto _block4;
            }
          _block4__branch2: {}
            if (!_vs_type.term_eq (_c_48, 0))
            {
              goto _block2__branch7;
            }
          }
        _block4: {}
          RF_CALL (Parse_m_Func_m_Decl, _vs_type, _ve_items);
          goto _block2;
        }
      _block2__branch7: {}
        {
          {
            {
              if (!_vs_type.term_eq (_c_72, 0))
              {
                goto _block5__branch1;
              }
              goto _block5;
            }
          _block5__branch1: {}
            if (!_vs_type.term_eq (_c_73, 0))
            {
              goto _block2__branch8;
            }
          }
        _block5: {}
          RF_CALL (Parse_m_Func_m_Def, (_ve_pos, _vs_type, _ve_value), _ve_items);
          goto _block2;
        }
      _block2__branch8: {}
        {
          if (!_vs_type.term_eq (_c_26, 0))
          {
            goto _negation1;
          }
          goto _block1__branch1;
        }
      _negation1: {}
        _ve_items = empty;
      }
    _block2: {}
      Expr _v_Parse_m_Body1;
      RF_CALL (Parse_m_Body, /*void*/, _v_Parse_m_Body1);
      _v_res1 = (_ve_items + _v_Parse_m_Body1);
      goto _block1;
    }
  _block1__branch1: {}
    {
      if (!RF_CALL (Interface_q_, /*void*/, /*void*/))
      {
        goto _block1__branch2;
      }
      _v_res1 = empty;
      goto _block1;
    }
  _block1__branch2: {}
    Expr _ge_auxcall1;
    RF_CALL (Table::Domain, Names, _ge_auxcall1);
    Expr _ve_domain (_ge_auxcall1);
    Expr _ve_undefs (empty);
    for ( ; ; )
    {
      {
        if (_ve_domain.get_len () != 0)
        {
          goto _iter1;
        }
        _v_res1 = _ve_undefs;
        goto _exit__iter1;
      }
    _iter1: {}
      {
        {
          if (_ve_domain.get_len () < 1)
          {
            goto _block7__branch1;
          }
          RF_lsplit (_ve_domain, 0, _ve__e__e_tmp_m_rfp__parserf_m_232_m_17, _v_lsplit__domain);
          for ( ; ; RF_iter(_ve_domain)++)
          {
            {
              if (!RF_iter(_ve_domain))
              {
                goto _block7__branch1;
              }
              uintptr_t _v_len3 = _v_lsplit__domain.get_len ();
              uintptr_t _v_len4 = 1;
              if (_v_len3 < _v_len4)
              {
                goto _block7__branch1;
              }
              uintptr_t _v_len__rest = (_v_len3 - _v_len4);
              if (_v_lsplit__domain.symbol_at (0))
              {
                goto _continue1;
              }
              Expr _v_deref__lsplit__domain (_v_lsplit__domain, 0);
              uintptr_t _v_len5 = _v_deref__lsplit__domain.get_len ();
              uintptr_t _v_len6 = 0;
              if (_v_len5 < _v_len6)
              {
                goto _continue1;
              }
              uintptr_t _v_len__name = (_v_len5 - _v_len6);
              Expr _ve_rest (_v_lsplit__domain, (0 + 1), _v_len__rest);
              Expr _ve_name (_v_deref__lsplit__domain, 0, _v_len__name);
              Expr _v_Lookup1;
              if (!RF_CALL (Table::Lookup, (Names, _ve_name), _v_Lookup1))
              {
                goto _continue1;
              }
              if (_v_Lookup1.get_len () != 6)
              {
                goto _continue1;
              }
              if (_v_Lookup1.symbol_at (0))
              {
                goto _continue1;
              }
              if (_v_Lookup1.symbol_at ((0 + 1)))
              {
                goto _continue1;
              }
              Expr _v_deref__Lookup1 (_v_Lookup1, 0);
              Expr _v_deref__Lookup12 (_v_Lookup1, (0 + 1));
              uintptr_t _v_len7 = _v_deref__Lookup12.get_len ();
              uintptr_t _v_len8 = 0;
              if (_v_len7 < _v_len8)
              {
                goto _continue1;
              }
              uintptr_t _v_len__decl_m_name = (_v_len7 - _v_len8);
              uintptr_t _v_len9 = _v_deref__Lookup1.get_len ();
              uintptr_t _v_len10 = 0;
              if (_v_len9 < _v_len10)
              {
                goto _continue1;
              }
              uintptr_t _v_len__decl_m_pos = (_v_len9 - _v_len10);
              if (!_v_Lookup1.symbol_at ((0 + 1 + 1)))
              {
                goto _continue1;
              }
              if (!_v_Lookup1.symbol_at ((0 + 1 + 1 + 1)))
              {
                goto _continue1;
              }
              Expr _vs_tag (_v_Lookup1, (0 + 1 + 1), 1);
              Expr _vs_linkage (_v_Lookup1, (0 + 1 + 1 + 1), 1);
              Expr _vt_in (_v_Lookup1, (0 + 1 + 1 + 1 + 1), 1);
              Expr _vt_out (_v_Lookup1, (0 + 1 + 1 + 1 + 1 + 1), 1);
              Expr _ve_decl_m_pos (_v_deref__Lookup1, 0, _v_len__decl_m_pos);
              Expr _ve_decl_m_name (_v_deref__Lookup12, 0, _v_len__decl_m_name);
              {
                {
                  if (!_vs_linkage.term_eq (_c_74, 0))
                  {
                    goto _block8__branch1;
                  }
                  goto _block8;
                }
              _block8__branch1: {}
                if (!_vs_linkage.term_eq (_c_75, 0))
                {
                  goto _continue1;
                }
              }
            _block8: {}
              RF_CALL (rfp__err::RFP_m_Warning, (_ve_decl_m_pos, (_c_77 + _ve_name + _c_76)), /*void*/);
              Expr _ge_auxcall2;
              RF_CALL (Pragma, _ve_decl_m_pos, _ge_auxcall2);
              Expr _gt_auxcall3;
              RF_CALL (Make_m_Name, _ve_decl_m_name, _gt_auxcall3);
              _ve_domain = _ve_rest;
              _ve_undefs = (_ve_undefs + (_c_79 + _vs_tag + (_c_78 + _ge_auxcall2) () + _gt_auxcall3 + _vt_in + _vt_out) ());
              goto _exit1;
            }
        _continue1: {}
          }
        _exit1: {}
          goto _block7;
        }
      _block7__branch1: {}
        _ve_domain = empty;
      }
    _block7: {}
    }
  _exit__iter1: {}
  }
_block1: {}
RF_END

RF_FUNC (Parse_m_Imports, RF_VOID, (RF_RES _v_res1;;))
  Expr _ve_pos;
  Expr _vs_type;
  Expr _ve_value;
  if (!RF_CALL (Expect_m_Token, _c_80, (_ve_pos, _vs_type, _ve_value)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  {
    {
      if (!_vs_type.term_eq (_c_6, 0))
      {
        goto _block1__branch1;
      }
      _v_res1 = empty;
      goto _block1;
    }
  _block1__branch1: {}
    Expr _gt_auxcall1;
    RF_CALL (Make_m_Name, _ve_value, _gt_auxcall1);
    Expr _v_Parse_m_Imports1;
    RF_CALL (Parse_m_Imports, /*void*/, _v_Parse_m_Imports1);
    _v_res1 = ((_c_54 + _gt_auxcall1) () + _v_Parse_m_Imports1);
  }
_block1: {}
RF_END

RF_FUNC (Parse_m_Object_m_Decls, (RF_ARG _vs_type;;), (RF_RES _v_res1;;))
  Expr _v_Expect_m_Token1;
  Expr _v_Expect_m_Token2;
  Expr _v_Expect_m_Token3;
  if (!RF_CALL (Expect_m_Token, _c_80, (_v_Expect_m_Token1, _v_Expect_m_Token2, _v_Expect_m_Token3)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  {
    {
      Expr _v_compose1 ((_v_Expect_m_Token1 () + (_v_Expect_m_Token2 + _v_Expect_m_Token3) ()));
      if (_v_compose1.symbol_at (0))
      {
        goto _block2__branch1;
      }
      Expr _v_deref__compose1 (_v_compose1, 0);
      uintptr_t _v_len1 = _v_deref__compose1.get_len ();
      uintptr_t _v_len2 = 0;
      if (_v_len1 < _v_len2)
      {
        goto _block2__branch1;
      }
      uintptr_t _v_len___e__e_tmp_m_rfp__parserf_m_256_m_9 = (_v_len1 - _v_len2);
      if (!_c_81.term_eq (_v_compose1, (0 + 1)))
      {
        goto _block2__branch1;
      }
      Expr _ve__e__e_tmp_m_rfp__parserf_m_256_m_9 (_v_deref__compose1, 0, _v_len___e__e_tmp_m_rfp__parserf_m_256_m_9);
      _v_res1 = empty;
      goto _block2;
    }
  _block2__branch1: {}
    Expr _v_compose2 ((_v_Expect_m_Token1 () + (_v_Expect_m_Token2 + _v_Expect_m_Token3) ()));
    if (_v_compose2.symbol_at (0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    if (_v_compose2.symbol_at ((0 + 1)))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _v_deref__compose2 (_v_compose2, 0);
    Expr _v_deref__compose22 (_v_compose2, (0 + 1));
    uintptr_t _v_len3 = _v_deref__compose22.get_len ();
    uintptr_t _v_len4 = 1;
    if (_v_len3 < _v_len4)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    uintptr_t _v_len__name = (_v_len3 - _v_len4);
    uintptr_t _v_len5 = _v_deref__compose2.get_len ();
    uintptr_t _v_len6 = 0;
    if (_v_len5 < _v_len6)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    uintptr_t _v_len__pos = (_v_len5 - _v_len6);
    if (!_v_deref__compose22.symbol_at (0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _ve_pos (_v_deref__compose2, 0, _v_len__pos);
    Expr _vs_WORD_m_or_m_QWORD (_v_deref__compose22, 0, 1);
    Expr _ve_name (_v_deref__compose22, (0 + 1), _v_len__name);
    Expr _vs_linkage;
    Expr _ve_module;
    {
      {
        if (_v_len__pos != 4)
        {
          goto _block3__branch1;
        }
        if (!_ve_pos.symbol_at (0))
        {
          goto _block3__branch1;
        }
        if (!_c_82.term_eq (_ve_pos, (0 + 1)))
        {
          goto _block3__branch1;
        }
        if (!_ve_pos.symbol_at ((0 + 1 + 1)))
        {
          goto _block3__branch1;
        }
        if (!_ve_pos.symbol_at ((0 + 1 + 1 + 1)))
        {
          goto _block3__branch1;
        }
        Expr _vs__e__e_tmp_m_rfp__parserf_m_259_m_12 (_ve_pos, 0, 1);
        Expr _vs__e__e_tmp_m_rfp__parserf_m_259_m_16 (_ve_pos, (0 + 1 + 1), 1);
        Expr _vs__e__e_tmp_m_rfp__parserf_m_259_m_18 (_ve_pos, (0 + 1 + 1 + 1), 1);
        Expr _ge_auxcall1;
        RF_CALL (Module_m_Name, /*void*/, _ge_auxcall1);
        _vs_linkage = _c_74;
        _ve_module = _ge_auxcall1;
        goto _block3;
      }
    _block3__branch1: {}
      uintptr_t _v_len7 = _v_len__pos;
      uintptr_t _v_len8 = 1;
      if (_v_len7 < _v_len8)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      uintptr_t _v_len___e__e_tmp_m_rfp__parserf_m_260_m_18 = (_v_len7 - _v_len8);
      if (!_ve_pos.symbol_at (0))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      Expr _vs_idx (_ve_pos, 0, 1);
      Expr _ve__e__e_tmp_m_rfp__parserf_m_260_m_18 (_ve_pos, (0 + 1), _v_len___e__e_tmp_m_rfp__parserf_m_260_m_18);
      {
        {
          Expr _ge_auxcall2;
          if (!RF_CALL (Table::Lookup, (rfp__src::RFP_m_Sources, _vs_idx), _ge_auxcall2))
          {
            goto _block4__branch1;
          }
          Expr _ge_module__8;
          RF_CALL (rfp__src::RFP_m_Module_m_Name, _ge_auxcall2, _ge_module__8);
          Expr _ge_auxcall3;
          RF_CALL (Module_m_Name, /*void*/, _ge_auxcall3);
          if (!RF_CALL (Compare::_s__eq_, (_ge_module__8, _ge_auxcall3), /*void*/))
          {
            goto _block4__branch1;
          }
          _vs_linkage = _c_83;
          _ve_module = _ge_module__8;
          goto _block4;
        }
      _block4__branch1: {}
        Expr _ge_auxcall4;
        RF_CALL (Module_m_Name, /*void*/, _ge_auxcall4);
        _vs_linkage = _c_75;
        _ve_module = _ge_auxcall4;
      }
    _block4: {}
    }
  _block3: {}
    Expr _ge_name__5 ((_ve_module + _c_84 + _ve_name));
    Expr _ge_auxcall5;
    RF_CALL (Canonical_m_Name, (_vs_WORD_m_or_m_QWORD, _ge_name__5), _ge_auxcall5);
    RF_CALL (Bind_m_Name, (_ge_auxcall5, _ve_pos, (_ge_name__5 () + _vs_type)), /*void*/);
    Expr _ge_auxcall6;
    RF_CALL (Pragma, _ve_pos, _ge_auxcall6);
    Expr _gt_auxcall7;
    RF_CALL (Make_m_Name, _ge_name__5, _gt_auxcall7);
    Expr _v_Parse_m_Object_m_Decls1;
    RF_CALL (Parse_m_Object_m_Decls, _vs_type, _v_Parse_m_Object_m_Decls1);
    _v_res1 = ((_vs_linkage + _vs_type + (_c_78 + _ge_auxcall6) () + _gt_auxcall7) () + _v_Parse_m_Object_m_Decls1);
  }
_block2: {}
RF_END

RF_FUNC (Parse_m_Const_m_Expr, RF_VOID, (RF_RES _v_res1;;))
  Expr _ve_pos;
  Expr _vs_type;
  Expr _ve_value;
  if (!RF_CALL (Expect_m_Token, _c_85, (_ve_pos, _vs_type, _ve_value)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  {
    {
      if (!_vs_type.term_eq (_c_62, 0))
      {
        goto _block1__branch1;
      }
      _v_res1 = empty;
      goto _block1;
    }
  _block1__branch1: {}
    Expr _ge_auxcall1;
    RF_CALL (Parse_m_Const_m_Term, (_ve_pos, _vs_type, _ve_value), _ge_auxcall1);
    Expr _v_Parse_m_Const_m_Expr1;
    RF_CALL (Parse_m_Const_m_Expr, /*void*/, _v_Parse_m_Const_m_Expr1);
    _v_res1 = (_ge_auxcall1 + _v_Parse_m_Const_m_Expr1);
  }
_block1: {}
RF_END

RF_FUNC (Parse_m_Const_m_Term, (RF_ARG _ve_pos, _vs_type, _ve_value;;), (RF_RES _v_res1;;))
  {
    {
      if (!_vs_type.term_eq (_c_20, 0))
      {
        goto _block1__branch1;
      }
      RF_TAILCALL (Parse_m_Ref, /*void*/, _v_res1);
      goto _block1;
    }
  _block1__branch1: {}
    {
      if (!_vs_type.term_eq (_c_86, 0))
      {
        goto _block1__branch2;
      }
      _v_res1 = _ve_value;
      goto _block1;
    }
  _block1__branch2: {}
    {
      if (!_vs_type.term_eq (_c_87, 0))
      {
        goto _block1__branch3;
      }
      _v_res1 = _ve_value;
      goto _block1;
    }
  _block1__branch3: {}
    {
      if (!_vs_type.term_eq (_c_72, 0))
      {
        goto _block1__branch4;
      }
      RF_CALL (Canonical_m_Word, _ve_value, _v_res1);
      goto _block1;
    }
  _block1__branch4: {}
    {
      if (!_vs_type.term_eq (_c_73, 0))
      {
        goto _block1__branch5;
      }
      RF_CALL (Convert::To_m_Word, _ve_value, _v_res1);
      goto _block1;
    }
  _block1__branch5: {}
    if (!_vs_type.term_eq (_c_16, 0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _ve_expr;
    RF_CALL (Parse_m_Const_m_Expr, /*void*/, _ve_expr);
    Expr _v_Expect_m_Token1;
    Expr _v_Expect_m_Token2;
    Expr _v_Expect_m_Token3;
    if (!RF_CALL (Expect_m_Token, _c_18, (_v_Expect_m_Token1, _v_Expect_m_Token2, _v_Expect_m_Token3)))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    uintptr_t _v_len1 = 2;
    uintptr_t _v_len2 = 0;
    if (_v_len1 < _v_len2)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    uintptr_t _v_len___e__e_tmp_m_rfp__parserf_m_293_m_32 = (_v_len1 - _v_len2);
    Expr _v_compose1 ((_v_Expect_m_Token1 () + (_v_Expect_m_Token2 + _v_Expect_m_Token3) ()));
    Expr _ve__e__e_tmp_m_rfp__parserf_m_293_m_32 (_v_compose1, 0, _v_len___e__e_tmp_m_rfp__parserf_m_293_m_32);
    _v_res1 = (_c_88 + _ve_expr) ();
  }
_block1: {}
RF_END

RF_FUNC (Parse_m_Const_m_Decls, RF_VOID, (RF_RES _v_res1;;))
  Expr _ve_pos;
  Expr _vs_type;
  Expr _ve_value;
  if (!RF_CALL (Expect_m_Token, _c_89, (_ve_pos, _vs_type, _ve_value)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  {
    {
      if (!_vs_type.term_eq (_c_6, 0))
      {
        goto _block1__branch1;
      }
      _v_res1 = empty;
      goto _block1;
    }
  _block1__branch1: {}
    {
      if (!_vs_type.term_eq (_c_0, 0))
      {
        goto _block1__branch2;
      }
      RF_TAILCALL (Parse_m_Const_m_Decls, /*void*/, _v_res1);
      goto _block1;
    }
  _block1__branch2: {}
    if (!_vs_type.symbol_at (0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _vs_WORD_m_or_m_QWORD (_vs_type, 0, 1);
    Expr _v_Expect_m_Token1;
    Expr _v_Expect_m_Token2;
    Expr _v_Expect_m_Token3;
    if (!RF_CALL (Expect_m_Token, _c_24, (_v_Expect_m_Token1, _v_Expect_m_Token2, _v_Expect_m_Token3)))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    uintptr_t _v_len1 = 2;
    uintptr_t _v_len2 = 0;
    if (_v_len1 < _v_len2)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    uintptr_t _v_len___e__e_tmp_m_rfp__parserf_m_303_m_35 = (_v_len1 - _v_len2);
    Expr _v_compose1 ((_v_Expect_m_Token1 () + (_v_Expect_m_Token2 + _v_Expect_m_Token3) ()));
    Expr _ve__e__e_tmp_m_rfp__parserf_m_303_m_35 (_v_compose1, 0, _v_len___e__e_tmp_m_rfp__parserf_m_303_m_35);
    Expr _ve_expr;
    RF_CALL (Parse_m_Const_m_Expr, /*void*/, _ve_expr);
    Expr _vs_linkage;
    Expr _ve_module;
    {
      {
        if (_ve_pos.get_len () != 4)
        {
          goto _block2__branch1;
        }
        if (!_ve_pos.symbol_at (0))
        {
          goto _block2__branch1;
        }
        if (!_c_82.term_eq (_ve_pos, (0 + 1)))
        {
          goto _block2__branch1;
        }
        if (!_ve_pos.symbol_at ((0 + 1 + 1)))
        {
          goto _block2__branch1;
        }
        if (!_ve_pos.symbol_at ((0 + 1 + 1 + 1)))
        {
          goto _block2__branch1;
        }
        Expr _vs__e__e_tmp_m_rfp__parserf_m_307_m_18 (_ve_pos, 0, 1);
        Expr _vs__e__e_tmp_m_rfp__parserf_m_307_m_22 (_ve_pos, (0 + 1 + 1), 1);
        Expr _vs__e__e_tmp_m_rfp__parserf_m_307_m_24 (_ve_pos, (0 + 1 + 1 + 1), 1);
        Expr _ge_auxcall1;
        RF_CALL (Module_m_Name, /*void*/, _ge_auxcall1);
        _vs_linkage = _c_74;
        _ve_module = _ge_auxcall1;
        goto _block2;
      }
    _block2__branch1: {}
      uintptr_t _v_len3 = _ve_pos.get_len ();
      uintptr_t _v_len4 = 1;
      if (_v_len3 < _v_len4)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      uintptr_t _v_len___e__e_tmp_m_rfp__parserf_m_308_m_24 = (_v_len3 - _v_len4);
      if (!_ve_pos.symbol_at (0))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      Expr _vs_idx (_ve_pos, 0, 1);
      Expr _ve__e__e_tmp_m_rfp__parserf_m_308_m_24 (_ve_pos, (0 + 1), _v_len___e__e_tmp_m_rfp__parserf_m_308_m_24);
      {
        {
          Expr _ge_auxcall2;
          if (!RF_CALL (Table::Lookup, (rfp__src::RFP_m_Sources, _vs_idx), _ge_auxcall2))
          {
            goto _block3__branch1;
          }
          Expr _ge_module__6;
          RF_CALL (rfp__src::RFP_m_Module_m_Name, _ge_auxcall2, _ge_module__6);
          Expr _ge_auxcall3;
          RF_CALL (Module_m_Name, /*void*/, _ge_auxcall3);
          if (!RF_CALL (Compare::_s__eq_, (_ge_module__6, _ge_auxcall3), /*void*/))
          {
            goto _block3__branch1;
          }
          _vs_linkage = _c_83;
          _ve_module = _ge_module__6;
          goto _block3;
        }
      _block3__branch1: {}
        Expr _ge_auxcall4;
        RF_CALL (Module_m_Name, /*void*/, _ge_auxcall4);
        _vs_linkage = _c_75;
        _ve_module = _ge_auxcall4;
      }
    _block3: {}
    }
  _block2: {}
    Expr _ve_name ((_ve_module + _c_84 + _ve_value));
    Expr _ge_auxcall5;
    RF_CALL (Canonical_m_Name, (_vs_WORD_m_or_m_QWORD, _ve_name), _ge_auxcall5);
    RF_CALL (Bind_m_Name, (_ge_auxcall5, _ve_pos, (_ve_name () + _c_70)), /*void*/);
    Expr _ge_auxcall6;
    RF_CALL (Pragma, _ve_pos, _ge_auxcall6);
    Expr _gt_auxcall7;
    RF_CALL (Make_m_Name, _ve_name, _gt_auxcall7);
    Expr _v_Parse_m_Const_m_Decls1;
    RF_CALL (Parse_m_Const_m_Decls, /*void*/, _v_Parse_m_Const_m_Decls1);
    _v_res1 = ((_vs_linkage + _c_70 + (_c_78 + _ge_auxcall6) () + _gt_auxcall7 + _ve_expr) () + _v_Parse_m_Const_m_Decls1);
  }
_block1: {}
RF_END

RF_FUNC (Lookup_m_Name, (RF_ARG _ve_pos, _ve_name;;), (RF_RES _v_res1;;))
  Expr _v_Domain1;
  RF_CALL (Table::Domain, Names, _v_Domain1);
  Expr _ve_fullname;
  Expr _ve_rest;
  {
    {
      if (_v_Domain1.get_len () < 1)
      {
        goto _block1__branch1;
      }
      RF_lsplit (_v_Domain1, 0, _ve__e__e_tmp_m_rfp__parserf_m_338_m_8, _v_lsplit__Domain1);
      for ( ; ; RF_iter(_v_Domain1)++)
      {
        {
          if (!RF_iter(_v_Domain1))
          {
            goto _block1__branch1;
          }
          uintptr_t _v_len1 = _v_lsplit__Domain1.get_len ();
          uintptr_t _v_len2 = 1;
          if (_v_len1 < _v_len2)
          {
            goto _block1__branch1;
          }
          uintptr_t _v_len__rest__2 = (_v_len1 - _v_len2);
          if (_v_lsplit__Domain1.symbol_at (0))
          {
            goto _continue1;
          }
          Expr _v_deref__lsplit__Domain1 (_v_lsplit__Domain1, 0);
          if (_v_deref__lsplit__Domain1.get_len () != _ve_name.get_len ())
          {
            goto _continue1;
          }
          if (!_ve_name.eq (_v_deref__lsplit__Domain1, 0))
          {
            goto _continue1;
          }
          Expr _ge_rest__2 (_v_lsplit__Domain1, (0 + 1), _v_len__rest__2);
          _ve_fullname = _ve_name;
          _ve_rest = _ge_rest__2;
          goto _exit1;
        }
    _continue1: {}
      }
    _exit1: {}
      goto _block1;
    }
  _block1__branch1: {}
    if (_v_Domain1.get_len () < 1)
    {
      RF_RETFAIL;
    }
    RF_lsplit (_v_Domain1, 0, _ve__e__e_tmp_m_rfp__parserf_m_339_m_8, _v_lsplit__Domain12);
    for ( ; ; RF_iter(_v_Domain1)++)
    {
      {
        if (!RF_iter(_v_Domain1))
        {
          RF_RETFAIL;
        }
        uintptr_t _v_len3 = _v_lsplit__Domain12.get_len ();
        uintptr_t _v_len4 = 1;
        if (_v_len3 < _v_len4)
        {
          RF_RETFAIL;
        }
        uintptr_t _v_len__rest__22 = (_v_len3 - _v_len4);
        if (_v_lsplit__Domain12.symbol_at (0))
        {
          goto _continue2;
        }
        Expr _v_deref__lsplit__Domain12 (_v_lsplit__Domain12, 0);
        uintptr_t _v_len5 = _v_deref__lsplit__Domain12.get_len ();
        uintptr_t _v_len6 = (_ve_name.get_len () + 1);
        if (_v_len5 < _v_len6)
        {
          goto _continue2;
        }
        uintptr_t _v_len__module = (_v_len5 - _v_len6);
        if (!_c_84.term_eq (_v_deref__lsplit__Domain12, (0 + _v_len__module)))
        {
          goto _continue2;
        }
        if (!_ve_name.eq (_v_deref__lsplit__Domain12, (0 + _v_len__module + 1)))
        {
          goto _continue2;
        }
        Expr _ge_rest__2 (_v_lsplit__Domain12, (0 + 1), _v_len__rest__22);
        Expr _ve_module (_v_deref__lsplit__Domain12, 0, _v_len__module);
        _ve_fullname = (_ve_module + _c_84 + _ve_name);
        _ve_rest = _ge_rest__2;
        goto _exit2;
      }
  _continue2: {}
    }
  _exit2: {}
  }
_block1: {}
  RF_CALL (Lookup_m_Check, (_ve_pos, _ve_name, _ve_fullname, _ve_rest), /*void*/);
  _v_res1 = _ve_fullname;
RF_END

RF_FUNC (Lookup_m_Check, (RF_ARG _ve_pos, _ve_name, _ve_fullname, _ve_names;;), RF_VOID)
  {
    {
      Expr _ve_other;
      Expr _ve_rest;
      {
        {
          if (_ve_names.get_len () < 1)
          {
            goto _block2__branch1;
          }
          RF_lsplit (_ve_names, 0, _ve__e__e_tmp_m_rfp__parserf_m_349_m_10, _v_lsplit__names);
          for ( ; ; RF_iter(_ve_names)++)
          {
            {
              if (!RF_iter(_ve_names))
              {
                goto _block2__branch1;
              }
              uintptr_t _v_len1 = _v_lsplit__names.get_len ();
              uintptr_t _v_len2 = 1;
              if (_v_len1 < _v_len2)
              {
                goto _block2__branch1;
              }
              uintptr_t _v_len__rest__4 = (_v_len1 - _v_len2);
              if (_v_lsplit__names.symbol_at (0))
              {
                goto _continue1;
              }
              Expr _v_deref__lsplit__names (_v_lsplit__names, 0);
              if (_v_deref__lsplit__names.get_len () != _ve_name.get_len ())
              {
                goto _continue1;
              }
              if (!_ve_name.eq (_v_deref__lsplit__names, 0))
              {
                goto _continue1;
              }
              Expr _ge_rest__4 (_v_lsplit__names, (0 + 1), _v_len__rest__4);
              _ve_other = _ve_name;
              _ve_rest = _ge_rest__4;
              goto _exit1;
            }
        _continue1: {}
          }
        _exit1: {}
          goto _block2;
        }
      _block2__branch1: {}
        if (_ve_names.get_len () < 1)
        {
          goto _block1__branch1;
        }
        RF_lsplit (_ve_names, 0, _ve__e__e_tmp_m_rfp__parserf_m_350_m_10, _v_lsplit__names2);
        for ( ; ; RF_iter(_ve_names)++)
        {
          {
            if (!RF_iter(_ve_names))
            {
              goto _block1__branch1;
            }
            uintptr_t _v_len3 = _v_lsplit__names2.get_len ();
            uintptr_t _v_len4 = 1;
            if (_v_len3 < _v_len4)
            {
              goto _block1__branch1;
            }
            uintptr_t _v_len__rest__42 = (_v_len3 - _v_len4);
            if (_v_lsplit__names2.symbol_at (0))
            {
              goto _continue2;
            }
            Expr _v_deref__lsplit__names2 (_v_lsplit__names2, 0);
            uintptr_t _v_len5 = _v_deref__lsplit__names2.get_len ();
            uintptr_t _v_len6 = (_ve_name.get_len () + 1);
            if (_v_len5 < _v_len6)
            {
              goto _continue2;
            }
            uintptr_t _v_len__module = (_v_len5 - _v_len6);
            if (!_c_84.term_eq (_v_deref__lsplit__names2, (0 + _v_len__module)))
            {
              goto _continue2;
            }
            if (!_ve_name.eq (_v_deref__lsplit__names2, (0 + _v_len__module + 1)))
            {
              goto _continue2;
            }
            Expr _ge_rest__4 (_v_lsplit__names2, (0 + 1), _v_len__rest__42);
            Expr _ve_module (_v_deref__lsplit__names2, 0, _v_len__module);
            _ve_other = (_ve_module + _c_84 + _ve_name);
            _ve_rest = _ge_rest__4;
            goto _exit2;
          }
      _continue2: {}
        }
      _exit2: {}
      }
    _block2: {}
      RF_CALL (rfp__err::RFP_m_Error, (_ve_pos, (_c_93 + _ve_name + _c_92 + _ve_fullname + _c_91 + _ve_other + _c_90)), /*void*/);
      RF_TAILCALL (Lookup_m_Check, (_ve_pos, _ve_name, _ve_fullname, _ve_rest), /*void*/);
      goto _block1;
    }
  _block1__branch1: {}
  }
_block1: {}
RF_END

RF_FUNC (Bind_m_Name, (RF_ARG _ve_name, _ve_pos, _ve_info;;), RF_VOID)
  {
    {
      Expr _v_Lookup1;
      if (!RF_CALL (Table::Lookup, (Names, _ve_name), _v_Lookup1))
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len1 = _v_Lookup1.get_len ();
      uintptr_t _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len___e__e_tmp_m_rfp__parserf_m_361_m_44 = (_v_len1 - _v_len2);
      if (_v_Lookup1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__Lookup1 (_v_Lookup1, 0);
      uintptr_t _v_len3 = _v_deref__Lookup1.get_len ();
      uintptr_t _v_len4 = 0;
      if (_v_len3 < _v_len4)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__prev_m_pos = (_v_len3 - _v_len4);
      Expr _ve__e__e_tmp_m_rfp__parserf_m_361_m_44 (_v_Lookup1, (0 + 1), _v_len___e__e_tmp_m_rfp__parserf_m_361_m_44);
      Expr _ve_prev_m_pos (_v_deref__Lookup1, 0, _v_len__prev_m_pos);
      RF_CALL (rfp__err::RFP_m_Error, (_ve_pos, (_c_95 + _ve_name + _c_94)), /*void*/);
      RF_CALL (rfp__err::RFP_m_Error, (_ve_prev_m_pos, _c_96), /*void*/);
      goto _block1;
    }
  _block1__branch1: {}
  }
_block1: {}
  RF_TAILCALL (Table::Bind, (Names, _ve_name, (_ve_pos () + _ve_info)), /*void*/);
RF_END

RF_FUNC (Parse_m_Extern_m_Names, RF_VOID, (RF_RES _v_res1;;))
  Expr _v_Expect_m_Token1;
  Expr _v_Expect_m_Token2;
  Expr _v_Expect_m_Token3;
  if (!RF_CALL (Expect_m_Token, _c_80, (_v_Expect_m_Token1, _v_Expect_m_Token2, _v_Expect_m_Token3)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  {
    {
      uintptr_t _v_len1 = 2;
      uintptr_t _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len___e__e_tmp_m_rfp__parserf_m_369_m_6 = (_v_len1 - _v_len2);
      Expr _v_compose1 ((_v_Expect_m_Token1 () + (_v_Expect_m_Token2 + _v_Expect_m_Token3) ()));
      if (!_c_81.term_eq (_v_compose1, (0 + _v_len___e__e_tmp_m_rfp__parserf_m_369_m_6)))
      {
        goto _block1__branch1;
      }
      Expr _ve__e__e_tmp_m_rfp__parserf_m_369_m_6 (_v_compose1, 0, _v_len___e__e_tmp_m_rfp__parserf_m_369_m_6);
      _v_res1 = empty;
      goto _block1;
    }
  _block1__branch1: {}
    Expr _v_compose2 ((_v_Expect_m_Token1 () + (_v_Expect_m_Token2 + _v_Expect_m_Token3) ()));
    if (_v_compose2.symbol_at (0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    if (_v_compose2.symbol_at ((0 + 1)))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _v_deref__compose2 (_v_compose2, 0);
    Expr _v_deref__compose22 (_v_compose2, (0 + 1));
    uintptr_t _v_len3 = _v_deref__compose22.get_len ();
    uintptr_t _v_len4 = 1;
    if (_v_len3 < _v_len4)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    uintptr_t _v_len__value = (_v_len3 - _v_len4);
    uintptr_t _v_len5 = _v_deref__compose2.get_len ();
    uintptr_t _v_len6 = 0;
    if (_v_len5 < _v_len6)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    uintptr_t _v_len__pos = (_v_len5 - _v_len6);
    if (!_v_deref__compose22.symbol_at (0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _ve_pos (_v_deref__compose2, 0, _v_len__pos);
    Expr _vs_type (_v_deref__compose22, 0, 1);
    Expr _ve_value (_v_deref__compose22, (0 + 1), _v_len__value);
    Expr _ge_auxcall1;
    RF_CALL (Canonical_m_Name, (_vs_type, _ve_value), _ge_auxcall1);
    RF_CALL (Bind_m_Name, (_ge_auxcall1, _ve_pos, (_ve_value () + _c_97)), /*void*/);
    Expr _ge_auxcall2;
    RF_CALL (Pragma, _ve_pos, _ge_auxcall2);
    Expr _gt_auxcall3;
    RF_CALL (Make_m_Name, _ve_value, _gt_auxcall3);
    Expr _v_Parse_m_Extern_m_Names1;
    RF_CALL (Parse_m_Extern_m_Names, /*void*/, _v_Parse_m_Extern_m_Names1);
    _v_res1 = ((_c_50 + (_c_78 + _ge_auxcall2) () + _gt_auxcall3) () + _v_Parse_m_Extern_m_Names1);
  }
_block1: {}
RF_END

RF_FUNC (Parse_m_Func_m_Decl, (RF_ARG _vs_type;;), (RF_RES _v_res1;;))
  Expr _ve_pos;
  Expr _vs_WORD_m_or_m_QWORD;
  Expr _ve_name;
  if (!RF_CALL (Expect_m_Token, _c_98, (_ve_pos, _vs_WORD_m_or_m_QWORD, _ve_name)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _vs_linkage;
  Expr _ve_module;
  {
    {
      if (_ve_pos.get_len () != 4)
      {
        goto _block1__branch1;
      }
      if (!_ve_pos.symbol_at (0))
      {
        goto _block1__branch1;
      }
      if (!_c_82.term_eq (_ve_pos, (0 + 1)))
      {
        goto _block1__branch1;
      }
      if (!_ve_pos.symbol_at ((0 + 1 + 1)))
      {
        goto _block1__branch1;
      }
      if (!_ve_pos.symbol_at ((0 + 1 + 1 + 1)))
      {
        goto _block1__branch1;
      }
      Expr _vs__e__e_tmp_m_rfp__parserf_m_382_m_12 (_ve_pos, 0, 1);
      Expr _vs__e__e_tmp_m_rfp__parserf_m_382_m_16 (_ve_pos, (0 + 1 + 1), 1);
      Expr _vs__e__e_tmp_m_rfp__parserf_m_382_m_18 (_ve_pos, (0 + 1 + 1 + 1), 1);
      Expr _ge_auxcall1;
      RF_CALL (Module_m_Name, /*void*/, _ge_auxcall1);
      _vs_linkage = _c_74;
      _ve_module = _ge_auxcall1;
      goto _block1;
    }
  _block1__branch1: {}
    uintptr_t _v_len1 = _ve_pos.get_len ();
    uintptr_t _v_len2 = 1;
    if (_v_len1 < _v_len2)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    uintptr_t _v_len___e__e_tmp_m_rfp__parserf_m_383_m_18 = (_v_len1 - _v_len2);
    if (!_ve_pos.symbol_at (0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _vs_idx (_ve_pos, 0, 1);
    Expr _ve__e__e_tmp_m_rfp__parserf_m_383_m_18 (_ve_pos, (0 + 1), _v_len___e__e_tmp_m_rfp__parserf_m_383_m_18);
    {
      {
        Expr _ge_auxcall2;
        if (!RF_CALL (Table::Lookup, (rfp__src::RFP_m_Sources, _vs_idx), _ge_auxcall2))
        {
          goto _block2__branch1;
        }
        Expr _ge_module__4;
        RF_CALL (rfp__src::RFP_m_Module_m_Name, _ge_auxcall2, _ge_module__4);
        Expr _ge_auxcall3;
        RF_CALL (Module_m_Name, /*void*/, _ge_auxcall3);
        if (!RF_CALL (Compare::_s__eq_, (_ge_module__4, _ge_auxcall3), /*void*/))
        {
          goto _block2__branch1;
        }
        _vs_linkage = _c_83;
        _ve_module = _ge_module__4;
        goto _block2;
      }
    _block2__branch1: {}
      Expr _ge_auxcall4;
      RF_CALL (Module_m_Name, /*void*/, _ge_auxcall4);
      _vs_linkage = _c_75;
      _ve_module = _ge_auxcall4;
    }
  _block2: {}
  }
_block1: {}
  Expr _ge_name__1 ((_ve_module + _c_84 + _ve_name));
  Expr _ve_in;
  RF_CALL (Parse_m_Format, /*void*/, _ve_in);
  Expr _v_Expect_m_Token1;
  Expr _v_Expect_m_Token2;
  Expr _v_Expect_m_Token3;
  if (!RF_CALL (Expect_m_Token, _c_24, (_v_Expect_m_Token1, _v_Expect_m_Token2, _v_Expect_m_Token3)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len3 = 2;
  uintptr_t _v_len4 = 0;
  if (_v_len3 < _v_len4)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len___e__e_tmp_m_rfp__parserf_m_391_m_31 = (_v_len3 - _v_len4);
  Expr _v_compose1 ((_v_Expect_m_Token1 () + (_v_Expect_m_Token2 + _v_Expect_m_Token3) ()));
  Expr _ve__e__e_tmp_m_rfp__parserf_m_391_m_31 (_v_compose1, 0, _v_len___e__e_tmp_m_rfp__parserf_m_391_m_31);
  Expr _ve_out;
  RF_CALL (Parse_m_Format, /*void*/, _ve_out);
  Expr _v_Expect_m_Token4;
  Expr _v_Expect_m_Token5;
  Expr _v_Expect_m_Token6;
  if (!RF_CALL (Expect_m_Token, _c_6, (_v_Expect_m_Token4, _v_Expect_m_Token5, _v_Expect_m_Token6)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len5 = 2;
  uintptr_t _v_len6 = 0;
  if (_v_len5 < _v_len6)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len___e__e_tmp_m_rfp__parserf_m_393_m_35 = (_v_len5 - _v_len6);
  Expr _v_compose2 ((_v_Expect_m_Token4 () + (_v_Expect_m_Token5 + _v_Expect_m_Token6) ()));
  Expr _ve__e__e_tmp_m_rfp__parserf_m_393_m_35 (_v_compose2, 0, _v_len___e__e_tmp_m_rfp__parserf_m_393_m_35);
  Expr _ge_auxcall5;
  RF_CALL (Canonical_m_Name, (_vs_WORD_m_or_m_QWORD, _ge_name__1), _ge_auxcall5);
  RF_CALL (Bind_m_Name, (_ge_auxcall5, _ve_pos, (_ge_name__1 () + _vs_type + _vs_linkage + _ve_in () + _ve_out ())), /*void*/);
  {
    {
      {
        {
          if (!_vs_linkage.term_eq (_c_83, 0))
          {
            goto _block4__branch1;
          }
          goto _block4;
        }
      _block4__branch1: {}
        if (!RF_CALL (Interface_q_, /*void*/, /*void*/))
        {
          goto _block3__branch1;
        }
      }
    _block4: {}
      Expr _ge_auxcall6;
      RF_CALL (Pragma, _ve_pos, _ge_auxcall6);
      Expr _gt_auxcall7;
      RF_CALL (Make_m_Name, _ge_name__1, _gt_auxcall7);
      _v_res1 = (_vs_linkage + _vs_type + (_c_78 + _ge_auxcall6) () + _gt_auxcall7 + _ve_in () + _ve_out ()) ();
      goto _block3;
    }
  _block3__branch1: {}
    _v_res1 = empty;
  }
_block3: {}
RF_END

RF_FUNC (Parse_m_Format, RF_VOID, (RF_RES _v_res1;;))
  Expr _ve_terms;
  RF_CALL (Parse_m_Format_m_Terms, /*void*/, _ve_terms);
  Expr _ve_pos;
  Expr _vs_type;
  Expr _ve_value;
  if (!RF_CALL (Expect_m_Token, _c_99, (_ve_pos, _vs_type, _ve_value)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _ve_var;
  {
    {
      if (!_vs_type.term_eq (_c_62, 0))
      {
        goto _block1__branch1;
      }
      _ve_var = empty;
      goto _block1;
    }
  _block1__branch1: {}
    _ve_var = _vs_type ();
  }
_block1: {}
  Expr _v_Parse_m_Format_m_Terms1;
  RF_CALL (Parse_m_Format_m_Terms, /*void*/, _v_Parse_m_Format_m_Terms1);
  _v_res1 = (_ve_terms + _ve_var + _v_Parse_m_Format_m_Terms1);
RF_END

RF_FUNC (Parse_m_Format_m_Terms, RF_VOID, (RF_RES _v_res1;;))
  Expr _ve_pos;
  Expr _vs_type;
  Expr _ve_value;
  if (!RF_CALL (Expect_m_Token, _c_100, (_ve_pos, _vs_type, _ve_value)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  {
    {
      if (!_vs_type.term_eq (_c_62, 0))
      {
        goto _block1__branch1;
      }
      _v_res1 = empty;
      goto _block1;
    }
  _block1__branch1: {}
    Expr _ve_term;
    {
      {
        if (!_vs_type.term_eq (_c_16, 0))
        {
          goto _block2__branch1;
        }
        Expr _ge_auxcall1;
        RF_CALL (Parse_m_Format, /*void*/, _ge_auxcall1);
        Expr _ve_hexpr ((_c_88 + _ge_auxcall1) ());
        Expr _v_Expect_m_Token1;
        Expr _v_Expect_m_Token2;
        Expr _v_Expect_m_Token3;
        if (!RF_CALL (Expect_m_Token, _c_18, (_v_Expect_m_Token1, _v_Expect_m_Token2, _v_Expect_m_Token3)))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        uintptr_t _v_len1 = 2;
        uintptr_t _v_len2 = 0;
        if (_v_len1 < _v_len2)
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        uintptr_t _v_len___e__e_tmp_m_rfp__parserf_m_421_m_36 = (_v_len1 - _v_len2);
        Expr _v_compose1 ((_v_Expect_m_Token1 () + (_v_Expect_m_Token2 + _v_Expect_m_Token3) ()));
        Expr _ve__e__e_tmp_m_rfp__parserf_m_421_m_36 (_v_compose1, 0, _v_len___e__e_tmp_m_rfp__parserf_m_421_m_36);
        _ve_term = _ve_hexpr;
        goto _block2;
      }
    _block2__branch1: {}
      {
        if (!_vs_type.term_eq (_c_86, 0))
        {
          goto _block2__branch2;
        }
        _ve_term = _ve_value;
        goto _block2;
      }
    _block2__branch2: {}
      {
        if (!_vs_type.term_eq (_c_87, 0))
        {
          goto _block2__branch3;
        }
        _ve_term = _ve_value;
        goto _block2;
      }
    _block2__branch3: {}
      {
        if (!_vs_type.term_eq (_c_72, 0))
        {
          goto _block2__branch4;
        }
        RF_CALL (Canonical_m_Word, _ve_value, _ve_term);
        goto _block2;
      }
    _block2__branch4: {}
      {
        if (!_vs_type.term_eq (_c_73, 0))
        {
          goto _block2__branch5;
        }
        RF_CALL (Convert::To_m_Word, _ve_value, _ve_term);
        goto _block2;
      }
    _block2__branch5: {}
      {
        if (!_vs_type.term_eq (_c_20, 0))
        {
          goto _block2__branch6;
        }
        RF_CALL (Parse_m_Ref, /*void*/, _ve_term);
        goto _block2;
      }
    _block2__branch6: {}
      if (!_vs_type.symbol_at (0))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      Expr _vs__e__e_tmp_m_rfp__parserf_m_427_m_10 (_vs_type, 0, 1);
      _ve_term = _vs_type ();
    }
  _block2: {}
    Expr _v_Parse_m_Format_m_Terms1;
    RF_CALL (Parse_m_Format_m_Terms, /*void*/, _v_Parse_m_Format_m_Terms1);
    _v_res1 = (_ve_term + _v_Parse_m_Format_m_Terms1);
  }
_block1: {}
RF_END

RF_FUNC (Parse_m_Hard_m_Expr, RF_VOID, (RF_RES _v_res1;;))
  Expr _ve_terms;
  RF_CALL (Parse_m_Hard_m_Expr_m_Terms, /*void*/, _ve_terms);
  Expr _ve_pos;
  Expr _vs_type;
  Expr _ve_value;
  if (!RF_CALL (Expect_m_Token, _c_99, (_ve_pos, _vs_type, _ve_value)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _ve_var;
  {
    {
      if (!_vs_type.term_eq (_c_62, 0))
      {
        goto _block1__branch1;
      }
      _ve_var = empty;
      goto _block1;
    }
  _block1__branch1: {}
    Expr _ge_auxcall1;
    RF_CALL (Pragma, _ve_pos, _ge_auxcall1);
    Expr _gt_auxcall2;
    RF_CALL (Make_m_Name, _ve_value, _gt_auxcall2);
    _ve_var = (_vs_type + (_c_78 + _ge_auxcall1) () + _gt_auxcall2) ();
  }
_block1: {}
  Expr _v_Parse_m_Hard_m_Expr_m_Terms1;
  RF_CALL (Parse_m_Hard_m_Expr_m_Terms, /*void*/, _v_Parse_m_Hard_m_Expr_m_Terms1);
  _v_res1 = (_ve_terms + _ve_var + _v_Parse_m_Hard_m_Expr_m_Terms1);
RF_END

RF_FUNC (Parse_m_Hard_m_Expr_m_Terms, RF_VOID, (RF_RES _v_res1;;))
  Expr _ve_pos;
  Expr _vs_type;
  Expr _ve_value;
  if (!RF_CALL (Expect_m_Token, _c_100, (_ve_pos, _vs_type, _ve_value)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  {
    {
      if (!_vs_type.term_eq (_c_62, 0))
      {
        goto _block1__branch1;
      }
      _v_res1 = empty;
      goto _block1;
    }
  _block1__branch1: {}
    Expr _ve_term;
    {
      {
        if (!_vs_type.term_eq (_c_16, 0))
        {
          goto _block2__branch1;
        }
        Expr _ge_auxcall1;
        RF_CALL (Parse_m_Hard_m_Expr, /*void*/, _ge_auxcall1);
        Expr _ve_hexpr ((_c_88 + _ge_auxcall1) ());
        Expr _v_Expect_m_Token1;
        Expr _v_Expect_m_Token2;
        Expr _v_Expect_m_Token3;
        if (!RF_CALL (Expect_m_Token, _c_18, (_v_Expect_m_Token1, _v_Expect_m_Token2, _v_Expect_m_Token3)))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        uintptr_t _v_len1 = 2;
        uintptr_t _v_len2 = 0;
        if (_v_len1 < _v_len2)
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        uintptr_t _v_len___e__e_tmp_m_rfp__parserf_m_451_m_36 = (_v_len1 - _v_len2);
        Expr _v_compose1 ((_v_Expect_m_Token1 () + (_v_Expect_m_Token2 + _v_Expect_m_Token3) ()));
        Expr _ve__e__e_tmp_m_rfp__parserf_m_451_m_36 (_v_compose1, 0, _v_len___e__e_tmp_m_rfp__parserf_m_451_m_36);
        _ve_term = _ve_hexpr;
        goto _block2;
      }
    _block2__branch1: {}
      {
        if (!_vs_type.term_eq (_c_86, 0))
        {
          goto _block2__branch2;
        }
        _ve_term = _ve_value;
        goto _block2;
      }
    _block2__branch2: {}
      {
        if (!_vs_type.term_eq (_c_87, 0))
        {
          goto _block2__branch3;
        }
        _ve_term = _ve_value;
        goto _block2;
      }
    _block2__branch3: {}
      {
        if (!_vs_type.term_eq (_c_72, 0))
        {
          goto _block2__branch4;
        }
        RF_CALL (Canonical_m_Word, _ve_value, _ve_term);
        goto _block2;
      }
    _block2__branch4: {}
      {
        if (!_vs_type.term_eq (_c_73, 0))
        {
          goto _block2__branch5;
        }
        RF_CALL (Convert::To_m_Word, _ve_value, _ve_term);
        goto _block2;
      }
    _block2__branch5: {}
      {
        if (!_vs_type.term_eq (_c_20, 0))
        {
          goto _block2__branch6;
        }
        RF_CALL (Parse_m_Ref, /*void*/, _ve_term);
        goto _block2;
      }
    _block2__branch6: {}
      if (!_vs_type.symbol_at (0))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      Expr _vs__e__e_tmp_m_rfp__parserf_m_457_m_10 (_vs_type, 0, 1);
      Expr _ge_auxcall2;
      RF_CALL (Pragma, _ve_pos, _ge_auxcall2);
      Expr _gt_auxcall3;
      RF_CALL (Make_m_Name, _ve_value, _gt_auxcall3);
      _ve_term = (_vs_type + (_c_78 + _ge_auxcall2) () + _gt_auxcall3) ();
    }
  _block2: {}
    Expr _v_Parse_m_Hard_m_Expr_m_Terms1;
    RF_CALL (Parse_m_Hard_m_Expr_m_Terms, /*void*/, _v_Parse_m_Hard_m_Expr_m_Terms1);
    _v_res1 = (_ve_term + _v_Parse_m_Hard_m_Expr_m_Terms1);
  }
_block1: {}
RF_END

RF_FUNC (Parse_m_Trace_m_Names, RF_VOID, (RF_RES _v_res1;;))
  Expr _v_Expect_m_Token1;
  Expr _v_Expect_m_Token2;
  Expr _v_Expect_m_Token3;
  if (!RF_CALL (Expect_m_Token, _c_80, (_v_Expect_m_Token1, _v_Expect_m_Token2, _v_Expect_m_Token3)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  {
    {
      uintptr_t _v_len1 = 2;
      uintptr_t _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len___e__e_tmp_m_rfp__parserf_m_463_m_6 = (_v_len1 - _v_len2);
      Expr _v_compose1 ((_v_Expect_m_Token1 () + (_v_Expect_m_Token2 + _v_Expect_m_Token3) ()));
      if (!_c_81.term_eq (_v_compose1, (0 + _v_len___e__e_tmp_m_rfp__parserf_m_463_m_6)))
      {
        goto _block1__branch1;
      }
      Expr _ve__e__e_tmp_m_rfp__parserf_m_463_m_6 (_v_compose1, 0, _v_len___e__e_tmp_m_rfp__parserf_m_463_m_6);
      _v_res1 = empty;
      goto _block1;
    }
  _block1__branch1: {}
    Expr _v_compose2 ((_v_Expect_m_Token1 () + (_v_Expect_m_Token2 + _v_Expect_m_Token3) ()));
    if (_v_compose2.symbol_at (0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    if (_v_compose2.symbol_at ((0 + 1)))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _v_deref__compose2 (_v_compose2, 0);
    Expr _v_deref__compose22 (_v_compose2, (0 + 1));
    uintptr_t _v_len3 = _v_deref__compose22.get_len ();
    uintptr_t _v_len4 = 1;
    if (_v_len3 < _v_len4)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    uintptr_t _v_len__value = (_v_len3 - _v_len4);
    uintptr_t _v_len5 = _v_deref__compose2.get_len ();
    uintptr_t _v_len6 = 0;
    if (_v_len5 < _v_len6)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    uintptr_t _v_len__pos = (_v_len5 - _v_len6);
    if (!_v_deref__compose22.symbol_at (0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _ve_pos (_v_deref__compose2, 0, _v_len__pos);
    Expr _vs_type (_v_deref__compose22, 0, 1);
    Expr _ve_value (_v_deref__compose22, (0 + 1), _v_len__value);
    Expr _ve_uniname;
    RF_CALL (Canonical_m_Name, (_vs_type, _ve_value), _ve_uniname);
    Expr _ve_name;
    {
      {
        Expr _ge_name__4;
        if (!RF_CALL (Lookup_m_Name, (_ve_pos, _ve_uniname), _ge_name__4))
        {
          goto _block2__branch1;
        }
        Expr _v_Lookup1;
        if (!RF_CALL (Table::Lookup, (Names, _ge_name__4), _v_Lookup1))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        {
          {
            uintptr_t _v_len7 = _v_Lookup1.get_len ();
            uintptr_t _v_len8 = 3;
            if (_v_len7 < _v_len8)
            {
              goto _block3__branch1;
            }
            uintptr_t _v_len___e__e_tmp_m_rfp__parserf_m_469_m_47 = (_v_len7 - _v_len8);
            if (_v_Lookup1.symbol_at (0))
            {
              goto _block3__branch1;
            }
            if (_v_Lookup1.symbol_at ((0 + 1)))
            {
              goto _block3__branch1;
            }
            Expr _v_deref__Lookup1 (_v_Lookup1, 0);
            Expr _v_deref__Lookup12 (_v_Lookup1, (0 + 1));
            uintptr_t _v_len9 = _v_deref__Lookup12.get_len ();
            uintptr_t _v_len10 = 0;
            if (_v_len9 < _v_len10)
            {
              goto _block3__branch1;
            }
            uintptr_t _v_len__origname = (_v_len9 - _v_len10);
            uintptr_t _v_len11 = _v_deref__Lookup1.get_len ();
            uintptr_t _v_len12 = 0;
            if (_v_len11 < _v_len12)
            {
              goto _block3__branch1;
            }
            uintptr_t _v_len__pragma_m_pos = (_v_len11 - _v_len12);
            if (!_c_44.term_eq (_v_Lookup1, (0 + 1 + 1)))
            {
              goto _block3__branch1;
            }
            Expr _ve__e__e_tmp_m_rfp__parserf_m_469_m_47 (_v_Lookup1, (0 + 1 + 1 + 1), _v_len___e__e_tmp_m_rfp__parserf_m_469_m_47);
            Expr _ve_pragma_m_pos (_v_deref__Lookup1, 0, _v_len__pragma_m_pos);
            Expr _ve_origname (_v_deref__Lookup12, 0, _v_len__origname);
            _ve_name = _ve_origname;
            goto _block3;
          }
        _block3__branch1: {}
          {
            uintptr_t _v_len13 = _v_Lookup1.get_len ();
            uintptr_t _v_len14 = 3;
            if (_v_len13 < _v_len14)
            {
              goto _block3__branch2;
            }
            uintptr_t _v_len___e__e_tmp_m_rfp__parserf_m_470_m_48 = (_v_len13 - _v_len14);
            if (_v_Lookup1.symbol_at (0))
            {
              goto _block3__branch2;
            }
            if (_v_Lookup1.symbol_at ((0 + 1)))
            {
              goto _block3__branch2;
            }
            Expr _v_deref__Lookup13 (_v_Lookup1, 0);
            Expr _v_deref__Lookup14 (_v_Lookup1, (0 + 1));
            uintptr_t _v_len15 = _v_deref__Lookup14.get_len ();
            uintptr_t _v_len16 = 0;
            if (_v_len15 < _v_len16)
            {
              goto _block3__branch2;
            }
            uintptr_t _v_len__origname2 = (_v_len15 - _v_len16);
            uintptr_t _v_len17 = _v_deref__Lookup13.get_len ();
            uintptr_t _v_len18 = 0;
            if (_v_len17 < _v_len18)
            {
              goto _block3__branch2;
            }
            uintptr_t _v_len__pragma_m_pos2 = (_v_len17 - _v_len18);
            if (!_c_46.term_eq (_v_Lookup1, (0 + 1 + 1)))
            {
              goto _block3__branch2;
            }
            Expr _ve__e__e_tmp_m_rfp__parserf_m_470_m_48 (_v_Lookup1, (0 + 1 + 1 + 1), _v_len___e__e_tmp_m_rfp__parserf_m_470_m_48);
            Expr _ve_pragma_m_pos (_v_deref__Lookup13, 0, _v_len__pragma_m_pos2);
            Expr _ve_origname (_v_deref__Lookup14, 0, _v_len__origname2);
            _ve_name = _ve_origname;
            goto _block3;
          }
        _block3__branch2: {}
          {
            uintptr_t _v_len19 = _v_Lookup1.get_len ();
            uintptr_t _v_len20 = 3;
            if (_v_len19 < _v_len20)
            {
              goto _block3__branch3;
            }
            uintptr_t _v_len___e__e_tmp_m_rfp__parserf_m_471_m_48 = (_v_len19 - _v_len20);
            if (_v_Lookup1.symbol_at (0))
            {
              goto _block3__branch3;
            }
            if (_v_Lookup1.symbol_at ((0 + 1)))
            {
              goto _block3__branch3;
            }
            Expr _v_deref__Lookup15 (_v_Lookup1, 0);
            Expr _v_deref__Lookup16 (_v_Lookup1, (0 + 1));
            uintptr_t _v_len21 = _v_deref__Lookup16.get_len ();
            uintptr_t _v_len22 = 0;
            if (_v_len21 < _v_len22)
            {
              goto _block3__branch3;
            }
            uintptr_t _v_len__origname3 = (_v_len21 - _v_len22);
            uintptr_t _v_len23 = _v_deref__Lookup15.get_len ();
            uintptr_t _v_len24 = 0;
            if (_v_len23 < _v_len24)
            {
              goto _block3__branch3;
            }
            uintptr_t _v_len__pragma_m_pos3 = (_v_len23 - _v_len24);
            if (!_c_48.term_eq (_v_Lookup1, (0 + 1 + 1)))
            {
              goto _block3__branch3;
            }
            Expr _ve__e__e_tmp_m_rfp__parserf_m_471_m_48 (_v_Lookup1, (0 + 1 + 1 + 1), _v_len___e__e_tmp_m_rfp__parserf_m_471_m_48);
            Expr _ve_pragma_m_pos (_v_deref__Lookup15, 0, _v_len__pragma_m_pos3);
            Expr _ve_origname (_v_deref__Lookup16, 0, _v_len__origname3);
            _ve_name = _ve_origname;
            goto _block3;
          }
        _block3__branch3: {}
          uintptr_t _v_len25 = _v_Lookup1.get_len ();
          uintptr_t _v_len26 = 3;
          if (_v_len25 < _v_len26)
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          uintptr_t _v_len___e__e_tmp_m_rfp__parserf_m_472_m_49 = (_v_len25 - _v_len26);
          if (_v_Lookup1.symbol_at (0))
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          if (_v_Lookup1.symbol_at ((0 + 1)))
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          Expr _v_deref__Lookup17 (_v_Lookup1, 0);
          Expr _v_deref__Lookup18 (_v_Lookup1, (0 + 1));
          uintptr_t _v_len27 = _v_deref__Lookup18.get_len ();
          uintptr_t _v_len28 = 0;
          if (_v_len27 < _v_len28)
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          uintptr_t _v_len__origname4 = (_v_len27 - _v_len28);
          uintptr_t _v_len29 = _v_deref__Lookup17.get_len ();
          uintptr_t _v_len30 = 0;
          if (_v_len29 < _v_len30)
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          uintptr_t _v_len__pragma_m_pos4 = (_v_len29 - _v_len30);
          if (!_v_Lookup1.symbol_at ((0 + 1 + 1)))
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          Expr _vs_decl (_v_Lookup1, (0 + 1 + 1), 1);
          Expr _ve__e__e_tmp_m_rfp__parserf_m_472_m_49 (_v_Lookup1, (0 + 1 + 1 + 1), _v_len___e__e_tmp_m_rfp__parserf_m_472_m_49);
          Expr _ve_pragma_m_pos (_v_deref__Lookup17, 0, _v_len__pragma_m_pos4);
          Expr _ve_origname (_v_deref__Lookup18, 0, _v_len__origname4);
          RF_CALL (rfp__err::RFP_m_Error, (_ve_pos, (_c_76 + _ge_name__4 + _c_101)), /*void*/);
          RF_CALL (rfp__err::RFP_m_Error, (_ve_pragma_m_pos, (_c_103 + _ge_name__4 + _c_102 + _vs_decl)), /*void*/);
          _ve_name = empty;
        }
      _block3: {}
        goto _block2;
      }
    _block2__branch1: {}
      {
        {
          {
            if (_v_len__value != 4)
            {
              goto _block4__branch1;
            }
            if (!_c_104.eq (_ve_value, 0))
            {
              goto _block4__branch1;
            }
            goto _block4;
          }
        _block4__branch1: {}
          if (!RF_CALL (Table::In_m_Table_q_, (rfp__helper::RFP_m_Options, _c_105), /*void*/))
          {
            goto _block2__branch2;
          }
          Expr _v_To_m_Upper1;
          RF_CALL (Convert::To_m_Upper, _ve_value, _v_To_m_Upper1);
          if (_v_To_m_Upper1.get_len () != 4)
          {
            goto _block2__branch2;
          }
          if (!_c_106.eq (_v_To_m_Upper1, 0))
          {
            goto _block2__branch2;
          }
        }
      _block4: {}
        Expr _ge_auxcall1;
        RF_CALL (Module_m_Name, /*void*/, _ge_auxcall1);
        _ve_name = (_ge_auxcall1 + _c_84 + _ve_value);
        goto _block2;
      }
    _block2__branch2: {}
      RF_CALL (rfp__err::RFP_m_Error, (_ve_pos, (_c_107 + _ve_value + _c_76)), /*void*/);
      _ve_name = empty;
    }
  _block2: {}
    {
      {
        uintptr_t _v_len31 = _ve_name.get_len ();
        uintptr_t _v_len32 = 0;
        if (_v_len31 < (_v_len32 + 1))
        {
          goto _block5__branch1;
        }
        uintptr_t _v_len___e__e_tmp_m_rfp__parserf_m_485_m_19 = (_v_len31 - _v_len32);
        Expr _vv__e__e_tmp_m_rfp__parserf_m_485_m_19 (_ve_name, 0, _v_len___e__e_tmp_m_rfp__parserf_m_485_m_19);
        Expr _gt_auxcall2;
        RF_CALL (Make_m_Name, _ve_name, _gt_auxcall2);
        Expr _v_Parse_m_Trace_m_Names1;
        RF_CALL (Parse_m_Trace_m_Names, /*void*/, _v_Parse_m_Trace_m_Names1);
        _v_res1 = ((_c_56 + _gt_auxcall2) () + _v_Parse_m_Trace_m_Names1);
        goto _block5;
      }
    _block5__branch1: {}
      RF_TAILCALL (Parse_m_Trace_m_Names, /*void*/, _v_res1);
    }
  _block5: {}
  }
_block1: {}
RF_END

RF_FUNC (Parse_m_Func_m_Def, (RF_ARG _ve_pos, _vs_type, _ve_value;;), (RF_RES _v_res1;;))
  Expr _ve_items;
  RF_CALL (Parse_m_Alt, empty, _ve_items);
  Expr _v_Expect_m_Token1;
  Expr _v_Expect_m_Token2;
  Expr _v_Expect_m_Token3;
  if (!RF_CALL (Expect_m_Token, _c_6, (_v_Expect_m_Token1, _v_Expect_m_Token2, _v_Expect_m_Token3)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len1 = 2;
  uintptr_t _v_len2 = 0;
  if (_v_len1 < _v_len2)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len___e__e_tmp_m_rfp__parserf_m_494_m_33 = (_v_len1 - _v_len2);
  Expr _v_compose1 ((_v_Expect_m_Token1 () + (_v_Expect_m_Token2 + _v_Expect_m_Token3) ()));
  Expr _ve__e__e_tmp_m_rfp__parserf_m_494_m_33 (_v_compose1, 0, _v_len___e__e_tmp_m_rfp__parserf_m_494_m_33);
  Expr _ve_uniname;
  RF_CALL (Canonical_m_Name, (_vs_type, _ve_value), _ve_uniname);
  Expr _ve_name;
  Expr _vs_tag;
  Expr _vs_linkage;
  Expr _vt_in;
  Expr _vt_out;
  Expr _vt_pragma;
  {
    {
      Expr _ge_name__2;
      if (!RF_CALL (Lookup_m_Name, (_ve_pos, _ve_uniname), _ge_name__2))
      {
        goto _block1__branch1;
      }
      Expr _ve_nameinfo;
      if (!RF_CALL (Table::Lookup, (Names, _ge_name__2), _ve_nameinfo))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      {
        {
          Expr _v_R1;
          if (!RF_CALL (Access::R, (_c_108, _ve_nameinfo), _v_R1))
          {
            goto _block2__branch1;
          }
          if (_v_R1.symbol_at (0))
          {
            goto _block2__branch1;
          }
          Expr _v_deref__R1 (_v_R1, 0);
          uintptr_t _v_len3 = _v_deref__R1.get_len ();
          uintptr_t _v_len4 = 1;
          if (_v_len3 < _v_len4)
          {
            goto _block2__branch1;
          }
          uintptr_t _v_len__def_m_pos = (_v_len3 - _v_len4);
          if (!_c_109.term_eq (_v_deref__R1, 0))
          {
            goto _block2__branch1;
          }
          Expr _ve_def_m_pos (_v_deref__R1, (0 + 1), _v_len__def_m_pos);
          RF_CALL (rfp__err::RFP_m_Error, (_ve_pos, (_c_110 + _ge_name__2 + _c_94)), /*void*/);
          RF_CALL (rfp__err::RFP_m_Error, (_ve_def_m_pos, _c_111), /*void*/);
          goto _block2;
        }
      _block2__branch1: {}
      }
    _block2: {}
      {
        {
          uintptr_t _v_len5 = _ve_nameinfo.get_len ();
          uintptr_t _v_len6 = 6;
          if (_v_len5 < _v_len6)
          {
            goto _block3__branch1;
          }
          uintptr_t _v_len___e__e_tmp_m_rfp__parserf_m_508_m_68 = (_v_len5 - _v_len6);
          if (_ve_nameinfo.symbol_at (0))
          {
            goto _block3__branch1;
          }
          if (_ve_nameinfo.symbol_at ((0 + 1)))
          {
            goto _block3__branch1;
          }
          Expr _v_deref__nameinfo (_ve_nameinfo, 0);
          Expr _v_deref__nameinfo2 (_ve_nameinfo, (0 + 1));
          uintptr_t _v_len7 = _v_deref__nameinfo2.get_len ();
          uintptr_t _v_len8 = 0;
          if (_v_len7 < _v_len8)
          {
            goto _block3__branch1;
          }
          uintptr_t _v_len__origname = (_v_len7 - _v_len8);
          uintptr_t _v_len9 = _v_deref__nameinfo.get_len ();
          uintptr_t _v_len10 = 0;
          if (_v_len9 < _v_len10)
          {
            goto _block3__branch1;
          }
          uintptr_t _v_len__pragma_m_pos = (_v_len9 - _v_len10);
          if (!_c_44.term_eq (_ve_nameinfo, (0 + 1 + 1)))
          {
            goto _block3__branch1;
          }
          if (!_ve_nameinfo.symbol_at ((0 + 1 + 1 + 1)))
          {
            goto _block3__branch1;
          }
          Expr _gs_linkage__4 (_ve_nameinfo, (0 + 1 + 1 + 1), 1);
          Expr _gt_in__4 (_ve_nameinfo, (0 + 1 + 1 + 1 + 1), 1);
          Expr _gt_out__4 (_ve_nameinfo, (0 + 1 + 1 + 1 + 1 + 1), 1);
          Expr _ve__e__e_tmp_m_rfp__parserf_m_508_m_68 (_ve_nameinfo, (0 + 1 + 1 + 1 + 1 + 1 + 1), _v_len___e__e_tmp_m_rfp__parserf_m_508_m_68);
          Expr _ve_pragma_m_pos (_v_deref__nameinfo, 0, _v_len__pragma_m_pos);
          Expr _ve_origname (_v_deref__nameinfo2, 0, _v_len__origname);
          RF_CALL (Table::Bind, (Names, _ge_name__2, (_ve_pragma_m_pos () + _ve_origname () + _c_44 + _gs_linkage__4 + _gt_in__4 + _gt_out__4 + (_c_109 + _ve_pos) ())), /*void*/);
          Expr _v_Pragma1;
          RF_CALL (Pragma, _ve_pragma_m_pos, _v_Pragma1);
          _ve_name = _ve_origname;
          _vs_tag = _c_44;
          _vs_linkage = _gs_linkage__4;
          _vt_in = _gt_in__4;
          _vt_out = _gt_out__4;
          _vt_pragma = (_c_78 + _v_Pragma1) ();
          goto _block3;
        }
      _block3__branch1: {}
        {
          uintptr_t _v_len11 = _ve_nameinfo.get_len ();
          uintptr_t _v_len12 = 6;
          if (_v_len11 < _v_len12)
          {
            goto _block3__branch2;
          }
          uintptr_t _v_len___e__e_tmp_m_rfp__parserf_m_513_m_69 = (_v_len11 - _v_len12);
          if (_ve_nameinfo.symbol_at (0))
          {
            goto _block3__branch2;
          }
          if (_ve_nameinfo.symbol_at ((0 + 1)))
          {
            goto _block3__branch2;
          }
          Expr _v_deref__nameinfo3 (_ve_nameinfo, 0);
          Expr _v_deref__nameinfo4 (_ve_nameinfo, (0 + 1));
          uintptr_t _v_len13 = _v_deref__nameinfo4.get_len ();
          uintptr_t _v_len14 = 0;
          if (_v_len13 < _v_len14)
          {
            goto _block3__branch2;
          }
          uintptr_t _v_len__origname2 = (_v_len13 - _v_len14);
          uintptr_t _v_len15 = _v_deref__nameinfo3.get_len ();
          uintptr_t _v_len16 = 0;
          if (_v_len15 < _v_len16)
          {
            goto _block3__branch2;
          }
          uintptr_t _v_len__pragma_m_pos2 = (_v_len15 - _v_len16);
          if (!_c_46.term_eq (_ve_nameinfo, (0 + 1 + 1)))
          {
            goto _block3__branch2;
          }
          if (!_ve_nameinfo.symbol_at ((0 + 1 + 1 + 1)))
          {
            goto _block3__branch2;
          }
          Expr _gs_linkage__4 (_ve_nameinfo, (0 + 1 + 1 + 1), 1);
          Expr _gt_in__4 (_ve_nameinfo, (0 + 1 + 1 + 1 + 1), 1);
          Expr _gt_out__4 (_ve_nameinfo, (0 + 1 + 1 + 1 + 1 + 1), 1);
          Expr _ve__e__e_tmp_m_rfp__parserf_m_513_m_69 (_ve_nameinfo, (0 + 1 + 1 + 1 + 1 + 1 + 1), _v_len___e__e_tmp_m_rfp__parserf_m_513_m_69);
          Expr _ve_pragma_m_pos (_v_deref__nameinfo3, 0, _v_len__pragma_m_pos2);
          Expr _ve_origname (_v_deref__nameinfo4, 0, _v_len__origname2);
          RF_CALL (Table::Bind, (Names, _ge_name__2, (_ve_pragma_m_pos () + _ve_origname () + _c_46 + _gs_linkage__4 + _gt_in__4 + _gt_out__4 + (_c_109 + _ve_pos) ())), /*void*/);
          Expr _v_Pragma2;
          RF_CALL (Pragma, _ve_pragma_m_pos, _v_Pragma2);
          _ve_name = _ve_origname;
          _vs_tag = _c_46;
          _vs_linkage = _gs_linkage__4;
          _vt_in = _gt_in__4;
          _vt_out = _gt_out__4;
          _vt_pragma = (_c_78 + _v_Pragma2) ();
          goto _block3;
        }
      _block3__branch2: {}
        {
          uintptr_t _v_len17 = _ve_nameinfo.get_len ();
          uintptr_t _v_len18 = 6;
          if (_v_len17 < _v_len18)
          {
            goto _block3__branch3;
          }
          uintptr_t _v_len___e__e_tmp_m_rfp__parserf_m_518_m_69 = (_v_len17 - _v_len18);
          if (_ve_nameinfo.symbol_at (0))
          {
            goto _block3__branch3;
          }
          if (_ve_nameinfo.symbol_at ((0 + 1)))
          {
            goto _block3__branch3;
          }
          Expr _v_deref__nameinfo5 (_ve_nameinfo, 0);
          Expr _v_deref__nameinfo6 (_ve_nameinfo, (0 + 1));
          uintptr_t _v_len19 = _v_deref__nameinfo6.get_len ();
          uintptr_t _v_len20 = 0;
          if (_v_len19 < _v_len20)
          {
            goto _block3__branch3;
          }
          uintptr_t _v_len__origname3 = (_v_len19 - _v_len20);
          uintptr_t _v_len21 = _v_deref__nameinfo5.get_len ();
          uintptr_t _v_len22 = 0;
          if (_v_len21 < _v_len22)
          {
            goto _block3__branch3;
          }
          uintptr_t _v_len__pragma_m_pos3 = (_v_len21 - _v_len22);
          if (!_c_48.term_eq (_ve_nameinfo, (0 + 1 + 1)))
          {
            goto _block3__branch3;
          }
          if (!_ve_nameinfo.symbol_at ((0 + 1 + 1 + 1)))
          {
            goto _block3__branch3;
          }
          Expr _gs_linkage__4 (_ve_nameinfo, (0 + 1 + 1 + 1), 1);
          Expr _gt_in__4 (_ve_nameinfo, (0 + 1 + 1 + 1 + 1), 1);
          Expr _gt_out__4 (_ve_nameinfo, (0 + 1 + 1 + 1 + 1 + 1), 1);
          Expr _ve__e__e_tmp_m_rfp__parserf_m_518_m_69 (_ve_nameinfo, (0 + 1 + 1 + 1 + 1 + 1 + 1), _v_len___e__e_tmp_m_rfp__parserf_m_518_m_69);
          Expr _ve_pragma_m_pos (_v_deref__nameinfo5, 0, _v_len__pragma_m_pos3);
          Expr _ve_origname (_v_deref__nameinfo6, 0, _v_len__origname3);
          RF_CALL (Table::Bind, (Names, _ge_name__2, (_ve_pragma_m_pos () + _ve_origname () + _c_48 + _gs_linkage__4 + _gt_in__4 + _gt_out__4 + (_c_109 + _ve_pos) ())), /*void*/);
          Expr _v_Pragma3;
          RF_CALL (Pragma, _ve_pragma_m_pos, _v_Pragma3);
          _ve_name = _ve_origname;
          _vs_tag = _c_48;
          _vs_linkage = _gs_linkage__4;
          _vt_in = _gt_in__4;
          _vt_out = _gt_out__4;
          _vt_pragma = (_c_78 + _v_Pragma3) ();
          goto _block3;
        }
      _block3__branch3: {}
        uintptr_t _v_len23 = _ve_nameinfo.get_len ();
        uintptr_t _v_len24 = 3;
        if (_v_len23 < _v_len24)
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        uintptr_t _v_len___e__e_tmp_m_rfp__parserf_m_523_m_49 = (_v_len23 - _v_len24);
        if (_ve_nameinfo.symbol_at (0))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        if (_ve_nameinfo.symbol_at ((0 + 1)))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        Expr _v_deref__nameinfo7 (_ve_nameinfo, 0);
        Expr _v_deref__nameinfo8 (_ve_nameinfo, (0 + 1));
        uintptr_t _v_len25 = _v_deref__nameinfo8.get_len ();
        uintptr_t _v_len26 = 0;
        if (_v_len25 < _v_len26)
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        uintptr_t _v_len__origname4 = (_v_len25 - _v_len26);
        uintptr_t _v_len27 = _v_deref__nameinfo7.get_len ();
        uintptr_t _v_len28 = 0;
        if (_v_len27 < _v_len28)
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        uintptr_t _v_len__pragma_m_pos4 = (_v_len27 - _v_len28);
        if (!_ve_nameinfo.symbol_at ((0 + 1 + 1)))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        Expr _vs_decl (_ve_nameinfo, (0 + 1 + 1), 1);
        Expr _ve__e__e_tmp_m_rfp__parserf_m_523_m_49 (_ve_nameinfo, (0 + 1 + 1 + 1), _v_len___e__e_tmp_m_rfp__parserf_m_523_m_49);
        Expr _ve_pragma_m_pos (_v_deref__nameinfo7, 0, _v_len__pragma_m_pos4);
        Expr _ve_origname (_v_deref__nameinfo8, 0, _v_len__origname4);
        RF_CALL (rfp__err::RFP_m_Error, (_ve_pos, (_c_76 + _ge_name__2 + _c_101)), /*void*/);
        RF_CALL (rfp__err::RFP_m_Error, (_ve_pragma_m_pos, (_c_103 + _ge_name__2 + _c_102 + _vs_decl)), /*void*/);
        RF_CALL (Table::Bind, (Names, _ge_name__2, (_ve_pragma_m_pos () + _ve_origname () + _c_112 + (_c_109 + _ve_pos) ())), /*void*/);
        Expr _v_Pragma4;
        RF_CALL (Pragma, _ve_pragma_m_pos, _v_Pragma4);
        _ve_name = _ve_origname;
        _vs_tag = _c_44;
        _vs_linkage = _c_74;
        _vt_in = _c_113;
        _vt_out = _c_113;
        _vt_pragma = (_c_78 + _v_Pragma4) ();
      }
    _block3: {}
      goto _block1;
    }
  _block1__branch1: {}
    {
      {
        {
          if (_ve_value.get_len () != 4)
          {
            goto _block4__branch1;
          }
          if (!_c_104.eq (_ve_value, 0))
          {
            goto _block4__branch1;
          }
          goto _block4;
        }
      _block4__branch1: {}
        if (!RF_CALL (Table::In_m_Table_q_, (rfp__helper::RFP_m_Options, _c_105), /*void*/))
        {
          goto _block1__branch2;
        }
        Expr _v_To_m_Upper1;
        RF_CALL (Convert::To_m_Upper, _ve_value, _v_To_m_Upper1);
        if (_v_To_m_Upper1.get_len () != 4)
        {
          goto _block1__branch2;
        }
        if (!_c_106.eq (_v_To_m_Upper1, 0))
        {
          goto _block1__branch2;
        }
      }
    _block4: {}
      Expr _ge_auxcall1;
      RF_CALL (Module_m_Name, /*void*/, _ge_auxcall1);
      RF_CALL (Table::Bind, (Names, (_ge_auxcall1 + _c_84 + _ve_uniname), (_ve_pos () + _ve_value () + _c_114 + (_c_109 + _ve_pos) ())), /*void*/);
      Expr _ge_auxcall2;
      RF_CALL (Module_m_Name, /*void*/, _ge_auxcall2);
      Expr _v_Pragma5;
      RF_CALL (Pragma, _ve_pos, _v_Pragma5);
      _ve_name = (_ge_auxcall2 + _c_84 + _ve_value);
      _vs_tag = _c_44;
      _vs_linkage = _c_75;
      _vt_in = _c_113;
      _vt_out = _c_115;
      _vt_pragma = (_c_78 + _v_Pragma5) ();
      goto _block1;
    }
  _block1__branch2: {}
    RF_CALL (rfp__err::RFP_m_Error, (_ve_pos, (_c_107 + _ve_value + _c_76)), /*void*/);
    RF_CALL (Table::Bind, (Names, _ve_uniname, (_ve_pos () + _ve_value () + _c_112 + (_c_109 + _ve_pos) ())), /*void*/);
    Expr _v_Pragma6;
    RF_CALL (Pragma, _ve_pos, _v_Pragma6);
    _ve_name = _ve_value;
    _vs_tag = _c_44;
    _vs_linkage = _c_74;
    _vt_in = _c_113;
    _vt_out = _c_113;
    _vt_pragma = (_c_78 + _v_Pragma6) ();
  }
_block1: {}
  Expr _ve_trace;
  {
    {
      Expr _v__q_1;
      RF_CALL (Box::_q_, Traceall_q_, _v__q_1);
      uintptr_t _v_len29 = _v__q_1.get_len ();
      uintptr_t _v_len30 = 0;
      if (_v_len29 < (_v_len30 + 1))
      {
        goto _block5__branch1;
      }
      uintptr_t _v_len___e__e_tmp_m_rfp__parserf_m_543_m_25 = (_v_len29 - _v_len30);
      Expr _vv__e__e_tmp_m_rfp__parserf_m_543_m_25 (_v__q_1, 0, _v_len___e__e_tmp_m_rfp__parserf_m_543_m_25);
      Expr _gt_auxcall3;
      RF_CALL (Make_m_Name, _ve_name, _gt_auxcall3);
      _ve_trace = (_c_56 + _gt_auxcall3) ();
      goto _block5;
    }
  _block5__branch1: {}
    _ve_trace = empty;
  }
_block5: {}
  Expr _gs_linkage__3;
  {
    {
      if (!_vs_linkage.term_eq (_c_50, 0))
      {
        goto _block6__branch1;
      }
      _gs_linkage__3 = _c_75;
      goto _block6;
    }
  _block6__branch1: {}
    _gs_linkage__3 = _vs_linkage;
  }
_block6: {}
  Expr _gt_auxcall4;
  RF_CALL (Make_m_Name, _ve_name, _gt_auxcall4);
  Expr _ge_auxcall5;
  RF_CALL (Pragma, _ve_pos, _ge_auxcall5);
  _v_res1 = ((_gs_linkage__3 + _vs_tag + _vt_pragma + _gt_auxcall4 + _vt_in + _vt_out + (_c_116 + (_c_78 + _ge_auxcall5) () + _ve_items) ()) () + _ve_trace);
RF_END

RF_FUNC (Parse_m_Alt, (RF_ARG _ve_colon_m_pos;;), (RF_RES _v_res1;;))
  Expr _ve_pos;
  Expr _vs_type;
  Expr _ve_value;
  if (!RF_CALL (Expect_m_Token, _c_117, (_ve_pos, _vs_type, _ve_value)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  {
    {
      if (!_vs_type.term_eq (_c_62, 0))
      {
        goto _block1__branch1;
      }
      RF_TAILCALL (Parse_m_Sentence, _ve_colon_m_pos, _v_res1);
      goto _block1;
    }
  _block1__branch1: {}
    Expr _ve_snt_m_end_m_pos (_ve_pos);
    Expr _ve_items (empty);
    for ( ; ; )
    {
      {
        Expr _v_Expect_m_Token1;
        Expr _v_Expect_m_Token2;
        Expr _v_Expect_m_Token3;
        if (!RF_CALL (Expect_m_Token, _c_118, (_v_Expect_m_Token1, _v_Expect_m_Token2, _v_Expect_m_Token3)))
        {
          goto _iter1;
        }
        Expr _v_compose1 ((_v_Expect_m_Token1 () + (_v_Expect_m_Token2 + _v_Expect_m_Token3) ()));
        if (_v_compose1.symbol_at (0))
        {
          goto _iter1;
        }
        if (_v_compose1.symbol_at ((0 + 1)))
        {
          goto _iter1;
        }
        Expr _v_deref__compose1 (_v_compose1, 0);
        Expr _v_deref__compose12 (_v_compose1, (0 + 1));
        uintptr_t _v_len1 = _v_deref__compose12.get_len ();
        uintptr_t _v_len2 = 1;
        if (_v_len1 < _v_len2)
        {
          goto _iter1;
        }
        uintptr_t _v_len___e__e_tmp_m_rfp__parserf_m_567_m_52 = (_v_len1 - _v_len2);
        uintptr_t _v_len3 = _v_deref__compose1.get_len ();
        uintptr_t _v_len4 = 0;
        if (_v_len3 < _v_len4)
        {
          goto _iter1;
        }
        uintptr_t _v_len___e__e_tmp_m_rfp__parserf_m_567_m_41 = (_v_len3 - _v_len4);
        if (!_c_10.term_eq (_v_deref__compose12, 0))
        {
          goto _iter1;
        }
        Expr _ve__e__e_tmp_m_rfp__parserf_m_567_m_41 (_v_deref__compose1, 0, _v_len___e__e_tmp_m_rfp__parserf_m_567_m_41);
        Expr _ve__e__e_tmp_m_rfp__parserf_m_567_m_52 (_v_deref__compose12, (0 + 1), _v_len___e__e_tmp_m_rfp__parserf_m_567_m_52);
        {
          {
            if (_ve_items.get_len () != 0)
            {
              goto _block2__branch1;
            }
            Expr _ge_auxcall3;
            RF_CALL (Pragma, _ve_pos, _ge_auxcall3);
            _v_res1 = (_c_119 + (_c_78 + _ge_auxcall3) ()) ();
            goto _block2;
          }
        _block2__branch1: {}
          {
            {
              if (!_vs_type.term_eq (_c_8, 0))
              {
                goto _block3__branch1;
              }
              Expr _ge_auxcall4;
              RF_CALL (Pragma, _ve_pos, _ge_auxcall4);
              _v_res1 = (_c_120 + (_c_78 + _ge_auxcall4) () + _ve_items) ();
              goto _block3;
            }
          _block3__branch1: {}
            Expr _ge_auxcall5;
            RF_CALL (Pragma, _ve_pos, _ge_auxcall5);
            _v_res1 = (_c_121 + (_c_78 + _ge_auxcall5) () + _ve_items) ();
          }
        _block3: {}
        }
      _block2: {}
        goto _exit__iter1;
      }
    _iter1: {}
      Expr _ge_auxcall1;
      RF_CALL (Pragma, _ve_snt_m_end_m_pos, _ge_auxcall1);
      Expr _ge_auxcall2;
      RF_CALL (Parse_m_Alt, _ve_colon_m_pos, _ge_auxcall2);
      Expr _ge_items__4 ((_ve_items + (_c_116 + (_c_78 + _ge_auxcall1) () + _ge_auxcall2) ()));
      Expr _ge_snt_m_end_m_pos__4;
      Expr _v_Expect_m_Token4;
      Expr _v_Expect_m_Token5;
      if (!RF_CALL (Expect_m_Token, _c_6, (_ge_snt_m_end_m_pos__4, _v_Expect_m_Token4, _v_Expect_m_Token5)))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      Expr _vt__e__e_tmp_m_rfp__parserf_m_564_m_56 ((_v_Expect_m_Token4 + _v_Expect_m_Token5) ());
      _ve_snt_m_end_m_pos = _ge_snt_m_end_m_pos__4;
      _ve_items = _ge_items__4;
    }
  _exit__iter1: {}
  }
_block1: {}
RF_END

RF_FUNC (Parse_m_Sentence, (RF_ARG _ve_colon_m_pos;;), (RF_RES _v_res1;;))
  Expr _ve_pattern;
  RF_CALL (Parse_m_Pattern, _ve_colon_m_pos, _ve_pattern);
  Expr _ve_tail;
  RF_CALL (Parse_m_Tail, /*void*/, _ve_tail);
  _v_res1 = (_ve_pattern + _ve_tail);
RF_END

RF_FUNC (Tail_q_, RF_VOID, RF_VOID)
  Expr _ve_pos;
  Expr _vs_type;
  Expr _ve_value;
  if (!RF_CALL (Expect_m_Token, _c_122, (_ve_pos, _vs_type, _ve_value)))
  {
    RF_RETFAIL;
  }
  {
    if (!_vs_type.term_eq (_c_62, 0))
    {
      goto _block1__branch1;
    }
    RF_RETFAIL;
  }
_block1__branch1: {}
  RF_TAILCALL (Unget_m_Token, (_ve_pos () + (_vs_type + _ve_value) ()), /*void*/);
RF_END

RF_FUNC (Parse_m_Tail, RF_VOID, (RF_RES _v_res1;;))
  Expr _ve_pos;
  Expr _vs_type;
  Expr _ve_value;
  if (!RF_CALL (Expect_m_Token, _c_122, (_ve_pos, _vs_type, _ve_value)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  {
    {
      if (!_vs_type.term_eq (_c_0, 0))
      {
        goto _block1__branch1;
      }
      RF_TAILCALL (Parse_m_Path, /*void*/, _v_res1);
      goto _block1;
    }
  _block1__branch1: {}
    {
      if (!_vs_type.term_eq (_c_22, 0))
      {
        goto _block1__branch2;
      }
      Expr _ge_auxcall1;
      RF_CALL (Pragma, _ve_pos, _ge_auxcall1);
      Expr _ge_auxcall2;
      RF_CALL (Parse_m_Source, /*void*/, _ge_auxcall2);
      Expr _v_Parse_m_Tail1;
      RF_CALL (Parse_m_Tail, /*void*/, _v_Parse_m_Tail1);
      _v_res1 = ((_c_22 + (_c_116 + (_c_78 + _ge_auxcall1) () + _ge_auxcall2) ()) () + _v_Parse_m_Tail1);
      goto _block1;
    }
  _block1__branch2: {}
    {
      if (!_vs_type.term_eq (_c_123, 0))
      {
        goto _block1__branch3;
      }
      Expr _ge_auxcall3;
      RF_CALL (Pragma, _ve_pos, _ge_auxcall3);
      Expr _v_Parse_m_Path1;
      RF_CALL (Parse_m_Path, /*void*/, _v_Parse_m_Path1);
      _v_res1 = ((_c_123 + (_c_78 + _ge_auxcall3) ()) () + _v_Parse_m_Path1);
      goto _block1;
    }
  _block1__branch3: {}
    {
      if (!_vs_type.term_eq (_c_124, 0))
      {
        goto _block1__branch4;
      }
      Expr _ge_auxcall4;
      RF_CALL (Pragma, _ve_pos, _ge_auxcall4);
      Expr _v_Parse_m_Path2;
      RF_CALL (Parse_m_Path, /*void*/, _v_Parse_m_Path2);
      _v_res1 = ((_c_124 + (_c_78 + _ge_auxcall4) ()) () + _v_Parse_m_Path2);
      goto _block1;
    }
  _block1__branch4: {}
    {
      if (!_vs_type.term_eq (_c_125, 0))
      {
        goto _block1__branch5;
      }
      Expr _ge_auxcall5;
      RF_CALL (Pragma, _ve_pos, _ge_auxcall5);
      _v_res1 = (_c_125 + (_c_78 + _ge_auxcall5) ()) ();
      goto _block1;
    }
  _block1__branch5: {}
    {
      if (!_vs_type.term_eq (_c_24, 0))
      {
        goto _block1__branch6;
      }
      Expr _ge_auxcall6;
      RF_CALL (Pragma, _ve_pos, _ge_auxcall6);
      Expr _v_Parse_m_Path3;
      RF_CALL (Parse_m_Path, /*void*/, _v_Parse_m_Path3);
      _v_res1 = ((_c_126 + (_c_78 + _ge_auxcall6) ()) () + _v_Parse_m_Path3);
      goto _block1;
    }
  _block1__branch6: {}
    {
      if (!_vs_type.term_eq (_c_127, 0))
      {
        goto _block1__branch7;
      }
      Expr _ge_auxcall7;
      RF_CALL (Pragma, _ve_pos, _ge_auxcall7);
      Expr _v_Parse_m_Path4;
      RF_CALL (Parse_m_Path, /*void*/, _v_Parse_m_Path4);
      _v_res1 = ((_c_127 + (_c_78 + _ge_auxcall7) ()) () + _v_Parse_m_Path4);
      goto _block1;
    }
  _block1__branch7: {}
    {
      if (!_vs_type.term_eq (_c_128, 0))
      {
        goto _block1__branch8;
      }
      Expr _ve_try;
      RF_CALL (Parse_m_Path, /*void*/, _ve_try);
      Expr _v_Expect_m_Token1;
      Expr _v_Expect_m_Token2;
      Expr _v_Expect_m_Token3;
      if (!RF_CALL (Expect_m_Token, _c_129, (_v_Expect_m_Token1, _v_Expect_m_Token2, _v_Expect_m_Token3)))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      uintptr_t _v_len1 = 2;
      uintptr_t _v_len2 = 0;
      if (_v_len1 < _v_len2)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      uintptr_t _v_len___e__e_tmp_m_rfp__parserf_m_607_m_34 = (_v_len1 - _v_len2);
      Expr _v_compose1 ((_v_Expect_m_Token1 () + (_v_Expect_m_Token2 + _v_Expect_m_Token3) ()));
      Expr _ve__e__e_tmp_m_rfp__parserf_m_607_m_34 (_v_compose1, 0, _v_len___e__e_tmp_m_rfp__parserf_m_607_m_34);
      Expr _ge_auxcall8;
      RF_CALL (Pragma, _ve_pos, _ge_auxcall8);
      Expr _ge_auxcall9;
      RF_CALL (Parse_m_Alt, empty, _ge_auxcall9);
      _v_res1 = (_c_130 + (_c_116 + (_c_78 + _ge_auxcall8) () + _ve_try) () + _ge_auxcall9) ();
      goto _block1;
    }
  _block1__branch8: {}
    if (!_vs_type.term_eq (_c_62, 0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _ge_auxcall10;
    RF_CALL (Pragma, _ve_pos, _ge_auxcall10);
    _v_res1 = (_c_131 + (_c_78 + _ge_auxcall10) ()) ();
  }
_block1: {}
RF_END

RF_FUNC (Parse_m_Path, RF_VOID, (RF_RES _v_res1;;))
  {
    {
      if (!RF_CALL (Tail_q_, /*void*/, /*void*/))
      {
        goto _block1__branch1;
      }
      RF_TAILCALL (Parse_m_Tail, /*void*/, _v_res1);
      goto _block1;
    }
  _block1__branch1: {}
    Expr _ve_source;
    RF_CALL (Parse_m_Source, /*void*/, _ve_source);
    Expr _ve_items;
    {
      {
        if (!RF_CALL (Tail_q_, /*void*/, /*void*/))
        {
          goto _block2__branch1;
        }
        RF_CALL (Parse_m_Tail, /*void*/, _ve_items);
        goto _block2;
      }
    _block2__branch1: {}
      Expr _ve_pos;
      Expr _vs_type;
      Expr _ve__e__e_tmp_m_rfp__parserf_m_620_m_68;
      if (!RF_CALL (Expect_m_Token, _c_132, (_ve_pos, _vs_type, _ve__e__e_tmp_m_rfp__parserf_m_620_m_68)))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      {
        {
          if (!_vs_type.term_eq (_c_4, 0))
          {
            goto _block3__branch1;
          }
          Expr _ge_auxcall1;
          RF_CALL (Pragma, _ve_pos, _ge_auxcall1);
          Expr _ge_auxcall2;
          RF_CALL (Parse_m_Hard_m_Expr, /*void*/, _ge_auxcall2);
          Expr _v_Parse_m_Tail1;
          RF_CALL (Parse_m_Tail, /*void*/, _v_Parse_m_Tail1);
          _ve_items = ((_c_133 + (_c_78 + _ge_auxcall1) () + _ge_auxcall2) () + _v_Parse_m_Tail1);
          goto _block3;
        }
      _block3__branch1: {}
        {
          if (!_vs_type.term_eq (_c_134, 0))
          {
            goto _block3__branch2;
          }
          Expr _ve_body;
          RF_CALL (Parse_m_Source, /*void*/, _ve_body);
          {
            {
              if (!RF_CALL (Tail_q_, /*void*/, /*void*/))
              {
                goto _block4__branch1;
              }
              Expr _ge_auxcall3;
              RF_CALL (Pragma, _ve_pos, _ge_auxcall3);
              Expr _ge_auxcall4;
              RF_CALL (Pragma, _ve_pos, _ge_auxcall4);
              Expr _ge_auxcall5;
              RF_CALL (Pragma, _ve_pos, _ge_auxcall5);
              Expr _ge_auxcall6;
              RF_CALL (Parse_m_Tail, /*void*/, _ge_auxcall6);
              _ve_items = (_c_134 + (_c_116 + (_c_78 + _ge_auxcall3) () + _ve_body) () + (_c_133 + (_c_78 + _ge_auxcall4) ()) () + (_c_116 + (_c_78 + _ge_auxcall5) () + _ge_auxcall6) ()) ();
              goto _block4;
            }
          _block4__branch1: {}
            Expr _ve_dcolon_m_pos;
            Expr _v_Expect_m_Token1;
            Expr _v_Expect_m_Token2;
            if (!RF_CALL (Expect_m_Token, _c_4, (_ve_dcolon_m_pos, _v_Expect_m_Token1, _v_Expect_m_Token2)))
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            Expr _vt__e__e_tmp_m_rfp__parserf_m_631_m_58 ((_v_Expect_m_Token1 + _v_Expect_m_Token2) ());
            Expr _ge_auxcall7;
            RF_CALL (Pragma, _ve_pos, _ge_auxcall7);
            Expr _ge_auxcall8;
            RF_CALL (Pragma, _ve_dcolon_m_pos, _ge_auxcall8);
            Expr _ge_auxcall9;
            RF_CALL (Parse_m_Hard_m_Expr, /*void*/, _ge_auxcall9);
            Expr _ge_auxcall10;
            RF_CALL (Pragma, _ve_dcolon_m_pos, _ge_auxcall10);
            Expr _ge_auxcall11;
            RF_CALL (Parse_m_Tail, /*void*/, _ge_auxcall11);
            _ve_items = (_c_134 + (_c_116 + (_c_78 + _ge_auxcall7) () + _ve_body) () + (_c_133 + (_c_78 + _ge_auxcall8) () + _ge_auxcall9) () + (_c_116 + (_c_78 + _ge_auxcall10) () + _ge_auxcall11) ()) ();
          }
        _block4: {}
          goto _block3;
        }
      _block3__branch2: {}
        {
          if (!_vs_type.term_eq (_c_2, 0))
          {
            goto _block3__branch3;
          }
          RF_CALL (Parse_m_Alt, _ve_pos, _ve_items);
          goto _block3;
        }
      _block3__branch3: {}
        if (!_vs_type.term_eq (_c_62, 0))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        _ve_items = empty;
      }
    _block3: {}
    }
  _block2: {}
    _v_res1 = (_ve_source + _ve_items);
  }
_block1: {}
RF_END

RF_FUNC (Parse_m_Source, RF_VOID, (RF_RES _v_res1;;))
  Expr _ve_items;
  Expr _ve_pos;
  Expr _v_Expect_m_Token1;
  Expr _v_Expect_m_Token2;
  if (!RF_CALL (Expect_m_Token, _c_62, (_ve_pos, _v_Expect_m_Token1, _v_Expect_m_Token2)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _ve__e__e_tmp_m_rfp__parserf_m_665_m_38 ((_v_Expect_m_Token1 + _v_Expect_m_Token2) ());
  Expr _ge_auxcall1;
  RF_CALL (Pragma, _ve_pos, _ge_auxcall1);
  Expr _ge_auxcall2;
  RF_CALL (Parse_m_Result, /*void*/, _ge_auxcall2);
  _ve_items = (_c_131 + (_c_78 + _ge_auxcall1) () + _ge_auxcall2) ();
  Expr _vs_type;
  Expr _ve_value;
  if (!RF_CALL (Expect_m_Token, _c_135, (_ve_pos, _vs_type, _ve_value)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  for ( ; ; )
  {
    {
      if (!_vs_type.term_eq (_c_62, 0))
      {
        goto _iter1;
      }
      _v_res1 = _ve_items;
      goto _exit__iter1;
    }
  _iter1: {}
    {
      {
        Expr _ve_p;
        Expr _vs_t;
        Expr _ve_v;
        if (!RF_CALL (Expect_m_Token, _c_117, (_ve_p, _vs_t, _ve_v)))
        {
          goto _block2__branch1;
        }
        RF_CALL (Unget_m_Token, (_ve_p () + (_vs_t + _ve_v) ()), /*void*/);
        {
          {
            if (!_vs_t.term_eq (_c_8, 0))
            {
              goto _block3__branch1;
            }
            goto _block3;
          }
        _block3__branch1: {}
          if (!_vs_t.term_eq (_c_136, 0))
          {
            goto _block2__branch1;
          }
        }
      _block3: {}
        Expr _ge_auxcall3;
        RF_CALL (Parse_m_Alt, _ve_pos, _ge_auxcall3);
        if (!RF_CALL (Expect_m_Token, _c_135, (_ve_pos, _vs_type, _ve_value)))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        _ve_items = (_ve_items + _ge_auxcall3);
        goto _block2;
      }
    _block2__branch1: {}
      RF_CALL (Unget_m_Token, (_ve_pos () + (_vs_type + _ve_value) ()), /*void*/);
      _vs_type = _c_62;
      _ve_value = empty;
    }
  _block2: {}
  }
_exit__iter1: {}
RF_END

RF_FUNC (Parse_m_Result, RF_VOID, (RF_RES _v_res1;;))
  {
    {
      Expr _v_Parse_m_Result_m_Term1;
      RF_CALL (Parse_m_Result_m_Term, /*void*/, _v_Parse_m_Result_m_Term1);
      uintptr_t _v_len1 = _v_Parse_m_Result_m_Term1.get_len ();
      uintptr_t _v_len2 = 0;
      if (_v_len1 < (_v_len2 + 1))
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__term = (_v_len1 - _v_len2);
      Expr _vv_term (_v_Parse_m_Result_m_Term1, 0, _v_len__term);
      Expr _v_Parse_m_Result1;
      RF_CALL (Parse_m_Result, /*void*/, _v_Parse_m_Result1);
      _v_res1 = (_vv_term + _v_Parse_m_Result1);
      goto _block1;
    }
  _block1__branch1: {}
    _v_res1 = empty;
  }
_block1: {}
RF_END

RF_FUNC (Parse_m_Result_m_Term, RF_VOID, (RF_RES _v_res1;;))
  Expr _ve_pos;
  Expr _vs_type;
  Expr _ve_value;
  if (!RF_CALL (Expect_m_Token, _c_137, (_ve_pos, _vs_type, _ve_value)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  {
    {
      if (!_vs_type.term_eq (_c_62, 0))
      {
        goto _block1__branch1;
      }
      _v_res1 = empty;
      goto _block1;
    }
  _block1__branch1: {}
    {
      if (!_vs_type.term_eq (_c_86, 0))
      {
        goto _block1__branch2;
      }
      _v_res1 = _ve_value;
      goto _block1;
    }
  _block1__branch2: {}
    {
      if (!_vs_type.term_eq (_c_87, 0))
      {
        goto _block1__branch3;
      }
      _v_res1 = _ve_value;
      goto _block1;
    }
  _block1__branch3: {}
    {
      if (!_vs_type.term_eq (_c_20, 0))
      {
        goto _block1__branch4;
      }
      RF_TAILCALL (Parse_m_Ref, /*void*/, _v_res1);
      goto _block1;
    }
  _block1__branch4: {}
    {
      if (!_vs_type.term_eq (_c_16, 0))
      {
        goto _block1__branch5;
      }
      Expr _ve_items;
      RF_CALL (Parse_m_Result, /*void*/, _ve_items);
      Expr _v_Expect_m_Token1;
      Expr _v_Expect_m_Token2;
      Expr _v_Expect_m_Token3;
      if (!RF_CALL (Expect_m_Token, _c_18, (_v_Expect_m_Token1, _v_Expect_m_Token2, _v_Expect_m_Token3)))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      uintptr_t _v_len1 = 2;
      uintptr_t _v_len2 = 0;
      if (_v_len1 < _v_len2)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      uintptr_t _v_len___e__e_tmp_m_rfp__parserf_m_701_m_34 = (_v_len1 - _v_len2);
      Expr _v_compose1 ((_v_Expect_m_Token1 () + (_v_Expect_m_Token2 + _v_Expect_m_Token3) ()));
      Expr _ve__e__e_tmp_m_rfp__parserf_m_701_m_34 (_v_compose1, 0, _v_len___e__e_tmp_m_rfp__parserf_m_701_m_34);
      _v_res1 = (_c_88 + _ve_items) ();
      goto _block1;
    }
  _block1__branch5: {}
    {
      {
        {
          if (!_vs_type.term_eq (_c_28, 0))
          {
            goto _block2__branch1;
          }
          goto _block2;
        }
      _block2__branch1: {}
        {
          if (!_vs_type.term_eq (_c_30, 0))
          {
            goto _block2__branch2;
          }
          goto _block2;
        }
      _block2__branch2: {}
        {
          if (!_vs_type.term_eq (_c_32, 0))
          {
            goto _block2__branch3;
          }
          goto _block2;
        }
      _block2__branch3: {}
        if (!_vs_type.term_eq (_c_34, 0))
        {
          goto _block1__branch6;
        }
      }
    _block2: {}
      Expr _ge_auxcall1;
      RF_CALL (Pragma, _ve_pos, _ge_auxcall1);
      Expr _gt_auxcall2;
      RF_CALL (Make_m_Name, _ve_value, _gt_auxcall2);
      _v_res1 = (_vs_type + (_c_78 + _ge_auxcall1) () + _gt_auxcall2) ();
      goto _block1;
    }
  _block1__branch6: {}
    {
      if (!_vs_type.term_eq (_c_72, 0))
      {
        goto _block1__branch7;
      }
      RF_CALL (Canonical_m_Word, _ve_value, _v_res1);
      goto _block1;
    }
  _block1__branch7: {}
    {
      if (!_vs_type.term_eq (_c_73, 0))
      {
        goto _block1__branch8;
      }
      RF_CALL (Convert::To_m_Word, _ve_value, _v_res1);
      goto _block1;
    }
  _block1__branch8: {}
    {
      if (!_vs_type.term_eq (_c_12, 0))
      {
        goto _block1__branch9;
      }
      Expr _ge_pos__2;
      Expr _gs_type__2;
      Expr _ge_value__2;
      if (!RF_CALL (Expect_m_Token, _c_98, (_ge_pos__2, _gs_type__2, _ge_value__2)))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      Expr _ve_uniname;
      RF_CALL (Canonical_m_Name, (_gs_type__2, _ge_value__2), _ve_uniname);
      Expr _ve_name;
      {
        {
          Expr _ge_name__4;
          if (!RF_CALL (Lookup_m_Name, (_ge_pos__2, _ve_uniname), _ge_name__4))
          {
            goto _block3__branch1;
          }
          Expr _v_Lookup1;
          if (!RF_CALL (Table::Lookup, (Names, _ge_name__4), _v_Lookup1))
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          uintptr_t _v_len3 = _v_Lookup1.get_len ();
          uintptr_t _v_len4 = 3;
          if (_v_len3 < _v_len4)
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          uintptr_t _v_len__nameinfo = (_v_len3 - _v_len4);
          if (_v_Lookup1.symbol_at (0))
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          if (_v_Lookup1.symbol_at ((0 + 1)))
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          Expr _v_deref__Lookup1 (_v_Lookup1, 0);
          Expr _v_deref__Lookup12 (_v_Lookup1, (0 + 1));
          uintptr_t _v_len5 = _v_deref__Lookup12.get_len ();
          uintptr_t _v_len6 = 0;
          if (_v_len5 < _v_len6)
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          uintptr_t _v_len__origname = (_v_len5 - _v_len6);
          uintptr_t _v_len7 = _v_deref__Lookup1.get_len ();
          uintptr_t _v_len8 = 0;
          if (_v_len7 < _v_len8)
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          uintptr_t _v_len__decl_m_pos = (_v_len7 - _v_len8);
          if (!_v_Lookup1.symbol_at ((0 + 1 + 1)))
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          Expr _vs_decl_m_type (_v_Lookup1, (0 + 1 + 1), 1);
          Expr _ve_nameinfo (_v_Lookup1, (0 + 1 + 1 + 1), _v_len__nameinfo);
          Expr _ve_decl_m_pos (_v_deref__Lookup1, 0, _v_len__decl_m_pos);
          Expr _ve_origname (_v_deref__Lookup12, 0, _v_len__origname);
          {
            {
              {
                {
                  uintptr_t _v_len9 = 1;
                  uintptr_t _v_len10 = 1;
                  if (_v_len9 < _v_len10)
                  {
                    goto _block5__branch1;
                  }
                  uintptr_t _v_len___e__e_tmp_m_rfp__parserf_m_721_m_27 = (_v_len9 - _v_len10);
                  if (!_vs_decl_m_type.term_eq (_c_44, 0))
                  {
                    goto _block5__branch1;
                  }
                  Expr _ve__e__e_tmp_m_rfp__parserf_m_721_m_27 (_vs_decl_m_type, (0 + 1), _v_len___e__e_tmp_m_rfp__parserf_m_721_m_27);
                  goto _block5;
                }
              _block5__branch1: {}
                {
                  uintptr_t _v_len11 = 1;
                  uintptr_t _v_len12 = 1;
                  if (_v_len11 < _v_len12)
                  {
                    goto _block5__branch2;
                  }
                  uintptr_t _v_len___e__e_tmp_m_rfp__parserf_m_722_m_28 = (_v_len11 - _v_len12);
                  if (!_vs_decl_m_type.term_eq (_c_46, 0))
                  {
                    goto _block5__branch2;
                  }
                  Expr _ve__e__e_tmp_m_rfp__parserf_m_722_m_28 (_vs_decl_m_type, (0 + 1), _v_len___e__e_tmp_m_rfp__parserf_m_722_m_28);
                  goto _block5;
                }
              _block5__branch2: {}
                uintptr_t _v_len13 = 1;
                uintptr_t _v_len14 = 1;
                if (_v_len13 < _v_len14)
                {
                  goto _block4__branch1;
                }
                uintptr_t _v_len___e__e_tmp_m_rfp__parserf_m_723_m_28 = (_v_len13 - _v_len14);
                if (!_vs_decl_m_type.term_eq (_c_48, 0))
                {
                  goto _block4__branch1;
                }
                Expr _ve__e__e_tmp_m_rfp__parserf_m_723_m_28 (_vs_decl_m_type, (0 + 1), _v_len___e__e_tmp_m_rfp__parserf_m_723_m_28);
              }
            _block5: {}
              _ve_name = _ve_origname;
              goto _block4;
            }
          _block4__branch1: {}
            RF_CALL (rfp__err::RFP_m_Error, (_ge_pos__2, (_c_76 + _ge_name__4 + _c_138)), /*void*/);
            RF_CALL (rfp__err::RFP_m_Error, (_ve_decl_m_pos, (_c_103 + _ge_name__4 + _c_102 + _vs_decl_m_type)), /*void*/);
            _ve_name = _ve_origname;
          }
        _block4: {}
          goto _block3;
        }
      _block3__branch1: {}
        RF_CALL (rfp__err::RFP_m_Error, (_ge_pos__2, (_c_107 + _ge_value__2 + _c_76)), /*void*/);
        _ve_name = _ge_value__2;
      }
    _block3: {}
      Expr _ge_auxcall3;
      RF_CALL (Pragma, _ge_pos__2, _ge_auxcall3);
      Expr _gt_auxcall4;
      RF_CALL (Make_m_Name, _ve_name, _gt_auxcall4);
      Expr _ge_auxcall5;
      RF_CALL (Parse_m_Result, /*void*/, _ge_auxcall5);
      Expr _ve_items ((_c_139 + (_c_78 + _ge_auxcall3) () + _gt_auxcall4 + _ge_auxcall5) ());
      Expr _v_Expect_m_Token4;
      Expr _v_Expect_m_Token5;
      Expr _v_Expect_m_Token6;
      if (!RF_CALL (Expect_m_Token, _c_14, (_v_Expect_m_Token4, _v_Expect_m_Token5, _v_Expect_m_Token6)))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      uintptr_t _v_len15 = 2;
      uintptr_t _v_len16 = 0;
      if (_v_len15 < _v_len16)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      uintptr_t _v_len___e__e_tmp_m_rfp__parserf_m_735_m_36 = (_v_len15 - _v_len16);
      Expr _v_compose2 ((_v_Expect_m_Token4 () + (_v_Expect_m_Token5 + _v_Expect_m_Token6) ()));
      Expr _ve__e__e_tmp_m_rfp__parserf_m_735_m_36 (_v_compose2, 0, _v_len___e__e_tmp_m_rfp__parserf_m_735_m_36);
      _v_res1 = _ve_items;
      goto _block1;
    }
  _block1__branch9: {}
    {
      {
        if (!_vs_type.term_eq (_c_8, 0))
        {
          goto _block6__branch1;
        }
        goto _block6;
      }
    _block6__branch1: {}
      if (!_vs_type.term_eq (_c_136, 0))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
    }
  _block6: {}
    Expr _ve_snt_m_end_m_pos (_ve_pos);
    Expr _ve_items (empty);
    for ( ; ; )
    {
      {
        Expr _v_Expect_m_Token7;
        Expr _v_Expect_m_Token8;
        Expr _v_Expect_m_Token9;
        if (!RF_CALL (Expect_m_Token, _c_118, (_v_Expect_m_Token7, _v_Expect_m_Token8, _v_Expect_m_Token9)))
        {
          goto _iter1;
        }
        Expr _v_compose3 ((_v_Expect_m_Token7 () + (_v_Expect_m_Token8 + _v_Expect_m_Token9) ()));
        if (_v_compose3.symbol_at (0))
        {
          goto _iter1;
        }
        if (_v_compose3.symbol_at ((0 + 1)))
        {
          goto _iter1;
        }
        Expr _v_deref__compose3 (_v_compose3, 0);
        Expr _v_deref__compose32 (_v_compose3, (0 + 1));
        uintptr_t _v_len17 = _v_deref__compose32.get_len ();
        uintptr_t _v_len18 = 1;
        if (_v_len17 < _v_len18)
        {
          goto _iter1;
        }
        uintptr_t _v_len___e__e_tmp_m_rfp__parserf_m_742_m_52 = (_v_len17 - _v_len18);
        uintptr_t _v_len19 = _v_deref__compose3.get_len ();
        uintptr_t _v_len20 = 0;
        if (_v_len19 < _v_len20)
        {
          goto _iter1;
        }
        uintptr_t _v_len___e__e_tmp_m_rfp__parserf_m_742_m_41 = (_v_len19 - _v_len20);
        if (!_c_10.term_eq (_v_deref__compose32, 0))
        {
          goto _iter1;
        }
        Expr _ve__e__e_tmp_m_rfp__parserf_m_742_m_41 (_v_deref__compose3, 0, _v_len___e__e_tmp_m_rfp__parserf_m_742_m_41);
        Expr _ve__e__e_tmp_m_rfp__parserf_m_742_m_52 (_v_deref__compose32, (0 + 1), _v_len___e__e_tmp_m_rfp__parserf_m_742_m_52);
        {
          {
            if (!_vs_type.term_eq (_c_8, 0))
            {
              goto _block7__branch1;
            }
            Expr _ge_auxcall8;
            RF_CALL (Pragma, _ve_pos, _ge_auxcall8);
            _v_res1 = (_c_120 + (_c_78 + _ge_auxcall8) () + _ve_items) ();
            goto _block7;
          }
        _block7__branch1: {}
          Expr _ge_auxcall9;
          RF_CALL (Pragma, _ve_pos, _ge_auxcall9);
          _v_res1 = (_c_121 + (_c_78 + _ge_auxcall9) () + _ve_items) ();
        }
      _block7: {}
        goto _exit__iter1;
      }
    _iter1: {}
      Expr _ge_auxcall6;
      RF_CALL (Pragma, _ve_snt_m_end_m_pos, _ge_auxcall6);
      Expr _ge_auxcall7;
      RF_CALL (Parse_m_Path, /*void*/, _ge_auxcall7);
      Expr _ge_items__4 ((_ve_items + (_c_116 + (_c_78 + _ge_auxcall6) () + _ge_auxcall7) ()));
      Expr _ge_snt_m_end_m_pos__4;
      Expr _v_Expect_m_Token10;
      Expr _v_Expect_m_Token11;
      if (!RF_CALL (Expect_m_Token, _c_6, (_ge_snt_m_end_m_pos__4, _v_Expect_m_Token10, _v_Expect_m_Token11)))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      Expr _vt__e__e_tmp_m_rfp__parserf_m_739_m_58 ((_v_Expect_m_Token10 + _v_Expect_m_Token11) ());
      _ve_snt_m_end_m_pos = _ge_snt_m_end_m_pos__4;
      _ve_items = _ge_items__4;
    }
  _exit__iter1: {}
  }
_block1: {}
RF_END

RF_FUNC (Parse_m_Pattern, (RF_ARG _ve_colon_m_pos;;), (RF_RES _v_res1;;))
  Expr _v_Expect_m_Token1;
  Expr _v_Expect_m_Token2;
  Expr _v_Expect_m_Token3;
  if (!RF_CALL (Expect_m_Token, _c_140, (_v_Expect_m_Token1, _v_Expect_m_Token2, _v_Expect_m_Token3)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _v_compose1 ((_v_Expect_m_Token1 () + (_v_Expect_m_Token2 + _v_Expect_m_Token3) ()));
  if (_v_compose1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (_v_compose1.symbol_at ((0 + 1)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _v_deref__compose1 (_v_compose1, 0);
  Expr _v_deref__compose12 (_v_compose1, (0 + 1));
  uintptr_t _v_len1 = _v_deref__compose12.get_len ();
  uintptr_t _v_len2 = 1;
  if (_v_len1 < _v_len2)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len___e__e_tmp_m_rfp__parserf_m_751_m_47 = (_v_len1 - _v_len2);
  uintptr_t _v_len3 = _v_deref__compose1.get_len ();
  uintptr_t _v_len4 = 0;
  if (_v_len3 < _v_len4)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len__pos = (_v_len3 - _v_len4);
  if (!_v_deref__compose12.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _ve_pos (_v_deref__compose1, 0, _v_len__pos);
  Expr _vs_type (_v_deref__compose12, 0, 1);
  Expr _ve__e__e_tmp_m_rfp__parserf_m_751_m_47 (_v_deref__compose12, (0 + 1), _v_len___e__e_tmp_m_rfp__parserf_m_751_m_47);
  Expr _v_compose2 ((_ve_colon_m_pos () + _ve_pos ()));
  RF_lsplit (_v_compose2, 0, _ve__e__e_tmp_m_rfp__parserf_m_752_m_28, _v_lsplit__compose2);
  for ( ; ; RF_iter(_v_compose2)++)
  {
    {
      if (!RF_iter(_v_compose2))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      uintptr_t _v_len5 = _v_lsplit__compose2.get_len ();
      uintptr_t _v_len6 = 1;
      if (_v_len5 < _v_len6)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      uintptr_t _v_len___e__e_tmp_m_rfp__parserf_m_752_m_36 = (_v_len5 - _v_len6);
      if (_v_lsplit__compose2.symbol_at (0))
      {
        goto _continue1;
      }
      Expr _v_deref__lsplit__compose2 (_v_lsplit__compose2, 0);
      uintptr_t _v_len7 = _v_deref__lsplit__compose2.get_len ();
      uintptr_t _v_len8 = 0;
      if (_v_len7 < (_v_len8 + 1))
      {
        goto _continue1;
      }
      uintptr_t _v_len__p = (_v_len7 - _v_len8);
      Expr _ve__e__e_tmp_m_rfp__parserf_m_752_m_36 (_v_lsplit__compose2, (0 + 1), _v_len___e__e_tmp_m_rfp__parserf_m_752_m_36);
      Expr _vv_p (_v_deref__lsplit__compose2, 0, _v_len__p);
      {
        {
          if (!_vs_type.term_eq (_c_141, 0))
          {
            goto _block1__branch1;
          }
          Expr _ge_auxcall1;
          RF_CALL (Pragma, _vv_p, _ge_auxcall1);
          Expr _ge_auxcall2;
          RF_CALL (Parse_m_Pattern_m_Expr, /*void*/, _ge_auxcall2);
          _v_res1 = (_c_142 + (_c_78 + _ge_auxcall1) () + _ge_auxcall2) ();
          goto _block1;
        }
      _block1__branch1: {}
        Expr _ge_auxcall3;
        RF_CALL (Pragma, _vv_p, _ge_auxcall3);
        Expr _ge_auxcall4;
        RF_CALL (Parse_m_Pattern_m_Expr, /*void*/, _ge_auxcall4);
        _v_res1 = (_c_119 + (_c_78 + _ge_auxcall3) () + _ge_auxcall4) ();
      }
    _block1: {}
      goto _exit1;
    }
_continue1: {}
  }
_exit1: {}
RF_END

RF_FUNC (Parse_m_Pattern_m_Expr, RF_VOID, (RF_RES _v_res1;;))
  {
    {
      Expr _v_Parse_m_Pattern_m_Term1;
      RF_CALL (Parse_m_Pattern_m_Term, /*void*/, _v_Parse_m_Pattern_m_Term1);
      uintptr_t _v_len1 = _v_Parse_m_Pattern_m_Term1.get_len ();
      uintptr_t _v_len2 = 0;
      if (_v_len1 < (_v_len2 + 1))
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__term = (_v_len1 - _v_len2);
      Expr _vv_term (_v_Parse_m_Pattern_m_Term1, 0, _v_len__term);
      Expr _v_Parse_m_Pattern_m_Expr1;
      RF_CALL (Parse_m_Pattern_m_Expr, /*void*/, _v_Parse_m_Pattern_m_Expr1);
      _v_res1 = (_vv_term + _v_Parse_m_Pattern_m_Expr1);
      goto _block1;
    }
  _block1__branch1: {}
    _v_res1 = empty;
  }
_block1: {}
RF_END

RF_FUNC (Parse_m_Pattern_m_Term, RF_VOID, (RF_RES _v_res1;;))
  Expr _ve_pos;
  Expr _vs_type;
  Expr _ve_value;
  if (!RF_CALL (Expect_m_Token, _c_143, (_ve_pos, _vs_type, _ve_value)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  {
    {
      if (!_vs_type.term_eq (_c_62, 0))
      {
        goto _block1__branch1;
      }
      _v_res1 = empty;
      goto _block1;
    }
  _block1__branch1: {}
    {
      if (!_vs_type.term_eq (_c_86, 0))
      {
        goto _block1__branch2;
      }
      _v_res1 = _ve_value;
      goto _block1;
    }
  _block1__branch2: {}
    {
      if (!_vs_type.term_eq (_c_87, 0))
      {
        goto _block1__branch3;
      }
      _v_res1 = _ve_value;
      goto _block1;
    }
  _block1__branch3: {}
    {
      if (!_vs_type.term_eq (_c_72, 0))
      {
        goto _block1__branch4;
      }
      RF_CALL (Canonical_m_Word, _ve_value, _v_res1);
      goto _block1;
    }
  _block1__branch4: {}
    {
      if (!_vs_type.term_eq (_c_73, 0))
      {
        goto _block1__branch5;
      }
      RF_CALL (Convert::To_m_Word, _ve_value, _v_res1);
      goto _block1;
    }
  _block1__branch5: {}
    {
      if (!_vs_type.term_eq (_c_20, 0))
      {
        goto _block1__branch6;
      }
      RF_TAILCALL (Parse_m_Ref, /*void*/, _v_res1);
      goto _block1;
    }
  _block1__branch6: {}
    {
      if (!_vs_type.term_eq (_c_16, 0))
      {
        goto _block1__branch7;
      }
      Expr _ve_items;
      RF_CALL (Parse_m_Pattern_m_Expr, /*void*/, _ve_items);
      Expr _v_Expect_m_Token1;
      Expr _v_Expect_m_Token2;
      Expr _v_Expect_m_Token3;
      if (!RF_CALL (Expect_m_Token, _c_18, (_v_Expect_m_Token1, _v_Expect_m_Token2, _v_Expect_m_Token3)))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      uintptr_t _v_len1 = 2;
      uintptr_t _v_len2 = 0;
      if (_v_len1 < _v_len2)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      uintptr_t _v_len___e__e_tmp_m_rfp__parserf_m_781_m_34 = (_v_len1 - _v_len2);
      Expr _v_compose1 ((_v_Expect_m_Token1 () + (_v_Expect_m_Token2 + _v_Expect_m_Token3) ()));
      Expr _ve__e__e_tmp_m_rfp__parserf_m_781_m_34 (_v_compose1, 0, _v_len___e__e_tmp_m_rfp__parserf_m_781_m_34);
      _v_res1 = (_c_88 + _ve_items) ();
      goto _block1;
    }
  _block1__branch7: {}
    {
      {
        if (!_vs_type.term_eq (_c_28, 0))
        {
          goto _block2__branch1;
        }
        goto _block2;
      }
    _block2__branch1: {}
      {
        if (!_vs_type.term_eq (_c_30, 0))
        {
          goto _block2__branch2;
        }
        goto _block2;
      }
    _block2__branch2: {}
      {
        if (!_vs_type.term_eq (_c_32, 0))
        {
          goto _block2__branch3;
        }
        goto _block2;
      }
    _block2__branch3: {}
      if (!_vs_type.term_eq (_c_34, 0))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
    }
  _block2: {}
    Expr _ge_auxcall1;
    RF_CALL (Pragma, _ve_pos, _ge_auxcall1);
    Expr _gt_auxcall2;
    RF_CALL (Make_m_Name, _ve_value, _gt_auxcall2);
    _v_res1 = (_vs_type + (_c_78 + _ge_auxcall1) () + _gt_auxcall2) ();
  }
_block1: {}
RF_END

RF_FUNC (Parse_m_Ref, RF_VOID, (RF_RES _v_res1;;))
  Expr _ve_pos;
  Expr _vs_type;
  Expr _ve_value;
  if (!RF_CALL (Expect_m_Token, _c_98, (_ve_pos, _vs_type, _ve_value)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _ve_uniname;
  RF_CALL (Canonical_m_Name, (_vs_type, _ve_value), _ve_uniname);
  {
    {
      Expr _ve_name;
      if (!RF_CALL (Lookup_m_Name, (_ve_pos, _ve_uniname), _ve_name))
      {
        goto _block1__branch1;
      }
      Expr _v_Lookup1;
      if (!RF_CALL (Table::Lookup, (Names, _ve_name), _v_Lookup1))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      uintptr_t _v_len1 = _v_Lookup1.get_len ();
      uintptr_t _v_len2 = 3;
      if (_v_len1 < _v_len2)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      uintptr_t _v_len__nameinfo = (_v_len1 - _v_len2);
      if (_v_Lookup1.symbol_at (0))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      if (_v_Lookup1.symbol_at ((0 + 1)))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      Expr _v_deref__Lookup1 (_v_Lookup1, 0);
      Expr _v_deref__Lookup12 (_v_Lookup1, (0 + 1));
      uintptr_t _v_len3 = _v_deref__Lookup12.get_len ();
      uintptr_t _v_len4 = 0;
      if (_v_len3 < _v_len4)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      uintptr_t _v_len__origname = (_v_len3 - _v_len4);
      uintptr_t _v_len5 = _v_deref__Lookup1.get_len ();
      uintptr_t _v_len6 = 0;
      if (_v_len5 < _v_len6)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      uintptr_t _v_len__decl_m_pos = (_v_len5 - _v_len6);
      if (!_v_Lookup1.symbol_at ((0 + 1 + 1)))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      Expr _vs_decl_m_type (_v_Lookup1, (0 + 1 + 1), 1);
      Expr _ve_nameinfo (_v_Lookup1, (0 + 1 + 1 + 1), _v_len__nameinfo);
      Expr _ve_decl_m_pos (_v_deref__Lookup1, 0, _v_len__decl_m_pos);
      Expr _ve_origname (_v_deref__Lookup12, 0, _v_len__origname);
      Expr _gt_auxcall1;
      RF_CALL (Make_m_Name, _ve_origname, _gt_auxcall1);
      _v_res1 = (_c_20 + _gt_auxcall1) ();
      goto _block1;
    }
  _block1__branch1: {}
    RF_CALL (rfp__err::RFP_m_Error, (_ve_pos, (_c_107 + _ve_value + _c_76)), /*void*/);
    Expr _gt_auxcall2;
    RF_CALL (Make_m_Name, _ve_value, _gt_auxcall2);
    _v_res1 = (_c_20 + _gt_auxcall2) ();
  }
_block1: {}
RF_END

RF_FUNC (Make_m_Name, (RF_ARG _ve_sname;;), (RF_RES _v_res1;;))
  Expr _ge_auxcall1;
  RF_CALL (Convert::To_m_Chars, _ve_sname, _ge_auxcall1);
  Expr _ge_auxcall2;
  RF_CALL (Make_m_Name2, _ge_auxcall1, _ge_auxcall2);
  _v_res1 = _ge_auxcall2 ();
RF_END

RF_FUNC (Make_m_Name2, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  {
    {
      if (_ge_arg1.get_len () < 1)
      {
        goto _block1__branch1;
      }
      RF_lsplit (_ge_arg1, 0, _ve_item, _v_lsplit__arg1);
      for ( ; ; RF_iter(_ge_arg1)++)
      {
        {
          if (!RF_iter(_ge_arg1))
          {
            goto _block1__branch1;
          }
          uintptr_t _v_len1 = _v_lsplit__arg1.get_len ();
          uintptr_t _v_len2 = 1;
          if (_v_len1 < _v_len2)
          {
            goto _block1__branch1;
          }
          uintptr_t _v_len__rest = (_v_len1 - _v_len2);
          if (!_c_84.term_eq (_v_lsplit__arg1, 0))
          {
            goto _continue1;
          }
          Expr _ve_rest (_v_lsplit__arg1, (0 + 1), _v_len__rest);
          Expr _gs_auxcall1;
          RF_CALL (Convert::To_m_Word, _ve_item, _gs_auxcall1);
          Expr _v_Make_m_Name21;
          RF_CALL (Make_m_Name2, _ve_rest, _v_Make_m_Name21);
          _v_res1 = (_gs_auxcall1 + _v_Make_m_Name21);
          goto _exit1;
        }
    _continue1: {}
      }
    _exit1: {}
      goto _block1;
    }
  _block1__branch1: {}
    RF_CALL (Convert::To_m_Word, _ge_arg1, _v_res1);
  }
_block1: {}
RF_END

RF_FUNC (Canonical_m_Name, (RF_ARG _vs_type, _ve_name;;), (RF_RES _v_res1;;))
  {
    {
      if (!_vs_type.term_eq (_c_72, 0))
      {
        goto _block1__branch1;
      }
      if (!RF_CALL (Table::In_m_Table_q_, (rfp__helper::RFP_m_Options, _c_105), /*void*/))
      {
        goto _block1__branch1;
      }
      RF_TAILCALL (Convert::To_m_Upper, _ve_name, _v_res1);
      goto _block1;
    }
  _block1__branch1: {}
    _v_res1 = _ve_name;
  }
_block1: {}
RF_END

RF_FUNC (Canonical_m_Word, (RF_ARG _ve_value;;), (RF_RES _v_res1;;))
  {
    {
      if (!RF_CALL (Table::In_m_Table_q_, (rfp__helper::RFP_m_Options, _c_105), /*void*/))
      {
        goto _block1__branch1;
      }
      Expr _ge_auxcall1;
      RF_CALL (Convert::To_m_Upper, _ve_value, _ge_auxcall1);
      RF_TAILCALL (Convert::To_m_Word, _ge_auxcall1, _v_res1);
      goto _block1;
    }
  _block1__branch1: {}
    RF_TAILCALL (Convert::To_m_Word, _ve_value, _v_res1);
  }
_block1: {}
RF_END

RF_FUNC (Pragma, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  if (_ge_arg1.get_len () != 4)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_ge_arg1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_ge_arg1.symbol_at ((0 + 1)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_ge_arg1.symbol_at ((0 + 1 + 1)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_ge_arg1.symbol_at ((0 + 1 + 1 + 1)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _vs_idx (_ge_arg1, 0, 1);
  Expr _vs__e__e_tmp_m_rfp__parserf_m_822_m_15 (_ge_arg1, (0 + 1), 1);
  Expr _vs_line (_ge_arg1, (0 + 1 + 1), 1);
  Expr _vs_col (_ge_arg1, (0 + 1 + 1 + 1), 1);
  Expr _ge_auxcall1;
  RF_CALL (rfp__src::RFP_m_Source_m_File_m_Name, _vs_idx, _ge_auxcall1);
  _v_res1 = ((_c_144 + _ge_auxcall1) () + (_c_145 + _vs_line + _vs_col) ());
RF_END

}

namespace rfp__parse
{

static void init_ ()
{
  Module_m_Name_m_Box = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Module-Name-Box");
  Saved_m_Position = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Saved-Position");
  Unget_m_Stack = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Unget-Stack");
  Constants = new rftype::StaticObject<rftype::Table>(L"Constants");
  Names = new rftype::StaticObject<rftype::Table>(L"Names");
  Traceall_q_ = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Traceall?");
  _c_89 = Expr::create<rftype::Word>("WORD") + Expr::create<rftype::Word>("QWORD") + Expr::create<rftype::Word>("SEMICOLON") + Expr::create<rftype::Word>("COMMA");
  _c_0 = Expr (_c_89, 3, 1);
  _c_1 = Expr::create<rftype::Word>("','");
  _c_132 = Expr::create<rftype::Word>("DCOLON") + Expr::create<rftype::Word>("ITER") + Expr::create<rftype::Word>("COLON") + Expr::create<rftype::Word>("EMPTY");
  _c_2 = Expr (_c_132, 2, 1);
  _c_3 = Expr::create<rftype::Word>("':'");
  _c_4 = Expr (_c_132, 0, 1);
  _c_5 = Expr::create<rftype::Word>("'::'");
  _c_71 = Expr::create<rftype::Word>("SEMICOLON") + Expr::create<rftype::Word>("EMPTY");
  _c_6 = Expr (_c_71, 0, 1);
  _c_7 = Expr::create<rftype::Word>("';'");
  _c_137 = Expr::create<rftype::Word>("SYMBOLS") + Expr::create<rftype::Word>("NUMBER") + Expr::create<rftype::Word>("WORD") + Expr::create<rftype::Word>("QWORD") + Expr::create<rftype::Word>("REF") + Expr::create<rftype::Word>("LPAREN") + Expr::create<rftype::Word>("EVAR") + Expr::create<rftype::Word>("VVAR") + Expr::create<rftype::Word>("TVAR") + Expr::create<rftype::Word>("SVAR") + Expr::create<rftype::Word>("LBRACKET") + Expr::create<rftype::Word>("LBRACE") + Expr::create<rftype::Word>("TLBRACE") + Expr::create<rftype::Word>("EMPTY");
  _c_117 = Expr (_c_137, 11, 3);
  _c_8 = Expr (_c_117, 0, 1);
  _c_9 = Expr::create<rftype::Word>("'{'");
  _c_118 = Expr::create<rftype::Word>("RBRACE") + Expr::create<rftype::Word>("EMPTY");
  _c_10 = Expr (_c_118, 0, 1);
  _c_11 = Expr::create<rftype::Word>("'}'");
  _c_12 = Expr (_c_137, 10, 1);
  _c_13 = Expr::create<rftype::Word>("'<'");
  _c_14 = Expr::create<rftype::Word>("RBRACKET");
  _c_15 = Expr::create<rftype::Word>("'>'");
  _c_85 = Expr::create<rftype::Word>("REF") + Expr::create<rftype::Word>("SYMBOLS") + Expr::create<rftype::Word>("NUMBER") + Expr::create<rftype::Word>("WORD") + Expr::create<rftype::Word>("QWORD") + Expr::create<rftype::Word>("LPAREN") + Expr::create<rftype::Word>("EMPTY");
  _c_16 = Expr (_c_85, 5, 1);
  _c_17 = Expr::create<rftype::Word>("'('");
  _c_18 = Expr::create<rftype::Word>("RPAREN");
  _c_19 = Expr::create<rftype::Word>("')'");
  _c_20 = Expr (_c_85, 0, 1);
  _c_21 = Expr::create<rftype::Word>("'&'");
  _c_122 = Expr::create<rftype::Word>("COMMA") + Expr::create<rftype::Word>("NOT") + Expr::create<rftype::Word>("STAKE") + Expr::create<rftype::Word>("CUT") + Expr::create<rftype::Word>("FAIL") + Expr::create<rftype::Word>("EQUAL") + Expr::create<rftype::Word>("ERROR") + Expr::create<rftype::Word>("TRAP") + Expr::create<rftype::Word>("EMPTY");
  _c_22 = Expr (_c_122, 1, 1);
  _c_23 = Expr::create<rftype::Word>("'#'");
  _c_24 = Expr (_c_122, 5, 1);
  _c_25 = Expr::create<rftype::Word>("'='");
  _c_69 = Expr::create<rftype::Word>("BOX") + Expr::create<rftype::Word>("TABLE") + Expr::create<rftype::Word>("VECTOR") + Expr::create<rftype::Word>("STRING") + Expr::create<rftype::Word>("CHANNEL") + Expr::create<rftype::Word>("CONST") + Expr::create<rftype::Word>("WORD") + Expr::create<rftype::Word>("QWORD") + Expr::create<rftype::Word>("FUNC") + Expr::create<rftype::Word>("FUNC?") + Expr::create<rftype::Word>("TFUNC") + Expr::create<rftype::Word>("EXTERN") + Expr::create<rftype::Word>("USE") + Expr::create<rftype::Word>("TRACE") + Expr::create<rftype::Word>("TRACEALL") + Expr::create<rftype::Word>("EOF");
  _c_26 = Expr (_c_69, 15, 1);
  _c_27 = Expr::create<rftype::Word>("end of file");
  _c_99 = Expr::create<rftype::Word>("EVAR") + Expr::create<rftype::Word>("VVAR") + Expr::create<rftype::Word>("EMPTY");
  _c_28 = Expr (_c_99, 0, 1);
  _c_29 = Expr::create<rftype::Word>("e-variable");
  _c_30 = Expr (_c_99, 1, 1);
  _c_31 = Expr::create<rftype::Word>("v-variable");
  _c_100 = Expr::create<rftype::Word>("LPAREN") + Expr::create<rftype::Word>("SYMBOLS") + Expr::create<rftype::Word>("NUMBER") + Expr::create<rftype::Word>("WORD") + Expr::create<rftype::Word>("QWORD") + Expr::create<rftype::Word>("SVAR") + Expr::create<rftype::Word>("TVAR") + Expr::create<rftype::Word>("EMPTY") + Expr::create<rftype::Word>("REF");
  _c_32 = Expr (_c_100, 6, 1);
  _c_33 = Expr::create<rftype::Word>("t-variable");
  _c_34 = Expr (_c_100, 5, 1);
  _c_35 = Expr::create<rftype::Word>("s-variable");
  _c_36 = Expr (_c_69, 0, 1);
  _c_37 = Expr::create<rftype::Word>("$box");
  _c_38 = Expr (_c_69, 1, 1);
  _c_39 = Expr::create<rftype::Word>("$table");
  _c_40 = Expr (_c_69, 2, 1);
  _c_41 = Expr::create<rftype::Word>("$vector");
  _c_42 = Expr (_c_69, 3, 1);
  _c_43 = Expr::create<rftype::Word>("$string");
  _c_44 = Expr (_c_69, 8, 1);
  _c_45 = Expr::create<rftype::Word>("$func");
  _c_46 = Expr (_c_69, 9, 1);
  _c_47 = Expr::create<rftype::Word>("$func?");
  _c_48 = Expr (_c_69, 10, 1);
  _c_49 = Expr::create<rftype::Word>("$tfunc");
  _c_50 = Expr (_c_69, 11, 1);
  _c_51 = Expr::create<rftype::Word>("$extern");
  _c_52 = Expr (_c_69, 4, 1);
  _c_53 = Expr::create<rftype::Word>("$channel");
  _c_54 = Expr (_c_69, 12, 1);
  _c_55 = Expr::create<rftype::Word>("$use");
  _c_56 = Expr (_c_69, 13, 1);
  _c_57 = Expr::create<rftype::Word>("$trace");
  _c_58 = Expr (_c_69, 14, 1);
  _c_59 = Expr::create<rftype::Word>("$traceall");
  _c_60 = Expr::create<rftype::Word>("token ");
  _c_61 = Expr::create<rftype::Word>("T");
  _c_62 = Expr (_c_71, 1, 1);
  _c_63 = Expr::create<rftype::Word>("Unexpected ");
  _c_64 = Expr::create<rftype::Word>("F");
  _c_65 = Expr::create<rftype::Integer>("1");
  _c_66 = Expr::create<rftype::Word>("INTERFACE");
  _c_67 = Expr::create<rftype::Word>("MODULE");
  _c_68 = rftype::Char::create_expr (L".rfi");
  _c_70 = Expr (_c_69, 5, 1);
  _c_72 = Expr (_c_69, 6, 1);
  _c_73 = Expr (_c_69, 7, 1);
  _c_112 = Expr::create<rftype::Word>("FUNC") + Expr::create<rftype::Word>("LOCAL") + (empty) () + (empty) ();
  _c_74 = Expr (_c_112, 1, 1);
  _c_146 = (_c_28) ();
  _c_114 = Expr::create<rftype::Word>("FUNC") + Expr::create<rftype::Word>("EXPORT") + (empty) () + (_c_146) ();
  _c_75 = Expr (_c_114, 1, 1);
  _c_76 = Expr::create<rftype::Word>("'");
  _c_77 = Expr::create<rftype::Word>("No defenition for the function '");
  _c_78 = Expr::create<rftype::Word>("PRAGMA");
  _c_79 = Expr::create<rftype::Word>("UNDEF");
  _c_80 = Expr (_c_89, 0, 3);
  _c_81 = (_c_6) ();
  _c_82 = Expr::create<rftype::Word>("S");
  _c_83 = Expr::create<rftype::Word>("IMPORT");
  _c_84 = Expr (_c_68, 0, 1);
  _c_86 = Expr (_c_85, 1, 1);
  _c_87 = Expr (_c_85, 2, 1);
  _c_88 = Expr::create<rftype::Word>("PAREN");
  _c_90 = Expr::create<rftype::Word>("' do exist");
  _c_91 = Expr::create<rftype::Word>("' and '");
  _c_92 = Expr::create<rftype::Word>("' - both '");
  _c_93 = Expr::create<rftype::Word>("Ambiguous name '");
  _c_94 = Expr::create<rftype::Word>("',");
  _c_95 = Expr::create<rftype::Word>("Redeclaration of '");
  _c_96 = Expr::create<rftype::Word>("  previously declared here");
  _c_97 = Expr::create<rftype::Word>("FUNC?") + Expr::create<rftype::Word>("EXTERN") + (_c_146) () + (_c_146) ();
  _c_98 = Expr (_c_80, 0, 2);
  _c_101 = Expr::create<rftype::Word>("' is not a function,");
  _c_102 = Expr::create<rftype::Word>("' is declared here as ");
  _c_103 = Expr::create<rftype::Word>("  '");
  _c_104 = rftype::Char::create_expr (L"Main");
  _c_105 = Expr::create<rftype::Word>("CASE-INSENSITIVE");
  _c_106 = rftype::Char::create_expr (L"MAIN");
  _c_107 = Expr::create<rftype::Word>("Undefined name '");
  _c_108 = Expr::create<rftype::Integer>("0");
  _c_109 = Expr::create<rftype::Word>("Def");
  _c_110 = Expr::create<rftype::Word>("Redefenition of function '");
  _c_111 = Expr::create<rftype::Word>("  previously defined here");
  _c_113 = Expr (_c_114, 2, 1);
  _c_115 = Expr (_c_114, 3, 1);
  _c_116 = Expr::create<rftype::Word>("BRANCH");
  _c_119 = Expr::create<rftype::Word>("LEFT");
  _c_120 = Expr::create<rftype::Word>("BLOCK");
  _c_121 = Expr::create<rftype::Word>("BLOCK?");
  _c_123 = Expr (_c_122, 2, 1);
  _c_124 = Expr (_c_122, 3, 1);
  _c_125 = Expr (_c_122, 4, 1);
  _c_126 = Expr::create<rftype::Word>("CUTALL");
  _c_127 = Expr (_c_122, 6, 1);
  _c_128 = Expr (_c_122, 7, 1);
  _c_129 = Expr::create<rftype::Word>("WITH");
  _c_130 = Expr::create<rftype::Word>("TRY");
  _c_131 = Expr::create<rftype::Word>("RESULT");
  _c_133 = Expr::create<rftype::Word>("FORMAT");
  _c_134 = Expr (_c_132, 1, 1);
  _c_135 = Expr (_c_132, 2, 2);
  _c_136 = Expr (_c_117, 1, 1);
  _c_138 = Expr::create<rftype::Word>("' is not a function");
  _c_139 = Expr::create<rftype::Word>("CALL");
  _c_140 = Expr::create<rftype::Word>("L") + Expr::create<rftype::Word>("R") + Expr::create<rftype::Word>("EMPTY");
  _c_141 = Expr (_c_140, 1, 1);
  _c_142 = Expr::create<rftype::Word>("RIGHT");
  _c_143 = Expr::create<rftype::Word>("SYMBOLS") + Expr::create<rftype::Word>("NUMBER") + Expr::create<rftype::Word>("WORD") + Expr::create<rftype::Word>("QWORD") + Expr::create<rftype::Word>("REF") + Expr::create<rftype::Word>("LPAREN") + Expr::create<rftype::Word>("EVAR") + Expr::create<rftype::Word>("VVAR") + Expr::create<rftype::Word>("TVAR") + Expr::create<rftype::Word>("SVAR") + Expr::create<rftype::Word>("EMPTY");
  _c_144 = Expr::create<rftype::Word>("FILE");
  _c_145 = Expr::create<rftype::Word>("LINE");
}

static AtStart init_registrator_ (&init_);

}

}
