#include <rf_core.hh>
#include <refal/Arithm.hh>
#include <refal/Apply.hh>
#include <refal/File.hh>
#include <refal/Table.hh>
#include <refal/StdIO.hh>
#include <refal/Box.hh>

namespace refal
{

using namespace rfrt;

namespace rfp__src
{

Expr RFP_m_Sources;

RF_DECL (RFP_m_Src_m_Open_m_File);

RF_DECL (RFP_m_Src_m_Close);

RF_DECL (RFP_m_Src_m_Open_m_StdIN);

RF_DECL (RFP_m_Get_m_Line_m_From_m_File);

RF_DECL (RFP_m_Get_m_Line_m_From_m_StdIN);

RF_DECL (RFP_m_Src_m_Get_m_Line);

RF_DECL (RFP_m_Next_m_Row);

RF_DECL (RFP_m_Next_m_Column);

RF_DECL (RFP_m_Source_m_File_m_Name);

RF_DECL (RFP_m_Dir_m_Name);

RF_DECL (RFP_m_File_m_Name);

RF_DECL (RFP_m_Module_m_Name);

static Expr _c_0;

static Expr _c_1;

static Expr _c_2;

static Expr _c_4;

static Expr _c_3;

static Expr _c_5;

static Expr _c_6;

RF_FUNC (RFP_m_Src_m_Open_m_File, (RF_ARG _ve_filename;;), (RF_RES _v_res1;;))
  Expr _vs_chl;
  RF_CALL (StdIO::Channel, /*void*/, _vs_chl);
  if (!RF_CALL (StdIO::Open_m_File, (_vs_chl, _ve_filename, _c_0), /*void*/))
  {
    RF_RETFAIL;
  }
  _v_res1 = (_c_1 + _ve_filename () + _vs_chl ());
RF_END

RF_FUNC (RFP_m_Src_m_Close, (RF_ARG _ge_arg1;;), RF_VOID)
  if (_ge_arg1.get_len () != 4)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (_ge_arg1.symbol_at ((0 + 1 + 1)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (_ge_arg1.symbol_at ((0 + 1 + 1 + 1)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _v_deref__arg1 (_ge_arg1, (0 + 1 + 1));
  Expr _v_deref__arg12 (_ge_arg1, (0 + 1 + 1 + 1));
  uintptr_t _v_len1 = _v_deref__arg12.get_len ();
  uintptr_t _v_len2 = 0;
  if (_v_len1 < _v_len2)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len__src = (_v_len1 - _v_len2);
  uintptr_t _v_len3 = _v_deref__arg1.get_len ();
  uintptr_t _v_len4 = 0;
  if (_v_len3 < _v_len4)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len__name = (_v_len3 - _v_len4);
  if (!_ge_arg1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_ge_arg1.symbol_at ((0 + 1)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _vs_srctype (_ge_arg1, 0, 1);
  Expr _vs_getline_m_func (_ge_arg1, (0 + 1), 1);
  Expr _ve_name (_v_deref__arg1, 0, _v_len__name);
  Expr _ve_src (_v_deref__arg12, 0, _v_len__src);
  {
    {
      if (!_vs_srctype.term_eq (_c_2, 0))
      {
        goto _block1__branch1;
      }
      if (_v_len__src != 1)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      if (!_ve_src.symbol_at (0))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      Expr _vs_channel (_ve_src, 0, 1);
      RF_TAILCALL (StdIO::Close_m_Channel, _vs_channel, /*void*/);
      goto _block1;
    }
  _block1__branch1: {}
    if (!_vs_srctype.term_eq (_c_3, 0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
  }
_block1: {}
RF_END

RF_FUNC (RFP_m_Src_m_Open_m_StdIN, RF_VOID, (RF_RES _v_res1;;))
  _v_res1 = _c_4;
RF_END

RF_FUNC (RFP_m_Get_m_Line_m_From_m_File, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  if (_ge_arg1.get_len () != 1)
  {
    RF_RETFAIL;
  }
  if (!_ge_arg1.symbol_at (0))
  {
    RF_RETFAIL;
  }
  Expr _vs_channel (_ge_arg1, 0, 1);
  RF_TAILCALL (StdIO::Read_m_Line_e_, _vs_channel, _v_res1);
RF_END

RF_FUNC (RFP_m_Get_m_Line_m_From_m_StdIN, (RF_ARG _ve__e__e_tmp_m_rfp__srcrf_m_48_m_26;;), (RF_RES _v_res1;;))
  RF_TAILCALL (StdIO::Read_m_Line, /*void*/, _v_res1);
RF_END

RF_FUNC (RFP_m_Src_m_Get_m_Line, (RF_ARG _ve_source;;), (RF_RES _v_res1;;))
  if (_ve_source.get_len () != 4)
  {
    RF_RETFAIL;
  }
  if (_ve_source.symbol_at ((0 + 1 + 1)))
  {
    RF_RETFAIL;
  }
  if (_ve_source.symbol_at ((0 + 1 + 1 + 1)))
  {
    RF_RETFAIL;
  }
  Expr _v_deref__source (_ve_source, (0 + 1 + 1));
  Expr _v_deref__source2 (_ve_source, (0 + 1 + 1 + 1));
  uintptr_t _v_len1 = _v_deref__source2.get_len ();
  uintptr_t _v_len2 = 0;
  if (_v_len1 < _v_len2)
  {
    RF_RETFAIL;
  }
  uintptr_t _v_len__src = (_v_len1 - _v_len2);
  uintptr_t _v_len3 = _v_deref__source.get_len ();
  uintptr_t _v_len4 = 0;
  if (_v_len3 < _v_len4)
  {
    RF_RETFAIL;
  }
  uintptr_t _v_len__name = (_v_len3 - _v_len4);
  if (!_ve_source.symbol_at (0))
  {
    RF_RETFAIL;
  }
  if (!_ve_source.symbol_at ((0 + 1)))
  {
    RF_RETFAIL;
  }
  Expr _vs_srctype (_ve_source, 0, 1);
  Expr _vs_getline_m_func (_ve_source, (0 + 1), 1);
  Expr _ve_name (_v_deref__source, 0, _v_len__name);
  Expr _ve_src (_v_deref__source2, 0, _v_len__src);
  RF_TAILCALL (Apply::Apply, (_vs_getline_m_func, _ve_src), _v_res1);
RF_END

RF_FUNC (RFP_m_Next_m_Row, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  if (_ge_arg1.get_len () != 2)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_ge_arg1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_ge_arg1.symbol_at ((0 + 1)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _vs_row (_ge_arg1, 0, 1);
  Expr _vs_col (_ge_arg1, (0 + 1), 1);
  Expr _gs_auxcall1;
  RF_CALL (Arithm::_p_, (_vs_row, _c_5), _gs_auxcall1);
  _v_res1 = (_gs_auxcall1 + _c_5);
RF_END

RF_FUNC (RFP_m_Next_m_Column, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  if (_ge_arg1.get_len () != 2)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_ge_arg1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_ge_arg1.symbol_at ((0 + 1)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _vs_row (_ge_arg1, 0, 1);
  Expr _vs_col (_ge_arg1, (0 + 1), 1);
  Expr _v__p_1;
  RF_CALL (Arithm::_p_, (_vs_col, _c_5), _v__p_1);
  _v_res1 = (_vs_row + _v__p_1);
RF_END

RF_FUNC (RFP_m_Source_m_File_m_Name, (RF_ARG _vs_idx;;), (RF_RES _v_res1;;))
  if (!RF_CALL (Table::Lookup, (RFP_m_Sources, _vs_idx), _v_res1))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
RF_END

RF_FUNC (RFP_m_Dir_m_Name, (RF_ARG _ve_f;;), (RF_RES _v_res1;;))
  Expr _v__q_1;
  RF_CALL (Box::_q_, File::Dir_m_Separator, _v__q_1);
  if (_v__q_1.get_len () != 1)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_v__q_1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _vs_dir_m_separator (_v__q_1, 0, 1);
  {
    {
      if (_ve_f.get_len () < 1)
      {
        goto _block1__branch1;
      }
      RF_rsplit (_ve_f, 0, _v_rsplit__f, _ve__e__e_tmp_m_rfp__srcrf_m_67_m_38);
      for ( ; ; RF_iter(_ve_f)--)
      {
        {
          if (!RF_iter(_ve_f))
          {
            goto _block1__branch1;
          }
          uintptr_t _v_len1 = _v_rsplit__f.get_len ();
          uintptr_t _v_len2 = 1;
          if (_v_len1 < _v_len2)
          {
            goto _block1__branch1;
          }
          uintptr_t _v_len__base = (_v_len1 - _v_len2);
          if (!_vs_dir_m_separator.term_eq (_v_rsplit__f, (0 + _v_len__base)))
          {
            goto _continue1;
          }
          Expr _ve_base (_v_rsplit__f, 0, _v_len__base);
          _v_res1 = _ve_base;
          goto _exit1;
        }
    _continue1: {}
      }
    _exit1: {}
      goto _block1;
    }
  _block1__branch1: {}
    _v_res1 = _c_6;
  }
_block1: {}
RF_END

RF_FUNC (RFP_m_File_m_Name, (RF_ARG _ve_f;;), (RF_RES _v_res1;;))
  Expr _v__q_1;
  RF_CALL (Box::_q_, File::Dir_m_Separator, _v__q_1);
  if (_v__q_1.get_len () != 1)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_v__q_1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _vs_dir_m_separator (_v__q_1, 0, 1);
  {
    {
      if (_ve_f.get_len () < 1)
      {
        goto _block1__branch1;
      }
      RF_rsplit (_ve_f, 0, _v_rsplit__f, _ve_file);
      for ( ; ; RF_iter(_ve_f)--)
      {
        {
          if (!RF_iter(_ve_f))
          {
            goto _block1__branch1;
          }
          uintptr_t _v_len1 = _v_rsplit__f.get_len ();
          uintptr_t _v_len2 = 1;
          if (_v_len1 < _v_len2)
          {
            goto _block1__branch1;
          }
          uintptr_t _v_len___e__e_tmp_m_rfp__srcrf_m_74_m_15 = (_v_len1 - _v_len2);
          if (!_vs_dir_m_separator.term_eq (_v_rsplit__f, (0 + _v_len___e__e_tmp_m_rfp__srcrf_m_74_m_15)))
          {
            goto _continue1;
          }
          Expr _ve__e__e_tmp_m_rfp__srcrf_m_74_m_15 (_v_rsplit__f, 0, _v_len___e__e_tmp_m_rfp__srcrf_m_74_m_15);
          _v_res1 = _ve_file;
          goto _exit1;
        }
    _continue1: {}
      }
    _exit1: {}
      goto _block1;
    }
  _block1__branch1: {}
    _v_res1 = _ve_f;
  }
_block1: {}
RF_END

RF_FUNC (RFP_m_Module_m_Name, (RF_ARG _ve_path;;), (RF_RES _v_res1;;))
  Expr _ve_file;
  RF_CALL (RFP_m_File_m_Name, _ve_path, _ve_file);
  {
    {
      if (_ve_file.get_len () < 1)
      {
        goto _block1__branch1;
      }
      RF_rsplit (_ve_file, 0, _v_rsplit__file, _ve__e__e_tmp_m_rfp__srcrf_m_81_m_31);
      for ( ; ; RF_iter(_ve_file)--)
      {
        {
          if (!RF_iter(_ve_file))
          {
            goto _block1__branch1;
          }
          uintptr_t _v_len1 = _v_rsplit__file.get_len ();
          uintptr_t _v_len2 = 1;
          if (_v_len1 < _v_len2)
          {
            goto _block1__branch1;
          }
          uintptr_t _v_len__module = (_v_len1 - _v_len2);
          if (!_c_6.term_eq (_v_rsplit__file, (0 + _v_len__module)))
          {
            goto _continue1;
          }
          Expr _ve_module (_v_rsplit__file, 0, _v_len__module);
          _v_res1 = _ve_module;
          goto _exit1;
        }
    _continue1: {}
      }
    _exit1: {}
      goto _block1;
    }
  _block1__branch1: {}
    _v_res1 = _ve_file;
  }
_block1: {}
RF_END

}

namespace rfp__src
{

static void init_ ()
{
  RFP_m_Sources = new rftype::StaticObject<rftype::Table>(L"RFP-Sources");
  _c_0 = Expr::create<rftype::Word>("r");
  _c_1 = Expr::create<rftype::Word>("FILE") + Expr::create_sym<rftype::Func> (RFP_m_Get_m_Line_m_From_m_File);
  _c_2 = Expr (_c_1, 0, 1);
  _c_4 = Expr::create<rftype::Word>("STDIN") + Expr::create_sym<rftype::Func> (RFP_m_Get_m_Line_m_From_m_File) + (rftype::Char::create_expr (L"StdIN")) () + (empty) ();
  _c_3 = Expr (_c_4, 0, 1);
  _c_5 = Expr::create<rftype::Integer>("1");
  _c_6 = rftype::Char::create_expr (L".");
}

static AtStart init_registrator_ (&init_);

}

}
