// $Source$
// $Revision: 2187 $
// $Date: 2006-12-15 03:17:56 +0300 (Fri, 15 Dec 2006) $
// $Author: orlov $

#include <rf_core.hh>
#include <rf_integer.ih>

#ifndef RFRT_WITHOUT_GMP

namespace refal
{

using namespace rfrt;
using namespace rftype;

namespace Arithm
{

RF_FUNC (_a_, (RF_ARG s_Int1, s_Int2;;), (RF_RES s_Res;;))

  Term* p_Int1 = s_Int1.get_first();
  Term* p_Int2 = s_Int2.get_first();

  if (p_Int1->get_type() == type_int) {
    Integer* i1 = static_cast<Integer*>(p_Int1);
    if (p_Int2->get_type() == type_int) {
      Integer* i2 = static_cast<Integer*>(p_Int2);
      s_Res = Integer::create_mult(*i1, *i2);
    } else {
      RF_LIB_ERROR("Invalid argument");
    }
  } else {
    RF_LIB_ERROR("Invalid argument");
  }
RF_END
}

}

#endif // !defined RFRT_WITHOUT_GMP
