// $Id: open_dir.cc 2187 2006-12-15 00:17:56Z orlov $

#include <rf_core.hh>
#include "lib_error.hh"
#include "dir_symbol.hh"

namespace refal
{

using namespace rfrt;

namespace Dir
{

RF_FUNC (Open_m_Dir, (RF_ARG _name;;), (RF_RES _dir;;))
  WString wname = WString(_name);
  size_t len = wcstombs(null, wname.get_data(), 0);
  if (len == (size_t)(-1))
  {
    RF_LIB_ERROR (L"Invalid argument");
  }
  char* name = static_cast<char*>(alloca(len + 1));
  wcstombs(name, wname.get_data(), len + 1);
  name[len] = 0;
  try
  {
    _dir = Expr::create_sym<rftype::Dir>(name);
  }
  catch (pxx::SysError const& err)
  {
    throw_rf_error(L"Open-Dir", err.get_code());
  }
RF_END

}

}
