#include <rf_core.hh>
#include <refal/Arithm.hh>
#include <refal/Class.hh>
#include <refal/Convert.hh>
#include <refal/Compare.hh>
#include <refal/Table.hh>
#include "../Stream/StreamErr.hh"
#include "../Stream/Stream.hh"
#include "../Lexer/Lexer.hh"
#include <refal/Error.hh>
#include <refal/Box.hh>
#include "StdIO.hh"

namespace refal
{

using namespace rfrt;

namespace StdIO
{

//Expr StdIn;
//
//Expr StdOut;
//
//Expr StdErr;

Expr Read_m_Chunk_m_Size;

static Expr Buffers;

RF_DECL (Open_m_File);

RF_DECL (Close_m_Channel);

RF_DECL (EOF_q_);

RF_DECL (Read_m_Char_e_);

RF_DECL (Read_m_Char);

RF_DECL (Read_m_Line_e_);

RF_DECL (Read_m_Line);

RF_DECL (Read_e_);

RF_DECL (Read);

RF_DECL (Read_m_Main);

RF_DECL (Print);

RF_DECL (Write);

RF_DECL (Print_e_);

RF_DECL (Flush_e_);

RF_DECL (Write_e_);

RF_DECL (PrintLN);

RF_DECL (PrintLN_e_);

RF_DECL (WriteLN);

RF_DECL (Prim_m_Read);

RF_DECL (WriteLN_e_);

RF_DECL (Prim_m_Open_m_File);

RF_DECL (Prim_m_Close_m_Channel);

RF_DECL (Parse_m_File_m_Name);

RF_DECL (Erase_m_File);

RF_DECL (Channel);

RF_DECL (Prim_m_Read__0);

static Expr _c_0;

static Expr _c_1;

static Expr _c_2;

static Expr _c_3;

static Expr _c_4;

static Expr _c_5;

static Expr _c_6;

static Expr _c_7;

static Expr _c_8;

static Expr _c_9;

static Expr _c_10;

static Expr _c_11;

static Expr _c_12;

static Expr _c_13;

static Expr _c_14;

static Expr _c_15;

RF_FUNC (Open_m_File, (RF_ARG _vs_channel, _ve_file, _vs_mode;;), RF_VOID)
  {
    {
      {
        if (!RF_CALL (Class::Channel_q_, _vs_channel, /*void*/))
        {
          goto _negation1;
        }
        goto _block1__branch1;
      }
    _negation1: {}
      RF_TAILCALL (Error::Lib_m_Error, (_c_0, _c_1), /*void*/);
      goto _block1;
    }
  _block1__branch1: {}
    {
      {
        if (!RF_CALL (Class::Word_q_, _vs_mode, /*void*/))
        {
          goto _negation2;
        }
        goto _block1__branch2;
      }
    _negation2: {}
      RF_TAILCALL (Error::Lib_m_Error, (_c_0, _c_2), /*void*/);
      goto _block1;
    }
  _block1__branch2: {}
    if (!RF_CALL (Prim_m_Open_m_File, (_vs_channel, _ve_file, _vs_mode), /*void*/))
    {
      RF_RETFAIL;
    }
    Expr _v_Stream1;
    RF_CALL (Stream::Stream, (_c_3, (_vs_channel + Read_m_Chunk_m_Size)), _v_Stream1);
    RF_TAILCALL (Table::Bind, (Buffers, _vs_channel, _v_Stream1), /*void*/);
  }
_block1: {}
RF_END

RF_FUNC (Close_m_Channel, (RF_ARG _vs_channel;;), RF_VOID)
  {
    {
      {
        if (!RF_CALL (Class::Channel_q_, _vs_channel, /*void*/))
        {
          goto _negation1;
        }
        goto _block1__branch1;
      }
    _negation1: {}
      RF_TAILCALL (Error::Lib_m_Error, (_c_4, _c_1), /*void*/);
      goto _block1;
    }
  _block1__branch1: {}
    RF_CALL (Prim_m_Close_m_Channel, _vs_channel, /*void*/);
    RF_TAILCALL (Table::Unbind, (Buffers, _vs_channel), /*void*/);
  }
_block1: {}
RF_END

RF_FUNC (EOF_q_, (RF_ARG _vs_channel;;), RF_VOID)
  {
    {
      Expr _v_Lookup1;
      if (!RF_CALL (Table::Lookup, (Buffers, _vs_channel), _v_Lookup1))
      {
        goto _block1__branch1;
      }
      if ((_v_Lookup1.get_len () != 1))
      {
        goto _block1__branch1;
      }
      if (!_v_Lookup1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _vs_tream (_v_Lookup1, 0, 1);
      RF_TAILCALL (Stream::End_m_of_m_Stream_q_, _vs_tream, /*void*/);
      goto _block1;
    }
  _block1__branch1: {}
    RF_TAILCALL (Error::Lib_m_Error, (_c_5, _c_6), /*void*/);
  }
_block1: {}
RF_END

RF_FUNC (Read_m_Char_e_, (RF_ARG _vs_channel;;), (RF_RES _v_res1;;))
  {
    {
      Expr _v_Lookup1;
      if (!RF_CALL (Table::Lookup, (Buffers, _vs_channel), _v_Lookup1))
      {
        goto _block1__branch1;
      }
      if ((_v_Lookup1.get_len () != 1))
      {
        goto _block1__branch1;
      }
      if (!_v_Lookup1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _vs_tream (_v_Lookup1, 0, 1);
      Expr _v_Getc1;
      if (!RF_CALL (Stream::Getc, _vs_tream, _v_Getc1))
      {
        RF_RETFAIL;
      }
      if ((1 != 1))
      {
        RF_RETFAIL;
      }
      if (!_v_Getc1.symbol_at (0))
      {
        RF_RETFAIL;
      }
      Expr _vs_char (_v_Getc1, 0, 1);
      _v_res1 = _vs_char;
      goto _block1;
    }
  _block1__branch1: {}
    RF_CALL (Error::Lib_m_Error, (_c_7, _c_6), /*void*/);
    RF_RETFAIL;
  }
_block1: {}
RF_END

RF_FUNC (Read_m_Char, RF_VOID, (RF_RES _v_res1;;))
  RF_TAILCALL (Read_m_Char_e_, StdIn, _v_res1);
RF_END

RF_FUNC (Read_m_Line_e_, (RF_ARG _vs_channel;;), (RF_RES _v_res1;;))
  {
    {
      Expr _v_Lookup1;
      if (!RF_CALL (Table::Lookup, (Buffers, _vs_channel), _v_Lookup1))
      {
        goto _block1__branch1;
      }
      if ((_v_Lookup1.get_len () != 1))
      {
        goto _block1__branch1;
      }
      if (!_v_Lookup1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _vs_tream (_v_Lookup1, 0, 1);
      Expr _v_Get_m_Line1;
      RF_CALL (Stream::Get_m_Line, _vs_tream, _v_Get_m_Line1);
      {
        {
          uintptr_t _v_len1 = _v_Get_m_Line1.get_len ();
          uintptr_t _v_len2 = (1 + 1);
          if (((_v_len1 < (_v_len2 + (0 * 1)))))
          {
            goto _block2__branch1;
          }
          if (((_v_len1 - _v_len2) % 1))
          {
            goto _block2__branch1;
          }
          uintptr_t _v_len__line = ((_v_len1 - _v_len2) / 1);
          if (!_c_8.eq (_v_Get_m_Line1, (0 + _v_len__line)))
          {
            goto _block2__branch1;
          }
          Expr _ve_line (_v_Get_m_Line1, 0, _v_len__line);
          _v_res1 = _ve_line;
          goto _block2;
        }
      _block2__branch1: {}
        {
          uintptr_t _v_len3 = _v_Get_m_Line1.get_len ();
          uintptr_t _v_len4 = 1;
          if (((_v_len3 < (_v_len4 + (0 * 1)))))
          {
            goto _block2__branch2;
          }
          if (((_v_len3 - _v_len4) % 1))
          {
            goto _block2__branch2;
          }
          uintptr_t _v_len__line2 = ((_v_len3 - _v_len4) / 1);
          if (!_c_9.term_eq (_v_Get_m_Line1, (0 + _v_len__line2)))
          {
            goto _block2__branch2;
          }
          Expr _ve_line (_v_Get_m_Line1, 0, _v_len__line2);
          _v_res1 = _ve_line;
          goto _block2;
        }
      _block2__branch2: {}
        {
          uintptr_t _v_len5 = _v_Get_m_Line1.get_len ();
          uintptr_t _v_len6 = 1;
          if (((_v_len5 < (_v_len6 + (0 * 1)))))
          {
            goto _block2__branch3;
          }
          if (((_v_len5 - _v_len6) % 1))
          {
            goto _block2__branch3;
          }
          uintptr_t _v_len__line3 = ((_v_len5 - _v_len6) / 1);
          if (!_c_10.term_eq (_v_Get_m_Line1, (0 + _v_len__line3)))
          {
            goto _block2__branch3;
          }
          Expr _ve_line (_v_Get_m_Line1, 0, _v_len__line3);
          _v_res1 = _ve_line;
          goto _block2;
        }
      _block2__branch3: {}
        uintptr_t _v_len7 = _v_Get_m_Line1.get_len ();
        uintptr_t _v_len8 = 0;
        if (((_v_len7 < (_v_len8 + (1 * 1)))))
        {
          RF_RETFAIL;
        }
        if (((_v_len7 - _v_len8) % 1))
        {
          RF_RETFAIL;
        }
        uintptr_t _v_len__line4 = ((_v_len7 - _v_len8) / 1);
        Expr _vv_line (_v_Get_m_Line1, 0, _v_len__line4);
        _v_res1 = _vv_line;
      }
    _block2: {}
      goto _block1;
    }
  _block1__branch1: {}
    RF_CALL (Error::Lib_m_Error, (_c_11, _c_6), /*void*/);
    RF_RETFAIL;
  }
_block1: {}
RF_END

RF_FUNC (Read_m_Line, RF_VOID, (RF_RES _v_res1;;))
  RF_TAILCALL (Read_m_Line_e_, StdIn, _v_res1);
RF_END

RF_FUNC (Read_e_, (RF_ARG _vs_channel;;), (RF_RES _v_res1;;))
  RF_TAILCALL (Read_m_Main, (_c_12, _vs_channel), _v_res1);
RF_END

RF_FUNC (Read, RF_VOID, (RF_RES _v_res1;;))
  RF_TAILCALL (Read_m_Main, (_c_13, StdIn), _v_res1);
RF_END

RF_FUNC (Read_m_Main, (RF_ARG _vs_fname, _vs_channel;;), (RF_RES _v_res1;;))
  {
    {
      Expr _v_Lookup1;
      if (!RF_CALL (Table::Lookup, (Buffers, _vs_channel), _v_Lookup1))
      {
        goto _block1__branch1;
      }
      if ((_v_Lookup1.get_len () != 1))
      {
        goto _block1__branch1;
      }
      if (!_v_Lookup1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _vs_tream (_v_Lookup1, 0, 1);
      Expr _ve_result;
      {
        {
          if (!RF_CALL (Lexer::Read_m_Term_q_, _vs_tream, _ve_result))
          {
            goto _block2__branch1;
          }
          goto _block2;
        }
      _block2__branch1: {}
        _ve_result = empty;
      }
    _block2: {}
      {
        {
          Expr _v_Errors1;
          RF_CALL (StreamErr::Errors, /*void*/, _v_Errors1);
          uintptr_t _v_len1 = _v_Errors1.get_len ();
          uintptr_t _v_len2 = 1;
          if (((_v_len1 < (_v_len2 + (0 * 1)))))
          {
            goto _block3__branch1;
          }
          if (((_v_len1 - _v_len2) % 1))
          {
            goto _block3__branch1;
          }
          uintptr_t _v_len___e__e_tmp_m_StdIOrf_m_86_m_46 = ((_v_len1 - _v_len2) / 1);
          if (_v_Errors1.symbol_at (0))
          {
            goto _block3__branch1;
          }
          Expr _v_deref__Errors1 (_v_Errors1, 0);
          if ((_v_deref__Errors1.get_len () != (1 + 1 + 1)))
          {
            goto _block3__branch1;
          }
          if (_v_deref__Errors1.symbol_at ((0 + 1 + 1)))
          {
            goto _block3__branch1;
          }
          Expr _v_deref__deref__Errors1 (_v_deref__Errors1, (0 + 1 + 1));
          uintptr_t _v_len3 = _v_deref__deref__Errors1.get_len ();
          uintptr_t _v_len4 = 0;
          if (((_v_len3 < (_v_len4 + (0 * 1)))))
          {
            goto _block3__branch1;
          }
          if (((_v_len3 - _v_len4) % 1))
          {
            goto _block3__branch1;
          }
          uintptr_t _v_len__message = ((_v_len3 - _v_len4) / 1);
          Expr _ve__e__e_tmp_m_StdIOrf_m_86_m_46 (_v_Errors1, (0 + 1), _v_len___e__e_tmp_m_StdIOrf_m_86_m_46);
          Expr _vt_name (_v_deref__Errors1, 0, 1);
          Expr _vt_pos (_v_deref__Errors1, (0 + 1), 1);
          Expr _ve_message (_v_deref__deref__Errors1, 0, _v_len__message);
          RF_CALL (Error::Lib_m_Error, ((_c_14 + _vs_fname), _ve_message), /*void*/);
          RF_RETFAIL;
          goto _block3;
        }
      _block3__branch1: {}
      }
    _block3: {}
      if ((_ve_result.get_len () != 1))
      {
        RF_RETFAIL;
      }
      Expr _vt_erm (_ve_result, 0, 1);
      _v_res1 = _vt_erm;
      goto _block1;
    }
  _block1__branch1: {}
    RF_CALL (Error::Lib_m_Error, ((_c_14 + _vs_fname), _c_6), /*void*/);
    RF_RETFAIL;
  }
_block1: {}
RF_END

RF_FUNC (Prim_m_Read__0, (RF_ARG _v_arg1;;), (RF_RES _v_res1;;))
  if ((_v_arg1.get_len () != (1 + 1)))
  {
    RF_ERROR (_c_15);
  }
  if (!_v_arg1.symbol_at (0))
  {
    RF_ERROR (_c_15);
  }
  if (!_v_arg1.symbol_at ((0 + 1)))
  {
    RF_ERROR (_c_15);
  }
  Expr _v_stub1 (_v_arg1, 0, 1);
  Expr _v_stub2 (_v_arg1, (0 + 1), 1);
  RF_TAILCALL (Prim_m_Read, (_v_stub1, _v_stub2), _v_res1);
RF_END

}

namespace StdIO
{

static void init_ ()
{
//  StdIn = new rftype::StaticObject<rftype::Channel>(L"StdIn");
//  StdOut = new rftype::StaticObject<rftype::Channel>(L"StdOut");
//  StdErr = new rftype::StaticObject<rftype::Channel>(L"StdErr");
  Read_m_Chunk_m_Size = Expr::create<Integer>("64");
  Buffers = new rftype::StaticObject<rftype::Table>(L"Buffers");
  _c_0 = Expr::create<Word>("StdIO") + Expr::create<Word>("Open-File");
  _c_1 = Expr::create<Word>("Arg 1 is not a Channel");
  _c_2 = Expr::create<Word>("Arg 3 is not a Word");
  _c_3 = Expr::create_sym<Func> (Prim_m_Read__0);
  _c_4 = Expr::create<Word>("StdIO") + Expr::create<Word>("Close-Channel");
  _c_5 = Expr::create<Word>("StdIO") + Expr::create<Word>("EOF?");
  _c_6 = Expr::create<Word>("Channel is not open");
  _c_7 = Expr::create<Word>("StdIO") + Expr::create<Word>("Read-Char!");
  _c_8 = Char::create_expr (L"\r\n");
  _c_9 = Expr (_c_8, 1, 1);
  _c_10 = Expr (_c_8, 0, 1);
  _c_11 = Expr::create<Word>("StdIO") + Expr::create<Word>("Read-Line!");
  _c_12 = Expr::create<Word>("Read!");
  _c_13 = Expr::create<Word>("Read");
  _c_14 = Expr (_c_5, 0, 1);
  _c_15 = Expr::create<Word>("Apply") + Expr::create<Word>("Apply") + Expr::create<Word>("Unexpected fail");
}

static AtStart init_registrator_ (&init_);

static void init_StdIn_ ()
{
  Expr _v_Stream1;
  RF_CALL (Stream::Stream, (_c_3, (StdIn + Expr::create<Integer>(1))), _v_Stream1);
  RF_CALL (Table::Bind, (Buffers, StdIn, _v_Stream1), /*void*/);
}

static rfrt::InitStdIn init_StdIn_registrator_ (init_StdIn_);

}

}
