// $Id: prim_read.cc 2194 2006-12-24 00:18:21Z orlov $

#include <rf_core.hh>
#include <limits.h>

namespace refal
{

using namespace rfrt;

namespace StdIO
{

static char buf[MB_LEN_MAX * 8];

static inline wint_t get_char (FILE* _fp)
{
  memset(&buf, '\0', sizeof(buf));
  wchar_t wc;
  mbstate_t st;
  for (unsigned i = 0; i < sizeof(buf); i++)
  {
    memset(&st, '\0', sizeof(mbstate_t));
    int c = getc(_fp);
    if (c == EOF) return WEOF;
    buf[i] = c;
    size_t res = mbrtowc(&wc, buf, sizeof(buf), &st);
    if (res == (size_t)(-2)) continue;
    if (res == (size_t)(-1)) FATAL("Error while converting input characters");
    return wc;
  }
  FATAL("Error while converting input characters");
  return WEOF;
}

RF_FUNC (Prim_m_Read, (RF_ARG _channel, _n;;), (RF_RES _chars;;))
  FILE* fp   = _channel.get_first()->cast_to<Channel>(type_channel)->get_fp();
  Term* p    = _n.get_first();
  unsigned n = p->get_type() == type_int32 ?
               p->cast_to<Int32>(type_int32)->to_int() :
               p->cast_to<Integer>(type_int)->to_int();
  wchar_t* s = static_cast<wchar_t*>(alloca(n * sizeof(wchar_t)));
  unsigned i = 0;
  while (i < n)
  {
    wint_t w = get_char(fp);
    if (w == WEOF)
    {
      if (i) break;
      RF_RETFAIL;
    }
    s[i++] = w;
  }
  _chars = Expr::create_seq<Char>(s, i);
RF_END

}
}
