#include <rf_core.hh>
#include <refal/Access.hh>
#include <refal/Box.hh>
#include <refal/Apply.hh>
#include <refal/Compare.hh>
#include <refal/StdIO.hh>
#include <refal/Error.hh>
#include <refal/Class.hh>

namespace refal
{

using namespace rfrt;

namespace Stream
{

RF_DECL (Stream);

RF_DECL (Read_m_Expr);

RF_DECL (Expr_m_Open);

RF_DECL (File_m_Open);

RF_DECL (File_m_Close);

static Expr StdIStream_m_Box;

RF_DECL (StdIStream);

RF_DECL (Getc);

RF_DECL (Gets);

RF_DECL (Ungets);

RF_DECL (Scanc);

RF_DECL (Get_m_Delim);

RF_DECL (Not_m_EOL);

RF_DECL (Get_m_Line);

RF_DECL (Get_m_While);

RF_DECL (End_m_of_m_Stream_q_);

RF_DECL (Prim_m_Read__0);

RF_DECL (Read_m_Expr__0);

RF_DECL (Not_m_EOL__0);

static Expr _c_0;

static Expr _c_1;

static Expr _c_2;

static Expr _c_3;

static Expr _c_4;

static Expr _c_5;

static Expr _c_6;

static Expr _c_7;

static Expr _c_8;

static Expr _c_9;

static Expr _c_10;

static Expr _c_11;

static Expr _c_12;

static Expr _c_13;

static Expr _c_14;

static Expr _c_15;

static Expr _c_16;

static Expr _c_17;

static Expr _c_18;

static Expr _c_19;

static Expr _c_20;

static Expr _c_21;

RF_FUNC (Stream, (RF_ARG _vs_func, _ve_args;;), (RF_RES _v_res1;;))
  {
    {
      if (!RF_CALL (Class::Func_q_, _vs_func, /*void*/))
      {
        goto _negation1;
      }
      goto _block1__branch1;
    }
  _negation1: {}
    RF_CALL (Error::Lib_m_Error, (_c_0, _c_1), /*void*/);
    RF_FUNC_ERROR (unexpected_fail);
  }
_block1__branch1: {}
  RF_TAILCALL (Box::Box, (_c_2 + (_vs_func + _ve_args) ()), _v_res1);
RF_END

RF_FUNC (Read_m_Expr, (RF_ARG _vs_box;;), (RF_RES _v_res1;;))
  Expr _v__q_1;
  RF_CALL (Box::_q_, _vs_box, _v__q_1);
  uintptr_t _v_len1 = _v__q_1.get_len ();
  uintptr_t _v_len2 = 0;
  if (((_v_len1 < (_v_len2 + (1 * 1)))))
  {
    RF_RETFAIL;
  }
  if (((_v_len1 - _v_len2) % 1))
  {
    RF_RETFAIL;
  }
  uintptr_t _v_len__expr = ((_v_len1 - _v_len2) / 1);
  Expr _vv_expr (_v__q_1, 0, _v_len__expr);
  RF_CALL (Box::Store, (_vs_box, empty), /*void*/);
  _v_res1 = _vv_expr;
RF_END

RF_FUNC (Expr_m_Open, (RF_ARG _ve_xpr;;), (RF_RES _v_res1;;))
  Expr _vs_box;
  RF_CALL (Box::Box, _ve_xpr, _vs_box);
  RF_TAILCALL (Stream, (_c_3, _vs_box), _v_res1);
RF_END

RF_FUNC (File_m_Open, (RF_ARG _ve_filename;;), (RF_RES _v_res1;;))
  Expr _vs_channel;
  RF_CALL (StdIO::Channel, /*void*/, _vs_channel);
  if (!RF_CALL (StdIO::Prim_m_Open_m_File, (_vs_channel, _ve_filename, _c_4), /*void*/))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  RF_TAILCALL (Stream, (_c_5, (_vs_channel + StdIO::Read_m_Chunk_m_Size)), _v_res1);
RF_END

RF_FUNC (File_m_Close, (RF_ARG _vs_tream;;), RF_VOID)
  {
    {
      Expr _v__q_1;
      RF_CALL (Box::_q_, _vs_tream, _v__q_1);
      if ((_v__q_1.get_len () != 2))
      {
        goto _block1__branch1;
      }
      if (_v__q_1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      if (_v__q_1.symbol_at (1))
      {
        goto _block1__branch1;
      }
      Expr _v_deref___q_1 (_v__q_1, 0);
      Expr _v_deref___q_12 (_v__q_1, 1);
      uintptr_t _v_len1 = _v_deref___q_12.get_len ();
      uintptr_t _v_len2 = 1;
      if ((_v_len1 < _v_len2))
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__args = (_v_len1 - _v_len2);
      uintptr_t _v_len3 = _v_deref___q_1.get_len ();
      uintptr_t _v_len4 = 0;
      if ((_v_len3 < _v_len4))
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__buf = (_v_len3 - _v_len4);
      if (!_v_deref___q_12.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _ve_buf (_v_deref___q_1, 0, _v_len__buf);
      Expr _vs_func (_v_deref___q_12, 0, 1);
      Expr _ve_args (_v_deref___q_12, 1, _v_len__args);
      {
        {
          uintptr_t _v_len5 = _v_len__args;
          uintptr_t _v_len6 = 1;
          if ((_v_len5 < _v_len6))
          {
            goto _block2__branch1;
          }
          uintptr_t _v_len__rest = (_v_len5 - _v_len6);
          if (!_ve_args.symbol_at (0))
          {
            goto _block2__branch1;
          }
          Expr _vs_ch (_ve_args, 0, 1);
          Expr _ve_rest (_ve_args, 1, _v_len__rest);
          if (!RF_CALL (Class::Channel_q_, _vs_ch, /*void*/))
          {
            goto _block2__branch1;
          }
          RF_TAILCALL (StdIO::Prim_m_Close_m_Channel, _vs_ch, /*void*/);
          goto _block2;
        }
      _block2__branch1: {}
        RF_CALL (Error::Lib_m_Error, (_c_6, _c_7), /*void*/);
        RF_FUNC_ERROR (unexpected_fail);
      }
    _block2: {}
      goto _block1;
    }
  _block1__branch1: {}
    RF_CALL (Error::Lib_m_Error, (_c_6, _c_8), /*void*/);
    RF_FUNC_ERROR (unexpected_fail);
  }
_block1: {}
RF_END

RF_FUNC (StdIStream, RF_VOID, (RF_RES _v_res1;;))
  {
    {
      Expr _v__q_1;
      RF_CALL (Box::_q_, StdIStream_m_Box, _v__q_1);
      if ((_v__q_1.get_len () != 1))
      {
        goto _block1__branch1;
      }
      if (!_v__q_1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _vs_tream (_v__q_1, 0, 1);
      _v_res1 = _vs_tream;
      goto _block1;
    }
  _block1__branch1: {}
    Expr _vs_tream;
    RF_CALL (Stream, (_c_5, _c_9), _vs_tream);
    RF_CALL (Box::Store, (StdIStream_m_Box, _vs_tream), /*void*/);
    _v_res1 = _vs_tream;
  }
_block1: {}
RF_END

RF_FUNC (Getc, (RF_ARG _vs_tream;;), (RF_RES _v_res1;;))
  Expr _v_Gets1;
  if (!RF_CALL (Gets, (_vs_tream, _c_10), _v_Gets1))
  {
    RF_RETFAIL;
  }
  if ((_v_Gets1.get_len () != 1))
  {
    RF_RETFAIL;
  }
  Expr _vt_erm (_v_Gets1, 0, 1);
  _v_res1 = _vt_erm;
RF_END

RF_FUNC (Gets, (RF_ARG _vs_tream, _vs_n;;), (RF_RES _v_res1;;))
  {
    {
      Expr _v__q_1;
      RF_CALL (Box::_q_, _vs_tream, _v__q_1);
      if ((_v__q_1.get_len () != (1 + 1)))
      {
        goto _block1__branch1;
      }
      if (_v__q_1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      if (_v__q_1.symbol_at ((0 + 1)))
      {
        goto _block1__branch1;
      }
      Expr _v_deref___q_1 (_v__q_1, 0);
      Expr _v_deref___q_12 (_v__q_1, (0 + 1));
      uintptr_t _v_len1 = _v_deref___q_12.get_len ();
      uintptr_t _v_len2 = 1;
      if (((_v_len1 < (_v_len2 + (0 * 1)))))
      {
        goto _block1__branch1;
      }
      if (((_v_len1 - _v_len2) % 1))
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__args = ((_v_len1 - _v_len2) / 1);
      uintptr_t _v_len3 = _v_deref___q_1.get_len ();
      uintptr_t _v_len4 = 0;
      if (((_v_len3 < (_v_len4 + (0 * 1)))))
      {
        goto _block1__branch1;
      }
      if (((_v_len3 - _v_len4) % 1))
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__buf = ((_v_len3 - _v_len4) / 1);
      if (!_v_deref___q_12.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _ve_buf (_v_deref___q_1, 0, _v_len__buf);
      Expr _vs_func (_v_deref___q_12, 0, 1);
      Expr _ve_args (_v_deref___q_12, (0 + 1), _v_len__args);
      for ( ; ; )
      {
        {
          Expr _v_Length1;
          RF_CALL (Access::Length, _ve_buf, _v_Length1);
          if (!RF_CALL (Compare::_gt__eq_, (_v_Length1, _vs_n), /*void*/))
          {
            goto _iter1;
          }
          Expr _v_Middle1;
          if (!RF_CALL (Access::Middle, (_vs_n, _c_11, _ve_buf), _v_Middle1))
          {
            RF_RETFAIL;
          }
          RF_CALL (Box::Store, (_vs_tream, (_v_Middle1 () + (_vs_func + _ve_args) ())), /*void*/);
          RF_TAILCALL (Access::Left, (_c_11, _vs_n, _ve_buf), _v_res1);
          goto _exit__iter1;
        }
      _iter1: {}
        {
          {
            Expr _v_Apply1;
            if (!RF_CALL (Apply::Apply, (_vs_func, _ve_args), _v_Apply1))
            {
              goto _block2__branch1;
            }
            _ve_buf = (_ve_buf + _v_Apply1);
            goto _block2;
          }
        _block2__branch1: {}
          RF_CALL (Box::Store, (_vs_tream, (_ve_buf () + (_vs_func + _ve_args) ())), /*void*/);
          RF_RETFAIL;
        }
      _block2: {}
      }
    _exit__iter1: {}
      goto _block1;
    }
  _block1__branch1: {}
    RF_CALL (Error::Lib_m_Error, (_c_12, _c_8), /*void*/);
    RF_RETFAIL;
  }
_block1: {}
RF_END

RF_FUNC (Ungets, (RF_ARG _vs_tream, _ve_xpr;;), RF_VOID)
  {
    {
      Expr _v__q_1;
      RF_CALL (Box::_q_, _vs_tream, _v__q_1);
      if ((_v__q_1.get_len () != 2))
      {
        goto _block1__branch1;
      }
      if (_v__q_1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      if (_v__q_1.symbol_at (1))
      {
        goto _block1__branch1;
      }
      Expr _v_deref___q_1 (_v__q_1, 0);
      Expr _v_deref___q_12 (_v__q_1, 1);
      uintptr_t _v_len1 = _v_deref___q_12.get_len ();
      uintptr_t _v_len2 = 1;
      if ((_v_len1 < _v_len2))
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__args = (_v_len1 - _v_len2);
      uintptr_t _v_len3 = _v_deref___q_1.get_len ();
      uintptr_t _v_len4 = 0;
      if ((_v_len3 < _v_len4))
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__buf = (_v_len3 - _v_len4);
      if (!_v_deref___q_12.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _ve_buf (_v_deref___q_1, 0, _v_len__buf);
      Expr _vs_func (_v_deref___q_12, 0, 1);
      Expr _ve_args (_v_deref___q_12, 1, _v_len__args);
      RF_TAILCALL (Box::Store, (_vs_tream, ((_ve_xpr + _ve_buf) () + (_vs_func + _ve_args) ())), /*void*/);
      goto _block1;
    }
  _block1__branch1: {}
    RF_CALL (Error::Lib_m_Error, (_c_13, _c_8), /*void*/);
    RF_FUNC_ERROR (unexpected_fail);
  }
_block1: {}
RF_END

RF_FUNC (Scanc, (RF_ARG _vs_tream, _vt_1;;), (RF_RES _v_res1;;))
  {
    {
      Expr _v_Getc1;
      if (!RF_CALL (Getc, _vs_tream, _v_Getc1))
      {
        goto _block1__branch1;
      }
      {
        {
          if (!_vt_1.term_eq (_v_Getc1, 0))
          {
            goto _block2__branch1;
          }
          _v_res1 = _vt_1;
          goto _block2;
        }
      _block2__branch1: {}
        Expr _vt_2 (_v_Getc1, 0, 1);
        RF_CALL (Ungets, (_vs_tream, _vt_2), /*void*/);
        _v_res1 = empty;
      }
    _block2: {}
      goto _block1;
    }
  _block1__branch1: {}
    _v_res1 = empty;
  }
_block1: {}
RF_END

RF_FUNC (Get_m_Delim, (RF_ARG _vs_tream, _vt_delim;;), (RF_RES _v_res1;;))
  {
    {
      Expr _v__q_1;
      RF_CALL (Box::_q_, _vs_tream, _v__q_1);
      if ((_v__q_1.get_len () != 2))
      {
        goto _block1__branch1;
      }
      if (_v__q_1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      if (_v__q_1.symbol_at (1))
      {
        goto _block1__branch1;
      }
      Expr _v_deref___q_1 (_v__q_1, 0);
      Expr _v_deref___q_12 (_v__q_1, 1);
      uintptr_t _v_len1 = _v_deref___q_12.get_len ();
      uintptr_t _v_len2 = 1;
      if ((_v_len1 < _v_len2))
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__args = (_v_len1 - _v_len2);
      uintptr_t _v_len3 = _v_deref___q_1.get_len ();
      uintptr_t _v_len4 = 0;
      if ((_v_len3 < _v_len4))
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__buf = (_v_len3 - _v_len4);
      if (!_v_deref___q_12.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _ve_buf (_v_deref___q_1, 0, _v_len__buf);
      Expr _vs_func (_v_deref___q_12, 0, 1);
      Expr _ve_args (_v_deref___q_12, 1, _v_len__args);
      Expr _ve_str (empty);
      Expr _ve_stop_q_ (empty);
      for ( ; ; )
      {
        {
          if ((_ve_stop_q_.get_len () != 1))
          {
            goto _iter1;
          }
          if (!_c_14.term_eq (_ve_stop_q_, 0))
          {
            goto _iter1;
          }
          RF_CALL (Box::Store, (_vs_tream, (_ve_buf () + (_vs_func + _ve_args) ())), /*void*/);
          _v_res1 = _ve_str;
          goto _exit__iter1;
        }
      _iter1: {}
        {
          {
            if ((_ve_buf.get_len () < 1))
            {
              goto _block2__branch1;
            }
            RF_lsplit (_ve_buf, 0, _ve_1, _v_lsplit__buf);
            for ( ; ; RF_iter(_ve_buf)++)
            {
              {
                if (!RF_iter(_ve_buf))
                {
                  goto _block2__branch1;
                }
                uintptr_t _v_len5 = _v_lsplit__buf.get_len ();
                uintptr_t _v_len6 = 1;
                if ((_v_len5 < _v_len6))
                {
                  goto _block2__branch1;
                }
                uintptr_t _v_len__2 = (_v_len5 - _v_len6);
                if (!_vt_delim.term_eq (_v_lsplit__buf, 0))
                {
                  goto _continue1;
                }
                Expr _ve_2 (_v_lsplit__buf, 1, _v_len__2);
                _ve_str = (_ve_str + _ve_1 + _vt_delim);
                _ve_buf = _ve_2;
                _ve_stop_q_ = _c_14;
                goto _exit1;
              }
          _continue1: {}
            }
          _exit1: {}
            goto _block2;
          }
        _block2__branch1: {}
          {
            Expr _v_Apply1;
            if (!RF_CALL (Apply::Apply, (_vs_func, _ve_args), _v_Apply1))
            {
              goto _block2__branch2;
            }
            _ve_str = (_ve_str + _ve_buf);
            _ve_buf = _v_Apply1;
            _ve_stop_q_ = empty;
            goto _block2;
          }
        _block2__branch2: {}
          _ve_str = (_ve_str + _ve_buf);
          _ve_buf = empty;
          _ve_stop_q_ = _c_14;
        }
      _block2: {}
      }
    _exit__iter1: {}
      goto _block1;
    }
  _block1__branch1: {}
    RF_CALL (Error::Lib_m_Error, (_c_15, _c_8), /*void*/);
    RF_FUNC_ERROR (unexpected_fail);
  }
_block1: {}
RF_END

RF_FUNC (Not_m_EOL, (RF_ARG _vt_1;;), RF_VOID)
  {
    {
      {
        if ((1 != 1))
        {
          goto _block1__branch1;
        }
        if (!_vt_1.term_eq (_c_16, 0))
        {
          goto _block1__branch1;
        }
        goto _block1;
      }
    _block1__branch1: {}
      if ((1 != 1))
      {
        goto _negation1;
      }
      if (!_vt_1.term_eq (_c_17, 0))
      {
        goto _negation1;
      }
    }
  _block1: {}
    RF_RETFAIL;
  }
_negation1: {}
RF_END

RF_FUNC (Get_m_Line, (RF_ARG _vs_tream;;), (RF_RES _v_res1;;))
  Expr _v_Get_m_While1;
  RF_CALL (Get_m_While, (_vs_tream, _c_18), _v_Get_m_While1);
  Expr _v_Scanc1;
  RF_CALL (Scanc, (_vs_tream, _c_17), _v_Scanc1);
  Expr _v_Scanc2;
  RF_CALL (Scanc, (_vs_tream, _c_16), _v_Scanc2);
  _v_res1 = (_v_Get_m_While1 + _v_Scanc1 + _v_Scanc2);
RF_END

RF_FUNC (Get_m_While, (RF_ARG _vs_tream, _vs_pred;;), (RF_RES _v_res1;;))
  {
    {
      Expr _v__q_1;
      RF_CALL (Box::_q_, _vs_tream, _v__q_1);
      if ((_v__q_1.get_len () != 2))
      {
        goto _block1__branch1;
      }
      if (_v__q_1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      if (_v__q_1.symbol_at (1))
      {
        goto _block1__branch1;
      }
      Expr _v_deref___q_1 (_v__q_1, 0);
      Expr _v_deref___q_12 (_v__q_1, 1);
      uintptr_t _v_len1 = _v_deref___q_12.get_len ();
      uintptr_t _v_len2 = 1;
      if ((_v_len1 < _v_len2))
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__args = (_v_len1 - _v_len2);
      uintptr_t _v_len3 = _v_deref___q_1.get_len ();
      uintptr_t _v_len4 = 0;
      if ((_v_len3 < _v_len4))
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__buf = (_v_len3 - _v_len4);
      if (!_v_deref___q_12.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _ve_buf (_v_deref___q_1, 0, _v_len__buf);
      Expr _vs_func (_v_deref___q_12, 0, 1);
      Expr _ve_args (_v_deref___q_12, 1, _v_len__args);
      Expr _ve_str (empty);
      Expr _ve_stop_q_ (empty);
      for ( ; ; )
      {
        {
          if ((_ve_stop_q_.get_len () != 1))
          {
            goto _iter1;
          }
          if (!_c_14.term_eq (_ve_stop_q_, 0))
          {
            goto _iter1;
          }
          RF_CALL (Box::Store, (_vs_tream, (_ve_buf () + (_vs_func + _ve_args) ())), /*void*/);
          _v_res1 = _ve_str;
          goto _exit__iter1;
        }
      _iter1: {}
        {
          {
            uintptr_t _v_len5 = _ve_buf.get_len ();
            uintptr_t _v_len6 = 1;
            if ((_v_len5 < _v_len6))
            {
              goto _block2__branch1;
            }
            uintptr_t _v_len__2 = (_v_len5 - _v_len6);
            Expr _vt_1 (_ve_buf, 0, 1);
            Expr _ve_2 (_ve_buf, 1, _v_len__2);
            {
              {
                Expr _v_Apply1;
                if (!RF_CALL (Apply::Apply, (_vs_pred, _vt_1), _v_Apply1))
                {
                  goto _block3__branch1;
                }
                uintptr_t _v_len7 = _v_Apply1.get_len ();
                uintptr_t _v_len8 = 0;
                if ((_v_len7 < _v_len8))
                {
                  goto _block3__branch1;
                }
                uintptr_t _v_len___e__e_tmp_m_Streamrf_m_134_m_30 = (_v_len7 - _v_len8);
                Expr _ve__e__e_tmp_m_Streamrf_m_134_m_30 (_v_Apply1, 0, _v_len___e__e_tmp_m_Streamrf_m_134_m_30);
                _ve_str = (_ve_str + _vt_1);
                _ve_buf = _ve_2;
                _ve_stop_q_ = empty;
                goto _block3;
              }
            _block3__branch1: {}
              _ve_stop_q_ = _c_14;
            }
          _block3: {}
            goto _block2;
          }
        _block2__branch1: {}
          {
            if (!RF_CALL (Apply::Apply, (_vs_func, _ve_args), _ve_buf))
            {
              goto _block2__branch2;
            }
            _ve_stop_q_ = empty;
            goto _block2;
          }
        _block2__branch2: {}
          _ve_stop_q_ = _c_14;
        }
      _block2: {}
      }
    _exit__iter1: {}
      goto _block1;
    }
  _block1__branch1: {}
    RF_CALL (Error::Lib_m_Error, (_c_19, _c_8), /*void*/);
    RF_FUNC_ERROR (unexpected_fail);
  }
_block1: {}
RF_END

RF_FUNC (End_m_of_m_Stream_q_, (RF_ARG _vs_tream;;), RF_VOID)
  {
    {
      Expr _v__q_1;
      RF_CALL (Box::_q_, _vs_tream, _v__q_1);
      if ((_v__q_1.get_len () != (1 + 1)))
      {
        goto _block1__branch1;
      }
      if (_v__q_1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      if (_v__q_1.symbol_at ((0 + 1)))
      {
        goto _block1__branch1;
      }
      Expr _v_deref___q_1 (_v__q_1, 0);
      Expr _v_deref___q_12 (_v__q_1, (0 + 1));
      uintptr_t _v_len1 = _v_deref___q_12.get_len ();
      uintptr_t _v_len2 = 1;
      if (((_v_len1 < (_v_len2 + (0 * 1)))))
      {
        goto _block1__branch1;
      }
      if (((_v_len1 - _v_len2) % 1))
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__args = ((_v_len1 - _v_len2) / 1);
      uintptr_t _v_len3 = _v_deref___q_1.get_len ();
      uintptr_t _v_len4 = 0;
      if (((_v_len3 < (_v_len4 + (0 * 1)))))
      {
        goto _block1__branch1;
      }
      if (((_v_len3 - _v_len4) % 1))
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__buf = ((_v_len3 - _v_len4) / 1);
      if (!_v_deref___q_12.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _ve_buf (_v_deref___q_1, 0, _v_len__buf);
      Expr _vs_func (_v_deref___q_12, 0, 1);
      Expr _ve_args (_v_deref___q_12, (0 + 1), _v_len__args);
      {
        {
          Expr _v_buf__1 (_ve_buf);
          for ( ; ; )
          {
            {
              uintptr_t _v_len5 = _v_buf__1.get_len ();
              uintptr_t _v_len6 = 0;
              if (((_v_len5 < (_v_len6 + (1 * 1)))))
              {
                goto _iter1;
              }
              if (((_v_len5 - _v_len6) % 1))
              {
                goto _iter1;
              }
              uintptr_t _v_len___e__e_tmp_m_Streamrf_m_155_m_18 = ((_v_len5 - _v_len6) / 1);
              Expr _vv__e__e_tmp_m_Streamrf_m_155_m_18 (_v_buf__1, 0, _v_len___e__e_tmp_m_Streamrf_m_155_m_18);
              RF_CALL (Box::Store, (_vs_tream, (_v_buf__1 () + (_vs_func + _ve_args) ())), /*void*/);
              RF_RETFAIL;
              goto _exit__iter1;
            }
          _iter1: {}
            if (!RF_CALL (Apply::Apply, (_vs_func, _ve_args), _v_buf__1))
            {
              goto _block2__branch1;
            }
          }
        _exit__iter1: {}
          goto _block2;
        }
      _block2__branch1: {}
      }
    _block2: {}
      goto _block1;
    }
  _block1__branch1: {}
    RF_CALL (Error::Lib_m_Error, (_c_20, _c_8), /*void*/);
    RF_RETFAIL;
  }
_block1: {}
RF_END

RF_FUNC (Prim_m_Read__0, (RF_ARG _v_arg1;;), (RF_RES _v_res1;;))
  if ((_v_arg1.get_len () != (1 + 1)))
  {
    RF_ERROR (_c_21);
  }
  if (!_v_arg1.symbol_at (0))
  {
    RF_ERROR (_c_21);
  }
  if (!_v_arg1.symbol_at ((0 + 1)))
  {
    RF_ERROR (_c_21);
  }
  Expr _v_stub1 (_v_arg1, 0, 1);
  Expr _v_stub2 (_v_arg1, (0 + 1), 1);
  RF_TAILCALL (StdIO::Prim_m_Read, (_v_stub1, _v_stub2), _v_res1);
RF_END

RF_FUNC (Read_m_Expr__0, (RF_ARG _v_arg1;;), (RF_RES _v_res1;;))
  if ((_v_arg1.get_len () != 1))
  {
    RF_ERROR (_c_21);
  }
  if (!_v_arg1.symbol_at (0))
  {
    RF_ERROR (_c_21);
  }
  Expr _v_stub1 (_v_arg1, 0, 1);
  if (!RF_CALL (Read_m_Expr, _v_stub1, _v_res1))
  {
    RF_RETFAIL;
  }
RF_END

RF_FUNC (Not_m_EOL__0, (RF_ARG _v_arg1;;), (RF_RES _v_res1;;))
  if ((_v_arg1.get_len () != 1))
  {
    RF_ERROR (_c_21);
  }
  Expr _v_stub1 (_v_arg1, 0, 1);
  if (!RF_CALL (Not_m_EOL, _v_stub1, /*void*/))
  {
    RF_RETFAIL;
  }
  _v_res1 = empty;
RF_END

}

namespace StdIO {  extern AtStart init_StdIn;  }

namespace Stream
{

static void init_ ()
{
  StdIO::init_StdIn.invoke();
  StdIStream_m_Box = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"StdIStream-Box");
  _c_0 = Expr::create<Word>("Stream") + Expr::create<Word>("Stream");
  _c_1 = Expr::create<Word>("Arg 1 is not a Function");
  _c_2 = (empty) ();
  _c_3 = Expr::create_sym<Func> (Read_m_Expr__0);
  _c_4 = Expr::create<Word>("R");
  _c_5 = Expr::create_sym<Func> (Prim_m_Read__0);
  _c_6 = Expr::create<Word>("Stream") + Expr::create<Word>("File-Close");
  _c_7 = Expr::create<Word>("Arg 1 is not a Streamed File");
  _c_8 = Expr::create<Word>("Arg 1 is not a Stream");
  _c_9 = StdIO::StdIn + Expr::create<Integer>("1");
  _c_10 = Expr (_c_9, 1, 1);
  _c_11 = Expr::create<Integer>("0");
  _c_12 = Expr::create<Word>("Stream") + Expr::create<Word>("Gets");
  _c_13 = Expr::create<Word>("Stream") + Expr::create<Word>("Ungets");
  _c_14 = Expr::create<Word>("Stop");
  _c_15 = Expr::create<Word>("Stream") + Expr::create<Word>("Get-Delim");
  _c_16 = Char::create_expr (L"\n");
  _c_17 = Char::create_expr (L"\r");
  _c_18 = Expr::create_sym<Func> (Not_m_EOL__0);
  _c_19 = Expr::create<Word>("Stream") + Expr::create<Word>("Get-While");
  _c_20 = Expr::create<Word>("Stream") + Expr::create<Word>("End-of-Stream?");
  _c_21 = Expr::create<Word>("Apply") + Expr::create<Word>("Apply") + Expr::create<Word>("Unexpected fail");
}

static AtStart init_registrator_ (&init_);

}

}
