#include <rf_core.hh>
#include <refal/Access.hh>
#include <refal/Apply.hh>
#include <refal/Box.hh>
#include <refal/Arithm.hh>
#include <refal/Compare.hh>
#include <refal/File.hh>
#include <refal/Convert.hh>
#include <refal/Class.hh>
#include <refal/JavaMangle.hh>
#include <refal/List.hh>
#include <refal/Table.hh>
#include "rfpc.hh"
#include "rfp_helper.hh"
#include <refal/StdIO.hh>
#include <refal/Java.hh>

namespace refal
{

using namespace rfrt;

namespace Opcodes
{

static Expr IFEQ;

}

namespace ClassWriter
{

RF_FUNC (CWtoByteArray, (RF_ARG _v_arg1;;), (RF_RES _v_res1;;))
  RF_ERROR ((Expr::create<rftype::Word>("ClassWriter") + Expr::create<rftype::Word>("CWtoByteArray") + Expr::create<rftype::Word>("Not available")));
RF_END

}

namespace Opcodes
{

static Expr IFNE;

}

namespace ClassWriter
{

RF_FUNC (CWvisitField, (RF_ARG _v_arg1, _v_arg2, _v_arg3, _v_arg4, _v_arg5, _v_arg6;;), (RF_RES _v_res1;;))
  RF_ERROR ((Expr::create<rftype::Word>("ClassWriter") + Expr::create<rftype::Word>("CWvisitField") + Expr::create<rftype::Word>("Not available")));
RF_END

RF_FUNC (CWvisitEnd, (RF_ARG _v_arg1;;), RF_VOID)
  RF_ERROR ((Expr::create<rftype::Word>("ClassWriter") + Expr::create<rftype::Word>("CWvisitEnd") + Expr::create<rftype::Word>("Not available")));
RF_END

RF_FUNC (CWvisit, (RF_ARG _v_arg1, _v_arg2, _v_arg3, _v_arg4, _v_arg5, _v_arg6, _v_arg7;;), RF_VOID)
  RF_ERROR ((Expr::create<rftype::Word>("ClassWriter") + Expr::create<rftype::Word>("CWvisit") + Expr::create<rftype::Word>("Not available")));
RF_END

RF_FUNC (ClassWriter, (RF_ARG _v_arg1;;), (RF_RES _v_res1;;))
  RF_ERROR ((Expr::create<rftype::Word>("ClassWriter") + Expr::create<rftype::Word>("ClassWriter") + Expr::create<rftype::Word>("Not available")));
RF_END

}

namespace Integer
{

RF_FUNC (Integer, (RF_ARG _v_arg1;;), (RF_RES _v_res1;;))
  RF_ERROR ((Expr::create<rftype::Word>("Integer") + Expr::create<rftype::Word>("Integer") + Expr::create<rftype::Word>("Not available")));
RF_END

}

namespace Label
{

RF_FUNC (Label, RF_VOID, (RF_RES _v_res1;;))
  RF_ERROR ((Expr::create<rftype::Word>("Label") + Expr::create<rftype::Word>("Label") + Expr::create<rftype::Word>("Not available")));
RF_END

}

namespace FieldVisitor
{

RF_FUNC (FVvisitEnd, (RF_ARG _v_arg1;;), RF_VOID)
  RF_ERROR ((Expr::create<rftype::Word>("FieldVisitor") + Expr::create<rftype::Word>("FVvisitEnd") + Expr::create<rftype::Word>("Not available")));
RF_END

}

namespace MethodVisitor
{

RF_FUNC (MVvisitFieldInsn, (RF_ARG _v_arg1, _v_arg2, _v_arg3, _v_arg4, _v_arg5;;), RF_VOID)
  RF_ERROR ((Expr::create<rftype::Word>("MethodVisitor") + Expr::create<rftype::Word>("MVvisitFieldInsn") + Expr::create<rftype::Word>("Not available")));
RF_END

RF_FUNC (MVvisitLabel, (RF_ARG _v_arg1, _v_arg2;;), RF_VOID)
  RF_ERROR ((Expr::create<rftype::Word>("MethodVisitor") + Expr::create<rftype::Word>("MVvisitLabel") + Expr::create<rftype::Word>("Not available")));
RF_END

RF_FUNC (MVvisitJumpInsn, (RF_ARG _v_arg1, _v_arg2, _v_arg3;;), RF_VOID)
  RF_ERROR ((Expr::create<rftype::Word>("MethodVisitor") + Expr::create<rftype::Word>("MVvisitJumpInsn") + Expr::create<rftype::Word>("Not available")));
RF_END

RF_FUNC (MVvisitInsn, (RF_ARG _v_arg1, _v_arg2;;), RF_VOID)
  RF_ERROR ((Expr::create<rftype::Word>("MethodVisitor") + Expr::create<rftype::Word>("MVvisitInsn") + Expr::create<rftype::Word>("Not available")));
RF_END

RF_FUNC (MVvisitEnd, (RF_ARG _v_arg1;;), RF_VOID)
  RF_ERROR ((Expr::create<rftype::Word>("MethodVisitor") + Expr::create<rftype::Word>("MVvisitEnd") + Expr::create<rftype::Word>("Not available")));
RF_END

}

namespace ClassWriter
{

RF_FUNC (CWvisitMethod, (RF_ARG _v_arg1, _v_arg2, _v_arg3, _v_arg4, _v_arg5, _v_arg6;;), (RF_RES _v_res1;;))
  RF_ERROR ((Expr::create<rftype::Word>("ClassWriter") + Expr::create<rftype::Word>("CWvisitMethod") + Expr::create<rftype::Word>("Not available")));
RF_END

}

namespace MethodVisitor
{

RF_FUNC (MVvisitMaxs, (RF_ARG _v_arg1, _v_arg2, _v_arg3;;), RF_VOID)
  RF_ERROR ((Expr::create<rftype::Word>("MethodVisitor") + Expr::create<rftype::Word>("MVvisitMaxs") + Expr::create<rftype::Word>("Not available")));
RF_END

RF_FUNC (MVvisitTryCatchBlock, (RF_ARG _v_arg1, _v_arg2, _v_arg3, _v_arg4, _v_arg5;;), RF_VOID)
  RF_ERROR ((Expr::create<rftype::Word>("MethodVisitor") + Expr::create<rftype::Word>("MVvisitTryCatchBlock") + Expr::create<rftype::Word>("Not available")));
RF_END

RF_FUNC (MVvisitMethodInsn, (RF_ARG _v_arg1, _v_arg2, _v_arg3, _v_arg4, _v_arg5;;), RF_VOID)
  RF_ERROR ((Expr::create<rftype::Word>("MethodVisitor") + Expr::create<rftype::Word>("MVvisitMethodInsn") + Expr::create<rftype::Word>("Not available")));
RF_END

RF_FUNC (MVvisitVarInsn, (RF_ARG _v_arg1, _v_arg2, _v_arg3;;), RF_VOID)
  RF_ERROR ((Expr::create<rftype::Word>("MethodVisitor") + Expr::create<rftype::Word>("MVvisitVarInsn") + Expr::create<rftype::Word>("Not available")));
RF_END

RF_FUNC (MVvisitTypeInsn, (RF_ARG _v_arg1, _v_arg2, _v_arg3;;), RF_VOID)
  RF_ERROR ((Expr::create<rftype::Word>("MethodVisitor") + Expr::create<rftype::Word>("MVvisitTypeInsn") + Expr::create<rftype::Word>("Not available")));
RF_END

RF_FUNC (MVvisitLdcInsn, (RF_ARG _v_arg1, _v_arg2;;), RF_VOID)
  RF_ERROR ((Expr::create<rftype::Word>("MethodVisitor") + Expr::create<rftype::Word>("MVvisitLdcInsn") + Expr::create<rftype::Word>("Not available")));
RF_END

}

namespace rfp__asail__jbc
{

static Expr Int;

static Expr Exports;

static Expr Module_m_Name;

static Expr Refal_m_Module_m_Name;

static Expr Entry;

static Expr Entry_m_Name;

static Expr Func_m_Name;

static Expr Objects;

static Expr Constants;

static Expr Func_m_Refs;

static Expr MVbox;

RF_DECL (MV);

RF_DECL (RFP_m_ASAIL_m_To_m_JBC);

static Expr Block_m_Tables;

RF_DECL (Init_m_Block_m_Table);

RF_DECL (Push_m_Block_m_Table);

RF_DECL (Pop_m_Block_m_Table);

RF_DECL (Get_m_Block_m_Table);

RF_DECL (Bind_m_Vars);

RF_DECL (Bind_m_Var);

RF_DECL (Lookup_m_Var);

RF_DECL (Bind_m_Iter_m_Var);

RF_DECL (Lookup_m_Iter_m_Var);

RF_DECL (Bind_m_TMP_m_Var);

RF_DECL (Lookup_m_TMP_m_Var);

RF_DECL (Bind_m_Label);

RF_DECL (Lookup_m_Label);

static Expr Traps;

RF_DECL (Push_m_Trap);

RF_DECL (Get_m_Trap);

RF_DECL (Pop_m_Trap);

RF_DECL (Qualified_m_Module_m_Name);

RF_DECL (Function_m_Description);

RF_DECL (Module_m_To_m_JBC);

RF_DECL (ASAIL_m_To_m_JBC);

RF_DECL (Expr_m_Ref_m_To_m_JBC);

RF_DECL (Term_m_Ref_m_To_m_JBC);

RF_DECL (Expr_m_Int_m_To_m_JBC);

RF_DECL (Infix_m_To_m_JBC);

RF_DECL (Cond_m_To_m_JBC);

RF_DECL (Step_m_To_m_JBC);

RF_DECL (Const_m_Expr_m_To_m_JBC);

RF_DECL (Get_m_String_m_From_m_Const_m_Expr);

RF_DECL (Convert_m_Const_m_Expr);

RF_DECL (Const_m_Term_m_To_m_JBC);

RF_DECL (Var_m_To_m_JBC);

RF_DECL (Access_m_Mode);

RF_DECL (Expr_m_Int_m_To_m_JBC__0);

RF_DECL (To_m_Word__0);

static Expr _c_0;

static Expr _c_1;

static Expr _c_2;

static Expr _c_3;

static Expr _c_4;

static Expr _c_5;

static Expr _c_53;

static Expr _c_6;

static Expr _c_7;

static Expr _c_8;

static Expr _c_9;

static Expr _c_10;

static Expr _c_11;

static Expr _c_12;

static Expr _c_13;

static Expr _c_14;

static Expr _c_15;

static Expr _c_16;

static Expr _c_17;

static Expr _c_18;

static Expr _c_19;

static Expr _c_20;

static Expr _c_21;

static Expr _c_22;

static Expr _c_23;

static Expr _c_24;

static Expr _c_25;

static Expr _c_26;

static Expr _c_27;

static Expr _c_28;

static Expr _c_29;

static Expr _c_30;

static Expr _c_31;

static Expr _c_32;

static Expr _c_33;

static Expr _c_34;

static Expr _c_35;

static Expr _c_36;

static Expr _c_37;

static Expr _c_38;

static Expr _c_39;

static Expr _c_40;

static Expr _c_41;

static Expr _c_42;

static Expr _c_43;

static Expr _c_44;

static Expr _c_45;

static Expr _c_46;

static Expr _c_47;

static Expr _c_48;

static Expr _c_49;

static Expr _c_50;

static Expr _c_51;

static Expr _c_52;

static Expr _c_54;

static Expr _c_55;

static Expr _c_56;

static Expr _c_57;

static Expr _c_58;

static Expr _c_59;

static Expr _c_60;

static Expr _c_61;

static Expr _c_62;

static Expr _c_63;

static Expr _c_64;

static Expr _c_65;

static Expr _c_66;

static Expr _c_67;

static Expr _c_68;

static Expr _c_69;

static Expr _c_70;

static Expr _c_71;

static Expr _c_72;

static Expr _c_73;

static Expr _c_74;

static Expr _c_75;

static Expr _c_76;

static Expr _c_77;

static Expr _c_78;

static Expr _c_79;

static Expr _c_80;

static Expr _c_81;

static Expr _c_82;

static Expr _c_83;

static Expr _c_84;

static Expr _c_85;

static Expr _c_86;

static Expr _c_87;

static Expr _c_88;

static Expr _c_89;

static Expr _c_90;

static Expr _c_91;

static Expr _c_92;

static Expr _c_93;

static Expr _c_94;

static Expr _c_95;

static Expr _c_96;

static Expr _c_97;

static Expr _c_98;

static Expr _c_99;

static Expr _c_100;

static Expr _c_101;

static Expr _c_102;

static Expr _c_103;

static Expr _c_104;

static Expr _c_105;

static Expr _c_106;

static Expr _c_107;

static Expr _c_108;

static Expr _c_109;

static Expr _c_110;

static Expr _c_111;

static Expr _c_112;

static Expr _c_113;

static Expr _c_114;

static Expr _c_115;

static Expr _c_116;

static Expr _c_187;

static Expr _c_117;

static Expr _c_118;

static Expr _c_119;

static Expr _c_120;

static Expr _c_121;

static Expr _c_122;

static Expr _c_123;

static Expr _c_124;

static Expr _c_125;

static Expr _c_126;

static Expr _c_127;

static Expr _c_128;

static Expr _c_129;

static Expr _c_130;

static Expr _c_131;

static Expr _c_132;

static Expr _c_133;

static Expr _c_134;

static Expr _c_135;

static Expr _c_136;

static Expr _c_137;

static Expr _c_138;

static Expr _c_139;

static Expr _c_140;

static Expr _c_141;

static Expr _c_142;

static Expr _c_143;

static Expr _c_144;

static Expr _c_145;

static Expr _c_146;

static Expr _c_147;

static Expr _c_148;

static Expr _c_149;

static Expr _c_150;

static Expr _c_151;

static Expr _c_152;

static Expr _c_153;

static Expr _c_154;

static Expr _c_155;

static Expr _c_156;

static Expr _c_157;

static Expr _c_158;

static Expr _c_159;

static Expr _c_160;

static Expr _c_161;

static Expr _c_162;

static Expr _c_163;

static Expr _c_164;

static Expr _c_165;

static Expr _c_166;

static Expr _c_167;

static Expr _c_168;

static Expr _c_169;

static Expr _c_170;

static Expr _c_171;

static Expr _c_172;

static Expr _c_173;

static Expr _c_174;

static Expr _c_175;

static Expr _c_176;

static Expr _c_177;

static Expr _c_178;

static Expr _c_179;

static Expr _c_180;

static Expr _c_181;

static Expr _c_182;

static Expr _c_183;

static Expr _c_184;

static Expr _c_185;

static Expr _c_186;

RF_FUNC (MV, RF_VOID, (RF_RES _v_res1;;))
  Expr _v__q_1;
  RF_CALL (Box::_q_, MVbox, _v__q_1);
  if (_v__q_1.get_len () != 1)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_v__q_1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _vs_mv (_v__q_1, 0, 1);
  _v_res1 = _vs_mv;
RF_END

RF_FUNC (RFP_m_ASAIL_m_To_m_JBC, (RF_ARG _gt_arg1, _ge_arg2, _ge_arg3, _ge_arg4;;), (RF_RES _v_res1;;))
  uintptr_t _v_len1 = (_ge_arg4.get_len () + 3);
  uintptr_t _v_len2 = 3;
  if (_v_len1 < _v_len2)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len__module = (_v_len1 - _v_len2);
  Expr _v_compose1 ((_gt_arg1 + _ge_arg2 () + _ge_arg3 () + _ge_arg4));
  if (_v_compose1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (_v_compose1.symbol_at ((0 + 1)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (_v_compose1.symbol_at ((0 + 1 + 1)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _v_deref__compose1 (_v_compose1, 0);
  Expr _v_deref__compose12 (_v_compose1, (0 + 1));
  Expr _v_deref__compose13 (_v_compose1, (0 + 1 + 1));
  uintptr_t _v_len3 = _v_deref__compose1.get_len ();
  uintptr_t _v_len4 = 0;
  if (_v_len3 < _v_len4)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len__module_m_name = (_v_len3 - _v_len4);
  uintptr_t _v_len5 = _v_deref__compose13.get_len ();
  uintptr_t _v_len6 = 0;
  if (_v_len5 < _v_len6)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len__exports = (_v_len5 - _v_len6);
  uintptr_t _v_len7 = _v_deref__compose12.get_len ();
  uintptr_t _v_len8 = 0;
  if (_v_len7 < _v_len8)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len__package = (_v_len7 - _v_len8);
  Expr _ve_module (_v_compose1, (0 + 1 + 1 + 1), _v_len__module);
  Expr _ve_module_m_name (_v_deref__compose1, 0, _v_len__module_m_name);
  Expr _ve_package (_v_deref__compose12, 0, _v_len__package);
  Expr _ve_exports (_v_deref__compose13, 0, _v_len__exports);
  RF_CALL (Box::Store, (Objects, empty), /*void*/);
  RF_CALL (Box::Store, (Constants, empty), /*void*/);
  RF_CALL (Box::Store, (Func_m_Refs, empty), /*void*/);
  {
    {
      Expr _ge_auxcall1;
      if (!RF_CALL (Table::Lookup, (rfp__helper::RFP_m_Options, _c_0), _ge_auxcall1))
      {
        goto _block1__branch1;
      }
      RF_CALL (Box::Store, (Int, _ge_auxcall1), /*void*/);
      goto _block1;
    }
  _block1__branch1: {}
    RF_CALL (Box::Store, (Int, _c_1), /*void*/);
  }
_block1: {}
  RF_CALL (Box::Store, (Exports, _ve_exports), /*void*/);
  {
    {
      Expr _ge_auxcall2;
      if (!RF_CALL (Table::Lookup, (rfp__helper::RFP_m_Options, _c_2), _ge_auxcall2))
      {
        goto _block2__branch1;
      }
      RF_CALL (Box::Store, (Entry, _ge_auxcall2), /*void*/);
      goto _block2;
    }
  _block2__branch1: {}
    RF_CALL (Box::Store, (Entry, (_ve_module_m_name + _c_3) ()), /*void*/);
  }
_block2: {}
  RF_CALL (Box::Store, (Entry_m_Name, empty), /*void*/);
  Expr _vs_refal_m_mod_m_name;
  RF_CALL (Convert::To_m_Word, _ve_module_m_name, _vs_refal_m_mod_m_name);
  RF_CALL (Box::Store, (Refal_m_Module_m_Name, _vs_refal_m_mod_m_name), /*void*/);
  Expr _ge_auxcall3;
  RF_CALL (Box::_q_, File::Dir_m_Separator, _ge_auxcall3);
  Expr _ge_auxcall4;
  RF_CALL (List::Separate, (_ge_auxcall3, _ve_package), _ge_auxcall4);
  Expr _ge_auxcall5;
  RF_CALL (JavaMangle::Rfp2Java, _ve_module_m_name, _ge_auxcall5);
  Expr _ge_auxcall6;
  RF_CALL (List::Separate, (_c_4, _ge_auxcall5), _ge_auxcall6);
  Expr _ge_auxcall7;
  if (!RF_CALL (List::Map_e_, (_c_5, empty, (_ge_auxcall4 + _ge_auxcall6)), _ge_auxcall7))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _ve_java_m_module_m_name;
  RF_CALL (List::Concat, _ge_auxcall7, _ve_java_m_module_m_name);
  RF_CALL (Box::Store, (Module_m_Name, _ve_java_m_module_m_name), /*void*/);
  Expr _ge_auxcall8;
  RF_CALL (List::Intersperse, (_c_6, _ve_java_m_module_m_name), _ge_auxcall8);
  Expr _vs_class_m_name;
  RF_CALL (Convert::To_m_Word, _ge_auxcall8, _vs_class_m_name);
  Expr _gs_auxcall9;
  RF_CALL (Arithm::_p_, (_c_7, _c_8), _gs_auxcall9);
  Expr _vs_cw;
  RF_CALL (ClassWriter::ClassWriter, _gs_auxcall9, _vs_cw);
  Expr _gs_auxcall10;
  RF_CALL (Java::Null, /*void*/, _gs_auxcall10);
  RF_CALL (ClassWriter::CWvisit, (_vs_cw, _c_9, _c_7, _vs_class_m_name, _gs_auxcall10, _c_10, empty), /*void*/);
  RF_CALL (Module_m_To_m_JBC, (_vs_cw, _ve_module), /*void*/);
  {
    {
      Expr _v__q_1;
      RF_CALL (Box::_q_, Entry_m_Name, _v__q_1);
      if (_v__q_1.get_len () != 1)
      {
        goto _block3__branch1;
      }
      if (!_v__q_1.symbol_at (0))
      {
        goto _block3__branch1;
      }
      Expr _vs_name (_v__q_1, 0, 1);
      Expr _gs_auxcall11;
      RF_CALL (Arithm::_p_, (_c_7, _c_11), _gs_auxcall11);
      Expr _gs_auxcall12;
      RF_CALL (Java::Null, /*void*/, _gs_auxcall12);
      Expr _gs_auxcall13;
      RF_CALL (ClassWriter::CWvisitMethod, (_vs_cw, _gs_auxcall11, _c_12, _c_13, _gs_auxcall12, empty), _gs_auxcall13);
      RF_CALL (Box::Store, (MVbox, _gs_auxcall13), /*void*/);
      Expr _gs_auxcall14;
      RF_CALL (MV, /*void*/, _gs_auxcall14);
      Expr _gs_auxcall15;
      RF_CALL (Java::WordToString, _vs_refal_m_mod_m_name, _gs_auxcall15);
      RF_CALL (MethodVisitor::MVvisitLdcInsn, (_gs_auxcall14, _gs_auxcall15), /*void*/);
      Expr _gs_auxcall16;
      RF_CALL (MV, /*void*/, _gs_auxcall16);
      RF_CALL (MethodVisitor::MVvisitVarInsn, (_gs_auxcall16, _c_14, _c_15), /*void*/);
      Expr _gs_auxcall17;
      RF_CALL (MV, /*void*/, _gs_auxcall17);
      RF_CALL (MethodVisitor::MVvisitMethodInsn, (_gs_auxcall17, _c_16, _c_17, _c_18, _c_19), /*void*/);
      Expr _gs_auxcall18;
      RF_CALL (MV, /*void*/, _gs_auxcall18);
      RF_CALL (MethodVisitor::MVvisitTypeInsn, (_gs_auxcall18, _c_20, _c_21), /*void*/);
      Expr _gs_auxcall19;
      RF_CALL (MV, /*void*/, _gs_auxcall19);
      RF_CALL (MethodVisitor::MVvisitInsn, (_gs_auxcall19, _c_22), /*void*/);
      Expr _gs_auxcall20;
      RF_CALL (MV, /*void*/, _gs_auxcall20);
      RF_CALL (MethodVisitor::MVvisitMethodInsn, (_gs_auxcall20, _c_23, _c_21, _c_24, _c_25), /*void*/);
      Expr _gs_auxcall21;
      RF_CALL (MV, /*void*/, _gs_auxcall21);
      RF_CALL (MethodVisitor::MVvisitMethodInsn, (_gs_auxcall21, _c_16, _vs_class_m_name, _vs_name, _c_26), /*void*/);
      Expr _gs_auxcall22;
      RF_CALL (MV, /*void*/, _gs_auxcall22);
      RF_CALL (MethodVisitor::MVvisitInsn, (_gs_auxcall22, _c_27), /*void*/);
      Expr _gs_auxcall23;
      RF_CALL (MV, /*void*/, _gs_auxcall23);
      RF_CALL (MethodVisitor::MVvisitMaxs, (_gs_auxcall23, _c_15, _c_15), /*void*/);
      Expr _gs_auxcall24;
      RF_CALL (MV, /*void*/, _gs_auxcall24);
      RF_CALL (MethodVisitor::MVvisitEnd, _gs_auxcall24, /*void*/);
      goto _block3;
    }
  _block3__branch1: {}
  }
_block3: {}
  Expr _gs_auxcall25;
  RF_CALL (Java::Null, /*void*/, _gs_auxcall25);
  Expr _gs_auxcall26;
  RF_CALL (ClassWriter::CWvisitMethod, (_vs_cw, _c_11, _c_28, _c_25, _gs_auxcall25, empty), _gs_auxcall26);
  RF_CALL (Box::Store, (MVbox, _gs_auxcall26), /*void*/);
  {
    Expr _v__q_2;
    RF_CALL (Box::_q_, Objects, _v__q_2);
    if (_v__q_2.get_len () < 1)
    {
      goto _block4__branch1;
    }
    RF_lsplit (_v__q_2, 0, _ve__e__e_tmp_m_rfp__asail__jbcrf_m_110_m_21, _v_lsplit___q_2);
    for ( ; ; RF_iter(_v__q_2)++)
    {
      {
        if (!RF_iter(_v__q_2))
        {
          goto _block4__branch1;
        }
        uintptr_t _v_len9 = _v_lsplit___q_2.get_len ();
        uintptr_t _v_len10 = 1;
        if (_v_len9 < _v_len10)
        {
          goto _block4__branch1;
        }
        uintptr_t _v_len___e__e_tmp_m_rfp__asail__jbcrf_m_110_m_54 = (_v_len9 - _v_len10);
        if (_v_lsplit___q_2.symbol_at (0))
        {
          goto _continue1;
        }
        Expr _v_deref__lsplit___q_2 (_v_lsplit___q_2, 0);
        uintptr_t _v_len11 = _v_deref__lsplit___q_2.get_len ();
        uintptr_t _v_len12 = 2;
        if (_v_len11 < _v_len12)
        {
          goto _continue1;
        }
        uintptr_t _v_len__cl_m_name = (_v_len11 - _v_len12);
        if (!_v_deref__lsplit___q_2.symbol_at (0))
        {
          goto _continue1;
        }
        if (!_v_deref__lsplit___q_2.symbol_at ((0 + 1)))
        {
          goto _continue1;
        }
        Expr _ve__e__e_tmp_m_rfp__asail__jbcrf_m_110_m_54 (_v_lsplit___q_2, (0 + 1), _v_len___e__e_tmp_m_rfp__asail__jbcrf_m_110_m_54);
        Expr _vs_j_m_name (_v_deref__lsplit___q_2, 0, 1);
        Expr _vs_rf_m_name (_v_deref__lsplit___q_2, (0 + 1), 1);
        Expr _ve_cl_m_name (_v_deref__lsplit___q_2, (0 + 1 + 1), _v_len__cl_m_name);
        Expr _vs_cl_m_name;
        RF_CALL (Convert::To_m_Word, (_c_29 + _ve_cl_m_name), _vs_cl_m_name);
        Expr _gs_auxcall27;
        RF_CALL (MV, /*void*/, _gs_auxcall27);
        RF_CALL (MethodVisitor::MVvisitTypeInsn, (_gs_auxcall27, _c_20, _c_30), /*void*/);
        Expr _gs_auxcall28;
        RF_CALL (MV, /*void*/, _gs_auxcall28);
        RF_CALL (MethodVisitor::MVvisitInsn, (_gs_auxcall28, _c_22), /*void*/);
        Expr _gs_auxcall29;
        RF_CALL (MV, /*void*/, _gs_auxcall29);
        RF_CALL (MethodVisitor::MVvisitTypeInsn, (_gs_auxcall29, _c_20, _vs_cl_m_name), /*void*/);
        Expr _gs_auxcall30;
        RF_CALL (MV, /*void*/, _gs_auxcall30);
        RF_CALL (MethodVisitor::MVvisitInsn, (_gs_auxcall30, _c_22), /*void*/);
        Expr _gs_auxcall31;
        RF_CALL (MV, /*void*/, _gs_auxcall31);
        Expr _gs_auxcall32;
        RF_CALL (Java::WordToString, _vs_rf_m_name, _gs_auxcall32);
        RF_CALL (MethodVisitor::MVvisitLdcInsn, (_gs_auxcall31, _gs_auxcall32), /*void*/);
        Expr _gs_auxcall33;
        RF_CALL (MV, /*void*/, _gs_auxcall33);
        RF_CALL (MethodVisitor::MVvisitMethodInsn, (_gs_auxcall33, _c_23, _vs_cl_m_name, _c_24, _c_31), /*void*/);
        Expr _gs_auxcall34;
        RF_CALL (MV, /*void*/, _gs_auxcall34);
        RF_CALL (MethodVisitor::MVvisitMethodInsn, (_gs_auxcall34, _c_23, _c_30, _c_24, _c_32), /*void*/);
        Expr _gs_auxcall35;
        RF_CALL (MV, /*void*/, _gs_auxcall35);
        RF_CALL (MethodVisitor::MVvisitFieldInsn, (_gs_auxcall35, _c_33, _vs_class_m_name, _vs_j_m_name, _c_34), /*void*/);
      }
  _continue1: {}
    }
  _exit1: {}
  }
_block4__branch1: {}
  {
    Expr _v__q_3;
    RF_CALL (Box::_q_, Constants, _v__q_3);
    if (_v__q_3.get_len () < 1)
    {
      goto _block5__branch1;
    }
    RF_lsplit (_v__q_3, 0, _ve__e__e_tmp_m_rfp__asail__jbcrf_m_123_m_23, _v_lsplit___q_3);
    for ( ; ; RF_iter(_v__q_3)++)
    {
      {
        if (!RF_iter(_v__q_3))
        {
          goto _block5__branch1;
        }
        uintptr_t _v_len13 = _v_lsplit___q_3.get_len ();
        uintptr_t _v_len14 = 1;
        if (_v_len13 < _v_len14)
        {
          goto _block5__branch1;
        }
        uintptr_t _v_len___e__e_tmp_m_rfp__asail__jbcrf_m_123_m_47 = (_v_len13 - _v_len14);
        if (_v_lsplit___q_3.symbol_at (0))
        {
          goto _continue2;
        }
        Expr _v_deref__lsplit___q_3 (_v_lsplit___q_3, 0);
        uintptr_t _v_len15 = _v_deref__lsplit___q_3.get_len ();
        uintptr_t _v_len16 = 1;
        if (_v_len15 < _v_len16)
        {
          goto _continue2;
        }
        uintptr_t _v_len__expr = (_v_len15 - _v_len16);
        if (!_v_deref__lsplit___q_3.symbol_at (0))
        {
          goto _continue2;
        }
        Expr _ve__e__e_tmp_m_rfp__asail__jbcrf_m_123_m_47 (_v_lsplit___q_3, (0 + 1), _v_len___e__e_tmp_m_rfp__asail__jbcrf_m_123_m_47);
        Expr _vs_const_m_name (_v_deref__lsplit___q_3, 0, 1);
        Expr _ve_expr (_v_deref__lsplit___q_3, (0 + 1), _v_len__expr);
        RF_CALL (Const_m_Expr_m_To_m_JBC, _ve_expr, /*void*/);
        Expr _gs_auxcall36;
        RF_CALL (MV, /*void*/, _gs_auxcall36);
        Expr _ge_auxcall37;
        RF_CALL (List::Intersperse, (_c_6, _ve_java_m_module_m_name), _ge_auxcall37);
        Expr _gs_auxcall38;
        RF_CALL (Convert::To_m_Word, _ge_auxcall37, _gs_auxcall38);
        RF_CALL (MethodVisitor::MVvisitFieldInsn, (_gs_auxcall36, _c_33, _gs_auxcall38, _vs_const_m_name, _c_34), /*void*/);
      }
  _continue2: {}
    }
  _exit2: {}
  }
_block5__branch1: {}
  Expr _gs_auxcall39;
  RF_CALL (MV, /*void*/, _gs_auxcall39);
  RF_CALL (MethodVisitor::MVvisitInsn, (_gs_auxcall39, _c_27), /*void*/);
  Expr _gs_auxcall40;
  RF_CALL (MV, /*void*/, _gs_auxcall40);
  RF_CALL (MethodVisitor::MVvisitMaxs, (_gs_auxcall40, _c_15, _c_15), /*void*/);
  Expr _gs_auxcall41;
  RF_CALL (MV, /*void*/, _gs_auxcall41);
  RF_CALL (MethodVisitor::MVvisitEnd, _gs_auxcall41, /*void*/);
  RF_CALL (ClassWriter::CWvisitEnd, _vs_cw, /*void*/);
  Expr _gs_auxcall42;
  RF_CALL (ClassWriter::CWtoByteArray, _vs_cw, _gs_auxcall42);
  Expr _vs_res;
  RF_CALL (Box::Box, (_gs_auxcall42 + _ve_java_m_module_m_name) (), _vs_res);
  {
    Expr _v__q_4;
    RF_CALL (Box::_q_, Func_m_Refs, _v__q_4);
    if (_v__q_4.get_len () < 1)
    {
      goto _block6__branch1;
    }
    RF_lsplit (_v__q_4, 0, _ve__e__e_tmp_m_rfp__asail__jbcrf_m_142_m_23, _v_lsplit___q_4);
    for ( ; ; RF_iter(_v__q_4)++)
    {
      {
        if (!RF_iter(_v__q_4))
        {
          goto _block6__branch1;
        }
        uintptr_t _v_len17 = _v_lsplit___q_4.get_len ();
        uintptr_t _v_len18 = 1;
        if (_v_len17 < _v_len18)
        {
          goto _block6__branch1;
        }
        uintptr_t _v_len___e__e_tmp_m_rfp__asail__jbcrf_m_142_m_67 = (_v_len17 - _v_len18);
        if (_v_lsplit___q_4.symbol_at (0))
        {
          goto _continue3;
        }
        Expr _v_deref__lsplit___q_4 (_v_lsplit___q_4, 0);
        if (_v_deref__lsplit___q_4.get_len () != 4)
        {
          goto _continue3;
        }
        if (!_v_deref__lsplit___q_4.symbol_at (0))
        {
          goto _continue3;
        }
        if (!_v_deref__lsplit___q_4.symbol_at ((0 + 1)))
        {
          goto _continue3;
        }
        if (!_v_deref__lsplit___q_4.symbol_at ((0 + 1 + 1)))
        {
          goto _continue3;
        }
        if (!_v_deref__lsplit___q_4.symbol_at ((0 + 1 + 1 + 1)))
        {
          goto _continue3;
        }
        Expr _ve__e__e_tmp_m_rfp__asail__jbcrf_m_142_m_67 (_v_lsplit___q_4, (0 + 1), _v_len___e__e_tmp_m_rfp__asail__jbcrf_m_142_m_67);
        Expr _vs_cl_m_name (_v_deref__lsplit___q_4, 0, 1);
        Expr _vs_mod_m_name (_v_deref__lsplit___q_4, (0 + 1), 1);
        Expr _vs_func_m_name (_v_deref__lsplit___q_4, (0 + 1 + 1), 1);
        Expr _vs_type (_v_deref__lsplit___q_4, (0 + 1 + 1 + 1), 1);
        Expr _gs_auxcall43;
        RF_CALL (Arithm::_p_, (_c_7, _c_8), _gs_auxcall43);
        Expr _gs_cw__2;
        RF_CALL (ClassWriter::ClassWriter, _gs_auxcall43, _gs_cw__2);
        Expr _gs_auxcall44;
        RF_CALL (Convert::To_m_Word, (_vs_class_m_name + _c_35 + _vs_cl_m_name), _gs_auxcall44);
        Expr _gs_auxcall45;
        RF_CALL (Java::Null, /*void*/, _gs_auxcall45);
        RF_CALL (ClassWriter::CWvisit, (_gs_cw__2, _c_9, _c_36, _gs_auxcall44, _gs_auxcall45, _c_10, _c_37), /*void*/);
        Expr _gs_auxcall46;
        RF_CALL (Java::Null, /*void*/, _gs_auxcall46);
        Expr _vs_mv;
        RF_CALL (ClassWriter::CWvisitMethod, (_gs_cw__2, _c_15, _c_24, _c_25, _gs_auxcall46, empty), _vs_mv);
        RF_CALL (MethodVisitor::MVvisitVarInsn, (_vs_mv, _c_14, _c_15), /*void*/);
        RF_CALL (MethodVisitor::MVvisitMethodInsn, (_vs_mv, _c_23, _c_10, _c_24, _c_25), /*void*/);
        RF_CALL (MethodVisitor::MVvisitInsn, (_vs_mv, _c_27), /*void*/);
        RF_CALL (MethodVisitor::MVvisitMaxs, (_vs_mv, _c_15, _c_15), /*void*/);
        RF_CALL (MethodVisitor::MVvisitEnd, _vs_mv, /*void*/);
        Expr _gs_auxcall47;
        RF_CALL (Java::Null, /*void*/, _gs_auxcall47);
        RF_CALL (ClassWriter::CWvisitMethod, (_gs_cw__2, _c_7, _c_38, _c_39, _gs_auxcall47, _c_40), _vs_mv);
        RF_CALL (MethodVisitor::MVvisitVarInsn, (_vs_mv, _c_14, _c_7), /*void*/);
        RF_CALL (MethodVisitor::MVvisitVarInsn, (_vs_mv, _c_14, _c_8), /*void*/);
        {
          {
            if (!_vs_type.term_eq (_c_41, 0))
            {
              goto _block7__branch1;
            }
            RF_CALL (MethodVisitor::MVvisitMethodInsn, (_vs_mv, _c_16, _vs_mod_m_name, _vs_func_m_name, _c_39), /*void*/);
            RF_CALL (MethodVisitor::MVvisitInsn, (_vs_mv, _c_42), /*void*/);
            goto _block7;
          }
        _block7__branch1: {}
          if (!_vs_type.term_eq (_c_43, 0))
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          RF_CALL (MethodVisitor::MVvisitMethodInsn, (_vs_mv, _c_16, _vs_mod_m_name, _vs_func_m_name, _c_44), /*void*/);
          RF_CALL (MethodVisitor::MVvisitInsn, (_vs_mv, _c_45), /*void*/);
          RF_CALL (MethodVisitor::MVvisitInsn, (_vs_mv, _c_42), /*void*/);
        }
      _block7: {}
        RF_CALL (MethodVisitor::MVvisitMaxs, (_vs_mv, _c_15, _c_15), /*void*/);
        RF_CALL (MethodVisitor::MVvisitEnd, _vs_mv, /*void*/);
        RF_CALL (ClassWriter::CWvisitEnd, _gs_cw__2, /*void*/);
        Expr _gs_auxcall48;
        RF_CALL (ClassWriter::CWtoByteArray, _gs_cw__2, _gs_auxcall48);
        Expr _ge_auxcall49;
        if (!RF_CALL (Access::Middle, (_c_15, _c_7, _ve_java_m_module_m_name), _ge_auxcall49))
        {
          goto _continue3;
        }
        Expr _gt_auxcall50;
        if (!RF_CALL (Access::R, (_c_15, _ve_java_m_module_m_name), _gt_auxcall50))
        {
          goto _continue3;
        }
        Expr _gs_auxcall51;
        RF_CALL (Convert::To_m_Word, (_gt_auxcall50 + _c_35 + _vs_cl_m_name), _gs_auxcall51);
        RF_CALL (Box::Put, (_vs_res, (_gs_auxcall48 + _ge_auxcall49 + _gs_auxcall51) ()), /*void*/);
      }
  _continue3: {}
    }
  _exit3: {}
  }
_block6__branch1: {}
  RF_TAILCALL (Box::_q_, _vs_res, _v_res1);
RF_END

RF_FUNC (Init_m_Block_m_Table, RF_VOID, RF_VOID)
  Expr _vs_block_m_table;
  RF_CALL (Table::Table, /*void*/, _vs_block_m_table);
  RF_CALL (Table::Bind, (_vs_block_m_table, _c_46, _c_15), /*void*/);
  RF_TAILCALL (Box::Store, (Block_m_Tables, _vs_block_m_table), /*void*/);
RF_END

RF_FUNC (Push_m_Block_m_Table, RF_VOID, RF_VOID)
  Expr _v__q_1;
  RF_CALL (Box::_q_, Block_m_Tables, _v__q_1);
  uintptr_t _v_len1 = _v__q_1.get_len ();
  uintptr_t _v_len2 = 0;
  if (_v_len1 < _v_len2)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len__block_m_tables = (_v_len1 - _v_len2);
  uintptr_t _v_len3 = _v_len__block_m_tables;
  uintptr_t _v_len4 = 1;
  if (_v_len3 < _v_len4)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len___e__e_tmp_m_rfp__asail__jbcrf_m_189_m_21 = (_v_len3 - _v_len4);
  Expr _ve_block_m_tables (_v__q_1, 0, _v_len__block_m_tables);
  if (!_ve_block_m_tables.symbol_at ((0 + _v_len___e__e_tmp_m_rfp__asail__jbcrf_m_189_m_21)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _ve__e__e_tmp_m_rfp__asail__jbcrf_m_189_m_21 (_ve_block_m_tables, 0, _v_len___e__e_tmp_m_rfp__asail__jbcrf_m_189_m_21);
  Expr _vs_block_m_table (_ve_block_m_tables, (0 + _v_len___e__e_tmp_m_rfp__asail__jbcrf_m_189_m_21), 1);
  Expr _gs_auxcall1;
  RF_CALL (Table::Table_m_Copy, _vs_block_m_table, _gs_auxcall1);
  RF_TAILCALL (Box::Store, (Block_m_Tables, (_ve_block_m_tables + _gs_auxcall1)), /*void*/);
RF_END

RF_FUNC (Pop_m_Block_m_Table, RF_VOID, RF_VOID)
  Expr _v__q_1;
  RF_CALL (Box::_q_, Block_m_Tables, _v__q_1);
  uintptr_t _v_len1 = _v__q_1.get_len ();
  uintptr_t _v_len2 = 2;
  if (_v_len1 < _v_len2)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len__block_m_tables = (_v_len1 - _v_len2);
  if (!_v__q_1.symbol_at ((0 + _v_len__block_m_tables)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_v__q_1.symbol_at ((0 + _v_len__block_m_tables + 1)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _ve_block_m_tables (_v__q_1, 0, _v_len__block_m_tables);
  Expr _vs_block_m_table1 (_v__q_1, (0 + _v_len__block_m_tables), 1);
  Expr _vs_block_m_table2 (_v__q_1, (0 + _v_len__block_m_tables + 1), 1);
  Expr _v_Lookup1;
  if (!RF_CALL (Table::Lookup, (_vs_block_m_table2, _c_46), _v_Lookup1))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (_v_Lookup1.get_len () != 1)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_v_Lookup1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _vs_i (_v_Lookup1, 0, 1);
  RF_CALL (Table::Bind, (_vs_block_m_table1, _c_46, _vs_i), /*void*/);
  RF_TAILCALL (Box::Store, (Block_m_Tables, (_ve_block_m_tables + _vs_block_m_table1)), /*void*/);
RF_END

RF_FUNC (Get_m_Block_m_Table, RF_VOID, (RF_RES _v_res1;;))
  Expr _v__q_1;
  RF_CALL (Box::_q_, Block_m_Tables, _v__q_1);
  uintptr_t _v_len1 = _v__q_1.get_len ();
  uintptr_t _v_len2 = 1;
  if (_v_len1 < _v_len2)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len___e__e_tmp_m_rfp__asail__jbcrf_m_199_m_24 = (_v_len1 - _v_len2);
  if (!_v__q_1.symbol_at ((0 + _v_len___e__e_tmp_m_rfp__asail__jbcrf_m_199_m_24)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _ve__e__e_tmp_m_rfp__asail__jbcrf_m_199_m_24 (_v__q_1, 0, _v_len___e__e_tmp_m_rfp__asail__jbcrf_m_199_m_24);
  Expr _vs_block_m_table (_v__q_1, (0 + _v_len___e__e_tmp_m_rfp__asail__jbcrf_m_199_m_24), 1);
  _v_res1 = _vs_block_m_table;
RF_END

RF_FUNC (Bind_m_Vars, (RF_ARG _vs_type, _ve_vars;;), RF_VOID)
  {
    if (_ve_vars.get_len () < 1)
    {
      goto _block1__branch1;
    }
    RF_lsplit (_ve_vars, 0, _ve__e__e_tmp_m_rfp__asail__jbcrf_m_212_m_15, _v_lsplit__vars);
    for ( ; ; RF_iter(_ve_vars)++)
    {
      {
        if (!RF_iter(_ve_vars))
        {
          goto _block1__branch1;
        }
        uintptr_t _v_len1 = _v_lsplit__vars.get_len ();
        uintptr_t _v_len2 = 1;
        if (_v_len1 < _v_len2)
        {
          goto _block1__branch1;
        }
        uintptr_t _v_len___e__e_tmp_m_rfp__asail__jbcrf_m_212_m_23 = (_v_len1 - _v_len2);
        Expr _vt_var (_v_lsplit__vars, 0, 1);
        Expr _ve__e__e_tmp_m_rfp__asail__jbcrf_m_212_m_23 (_v_lsplit__vars, (0 + 1), _v_len___e__e_tmp_m_rfp__asail__jbcrf_m_212_m_23);
        Expr _v_Bind_m_Var1;
        RF_CALL (Bind_m_Var, (_vs_type, _vt_var), _v_Bind_m_Var1);
        uintptr_t _v_len3 = 1;
        uintptr_t _v_len4 = 0;
        if (_v_len3 < _v_len4)
        {
          goto _continue1;
        }
        uintptr_t _v_len___e__e_tmp_m_rfp__asail__jbcrf_m_213_m_34 = (_v_len3 - _v_len4);
        Expr _ve__e__e_tmp_m_rfp__asail__jbcrf_m_213_m_34 (_v_Bind_m_Var1, 0, _v_len___e__e_tmp_m_rfp__asail__jbcrf_m_213_m_34);
      }
  _continue1: {}
    }
  _exit1: {}
  }
_block1__branch1: {}
RF_END

RF_FUNC (Bind_m_Var, (RF_ARG _vs_type, _vt_var;;), (RF_RES _v_res1;;))
  Expr _gs_auxcall1;
  RF_CALL (Get_m_Block_m_Table, /*void*/, _gs_auxcall1);
  Expr _v_Lookup1;
  if (!RF_CALL (Table::Lookup, (_gs_auxcall1, _c_46), _v_Lookup1))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (_v_Lookup1.get_len () != 1)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_v_Lookup1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _vs_i (_v_Lookup1, 0, 1);
  Expr _gs_auxcall2;
  RF_CALL (Get_m_Block_m_Table, /*void*/, _gs_auxcall2);
  Expr _gs_auxcall3;
  RF_CALL (Arithm::_p_, (_vs_i, _c_7), _gs_auxcall3);
  RF_CALL (Table::Bind, (_gs_auxcall2, _c_46, _gs_auxcall3), /*void*/);
  Expr _gs_auxcall4;
  RF_CALL (Get_m_Block_m_Table, /*void*/, _gs_auxcall4);
  RF_CALL (Table::Bind, (_gs_auxcall4, (_c_47 + _vt_var), (_vs_type + _vs_i)), /*void*/);
  _v_res1 = _vs_i;
RF_END

RF_FUNC (Lookup_m_Var, (RF_ARG _vt_var;;), (RF_RES _v_res1, _v_res2;;))
  Expr _gs_auxcall1;
  RF_CALL (Get_m_Block_m_Table, /*void*/, _gs_auxcall1);
  Expr _v_Lookup1;
  if (!RF_CALL (Table::Lookup, (_gs_auxcall1, (_c_47 + _vt_var)), _v_Lookup1))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (_v_Lookup1.get_len () != 2)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_v_Lookup1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_v_Lookup1.symbol_at ((0 + 1)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _vs_type (_v_Lookup1, 0, 1);
  Expr _vs_i (_v_Lookup1, (0 + 1), 1);
  _v_res1 = _vs_type;
  _v_res2 = _vs_i;
RF_END

RF_FUNC (Bind_m_Iter_m_Var, (RF_ARG _ve_expr, _vt_var1, _vt_var2;;), (RF_RES _v_res1;;))
  Expr _gs_auxcall1;
  RF_CALL (Get_m_Block_m_Table, /*void*/, _gs_auxcall1);
  Expr _v_Lookup1;
  if (!RF_CALL (Table::Lookup, (_gs_auxcall1, _c_46), _v_Lookup1))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (_v_Lookup1.get_len () != 1)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_v_Lookup1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _vs_i (_v_Lookup1, 0, 1);
  Expr _gs_auxcall2;
  RF_CALL (Get_m_Block_m_Table, /*void*/, _gs_auxcall2);
  Expr _gs_auxcall3;
  RF_CALL (Arithm::_p_, (_vs_i, _c_7), _gs_auxcall3);
  RF_CALL (Table::Bind, (_gs_auxcall2, _c_46, _gs_auxcall3), /*void*/);
  Expr _vs_i1;
  RF_CALL (Bind_m_Var, (_c_48, _vt_var1), _vs_i1);
  Expr _vs_i2;
  RF_CALL (Bind_m_Var, (_c_48, _vt_var2), _vs_i2);
  Expr _gs_auxcall4;
  RF_CALL (Get_m_Block_m_Table, /*void*/, _gs_auxcall4);
  RF_CALL (Table::Bind, (_gs_auxcall4, (_c_49 + _ve_expr), (_vs_i + _vs_i1 + _vs_i2)), /*void*/);
  _v_res1 = _vs_i;
RF_END

RF_FUNC (Lookup_m_Iter_m_Var, (RF_ARG _ve_expr;;), (RF_RES _v_res1, _v_res2, _v_res3;;))
  Expr _gs_auxcall1;
  RF_CALL (Get_m_Block_m_Table, /*void*/, _gs_auxcall1);
  Expr _v_Lookup1;
  if (!RF_CALL (Table::Lookup, (_gs_auxcall1, (_c_49 + _ve_expr)), _v_Lookup1))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (_v_Lookup1.get_len () != 3)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_v_Lookup1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_v_Lookup1.symbol_at ((0 + 1)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_v_Lookup1.symbol_at ((0 + 1 + 1)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _vs_i (_v_Lookup1, 0, 1);
  Expr _vs_i1 (_v_Lookup1, (0 + 1), 1);
  Expr _vs_i2 (_v_Lookup1, (0 + 1 + 1), 1);
  _v_res1 = _vs_i;
  _v_res2 = _vs_i1;
  _v_res3 = _vs_i2;
RF_END

RF_FUNC (Bind_m_TMP_m_Var, (RF_ARG _vt_var;;), (RF_RES _v_res1;;))
  Expr _gs_auxcall1;
  RF_CALL (Get_m_Block_m_Table, /*void*/, _gs_auxcall1);
  Expr _v_Lookup1;
  if (!RF_CALL (Table::Lookup, (_gs_auxcall1, _c_46), _v_Lookup1))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (_v_Lookup1.get_len () != 1)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_v_Lookup1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _vs_i (_v_Lookup1, 0, 1);
  Expr _gs_auxcall2;
  RF_CALL (Get_m_Block_m_Table, /*void*/, _gs_auxcall2);
  Expr _gs_auxcall3;
  RF_CALL (Arithm::_p_, (_vs_i, _c_7), _gs_auxcall3);
  RF_CALL (Table::Bind, (_gs_auxcall2, _c_46, _gs_auxcall3), /*void*/);
  Expr _gs_auxcall4;
  RF_CALL (Get_m_Block_m_Table, /*void*/, _gs_auxcall4);
  RF_CALL (Table::Bind, (_gs_auxcall4, (_c_50 + _vt_var), _vs_i), /*void*/);
  _v_res1 = _vs_i;
RF_END

RF_FUNC (Lookup_m_TMP_m_Var, (RF_ARG _vt_var;;), (RF_RES _v_res1;;))
  Expr _gs_auxcall1;
  RF_CALL (Get_m_Block_m_Table, /*void*/, _gs_auxcall1);
  Expr _v_Lookup1;
  if (!RF_CALL (Table::Lookup, (_gs_auxcall1, (_c_50 + _vt_var)), _v_Lookup1))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (_v_Lookup1.get_len () != 1)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_v_Lookup1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _vs_i (_v_Lookup1, 0, 1);
  _v_res1 = _vs_i;
RF_END

RF_FUNC (Bind_m_Label, (RF_ARG _vt_label;;), (RF_RES _v_res1;;))
  Expr _vs_l;
  RF_CALL (Label::Label, /*void*/, _vs_l);
  Expr _gs_auxcall1;
  RF_CALL (Get_m_Block_m_Table, /*void*/, _gs_auxcall1);
  RF_CALL (Table::Bind, (_gs_auxcall1, (_c_51 + _vt_label), _vs_l), /*void*/);
  _v_res1 = _vs_l;
RF_END

RF_FUNC (Lookup_m_Label, (RF_ARG _vt_label;;), (RF_RES _v_res1;;))
  Expr _gs_auxcall1;
  RF_CALL (Get_m_Block_m_Table, /*void*/, _gs_auxcall1);
  Expr _v_Lookup1;
  if (!RF_CALL (Table::Lookup, (_gs_auxcall1, (_c_51 + _vt_label)), _v_Lookup1))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (_v_Lookup1.get_len () != 1)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_v_Lookup1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _vs_l (_v_Lookup1, 0, 1);
  _v_res1 = _vs_l;
RF_END

RF_FUNC (Push_m_Trap, (RF_ARG _vs_end, _vs_handler;;), RF_VOID)
  RF_TAILCALL (Box::Put, (Traps, (_vs_end + _vs_handler)), /*void*/);
RF_END

RF_FUNC (Get_m_Trap, RF_VOID, (RF_RES _v_res1;;))
  Expr _ge_auxcall1;
  RF_CALL (Box::_q_, Traps, _ge_auxcall1);
  Expr _v_R1;
  if (!RF_CALL (Access::R, (_c_15, _ge_auxcall1), _v_R1))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_v_R1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _vs_handler (_v_R1, 0, 1);
  _v_res1 = _vs_handler;
RF_END

RF_FUNC (Pop_m_Trap, RF_VOID, (RF_RES _v_res1;;))
  Expr _v__q_1;
  RF_CALL (Box::_q_, Traps, _v__q_1);
  uintptr_t _v_len1 = _v__q_1.get_len ();
  uintptr_t _v_len2 = 2;
  if (_v_len1 < _v_len2)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len__traps = (_v_len1 - _v_len2);
  if (!_v__q_1.symbol_at ((0 + _v_len__traps)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_v__q_1.symbol_at ((0 + _v_len__traps + 1)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _ve_traps (_v__q_1, 0, _v_len__traps);
  Expr _vs_end (_v__q_1, (0 + _v_len__traps), 1);
  Expr _vs__e__e_tmp_m_rfp__asail__jbcrf_m_266_m_31 (_v__q_1, (0 + _v_len__traps + 1), 1);
  RF_CALL (Box::Store, (Traps, _ve_traps), /*void*/);
  _v_res1 = _vs_end;
RF_END

RF_FUNC (Qualified_m_Module_m_Name, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  {
    {
      if (_ge_arg1.get_len () != 1)
      {
        goto _block1__branch1;
      }
      if (!_ge_arg1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _vs_module_m_name (_ge_arg1, 0, 1);
      Expr _v__q_1;
      RF_CALL (Box::_q_, File::Dir_m_Separator, _v__q_1);
      if (_v__q_1.get_len () != 1)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      if (!_v__q_1.symbol_at (0))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      Expr _vs_dir_m_separator (_v__q_1, 0, 1);
      Expr _v_Lookup1;
      if (!RF_CALL (Table::Lookup, (rfpc::RFP_m_Includes, _vs_module_m_name), _v_Lookup1))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      Expr _ve_p;
      {
        {
          uintptr_t _v_len1 = _v_Lookup1.get_len ();
          uintptr_t _v_len2 = 1;
          if (_v_len1 < _v_len2)
          {
            goto _block2__branch1;
          }
          uintptr_t _v_len___e__e_tmp_m_rfp__asail__jbcrf_m_277_m_13 = (_v_len1 - _v_len2);
          if (!_c_52.term_eq (_v_Lookup1, 0))
          {
            goto _block2__branch1;
          }
          Expr _ve__e__e_tmp_m_rfp__asail__jbcrf_m_277_m_13 (_v_Lookup1, (0 + 1), _v_len___e__e_tmp_m_rfp__asail__jbcrf_m_277_m_13);
          _ve_p = _c_53;
          goto _block2;
        }
      _block2__branch1: {}
        {
          uintptr_t _v_len3 = _v_Lookup1.get_len ();
          uintptr_t _v_len4 = 1;
          if (_v_len3 < _v_len4)
          {
            goto _block2__branch2;
          }
          uintptr_t _v_len__path = (_v_len3 - _v_len4);
          if (!_c_54.term_eq (_v_Lookup1, 0))
          {
            goto _block2__branch2;
          }
          Expr _ve_path (_v_Lookup1, (0 + 1), _v_len__path);
          Expr _v__q_2;
          RF_CALL (Box::_q_, rfpc::RFP_m_Include_m_Path, _v__q_2);
          if (_v__q_2.get_len () < 1)
          {
            goto _block2__branch2;
          }
          RF_lsplit (_v__q_2, 0, _ve__e__e_tmp_m_rfp__asail__jbcrf_m_279_m_34, _v_lsplit___q_2);
          for ( ; ; RF_iter(_v__q_2)++)
          {
            {
              if (!RF_iter(_v__q_2))
              {
                goto _block2__branch2;
              }
              uintptr_t _v_len5 = _v_lsplit___q_2.get_len ();
              uintptr_t _v_len6 = 1;
              if (_v_len5 < _v_len6)
              {
                goto _block2__branch2;
              }
              uintptr_t _v_len___e__e_tmp_m_rfp__asail__jbcrf_m_279_m_44 = (_v_len5 - _v_len6);
              if (_v_lsplit___q_2.symbol_at (0))
              {
                goto _continue1;
              }
              Expr _v_deref__lsplit___q_2 (_v_lsplit___q_2, 0);
              uintptr_t _v_len7 = _v_deref__lsplit___q_2.get_len ();
              uintptr_t _v_len8 = 0;
              if (_v_len7 < _v_len8)
              {
                goto _continue1;
              }
              uintptr_t _v_len__dir = (_v_len7 - _v_len8);
              Expr _ve__e__e_tmp_m_rfp__asail__jbcrf_m_279_m_44 (_v_lsplit___q_2, (0 + 1), _v_len___e__e_tmp_m_rfp__asail__jbcrf_m_279_m_44);
              Expr _ve_dir (_v_deref__lsplit___q_2, 0, _v_len__dir);
              Expr _ge_p__5;
              {
                {
                  if (_v_len__path != _v_len__dir)
                  {
                    goto _block3__branch1;
                  }
                  if (!_ve_dir.eq (_ve_path, 0))
                  {
                    goto _block3__branch1;
                  }
                  _ge_p__5 = empty;
                  goto _block3;
                }
              _block3__branch1: {}
                uintptr_t _v_len9 = _v_len__path;
                uintptr_t _v_len10 = (_v_len__dir + 1);
                if (_v_len9 < _v_len10)
                {
                  goto _continue1;
                }
                uintptr_t _v_len__p__6 = (_v_len9 - _v_len10);
                if (!_ve_dir.eq (_ve_path, 0))
                {
                  goto _continue1;
                }
                if (!_vs_dir_m_separator.term_eq (_ve_path, (0 + _v_len__dir)))
                {
                  goto _continue1;
                }
                Expr _ge_p__6 (_ve_path, (0 + _v_len__dir + 1), _v_len__p__6);
                _ge_p__5 = _ge_p__6;
              }
            _block3: {}
              Expr _ge_p__5__6;
              {
                {
                  if (!_vs_dir_m_separator.term_eq (_c_6, 0))
                  {
                    goto _block4__branch1;
                  }
                  _ge_p__5__6 = _ge_p__5;
                  goto _block4;
                }
              _block4__branch1: {}
                RF_CALL (rfp__helper::Subst, (_vs_dir_m_separator, _c_55, _ge_p__5), _ge_p__5__6);
              }
            _block4: {}
              {
                {
                  {
                    {
                      uintptr_t _v_len11 = _ge_p__5__6.get_len ();
                      uintptr_t _v_len12 = 1;
                      if (_v_len11 < _v_len12)
                      {
                        goto _block6__branch1;
                      }
                      uintptr_t _v_len___e__e_tmp_m_rfp__asail__jbcrf_m_289_m_21 = (_v_len11 - _v_len12);
                      if (!_c_6.term_eq (_ge_p__5__6, (0 + _v_len___e__e_tmp_m_rfp__asail__jbcrf_m_289_m_21)))
                      {
                        goto _block6__branch1;
                      }
                      Expr _ve__e__e_tmp_m_rfp__asail__jbcrf_m_289_m_21 (_ge_p__5__6, 0, _v_len___e__e_tmp_m_rfp__asail__jbcrf_m_289_m_21);
                      goto _block6;
                    }
                  _block6__branch1: {}
                    if (_ge_p__5__6.get_len () != 0)
                    {
                      goto _block5__branch1;
                    }
                  }
                _block6: {}
                  _ve_p = _ge_p__5__6;
                  goto _block5;
                }
              _block5__branch1: {}
                _ve_p = (_ge_p__5__6 + _c_6);
              }
            _block5: {}
              goto _exit1;
            }
        _continue1: {}
          }
        _exit1: {}
          goto _block2;
        }
      _block2__branch2: {}
        if (_v_Lookup1.get_len () != 1)
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        if (!_c_54.term_eq (_v_Lookup1, 0))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        _ve_p = empty;
      }
    _block2: {}
      Expr _ge_auxcall1;
      RF_CALL (JavaMangle::Rfp2Java, _vs_module_m_name, _ge_auxcall1);
      RF_TAILCALL (Convert::To_m_Word, (_ve_p + _ge_auxcall1), _v_res1);
      goto _block1;
    }
  _block1__branch1: {}
    if (_ge_arg1.get_len () != 0)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _ge_auxcall2;
    RF_CALL (Box::_q_, Module_m_Name, _ge_auxcall2);
    Expr _ge_auxcall3;
    RF_CALL (List::Intersperse, (_c_6, _ge_auxcall2), _ge_auxcall3);
    RF_TAILCALL (Convert::To_m_Word, _ge_auxcall3, _v_res1);
  }
_block1: {}
RF_END

RF_FUNC (Function_m_Description, (RF_ARG _ve_args, _ve_ress, _vs_retType;;), (RF_RES _v_res1;;))
  Expr _gs_auxcall1;
  RF_CALL (Access::Length, _ve_args, _gs_auxcall1);
  Expr _ge_auxcall2;
  RF_CALL (List::Replicate, (_gs_auxcall1, _c_34), _ge_auxcall2);
  Expr _gs_auxcall3;
  RF_CALL (Access::Length, _ve_ress, _gs_auxcall3);
  Expr _ge_auxcall4;
  RF_CALL (List::Replicate, (_gs_auxcall3, _c_56), _ge_auxcall4);
  RF_TAILCALL (Convert::To_m_Word, (_c_58 + _ge_auxcall2 + _ge_auxcall4 + _c_57 + _vs_retType), _v_res1);
RF_END

RF_FUNC (Module_m_To_m_JBC, (RF_ARG _vs_cw, _ve_module;;), RF_VOID)
  {
    if (_ve_module.get_len () < 1)
    {
      goto _block1__branch1;
    }
    RF_lsplit (_ve_module, 0, _ve__e__e_tmp_m_rfp__asail__jbcrf_m_306_m_15, _v_lsplit__module);
    for ( ; ; RF_iter(_ve_module)++)
    {
      {
        if (!RF_iter(_ve_module))
        {
          goto _block1__branch1;
        }
        uintptr_t _v_len1 = _v_lsplit__module.get_len ();
        uintptr_t _v_len2 = 1;
        if (_v_len1 < _v_len2)
        {
          goto _block1__branch1;
        }
        uintptr_t _v_len___e__e_tmp_m_rfp__asail__jbcrf_m_306_m_24 = (_v_len1 - _v_len2);
        Expr _vt_item (_v_lsplit__module, 0, 1);
        Expr _ve__e__e_tmp_m_rfp__asail__jbcrf_m_306_m_24 (_v_lsplit__module, (0 + 1), _v_len___e__e_tmp_m_rfp__asail__jbcrf_m_306_m_24);
        {
          {
            if (_vt_item.symbol_at (0))
            {
              goto _block2__branch1;
            }
            Expr _v_deref__item (_vt_item, 0);
            uintptr_t _v_len3 = _v_deref__item.get_len ();
            uintptr_t _v_len4 = 2;
            if (_v_len3 < _v_len4)
            {
              goto _block2__branch1;
            }
            uintptr_t _v_len___e__e_tmp_m_rfp__asail__jbcrf_m_307_m_20 = (_v_len3 - _v_len4);
            if (!_v_deref__item.symbol_at (0))
            {
              goto _block2__branch1;
            }
            if (!_c_59.term_eq (_v_deref__item, (0 + 1)))
            {
              goto _block2__branch1;
            }
            Expr _vs_tag (_v_deref__item, 0, 1);
            Expr _ve__e__e_tmp_m_rfp__asail__jbcrf_m_307_m_20 (_v_deref__item, (0 + 1 + 1), _v_len___e__e_tmp_m_rfp__asail__jbcrf_m_307_m_20);
            goto _block2;
          }
        _block2__branch1: {}
          {
            if (_vt_item.symbol_at (0))
            {
              goto _block2__branch2;
            }
            Expr _v_deref__item2 (_vt_item, 0);
            uintptr_t _v_len5 = _v_deref__item2.get_len ();
            uintptr_t _v_len6 = 5;
            if (_v_len5 < _v_len6)
            {
              goto _block2__branch2;
            }
            uintptr_t _v_len__body = (_v_len5 - _v_len6);
            if (_v_deref__item2.symbol_at ((0 + 1 + 1 + 1)))
            {
              goto _block2__branch2;
            }
            if (_v_deref__item2.symbol_at ((0 + 1 + 1 + 1 + 1)))
            {
              goto _block2__branch2;
            }
            Expr _v_deref__deref__item2 (_v_deref__item2, (0 + 1 + 1 + 1));
            Expr _v_deref__deref__item22 (_v_deref__item2, (0 + 1 + 1 + 1 + 1));
            uintptr_t _v_len7 = _v_deref__deref__item22.get_len ();
            uintptr_t _v_len8 = 0;
            if (_v_len7 < _v_len8)
            {
              goto _block2__branch2;
            }
            uintptr_t _v_len__ress = (_v_len7 - _v_len8);
            uintptr_t _v_len9 = _v_deref__deref__item2.get_len ();
            uintptr_t _v_len10 = 0;
            if (_v_len9 < _v_len10)
            {
              goto _block2__branch2;
            }
            uintptr_t _v_len__args = (_v_len9 - _v_len10);
            if (!_v_deref__item2.symbol_at (0))
            {
              goto _block2__branch2;
            }
            if (!_v_deref__item2.symbol_at ((0 + 1)))
            {
              goto _block2__branch2;
            }
            Expr _vs_tag (_v_deref__item2, 0, 1);
            Expr _vs_linkage (_v_deref__item2, (0 + 1), 1);
            Expr _vt_name (_v_deref__item2, (0 + 1 + 1), 1);
            Expr _ve_body (_v_deref__item2, (0 + 1 + 1 + 1 + 1 + 1), _v_len__body);
            Expr _ve_args (_v_deref__deref__item2, 0, _v_len__args);
            Expr _ve_ress (_v_deref__deref__item22, 0, _v_len__ress);
            Expr _gs_auxalt1;
            {
              {
                if (!_vs_tag.term_eq (_c_43, 0))
                {
                  goto _block3__branch1;
                }
                _gs_auxalt1 = _c_60;
                goto _block3;
              }
            _block3__branch1: {}
              if (!_vs_tag.term_eq (_c_41, 0))
              {
                goto _block2__branch2;
              }
              _gs_auxalt1 = _c_61;
            }
          _block3: {}
            if (!_gs_auxalt1.symbol_at (0))
            {
              goto _block2__branch2;
            }
            Expr _vs_retType (_gs_auxalt1, 0, 1);
            RF_CALL (Init_m_Block_m_Table, /*void*/, /*void*/);
            RF_CALL (Bind_m_Vars, (_c_48, _ve_args), /*void*/);
            RF_CALL (Bind_m_Vars, (_c_62, _ve_ress), /*void*/);
            Expr _gs_auxcall2;
            RF_CALL (Access_m_Mode, _vt_name, _gs_auxcall2);
            Expr _vs_accessMode;
            RF_CALL (Arithm::_p_, (_c_11, _gs_auxcall2), _vs_accessMode);
            if (_vt_name.symbol_at (0))
            {
              goto _continue1;
            }
            Expr _v_deref__name (_vt_name, 0);
            uintptr_t _v_len11 = _v_deref__name.get_len ();
            uintptr_t _v_len12 = 1;
            if (_v_len11 < _v_len12)
            {
              goto _continue1;
            }
            uintptr_t _v_len___e__e_tmp_m_rfp__asail__jbcrf_m_317_m_18 = (_v_len11 - _v_len12);
            if (!_v_deref__name.symbol_at ((0 + _v_len___e__e_tmp_m_rfp__asail__jbcrf_m_317_m_18)))
            {
              goto _continue1;
            }
            Expr _ve__e__e_tmp_m_rfp__asail__jbcrf_m_317_m_18 (_v_deref__name, 0, _v_len___e__e_tmp_m_rfp__asail__jbcrf_m_317_m_18);
            Expr _vs_funcName (_v_deref__name, (0 + _v_len___e__e_tmp_m_rfp__asail__jbcrf_m_317_m_18), 1);
            RF_CALL (Box::Store, (Func_m_Name, _vs_funcName), /*void*/);
            Expr _ge_auxcall3;
            RF_CALL (JavaMangle::Rfp2Java, _vs_funcName, _ge_auxcall3);
            RF_CALL (Convert::To_m_Word, _ge_auxcall3, _vs_funcName);
            {
              {
                Expr _v__q_1;
                RF_CALL (Box::_q_, Entry, _v__q_1);
                if (_v__q_1.get_len () < 1)
                {
                  goto _block4__branch1;
                }
                RF_lsplit (_v__q_1, 0, _ve__e__e_tmp_m_rfp__asail__jbcrf_m_320_m_23, _v_lsplit___q_1);
                for ( ; ; RF_iter(_v__q_1)++)
                {
                  {
                    if (!RF_iter(_v__q_1))
                    {
                      goto _block4__branch1;
                    }
                    uintptr_t _v_len13 = _v_lsplit___q_1.get_len ();
                    uintptr_t _v_len14 = 1;
                    if (_v_len13 < _v_len14)
                    {
                      goto _block4__branch1;
                    }
                    uintptr_t _v_len___e__e_tmp_m_rfp__asail__jbcrf_m_320_m_32 = (_v_len13 - _v_len14);
                    if (!_vt_name.term_eq (_v_lsplit___q_1, 0))
                    {
                      goto _continue2;
                    }
                    Expr _ve__e__e_tmp_m_rfp__asail__jbcrf_m_320_m_32 (_v_lsplit___q_1, (0 + 1), _v_len___e__e_tmp_m_rfp__asail__jbcrf_m_320_m_32);
                    RF_CALL (Box::Store, (Entry_m_Name, _vs_funcName), /*void*/);
                    goto _exit2;
                  }
              _continue2: {}
                }
              _exit2: {}
                goto _block4;
              }
            _block4__branch1: {}
            }
          _block4: {}
            Expr _vs_desc;
            RF_CALL (Function_m_Description, (_ve_args, _ve_ress, _vs_retType), _vs_desc);
            Expr _gs_auxcall4;
            RF_CALL (Java::Null, /*void*/, _gs_auxcall4);
            Expr _gs_auxcall5;
            RF_CALL (ClassWriter::CWvisitMethod, (_vs_cw, _vs_accessMode, _vs_funcName, _vs_desc, _gs_auxcall4, _c_40), _gs_auxcall5);
            RF_CALL (Box::Store, (MVbox, _gs_auxcall5), /*void*/);
            RF_CALL (ASAIL_m_To_m_JBC, _ve_body, /*void*/);
            {
              {
                if (!_vs_tag.term_eq (_c_43, 0))
                {
                  goto _block5__branch1;
                }
                Expr _gs_auxcall6;
                RF_CALL (MV, /*void*/, _gs_auxcall6);
                RF_CALL (MethodVisitor::MVvisitInsn, (_gs_auxcall6, _c_27), /*void*/);
                goto _block5;
              }
            _block5__branch1: {}
              if (!_vs_tag.term_eq (_c_41, 0))
              {
                RF_FUNC_ERROR (unexpected_fail);
              }
              Expr _gs_auxcall7;
              RF_CALL (MV, /*void*/, _gs_auxcall7);
              RF_CALL (MethodVisitor::MVvisitInsn, (_gs_auxcall7, _c_45), /*void*/);
              Expr _gs_auxcall8;
              RF_CALL (MV, /*void*/, _gs_auxcall8);
              RF_CALL (MethodVisitor::MVvisitInsn, (_gs_auxcall8, _c_42), /*void*/);
            }
          _block5: {}
            Expr _gs_auxcall9;
            RF_CALL (MV, /*void*/, _gs_auxcall9);
            RF_CALL (MethodVisitor::MVvisitMaxs, (_gs_auxcall9, _c_15, _c_15), /*void*/);
            Expr _gs_auxcall10;
            RF_CALL (MV, /*void*/, _gs_auxcall10);
            RF_CALL (MethodVisitor::MVvisitEnd, _gs_auxcall10, /*void*/);
            goto _block2;
          }
        _block2__branch2: {}
          {
            if (_vt_item.symbol_at (0))
            {
              goto _block2__branch3;
            }
            Expr _v_deref__item3 (_vt_item, 0);
            uintptr_t _v_len15 = _v_deref__item3.get_len ();
            uintptr_t _v_len16 = 4;
            if (_v_len15 < _v_len16)
            {
              goto _block2__branch3;
            }
            uintptr_t _v_len__expr = (_v_len15 - _v_len16);
            if (_v_deref__item3.symbol_at ((0 + 1 + 1 + 1)))
            {
              goto _block2__branch3;
            }
            Expr _v_deref__deref__item3 (_v_deref__item3, (0 + 1 + 1 + 1));
            uintptr_t _v_len17 = _v_deref__deref__item3.get_len ();
            uintptr_t _v_len18 = 0;
            if (_v_len17 < _v_len18)
            {
              goto _block2__branch3;
            }
            uintptr_t _v_len__comment = (_v_len17 - _v_len18);
            if (!_c_63.term_eq (_v_deref__item3, 0))
            {
              goto _block2__branch3;
            }
            if (!_v_deref__item3.symbol_at ((0 + 1)))
            {
              goto _block2__branch3;
            }
            Expr _vs_linkage (_v_deref__item3, (0 + 1), 1);
            Expr _vt_name (_v_deref__item3, (0 + 1 + 1), 1);
            Expr _ve_expr (_v_deref__item3, (0 + 1 + 1 + 1 + 1), _v_len__expr);
            Expr _ve_comment (_v_deref__deref__item3, 0, _v_len__comment);
            Expr _gs_auxcall11;
            RF_CALL (Access_m_Mode, _vt_name, _gs_auxcall11);
            Expr _gs_auxcall12;
            RF_CALL (Arithm::_p_, (_c_36, _gs_auxcall11), _gs_auxcall12);
            Expr _vs_accessMode;
            RF_CALL (Arithm::_p_, (_c_11, _gs_auxcall12), _vs_accessMode);
            Expr _ve_n;
            {
              {
                if (_vt_name.symbol_at (0))
                {
                  goto _block6__branch1;
                }
                Expr _v_deref__name2 (_vt_name, 0);
                if (_v_deref__name2.get_len () != 2)
                {
                  goto _block6__branch1;
                }
                if (_v_deref__name2.symbol_at ((0 + 1)))
                {
                  goto _block6__branch1;
                }
                Expr _v_deref__deref__name2 (_v_deref__name2, (0 + 1));
                uintptr_t _v_len19 = _v_deref__deref__name2.get_len ();
                uintptr_t _v_len20 = 0;
                if (_v_len19 < _v_len20)
                {
                  goto _block6__branch1;
                }
                uintptr_t _v_len___e__e_tmp_m_rfp__asail__jbcrf_m_333_m_19 = (_v_len19 - _v_len20);
                if (!_c_64.term_eq (_v_deref__name2, 0))
                {
                  goto _block6__branch1;
                }
                Expr _ve__e__e_tmp_m_rfp__asail__jbcrf_m_333_m_19 (_v_deref__deref__name2, 0, _v_len___e__e_tmp_m_rfp__asail__jbcrf_m_333_m_19);
                RF_CALL (JavaMangle::Rfp2Java, _vt_name, _ve_n);
                goto _block6;
              }
            _block6__branch1: {}
              if (_vt_name.symbol_at (0))
              {
                RF_FUNC_ERROR (unexpected_fail);
              }
              Expr _v_deref__name3 (_vt_name, 0);
              if (_v_deref__name3.get_len () != 2)
              {
                RF_FUNC_ERROR (unexpected_fail);
              }
              if (!_v_deref__name3.symbol_at (0))
              {
                RF_FUNC_ERROR (unexpected_fail);
              }
              if (!_v_deref__name3.symbol_at ((0 + 1)))
              {
                RF_FUNC_ERROR (unexpected_fail);
              }
              Expr _vs__e__e_tmp_m_rfp__asail__jbcrf_m_334_m_11 (_v_deref__name3, 0, 1);
              Expr _vs_const_m_name (_v_deref__name3, (0 + 1), 1);
              RF_CALL (JavaMangle::Rfp2Java, _vs_const_m_name, _ve_n);
            }
          _block6: {}
            Expr _vs_n;
            RF_CALL (Convert::To_m_Word, _ve_n, _vs_n);
            Expr _gs_auxcall13;
            RF_CALL (Java::Null, /*void*/, _gs_auxcall13);
            Expr _gs_auxcall14;
            RF_CALL (Java::Null, /*void*/, _gs_auxcall14);
            Expr _vs_fv;
            RF_CALL (ClassWriter::CWvisitField, (_vs_cw, _vs_accessMode, _vs_n, _c_34, _gs_auxcall13, _gs_auxcall14), _vs_fv);
            RF_CALL (FieldVisitor::FVvisitEnd, _vs_fv, /*void*/);
            RF_CALL (Box::Put, (Constants, (_vs_n + _ve_expr) ()), /*void*/);
            goto _block2;
          }
        _block2__branch3: {}
          {
            if (_vt_item.symbol_at (0))
            {
              goto _block2__branch4;
            }
            Expr _v_deref__item4 (_vt_item, 0);
            if (_v_deref__item4.get_len () != 4)
            {
              goto _block2__branch4;
            }
            if (!_c_65.term_eq (_v_deref__item4, 0))
            {
              goto _block2__branch4;
            }
            if (!_v_deref__item4.symbol_at ((0 + 1)))
            {
              goto _block2__branch4;
            }
            if (!_v_deref__item4.symbol_at ((0 + 1 + 1)))
            {
              goto _block2__branch4;
            }
            Expr _vs_linkage (_v_deref__item4, (0 + 1), 1);
            Expr _vs_tag (_v_deref__item4, (0 + 1 + 1), 1);
            Expr _vt_name (_v_deref__item4, (0 + 1 + 1 + 1), 1);
            if (_vt_name.symbol_at (0))
            {
              goto _continue1;
            }
            Expr _v_deref__name4 (_vt_name, 0);
            if (_v_deref__name4.get_len () != 2)
            {
              goto _continue1;
            }
            if (!_v_deref__name4.symbol_at (0))
            {
              goto _continue1;
            }
            if (!_v_deref__name4.symbol_at ((0 + 1)))
            {
              goto _continue1;
            }
            Expr _vs__e__e_tmp_m_rfp__asail__jbcrf_m_341_m_18 (_v_deref__name4, 0, 1);
            Expr _vs_obj_m_name (_v_deref__name4, (0 + 1), 1);
            Expr _v_To_m_Chars1;
            RF_CALL (Convert::To_m_Chars, _vs_tag, _v_To_m_Chars1);
            uintptr_t _v_len21 = _v_To_m_Chars1.get_len ();
            uintptr_t _v_len22 = 1;
            if (_v_len21 < _v_len22)
            {
              goto _continue1;
            }
            uintptr_t _v_len__2 = (_v_len21 - _v_len22);
            if (!_v_To_m_Chars1.symbol_at (0))
            {
              goto _continue1;
            }
            Expr _vs_1 (_v_To_m_Chars1, 0, 1);
            Expr _ve_2 (_v_To_m_Chars1, (0 + 1), _v_len__2);
            Expr _v_To_m_Lower1;
            RF_CALL (Convert::To_m_Lower, _ve_2, _v_To_m_Lower1);
            Expr _ve_class_m_name ((_c_66 + _vs_1 + _v_To_m_Lower1));
            Expr _ge_auxcall15;
            RF_CALL (JavaMangle::Rfp2Java, _vs_obj_m_name, _ge_auxcall15);
            Expr _vs_n;
            RF_CALL (Convert::To_m_Word, _ge_auxcall15, _vs_n);
            Expr _gs_auxcall16;
            RF_CALL (Access_m_Mode, _vt_name, _gs_auxcall16);
            Expr _gs_auxcall17;
            RF_CALL (Arithm::_p_, (_c_36, _gs_auxcall16), _gs_auxcall17);
            Expr _vs_accessMode;
            RF_CALL (Arithm::_p_, (_c_11, _gs_auxcall17), _vs_accessMode);
            Expr _gs_auxcall18;
            RF_CALL (Java::Null, /*void*/, _gs_auxcall18);
            Expr _gs_auxcall19;
            RF_CALL (Java::Null, /*void*/, _gs_auxcall19);
            Expr _vs_fv;
            RF_CALL (ClassWriter::CWvisitField, (_vs_cw, _vs_accessMode, _vs_n, _c_34, _gs_auxcall18, _gs_auxcall19), _vs_fv);
            RF_CALL (FieldVisitor::FVvisitEnd, _vs_fv, /*void*/);
            RF_CALL (Box::Put, (Objects, (_vs_n + _vs_obj_m_name + _ve_class_m_name) ()), /*void*/);
            goto _block2;
          }
        _block2__branch4: {}
          {
            if (_vt_item.symbol_at (0))
            {
              goto _block2__branch5;
            }
            Expr _v_deref__item5 (_vt_item, 0);
            if (_v_deref__item5.get_len () != 2)
            {
              goto _block2__branch5;
            }
            if (!_c_67.term_eq (_v_deref__item5, 0))
            {
              goto _block2__branch5;
            }
            Expr _vt_name (_v_deref__item5, (0 + 1), 1);
            goto _block2;
          }
        _block2__branch5: {}
          {
            if (_vt_item.symbol_at (0))
            {
              goto _block2__branch6;
            }
            Expr _v_deref__item6 (_vt_item, 0);
            if (_v_deref__item6.get_len () != 2)
            {
              goto _block2__branch6;
            }
            if (!_c_68.term_eq (_v_deref__item6, 0))
            {
              goto _block2__branch6;
            }
            Expr _vt_name (_v_deref__item6, (0 + 1), 1);
            goto _block2;
          }
        _block2__branch6: {}
          if (_vt_item.symbol_at (0))
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          Expr _v_deref__item7 (_vt_item, 0);
          if (_v_deref__item7.get_len () != 2)
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          if (!_c_69.term_eq (_v_deref__item7, 0))
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          Expr _vt_name (_v_deref__item7, (0 + 1), 1);
          RF_CALL (Table::Bind, (rfpc::RFP_m_Trace, _vt_name, empty), /*void*/);
        }
      _block2: {}
      }
  _continue1: {}
    }
  _exit1: {}
  }
_block1__branch1: {}
RF_END

RF_FUNC (ASAIL_m_To_m_JBC, (RF_ARG _ge_arg1;;), RF_VOID)
  {
    if (_ge_arg1.get_len () < 1)
    {
      goto _block1__branch1;
    }
    RF_lsplit (_ge_arg1, 0, _ve__e__e_tmp_m_rfp__asail__jbcrf_m_358_m_4, _v_lsplit__arg1);
    for ( ; ; RF_iter(_ge_arg1)++)
    {
      {
        if (!RF_iter(_ge_arg1))
        {
          goto _block1__branch1;
        }
        uintptr_t _v_len1 = _v_lsplit__arg1.get_len ();
        uintptr_t _v_len2 = 1;
        if (_v_len1 < _v_len2)
        {
          goto _block1__branch1;
        }
        uintptr_t _v_len___e__e_tmp_m_rfp__asail__jbcrf_m_358_m_13 = (_v_len1 - _v_len2);
        Expr _vt_item (_v_lsplit__arg1, 0, 1);
        Expr _ve__e__e_tmp_m_rfp__asail__jbcrf_m_358_m_13 (_v_lsplit__arg1, (0 + 1), _v_len___e__e_tmp_m_rfp__asail__jbcrf_m_358_m_13);
        {
          {
            if (_vt_item.symbol_at (0))
            {
              goto _block2__branch1;
            }
            Expr _v_deref__item (_vt_item, 0);
            if (_v_deref__item.get_len () != 3)
            {
              goto _block2__branch1;
            }
            if (!_c_70.term_eq (_v_deref__item, 0))
            {
              goto _block2__branch1;
            }
            if (!_v_deref__item.symbol_at ((0 + 1)))
            {
              goto _block2__branch1;
            }
            Expr _vs_type (_v_deref__item, (0 + 1), 1);
            Expr _vt_var (_v_deref__item, (0 + 1 + 1), 1);
            Expr _vs_i;
            RF_CALL (Bind_m_Var, (_vs_type, _vt_var), _vs_i);
            {
              {
                if (!_vs_type.term_eq (_c_62, 0))
                {
                  goto _block3__branch1;
                }
                Expr _gs_auxcall1;
                RF_CALL (MV, /*void*/, _gs_auxcall1);
                RF_CALL (MethodVisitor::MVvisitTypeInsn, (_gs_auxcall1, _c_20, _c_21), /*void*/);
                Expr _gs_auxcall2;
                RF_CALL (MV, /*void*/, _gs_auxcall2);
                RF_CALL (MethodVisitor::MVvisitInsn, (_gs_auxcall2, _c_22), /*void*/);
                Expr _gs_auxcall3;
                RF_CALL (MV, /*void*/, _gs_auxcall3);
                RF_CALL (MethodVisitor::MVvisitMethodInsn, (_gs_auxcall3, _c_23, _c_21, _c_24, _c_25), /*void*/);
                Expr _gs_auxcall4;
                RF_CALL (MV, /*void*/, _gs_auxcall4);
                RF_CALL (MethodVisitor::MVvisitVarInsn, (_gs_auxcall4, _c_71, _vs_i), /*void*/);
                goto _block3;
              }
            _block3__branch1: {}
              if (!_vs_type.term_eq (_c_48, 0))
              {
                RF_FUNC_ERROR (unexpected_fail);
              }
              Expr _gs_auxcall5;
              RF_CALL (MV, /*void*/, _gs_auxcall5);
              RF_CALL (MethodVisitor::MVvisitFieldInsn, (_gs_auxcall5, _c_72, _c_30, _c_73, _c_34), /*void*/);
              Expr _gs_auxcall6;
              RF_CALL (MV, /*void*/, _gs_auxcall6);
              RF_CALL (MethodVisitor::MVvisitVarInsn, (_gs_auxcall6, _c_71, _vs_i), /*void*/);
            }
          _block3: {}
            goto _block2;
          }
        _block2__branch1: {}
          {
            if (_vt_item.symbol_at (0))
            {
              goto _block2__branch2;
            }
            Expr _v_deref__item2 (_vt_item, 0);
            uintptr_t _v_len3 = _v_deref__item2.get_len ();
            uintptr_t _v_len4 = 2;
            if (_v_len3 < _v_len4)
            {
              goto _block2__branch2;
            }
            uintptr_t _v_len__expr = (_v_len3 - _v_len4);
            if (!_c_74.term_eq (_v_deref__item2, 0))
            {
              goto _block2__branch2;
            }
            Expr _vt_var (_v_deref__item2, (0 + 1), 1);
            Expr _ve_expr (_v_deref__item2, (0 + 1 + 1), _v_len__expr);
            Expr _vs_type;
            Expr _vs_i;
            RF_CALL (Lookup_m_Var, _vt_var, (_vs_type, _vs_i));
            {
              {
                if (!_vs_type.term_eq (_c_62, 0))
                {
                  goto _block4__branch1;
                }
                Expr _gs_auxcall7;
                RF_CALL (MV, /*void*/, _gs_auxcall7);
                RF_CALL (MethodVisitor::MVvisitVarInsn, (_gs_auxcall7, _c_14, _vs_i), /*void*/);
                RF_CALL (Expr_m_Ref_m_To_m_JBC, _ve_expr, /*void*/);
                Expr _gs_auxcall8;
                RF_CALL (MV, /*void*/, _gs_auxcall8);
                RF_CALL (MethodVisitor::MVvisitMethodInsn, (_gs_auxcall8, _c_75, _c_21, _c_76, _c_77), /*void*/);
                goto _block4;
              }
            _block4__branch1: {}
              if (!_vs_type.term_eq (_c_48, 0))
              {
                RF_FUNC_ERROR (unexpected_fail);
              }
              RF_CALL (Expr_m_Ref_m_To_m_JBC, _ve_expr, /*void*/);
              Expr _gs_auxcall9;
              RF_CALL (MV, /*void*/, _gs_auxcall9);
              RF_CALL (MethodVisitor::MVvisitVarInsn, (_gs_auxcall9, _c_71, _vs_i), /*void*/);
            }
          _block4: {}
            goto _block2;
          }
        _block2__branch2: {}
          {
            if (_vt_item.symbol_at (0))
            {
              goto _block2__branch3;
            }
            Expr _v_deref__item3 (_vt_item, 0);
            uintptr_t _v_len5 = _v_deref__item3.get_len ();
            uintptr_t _v_len6 = 2;
            if (_v_len5 < _v_len6)
            {
              goto _block2__branch3;
            }
            uintptr_t _v_len__expr2 = (_v_len5 - _v_len6);
            if (!_c_0.term_eq (_v_deref__item3, 0))
            {
              goto _block2__branch3;
            }
            Expr _vt_var (_v_deref__item3, (0 + 1), 1);
            Expr _ve_expr (_v_deref__item3, (0 + 1 + 1), _v_len__expr2);
            Expr _vs_i;
            RF_CALL (Bind_m_Var, (_c_78, _vt_var), _vs_i);
            RF_CALL (Expr_m_Int_m_To_m_JBC, _ve_expr, /*void*/);
            Expr _gs_auxcall10;
            RF_CALL (MV, /*void*/, _gs_auxcall10);
            RF_CALL (MethodVisitor::MVvisitVarInsn, (_gs_auxcall10, _c_79, _vs_i), /*void*/);
            goto _block2;
          }
        _block2__branch3: {}
          {
            if (_vt_item.symbol_at (0))
            {
              goto _block2__branch4;
            }
            Expr _v_deref__item4 (_vt_item, 0);
            uintptr_t _v_len7 = _v_deref__item4.get_len ();
            uintptr_t _v_len8 = 2;
            if (_v_len7 < _v_len8)
            {
              goto _block2__branch4;
            }
            uintptr_t _v_len__expr3 = (_v_len7 - _v_len8);
            if (!_c_80.term_eq (_v_deref__item4, 0))
            {
              goto _block2__branch4;
            }
            Expr _vt_var (_v_deref__item4, (0 + 1), 1);
            Expr _ve_expr (_v_deref__item4, (0 + 1 + 1), _v_len__expr3);
            Expr _vs_i;
            RF_CALL (Bind_m_Var, (_c_48, _vt_var), _vs_i);
            RF_CALL (Expr_m_Ref_m_To_m_JBC, _ve_expr, /*void*/);
            Expr _gs_auxcall11;
            RF_CALL (MV, /*void*/, _gs_auxcall11);
            RF_CALL (MethodVisitor::MVvisitVarInsn, (_gs_auxcall11, _c_71, _vs_i), /*void*/);
            goto _block2;
          }
        _block2__branch4: {}
          {
            if (_vt_item.symbol_at (0))
            {
              goto _block2__branch5;
            }
            Expr _v_deref__item5 (_vt_item, 0);
            uintptr_t _v_len9 = _v_deref__item5.get_len ();
            uintptr_t _v_len10 = 3;
            if (_v_len9 < _v_len10)
            {
              goto _block2__branch5;
            }
            uintptr_t _v_len__expr4 = (_v_len9 - _v_len10);
            if (_v_deref__item5.symbol_at ((0 + 1 + 1 + _v_len__expr4)))
            {
              goto _block2__branch5;
            }
            Expr _v_deref__deref__item5 (_v_deref__item5, (0 + 1 + 1 + _v_len__expr4));
            uintptr_t _v_len11 = _v_deref__deref__item5.get_len ();
            uintptr_t _v_len12 = 0;
            if (_v_len11 < _v_len12)
            {
              goto _block2__branch5;
            }
            uintptr_t _v_len__pos = (_v_len11 - _v_len12);
            if (!_c_81.term_eq (_v_deref__item5, 0))
            {
              goto _block2__branch5;
            }
            Expr _vt_var (_v_deref__item5, (0 + 1), 1);
            Expr _ve_expr (_v_deref__item5, (0 + 1 + 1), _v_len__expr4);
            Expr _ve_pos (_v_deref__deref__item5, 0, _v_len__pos);
            Expr _vs_i;
            RF_CALL (Bind_m_Var, (_c_48, _vt_var), _vs_i);
            RF_CALL (Expr_m_Ref_m_To_m_JBC, _ve_expr, /*void*/);
            RF_CALL (Expr_m_Int_m_To_m_JBC, _ve_pos, /*void*/);
            Expr _gs_auxcall12;
            RF_CALL (MV, /*void*/, _gs_auxcall12);
            RF_CALL (MethodVisitor::MVvisitMethodInsn, (_gs_auxcall12, _c_75, _c_30, _c_82, _c_83), /*void*/);
            Expr _gs_auxcall13;
            RF_CALL (MV, /*void*/, _gs_auxcall13);
            RF_CALL (MethodVisitor::MVvisitTypeInsn, (_gs_auxcall13, _c_84, _c_30), /*void*/);
            Expr _gs_auxcall14;
            RF_CALL (MV, /*void*/, _gs_auxcall14);
            RF_CALL (MethodVisitor::MVvisitVarInsn, (_gs_auxcall14, _c_71, _vs_i), /*void*/);
            goto _block2;
          }
        _block2__branch5: {}
          {
            if (_vt_item.symbol_at (0))
            {
              goto _block2__branch6;
            }
            Expr _v_deref__item6 (_vt_item, 0);
            uintptr_t _v_len13 = _v_deref__item6.get_len ();
            uintptr_t _v_len14 = 4;
            if (_v_len13 < _v_len14)
            {
              goto _block2__branch6;
            }
            uintptr_t _v_len__expr5 = (_v_len13 - _v_len14);
            if (_v_deref__item6.symbol_at ((0 + 1 + 1 + _v_len__expr5)))
            {
              goto _block2__branch6;
            }
            if (_v_deref__item6.symbol_at ((0 + 1 + 1 + _v_len__expr5 + 1)))
            {
              goto _block2__branch6;
            }
            Expr _v_deref__deref__item6 (_v_deref__item6, (0 + 1 + 1 + _v_len__expr5));
            Expr _v_deref__deref__item62 (_v_deref__item6, (0 + 1 + 1 + _v_len__expr5 + 1));
            uintptr_t _v_len15 = _v_deref__deref__item62.get_len ();
            uintptr_t _v_len16 = 0;
            if (_v_len15 < _v_len16)
            {
              goto _block2__branch6;
            }
            uintptr_t _v_len__len = (_v_len15 - _v_len16);
            uintptr_t _v_len17 = _v_deref__deref__item6.get_len ();
            uintptr_t _v_len18 = 0;
            if (_v_len17 < _v_len18)
            {
              goto _block2__branch6;
            }
            uintptr_t _v_len__pos2 = (_v_len17 - _v_len18);
            if (!_c_85.term_eq (_v_deref__item6, 0))
            {
              goto _block2__branch6;
            }
            Expr _vt_var (_v_deref__item6, (0 + 1), 1);
            Expr _ve_expr (_v_deref__item6, (0 + 1 + 1), _v_len__expr5);
            Expr _ve_pos (_v_deref__deref__item6, 0, _v_len__pos2);
            Expr _ve_len (_v_deref__deref__item62, 0, _v_len__len);
            Expr _vs_i;
            RF_CALL (Bind_m_Var, (_c_48, _vt_var), _vs_i);
            Expr _gs_auxcall15;
            RF_CALL (MV, /*void*/, _gs_auxcall15);
            RF_CALL (MethodVisitor::MVvisitTypeInsn, (_gs_auxcall15, _c_20, _c_30), /*void*/);
            Expr _gs_auxcall16;
            RF_CALL (MV, /*void*/, _gs_auxcall16);
            RF_CALL (MethodVisitor::MVvisitInsn, (_gs_auxcall16, _c_22), /*void*/);
            RF_CALL (Expr_m_Ref_m_To_m_JBC, _ve_expr, /*void*/);
            RF_CALL (Expr_m_Int_m_To_m_JBC, _ve_pos, /*void*/);
            RF_CALL (Expr_m_Int_m_To_m_JBC, _ve_len, /*void*/);
            Expr _gs_auxcall17;
            RF_CALL (MV, /*void*/, _gs_auxcall17);
            RF_CALL (MethodVisitor::MVvisitMethodInsn, (_gs_auxcall17, _c_23, _c_30, _c_24, _c_86), /*void*/);
            Expr _gs_auxcall18;
            RF_CALL (MV, /*void*/, _gs_auxcall18);
            RF_CALL (MethodVisitor::MVvisitVarInsn, (_gs_auxcall18, _c_71, _vs_i), /*void*/);
            goto _block2;
          }
        _block2__branch6: {}
          {
            if (_vt_item.symbol_at (0))
            {
              goto _block2__branch7;
            }
            Expr _v_deref__item7 (_vt_item, 0);
            uintptr_t _v_len19 = _v_deref__item7.get_len ();
            uintptr_t _v_len20 = 4;
            if (_v_len19 < _v_len20)
            {
              goto _block2__branch7;
            }
            uintptr_t _v_len__body = (_v_len19 - _v_len20);
            if (_v_deref__item7.symbol_at ((0 + 1 + 1)))
            {
              goto _block2__branch7;
            }
            if (_v_deref__item7.symbol_at ((0 + 1 + 1 + 1)))
            {
              goto _block2__branch7;
            }
            Expr _v_deref__deref__item7 (_v_deref__item7, (0 + 1 + 1));
            Expr _v_deref__deref__item72 (_v_deref__item7, (0 + 1 + 1 + 1));
            uintptr_t _v_len21 = _v_deref__deref__item72.get_len ();
            uintptr_t _v_len22 = 0;
            if (_v_len21 < _v_len22)
            {
              goto _block2__branch7;
            }
            uintptr_t _v_len__arg2 = (_v_len21 - _v_len22);
            uintptr_t _v_len23 = _v_deref__deref__item7.get_len ();
            uintptr_t _v_len24 = 0;
            if (_v_len23 < _v_len24)
            {
              goto _block2__branch7;
            }
            uintptr_t _v_len__arg1 = (_v_len23 - _v_len24);
            if (!_c_87.term_eq (_v_deref__item7, 0))
            {
              goto _block2__branch7;
            }
            if (!_v_deref__item7.symbol_at ((0 + 1)))
            {
              goto _block2__branch7;
            }
            Expr _vs_op (_v_deref__item7, (0 + 1), 1);
            Expr _ve_body (_v_deref__item7, (0 + 1 + 1 + 1 + 1), _v_len__body);
            Expr _ve_arg1 (_v_deref__deref__item7, 0, _v_len__arg1);
            Expr _ve_arg2 (_v_deref__deref__item72, 0, _v_len__arg2);
            RF_CALL (Push_m_Block_m_Table, /*void*/, /*void*/);
            Expr _vs_label;
            RF_CALL (Label::Label, /*void*/, _vs_label);
            RF_CALL (Expr_m_Int_m_To_m_JBC, _ve_arg1, /*void*/);
            RF_CALL (Expr_m_Int_m_To_m_JBC, _ve_arg2, /*void*/);
            Expr _gs_op__5;
            {
              {
                if (!_vs_op.term_eq (_c_88, 0))
                {
                  goto _block5__branch1;
                }
                _gs_op__5 = _c_89;
                goto _block5;
              }
            _block5__branch1: {}
              {
                if (!_vs_op.term_eq (_c_90, 0))
                {
                  goto _block5__branch2;
                }
                _gs_op__5 = _c_91;
                goto _block5;
              }
            _block5__branch2: {}
              if (!_vs_op.term_eq (_c_92, 0))
              {
                RF_FUNC_ERROR (unexpected_fail);
              }
              _gs_op__5 = _c_93;
            }
          _block5: {}
            Expr _gs_auxcall19;
            RF_CALL (MV, /*void*/, _gs_auxcall19);
            RF_CALL (MethodVisitor::MVvisitJumpInsn, (_gs_auxcall19, _gs_op__5, _vs_label), /*void*/);
            RF_CALL (ASAIL_m_To_m_JBC, _ve_body, /*void*/);
            Expr _gs_auxcall20;
            RF_CALL (MV, /*void*/, _gs_auxcall20);
            RF_CALL (MethodVisitor::MVvisitLabel, (_gs_auxcall20, _vs_label), /*void*/);
            RF_CALL (Pop_m_Block_m_Table, /*void*/, /*void*/);
            goto _block2;
          }
        _block2__branch7: {}
          {
            if (_vt_item.symbol_at (0))
            {
              goto _block2__branch8;
            }
            Expr _v_deref__item8 (_vt_item, 0);
            uintptr_t _v_len25 = _v_deref__item8.get_len ();
            uintptr_t _v_len26 = 2;
            if (_v_len25 < _v_len26)
            {
              goto _block2__branch8;
            }
            uintptr_t _v_len__body2 = (_v_len25 - _v_len26);
            if (!_c_94.term_eq (_v_deref__item8, 0))
            {
              goto _block2__branch8;
            }
            Expr _vt_cond (_v_deref__item8, (0 + 1), 1);
            Expr _ve_body (_v_deref__item8, (0 + 1 + 1), _v_len__body2);
            RF_CALL (Push_m_Block_m_Table, /*void*/, /*void*/);
            Expr _vs_label;
            RF_CALL (Label::Label, /*void*/, _vs_label);
            Expr _vs_if;
            RF_CALL (Cond_m_To_m_JBC, _vt_cond, _vs_if);
            Expr _gs_auxcall21;
            RF_CALL (MV, /*void*/, _gs_auxcall21);
            RF_CALL (MethodVisitor::MVvisitJumpInsn, (_gs_auxcall21, _vs_if, _vs_label), /*void*/);
            RF_CALL (ASAIL_m_To_m_JBC, _ve_body, /*void*/);
            Expr _gs_auxcall22;
            RF_CALL (MV, /*void*/, _gs_auxcall22);
            RF_CALL (MethodVisitor::MVvisitLabel, (_gs_auxcall22, _vs_label), /*void*/);
            RF_CALL (Pop_m_Block_m_Table, /*void*/, /*void*/);
            goto _block2;
          }
        _block2__branch8: {}
          {
            if (_vt_item.symbol_at (0))
            {
              goto _block2__branch9;
            }
            Expr _v_deref__item9 (_vt_item, 0);
            if (_v_deref__item9.get_len () != 5)
            {
              goto _block2__branch9;
            }
            if (_v_deref__item9.symbol_at ((0 + 1 + 1)))
            {
              goto _block2__branch9;
            }
            Expr _v_deref__deref__item9 (_v_deref__item9, (0 + 1 + 1));
            uintptr_t _v_len27 = _v_deref__deref__item9.get_len ();
            uintptr_t _v_len28 = 0;
            if (_v_len27 < _v_len28)
            {
              goto _block2__branch9;
            }
            uintptr_t _v_len__min = (_v_len27 - _v_len28);
            if (!_c_95.term_eq (_v_deref__item9, 0))
            {
              goto _block2__branch9;
            }
            Expr _vt_name (_v_deref__item9, (0 + 1), 1);
            Expr _vt_var1 (_v_deref__item9, (0 + 1 + 1 + 1), 1);
            Expr _vt_var2 (_v_deref__item9, (0 + 1 + 1 + 1 + 1), 1);
            Expr _ve_min (_v_deref__deref__item9, 0, _v_len__min);
            RF_CALL (Push_m_Block_m_Table, /*void*/, /*void*/);
            Expr _vs_i;
            RF_CALL (Bind_m_Iter_m_Var, (_vt_name, _vt_var1, _vt_var2), _vs_i);
            RF_CALL (Expr_m_Ref_m_To_m_JBC, _vt_name, /*void*/);
            RF_CALL (Expr_m_Int_m_To_m_JBC, _ve_min, /*void*/);
            Expr _gs_auxcall23;
            RF_CALL (MV, /*void*/, _gs_auxcall23);
            RF_CALL (MethodVisitor::MVvisitMethodInsn, (_gs_auxcall23, _c_75, _c_30, _c_96, _c_97), /*void*/);
            Expr _gs_auxcall24;
            RF_CALL (MV, /*void*/, _gs_auxcall24);
            RF_CALL (MethodVisitor::MVvisitVarInsn, (_gs_auxcall24, _c_71, _vs_i), /*void*/);
            goto _block2;
          }
        _block2__branch9: {}
          {
            if (_vt_item.symbol_at (0))
            {
              goto _block2__branch10;
            }
            Expr _v_deref__item10 (_vt_item, 0);
            if (_v_deref__item10.get_len () != 5)
            {
              goto _block2__branch10;
            }
            if (_v_deref__item10.symbol_at ((0 + 1 + 1)))
            {
              goto _block2__branch10;
            }
            Expr _v_deref__deref__item10 (_v_deref__item10, (0 + 1 + 1));
            uintptr_t _v_len29 = _v_deref__deref__item10.get_len ();
            uintptr_t _v_len30 = 0;
            if (_v_len29 < _v_len30)
            {
              goto _block2__branch10;
            }
            uintptr_t _v_len__min2 = (_v_len29 - _v_len30);
            if (!_c_98.term_eq (_v_deref__item10, 0))
            {
              goto _block2__branch10;
            }
            Expr _vt_name (_v_deref__item10, (0 + 1), 1);
            Expr _vt_var1 (_v_deref__item10, (0 + 1 + 1 + 1), 1);
            Expr _vt_var2 (_v_deref__item10, (0 + 1 + 1 + 1 + 1), 1);
            Expr _ve_min (_v_deref__deref__item10, 0, _v_len__min2);
            RF_CALL (Push_m_Block_m_Table, /*void*/, /*void*/);
            Expr _vs_i;
            RF_CALL (Bind_m_Iter_m_Var, (_vt_name, _vt_var1, _vt_var2), _vs_i);
            RF_CALL (Expr_m_Ref_m_To_m_JBC, _vt_name, /*void*/);
            RF_CALL (Expr_m_Int_m_To_m_JBC, _ve_min, /*void*/);
            Expr _gs_auxcall25;
            RF_CALL (MV, /*void*/, _gs_auxcall25);
            RF_CALL (MethodVisitor::MVvisitMethodInsn, (_gs_auxcall25, _c_75, _c_30, _c_99, _c_97), /*void*/);
            Expr _gs_auxcall26;
            RF_CALL (MV, /*void*/, _gs_auxcall26);
            RF_CALL (MethodVisitor::MVvisitVarInsn, (_gs_auxcall26, _c_71, _vs_i), /*void*/);
            goto _block2;
          }
        _block2__branch10: {}
          {
            if (_vt_item.symbol_at (0))
            {
              goto _block2__branch11;
            }
            Expr _v_deref__item11 (_vt_item, 0);
            uintptr_t _v_len31 = _v_deref__item11.get_len ();
            uintptr_t _v_len32 = 5;
            if (_v_len31 < _v_len32)
            {
              goto _block2__branch11;
            }
            uintptr_t _v_len__body3 = (_v_len31 - _v_len32);
            if (_v_deref__item11.symbol_at ((0 + 1)))
            {
              goto _block2__branch11;
            }
            if (_v_deref__item11.symbol_at ((0 + 1 + 1)))
            {
              goto _block2__branch11;
            }
            if (_v_deref__item11.symbol_at ((0 + 1 + 1 + 1 + 1)))
            {
              goto _block2__branch11;
            }
            Expr _v_deref__deref__item11 (_v_deref__item11, (0 + 1));
            Expr _v_deref__deref__item112 (_v_deref__item11, (0 + 1 + 1));
            Expr _v_deref__deref__item113 (_v_deref__item11, (0 + 1 + 1 + 1 + 1));
            uintptr_t _v_len33 = _v_deref__deref__item11.get_len ();
            uintptr_t _v_len34 = 0;
            if (_v_len33 < _v_len34)
            {
              goto _block2__branch11;
            }
            uintptr_t _v_len__cont_m_label = (_v_len33 - _v_len34);
            uintptr_t _v_len35 = _v_deref__deref__item113.get_len ();
            uintptr_t _v_len36 = 0;
            if (_v_len35 < _v_len36)
            {
              goto _block2__branch11;
            }
            uintptr_t _v_len__step = (_v_len35 - _v_len36);
            uintptr_t _v_len37 = _v_deref__deref__item112.get_len ();
            uintptr_t _v_len38 = 0;
            if (_v_len37 < _v_len38)
            {
              goto _block2__branch11;
            }
            uintptr_t _v_len__break_m_label = (_v_len37 - _v_len38);
            if (!_c_101.term_eq (_v_deref__item11, 0))
            {
              goto _block2__branch11;
            }
            if (!_c_100.term_eq (_v_deref__item11, (0 + 1 + 1 + 1)))
            {
              goto _block2__branch11;
            }
            Expr _ve_body (_v_deref__item11, (0 + 1 + 1 + 1 + 1 + 1), _v_len__body3);
            Expr _ve_cont_m_label (_v_deref__deref__item11, 0, _v_len__cont_m_label);
            Expr _ve_break_m_label (_v_deref__deref__item112, 0, _v_len__break_m_label);
            Expr _ve_step (_v_deref__deref__item113, 0, _v_len__step);
            {
              {
                if (_v_len__step != 0)
                {
                  goto _block6__branch1;
                }
                RF_CALL (Push_m_Block_m_Table, /*void*/, /*void*/);
                goto _block6;
              }
            _block6__branch1: {}
            }
          _block6: {}
            Expr _gs_cont_m_label__5;
            {
              {
                if (_v_len__cont_m_label != 1)
                {
                  goto _block7__branch1;
                }
                Expr _vt_label (_ve_cont_m_label, 0, 1);
                RF_CALL (Bind_m_Label, _vt_label, _gs_cont_m_label__5);
                goto _block7;
              }
            _block7__branch1: {}
              RF_CALL (Label::Label, /*void*/, _gs_cont_m_label__5);
            }
          _block7: {}
            Expr _gs_break_m_label__6;
            {
              {
                if (_v_len__break_m_label != 1)
                {
                  goto _block8__branch1;
                }
                Expr _vt_label (_ve_break_m_label, 0, 1);
                RF_CALL (Bind_m_Label, _vt_label, _gs_break_m_label__6);
                goto _block8;
              }
            _block8__branch1: {}
              RF_CALL (Label::Label, /*void*/, _gs_break_m_label__6);
            }
          _block8: {}
            Expr _vs_for_m_label;
            RF_CALL (Label::Label, /*void*/, _vs_for_m_label);
            Expr _gs_auxcall27;
            RF_CALL (MV, /*void*/, _gs_auxcall27);
            RF_CALL (MethodVisitor::MVvisitLabel, (_gs_auxcall27, _vs_for_m_label), /*void*/);
            {
              {
                if (_v_len__step != 1)
                {
                  goto _block9__branch1;
                }
                if (_ve_step.symbol_at (0))
                {
                  goto _block9__branch1;
                }
                Expr _v_deref__step (_ve_step, 0);
                uintptr_t _v_len39 = _v_deref__step.get_len ();
                uintptr_t _v_len40 = 1;
                if (_v_len39 < _v_len40)
                {
                  goto _block9__branch1;
                }
                uintptr_t _v_len__expr6 = (_v_len39 - _v_len40);
                if (!_v_deref__step.symbol_at (0))
                {
                  goto _block9__branch1;
                }
                Expr _vs_tag (_v_deref__step, 0, 1);
                Expr _ve_expr (_v_deref__step, (0 + 1), _v_len__expr6);
                {
                  {
                    if (!_vs_tag.term_eq (_c_102, 0))
                    {
                      goto _block10__branch1;
                    }
                    goto _block10;
                  }
                _block10__branch1: {}
                  if (!_vs_tag.term_eq (_c_103, 0))
                  {
                    goto _block9__branch1;
                  }
                }
              _block10: {}
                Expr _v_Lookup_m_Iter_m_Var1;
                Expr _v_Lookup_m_Iter_m_Var2;
                Expr _v_Lookup_m_Iter_m_Var3;
                RF_CALL (Lookup_m_Iter_m_Var, _ve_expr, (_v_Lookup_m_Iter_m_Var1, _v_Lookup_m_Iter_m_Var2, _v_Lookup_m_Iter_m_Var3));
                Expr _v_compose1 ((_v_Lookup_m_Iter_m_Var1 + _v_Lookup_m_Iter_m_Var2 + _v_Lookup_m_Iter_m_Var3));
                if (!_v_compose1.symbol_at (0))
                {
                  goto _continue1;
                }
                if (!_v_compose1.symbol_at ((0 + 1)))
                {
                  goto _continue1;
                }
                if (!_v_compose1.symbol_at ((0 + 1 + 1)))
                {
                  goto _continue1;
                }
                Expr _vs_i (_v_compose1, 0, 1);
                Expr _vs_i1 (_v_compose1, (0 + 1), 1);
                Expr _vs_i2 (_v_compose1, (0 + 1 + 1), 1);
                Expr _gs_auxcall28;
                RF_CALL (MV, /*void*/, _gs_auxcall28);
                RF_CALL (MethodVisitor::MVvisitVarInsn, (_gs_auxcall28, _c_14, _vs_i), /*void*/);
                Expr _gs_auxcall29;
                RF_CALL (MV, /*void*/, _gs_auxcall29);
                RF_CALL (MethodVisitor::MVvisitInsn, (_gs_auxcall29, _c_22), /*void*/);
                Expr _gs_auxcall30;
                RF_CALL (MV, /*void*/, _gs_auxcall30);
                RF_CALL (MethodVisitor::MVvisitMethodInsn, (_gs_auxcall30, _c_75, _c_104, _c_105, _c_106), /*void*/);
                Expr _gs_auxcall31;
                RF_CALL (MV, /*void*/, _gs_auxcall31);
                RF_CALL (MethodVisitor::MVvisitVarInsn, (_gs_auxcall31, _c_71, _vs_i1), /*void*/);
                Expr _gs_auxcall32;
                RF_CALL (MV, /*void*/, _gs_auxcall32);
                RF_CALL (MethodVisitor::MVvisitMethodInsn, (_gs_auxcall32, _c_75, _c_104, _c_107, _c_106), /*void*/);
                Expr _gs_auxcall33;
                RF_CALL (MV, /*void*/, _gs_auxcall33);
                RF_CALL (MethodVisitor::MVvisitVarInsn, (_gs_auxcall33, _c_71, _vs_i2), /*void*/);
                goto _block9;
              }
            _block9__branch1: {}
            }
          _block9: {}
            RF_CALL (ASAIL_m_To_m_JBC, _ve_body, /*void*/);
            Expr _gs_auxcall34;
            RF_CALL (MV, /*void*/, _gs_auxcall34);
            RF_CALL (MethodVisitor::MVvisitLabel, (_gs_auxcall34, _gs_cont_m_label__5), /*void*/);
            RF_CALL (Step_m_To_m_JBC, _ve_step, /*void*/);
            Expr _gs_auxcall35;
            RF_CALL (MV, /*void*/, _gs_auxcall35);
            RF_CALL (MethodVisitor::MVvisitJumpInsn, (_gs_auxcall35, _c_108, _vs_for_m_label), /*void*/);
            Expr _gs_auxcall36;
            RF_CALL (MV, /*void*/, _gs_auxcall36);
            RF_CALL (MethodVisitor::MVvisitLabel, (_gs_auxcall36, _gs_break_m_label__6), /*void*/);
            RF_CALL (Pop_m_Block_m_Table, /*void*/, /*void*/);
            goto _block2;
          }
        _block2__branch11: {}
          {
            if (_vt_item.symbol_at (0))
            {
              goto _block2__branch12;
            }
            Expr _v_deref__item12 (_vt_item, 0);
            uintptr_t _v_len41 = _v_deref__item12.get_len ();
            uintptr_t _v_len42 = 2;
            if (_v_len41 < _v_len42)
            {
              goto _block2__branch12;
            }
            uintptr_t _v_len__body4 = (_v_len41 - _v_len42);
            if (_v_deref__item12.symbol_at ((0 + 1)))
            {
              goto _block2__branch12;
            }
            Expr _v_deref__deref__item12 (_v_deref__item12, (0 + 1));
            if (_v_deref__deref__item12.get_len () != 1)
            {
              goto _block2__branch12;
            }
            if (!_c_51.term_eq (_v_deref__item12, 0))
            {
              goto _block2__branch12;
            }
            Expr _ve_body (_v_deref__item12, (0 + 1 + 1), _v_len__body4);
            Expr _vt_label (_v_deref__deref__item12, 0, 1);
            RF_CALL (Push_m_Block_m_Table, /*void*/, /*void*/);
            Expr _vs_l;
            RF_CALL (Bind_m_Label, _vt_label, _vs_l);
            RF_CALL (ASAIL_m_To_m_JBC, _ve_body, /*void*/);
            Expr _gs_auxcall37;
            RF_CALL (MV, /*void*/, _gs_auxcall37);
            RF_CALL (MethodVisitor::MVvisitLabel, (_gs_auxcall37, _vs_l), /*void*/);
            RF_CALL (Pop_m_Block_m_Table, /*void*/, /*void*/);
            goto _block2;
          }
        _block2__branch12: {}
          {
            if (_vt_item.symbol_at (0))
            {
              goto _block2__branch13;
            }
            Expr _v_deref__item13 (_vt_item, 0);
            if (_v_deref__item13.get_len () != 2)
            {
              goto _block2__branch13;
            }
            if (!_v_deref__item13.symbol_at (0))
            {
              goto _block2__branch13;
            }
            Expr _vs_tag (_v_deref__item13, 0, 1);
            Expr _vt_label (_v_deref__item13, (0 + 1), 1);
            {
              {
                if (!_vs_tag.term_eq (_c_109, 0))
                {
                  goto _block11__branch1;
                }
                goto _block11;
              }
            _block11__branch1: {}
              if (!_vs_tag.term_eq (_c_110, 0))
              {
                goto _block2__branch13;
              }
            }
          _block11: {}
            Expr _gs_auxcall38;
            RF_CALL (MV, /*void*/, _gs_auxcall38);
            Expr _gs_auxcall39;
            RF_CALL (Lookup_m_Label, _vt_label, _gs_auxcall39);
            RF_CALL (MethodVisitor::MVvisitJumpInsn, (_gs_auxcall38, _c_108, _gs_auxcall39), /*void*/);
            goto _block2;
          }
        _block2__branch13: {}
          {
            if (!_vt_item.term_eq (_c_111, 0))
            {
              goto _block2__branch14;
            }
            Expr _gs_auxcall40;
            RF_CALL (MV, /*void*/, _gs_auxcall40);
            RF_CALL (MethodVisitor::MVvisitInsn, (_gs_auxcall40, _c_112), /*void*/);
            Expr _gs_auxcall41;
            RF_CALL (MV, /*void*/, _gs_auxcall41);
            RF_CALL (MethodVisitor::MVvisitInsn, (_gs_auxcall41, _c_42), /*void*/);
            goto _block2;
          }
        _block2__branch14: {}
          {
            if (_vt_item.symbol_at (0))
            {
              goto _block2__branch15;
            }
            Expr _v_deref__item14 (_vt_item, 0);
            uintptr_t _v_len43 = _v_deref__item14.get_len ();
            uintptr_t _v_len44 = 1;
            if (_v_len43 < _v_len44)
            {
              goto _block2__branch15;
            }
            uintptr_t _v_len__body5 = (_v_len43 - _v_len44);
            if (!_c_113.term_eq (_v_deref__item14, 0))
            {
              goto _block2__branch15;
            }
            Expr _ve_body (_v_deref__item14, (0 + 1), _v_len__body5);
            RF_CALL (Push_m_Block_m_Table, /*void*/, /*void*/);
            Expr _vs_start;
            RF_CALL (Label::Label, /*void*/, _vs_start);
            Expr _vs_end;
            RF_CALL (Label::Label, /*void*/, _vs_end);
            Expr _vs_real_m_end;
            RF_CALL (Label::Label, /*void*/, _vs_real_m_end);
            Expr _vs_handler;
            RF_CALL (Label::Label, /*void*/, _vs_handler);
            RF_CALL (Push_m_Trap, (_vs_real_m_end, _vs_handler), /*void*/);
            Expr _gs_auxcall42;
            RF_CALL (MV, /*void*/, _gs_auxcall42);
            RF_CALL (MethodVisitor::MVvisitTryCatchBlock, (_gs_auxcall42, _vs_start, _vs_end, _vs_handler, _c_40), /*void*/);
            Expr _gs_auxcall43;
            RF_CALL (MV, /*void*/, _gs_auxcall43);
            RF_CALL (MethodVisitor::MVvisitLabel, (_gs_auxcall43, _vs_start), /*void*/);
            RF_CALL (ASAIL_m_To_m_JBC, _ve_body, /*void*/);
            Expr _gs_auxcall44;
            RF_CALL (MV, /*void*/, _gs_auxcall44);
            RF_CALL (MethodVisitor::MVvisitLabel, (_gs_auxcall44, _vs_end), /*void*/);
            Expr _gs_auxcall45;
            RF_CALL (MV, /*void*/, _gs_auxcall45);
            RF_CALL (MethodVisitor::MVvisitJumpInsn, (_gs_auxcall45, _c_108, _vs_real_m_end), /*void*/);
            RF_CALL (Pop_m_Block_m_Table, /*void*/, /*void*/);
            goto _block2;
          }
        _block2__branch15: {}
          {
            if (_vt_item.symbol_at (0))
            {
              goto _block2__branch16;
            }
            Expr _v_deref__item15 (_vt_item, 0);
            uintptr_t _v_len45 = _v_deref__item15.get_len ();
            uintptr_t _v_len46 = 1;
            if (_v_len45 < _v_len46)
            {
              goto _block2__branch16;
            }
            uintptr_t _v_len__body6 = (_v_len45 - _v_len46);
            if (!_c_114.term_eq (_v_deref__item15, 0))
            {
              goto _block2__branch16;
            }
            Expr _ve_body (_v_deref__item15, (0 + 1), _v_len__body6);
            RF_CALL (Push_m_Block_m_Table, /*void*/, /*void*/);
            Expr _vs_label;
            RF_CALL (Get_m_Trap, /*void*/, _vs_label);
            Expr _gs_auxcall46;
            RF_CALL (MV, /*void*/, _gs_auxcall46);
            RF_CALL (MethodVisitor::MVvisitLabel, (_gs_auxcall46, _vs_label), /*void*/);
            Expr _gs_auxcall47;
            RF_CALL (MV, /*void*/, _gs_auxcall47);
            RF_CALL (MethodVisitor::MVvisitMethodInsn, (_gs_auxcall47, _c_75, _c_40, _c_115, _c_106), /*void*/);
            Expr _gs_auxcall48;
            RF_CALL (MV, /*void*/, _gs_auxcall48);
            Expr _gs_auxcall49;
            RF_CALL (Bind_m_Var, (_c_48, _vs_label), _gs_auxcall49);
            RF_CALL (MethodVisitor::MVvisitVarInsn, (_gs_auxcall48, _c_71, _gs_auxcall49), /*void*/);
            RF_CALL (ASAIL_m_To_m_JBC, _ve_body, /*void*/);
            Expr _gs_auxcall50;
            RF_CALL (MV, /*void*/, _gs_auxcall50);
            Expr _gs_auxcall51;
            RF_CALL (Pop_m_Trap, /*void*/, _gs_auxcall51);
            RF_CALL (MethodVisitor::MVvisitLabel, (_gs_auxcall50, _gs_auxcall51), /*void*/);
            RF_CALL (Pop_m_Block_m_Table, /*void*/, /*void*/);
            goto _block2;
          }
        _block2__branch16: {}
          {
            if (!_vt_item.term_eq (_c_116, 0))
            {
              goto _block2__branch17;
            }
            Expr _gs_auxcall52;
            RF_CALL (MV, /*void*/, _gs_auxcall52);
            RF_CALL (MethodVisitor::MVvisitTypeInsn, (_gs_auxcall52, _c_20, _c_40), /*void*/);
            Expr _gs_auxcall53;
            RF_CALL (MV, /*void*/, _gs_auxcall53);
            RF_CALL (MethodVisitor::MVvisitInsn, (_gs_auxcall53, _c_22), /*void*/);
            Expr _v__q_1;
            RF_CALL (Box::_q_, Refal_m_Module_m_Name, _v__q_1);
            if (_v__q_1.get_len () != 1)
            {
              goto _continue1;
            }
            if (!_v__q_1.symbol_at (0))
            {
              goto _continue1;
            }
            Expr _vs_mod_m_name (_v__q_1, 0, 1);
            Expr _gs_auxcall54;
            RF_CALL (MV, /*void*/, _gs_auxcall54);
            Expr _gs_auxcall55;
            RF_CALL (Java::WordToString, _vs_mod_m_name, _gs_auxcall55);
            RF_CALL (MethodVisitor::MVvisitLdcInsn, (_gs_auxcall54, _gs_auxcall55), /*void*/);
            Expr _v__q_2;
            RF_CALL (Box::_q_, Func_m_Name, _v__q_2);
            if (_v__q_2.get_len () != 1)
            {
              goto _continue1;
            }
            if (!_v__q_2.symbol_at (0))
            {
              goto _continue1;
            }
            Expr _vs_fname (_v__q_2, 0, 1);
            Expr _gs_auxcall56;
            RF_CALL (MV, /*void*/, _gs_auxcall56);
            Expr _gs_auxcall57;
            RF_CALL (Java::WordToString, _vs_fname, _gs_auxcall57);
            RF_CALL (MethodVisitor::MVvisitLdcInsn, (_gs_auxcall56, _gs_auxcall57), /*void*/);
            Expr _gs_auxcall58;
            RF_CALL (MV, /*void*/, _gs_auxcall58);
            Expr _gs_auxcall59;
            RF_CALL (Java::WordToString, _c_117, _gs_auxcall59);
            RF_CALL (MethodVisitor::MVvisitLdcInsn, (_gs_auxcall58, _gs_auxcall59), /*void*/);
            Expr _gs_auxcall60;
            RF_CALL (MV, /*void*/, _gs_auxcall60);
            RF_CALL (MethodVisitor::MVvisitMethodInsn, (_gs_auxcall60, _c_23, _c_40, _c_24, _c_118), /*void*/);
            Expr _gs_auxcall61;
            RF_CALL (MV, /*void*/, _gs_auxcall61);
            RF_CALL (MethodVisitor::MVvisitInsn, (_gs_auxcall61, _c_119), /*void*/);
            goto _block2;
          }
        _block2__branch17: {}
          {
            if (_vt_item.symbol_at (0))
            {
              goto _block2__branch18;
            }
            Expr _v_deref__item16 (_vt_item, 0);
            uintptr_t _v_len47 = _v_deref__item16.get_len ();
            uintptr_t _v_len48 = 1;
            if (_v_len47 < _v_len48)
            {
              goto _block2__branch18;
            }
            uintptr_t _v_len__expr7 = (_v_len47 - _v_len48);
            if (!_c_120.term_eq (_v_deref__item16, 0))
            {
              goto _block2__branch18;
            }
            Expr _ve_expr (_v_deref__item16, (0 + 1), _v_len__expr7);
            Expr _gs_auxcall62;
            RF_CALL (MV, /*void*/, _gs_auxcall62);
            RF_CALL (MethodVisitor::MVvisitTypeInsn, (_gs_auxcall62, _c_20, _c_40), /*void*/);
            Expr _gs_auxcall63;
            RF_CALL (MV, /*void*/, _gs_auxcall63);
            RF_CALL (MethodVisitor::MVvisitInsn, (_gs_auxcall63, _c_22), /*void*/);
            RF_CALL (Expr_m_Ref_m_To_m_JBC, _ve_expr, /*void*/);
            Expr _gs_auxcall64;
            RF_CALL (MV, /*void*/, _gs_auxcall64);
            RF_CALL (MethodVisitor::MVvisitMethodInsn, (_gs_auxcall64, _c_23, _c_40, _c_24, _c_77), /*void*/);
            Expr _gs_auxcall65;
            RF_CALL (MV, /*void*/, _gs_auxcall65);
            RF_CALL (MethodVisitor::MVvisitInsn, (_gs_auxcall65, _c_119), /*void*/);
            goto _block2;
          }
        _block2__branch18: {}
          if (_vt_item.symbol_at (0))
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          Expr _v_deref__item17 (_vt_item, 0);
          if (_v_deref__item17.get_len () != 4)
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          if (_v_deref__item17.symbol_at ((0 + 1)))
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          if (_v_deref__item17.symbol_at ((0 + 1 + 1)))
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          if (_v_deref__item17.symbol_at ((0 + 1 + 1 + 1)))
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          Expr _v_deref__deref__item17 (_v_deref__item17, (0 + 1));
          Expr _v_deref__deref__item172 (_v_deref__item17, (0 + 1 + 1));
          Expr _v_deref__deref__item173 (_v_deref__item17, (0 + 1 + 1 + 1));
          uintptr_t _v_len49 = _v_deref__deref__item17.get_len ();
          uintptr_t _v_len50 = 1;
          if (_v_len49 < _v_len50)
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          uintptr_t _v_len__module = (_v_len49 - _v_len50);
          uintptr_t _v_len51 = _v_deref__deref__item173.get_len ();
          uintptr_t _v_len52 = 0;
          if (_v_len51 < _v_len52)
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          uintptr_t _v_len__ress = (_v_len51 - _v_len52);
          uintptr_t _v_len53 = _v_deref__deref__item172.get_len ();
          uintptr_t _v_len54 = 0;
          if (_v_len53 < _v_len54)
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          uintptr_t _v_len__args = (_v_len53 - _v_len54);
          if (!_v_deref__item17.symbol_at (0))
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          if (!_v_deref__deref__item17.symbol_at ((0 + _v_len__module)))
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          Expr _vs_call (_v_deref__item17, 0, 1);
          Expr _ve_module (_v_deref__deref__item17, 0, _v_len__module);
          Expr _vs_name (_v_deref__deref__item17, (0 + _v_len__module), 1);
          Expr _ve_args (_v_deref__deref__item172, 0, _v_len__args);
          Expr _ve_ress (_v_deref__deref__item173, 0, _v_len__ress);
          Expr _vs_retType;
          {
            {
              if (!_vs_call.term_eq (_c_121, 0))
              {
                goto _block12__branch1;
              }
              _vs_retType = _c_122;
              goto _block12;
            }
          _block12__branch1: {}
            {
              if (!_vs_call.term_eq (_c_123, 0))
              {
                goto _block12__branch2;
              }
              _vs_retType = _c_122;
              goto _block12;
            }
          _block12__branch2: {}
            if (!_vs_call.term_eq (_c_124, 0))
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            _vs_retType = _c_125;
          }
        _block12: {}
          Expr _gs_module__5;
          RF_CALL (Qualified_m_Module_m_Name, _ve_module, _gs_module__5);
          Expr _ge_auxcall66;
          RF_CALL (JavaMangle::Rfp2Java, _vs_name, _ge_auxcall66);
          Expr _gs_name__5;
          RF_CALL (Convert::To_m_Word, _ge_auxcall66, _gs_name__5);
          Expr _vs_desc;
          RF_CALL (Function_m_Description, (_ve_args, _ve_ress, _vs_retType), _vs_desc);
          {
            if (_v_len__args < 1)
            {
              goto _block13__branch1;
            }
            RF_lsplit (_ve_args, 0, _ve__e__e_tmp_m_rfp__asail__jbcrf_m_524_m_19, _v_lsplit__args);
            for ( ; ; RF_iter(_ve_args)++)
            {
              {
                if (!RF_iter(_ve_args))
                {
                  goto _block13__branch1;
                }
                uintptr_t _v_len55 = _v_lsplit__args.get_len ();
                uintptr_t _v_len56 = 1;
                if (_v_len55 < _v_len56)
                {
                  goto _block13__branch1;
                }
                uintptr_t _v_len___e__e_tmp_m_rfp__asail__jbcrf_m_524_m_29 = (_v_len55 - _v_len56);
                if (_v_lsplit__args.symbol_at (0))
                {
                  goto _continue2;
                }
                Expr _v_deref__lsplit__args (_v_lsplit__args, 0);
                uintptr_t _v_len57 = _v_deref__lsplit__args.get_len ();
                uintptr_t _v_len58 = 0;
                if (_v_len57 < _v_len58)
                {
                  goto _continue2;
                }
                uintptr_t _v_len__arg = (_v_len57 - _v_len58);
                Expr _ve__e__e_tmp_m_rfp__asail__jbcrf_m_524_m_29 (_v_lsplit__args, (0 + 1), _v_len___e__e_tmp_m_rfp__asail__jbcrf_m_524_m_29);
                Expr _ve_arg (_v_deref__lsplit__args, 0, _v_len__arg);
                RF_CALL (Expr_m_Ref_m_To_m_JBC, _ve_arg, /*void*/);
              }
          _continue2: {}
            }
          _exit2: {}
          }
        _block13__branch1: {}
          {
            if (_v_len__ress < 1)
            {
              goto _block14__branch1;
            }
            RF_lsplit (_ve_ress, 0, _ve__e__e_tmp_m_rfp__asail__jbcrf_m_529_m_19, _v_lsplit__ress);
            for ( ; ; RF_iter(_ve_ress)++)
            {
              {
                if (!RF_iter(_ve_ress))
                {
                  goto _block14__branch1;
                }
                uintptr_t _v_len59 = _v_lsplit__ress.get_len ();
                uintptr_t _v_len60 = 1;
                if (_v_len59 < _v_len60)
                {
                  goto _block14__branch1;
                }
                uintptr_t _v_len___e__e_tmp_m_rfp__asail__jbcrf_m_529_m_27 = (_v_len59 - _v_len60);
                Expr _vt_var (_v_lsplit__ress, 0, 1);
                Expr _ve__e__e_tmp_m_rfp__asail__jbcrf_m_529_m_27 (_v_lsplit__ress, (0 + 1), _v_len___e__e_tmp_m_rfp__asail__jbcrf_m_529_m_27);
                Expr _v_Lookup_m_Var1;
                Expr _v_Lookup_m_Var2;
                RF_CALL (Lookup_m_Var, _vt_var, (_v_Lookup_m_Var1, _v_Lookup_m_Var2));
                {
                  {
                    Expr _v_compose2 ((_v_Lookup_m_Var1 + _v_Lookup_m_Var2));
                    if (!_c_48.term_eq (_v_compose2, 0))
                    {
                      goto _block15__branch1;
                    }
                    if (!_v_compose2.symbol_at ((0 + 1)))
                    {
                      goto _block15__branch1;
                    }
                    Expr _vs__e__e_tmp_m_rfp__asail__jbcrf_m_531_m_19 (_v_compose2, (0 + 1), 1);
                    Expr _vs_j;
                    RF_CALL (Bind_m_TMP_m_Var, _vt_var, _vs_j);
                    Expr _gs_auxcall67;
                    RF_CALL (MV, /*void*/, _gs_auxcall67);
                    RF_CALL (MethodVisitor::MVvisitTypeInsn, (_gs_auxcall67, _c_20, _c_21), /*void*/);
                    Expr _gs_auxcall68;
                    RF_CALL (MV, /*void*/, _gs_auxcall68);
                    RF_CALL (MethodVisitor::MVvisitInsn, (_gs_auxcall68, _c_22), /*void*/);
                    Expr _gs_auxcall69;
                    RF_CALL (MV, /*void*/, _gs_auxcall69);
                    RF_CALL (MethodVisitor::MVvisitInsn, (_gs_auxcall69, _c_22), /*void*/);
                    Expr _gs_auxcall70;
                    RF_CALL (MV, /*void*/, _gs_auxcall70);
                    RF_CALL (MethodVisitor::MVvisitMethodInsn, (_gs_auxcall70, _c_23, _c_21, _c_24, _c_25), /*void*/);
                    Expr _gs_auxcall71;
                    RF_CALL (MV, /*void*/, _gs_auxcall71);
                    RF_CALL (MethodVisitor::MVvisitVarInsn, (_gs_auxcall71, _c_71, _vs_j), /*void*/);
                    goto _block15;
                  }
                _block15__branch1: {}
                  Expr _v_compose3 ((_v_Lookup_m_Var1 + _v_Lookup_m_Var2));
                  if (!_c_62.term_eq (_v_compose3, 0))
                  {
                    RF_FUNC_ERROR (unexpected_fail);
                  }
                  if (!_v_compose3.symbol_at ((0 + 1)))
                  {
                    RF_FUNC_ERROR (unexpected_fail);
                  }
                  Expr _vs_i (_v_compose3, (0 + 1), 1);
                  Expr _gs_auxcall72;
                  RF_CALL (MV, /*void*/, _gs_auxcall72);
                  RF_CALL (MethodVisitor::MVvisitVarInsn, (_gs_auxcall72, _c_14, _vs_i), /*void*/);
                }
              _block15: {}
              }
          _continue3: {}
            }
          _exit3: {}
          }
        _block14__branch1: {}
          Expr _gs_auxcall73;
          RF_CALL (MV, /*void*/, _gs_auxcall73);
          RF_CALL (MethodVisitor::MVvisitMethodInsn, (_gs_auxcall73, _c_16, _gs_module__5, _gs_name__5, _vs_desc), /*void*/);
          {
            {
              if (!_vs_call.term_eq (_c_124, 0))
              {
                goto _block16__branch1;
              }
              Expr _vs_label;
              RF_CALL (Label::Label, /*void*/, _vs_label);
              Expr _gs_auxcall74;
              RF_CALL (MV, /*void*/, _gs_auxcall74);
              RF_CALL (MethodVisitor::MVvisitJumpInsn, (_gs_auxcall74, _c_126, _vs_label), /*void*/);
              Expr _gs_auxcall75;
              RF_CALL (MV, /*void*/, _gs_auxcall75);
              RF_CALL (MethodVisitor::MVvisitInsn, (_gs_auxcall75, _c_112), /*void*/);
              Expr _gs_auxcall76;
              RF_CALL (MV, /*void*/, _gs_auxcall76);
              RF_CALL (MethodVisitor::MVvisitInsn, (_gs_auxcall76, _c_42), /*void*/);
              Expr _gs_auxcall77;
              RF_CALL (MV, /*void*/, _gs_auxcall77);
              RF_CALL (MethodVisitor::MVvisitLabel, (_gs_auxcall77, _vs_label), /*void*/);
              goto _block16;
            }
          _block16__branch1: {}
          }
        _block16: {}
          {
            if (_v_len__ress < 1)
            {
              goto _block17__branch1;
            }
            RF_lsplit (_ve_ress, 0, _ve__e__e_tmp_m_rfp__asail__jbcrf_m_552_m_19, _v_lsplit__ress2);
            for ( ; ; RF_iter(_ve_ress)++)
            {
              {
                if (!RF_iter(_ve_ress))
                {
                  goto _block17__branch1;
                }
                uintptr_t _v_len61 = _v_lsplit__ress2.get_len ();
                uintptr_t _v_len62 = 1;
                if (_v_len61 < _v_len62)
                {
                  goto _block17__branch1;
                }
                uintptr_t _v_len___e__e_tmp_m_rfp__asail__jbcrf_m_552_m_27 = (_v_len61 - _v_len62);
                Expr _vt_var (_v_lsplit__ress2, 0, 1);
                Expr _ve__e__e_tmp_m_rfp__asail__jbcrf_m_552_m_27 (_v_lsplit__ress2, (0 + 1), _v_len___e__e_tmp_m_rfp__asail__jbcrf_m_552_m_27);
                Expr _v_Lookup_m_Var3;
                Expr _v_Lookup_m_Var4;
                RF_CALL (Lookup_m_Var, _vt_var, (_v_Lookup_m_Var3, _v_Lookup_m_Var4));
                Expr _v_compose4 ((_v_Lookup_m_Var3 + _v_Lookup_m_Var4));
                if (!_c_48.term_eq (_v_compose4, 0))
                {
                  goto _continue4;
                }
                if (!_v_compose4.symbol_at ((0 + 1)))
                {
                  goto _continue4;
                }
                Expr _vs_i (_v_compose4, (0 + 1), 1);
                Expr _vs_j;
                RF_CALL (Lookup_m_TMP_m_Var, _vt_var, _vs_j);
                Expr _gs_auxcall78;
                RF_CALL (MV, /*void*/, _gs_auxcall78);
                RF_CALL (MethodVisitor::MVvisitVarInsn, (_gs_auxcall78, _c_14, _vs_j), /*void*/);
                Expr _gs_auxcall79;
                RF_CALL (MV, /*void*/, _gs_auxcall79);
                RF_CALL (MethodVisitor::MVvisitMethodInsn, (_gs_auxcall79, _c_75, _c_21, _c_115, _c_106), /*void*/);
                Expr _gs_auxcall80;
                RF_CALL (MV, /*void*/, _gs_auxcall80);
                RF_CALL (MethodVisitor::MVvisitVarInsn, (_gs_auxcall80, _c_71, _vs_i), /*void*/);
              }
          _continue4: {}
            }
          _exit4: {}
          }
        _block17__branch1: {}
        }
      _block2: {}
      }
  _continue1: {}
    }
  _exit1: {}
  }
_block1__branch1: {}
RF_END

RF_FUNC (Expr_m_Ref_m_To_m_JBC, (RF_ARG _ge_arg1;;), RF_VOID)
  {
    {
      if (_ge_arg1.get_len () != 0)
      {
        goto _block1__branch1;
      }
      Expr _gs_auxcall1;
      RF_CALL (MV, /*void*/, _gs_auxcall1);
      RF_TAILCALL (MethodVisitor::MVvisitFieldInsn, (_gs_auxcall1, _c_72, _c_30, _c_73, _c_34), /*void*/);
      goto _block1;
    }
  _block1__branch1: {}
    {
      if (_ge_arg1.get_len () != 1)
      {
        goto _block1__branch2;
      }
      Expr _vt_term (_ge_arg1, 0, 1);
      RF_TAILCALL (Term_m_Ref_m_To_m_JBC, _vt_term, /*void*/);
      goto _block1;
    }
  _block1__branch2: {}
    {
      if (_ge_arg1.get_len () != 2)
      {
        goto _block1__branch3;
      }
      Expr _vt_term1 (_ge_arg1, 0, 1);
      Expr _vt_term2 (_ge_arg1, (0 + 1), 1);
      RF_CALL (Term_m_Ref_m_To_m_JBC, _vt_term1, /*void*/);
      RF_CALL (Term_m_Ref_m_To_m_JBC, _vt_term2, /*void*/);
      Expr _gs_auxcall2;
      RF_CALL (MV, /*void*/, _gs_auxcall2);
      RF_TAILCALL (MethodVisitor::MVvisitMethodInsn, (_gs_auxcall2, _c_16, _c_30, _c_127, _c_128), /*void*/);
      goto _block1;
    }
  _block1__branch3: {}
    Expr _gs_auxcall3;
    RF_CALL (MV, /*void*/, _gs_auxcall3);
    Expr _gs_auxcall4;
    RF_CALL (Access::Length, _ge_arg1, _gs_auxcall4);
    Expr _gs_auxcall5;
    RF_CALL (Integer::Integer, _gs_auxcall4, _gs_auxcall5);
    RF_CALL (MethodVisitor::MVvisitLdcInsn, (_gs_auxcall3, _gs_auxcall5), /*void*/);
    Expr _gs_auxcall6;
    RF_CALL (MV, /*void*/, _gs_auxcall6);
    RF_CALL (MethodVisitor::MVvisitTypeInsn, (_gs_auxcall6, _c_129, _c_30), /*void*/);
    Expr _vs_i (_c_15);
    Expr _ge_arg1__2 (_ge_arg1);
    for ( ; ; )
    {
      {
        if (_ge_arg1__2.get_len () != 0)
        {
          goto _iter1;
        }
        Expr _gs_auxcall12;
        RF_CALL (MV, /*void*/, _gs_auxcall12);
        RF_TAILCALL (MethodVisitor::MVvisitMethodInsn, (_gs_auxcall12, _c_16, _c_30, _c_127, _c_130), /*void*/);
        goto _exit__iter1;
      }
    _iter1: {}
      uintptr_t _v_len1 = _ge_arg1__2.get_len ();
      uintptr_t _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      uintptr_t _v_len__rest = (_v_len1 - _v_len2);
      Expr _vt_term (_ge_arg1__2, 0, 1);
      Expr _ve_rest (_ge_arg1__2, (0 + 1), _v_len__rest);
      Expr _gs_auxcall7;
      RF_CALL (MV, /*void*/, _gs_auxcall7);
      RF_CALL (MethodVisitor::MVvisitInsn, (_gs_auxcall7, _c_22), /*void*/);
      Expr _gs_auxcall8;
      RF_CALL (MV, /*void*/, _gs_auxcall8);
      Expr _gs_auxcall9;
      RF_CALL (Integer::Integer, _vs_i, _gs_auxcall9);
      RF_CALL (MethodVisitor::MVvisitLdcInsn, (_gs_auxcall8, _gs_auxcall9), /*void*/);
      RF_CALL (Term_m_Ref_m_To_m_JBC, _vt_term, /*void*/);
      Expr _gs_auxcall10;
      RF_CALL (MV, /*void*/, _gs_auxcall10);
      RF_CALL (MethodVisitor::MVvisitInsn, (_gs_auxcall10, _c_131), /*void*/);
      Expr _gs_auxcall11;
      RF_CALL (Arithm::_p_, (_vs_i, _c_7), _gs_auxcall11);
      _vs_i = _gs_auxcall11;
      _ge_arg1__2 = _ve_rest;
    }
  _exit__iter1: {}
  }
_block1: {}
RF_END

RF_FUNC (Term_m_Ref_m_To_m_JBC, (RF_ARG _gt_arg1;;), RF_VOID)
  {
    {
      if (_gt_arg1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__arg1 (_gt_arg1, 0);
      uintptr_t _v_len1 = _v_deref__arg1.get_len ();
      uintptr_t _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__expr = (_v_len1 - _v_len2);
      if (!_c_132.term_eq (_v_deref__arg1, 0))
      {
        goto _block1__branch1;
      }
      Expr _ve_expr (_v_deref__arg1, (0 + 1), _v_len__expr);
      Expr _gs_auxcall1;
      RF_CALL (MV, /*void*/, _gs_auxcall1);
      RF_CALL (MethodVisitor::MVvisitTypeInsn, (_gs_auxcall1, _c_20, _c_30), /*void*/);
      Expr _gs_auxcall2;
      RF_CALL (MV, /*void*/, _gs_auxcall2);
      RF_CALL (MethodVisitor::MVvisitInsn, (_gs_auxcall2, _c_22), /*void*/);
      RF_CALL (Expr_m_Ref_m_To_m_JBC, _ve_expr, /*void*/);
      Expr _gs_auxcall3;
      RF_CALL (MV, /*void*/, _gs_auxcall3);
      RF_TAILCALL (MethodVisitor::MVvisitMethodInsn, (_gs_auxcall3, _c_23, _c_30, _c_24, _c_32), /*void*/);
      goto _block1;
    }
  _block1__branch1: {}
    {
      if (_gt_arg1.symbol_at (0))
      {
        goto _block1__branch2;
      }
      Expr _v_deref__arg12 (_gt_arg1, 0);
      uintptr_t _v_len3 = _v_deref__arg12.get_len ();
      uintptr_t _v_len4 = 2;
      if (_v_len3 < _v_len4)
      {
        goto _block1__branch2;
      }
      uintptr_t _v_len__expr2 = (_v_len3 - _v_len4);
      if (_v_deref__arg12.symbol_at ((0 + 1 + _v_len__expr2)))
      {
        goto _block1__branch2;
      }
      Expr _v_deref__deref__arg12 (_v_deref__arg12, (0 + 1 + _v_len__expr2));
      uintptr_t _v_len5 = _v_deref__deref__arg12.get_len ();
      uintptr_t _v_len6 = 0;
      if (_v_len5 < _v_len6)
      {
        goto _block1__branch2;
      }
      uintptr_t _v_len__pos = (_v_len5 - _v_len6);
      if (!_c_81.term_eq (_v_deref__arg12, 0))
      {
        goto _block1__branch2;
      }
      Expr _ve_expr (_v_deref__arg12, (0 + 1), _v_len__expr2);
      Expr _ve_pos (_v_deref__deref__arg12, 0, _v_len__pos);
      RF_CALL (Expr_m_Ref_m_To_m_JBC, _ve_expr, /*void*/);
      RF_CALL (Expr_m_Int_m_To_m_JBC, _ve_pos, /*void*/);
      Expr _gs_auxcall4;
      RF_CALL (MV, /*void*/, _gs_auxcall4);
      RF_CALL (MethodVisitor::MVvisitMethodInsn, (_gs_auxcall4, _c_75, _c_30, _c_82, _c_83), /*void*/);
      Expr _gs_auxcall5;
      RF_CALL (MV, /*void*/, _gs_auxcall5);
      RF_TAILCALL (MethodVisitor::MVvisitTypeInsn, (_gs_auxcall5, _c_84, _c_30), /*void*/);
      goto _block1;
    }
  _block1__branch2: {}
    {
      if (_gt_arg1.symbol_at (0))
      {
        goto _block1__branch3;
      }
      Expr _v_deref__arg13 (_gt_arg1, 0);
      uintptr_t _v_len7 = _v_deref__arg13.get_len ();
      uintptr_t _v_len8 = 3;
      if (_v_len7 < _v_len8)
      {
        goto _block1__branch3;
      }
      uintptr_t _v_len__expr3 = (_v_len7 - _v_len8);
      if (_v_deref__arg13.symbol_at ((0 + 1 + _v_len__expr3)))
      {
        goto _block1__branch3;
      }
      if (_v_deref__arg13.symbol_at ((0 + 1 + _v_len__expr3 + 1)))
      {
        goto _block1__branch3;
      }
      Expr _v_deref__deref__arg13 (_v_deref__arg13, (0 + 1 + _v_len__expr3));
      Expr _v_deref__deref__arg132 (_v_deref__arg13, (0 + 1 + _v_len__expr3 + 1));
      uintptr_t _v_len9 = _v_deref__deref__arg132.get_len ();
      uintptr_t _v_len10 = 0;
      if (_v_len9 < _v_len10)
      {
        goto _block1__branch3;
      }
      uintptr_t _v_len__len = (_v_len9 - _v_len10);
      uintptr_t _v_len11 = _v_deref__deref__arg13.get_len ();
      uintptr_t _v_len12 = 0;
      if (_v_len11 < _v_len12)
      {
        goto _block1__branch3;
      }
      uintptr_t _v_len__pos2 = (_v_len11 - _v_len12);
      if (!_c_85.term_eq (_v_deref__arg13, 0))
      {
        goto _block1__branch3;
      }
      Expr _ve_expr (_v_deref__arg13, (0 + 1), _v_len__expr3);
      Expr _ve_pos (_v_deref__deref__arg13, 0, _v_len__pos2);
      Expr _ve_len (_v_deref__deref__arg132, 0, _v_len__len);
      Expr _gs_auxcall6;
      RF_CALL (MV, /*void*/, _gs_auxcall6);
      RF_CALL (MethodVisitor::MVvisitTypeInsn, (_gs_auxcall6, _c_20, _c_30), /*void*/);
      Expr _gs_auxcall7;
      RF_CALL (MV, /*void*/, _gs_auxcall7);
      RF_CALL (MethodVisitor::MVvisitInsn, (_gs_auxcall7, _c_22), /*void*/);
      RF_CALL (Expr_m_Ref_m_To_m_JBC, _ve_expr, /*void*/);
      RF_CALL (Expr_m_Int_m_To_m_JBC, _ve_pos, /*void*/);
      RF_CALL (Expr_m_Int_m_To_m_JBC, _ve_len, /*void*/);
      Expr _gs_auxcall8;
      RF_CALL (MV, /*void*/, _gs_auxcall8);
      RF_TAILCALL (MethodVisitor::MVvisitMethodInsn, (_gs_auxcall8, _c_23, _c_30, _c_24, _c_86), /*void*/);
      goto _block1;
    }
  _block1__branch3: {}
    {
      Expr _vs_module;
      Expr _vt_name;
      {
        {
          if (_gt_arg1.symbol_at (0))
          {
            goto _block2__branch1;
          }
          Expr _v_deref__arg14 (_gt_arg1, 0);
          if (_v_deref__arg14.get_len () != 2)
          {
            goto _block2__branch1;
          }
          if (_v_deref__arg14.symbol_at ((0 + 1)))
          {
            goto _block2__branch1;
          }
          Expr _v_deref__deref__arg14 (_v_deref__arg14, (0 + 1));
          if (_v_deref__deref__arg14.get_len () != 2)
          {
            goto _block2__branch1;
          }
          if (!_c_133.term_eq (_v_deref__arg14, 0))
          {
            goto _block2__branch1;
          }
          if (!_v_deref__deref__arg14.symbol_at (0))
          {
            goto _block2__branch1;
          }
          if (!_v_deref__deref__arg14.symbol_at ((0 + 1)))
          {
            goto _block2__branch1;
          }
          Expr _gs_module__4 (_v_deref__deref__arg14, 0, 1);
          Expr _gs_name__4 (_v_deref__deref__arg14, (0 + 1), 1);
          Expr _gs_auxcall9;
          RF_CALL (Qualified_m_Module_m_Name, _gs_module__4, _gs_auxcall9);
          _vs_module = _gs_auxcall9;
          _vt_name = _gs_name__4;
          goto _block2;
        }
      _block2__branch1: {}
        if (_gt_arg1.symbol_at (0))
        {
          goto _block1__branch4;
        }
        Expr _v_deref__arg15 (_gt_arg1, 0);
        if (_v_deref__arg15.get_len () != 2)
        {
          goto _block1__branch4;
        }
        if (_v_deref__arg15.symbol_at ((0 + 1)))
        {
          goto _block1__branch4;
        }
        Expr _v_deref__deref__arg15 (_v_deref__arg15, (0 + 1));
        uintptr_t _v_len13 = _v_deref__deref__arg15.get_len ();
        uintptr_t _v_len14 = 0;
        if (_v_len13 < _v_len14)
        {
          goto _block1__branch4;
        }
        uintptr_t _v_len___e__e_tmp_m_rfp__asail__jbcrf_m_607_m_15 = (_v_len13 - _v_len14);
        if (!_c_64.term_eq (_v_deref__arg15, 0))
        {
          goto _block1__branch4;
        }
        Expr _ve__e__e_tmp_m_rfp__asail__jbcrf_m_607_m_15 (_v_deref__deref__arg15, 0, _v_len___e__e_tmp_m_rfp__asail__jbcrf_m_607_m_15);
        Expr _ge_auxcall10;
        RF_CALL (Box::_q_, Module_m_Name, _ge_auxcall10);
        Expr _ge_auxcall11;
        RF_CALL (List::Intersperse, (_c_6, _ge_auxcall10), _ge_auxcall11);
        Expr _gs_auxcall12;
        RF_CALL (Convert::To_m_Word, _ge_auxcall11, _gs_auxcall12);
        _vs_module = _gs_auxcall12;
        _vt_name = _gt_arg1;
      }
    _block2: {}
      Expr _ge_auxcall13;
      RF_CALL (JavaMangle::Rfp2Java, _vt_name, _ge_auxcall13);
      Expr _vs_name;
      RF_CALL (Convert::To_m_Word, _ge_auxcall13, _vs_name);
      Expr _gs_auxcall14;
      RF_CALL (MV, /*void*/, _gs_auxcall14);
      RF_TAILCALL (MethodVisitor::MVvisitFieldInsn, (_gs_auxcall14, _c_72, _vs_module, _vs_name, _c_34), /*void*/);
      goto _block1;
    }
  _block1__branch4: {}
    {
      if (!_gt_arg1.term_eq (_c_134, 0))
      {
        goto _block1__branch5;
      }
      Expr _gs_auxcall15;
      RF_CALL (Get_m_Trap, /*void*/, _gs_auxcall15);
      RF_TAILCALL (Var_m_To_m_JBC, _gs_auxcall15, /*void*/);
      goto _block1;
    }
  _block1__branch5: {}
    if (_gt_arg1.symbol_at (0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _v_deref__arg16 (_gt_arg1, 0);
    uintptr_t _v_len15 = _v_deref__arg16.get_len ();
    uintptr_t _v_len16 = 1;
    if (_v_len15 < _v_len16)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    uintptr_t _v_len___e__e_tmp_m_rfp__asail__jbcrf_m_612_m_32 = (_v_len15 - _v_len16);
    if (!_v_deref__arg16.symbol_at (0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _vs_var_m_tag (_v_deref__arg16, 0, 1);
    Expr _ve__e__e_tmp_m_rfp__asail__jbcrf_m_612_m_32 (_v_deref__arg16, (0 + 1), _v_len___e__e_tmp_m_rfp__asail__jbcrf_m_612_m_32);
    {
      {
        if (!_vs_var_m_tag.term_eq (_c_47, 0))
        {
          goto _block3__branch1;
        }
        goto _block3;
      }
    _block3__branch1: {}
      {
        if (!_vs_var_m_tag.term_eq (_c_135, 0))
        {
          goto _block3__branch2;
        }
        goto _block3;
      }
    _block3__branch2: {}
      {
        if (!_vs_var_m_tag.term_eq (_c_136, 0))
        {
          goto _block3__branch3;
        }
        goto _block3;
      }
    _block3__branch3: {}
      {
        if (!_vs_var_m_tag.term_eq (_c_137, 0))
        {
          goto _block3__branch4;
        }
        goto _block3;
      }
    _block3__branch4: {}
      if (!_vs_var_m_tag.term_eq (_c_138, 0))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
    }
  _block3: {}
    RF_TAILCALL (Var_m_To_m_JBC, _gt_arg1, /*void*/);
  }
_block1: {}
RF_END

RF_FUNC (Expr_m_Int_m_To_m_JBC, (RF_ARG _ge_arg1;;), RF_VOID)
  {
    {
      if (_ge_arg1.get_len () != 1)
      {
        goto _block1__branch1;
      }
      if (!_ge_arg1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _vs_ObjectSymbol (_ge_arg1, 0, 1);
      {
        {
          if (!RF_CALL (Class::Int_q_, _vs_ObjectSymbol, /*void*/))
          {
            goto _block2__branch1;
          }
          Expr _gs_auxcall1;
          RF_CALL (MV, /*void*/, _gs_auxcall1);
          Expr _gs_auxcall2;
          RF_CALL (Integer::Integer, _vs_ObjectSymbol, _gs_auxcall2);
          RF_TAILCALL (MethodVisitor::MVvisitLdcInsn, (_gs_auxcall1, _gs_auxcall2), /*void*/);
          goto _block2;
        }
      _block2__branch1: {}
        RF_ERROR ((_c_139 + _vs_ObjectSymbol) ());
      }
    _block2: {}
      goto _block1;
    }
  _block1__branch1: {}
    {
      if (_ge_arg1.get_len () != 1)
      {
        goto _block1__branch2;
      }
      if (_ge_arg1.symbol_at (0))
      {
        goto _block1__branch2;
      }
      Expr _v_deref__arg1 (_ge_arg1, 0);
      uintptr_t _v_len1 = _v_deref__arg1.get_len ();
      uintptr_t _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch2;
      }
      uintptr_t _v_len__x = (_v_len1 - _v_len2);
      if (!_c_140.term_eq (_v_deref__arg1, 0))
      {
        goto _block1__branch2;
      }
      Expr _ve_x (_v_deref__arg1, (0 + 1), _v_len__x);
      RF_CALL (Expr_m_Ref_m_To_m_JBC, _ve_x, /*void*/);
      Expr _gs_auxcall3;
      RF_CALL (MV, /*void*/, _gs_auxcall3);
      RF_TAILCALL (MethodVisitor::MVvisitMethodInsn, (_gs_auxcall3, _c_75, _c_30, _c_141, _c_142), /*void*/);
      goto _block1;
    }
  _block1__branch2: {}
    {
      if (_ge_arg1.get_len () != 1)
      {
        goto _block1__branch3;
      }
      if (_ge_arg1.symbol_at (0))
      {
        goto _block1__branch3;
      }
      Expr _v_deref__arg12 (_ge_arg1, 0);
      if (_v_deref__arg12.get_len () != 3)
      {
        goto _block1__branch3;
      }
      if (_v_deref__arg12.symbol_at ((0 + 1)))
      {
        goto _block1__branch3;
      }
      if (_v_deref__arg12.symbol_at ((0 + 1 + 1)))
      {
        goto _block1__branch3;
      }
      Expr _v_deref__deref__arg12 (_v_deref__arg12, (0 + 1));
      Expr _v_deref__deref__arg122 (_v_deref__arg12, (0 + 1 + 1));
      uintptr_t _v_len3 = _v_deref__deref__arg122.get_len ();
      uintptr_t _v_len4 = 0;
      if (_v_len3 < _v_len4)
      {
        goto _block1__branch3;
      }
      uintptr_t _v_len__y = (_v_len3 - _v_len4);
      uintptr_t _v_len5 = _v_deref__deref__arg12.get_len ();
      uintptr_t _v_len6 = 0;
      if (_v_len5 < _v_len6)
      {
        goto _block1__branch3;
      }
      uintptr_t _v_len__x2 = (_v_len5 - _v_len6);
      if (!_v_deref__arg12.symbol_at (0))
      {
        goto _block1__branch3;
      }
      Expr _vs_tag (_v_deref__arg12, 0, 1);
      Expr _ve_x (_v_deref__deref__arg12, 0, _v_len__x2);
      Expr _ve_y (_v_deref__deref__arg122, 0, _v_len__y);
      Expr _vs_fn;
      {
        {
          if (!_vs_tag.term_eq (_c_143, 0))
          {
            goto _block3__branch1;
          }
          _vs_fn = _c_144;
          goto _block3;
        }
      _block3__branch1: {}
        if (!_vs_tag.term_eq (_c_145, 0))
        {
          goto _block1__branch3;
        }
        _vs_fn = _c_146;
      }
    _block3: {}
      RF_CALL (Expr_m_Int_m_To_m_JBC, _ve_x, /*void*/);
      RF_CALL (Expr_m_Int_m_To_m_JBC, _ve_y, /*void*/);
      Expr _gs_auxcall4;
      RF_CALL (MV, /*void*/, _gs_auxcall4);
      RF_TAILCALL (MethodVisitor::MVvisitMethodInsn, (_gs_auxcall4, _c_16, _c_147, _vs_fn, _c_148), /*void*/);
      goto _block1;
    }
  _block1__branch3: {}
    {
      if (_ge_arg1.get_len () != 1)
      {
        goto _block1__branch4;
      }
      if (_ge_arg1.symbol_at (0))
      {
        goto _block1__branch4;
      }
      Expr _v_deref__arg13 (_ge_arg1, 0);
      uintptr_t _v_len7 = _v_deref__arg13.get_len ();
      uintptr_t _v_len8 = 2;
      if (_v_len7 < _v_len8)
      {
        goto _block1__branch4;
      }
      uintptr_t _v_len__args = (_v_len7 - _v_len8);
      if (!_c_149.term_eq (_v_deref__arg13, 0))
      {
        goto _block1__branch4;
      }
      if (!_v_deref__arg13.symbol_at ((0 + 1)))
      {
        goto _block1__branch4;
      }
      Expr _vs_op (_v_deref__arg13, (0 + 1), 1);
      Expr _ve_args (_v_deref__arg13, (0 + 1 + 1), _v_len__args);
      RF_TAILCALL (Infix_m_To_m_JBC, (_c_150, _vs_op, _ve_args), /*void*/);
      goto _block1;
    }
  _block1__branch4: {}
    {
      if (_ge_arg1.get_len () != 1)
      {
        goto _block1__branch5;
      }
      Expr _vt_term (_ge_arg1, 0, 1);
      if (_vt_term.symbol_at (0))
      {
        goto _block1__branch5;
      }
      Expr _v_deref__term (_vt_term, 0);
      uintptr_t _v_len9 = _v_deref__term.get_len ();
      uintptr_t _v_len10 = 1;
      if (_v_len9 < _v_len10)
      {
        goto _block1__branch5;
      }
      uintptr_t _v_len___e__e_tmp_m_rfp__asail__jbcrf_m_637_m_32 = (_v_len9 - _v_len10);
      if (!_v_deref__term.symbol_at (0))
      {
        goto _block1__branch5;
      }
      Expr _vs_var_m_tag (_v_deref__term, 0, 1);
      Expr _ve__e__e_tmp_m_rfp__asail__jbcrf_m_637_m_32 (_v_deref__term, (0 + 1), _v_len___e__e_tmp_m_rfp__asail__jbcrf_m_637_m_32);
      RF_TAILCALL (Var_m_To_m_JBC, _vt_term, /*void*/);
      goto _block1;
    }
  _block1__branch5: {}
    Expr _ge_auxcall5;
    RF_CALL (List::Paren, _ge_arg1, _ge_auxcall5);
    RF_TAILCALL (Infix_m_To_m_JBC, (_c_150, _c_151, _ge_auxcall5), /*void*/);
  }
_block1: {}
RF_END

RF_FUNC (Infix_m_To_m_JBC, (RF_ARG _gs_arg1, _gs_arg2, _ge_arg3;;), RF_VOID)
  uintptr_t _v_len1 = (_ge_arg3.get_len () + 2);
  uintptr_t _v_len2 = 3;
  if (_v_len1 < _v_len2)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len__args = (_v_len1 - _v_len2);
  Expr _v_compose1 ((_gs_arg1 + _gs_arg2 + _ge_arg3));
  if (_v_compose1.symbol_at ((0 + 1 + 1)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _v_deref__compose1 (_v_compose1, (0 + 1 + 1));
  uintptr_t _v_len3 = _v_deref__compose1.get_len ();
  uintptr_t _v_len4 = 0;
  if (_v_len3 < _v_len4)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len__arg = (_v_len3 - _v_len4);
  if (!_v_compose1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_v_compose1.symbol_at ((0 + 1)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _vs_arg2java (_v_compose1, 0, 1);
  Expr _vs_op (_v_compose1, (0 + 1), 1);
  Expr _ve_args (_v_compose1, (0 + 1 + 1 + 1), _v_len__args);
  Expr _ve_arg (_v_deref__compose1, 0, _v_len__arg);
  Expr _vs_jbcop;
  {
    {
      if (!_vs_op.term_eq (_c_151, 0))
      {
        goto _block1__branch1;
      }
      _vs_jbcop = _c_152;
      goto _block1;
    }
  _block1__branch1: {}
    {
      if (!_vs_op.term_eq (_c_153, 0))
      {
        goto _block1__branch2;
      }
      _vs_jbcop = _c_154;
      goto _block1;
    }
  _block1__branch2: {}
    {
      if (!_vs_op.term_eq (_c_155, 0))
      {
        goto _block1__branch3;
      }
      _vs_jbcop = _c_156;
      goto _block1;
    }
  _block1__branch3: {}
    {
      if (!_vs_op.term_eq (_c_157, 0))
      {
        goto _block1__branch4;
      }
      _vs_jbcop = _c_158;
      goto _block1;
    }
  _block1__branch4: {}
    if (!_vs_op.term_eq (_c_159, 0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    _vs_jbcop = _c_160;
  }
_block1: {}
  Expr _v_Apply1;
  if (!RF_CALL (Apply::Apply, (_vs_arg2java, _ve_arg), _v_Apply1))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len5 = _v_Apply1.get_len ();
  uintptr_t _v_len6 = 0;
  if (_v_len5 < _v_len6)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len___e__e_tmp_m_rfp__asail__jbcrf_m_649_m_31 = (_v_len5 - _v_len6);
  Expr _ve__e__e_tmp_m_rfp__asail__jbcrf_m_649_m_31 (_v_Apply1, 0, _v_len___e__e_tmp_m_rfp__asail__jbcrf_m_649_m_31);
  {
    if (_v_len__args < 1)
    {
      goto _block2__branch1;
    }
    RF_lsplit (_ve_args, 0, _ve__e__e_tmp_m_rfp__asail__jbcrf_m_651_m_15, _v_lsplit__args);
    for ( ; ; RF_iter(_ve_args)++)
    {
      {
        if (!RF_iter(_ve_args))
        {
          goto _block2__branch1;
        }
        uintptr_t _v_len7 = _v_lsplit__args.get_len ();
        uintptr_t _v_len8 = 1;
        if (_v_len7 < _v_len8)
        {
          goto _block2__branch1;
        }
        uintptr_t _v_len___e__e_tmp_m_rfp__asail__jbcrf_m_651_m_26 = (_v_len7 - _v_len8);
        if (_v_lsplit__args.symbol_at (0))
        {
          goto _continue1;
        }
        Expr _v_deref__lsplit__args (_v_lsplit__args, 0);
        uintptr_t _v_len9 = _v_deref__lsplit__args.get_len ();
        uintptr_t _v_len10 = 0;
        if (_v_len9 < _v_len10)
        {
          goto _continue1;
        }
        uintptr_t _v_len__arg2 = (_v_len9 - _v_len10);
        Expr _ve__e__e_tmp_m_rfp__asail__jbcrf_m_651_m_26 (_v_lsplit__args, (0 + 1), _v_len___e__e_tmp_m_rfp__asail__jbcrf_m_651_m_26);
        Expr _ve_arg2 (_v_deref__lsplit__args, 0, _v_len__arg2);
        Expr _v_Apply2;
        if (!RF_CALL (Apply::Apply, (_vs_arg2java, _ve_arg2), _v_Apply2))
        {
          goto _continue1;
        }
        uintptr_t _v_len11 = _v_Apply2.get_len ();
        uintptr_t _v_len12 = 0;
        if (_v_len11 < _v_len12)
        {
          goto _continue1;
        }
        uintptr_t _v_len___e__e_tmp_m_rfp__asail__jbcrf_m_652_m_36 = (_v_len11 - _v_len12);
        Expr _ve__e__e_tmp_m_rfp__asail__jbcrf_m_652_m_36 (_v_Apply2, 0, _v_len___e__e_tmp_m_rfp__asail__jbcrf_m_652_m_36);
        Expr _gs_auxcall1;
        RF_CALL (MV, /*void*/, _gs_auxcall1);
        RF_CALL (MethodVisitor::MVvisitInsn, (_gs_auxcall1, _vs_jbcop), /*void*/);
      }
  _continue1: {}
    }
  _exit1: {}
  }
_block2__branch1: {}
RF_END

RF_FUNC (Cond_m_To_m_JBC, (RF_ARG _gt_arg1;;), (RF_RES _v_res1;;))
  {
    {
      if (_gt_arg1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__arg1 (_gt_arg1, 0);
      if (_v_deref__arg1.get_len () != 2)
      {
        goto _block1__branch1;
      }
      if (_v_deref__arg1.symbol_at ((0 + 1)))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__deref__arg1 (_v_deref__arg1, (0 + 1));
      if (_v_deref__deref__arg1.get_len () != 4)
      {
        goto _block1__branch1;
      }
      if (_v_deref__deref__arg1.symbol_at ((0 + 1)))
      {
        goto _block1__branch1;
      }
      if (_v_deref__deref__arg1.symbol_at ((0 + 1 + 1)))
      {
        goto _block1__branch1;
      }
      if (_v_deref__deref__arg1.symbol_at ((0 + 1 + 1 + 1)))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__deref__deref__arg1 (_v_deref__deref__arg1, (0 + 1));
      Expr _v_deref__deref__deref__arg12 (_v_deref__deref__arg1, (0 + 1 + 1));
      Expr _v_deref__deref__deref__arg13 (_v_deref__deref__arg1, (0 + 1 + 1 + 1));
      uintptr_t _v_len1 = _v_deref__deref__deref__arg1.get_len ();
      uintptr_t _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__module = (_v_len1 - _v_len2);
      uintptr_t _v_len3 = _v_deref__deref__deref__arg13.get_len ();
      uintptr_t _v_len4 = 0;
      if (_v_len3 < _v_len4)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__ress = (_v_len3 - _v_len4);
      uintptr_t _v_len5 = _v_deref__deref__deref__arg12.get_len ();
      uintptr_t _v_len6 = 0;
      if (_v_len5 < _v_len6)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__args = (_v_len5 - _v_len6);
      if (!_c_161.term_eq (_v_deref__arg1, 0))
      {
        goto _block1__branch1;
      }
      if (!_c_121.term_eq (_v_deref__deref__arg1, 0))
      {
        goto _block1__branch1;
      }
      if (!_v_deref__deref__deref__arg1.symbol_at ((0 + _v_len__module)))
      {
        goto _block1__branch1;
      }
      Expr _ve_module (_v_deref__deref__deref__arg1, 0, _v_len__module);
      Expr _vs_name (_v_deref__deref__deref__arg1, (0 + _v_len__module), 1);
      Expr _ve_args (_v_deref__deref__deref__arg12, 0, _v_len__args);
      Expr _ve_ress (_v_deref__deref__deref__arg13, 0, _v_len__ress);
      Expr _vs_module;
      RF_CALL (Qualified_m_Module_m_Name, _ve_module, _vs_module);
      Expr _ge_auxcall1;
      RF_CALL (JavaMangle::Rfp2Java, _vs_name, _ge_auxcall1);
      RF_CALL (Convert::To_m_Word, _ge_auxcall1, _vs_name);
      Expr _vs_desc;
      RF_CALL (Function_m_Description, (_ve_args, _ve_ress, _c_125), _vs_desc);
      {
        if (_v_len__args < 1)
        {
          goto _block2__branch1;
        }
        RF_lsplit (_ve_args, 0, _ve__e__e_tmp_m_rfp__asail__jbcrf_m_664_m_17, _v_lsplit__args);
        for ( ; ; RF_iter(_ve_args)++)
        {
          {
            if (!RF_iter(_ve_args))
            {
              goto _block2__branch1;
            }
            uintptr_t _v_len7 = _v_lsplit__args.get_len ();
            uintptr_t _v_len8 = 1;
            if (_v_len7 < _v_len8)
            {
              goto _block2__branch1;
            }
            uintptr_t _v_len___e__e_tmp_m_rfp__asail__jbcrf_m_664_m_27 = (_v_len7 - _v_len8);
            if (_v_lsplit__args.symbol_at (0))
            {
              goto _continue1;
            }
            Expr _v_deref__lsplit__args (_v_lsplit__args, 0);
            uintptr_t _v_len9 = _v_deref__lsplit__args.get_len ();
            uintptr_t _v_len10 = 0;
            if (_v_len9 < _v_len10)
            {
              goto _continue1;
            }
            uintptr_t _v_len__arg = (_v_len9 - _v_len10);
            Expr _ve__e__e_tmp_m_rfp__asail__jbcrf_m_664_m_27 (_v_lsplit__args, (0 + 1), _v_len___e__e_tmp_m_rfp__asail__jbcrf_m_664_m_27);
            Expr _ve_arg (_v_deref__lsplit__args, 0, _v_len__arg);
            RF_CALL (Expr_m_Ref_m_To_m_JBC, _ve_arg, /*void*/);
          }
      _continue1: {}
        }
      _exit1: {}
      }
    _block2__branch1: {}
      {
        if (_v_len__ress < 1)
        {
          goto _block3__branch1;
        }
        RF_lsplit (_ve_ress, 0, _ve__e__e_tmp_m_rfp__asail__jbcrf_m_669_m_17, _v_lsplit__ress);
        for ( ; ; RF_iter(_ve_ress)++)
        {
          {
            if (!RF_iter(_ve_ress))
            {
              goto _block3__branch1;
            }
            uintptr_t _v_len11 = _v_lsplit__ress.get_len ();
            uintptr_t _v_len12 = 1;
            if (_v_len11 < _v_len12)
            {
              goto _block3__branch1;
            }
            uintptr_t _v_len___e__e_tmp_m_rfp__asail__jbcrf_m_669_m_25 = (_v_len11 - _v_len12);
            Expr _vt_var (_v_lsplit__ress, 0, 1);
            Expr _ve__e__e_tmp_m_rfp__asail__jbcrf_m_669_m_25 (_v_lsplit__ress, (0 + 1), _v_len___e__e_tmp_m_rfp__asail__jbcrf_m_669_m_25);
            Expr _v_Lookup_m_Var1;
            Expr _v_Lookup_m_Var2;
            RF_CALL (Lookup_m_Var, _vt_var, (_v_Lookup_m_Var1, _v_Lookup_m_Var2));
            {
              {
                Expr _v_compose1 ((_v_Lookup_m_Var1 + _v_Lookup_m_Var2));
                if (!_c_48.term_eq (_v_compose1, 0))
                {
                  goto _block4__branch1;
                }
                if (!_v_compose1.symbol_at ((0 + 1)))
                {
                  goto _block4__branch1;
                }
                Expr _vs__e__e_tmp_m_rfp__asail__jbcrf_m_671_m_17 (_v_compose1, (0 + 1), 1);
                Expr _vs_j;
                RF_CALL (Bind_m_TMP_m_Var, _vt_var, _vs_j);
                Expr _gs_auxcall2;
                RF_CALL (MV, /*void*/, _gs_auxcall2);
                RF_CALL (MethodVisitor::MVvisitTypeInsn, (_gs_auxcall2, _c_20, _c_21), /*void*/);
                Expr _gs_auxcall3;
                RF_CALL (MV, /*void*/, _gs_auxcall3);
                RF_CALL (MethodVisitor::MVvisitInsn, (_gs_auxcall3, _c_22), /*void*/);
                Expr _gs_auxcall4;
                RF_CALL (MV, /*void*/, _gs_auxcall4);
                RF_CALL (MethodVisitor::MVvisitInsn, (_gs_auxcall4, _c_22), /*void*/);
                Expr _gs_auxcall5;
                RF_CALL (MV, /*void*/, _gs_auxcall5);
                RF_CALL (MethodVisitor::MVvisitMethodInsn, (_gs_auxcall5, _c_23, _c_21, _c_24, _c_25), /*void*/);
                Expr _gs_auxcall6;
                RF_CALL (MV, /*void*/, _gs_auxcall6);
                RF_CALL (MethodVisitor::MVvisitVarInsn, (_gs_auxcall6, _c_71, _vs_j), /*void*/);
                goto _block4;
              }
            _block4__branch1: {}
              Expr _v_compose2 ((_v_Lookup_m_Var1 + _v_Lookup_m_Var2));
              if (!_c_62.term_eq (_v_compose2, 0))
              {
                RF_FUNC_ERROR (unexpected_fail);
              }
              if (!_v_compose2.symbol_at ((0 + 1)))
              {
                RF_FUNC_ERROR (unexpected_fail);
              }
              Expr _vs_i (_v_compose2, (0 + 1), 1);
              Expr _gs_auxcall7;
              RF_CALL (MV, /*void*/, _gs_auxcall7);
              RF_CALL (MethodVisitor::MVvisitVarInsn, (_gs_auxcall7, _c_14, _vs_i), /*void*/);
            }
          _block4: {}
          }
      _continue2: {}
        }
      _exit2: {}
      }
    _block3__branch1: {}
      Expr _gs_auxcall8;
      RF_CALL (MV, /*void*/, _gs_auxcall8);
      RF_CALL (MethodVisitor::MVvisitMethodInsn, (_gs_auxcall8, _c_16, _vs_module, _vs_name, _vs_desc), /*void*/);
      {
        if (_v_len__ress < 1)
        {
          goto _block5__branch1;
        }
        RF_lsplit (_ve_ress, 0, _ve__e__e_tmp_m_rfp__asail__jbcrf_m_684_m_17, _v_lsplit__ress2);
        for ( ; ; RF_iter(_ve_ress)++)
        {
          {
            if (!RF_iter(_ve_ress))
            {
              goto _block5__branch1;
            }
            uintptr_t _v_len13 = _v_lsplit__ress2.get_len ();
            uintptr_t _v_len14 = 1;
            if (_v_len13 < _v_len14)
            {
              goto _block5__branch1;
            }
            uintptr_t _v_len___e__e_tmp_m_rfp__asail__jbcrf_m_684_m_25 = (_v_len13 - _v_len14);
            Expr _vt_var (_v_lsplit__ress2, 0, 1);
            Expr _ve__e__e_tmp_m_rfp__asail__jbcrf_m_684_m_25 (_v_lsplit__ress2, (0 + 1), _v_len___e__e_tmp_m_rfp__asail__jbcrf_m_684_m_25);
            Expr _v_Lookup_m_Var3;
            Expr _v_Lookup_m_Var4;
            RF_CALL (Lookup_m_Var, _vt_var, (_v_Lookup_m_Var3, _v_Lookup_m_Var4));
            Expr _v_compose3 ((_v_Lookup_m_Var3 + _v_Lookup_m_Var4));
            if (!_c_48.term_eq (_v_compose3, 0))
            {
              goto _continue3;
            }
            if (!_v_compose3.symbol_at ((0 + 1)))
            {
              goto _continue3;
            }
            Expr _vs_i (_v_compose3, (0 + 1), 1);
            Expr _vs_j;
            RF_CALL (Lookup_m_TMP_m_Var, _vt_var, _vs_j);
            Expr _gs_auxcall9;
            RF_CALL (MV, /*void*/, _gs_auxcall9);
            RF_CALL (MethodVisitor::MVvisitVarInsn, (_gs_auxcall9, _c_14, _vs_j), /*void*/);
            Expr _gs_auxcall10;
            RF_CALL (MV, /*void*/, _gs_auxcall10);
            RF_CALL (MethodVisitor::MVvisitMethodInsn, (_gs_auxcall10, _c_75, _c_21, _c_115, _c_106), /*void*/);
            Expr _gs_auxcall11;
            RF_CALL (MV, /*void*/, _gs_auxcall11);
            RF_CALL (MethodVisitor::MVvisitVarInsn, (_gs_auxcall11, _c_71, _vs_i), /*void*/);
          }
      _continue3: {}
        }
      _exit3: {}
      }
    _block5__branch1: {}
      _v_res1 = _c_126;
      goto _block1;
    }
  _block1__branch1: {}
    {
      if (_gt_arg1.symbol_at (0))
      {
        goto _block1__branch2;
      }
      Expr _v_deref__arg12 (_gt_arg1, 0);
      uintptr_t _v_len15 = _v_deref__arg12.get_len ();
      uintptr_t _v_len16 = 1;
      if (_v_len15 < _v_len16)
      {
        goto _block1__branch2;
      }
      uintptr_t _v_len__expr = (_v_len15 - _v_len16);
      if (!_c_162.term_eq (_v_deref__arg12, 0))
      {
        goto _block1__branch2;
      }
      Expr _ve_expr (_v_deref__arg12, (0 + 1), _v_len__expr);
      Expr _vs_i;
      Expr _vs__e__e_tmp_m_rfp__asail__jbcrf_m_693_m_38;
      Expr _vs__e__e_tmp_m_rfp__asail__jbcrf_m_693_m_40;
      RF_CALL (Lookup_m_Iter_m_Var, _ve_expr, (_vs_i, _vs__e__e_tmp_m_rfp__asail__jbcrf_m_693_m_38, _vs__e__e_tmp_m_rfp__asail__jbcrf_m_693_m_40));
      Expr _gs_auxcall12;
      RF_CALL (MV, /*void*/, _gs_auxcall12);
      RF_CALL (MethodVisitor::MVvisitVarInsn, (_gs_auxcall12, _c_14, _vs_i), /*void*/);
      Expr _gs_auxcall13;
      RF_CALL (MV, /*void*/, _gs_auxcall13);
      RF_CALL (MethodVisitor::MVvisitMethodInsn, (_gs_auxcall13, _c_75, _c_104, _c_163, _c_164), /*void*/);
      _v_res1 = _c_126;
      goto _block1;
    }
  _block1__branch2: {}
    {
      if (_gt_arg1.symbol_at (0))
      {
        goto _block1__branch3;
      }
      Expr _v_deref__arg13 (_gt_arg1, 0);
      uintptr_t _v_len17 = _v_deref__arg13.get_len ();
      uintptr_t _v_len18 = 2;
      if (_v_len17 < _v_len18)
      {
        goto _block1__branch3;
      }
      uintptr_t _v_len__expr2 = (_v_len17 - _v_len18);
      if (_v_deref__arg13.symbol_at ((0 + 1 + _v_len__expr2)))
      {
        goto _block1__branch3;
      }
      Expr _v_deref__deref__arg13 (_v_deref__arg13, (0 + 1 + _v_len__expr2));
      uintptr_t _v_len19 = _v_deref__deref__arg13.get_len ();
      uintptr_t _v_len20 = 0;
      if (_v_len19 < _v_len20)
      {
        goto _block1__branch3;
      }
      uintptr_t _v_len__pos = (_v_len19 - _v_len20);
      if (!_c_165.term_eq (_v_deref__arg13, 0))
      {
        goto _block1__branch3;
      }
      Expr _ve_expr (_v_deref__arg13, (0 + 1), _v_len__expr2);
      Expr _ve_pos (_v_deref__deref__arg13, 0, _v_len__pos);
      RF_CALL (Expr_m_Ref_m_To_m_JBC, _ve_expr, /*void*/);
      RF_CALL (Expr_m_Int_m_To_m_JBC, _ve_pos, /*void*/);
      Expr _gs_auxcall14;
      RF_CALL (MV, /*void*/, _gs_auxcall14);
      RF_CALL (MethodVisitor::MVvisitMethodInsn, (_gs_auxcall14, _c_75, _c_30, _c_166, _c_167), /*void*/);
      _v_res1 = _c_168;
      goto _block1;
    }
  _block1__branch3: {}
    {
      if (_gt_arg1.symbol_at (0))
      {
        goto _block1__branch4;
      }
      Expr _v_deref__arg14 (_gt_arg1, 0);
      uintptr_t _v_len21 = _v_deref__arg14.get_len ();
      uintptr_t _v_len22 = 3;
      if (_v_len21 < _v_len22)
      {
        goto _block1__branch4;
      }
      uintptr_t _v_len__expr1 = (_v_len21 - _v_len22);
      if (_v_deref__arg14.symbol_at ((0 + 1 + _v_len__expr1)))
      {
        goto _block1__branch4;
      }
      if (_v_deref__arg14.symbol_at ((0 + 1 + _v_len__expr1 + 1)))
      {
        goto _block1__branch4;
      }
      Expr _v_deref__deref__arg14 (_v_deref__arg14, (0 + 1 + _v_len__expr1));
      Expr _v_deref__deref__arg142 (_v_deref__arg14, (0 + 1 + _v_len__expr1 + 1));
      uintptr_t _v_len23 = _v_deref__deref__arg142.get_len ();
      uintptr_t _v_len24 = 0;
      if (_v_len23 < _v_len24)
      {
        goto _block1__branch4;
      }
      uintptr_t _v_len__pos2 = (_v_len23 - _v_len24);
      uintptr_t _v_len25 = _v_deref__deref__arg14.get_len ();
      uintptr_t _v_len26 = 0;
      if (_v_len25 < _v_len26)
      {
        goto _block1__branch4;
      }
      uintptr_t _v_len__expr22 = (_v_len25 - _v_len26);
      if (!_c_169.term_eq (_v_deref__arg14, 0))
      {
        goto _block1__branch4;
      }
      Expr _ve_expr1 (_v_deref__arg14, (0 + 1), _v_len__expr1);
      Expr _ve_expr2 (_v_deref__deref__arg14, 0, _v_len__expr22);
      Expr _ve_pos (_v_deref__deref__arg142, 0, _v_len__pos2);
      RF_CALL (Expr_m_Ref_m_To_m_JBC, _ve_expr1, /*void*/);
      RF_CALL (Expr_m_Ref_m_To_m_JBC, _ve_expr2, /*void*/);
      RF_CALL (Expr_m_Int_m_To_m_JBC, _ve_pos, /*void*/);
      Expr _gs_auxcall15;
      RF_CALL (MV, /*void*/, _gs_auxcall15);
      RF_CALL (MethodVisitor::MVvisitMethodInsn, (_gs_auxcall15, _c_75, _c_30, _c_170, _c_171), /*void*/);
      _v_res1 = _c_168;
      goto _block1;
    }
  _block1__branch4: {}
    {
      if (_gt_arg1.symbol_at (0))
      {
        goto _block1__branch5;
      }
      Expr _v_deref__arg15 (_gt_arg1, 0);
      uintptr_t _v_len27 = _v_deref__arg15.get_len ();
      uintptr_t _v_len28 = 3;
      if (_v_len27 < _v_len28)
      {
        goto _block1__branch5;
      }
      uintptr_t _v_len__expr12 = (_v_len27 - _v_len28);
      if (_v_deref__arg15.symbol_at ((0 + 1 + _v_len__expr12)))
      {
        goto _block1__branch5;
      }
      if (_v_deref__arg15.symbol_at ((0 + 1 + _v_len__expr12 + 1)))
      {
        goto _block1__branch5;
      }
      Expr _v_deref__deref__arg15 (_v_deref__arg15, (0 + 1 + _v_len__expr12));
      Expr _v_deref__deref__arg152 (_v_deref__arg15, (0 + 1 + _v_len__expr12 + 1));
      uintptr_t _v_len29 = _v_deref__deref__arg152.get_len ();
      uintptr_t _v_len30 = 0;
      if (_v_len29 < _v_len30)
      {
        goto _block1__branch5;
      }
      uintptr_t _v_len__pos3 = (_v_len29 - _v_len30);
      uintptr_t _v_len31 = _v_deref__deref__arg15.get_len ();
      uintptr_t _v_len32 = 0;
      if (_v_len31 < _v_len32)
      {
        goto _block1__branch5;
      }
      uintptr_t _v_len__expr23 = (_v_len31 - _v_len32);
      if (!_c_172.term_eq (_v_deref__arg15, 0))
      {
        goto _block1__branch5;
      }
      Expr _ve_expr1 (_v_deref__arg15, (0 + 1), _v_len__expr12);
      Expr _ve_expr2 (_v_deref__deref__arg15, 0, _v_len__expr23);
      Expr _ve_pos (_v_deref__deref__arg152, 0, _v_len__pos3);
      RF_CALL (Expr_m_Ref_m_To_m_JBC, _ve_expr1, /*void*/);
      RF_CALL (Expr_m_Ref_m_To_m_JBC, _ve_expr2, /*void*/);
      RF_CALL (Expr_m_Int_m_To_m_JBC, _ve_pos, /*void*/);
      Expr _gs_auxcall16;
      RF_CALL (MV, /*void*/, _gs_auxcall16);
      RF_CALL (MethodVisitor::MVvisitMethodInsn, (_gs_auxcall16, _c_75, _c_30, _c_173, _c_171), /*void*/);
      _v_res1 = _c_168;
      goto _block1;
    }
  _block1__branch5: {}
    if (_gt_arg1.symbol_at (0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _v_deref__arg16 (_gt_arg1, 0);
    if (_v_deref__arg16.get_len () != 2)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    if (!_c_174.term_eq (_v_deref__arg16, 0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _vt_cond (_v_deref__arg16, (0 + 1), 1);
    Expr _v_Cond_m_To_m_JBC1;
    RF_CALL (Cond_m_To_m_JBC, _vt_cond, _v_Cond_m_To_m_JBC1);
    {
      {
        if (!_v_Cond_m_To_m_JBC1.term_eq (Opcodes::IFEQ, 0))
        {
          goto _block6__branch1;
        }
        _v_res1 = _c_126;
        goto _block6;
      }
    _block6__branch1: {}
      if (!_v_Cond_m_To_m_JBC1.term_eq (Opcodes::IFNE, 0))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      _v_res1 = _c_168;
    }
  _block6: {}
  }
_block1: {}
RF_END

RF_FUNC (Step_m_To_m_JBC, (RF_ARG _ge_arg1;;), RF_VOID)
  {
    {
      if (_ge_arg1.get_len () != 0)
      {
        goto _block1__branch1;
      }
      goto _block1;
    }
  _block1__branch1: {}
    if (_ge_arg1.get_len () != 1)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    if (_ge_arg1.symbol_at (0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _v_deref__arg1 (_ge_arg1, 0);
    uintptr_t _v_len1 = _v_deref__arg1.get_len ();
    uintptr_t _v_len2 = 1;
    if (_v_len1 < _v_len2)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    uintptr_t _v_len__expr = (_v_len1 - _v_len2);
    if (!_v_deref__arg1.symbol_at (0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _vs_tag (_v_deref__arg1, 0, 1);
    Expr _ve_expr (_v_deref__arg1, (0 + 1), _v_len__expr);
    Expr _vs_m;
    {
      {
        if (!_vs_tag.term_eq (_c_102, 0))
        {
          goto _block2__branch1;
        }
        _vs_m = _c_175;
        goto _block2;
      }
    _block2__branch1: {}
      if (!_vs_tag.term_eq (_c_103, 0))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      _vs_m = _c_176;
    }
  _block2: {}
    Expr _vs_i;
    Expr _vs__e__e_tmp_m_rfp__asail__jbcrf_m_729_m_38;
    Expr _vs__e__e_tmp_m_rfp__asail__jbcrf_m_729_m_40;
    RF_CALL (Lookup_m_Iter_m_Var, _ve_expr, (_vs_i, _vs__e__e_tmp_m_rfp__asail__jbcrf_m_729_m_38, _vs__e__e_tmp_m_rfp__asail__jbcrf_m_729_m_40));
    Expr _gs_auxcall1;
    RF_CALL (MV, /*void*/, _gs_auxcall1);
    RF_CALL (MethodVisitor::MVvisitVarInsn, (_gs_auxcall1, _c_14, _vs_i), /*void*/);
    Expr _gs_auxcall2;
    RF_CALL (MV, /*void*/, _gs_auxcall2);
    RF_CALL (MethodVisitor::MVvisitMethodInsn, (_gs_auxcall2, _c_75, _c_104, _vs_m, _c_177), /*void*/);
    Expr _gs_auxcall3;
    RF_CALL (MV, /*void*/, _gs_auxcall3);
    RF_TAILCALL (MethodVisitor::MVvisitInsn, (_gs_auxcall3, _c_178), /*void*/);
  }
_block1: {}
RF_END

RF_FUNC (Const_m_Expr_m_To_m_JBC, (RF_ARG _ge_arg1;;), RF_VOID)
  {
    {
      if (_ge_arg1.get_len () != 0)
      {
        goto _block1__branch1;
      }
      Expr _gs_auxcall1;
      RF_CALL (MV, /*void*/, _gs_auxcall1);
      RF_TAILCALL (MethodVisitor::MVvisitFieldInsn, (_gs_auxcall1, _c_72, _c_30, _c_73, _c_34), /*void*/);
      goto _block1;
    }
  _block1__branch1: {}
    {
      if (_ge_arg1.get_len () != 1)
      {
        goto _block1__branch2;
      }
      if (_ge_arg1.symbol_at (0))
      {
        goto _block1__branch2;
      }
      Expr _v_deref__arg1 (_ge_arg1, 0);
      if (_v_deref__arg1.get_len () != 4)
      {
        goto _block1__branch2;
      }
      if (!_c_85.term_eq (_v_deref__arg1, 0))
      {
        goto _block1__branch2;
      }
      if (!_v_deref__arg1.symbol_at ((0 + 1 + 1)))
      {
        goto _block1__branch2;
      }
      if (!_v_deref__arg1.symbol_at ((0 + 1 + 1 + 1)))
      {
        goto _block1__branch2;
      }
      Expr _vt_name (_v_deref__arg1, (0 + 1), 1);
      Expr _vs_pos (_v_deref__arg1, (0 + 1 + 1), 1);
      Expr _vs_len (_v_deref__arg1, (0 + 1 + 1 + 1), 1);
      Expr _vs_module;
      Expr _gt_name__3;
      {
        {
          if (_vt_name.symbol_at (0))
          {
            goto _block2__branch1;
          }
          Expr _v_deref__name (_vt_name, 0);
          if (_v_deref__name.get_len () != 2)
          {
            goto _block2__branch1;
          }
          if (_v_deref__name.symbol_at ((0 + 1)))
          {
            goto _block2__branch1;
          }
          Expr _v_deref__deref__name (_v_deref__name, (0 + 1));
          if (_v_deref__deref__name.get_len () != 2)
          {
            goto _block2__branch1;
          }
          if (!_c_133.term_eq (_v_deref__name, 0))
          {
            goto _block2__branch1;
          }
          if (!_v_deref__deref__name.symbol_at (0))
          {
            goto _block2__branch1;
          }
          if (!_v_deref__deref__name.symbol_at ((0 + 1)))
          {
            goto _block2__branch1;
          }
          Expr _gs_module__4 (_v_deref__deref__name, 0, 1);
          Expr _vs_obj_m_name (_v_deref__deref__name, (0 + 1), 1);
          Expr _gs_auxcall2;
          RF_CALL (Qualified_m_Module_m_Name, _gs_module__4, _gs_auxcall2);
          _vs_module = _gs_auxcall2;
          _gt_name__3 = _vs_obj_m_name;
          goto _block2;
        }
      _block2__branch1: {}
        if (_vt_name.symbol_at (0))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        Expr _v_deref__name2 (_vt_name, 0);
        if (_v_deref__name2.get_len () != 2)
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        if (_v_deref__name2.symbol_at ((0 + 1)))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        Expr _v_deref__deref__name2 (_v_deref__name2, (0 + 1));
        uintptr_t _v_len1 = _v_deref__deref__name2.get_len ();
        uintptr_t _v_len2 = 0;
        if (_v_len1 < _v_len2)
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        uintptr_t _v_len___e__e_tmp_m_rfp__asail__jbcrf_m_744_m_17 = (_v_len1 - _v_len2);
        if (!_c_64.term_eq (_v_deref__name2, 0))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        Expr _ve__e__e_tmp_m_rfp__asail__jbcrf_m_744_m_17 (_v_deref__deref__name2, 0, _v_len___e__e_tmp_m_rfp__asail__jbcrf_m_744_m_17);
        Expr _ge_auxcall3;
        RF_CALL (Box::_q_, Module_m_Name, _ge_auxcall3);
        Expr _ge_auxcall4;
        RF_CALL (List::Intersperse, (_c_6, _ge_auxcall3), _ge_auxcall4);
        Expr _gs_auxcall5;
        RF_CALL (Convert::To_m_Word, _ge_auxcall4, _gs_auxcall5);
        _vs_module = _gs_auxcall5;
        _gt_name__3 = _vt_name;
      }
    _block2: {}
      Expr _ge_auxcall6;
      RF_CALL (JavaMangle::Rfp2Java, _gt_name__3, _ge_auxcall6);
      Expr _gs_name__3;
      RF_CALL (Convert::To_m_Word, _ge_auxcall6, _gs_name__3);
      Expr _gs_auxcall7;
      RF_CALL (MV, /*void*/, _gs_auxcall7);
      RF_CALL (MethodVisitor::MVvisitTypeInsn, (_gs_auxcall7, _c_20, _c_30), /*void*/);
      Expr _gs_auxcall8;
      RF_CALL (MV, /*void*/, _gs_auxcall8);
      RF_CALL (MethodVisitor::MVvisitInsn, (_gs_auxcall8, _c_22), /*void*/);
      Expr _gs_auxcall9;
      RF_CALL (MV, /*void*/, _gs_auxcall9);
      RF_CALL (MethodVisitor::MVvisitFieldInsn, (_gs_auxcall9, _c_72, _vs_module, _gs_name__3, _c_34), /*void*/);
      Expr _gs_auxcall10;
      RF_CALL (MV, /*void*/, _gs_auxcall10);
      Expr _gs_auxcall11;
      RF_CALL (Integer::Integer, _vs_pos, _gs_auxcall11);
      RF_CALL (MethodVisitor::MVvisitLdcInsn, (_gs_auxcall10, _gs_auxcall11), /*void*/);
      Expr _gs_auxcall12;
      RF_CALL (MV, /*void*/, _gs_auxcall12);
      Expr _gs_auxcall13;
      RF_CALL (Integer::Integer, _vs_len, _gs_auxcall13);
      RF_CALL (MethodVisitor::MVvisitLdcInsn, (_gs_auxcall12, _gs_auxcall13), /*void*/);
      Expr _gs_auxcall14;
      RF_CALL (MV, /*void*/, _gs_auxcall14);
      RF_TAILCALL (MethodVisitor::MVvisitMethodInsn, (_gs_auxcall14, _c_23, _c_30, _c_24, _c_86), /*void*/);
      goto _block1;
    }
  _block1__branch2: {}
    Expr _ge_arg1__2;
    RF_CALL (Convert_m_Const_m_Expr, _ge_arg1, _ge_arg1__2);
    Expr _gs_auxcall15;
    RF_CALL (MV, /*void*/, _gs_auxcall15);
    Expr _gs_auxcall16;
    RF_CALL (Access::Length, _ge_arg1__2, _gs_auxcall16);
    Expr _gs_auxcall17;
    RF_CALL (Integer::Integer, _gs_auxcall16, _gs_auxcall17);
    RF_CALL (MethodVisitor::MVvisitLdcInsn, (_gs_auxcall15, _gs_auxcall17), /*void*/);
    Expr _gs_auxcall18;
    RF_CALL (MV, /*void*/, _gs_auxcall18);
    RF_CALL (MethodVisitor::MVvisitTypeInsn, (_gs_auxcall18, _c_129, _c_30), /*void*/);
    Expr _vs_i (_c_15);
    for ( ; ; )
    {
      {
        if (_ge_arg1__2.get_len () != 0)
        {
          goto _iter1;
        }
        Expr _gs_auxcall24;
        RF_CALL (MV, /*void*/, _gs_auxcall24);
        RF_TAILCALL (MethodVisitor::MVvisitMethodInsn, (_gs_auxcall24, _c_16, _c_30, _c_127, _c_130), /*void*/);
        goto _exit__iter1;
      }
    _iter1: {}
      uintptr_t _v_len3 = _ge_arg1__2.get_len ();
      uintptr_t _v_len4 = 1;
      if (_v_len3 < _v_len4)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      uintptr_t _v_len__rest = (_v_len3 - _v_len4);
      Expr _vt_term (_ge_arg1__2, 0, 1);
      Expr _ve_rest (_ge_arg1__2, (0 + 1), _v_len__rest);
      Expr _gs_auxcall19;
      RF_CALL (MV, /*void*/, _gs_auxcall19);
      RF_CALL (MethodVisitor::MVvisitInsn, (_gs_auxcall19, _c_22), /*void*/);
      Expr _gs_auxcall20;
      RF_CALL (MV, /*void*/, _gs_auxcall20);
      Expr _gs_auxcall21;
      RF_CALL (Integer::Integer, _vs_i, _gs_auxcall21);
      RF_CALL (MethodVisitor::MVvisitLdcInsn, (_gs_auxcall20, _gs_auxcall21), /*void*/);
      RF_CALL (Const_m_Term_m_To_m_JBC, _vt_term, /*void*/);
      Expr _gs_auxcall22;
      RF_CALL (MV, /*void*/, _gs_auxcall22);
      RF_CALL (MethodVisitor::MVvisitInsn, (_gs_auxcall22, _c_131), /*void*/);
      Expr _gs_auxcall23;
      RF_CALL (Arithm::_p_, (_vs_i, _c_7), _gs_auxcall23);
      _vs_i = _gs_auxcall23;
      _ge_arg1__2 = _ve_rest;
    }
  _exit__iter1: {}
  }
_block1: {}
RF_END

RF_FUNC (Get_m_String_m_From_m_Const_m_Expr, (RF_ARG _ve_expr;;), (RF_RES _v_res1, _v_res2;;))
  Expr _ve_chars (empty);
  Expr _ge_expr__0 (_ve_expr);
  Expr _vs_flag (_c_179);
  for ( ; ; )
  {
    {
      if (!_vs_flag.term_eq (_c_180, 0))
      {
        goto _iter1;
      }
      _v_res1 = _ve_chars;
      _v_res2 = _ge_expr__0;
      goto _exit__iter1;
    }
  _iter1: {}
    {
      {
        uintptr_t _v_len1 = _ge_expr__0.get_len ();
        uintptr_t _v_len2 = 1;
        if (_v_len1 < _v_len2)
        {
          goto _block1__branch1;
        }
        uintptr_t _v_len__rest = (_v_len1 - _v_len2);
        if (!_ge_expr__0.symbol_at (0))
        {
          goto _block1__branch1;
        }
        Expr _vs_sym (_ge_expr__0, 0, 1);
        Expr _ve_rest (_ge_expr__0, (0 + 1), _v_len__rest);
        if (!RF_CALL (Class::Char_q_, _vs_sym, /*void*/))
        {
          goto _block1__branch1;
        }
        _ve_chars = (_ve_chars + _vs_sym);
        _ge_expr__0 = _ve_rest;
        _vs_flag = _c_179;
        goto _block1;
      }
    _block1__branch1: {}
      _vs_flag = _c_180;
    }
  _block1: {}
  }
_exit__iter1: {}
RF_END

RF_FUNC (Convert_m_Const_m_Expr, (RF_ARG _ve_expr;;), (RF_RES _v_res1;;))
  Expr _ve_res (empty);
  Expr _ge_expr__0 (_ve_expr);
  for ( ; ; )
  {
    {
      if (_ge_expr__0.get_len () != 0)
      {
        goto _iter1;
      }
      _v_res1 = _ve_res;
      goto _exit__iter1;
    }
  _iter1: {}
    Expr _ve_chars;
    Expr _ge_expr__0__2;
    RF_CALL (Get_m_String_m_From_m_Const_m_Expr, _ge_expr__0, (_ve_chars, _ge_expr__0__2));
    {
      {
        uintptr_t _v_len1 = _ve_chars.get_len ();
        uintptr_t _v_len2 = 0;
        if (_v_len1 < (_v_len2 + 1))
        {
          goto _block2__branch1;
        }
        uintptr_t _v_len___e__e_tmp_m_rfp__asail__jbcrf_m_797_m_20 = (_v_len1 - _v_len2);
        Expr _vv__e__e_tmp_m_rfp__asail__jbcrf_m_797_m_20 (_ve_chars, 0, _v_len___e__e_tmp_m_rfp__asail__jbcrf_m_797_m_20);
        _ve_res = (_ve_res + (_c_181 + _ve_chars) ());
        _ge_expr__0 = _ge_expr__0__2;
        goto _block2;
      }
    _block2__branch1: {}
      uintptr_t _v_len3 = _ge_expr__0__2.get_len ();
      uintptr_t _v_len4 = 1;
      if (_v_len3 < _v_len4)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      uintptr_t _v_len__rest = (_v_len3 - _v_len4);
      Expr _vt_term (_ge_expr__0__2, 0, 1);
      Expr _ve_rest (_ge_expr__0__2, (0 + 1), _v_len__rest);
      _ve_res = (_ve_res + _vt_term);
      _ge_expr__0 = _ve_rest;
    }
  _block2: {}
  }
_exit__iter1: {}
RF_END

RF_FUNC (Const_m_Term_m_To_m_JBC, (RF_ARG _gt_arg1;;), RF_VOID)
  {
    {
      if (_gt_arg1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__arg1 (_gt_arg1, 0);
      uintptr_t _v_len1 = _v_deref__arg1.get_len ();
      uintptr_t _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__chars = (_v_len1 - _v_len2);
      if (!_c_181.term_eq (_v_deref__arg1, 0))
      {
        goto _block1__branch1;
      }
      Expr _ve_chars (_v_deref__arg1, (0 + 1), _v_len__chars);
      Expr _gs_auxcall1;
      RF_CALL (MV, /*void*/, _gs_auxcall1);
      Expr _gs_auxcall2;
      RF_CALL (Convert::To_m_Word, _ve_chars, _gs_auxcall2);
      Expr _gs_auxcall3;
      RF_CALL (Java::WordToString, _gs_auxcall2, _gs_auxcall3);
      RF_CALL (MethodVisitor::MVvisitLdcInsn, (_gs_auxcall1, _gs_auxcall3), /*void*/);
      Expr _gs_auxcall4;
      RF_CALL (MV, /*void*/, _gs_auxcall4);
      RF_TAILCALL (MethodVisitor::MVvisitMethodInsn, (_gs_auxcall4, _c_16, _c_30, _c_182, _c_183), /*void*/);
      goto _block1;
    }
  _block1__branch1: {}
    {
      if (_gt_arg1.symbol_at (0))
      {
        goto _block1__branch2;
      }
      Expr _v_deref__arg12 (_gt_arg1, 0);
      uintptr_t _v_len3 = _v_deref__arg12.get_len ();
      uintptr_t _v_len4 = 1;
      if (_v_len3 < _v_len4)
      {
        goto _block1__branch2;
      }
      uintptr_t _v_len__expr = (_v_len3 - _v_len4);
      if (!_c_132.term_eq (_v_deref__arg12, 0))
      {
        goto _block1__branch2;
      }
      Expr _ve_expr (_v_deref__arg12, (0 + 1), _v_len__expr);
      Expr _gs_auxcall5;
      RF_CALL (MV, /*void*/, _gs_auxcall5);
      RF_CALL (MethodVisitor::MVvisitTypeInsn, (_gs_auxcall5, _c_20, _c_30), /*void*/);
      Expr _gs_auxcall6;
      RF_CALL (MV, /*void*/, _gs_auxcall6);
      RF_CALL (MethodVisitor::MVvisitInsn, (_gs_auxcall6, _c_22), /*void*/);
      RF_CALL (Const_m_Expr_m_To_m_JBC, _ve_expr, /*void*/);
      Expr _gs_auxcall7;
      RF_CALL (MV, /*void*/, _gs_auxcall7);
      RF_TAILCALL (MethodVisitor::MVvisitMethodInsn, (_gs_auxcall7, _c_23, _c_30, _c_24, _c_32), /*void*/);
      goto _block1;
    }
  _block1__branch2: {}
    {
      Expr _vs_module;
      Expr _vt_name;
      {
        {
          if (_gt_arg1.symbol_at (0))
          {
            goto _block2__branch1;
          }
          Expr _v_deref__arg13 (_gt_arg1, 0);
          if (_v_deref__arg13.get_len () != 2)
          {
            goto _block2__branch1;
          }
          if (_v_deref__arg13.symbol_at ((0 + 1)))
          {
            goto _block2__branch1;
          }
          Expr _v_deref__deref__arg13 (_v_deref__arg13, (0 + 1));
          if (_v_deref__deref__arg13.get_len () != 2)
          {
            goto _block2__branch1;
          }
          if (!_c_133.term_eq (_v_deref__arg13, 0))
          {
            goto _block2__branch1;
          }
          if (!_v_deref__deref__arg13.symbol_at (0))
          {
            goto _block2__branch1;
          }
          if (!_v_deref__deref__arg13.symbol_at ((0 + 1)))
          {
            goto _block2__branch1;
          }
          Expr _gs_module__4 (_v_deref__deref__arg13, 0, 1);
          Expr _vs_obj_m_name (_v_deref__deref__arg13, (0 + 1), 1);
          Expr _gs_auxcall8;
          RF_CALL (Qualified_m_Module_m_Name, _gs_module__4, _gs_auxcall8);
          _vs_module = _gs_auxcall8;
          _vt_name = _vs_obj_m_name;
          goto _block2;
        }
      _block2__branch1: {}
        if (_gt_arg1.symbol_at (0))
        {
          goto _block1__branch3;
        }
        Expr _v_deref__arg14 (_gt_arg1, 0);
        if (_v_deref__arg14.get_len () != 2)
        {
          goto _block1__branch3;
        }
        if (_v_deref__arg14.symbol_at ((0 + 1)))
        {
          goto _block1__branch3;
        }
        Expr _v_deref__deref__arg14 (_v_deref__arg14, (0 + 1));
        uintptr_t _v_len5 = _v_deref__deref__arg14.get_len ();
        uintptr_t _v_len6 = 0;
        if (_v_len5 < _v_len6)
        {
          goto _block1__branch3;
        }
        uintptr_t _v_len___e__e_tmp_m_rfp__asail__jbcrf_m_814_m_15 = (_v_len5 - _v_len6);
        if (!_c_64.term_eq (_v_deref__arg14, 0))
        {
          goto _block1__branch3;
        }
        Expr _ve__e__e_tmp_m_rfp__asail__jbcrf_m_814_m_15 (_v_deref__deref__arg14, 0, _v_len___e__e_tmp_m_rfp__asail__jbcrf_m_814_m_15);
        Expr _ge_auxcall9;
        RF_CALL (Box::_q_, Module_m_Name, _ge_auxcall9);
        Expr _ge_auxcall10;
        RF_CALL (List::Intersperse, (_c_6, _ge_auxcall9), _ge_auxcall10);
        Expr _gs_auxcall11;
        RF_CALL (Convert::To_m_Word, _ge_auxcall10, _gs_auxcall11);
        _vs_module = _gs_auxcall11;
        _vt_name = _gt_arg1;
      }
    _block2: {}
      Expr _ge_auxcall12;
      RF_CALL (JavaMangle::Rfp2Java, _vt_name, _ge_auxcall12);
      Expr _vs_name;
      RF_CALL (Convert::To_m_Word, _ge_auxcall12, _vs_name);
      Expr _gs_auxcall13;
      RF_CALL (MV, /*void*/, _gs_auxcall13);
      RF_TAILCALL (MethodVisitor::MVvisitFieldInsn, (_gs_auxcall13, _c_72, _vs_module, _vs_name, _c_34), /*void*/);
      goto _block1;
    }
  _block1__branch3: {}
    {
      if (_gt_arg1.symbol_at (0))
      {
        goto _block1__branch4;
      }
      Expr _v_deref__arg15 (_gt_arg1, 0);
      if (_v_deref__arg15.get_len () != 2)
      {
        goto _block1__branch4;
      }
      if (_v_deref__arg15.symbol_at ((0 + 1)))
      {
        goto _block1__branch4;
      }
      Expr _v_deref__deref__arg15 (_v_deref__arg15, (0 + 1));
      uintptr_t _v_len7 = _v_deref__deref__arg15.get_len ();
      uintptr_t _v_len8 = 1;
      if (_v_len7 < _v_len8)
      {
        goto _block1__branch4;
      }
      uintptr_t _v_len__module = (_v_len7 - _v_len8);
      if (!_v_deref__arg15.symbol_at (0))
      {
        goto _block1__branch4;
      }
      if (!_v_deref__deref__arg15.symbol_at ((0 + _v_len__module)))
      {
        goto _block1__branch4;
      }
      Expr _vs_func (_v_deref__arg15, 0, 1);
      Expr _ve_module (_v_deref__deref__arg15, 0, _v_len__module);
      Expr _vs_name (_v_deref__deref__arg15, (0 + _v_len__module), 1);
      {
        {
          if (!_vs_func.term_eq (_c_43, 0))
          {
            goto _block3__branch1;
          }
          goto _block3;
        }
      _block3__branch1: {}
        if (!_vs_func.term_eq (_c_41, 0))
        {
          goto _block1__branch4;
        }
      }
    _block3: {}
      Expr _ge_auxcall14;
      RF_CALL (Box::_q_, Module_m_Name, _ge_auxcall14);
      Expr _ge_auxcall15;
      RF_CALL (List::Intersperse, (_c_6, _ge_auxcall14), _ge_auxcall15);
      Expr _ge_auxcall16;
      RF_CALL (Box::_q_, Func_m_Refs, _ge_auxcall16);
      Expr _gs_auxcall17;
      RF_CALL (Access::Length, _ge_auxcall16, _gs_auxcall17);
      Expr _vs_cl_m_name;
      RF_CALL (Convert::To_m_Word, (_ge_auxcall15 + _c_35 + _gs_auxcall17), _vs_cl_m_name);
      Expr _ge_auxcall18;
      RF_CALL (Box::_q_, Func_m_Refs, _ge_auxcall18);
      Expr _gs_auxcall19;
      RF_CALL (Access::Length, _ge_auxcall18, _gs_auxcall19);
      Expr _gs_auxcall20;
      RF_CALL (Qualified_m_Module_m_Name, _ve_module, _gs_auxcall20);
      Expr _ge_auxcall21;
      RF_CALL (JavaMangle::Rfp2Java, _vs_name, _ge_auxcall21);
      Expr _gs_auxcall22;
      RF_CALL (Convert::To_m_Word, _ge_auxcall21, _gs_auxcall22);
      RF_CALL (Box::Put, (Func_m_Refs, (_gs_auxcall19 + _gs_auxcall20 + _gs_auxcall22 + _vs_func) ()), /*void*/);
      Expr _gs_auxcall23;
      RF_CALL (MV, /*void*/, _gs_auxcall23);
      RF_CALL (MethodVisitor::MVvisitTypeInsn, (_gs_auxcall23, _c_20, _c_30), /*void*/);
      Expr _gs_auxcall24;
      RF_CALL (MV, /*void*/, _gs_auxcall24);
      RF_CALL (MethodVisitor::MVvisitInsn, (_gs_auxcall24, _c_22), /*void*/);
      Expr _gs_auxcall25;
      RF_CALL (MV, /*void*/, _gs_auxcall25);
      RF_CALL (MethodVisitor::MVvisitTypeInsn, (_gs_auxcall25, _c_20, _vs_cl_m_name), /*void*/);
      Expr _gs_auxcall26;
      RF_CALL (MV, /*void*/, _gs_auxcall26);
      RF_CALL (MethodVisitor::MVvisitInsn, (_gs_auxcall26, _c_22), /*void*/);
      Expr _gs_auxcall27;
      RF_CALL (MV, /*void*/, _gs_auxcall27);
      RF_CALL (MethodVisitor::MVvisitMethodInsn, (_gs_auxcall27, _c_23, _vs_cl_m_name, _c_24, _c_25), /*void*/);
      Expr _gs_auxcall28;
      RF_CALL (MV, /*void*/, _gs_auxcall28);
      RF_TAILCALL (MethodVisitor::MVvisitMethodInsn, (_gs_auxcall28, _c_23, _c_30, _c_24, _c_32), /*void*/);
      goto _block1;
    }
  _block1__branch4: {}
    if (!_gt_arg1.symbol_at (0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _vs_sym (_gt_arg1, 0, 1);
    {
      {
        if (!RF_CALL (Class::Int_q_, _vs_sym, /*void*/))
        {
          goto _block4__branch1;
        }
        Expr _v__q_1;
        RF_CALL (Box::_q_, Int, _v__q_1);
        if (_v__q_1.get_len () != 1)
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        if (!_c_1.term_eq (_v__q_1, 0))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        Expr _gs_auxcall29;
        RF_CALL (MV, /*void*/, _gs_auxcall29);
        RF_CALL (MethodVisitor::MVvisitTypeInsn, (_gs_auxcall29, _c_20, _c_30), /*void*/);
        Expr _gs_auxcall30;
        RF_CALL (MV, /*void*/, _gs_auxcall30);
        RF_CALL (MethodVisitor::MVvisitInsn, (_gs_auxcall30, _c_22), /*void*/);
        Expr _gs_auxcall31;
        RF_CALL (MV, /*void*/, _gs_auxcall31);
        RF_CALL (MethodVisitor::MVvisitTypeInsn, (_gs_auxcall31, _c_20, _c_184), /*void*/);
        Expr _gs_auxcall32;
        RF_CALL (MV, /*void*/, _gs_auxcall32);
        RF_CALL (MethodVisitor::MVvisitInsn, (_gs_auxcall32, _c_22), /*void*/);
        Expr _gs_auxcall33;
        RF_CALL (MV, /*void*/, _gs_auxcall33);
        Expr _gs_auxcall34;
        RF_CALL (Convert::To_m_Word, _vs_sym, _gs_auxcall34);
        Expr _gs_auxcall35;
        RF_CALL (Java::WordToString, _gs_auxcall34, _gs_auxcall35);
        RF_CALL (MethodVisitor::MVvisitLdcInsn, (_gs_auxcall33, _gs_auxcall35), /*void*/);
        Expr _gs_auxcall36;
        RF_CALL (MV, /*void*/, _gs_auxcall36);
        RF_CALL (MethodVisitor::MVvisitMethodInsn, (_gs_auxcall36, _c_23, _c_184, _c_24, _c_31), /*void*/);
        Expr _gs_auxcall37;
        RF_CALL (MV, /*void*/, _gs_auxcall37);
        RF_TAILCALL (MethodVisitor::MVvisitMethodInsn, (_gs_auxcall37, _c_23, _c_30, _c_24, _c_32), /*void*/);
        goto _block4;
      }
    _block4__branch1: {}
      if (!RF_CALL (Class::Word_q_, _vs_sym, /*void*/))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      Expr _gs_auxcall38;
      RF_CALL (MV, /*void*/, _gs_auxcall38);
      RF_CALL (MethodVisitor::MVvisitTypeInsn, (_gs_auxcall38, _c_20, _c_30), /*void*/);
      Expr _gs_auxcall39;
      RF_CALL (MV, /*void*/, _gs_auxcall39);
      RF_CALL (MethodVisitor::MVvisitInsn, (_gs_auxcall39, _c_22), /*void*/);
      Expr _gs_auxcall40;
      RF_CALL (MV, /*void*/, _gs_auxcall40);
      RF_CALL (MethodVisitor::MVvisitTypeInsn, (_gs_auxcall40, _c_20, _c_185), /*void*/);
      Expr _gs_auxcall41;
      RF_CALL (MV, /*void*/, _gs_auxcall41);
      RF_CALL (MethodVisitor::MVvisitInsn, (_gs_auxcall41, _c_22), /*void*/);
      Expr _gs_auxcall42;
      RF_CALL (MV, /*void*/, _gs_auxcall42);
      Expr _gs_auxcall43;
      RF_CALL (Java::WordToString, _vs_sym, _gs_auxcall43);
      RF_CALL (MethodVisitor::MVvisitLdcInsn, (_gs_auxcall42, _gs_auxcall43), /*void*/);
      Expr _gs_auxcall44;
      RF_CALL (MV, /*void*/, _gs_auxcall44);
      RF_CALL (MethodVisitor::MVvisitMethodInsn, (_gs_auxcall44, _c_23, _c_185, _c_24, _c_31), /*void*/);
      Expr _gs_auxcall45;
      RF_CALL (MV, /*void*/, _gs_auxcall45);
      RF_TAILCALL (MethodVisitor::MVvisitMethodInsn, (_gs_auxcall45, _c_23, _c_30, _c_24, _c_32), /*void*/);
    }
  _block4: {}
  }
_block1: {}
RF_END

RF_FUNC (Var_m_To_m_JBC, (RF_ARG _vt_var;;), RF_VOID)
  Expr _vs_type;
  Expr _vs_i;
  RF_CALL (Lookup_m_Var, _vt_var, (_vs_type, _vs_i));
  {
    {
      if (!_vs_type.term_eq (_c_62, 0))
      {
        goto _block1__branch1;
      }
      Expr _gs_auxcall1;
      RF_CALL (MV, /*void*/, _gs_auxcall1);
      RF_CALL (MethodVisitor::MVvisitVarInsn, (_gs_auxcall1, _c_14, _vs_i), /*void*/);
      Expr _gs_auxcall2;
      RF_CALL (MV, /*void*/, _gs_auxcall2);
      RF_TAILCALL (MethodVisitor::MVvisitMethodInsn, (_gs_auxcall2, _c_75, _c_21, _c_115, _c_106), /*void*/);
      goto _block1;
    }
  _block1__branch1: {}
    {
      if (!_vs_type.term_eq (_c_48, 0))
      {
        goto _block1__branch2;
      }
      Expr _gs_auxcall3;
      RF_CALL (MV, /*void*/, _gs_auxcall3);
      RF_TAILCALL (MethodVisitor::MVvisitVarInsn, (_gs_auxcall3, _c_14, _vs_i), /*void*/);
      goto _block1;
    }
  _block1__branch2: {}
    if (!_vs_type.term_eq (_c_78, 0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _gs_auxcall4;
    RF_CALL (MV, /*void*/, _gs_auxcall4);
    RF_TAILCALL (MethodVisitor::MVvisitVarInsn, (_gs_auxcall4, _c_186, _vs_i), /*void*/);
  }
_block1: {}
RF_END

RF_FUNC (Access_m_Mode, (RF_ARG _vt_name;;), (RF_RES _v_res1;;))
  {
    {
      Expr _v__q_1;
      RF_CALL (Box::_q_, Exports, _v__q_1);
      if (_v__q_1.get_len () < 1)
      {
        goto _block1__branch1;
      }
      RF_lsplit (_v__q_1, 0, _ve__e__e_tmp_m_rfp__asail__jbcrf_m_865_m_19, _v_lsplit___q_1);
      for ( ; ; RF_iter(_v__q_1)++)
      {
        {
          if (!RF_iter(_v__q_1))
          {
            goto _block1__branch1;
          }
          uintptr_t _v_len1 = _v_lsplit___q_1.get_len ();
          uintptr_t _v_len2 = 1;
          if (_v_len1 < _v_len2)
          {
            goto _block1__branch1;
          }
          uintptr_t _v_len___e__e_tmp_m_rfp__asail__jbcrf_m_865_m_28 = (_v_len1 - _v_len2);
          if (!_vt_name.term_eq (_v_lsplit___q_1, 0))
          {
            goto _continue1;
          }
          Expr _ve__e__e_tmp_m_rfp__asail__jbcrf_m_865_m_28 (_v_lsplit___q_1, (0 + 1), _v_len___e__e_tmp_m_rfp__asail__jbcrf_m_865_m_28);
          _v_res1 = _c_7;
          goto _exit1;
        }
    _continue1: {}
      }
    _exit1: {}
      goto _block1;
    }
  _block1__branch1: {}
    _v_res1 = _c_15;
  }
_block1: {}
RF_END

RF_FUNC (Expr_m_Int_m_To_m_JBC__0, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  uintptr_t _v_len1 = _ge_arg1.get_len ();
  uintptr_t _v_len2 = 0;
  if (_v_len1 < _v_len2)
  {
    RF_ERROR (_c_187);
  }
  uintptr_t _v_len__stub1 = (_v_len1 - _v_len2);
  Expr _v_stub1 (_ge_arg1, 0, _v_len__stub1);
  RF_CALL (Expr_m_Int_m_To_m_JBC, _v_stub1, /*void*/);
  _v_res1 = empty;
RF_END

RF_FUNC (To_m_Word__0, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  uintptr_t _v_len1 = _ge_arg1.get_len ();
  uintptr_t _v_len2 = 0;
  if (_v_len1 < _v_len2)
  {
    RF_ERROR (_c_187);
  }
  uintptr_t _v_len__stub1 = (_v_len1 - _v_len2);
  Expr _v_stub1 (_ge_arg1, 0, _v_len__stub1);
  RF_CALL (Convert::To_m_Word, _v_stub1, _v_res1);
RF_END

}

namespace rfp__asail__jbc
{

static void init_ ()
{
  Int = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Int");
  Exports = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Exports");
  Module_m_Name = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Module-Name");
  Refal_m_Module_m_Name = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Refal-Module-Name");
  Entry = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Entry");
  Entry_m_Name = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Entry-Name");
  Func_m_Name = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Func-Name");
  Objects = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Objects");
  Constants = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Constants");
  Func_m_Refs = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Func-Refs");
  MVbox = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"MVbox");
  Block_m_Tables = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Block-Tables");
  Traps = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Traps");
  _c_0 = Expr::create<rftype::Word>("INT");
  _c_1 = Expr::create<rftype::Word>("BigInteger");
  _c_2 = Expr::create<rftype::Word>("ENTRIES");
  _c_3 = Expr::create<rftype::Word>("Main");
  _c_4 = rftype::Char::create_expr (L".");
  _c_5 = Expr::create_sym<rftype::Func> (To_m_Word__0);
  _c_53 = rftype::Char::create_expr (L"org/refal/plus/library/");
  _c_6 = Expr (_c_53, 3, 1);
  _c_7 = Expr::create<rftype::Integer>("1");
  _c_8 = Expr::create<rftype::Integer>("2");
  _c_9 = Expr::create<rftype::Integer>("48");
  _c_10 = Expr::create<rftype::Word>("java/lang/Object");
  _c_11 = Expr::create<rftype::Integer>("8");
  _c_12 = Expr::create<rftype::Word>("main");
  _c_13 = Expr::create<rftype::Word>("([Ljava/lang/String;)V");
  _c_14 = Expr::create<rftype::Integer>("25");
  _c_15 = Expr::create<rftype::Integer>("0");
  _c_16 = Expr::create<rftype::Integer>("184");
  _c_17 = Expr::create<rftype::Word>("org/refal/plus/RefalRuntime");
  _c_18 = Expr::create<rftype::Word>("setArgs");
  _c_19 = Expr::create<rftype::Word>("(Ljava/lang/String;[Ljava/lang/String;)V");
  _c_20 = Expr::create<rftype::Integer>("187");
  _c_21 = Expr::create<rftype::Word>("org/refal/plus/Result");
  _c_22 = Expr::create<rftype::Integer>("89");
  _c_23 = Expr::create<rftype::Integer>("183");
  _c_24 = Expr::create<rftype::Word>("<init>");
  _c_25 = Expr::create<rftype::Word>("()V");
  _c_26 = Expr::create<rftype::Word>("(Lorg/refal/plus/Result;)V");
  _c_27 = Expr::create<rftype::Integer>("177");
  _c_28 = Expr::create<rftype::Word>("<clinit>");
  _c_29 = Expr::create<rftype::Word>("org/refal/plus/library/");
  _c_30 = Expr::create<rftype::Word>("org/refal/plus/Expr");
  _c_31 = Expr::create<rftype::Word>("(Ljava/lang/String;)V");
  _c_32 = Expr::create<rftype::Word>("(Ljava/lang/Object;)V");
  _c_33 = Expr::create<rftype::Integer>("179");
  _c_34 = Expr::create<rftype::Word>("Lorg/refal/plus/Expr;");
  _c_35 = rftype::Char::create_expr (L"$");
  _c_36 = Expr::create<rftype::Integer>("16");
  _c_37 = Expr::create<rftype::Word>("org/refal/plus/Func");
  _c_38 = Expr::create<rftype::Word>("eval");
  _c_39 = Expr::create<rftype::Word>("(Lorg/refal/plus/Expr;Lorg/refal/plus/Result;)Z");
  _c_40 = Expr::create<rftype::Word>("org/refal/plus/RefalException");
  _c_41 = Expr::create<rftype::Word>("FUNC?");
  _c_42 = Expr::create<rftype::Integer>("172");
  _c_43 = Expr::create<rftype::Word>("FUNC");
  _c_44 = Expr::create<rftype::Word>("(Lorg/refal/plus/Expr;Lorg/refal/plus/Result;)V");
  _c_45 = Expr::create<rftype::Integer>("4");
  _c_46 = Expr::create<rftype::Word>("VAR-INDEX");
  _c_47 = Expr::create<rftype::Word>("VAR");
  _c_48 = Expr::create<rftype::Word>("Expr");
  _c_49 = Expr::create<rftype::Word>("ITER");
  _c_50 = Expr::create<rftype::Word>("TMP");
  _c_51 = Expr::create<rftype::Word>("LABEL");
  _c_52 = Expr::create<rftype::Word>("BOOT");
  _c_54 = Expr::create<rftype::Word>("LOCAL");
  _c_55 = (_c_6) ();
  _c_56 = Expr::create<rftype::Word>("Lorg/refal/plus/Result;");
  _c_57 = rftype::Char::create_expr (L")");
  _c_58 = rftype::Char::create_expr (L"(");
  _c_59 = Expr::create<rftype::Word>("IMPORT");
  _c_60 = rftype::Char::create_expr (L"V");
  _c_61 = rftype::Char::create_expr (L"Z");
  _c_62 = Expr::create<rftype::Word>("Result");
  _c_63 = Expr::create<rftype::Word>("CONSTEXPR");
  _c_64 = Expr::create<rftype::Word>("STATIC");
  _c_65 = Expr::create<rftype::Word>("OBJ");
  _c_66 = rftype::Char::create_expr (L"Named");
  _c_67 = Expr::create<rftype::Word>("DECL-OBJ");
  _c_68 = Expr::create<rftype::Word>("DECL-FUNC");
  _c_69 = Expr::create<rftype::Word>("TRACE");
  _c_70 = Expr::create<rftype::Word>("DECL");
  _c_71 = Expr::create<rftype::Integer>("58");
  _c_72 = Expr::create<rftype::Integer>("178");
  _c_73 = Expr::create<rftype::Word>("empty");
  _c_74 = Expr::create<rftype::Word>("ASSIGN");
  _c_75 = Expr::create<rftype::Integer>("182");
  _c_76 = Expr::create<rftype::Word>("assign");
  _c_77 = Expr::create<rftype::Word>("(Lorg/refal/plus/Expr;)V");
  _c_78 = Expr::create<rftype::Word>("Int");
  _c_79 = Expr::create<rftype::Integer>("54");
  _c_80 = Expr::create<rftype::Word>("EXPR");
  _c_81 = Expr::create<rftype::Word>("DEREF");
  _c_82 = Expr::create<rftype::Word>("at");
  _c_83 = Expr::create<rftype::Word>("(I)Ljava/lang/Object;");
  _c_84 = Expr::create<rftype::Integer>("192");
  _c_85 = Expr::create<rftype::Word>("SUBEXPR");
  _c_86 = Expr::create<rftype::Word>("(Lorg/refal/plus/Expr;II)V");
  _c_87 = Expr::create<rftype::Word>("IF-INT-CMP");
  _c_88 = Expr::create<rftype::Word>("!=");
  _c_89 = Expr::create<rftype::Integer>("159");
  _c_90 = Expr::create<rftype::Word>("<");
  _c_91 = Expr::create<rftype::Integer>("162");
  _c_92 = Expr::create<rftype::Word>(">");
  _c_93 = Expr::create<rftype::Integer>("164");
  _c_94 = Expr::create<rftype::Word>("IF");
  _c_95 = Expr::create<rftype::Word>("LSPLIT");
  _c_96 = Expr::create<rftype::Word>("leftSplit");
  _c_97 = Expr::create<rftype::Word>("(I)Lorg/refal/plus/Expr$SplitIterator;");
  _c_98 = Expr::create<rftype::Word>("RSPLIT");
  _c_99 = Expr::create<rftype::Word>("rightSplit");
  _c_100 = (empty) ();
  _c_101 = Expr::create<rftype::Word>("FOR");
  _c_102 = Expr::create<rftype::Word>("INC-ITER");
  _c_103 = Expr::create<rftype::Word>("DEC-ITER");
  _c_104 = Expr::create<rftype::Word>("org/refal/plus/Expr$SplitIterator");
  _c_105 = Expr::create<rftype::Word>("getLeft");
  _c_106 = Expr::create<rftype::Word>("()Lorg/refal/plus/Expr;");
  _c_107 = Expr::create<rftype::Word>("getRight");
  _c_108 = Expr::create<rftype::Integer>("167");
  _c_109 = Expr::create<rftype::Word>("CONTINUE");
  _c_110 = Expr::create<rftype::Word>("BREAK");
  _c_111 = Expr::create<rftype::Word>("RETFAIL");
  _c_112 = Expr::create<rftype::Integer>("3");
  _c_113 = Expr::create<rftype::Word>("TRY");
  _c_114 = Expr::create<rftype::Word>("CATCH-ERROR");
  _c_115 = Expr::create<rftype::Word>("getExpr");
  _c_116 = Expr::create<rftype::Word>("FATAL");
  _c_187 = Expr::create<rftype::Word>("Apply") + Expr::create<rftype::Word>("Apply") + Expr::create<rftype::Word>("Unexpected fail");
  _c_117 = Expr (_c_187, 2, 1);
  _c_118 = Expr::create<rftype::Word>("(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)V");
  _c_119 = Expr::create<rftype::Integer>("191");
  _c_120 = Expr::create<rftype::Word>("ERROR");
  _c_121 = Expr::create<rftype::Word>("CALL");
  _c_122 = Expr::create<rftype::Word>("V");
  _c_123 = Expr::create<rftype::Word>("TAILCALL");
  _c_124 = Expr::create<rftype::Word>("TAILCALL?");
  _c_125 = Expr::create<rftype::Word>("Z");
  _c_126 = Expr::create<rftype::Integer>("154");
  _c_127 = Expr::create<rftype::Word>("concat");
  _c_128 = Expr::create<rftype::Word>("(Lorg/refal/plus/Expr;Lorg/refal/plus/Expr;)Lorg/refal/plus/Expr;");
  _c_129 = Expr::create<rftype::Integer>("189");
  _c_130 = Expr::create<rftype::Word>("([Lorg/refal/plus/Expr;)Lorg/refal/plus/Expr;");
  _c_131 = Expr::create<rftype::Integer>("83");
  _c_132 = Expr::create<rftype::Word>("PAREN");
  _c_133 = Expr::create<rftype::Word>("REF");
  _c_134 = Expr::create<rftype::Word>("ERROR-EXPR");
  _c_135 = Expr::create<rftype::Word>("SVAR");
  _c_136 = Expr::create<rftype::Word>("TVAR");
  _c_137 = Expr::create<rftype::Word>("EVAR");
  _c_138 = Expr::create<rftype::Word>("VVAR");
  _c_139 = Expr::create<rftype::Word>("Illegal int-symbol: ");
  _c_140 = Expr::create<rftype::Word>("LENGTH");
  _c_141 = Expr::create<rftype::Word>("getLen");
  _c_142 = Expr::create<rftype::Word>("()I");
  _c_143 = Expr::create<rftype::Word>("MIN");
  _c_144 = Expr::create<rftype::Word>("min");
  _c_145 = Expr::create<rftype::Word>("MAX");
  _c_146 = Expr::create<rftype::Word>("max");
  _c_147 = Expr::create<rftype::Word>("java/lang/Math");
  _c_148 = Expr::create<rftype::Word>("(II)I");
  _c_149 = Expr::create<rftype::Word>("INFIX");
  _c_150 = Expr::create_sym<rftype::Func> (Expr_m_Int_m_To_m_JBC__0);
  _c_151 = Expr::create<rftype::Word>("+");
  _c_152 = Expr::create<rftype::Integer>("96");
  _c_153 = Expr::create<rftype::Word>("-");
  _c_154 = Expr::create<rftype::Integer>("100");
  _c_155 = Expr::create<rftype::Word>("%");
  _c_156 = Expr::create<rftype::Integer>("112");
  _c_157 = Expr::create<rftype::Word>("*");
  _c_158 = Expr::create<rftype::Integer>("104");
  _c_159 = Expr::create<rftype::Word>("/");
  _c_160 = Expr::create<rftype::Integer>("108");
  _c_161 = Expr::create<rftype::Word>("CALL-FAILS");
  _c_162 = Expr::create<rftype::Word>("ITER-FAILS");
  _c_163 = Expr::create<rftype::Word>("isValid");
  _c_164 = Expr::create<rftype::Word>("()Z");
  _c_165 = Expr::create<rftype::Word>("SYMBOL?");
  _c_166 = Expr::create<rftype::Word>("symbolAt");
  _c_167 = Expr::create<rftype::Word>("(I)Z");
  _c_168 = Expr::create<rftype::Integer>("153");
  _c_169 = Expr::create<rftype::Word>("EQ");
  _c_170 = Expr::create<rftype::Word>("eq");
  _c_171 = Expr::create<rftype::Word>("(Lorg/refal/plus/Expr;I)Z");
  _c_172 = Expr::create<rftype::Word>("TERM-EQ");
  _c_173 = Expr::create<rftype::Word>("termEq");
  _c_174 = Expr::create<rftype::Word>("NOT");
  _c_175 = Expr::create<rftype::Word>("next");
  _c_176 = Expr::create<rftype::Word>("prev");
  _c_177 = Expr::create<rftype::Word>("()Lorg/refal/plus/Expr$SplitIterator;");
  _c_178 = Expr::create<rftype::Integer>("87");
  _c_179 = Expr::create<rftype::Word>("F");
  _c_180 = Expr::create<rftype::Word>("T");
  _c_181 = Expr::create<rftype::Word>("CHARS");
  _c_182 = Expr::create<rftype::Word>("fromSequence");
  _c_183 = Expr::create<rftype::Word>("(Ljava/lang/CharSequence;)Lorg/refal/plus/Expr;");
  _c_184 = Expr::create<rftype::Word>("java/math/BigInteger");
  _c_185 = Expr::create<rftype::Word>("org/refal/plus/Word");
  _c_186 = Expr::create<rftype::Integer>("21");
  Opcodes::IFEQ = Expr::create<rftype::Integer>("153");
  Opcodes::IFNE = Expr::create<rftype::Integer>("154");
}

static AtStart init_registrator_ (&init_);

}

}
