#include <rf_core.hh>
#include <refal/Access.hh>
#include <refal/Arithm.hh>
#include <refal/Apply.hh>
#include <refal/Class.hh>
#include <refal/Convert.hh>
#include <refal/Compare.hh>
#include <refal/Box.hh>
#include <refal/List.hh>
#include <refal/Table.hh>
#include <refal/StdIO.hh>
#include "rfp_check.hh"
#include "rfp_clashes.hh"
#include "rfp_as2as.hh"
#include "rfp_format.hh"
#include "rfp_helper.hh"
#include "rfpc.hh"
#include "rfp_vars.hh"
#include "rfp_const.hh"
#include <refal/Dos.hh>

namespace refal
{

using namespace rfrt;

namespace rfp__compile
{

Expr Fun;

Expr Fun_q_;

Expr Const;

Expr Object;

static Expr Objects;

static Expr Stub_m_Funcs;

static Expr Out_m_Format;

static Expr Res_m_Vars;

static Expr Labels;

static Expr Prep_m_Vars;

static Expr Declarations;

static Expr Trace_m_Names;

static Expr Includes;

RF_DECL (RFP_m_Compile);

RF_DECL (Compile);

RF_DECL (Comp_m_Func_m_Stubs);

RF_DECL (Gener_m_Stub);

RF_DECL (Comp_m_Func);

RF_DECL (Set_m_Drops);

RF_DECL (Comp_m_Sentence);

static Expr Snt_m_State;

RF_DECL (Save_m_Snt_m_State);

RF_DECL (Recall_m_Snt_m_State);

RF_DECL (Pop_m_Snt_m_State);

RF_DECL (Extract_m_Calls);

RF_DECL (Comp_m_Calls);

RF_DECL (Prepare_m_Res);

RF_DECL (Static_m_Expr_q_);

RF_DECL (Static_m_Term_q_);

RF_DECL (Ref_m_Func_q_);

RF_DECL (Prepare_m_Vars);

RF_DECL (Stub_m_Name);

RF_DECL (Prepare_m_Const);

RF_DECL (Comp_m_Assign_m_to_m_Var);

RF_DECL (Comp_m_Assigns);

static Expr Aux_m_Index;

RF_DECL (Gener_m_Aux_m_Var);

RF_DECL (Comp_m_Format);

RF_DECL (Get_m_Vars);

RF_DECL (Create_m_Aux_m_Vars);

RF_DECL (Assign_m_Empty_m_Provides);

RF_DECL (Delay_m_Empty_m_Requires);

RF_DECL (Max_m_Require);

RF_DECL (Subst_m_Aux_m_Var);

RF_DECL (Extract_m_Assigns);

RF_DECL (CAV);

RF_DECL (Get_m_Clash_m_Sequence);

RF_DECL (Without_m_Calls_q_);

RF_DECL (Comp_m_Clashes);

RF_DECL (CC);

RF_DECL (CC_m_Known_m_Lengths);

RF_DECL (CC_m_Compute_m_Length);

RF_DECL (CC_m_Unknown_m_Lengths);

RF_DECL (Get_m_Min);

RF_DECL (Get_m_Max);

RF_DECL (Pos);

RF_DECL (CC_m_Deref);

RF_DECL (CC_m_Eqs);

RF_DECL (Gener_m_Label);

RF_DECL (Add_m_To_m_Label);

RF_DECL (Lookup_m_Func);

RF_DECL (Set_m_Var__0);

static Expr _c_0;

static Expr _c_1;

static Expr _c_2;

static Expr _c_3;

static Expr _c_4;

static Expr _c_5;

static Expr _c_6;

static Expr _c_7;

static Expr _c_16;

static Expr _c_8;

static Expr _c_9;

static Expr _c_10;

static Expr _c_11;

static Expr _c_12;

static Expr _c_13;

static Expr _c_14;

static Expr _c_15;

static Expr _c_17;

static Expr _c_23;

static Expr _c_18;

static Expr _c_19;

static Expr _c_154;

static Expr _c_20;

static Expr _c_21;

static Expr _c_22;

static Expr _c_25;

static Expr _c_24;

static Expr _c_26;

static Expr _c_27;

static Expr _c_28;

static Expr _c_146;

static Expr _c_29;

static Expr _c_30;

static Expr _c_31;

static Expr _c_32;

static Expr _c_155;

static Expr _c_156;

static Expr _c_33;

static Expr _c_34;

static Expr _c_35;

static Expr _c_36;

static Expr _c_157;

static Expr _c_37;

static Expr _c_38;

static Expr _c_39;

static Expr _c_40;

static Expr _c_153;

static Expr _c_41;

static Expr _c_42;

static Expr _c_59;

static Expr _c_43;

static Expr _c_44;

static Expr _c_45;

static Expr _c_46;

static Expr _c_47;

static Expr _c_48;

static Expr _c_49;

static Expr _c_50;

static Expr _c_51;

static Expr _c_52;

static Expr _c_53;

static Expr _c_54;

static Expr _c_55;

static Expr _c_56;

static Expr _c_57;

static Expr _c_108;

static Expr _c_58;

static Expr _c_60;

static Expr _c_79;

static Expr _c_61;

static Expr _c_62;

static Expr _c_63;

static Expr _c_64;

static Expr _c_65;

static Expr _c_66;

static Expr _c_67;

static Expr _c_68;

static Expr _c_69;

static Expr _c_70;

static Expr _c_71;

static Expr _c_94;

static Expr _c_72;

static Expr _c_73;

static Expr _c_74;

static Expr _c_75;

static Expr _c_76;

static Expr _c_77;

static Expr _c_78;

static Expr _c_80;

static Expr _c_81;

static Expr _c_82;

static Expr _c_83;

static Expr _c_84;

static Expr _c_85;

static Expr _c_86;

static Expr _c_87;

static Expr _c_88;

static Expr _c_89;

static Expr _c_90;

static Expr _c_91;

static Expr _c_92;

static Expr _c_93;

static Expr _c_95;

static Expr _c_96;

static Expr _c_97;

static Expr _c_98;

static Expr _c_99;

static Expr _c_100;

static Expr _c_101;

static Expr _c_102;

static Expr _c_103;

static Expr _c_104;

static Expr _c_105;

static Expr _c_106;

static Expr _c_107;

static Expr _c_109;

static Expr _c_110;

static Expr _c_111;

static Expr _c_112;

static Expr _c_113;

static Expr _c_140;

static Expr _c_114;

static Expr _c_115;

static Expr _c_116;

static Expr _c_117;

static Expr _c_118;

static Expr _c_119;

static Expr _c_120;

static Expr _c_121;

static Expr _c_122;

static Expr _c_123;

static Expr _c_124;

static Expr _c_125;

static Expr _c_126;

static Expr _c_127;

static Expr _c_128;

static Expr _c_129;

static Expr _c_130;

static Expr _c_131;

static Expr _c_132;

static Expr _c_133;

static Expr _c_134;

static Expr _c_135;

static Expr _c_136;

static Expr _c_137;

static Expr _c_138;

static Expr _c_139;

static Expr _c_141;

static Expr _c_142;

static Expr _c_143;

static Expr _c_144;

static Expr _c_145;

static Expr _c_147;

static Expr _c_148;

static Expr _c_149;

static Expr _c_150;

static Expr _c_151;

static Expr _c_152;

RF_FUNC (RFP_m_Compile, (RF_ARG _ve_Items;;), (RF_RES _v_res1;;))
  Expr _ve_targets;
  {
    {
      if (!RF_CALL (Table::Lookup, (rfp__helper::RFP_m_Options, _c_0), _ve_targets))
      {
        goto _block1__branch1;
      }
      goto _block1;
    }
  _block1__branch1: {}
    _ve_targets = empty;
  }
_block1: {}
  RF_CALL (rfp__helper::RFP_m_Clear_m_Table, Stub_m_Funcs, /*void*/);
  RF_CALL (rfp__helper::RFP_m_Clear_m_Table, Includes, /*void*/);
  RF_CALL (Box::Store, (Trace_m_Names, empty), /*void*/);
  RF_CALL (Box::Store, (Declarations, empty), /*void*/);
  RF_CALL (rfp__const::Init_m_Consts, /*void*/, /*void*/);
  Expr _ge_Items__1;
  Expr _v_Compile1;
  RF_CALL (Compile, (_ve_targets, empty, _ve_Items), (_ge_Items__1, _v_Compile1));
  Expr _vt_Interface ((_c_1 + _v_Compile1) ());
  Expr _ve_stub_m_funcs;
  RF_CALL (Comp_m_Func_m_Stubs, /*void*/, _ve_stub_m_funcs);
  Expr _ge_auxcall1;
  RF_CALL (Table::Domain, Includes, _ge_auxcall1);
  Expr _ge_auxcall2;
  RF_CALL (Box::_q_, Trace_m_Names, _ge_auxcall2);
  Expr _ge_auxcall3;
  RF_CALL (Box::_q_, Declarations, _ge_auxcall3);
  Expr _ge_auxcall4;
  RF_CALL (rfp__const::Comp_m_Consts, /*void*/, _ge_auxcall4);
  _v_res1 = (_vt_Interface + (_c_2 + _ge_auxcall1 + _ge_auxcall2 + _ge_auxcall3 + _ge_auxcall4 + _ge_Items__1 + _ve_stub_m_funcs) ());
RF_END

RF_FUNC (Compile, (RF_ARG _ve_targets, _ve_headers, _ve_Items;;), (RF_RES _v_res1, _v_res2;;))
  {
    {
      if (_ve_Items.get_len () < 1)
      {
        goto _block1__branch1;
      }
      RF_lsplit (_ve_Items, 0, _ve__e__e_tmp_m_rfp__compilerf_m_132_m_14, _v_lsplit__Items);
      for ( ; ; RF_iter(_ve_Items)++)
      {
        {
          if (!RF_iter(_ve_Items))
          {
            goto _block1__branch1;
          }
          uintptr_t _v_len1 = _v_lsplit__Items.get_len ();
          uintptr_t _v_len2 = 1;
          if (_v_len1 < _v_len2)
          {
            goto _block1__branch1;
          }
          uintptr_t _v_len__rest = (_v_len1 - _v_len2);
          Expr _vt_item (_v_lsplit__Items, 0, 1);
          Expr _ve_rest (_v_lsplit__Items, (0 + 1), _v_len__rest);
          {
            {
              uintptr_t _v_len3 = _ve_targets.get_len ();
              uintptr_t _v_len4 = 0;
              if (_v_len3 < (_v_len4 + 1))
              {
                goto _block2__branch1;
              }
              uintptr_t _v_len___e__e_tmp_m_rfp__compilerf_m_134_m_20 = (_v_len3 - _v_len4);
              Expr _vv__e__e_tmp_m_rfp__compilerf_m_134_m_20 (_ve_targets, 0, _v_len___e__e_tmp_m_rfp__compilerf_m_134_m_20);
              if (_ve_targets.get_len () < 1)
              {
                goto _continue1;
              }
              if (_vt_item.symbol_at (0))
              {
                goto _continue1;
              }
              Expr _v_deref__item (_vt_item, 0);
              uintptr_t _v_len5 = _v_deref__item.get_len ();
              uintptr_t _v_len6 = 4;
              if (_v_len5 < _v_len6)
              {
                goto _continue1;
              }
              uintptr_t _v_len___e__e_tmp_m_rfp__compilerf_m_136_m_33 = (_v_len5 - _v_len6);
              Expr _vt__e__e_tmp_m_rfp__compilerf_m_136_m_20 (_v_deref__item, 0, 1);
              Expr _vt__e__e_tmp_m_rfp__compilerf_m_136_m_22 (_v_deref__item, (0 + 1), 1);
              Expr _vt__e__e_tmp_m_rfp__compilerf_m_136_m_24 (_v_deref__item, (0 + 1 + 1), 1);
              Expr _vt_name (_v_deref__item, (0 + 1 + 1 + 1), 1);
              Expr _ve__e__e_tmp_m_rfp__compilerf_m_136_m_33 (_v_deref__item, (0 + 1 + 1 + 1 + 1), _v_len___e__e_tmp_m_rfp__compilerf_m_136_m_33);
              RF_lsplit (_ve_targets, 0, _ve__e__e_tmp_m_rfp__compilerf_m_135_m_22, _v_lsplit__targets);
              for ( ; ; RF_iter(_ve_targets)++)
              {
                {
                  if (!RF_iter(_ve_targets))
                  {
                    goto _continue1;
                  }
                  uintptr_t _v_len7 = _v_lsplit__targets.get_len ();
                  uintptr_t _v_len8 = 1;
                  if (_v_len7 < _v_len8)
                  {
                    goto _continue1;
                  }
                  uintptr_t _v_len___e__e_tmp_m_rfp__compilerf_m_135_m_31 = (_v_len7 - _v_len8);
                  if (!_vt_name.term_eq (_v_lsplit__targets, 0))
                  {
                    goto _continue2;
                  }
                  Expr _ve__e__e_tmp_m_rfp__compilerf_m_135_m_31 (_v_lsplit__targets, (0 + 1), _v_len___e__e_tmp_m_rfp__compilerf_m_135_m_31);
                  goto _exit2;
                }
            _continue2: {}
              }
            _exit2: {}
              goto _block2;
            }
          _block2__branch1: {}
          }
        _block2: {}
          Expr _ve_decl;
          Expr _ge_item__3;
          {
            {
              if (_vt_item.symbol_at (0))
              {
                goto _block3__branch1;
              }
              Expr _v_deref__item2 (_vt_item, 0);
              uintptr_t _v_len9 = _v_deref__item2.get_len ();
              uintptr_t _v_len10 = 4;
              if (_v_len9 < _v_len10)
              {
                goto _block3__branch1;
              }
              uintptr_t _v_len___e__e_tmp_m_rfp__compilerf_m_139_m_38 = (_v_len9 - _v_len10);
              if (!_c_3.term_eq (_v_deref__item2, 0))
              {
                goto _block3__branch1;
              }
              if (!_v_deref__item2.symbol_at ((0 + 1)))
              {
                goto _block3__branch1;
              }
              Expr _vs_tag (_v_deref__item2, (0 + 1), 1);
              Expr _vt_pragma (_v_deref__item2, (0 + 1 + 1), 1);
              Expr _vt_name (_v_deref__item2, (0 + 1 + 1 + 1), 1);
              Expr _ve__e__e_tmp_m_rfp__compilerf_m_139_m_38 (_v_deref__item2, (0 + 1 + 1 + 1 + 1), _v_len___e__e_tmp_m_rfp__compilerf_m_139_m_38);
              {
                {
                  if (_vt_pragma.symbol_at (0))
                  {
                    goto _block4__branch1;
                  }
                  Expr _v_deref__pragma (_vt_pragma, 0);
                  if (_v_deref__pragma.get_len () < 2)
                  {
                    goto _block4__branch1;
                  }
                  if (!_c_5.term_eq (_v_deref__pragma, 0))
                  {
                    goto _block4__branch1;
                  }
                  Expr _v_subexpr__deref__pragma (_v_deref__pragma, (0 + 1), (_v_deref__pragma.get_len () - (0 + 1 + 0)));
                  RF_lsplit (_v_subexpr__deref__pragma, 0, _ve__e__e_tmp_m_rfp__compilerf_m_141_m_31, _v_lsplit__deref__pragma);
                  for ( ; ; RF_iter(_v_subexpr__deref__pragma)++)
                  {
                    {
                      if (!RF_iter(_v_subexpr__deref__pragma))
                      {
                        goto _block4__branch1;
                      }
                      uintptr_t _v_len11 = _v_lsplit__deref__pragma.get_len ();
                      uintptr_t _v_len12 = 1;
                      if (_v_len11 < _v_len12)
                      {
                        goto _block4__branch1;
                      }
                      uintptr_t _v_len___e__e_tmp_m_rfp__compilerf_m_141_m_48 = (_v_len11 - _v_len12);
                      if (_v_lsplit__deref__pragma.symbol_at (0))
                      {
                        goto _continue3;
                      }
                      Expr _v_deref__lsplit__deref__pragma (_v_lsplit__deref__pragma, 0);
                      uintptr_t _v_len13 = _v_deref__lsplit__deref__pragma.get_len ();
                      uintptr_t _v_len14 = 1;
                      if (_v_len13 < _v_len14)
                      {
                        goto _continue3;
                      }
                      uintptr_t _v_len__fname = (_v_len13 - _v_len14);
                      if (!_c_4.term_eq (_v_deref__lsplit__deref__pragma, 0))
                      {
                        goto _continue3;
                      }
                      Expr _ve__e__e_tmp_m_rfp__compilerf_m_141_m_48 (_v_lsplit__deref__pragma, (0 + 1), _v_len___e__e_tmp_m_rfp__compilerf_m_141_m_48);
                      Expr _ve_fname (_v_deref__lsplit__deref__pragma, (0 + 1), _v_len__fname);
                      Expr _ve_mod_m_name;
                      Expr _ve__e__e_tmp_m_rfp__compilerf_m_142_m_62;
                      RF_CALL (rfp__helper::RFP_m_Extract_m_Qualifiers, _vt_name, (_ve_mod_m_name, _ve__e__e_tmp_m_rfp__compilerf_m_142_m_62));
                      RF_CALL (Table::Bind, (Includes, (_c_6 + _ve_mod_m_name () + _ve_fname), empty), /*void*/);
                      {
                        {
                          {
                            if (!_vs_tag.term_eq (_c_7, 0))
                            {
                              goto _block6__branch1;
                            }
                            goto _block6;
                          }
                        _block6__branch1: {}
                          {
                            if (!_vs_tag.term_eq (_c_8, 0))
                            {
                              goto _block6__branch2;
                            }
                            goto _block6;
                          }
                        _block6__branch2: {}
                          if (!_vs_tag.term_eq (_c_9, 0))
                          {
                            goto _block5__branch1;
                          }
                        }
                      _block6: {}
                        if (_v_len__fname < 23)
                        {
                          goto _block5__branch1;
                        }
                        RF_lsplit (_ve_fname, 0, _ve__e__e_tmp_m_rfp__compilerf_m_146_m_28, _v_lsplit__fname);
                        for ( ; ; RF_iter(_ve_fname)++)
                        {
                          {
                            if (!RF_iter(_ve_fname))
                            {
                              goto _block5__branch1;
                            }
                            uintptr_t _v_len15 = _v_lsplit__fname.get_len ();
                            uintptr_t _v_len16 = 23;
                            if (_v_len15 < _v_len16)
                            {
                              goto _block5__branch1;
                            }
                            uintptr_t _v_len___e__e_tmp_m_rfp__compilerf_m_146_m_68 = (_v_len15 - _v_len16);
                            if (!_c_13.eq (_v_lsplit__fname, 0))
                            {
                              goto _continue4;
                            }
                            if (!_v_lsplit__fname.symbol_at ((0 + 1 + 1 + 1)))
                            {
                              goto _continue4;
                            }
                            if (!_c_12.eq (_v_lsplit__fname, (0 + 1 + 1 + 1 + 1)))
                            {
                              goto _continue4;
                            }
                            if (!_v_lsplit__fname.symbol_at ((0 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1)))
                            {
                              goto _continue4;
                            }
                            if (!_c_11.eq (_v_lsplit__fname, (0 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1)))
                            {
                              goto _continue4;
                            }
                            if (!_v_lsplit__fname.symbol_at ((0 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1)))
                            {
                              goto _continue4;
                            }
                            if (!_c_10.eq (_v_lsplit__fname, (0 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1)))
                            {
                              goto _continue4;
                            }
                            Expr _vs__e__e_tmp_m_rfp__compilerf_m_146_m_36 (_v_lsplit__fname, (0 + 1 + 1 + 1), 1);
                            Expr _vs__e__e_tmp_m_rfp__compilerf_m_146_m_46 (_v_lsplit__fname, (0 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1), 1);
                            Expr _vs__e__e_tmp_m_rfp__compilerf_m_146_m_55 (_v_lsplit__fname, (0 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1), 1);
                            Expr _ve__e__e_tmp_m_rfp__compilerf_m_146_m_68 (_v_lsplit__fname, (0 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1), _v_len___e__e_tmp_m_rfp__compilerf_m_146_m_68);
                            goto _block3__branch1;
                          }
                      _continue4: {}
                        }
                      _exit4: {}
                      }
                    _block5__branch1: {}
                      goto _exit3;
                    }
                _continue3: {}
                  }
                _exit3: {}
                  goto _block4;
                }
              _block4__branch1: {}
              }
            _block4: {}
              _ve_decl = empty;
              _ge_item__3 = empty;
              goto _block3;
            }
          _block3__branch1: {}
            {
              if (_vt_item.symbol_at (0))
              {
                goto _block3__branch2;
              }
              Expr _v_deref__item3 (_vt_item, 0);
              if (_v_deref__item3.get_len () != 2)
              {
                goto _block3__branch2;
              }
              if (!_c_14.term_eq (_v_deref__item3, 0))
              {
                goto _block3__branch2;
              }
              Expr _vt_name (_v_deref__item3, (0 + 1), 1);
              RF_CALL (Box::Put, (Trace_m_Names, (_c_14 + _vt_name) ()), /*void*/);
              _ve_decl = empty;
              _ge_item__3 = empty;
              goto _block3;
            }
          _block3__branch2: {}
            {
              if (_vt_item.symbol_at (0))
              {
                goto _block3__branch3;
              }
              Expr _v_deref__item4 (_vt_item, 0);
              if (_v_deref__item4.get_len () != 3)
              {
                goto _block3__branch3;
              }
              if (!_c_15.term_eq (_v_deref__item4, 0))
              {
                goto _block3__branch3;
              }
              Expr _vt_pragma (_v_deref__item4, (0 + 1), 1);
              Expr _vt_name (_v_deref__item4, (0 + 1 + 1), 1);
              RF_CALL (Box::Put, (Declarations, (_c_15 + _vt_name) ()), /*void*/);
              _ve_decl = empty;
              _ge_item__3 = empty;
              goto _block3;
            }
          _block3__branch3: {}
            {
              if (_vt_item.symbol_at (0))
              {
                goto _block3__branch4;
              }
              Expr _v_deref__item5 (_vt_item, 0);
              uintptr_t _v_len17 = _v_deref__item5.get_len ();
              uintptr_t _v_len18 = 6;
              if (_v_len17 < _v_len18)
              {
                goto _block3__branch4;
              }
              uintptr_t _v_len__body = (_v_len17 - _v_len18);
              if (_v_deref__item5.symbol_at ((0 + 1 + 1 + 1 + 1)))
              {
                goto _block3__branch4;
              }
              if (_v_deref__item5.symbol_at ((0 + 1 + 1 + 1 + 1 + 1)))
              {
                goto _block3__branch4;
              }
              Expr _v_deref__deref__item5 (_v_deref__item5, (0 + 1 + 1 + 1 + 1));
              Expr _v_deref__deref__item52 (_v_deref__item5, (0 + 1 + 1 + 1 + 1 + 1));
              uintptr_t _v_len19 = _v_deref__deref__item52.get_len ();
              uintptr_t _v_len20 = 0;
              if (_v_len19 < _v_len20)
              {
                goto _block3__branch4;
              }
              uintptr_t _v_len__out = (_v_len19 - _v_len20);
              uintptr_t _v_len21 = _v_deref__deref__item5.get_len ();
              uintptr_t _v_len22 = 0;
              if (_v_len21 < _v_len22)
              {
                goto _block3__branch4;
              }
              uintptr_t _v_len__in = (_v_len21 - _v_len22);
              if (!_v_deref__item5.symbol_at (0))
              {
                goto _block3__branch4;
              }
              if (!_v_deref__item5.symbol_at ((0 + 1)))
              {
                goto _block3__branch4;
              }
              Expr _vs_link (_v_deref__item5, 0, 1);
              Expr _vs_tag (_v_deref__item5, (0 + 1), 1);
              Expr _vt_pragma (_v_deref__item5, (0 + 1 + 1), 1);
              Expr _vt_name (_v_deref__item5, (0 + 1 + 1 + 1), 1);
              Expr _ve_body (_v_deref__item5, (0 + 1 + 1 + 1 + 1 + 1 + 1), _v_len__body);
              Expr _ve_in (_v_deref__deref__item5, 0, _v_len__in);
              Expr _ve_out (_v_deref__deref__item52, 0, _v_len__out);
              RF_lsplit (_c_16, 0, _ve__e__e_tmp_m_rfp__compilerf_m_156_m_81, _v_lsplit__16);
              for ( ; ; RF_iter(_c_16)++)
              {
                {
                  if (!RF_iter(_c_16))
                  {
                    goto _block3__branch4;
                  }
                  uintptr_t _v_len23 = _v_lsplit__16.get_len ();
                  uintptr_t _v_len24 = 1;
                  if (_v_len23 < _v_len24)
                  {
                    goto _block3__branch4;
                  }
                  uintptr_t _v_len___e__e_tmp_m_rfp__compilerf_m_156_m_89 = (_v_len23 - _v_len24);
                  if (!_vs_tag.term_eq (_v_lsplit__16, 0))
                  {
                    goto _continue5;
                  }
                  Expr _ve__e__e_tmp_m_rfp__compilerf_m_156_m_89 (_v_lsplit__16, (0 + 1), _v_len___e__e_tmp_m_rfp__compilerf_m_156_m_89);
                  Expr _ge_decl__5;
                  {
                    {
                      Expr _v__q_1;
                      RF_CALL (Box::_q_, Declarations, _v__q_1);
                      if (_v__q_1.get_len () < 1)
                      {
                        goto _block7__branch1;
                      }
                      RF_rsplit (_v__q_1, 0, _v_rsplit___q_1, _ve__e__e_tmp_m_rfp__compilerf_m_158_m_48);
                      for ( ; ; RF_iter(_v__q_1)--)
                      {
                        {
                          if (!RF_iter(_v__q_1))
                          {
                            goto _block7__branch1;
                          }
                          uintptr_t _v_len25 = _v_rsplit___q_1.get_len ();
                          uintptr_t _v_len26 = 1;
                          if (_v_len25 < _v_len26)
                          {
                            goto _block7__branch1;
                          }
                          uintptr_t _v_len___e__e_tmp_m_rfp__compilerf_m_158_m_35 = (_v_len25 - _v_len26);
                          if (_v_rsplit___q_1.symbol_at ((0 + _v_len___e__e_tmp_m_rfp__compilerf_m_158_m_35)))
                          {
                            goto _continue6;
                          }
                          Expr _v_deref__rsplit___q_1 (_v_rsplit___q_1, (0 + _v_len___e__e_tmp_m_rfp__compilerf_m_158_m_35));
                          if (_v_deref__rsplit___q_1.get_len () != 2)
                          {
                            goto _continue6;
                          }
                          if (!_v_deref__rsplit___q_1.symbol_at (0))
                          {
                            goto _continue6;
                          }
                          if (!_vt_name.term_eq (_v_deref__rsplit___q_1, (0 + 1)))
                          {
                            goto _continue6;
                          }
                          Expr _ve__e__e_tmp_m_rfp__compilerf_m_158_m_35 (_v_rsplit___q_1, 0, _v_len___e__e_tmp_m_rfp__compilerf_m_158_m_35);
                          Expr _vs__e__e_tmp_m_rfp__compilerf_m_158_m_38 (_v_deref__rsplit___q_1, 0, 1);
                          _ge_decl__5 = empty;
                          goto _exit6;
                        }
                    _continue6: {}
                      }
                    _exit6: {}
                      goto _block7;
                    }
                  _block7__branch1: {}
                    {
                      if (!_vs_link.term_eq (_c_3, 0))
                      {
                        goto _block7__branch2;
                      }
                      _ge_decl__5 = empty;
                      goto _block7;
                    }
                  _block7__branch2: {}
                    _ge_decl__5 = (_c_17 + _vt_name) ();
                  }
                _block7: {}
                  RF_CALL (Box::Put, (Declarations, _ge_decl__5), /*void*/);
                  Expr _ge_decl__5__6;
                  {
                    {
                      if (!_vs_link.term_eq (_c_18, 0))
                      {
                        goto _block8__branch1;
                      }
                      _ge_decl__5__6 = _ge_decl__5;
                      goto _block8;
                    }
                  _block8__branch1: {}
                    _ge_decl__5__6 = empty;
                  }
                _block8: {}
                  Expr _ve_comp_m_func;
                  {
                    {
                      if (_v_len__body != 1)
                      {
                        goto _block9__branch1;
                      }
                      if (_ve_body.symbol_at (0))
                      {
                        goto _block9__branch1;
                      }
                      Expr _v_deref__body (_ve_body, 0);
                      uintptr_t _v_len27 = _v_deref__body.get_len ();
                      uintptr_t _v_len28 = 2;
                      if (_v_len27 < _v_len28)
                      {
                        goto _block9__branch1;
                      }
                      uintptr_t _v_len__branch = (_v_len27 - _v_len28);
                      if (!_c_19.term_eq (_v_deref__body, 0))
                      {
                        goto _block9__branch1;
                      }
                      Expr _vt_p (_v_deref__body, (0 + 1), 1);
                      Expr _ve_branch (_v_deref__body, (0 + 1 + 1), _v_len__branch);
                      Expr _ge_auxcall1;
                      RF_CALL (rfp__helper::Del_m_Pragmas, (_ve_in () + _ve_out () + _ve_branch), _ge_auxcall1);
                      RF_CALL (Comp_m_Func, (_vs_link, _vs_tag, _vt_name, _ge_auxcall1), _ve_comp_m_func);
                      goto _block9;
                    }
                  _block9__branch1: {}
                    Expr _ge_auxcall2;
                    RF_CALL (rfp__vars::Gener_m_Vars, (_ve_in, _c_20), _ge_auxcall2);
                    RF_CALL (Comp_m_Func, (_vs_link, _vs_tag, _vt_name, (_ge_auxcall2 () + _ve_out ())), _ve_comp_m_func);
                  }
                _block9: {}
                  _ve_decl = _ge_decl__5__6;
                  _ge_item__3 = _ve_comp_m_func;
                  goto _exit5;
                }
            _continue5: {}
              }
            _exit5: {}
              goto _block3;
            }
          _block3__branch4: {}
            {
              if (_vt_item.symbol_at (0))
              {
                goto _block3__branch5;
              }
              Expr _v_deref__item6 (_vt_item, 0);
              uintptr_t _v_len29 = _v_deref__item6.get_len ();
              uintptr_t _v_len30 = 4;
              if (_v_len29 < _v_len30)
              {
                goto _block3__branch5;
              }
              uintptr_t _v_len__expr = (_v_len29 - _v_len30);
              if (!_v_deref__item6.symbol_at (0))
              {
                goto _block3__branch5;
              }
              if (!_c_7.term_eq (_v_deref__item6, (0 + 1)))
              {
                goto _block3__branch5;
              }
              Expr _vs_link (_v_deref__item6, 0, 1);
              Expr _vt_pragma (_v_deref__item6, (0 + 1 + 1), 1);
              Expr _vt_name (_v_deref__item6, (0 + 1 + 1 + 1), 1);
              Expr _ve_expr (_v_deref__item6, (0 + 1 + 1 + 1 + 1), _v_len__expr);
              Expr _ge_auxcall3;
              RF_CALL (Prepare_m_Const, _ve_expr, _ge_auxcall3);
              Expr _vt_const ((_c_21 + _vs_link + _vt_name + _ve_expr () + _ge_auxcall3) ());
              RF_CALL (Box::Put, (Declarations, _vt_const), /*void*/);
              {
                {
                  if (!_vs_link.term_eq (_c_18, 0))
                  {
                    goto _block10__branch1;
                  }
                  _ve_decl = (_c_22 + _vt_name) ();
                  _ge_item__3 = empty;
                  goto _block10;
                }
              _block10__branch1: {}
                _ve_decl = empty;
                _ge_item__3 = empty;
              }
            _block10: {}
              goto _block3;
            }
          _block3__branch5: {}
            {
              if (_vt_item.symbol_at (0))
              {
                goto _block3__branch6;
              }
              Expr _v_deref__item7 (_vt_item, 0);
              if (_v_deref__item7.get_len () != 4)
              {
                goto _block3__branch6;
              }
              if (!_c_18.term_eq (_v_deref__item7, 0))
              {
                goto _block3__branch6;
              }
              if (!_v_deref__item7.symbol_at ((0 + 1)))
              {
                goto _block3__branch6;
              }
              Expr _vs_tag (_v_deref__item7, (0 + 1), 1);
              Expr _vt_pragma (_v_deref__item7, (0 + 1 + 1), 1);
              Expr _vt_name (_v_deref__item7, (0 + 1 + 1 + 1), 1);
              RF_CALL (Box::Put, (Declarations, (_c_23 + _vs_tag + _vt_name) ()), /*void*/);
              _ve_decl = (_c_22 + _vt_name) ();
              _ge_item__3 = empty;
              goto _block3;
            }
          _block3__branch6: {}
            if (_vt_item.symbol_at (0))
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            Expr _v_deref__item8 (_vt_item, 0);
            if (_v_deref__item8.get_len () != 4)
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            if (!_c_24.term_eq (_v_deref__item8, 0))
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            if (!_v_deref__item8.symbol_at ((0 + 1)))
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            Expr _vs_tag (_v_deref__item8, (0 + 1), 1);
            Expr _vt_pragma (_v_deref__item8, (0 + 1 + 1), 1);
            Expr _vt_name (_v_deref__item8, (0 + 1 + 1 + 1), 1);
            RF_CALL (Box::Put, (Declarations, (_c_25 + _vs_tag + _vt_name) ()), /*void*/);
            _ve_decl = empty;
            _ge_item__3 = empty;
          }
        _block3: {}
          Expr _v_Compile1;
          RF_CALL (Compile, (_ve_targets, (_ve_headers + _ve_decl), _ve_rest), (_v_Compile1, _v_res2));
          _v_res1 = (_ge_item__3 + _v_Compile1);
          goto _exit1;
        }
    _continue1: {}
      }
    _exit1: {}
      goto _block1;
    }
  _block1__branch1: {}
    _v_res1 = empty;
    _v_res2 = _ve_headers;
  }
_block1: {}
RF_END

RF_FUNC (Comp_m_Func_m_Stubs, RF_VOID, (RF_RES _v_res1;;))
  Expr _ge_auxcall1;
  RF_CALL (Table::Domain, Stub_m_Funcs, _ge_auxcall1);
  if (!RF_CALL (List::Map, (_c_26, empty, _ge_auxcall1), _v_res1))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
RF_END

RF_FUNC (Gener_m_Stub, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  if (_ge_arg1.get_len () != 1)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (_ge_arg1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _v_deref__arg1 (_ge_arg1, 0);
  if (_v_deref__arg1.get_len () != 1)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _vt_name (_v_deref__arg1, 0, 1);
  Expr _v_Lookup1;
  if (!RF_CALL (Table::Lookup, (Stub_m_Funcs, _vt_name), _v_Lookup1))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (_v_Lookup1.get_len () != 4)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (_v_Lookup1.symbol_at ((0 + 1 + 1)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (_v_Lookup1.symbol_at ((0 + 1 + 1 + 1)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _v_deref__Lookup1 (_v_Lookup1, (0 + 1 + 1));
  Expr _v_deref__Lookup12 (_v_Lookup1, (0 + 1 + 1 + 1));
  uintptr_t _v_len1 = _v_deref__Lookup12.get_len ();
  uintptr_t _v_len2 = 0;
  if (_v_len1 < _v_len2)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len__Fout = (_v_len1 - _v_len2);
  uintptr_t _v_len3 = _v_deref__Lookup1.get_len ();
  uintptr_t _v_len4 = 0;
  if (_v_len3 < _v_len4)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len__Fin = (_v_len3 - _v_len4);
  if (!_v_Lookup1.symbol_at ((0 + 1)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _vt_stub_m_name (_v_Lookup1, 0, 1);
  Expr _vs_tag (_v_Lookup1, (0 + 1), 1);
  Expr _ve_Fin (_v_deref__Lookup1, 0, _v_len__Fin);
  Expr _ve_Fout (_v_deref__Lookup12, 0, _v_len__Fout);
  RF_CALL (Box::Put, (Declarations, (_c_17 + _vt_stub_m_name) ()), /*void*/);
  Expr _ve_He;
  RF_CALL (rfp__vars::Gener_m_Vars, (_ve_Fin, _c_27), _ve_He);
  RF_TAILCALL (Comp_m_Func, (_c_24, _c_28, _vt_stub_m_name, (_c_33 + (_c_29 + _ve_He) () + _c_32 + (_c_31 + (_c_30 + _vt_name + _ve_He) ()) ())), _v_res1);
RF_END

RF_FUNC (Comp_m_Func, (RF_ARG _gs_arg1, _gs_arg2, _gt_arg3, _ge_arg4;;), (RF_RES _v_res1;;))
  uintptr_t _v_len1 = (_ge_arg4.get_len () + 3);
  uintptr_t _v_len2 = 5;
  if (_v_len1 < _v_len2)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len__Sentence = (_v_len1 - _v_len2);
  Expr _v_compose1 ((_gs_arg1 + _gs_arg2 + _gt_arg3 + _ge_arg4));
  if (_v_compose1.symbol_at ((0 + 1 + 1 + 1)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (_v_compose1.symbol_at ((0 + 1 + 1 + 1 + 1)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _v_deref__compose1 (_v_compose1, (0 + 1 + 1 + 1));
  Expr _v_deref__compose12 (_v_compose1, (0 + 1 + 1 + 1 + 1));
  uintptr_t _v_len3 = _v_deref__compose12.get_len ();
  uintptr_t _v_len4 = 0;
  if (_v_len3 < _v_len4)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len__out = (_v_len3 - _v_len4);
  uintptr_t _v_len5 = _v_deref__compose1.get_len ();
  uintptr_t _v_len6 = 0;
  if (_v_len5 < _v_len6)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len__in = (_v_len5 - _v_len6);
  if (!_v_compose1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_v_compose1.symbol_at ((0 + 1)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _vs_linkage (_v_compose1, 0, 1);
  Expr _vs_tag (_v_compose1, (0 + 1), 1);
  Expr _vt_name (_v_compose1, (0 + 1 + 1), 1);
  Expr _ve_Sentence (_v_compose1, (0 + 1 + 1 + 1 + 1 + 1), _v_len__Sentence);
  Expr _ve_in (_v_deref__compose1, 0, _v_len__in);
  Expr _ve_out (_v_deref__compose12, 0, _v_len__out);
  RF_CALL (rfp__helper::RFP_m_Clear_m_Table, Labels, /*void*/);
  RF_CALL (rfp__helper::RFP_m_Clear_m_Table, Prep_m_Vars, /*void*/);
  RF_CALL (rfp__vars::Init_m_Vars, /*void*/, /*void*/);
  Expr _ge_auxcall1;
  RF_CALL (rfp__vars::Gener_m_Vars, (_ve_out, _c_34), _ge_auxcall1);
  Expr _ve_res_m_vars;
  RF_CALL (rfp__vars::Vars, _ge_auxcall1, _ve_res_m_vars);
  Expr _v_Vars_m_Decl1;
  RF_CALL (rfp__vars::Vars_m_Decl, (_c_35, _ve_res_m_vars), _v_Vars_m_Decl1);
  uintptr_t _v_len7 = _v_Vars_m_Decl1.get_len ();
  uintptr_t _v_len8 = 0;
  if (_v_len7 < _v_len8)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len___e__e_tmp_m_rfp__compilerf_m_214_m_36 = (_v_len7 - _v_len8);
  Expr _ve__e__e_tmp_m_rfp__compilerf_m_214_m_36 (_v_Vars_m_Decl1, 0, _v_len___e__e_tmp_m_rfp__compilerf_m_214_m_36);
  RF_CALL (Box::Store, (Res_m_Vars, _ve_res_m_vars), /*void*/);
  Expr _ge_auxcall2;
  RF_CALL (rfp__format::Format_m_Exp, _ve_out, _ge_auxcall2);
  RF_CALL (Box::Store, (Out_m_Format, _ge_auxcall2), /*void*/);
  Expr _v_Prepare_m_Res1;
  RF_CALL (Prepare_m_Res, _ve_in (), _v_Prepare_m_Res1);
  if (_v_Prepare_m_Res1.get_len () != 1)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (_v_Prepare_m_Res1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _v_deref__Prepare_m_Res1 (_v_Prepare_m_Res1, 0);
  uintptr_t _v_len9 = _v_deref__Prepare_m_Res1.get_len ();
  uintptr_t _v_len10 = 0;
  if (_v_len9 < _v_len10)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len__arg = (_v_len9 - _v_len10);
  Expr _ve_arg (_v_deref__Prepare_m_Res1, 0, _v_len__arg);
  Expr _ve_arg_m_vars;
  RF_CALL (rfp__vars::Vars, _ve_arg, _ve_arg_m_vars);
  Expr _v_Map1;
  if (!RF_CALL (List::Map, (_c_36, _c_37, _ve_arg_m_vars), _v_Map1))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len11 = _v_Map1.get_len ();
  uintptr_t _v_len12 = 0;
  if (_v_len11 < _v_len12)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len___e__e_tmp_m_rfp__compilerf_m_219_m_55 = (_v_len11 - _v_len12);
  Expr _ve__e__e_tmp_m_rfp__compilerf_m_219_m_55 (_v_Map1, 0, _v_len___e__e_tmp_m_rfp__compilerf_m_219_m_55);
  Expr _gs_tag__1;
  Expr _ve_fails;
  {
    {
      if (!_vs_tag.term_eq (_c_8, 0))
      {
        goto _block1__branch1;
      }
      _gs_tag__1 = _c_8;
      _ve_fails = _c_38;
      goto _block1;
    }
  _block1__branch1: {}
    {
      if (!_vs_tag.term_eq (_c_9, 0))
      {
        goto _block1__branch2;
      }
      _gs_tag__1 = _c_9;
      _ve_fails = _c_39;
      goto _block1;
    }
  _block1__branch2: {}
    {
      if (!_vs_tag.term_eq (_c_40, 0))
      {
        goto _block1__branch3;
      }
      _gs_tag__1 = _c_40;
      _ve_fails = _c_38;
      goto _block1;
    }
  _block1__branch3: {}
    if (!_vs_tag.term_eq (_c_28, 0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _v_Prepare_m_Res2;
    RF_CALL (Prepare_m_Res, _c_41, _v_Prepare_m_Res2);
    if (_v_Prepare_m_Res2.get_len () != 1)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    if (_v_Prepare_m_Res2.symbol_at (0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _v_deref__Prepare_m_Res2 (_v_Prepare_m_Res2, 0);
    uintptr_t _v_len13 = _v_deref__Prepare_m_Res2.get_len ();
    uintptr_t _v_len14 = 0;
    if (_v_len13 < _v_len14)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    uintptr_t _v_len__message = (_v_len13 - _v_len14);
    Expr _ve_message (_v_deref__Prepare_m_Res2, 0, _v_len__message);
    _gs_tag__1 = _c_9;
    _ve_fails = (_c_39 + (_c_42 + _ve_message) () ());
  }
_block1: {}
  Expr _ge_auxcall3;
  RF_CALL (rfp__vars::Vars_m_Print, _ve_arg_m_vars, _ge_auxcall3);
  Expr _ge_auxcall4;
  RF_CALL (rfp__vars::Vars_m_Print, _ve_res_m_vars, _ge_auxcall4);
  Expr _ge_auxcall5;
  RF_CALL (Comp_m_Sentence, (_c_43 + _ve_fails () + _ve_arg () + _ve_Sentence), _ge_auxcall5);
  Expr _ve_comp_m_func ((_gs_tag__1 + _vs_linkage + _vt_name + _ge_auxcall3 () + _ge_auxcall4 () + _ge_auxcall5) ());
  RF_CALL (rfp__vars::Gener_m_Var_m_Names, _ve_comp_m_func, _ve_comp_m_func);
  _v_res1 = _ve_comp_m_func;
RF_END

RF_FUNC (Set_m_Drops, (RF_ARG _ve_declared, _ve_comp_m_func;;), (RF_RES _v_res1, _v_res2;;))
  Expr _ge_comp_m_func__0 (_ve_comp_m_func);
  Expr _ve_result_m_func (empty);
  Expr _ge_declared__0 (_ve_declared);
  for ( ; ; )
  {
    {
      if (_ge_comp_m_func__0.get_len () != 0)
      {
        goto _iter1;
      }
      _v_res1 = _ge_declared__0;
      _v_res2 = _ve_result_m_func;
      goto _exit__iter1;
    }
  _iter1: {}
    uintptr_t _v_len1 = _ge_comp_m_func__0.get_len ();
    uintptr_t _v_len2 = 1;
    if (_v_len1 < _v_len2)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    uintptr_t _v_len__rest = (_v_len1 - _v_len2);
    Expr _vt_first (_ge_comp_m_func__0, 0, 1);
    Expr _ve_rest (_ge_comp_m_func__0, (0 + 1), _v_len__rest);
    {
      {
        Expr _ve_drop;
        Expr _ve_constr;
        Expr _vt_var;
        Expr _vs_init;
        {
          {
            if (_vt_first.symbol_at (0))
            {
              goto _block3__branch1;
            }
            Expr _v_deref__first (_vt_first, 0);
            uintptr_t _v_len3 = _v_deref__first.get_len ();
            uintptr_t _v_len4 = 2;
            if (_v_len3 < _v_len4)
            {
              goto _block3__branch1;
            }
            uintptr_t _v_len___e__e_tmp_m_rfp__compilerf_m_248_m_22 = (_v_len3 - _v_len4);
            if (!_c_44.term_eq (_v_deref__first, 0))
            {
              goto _block3__branch1;
            }
            Expr _gt_var__6 (_v_deref__first, (0 + 1), 1);
            Expr _ve__e__e_tmp_m_rfp__compilerf_m_248_m_22 (_v_deref__first, (0 + 1 + 1), _v_len___e__e_tmp_m_rfp__compilerf_m_248_m_22);
            _ve_drop = (_c_45 + _gt_var__6) ();
            _ve_constr = _vt_first;
            _vt_var = _gt_var__6;
            _vs_init = _c_46;
            goto _block3;
          }
        _block3__branch1: {}
          {
            if (_vt_first.symbol_at (0))
            {
              goto _block3__branch2;
            }
            Expr _v_deref__first2 (_vt_first, 0);
            uintptr_t _v_len5 = _v_deref__first2.get_len ();
            uintptr_t _v_len6 = 2;
            if (_v_len5 < _v_len6)
            {
              goto _block3__branch2;
            }
            uintptr_t _v_len___e__e_tmp_m_rfp__compilerf_m_249_m_23 = (_v_len5 - _v_len6);
            if (!_c_47.term_eq (_v_deref__first2, 0))
            {
              goto _block3__branch2;
            }
            Expr _gt_var__6 (_v_deref__first2, (0 + 1), 1);
            Expr _ve__e__e_tmp_m_rfp__compilerf_m_249_m_23 (_v_deref__first2, (0 + 1 + 1), _v_len___e__e_tmp_m_rfp__compilerf_m_249_m_23);
            _ve_drop = (_c_45 + _gt_var__6) ();
            _ve_constr = _vt_first;
            _vt_var = _gt_var__6;
            _vs_init = _c_46;
            goto _block3;
          }
        _block3__branch2: {}
          {
            if (_vt_first.symbol_at (0))
            {
              goto _block3__branch3;
            }
            Expr _v_deref__first3 (_vt_first, 0);
            uintptr_t _v_len7 = _v_deref__first3.get_len ();
            uintptr_t _v_len8 = 2;
            if (_v_len7 < _v_len8)
            {
              goto _block3__branch3;
            }
            uintptr_t _v_len___e__e_tmp_m_rfp__compilerf_m_250_m_25 = (_v_len7 - _v_len8);
            if (!_c_48.term_eq (_v_deref__first3, 0))
            {
              goto _block3__branch3;
            }
            Expr _gt_var__6 (_v_deref__first3, (0 + 1), 1);
            Expr _ve__e__e_tmp_m_rfp__compilerf_m_250_m_25 (_v_deref__first3, (0 + 1 + 1), _v_len___e__e_tmp_m_rfp__compilerf_m_250_m_25);
            _ve_drop = (_c_45 + _gt_var__6) ();
            _ve_constr = _vt_first;
            _vt_var = _gt_var__6;
            _vs_init = _c_46;
            goto _block3;
          }
        _block3__branch3: {}
          {
            if (_vt_first.symbol_at (0))
            {
              goto _block3__branch4;
            }
            Expr _v_deref__first4 (_vt_first, 0);
            if (_v_deref__first4.get_len () != 3)
            {
              goto _block3__branch4;
            }
            if (!_c_49.eq (_v_deref__first4, 0))
            {
              goto _block3__branch4;
            }
            Expr _gt_var__6 (_v_deref__first4, (0 + 1 + 1), 1);
            _ve_drop = (_c_45 + _gt_var__6) ();
            _ve_constr = empty;
            _vt_var = _gt_var__6;
            _vs_init = _c_50;
            goto _block3;
          }
        _block3__branch4: {}
          if (_vt_first.symbol_at (0))
          {
            goto _block2__branch1;
          }
          Expr _v_deref__first5 (_vt_first, 0);
          if (_v_deref__first5.get_len () != 3)
          {
            goto _block2__branch1;
          }
          if (!_c_51.eq (_v_deref__first5, 0))
          {
            goto _block2__branch1;
          }
          Expr _gt_var__6 (_v_deref__first5, (0 + 1 + 1), 1);
          _ve_drop = empty;
          _ve_constr = empty;
          _vt_var = _gt_var__6;
          _vs_init = _c_50;
        }
      _block3: {}
        {
          {
            if (_ge_declared__0.get_len () < 2)
            {
              goto _block4__branch1;
            }
            RF_lsplit (_ge_declared__0, 0, _ve_1, _v_lsplit__declared__0);
            for ( ; ; RF_iter(_ge_declared__0)++)
            {
              {
                if (!RF_iter(_ge_declared__0))
                {
                  goto _block4__branch1;
                }
                uintptr_t _v_len9 = _v_lsplit__declared__0.get_len ();
                uintptr_t _v_len10 = 2;
                if (_v_len9 < _v_len10)
                {
                  goto _block4__branch1;
                }
                uintptr_t _v_len__2 = (_v_len9 - _v_len10);
                if (!_vt_var.term_eq (_v_lsplit__declared__0, 0))
                {
                  goto _continue1;
                }
                if (!_v_lsplit__declared__0.symbol_at ((0 + 1)))
                {
                  goto _continue1;
                }
                Expr _vs_old_m_init (_v_lsplit__declared__0, (0 + 1), 1);
                Expr _ve_2 (_v_lsplit__declared__0, (0 + 1 + 1), _v_len__2);
                {
                  {
                    if (!_vs_old_m_init.term_eq (_c_46, 0))
                    {
                      goto _block5__branch1;
                    }
                    {
                      {
                        if (_vt_var.symbol_at (0))
                        {
                          goto _block6__branch1;
                        }
                        Expr _v_deref__var (_vt_var, 0);
                        if (_v_deref__var.get_len () != 2)
                        {
                          goto _block6__branch1;
                        }
                        if (_v_deref__var.symbol_at ((0 + 1)))
                        {
                          goto _block6__branch1;
                        }
                        Expr _v_deref__deref__var (_v_deref__var, (0 + 1));
                        uintptr_t _v_len11 = _v_deref__deref__var.get_len ();
                        uintptr_t _v_len12 = 1;
                        if (_v_len11 < _v_len12)
                        {
                          goto _block6__branch1;
                        }
                        uintptr_t _v_len___e__e_tmp_m_rfp__compilerf_m_257_m_38 = (_v_len11 - _v_len12);
                        if (!_c_53.term_eq (_v_deref__var, 0))
                        {
                          goto _block6__branch1;
                        }
                        if (!_c_52.term_eq (_v_deref__deref__var, 0))
                        {
                          goto _block6__branch1;
                        }
                        Expr _ve__e__e_tmp_m_rfp__compilerf_m_257_m_38 (_v_deref__deref__var, (0 + 1), _v_len___e__e_tmp_m_rfp__compilerf_m_257_m_38);
                        _ge_comp_m_func__0 = _ve_rest;
                        goto _block6;
                      }
                    _block6__branch1: {}
                      _ge_comp_m_func__0 = _ve_rest;
                      _ve_result_m_func = (_ve_result_m_func + _ve_drop + _ve_constr);
                    }
                  _block6: {}
                    goto _block5;
                  }
                _block5__branch1: {}
                  if (!_vs_old_m_init.term_eq (_c_50, 0))
                  {
                    RF_FUNC_ERROR (unexpected_fail);
                  }
                  {
                    {
                      if (!_vs_init.term_eq (_c_50, 0))
                      {
                        goto _block7__branch1;
                      }
                      _ge_comp_m_func__0 = _ve_rest;
                      goto _block7;
                    }
                  _block7__branch1: {}
                    if (!_vs_init.term_eq (_c_46, 0))
                    {
                      RF_FUNC_ERROR (unexpected_fail);
                    }
                    if (_vt_first.symbol_at (0))
                    {
                      RF_FUNC_ERROR (unexpected_fail);
                    }
                    Expr _v_deref__first6 (_vt_first, 0);
                    uintptr_t _v_len13 = _v_deref__first6.get_len ();
                    uintptr_t _v_len14 = 2;
                    if (_v_len13 < _v_len14)
                    {
                      RF_FUNC_ERROR (unexpected_fail);
                    }
                    uintptr_t _v_len__args = (_v_len13 - _v_len14);
                    if (!_v_deref__first6.symbol_at (0))
                    {
                      RF_FUNC_ERROR (unexpected_fail);
                    }
                    if (!_vt_var.term_eq (_v_deref__first6, (0 + 1)))
                    {
                      RF_FUNC_ERROR (unexpected_fail);
                    }
                    Expr _vs_method (_v_deref__first6, 0, 1);
                    Expr _ve_args (_v_deref__first6, (0 + 1 + 1), _v_len__args);
                    _ge_comp_m_func__0 = _ve_rest;
                    _ve_result_m_func = (_ve_result_m_func + (_c_54 + _vt_var + (_vs_method + _ve_args) ()) ());
                    _ge_declared__0 = (_ve_1 + _ve_2 + _vt_var + _vs_init);
                  }
                _block7: {}
                }
              _block5: {}
                goto _exit1;
              }
          _continue1: {}
            }
          _exit1: {}
            goto _block4;
          }
        _block4__branch1: {}
          _ge_comp_m_func__0 = _ve_rest;
          _ve_result_m_func = (_ve_result_m_func + _vt_first);
          _ge_declared__0 = (_ge_declared__0 + _vt_var + _vs_init);
        }
      _block4: {}
        goto _block2;
      }
    _block2__branch1: {}
      {
        if (_vt_first.symbol_at (0))
        {
          goto _block2__branch2;
        }
        Expr _v_deref__first7 (_vt_first, 0);
        uintptr_t _v_len15 = _v_deref__first7.get_len ();
        uintptr_t _v_len16 = 2;
        if (_v_len15 < _v_len16)
        {
          goto _block2__branch2;
        }
        uintptr_t _v_len__expr = (_v_len15 - _v_len16);
        if (_v_deref__first7.symbol_at ((0 + 1)))
        {
          goto _block2__branch2;
        }
        Expr _v_deref__deref__first7 (_v_deref__first7, (0 + 1));
        if (_v_deref__deref__first7.get_len () != 1)
        {
          goto _block2__branch2;
        }
        if (!_c_55.term_eq (_v_deref__first7, 0))
        {
          goto _block2__branch2;
        }
        Expr _ve_expr (_v_deref__first7, (0 + 1 + 1), _v_len__expr);
        Expr _vt_label (_v_deref__deref__first7, 0, 1);
        Expr _ge_declared__0__4;
        RF_CALL (Set_m_Drops, (_ge_declared__0, _ve_expr), (_ge_declared__0__4, _ve_expr));
        _ge_comp_m_func__0 = _ve_rest;
        _ve_result_m_func = (_ve_result_m_func + (_c_55 + _vt_label () + _ve_expr) ());
        _ge_declared__0 = _ge_declared__0__4;
        goto _block2;
      }
    _block2__branch2: {}
      {
        if (_vt_first.symbol_at (0))
        {
          goto _block2__branch3;
        }
        Expr _v_deref__first8 (_vt_first, 0);
        uintptr_t _v_len17 = _v_deref__first8.get_len ();
        uintptr_t _v_len18 = 0;
        if (_v_len17 < _v_len18)
        {
          goto _block2__branch3;
        }
        uintptr_t _v_len__expr2 = (_v_len17 - _v_len18);
        Expr _ve_expr (_v_deref__first8, 0, _v_len__expr2);
        Expr _v_Set_m_Drops1;
        RF_CALL (Set_m_Drops, (_ge_declared__0, _ve_expr), (_v_Set_m_Drops1, _ve_expr));
        Expr _vt__e__e_tmp_m_rfp__compilerf_m_279_m_45 (_v_Set_m_Drops1 ());
        _ge_comp_m_func__0 = _ve_rest;
        _ve_result_m_func = (_ve_result_m_func + _ve_expr ());
        goto _block2;
      }
    _block2__branch3: {}
      if (!_vt_first.symbol_at (0))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      Expr _vs_symbol (_vt_first, 0, 1);
      _ge_comp_m_func__0 = _ve_rest;
      _ve_result_m_func = (_ve_result_m_func + _vs_symbol);
    }
  _block2: {}
  }
_exit__iter1: {}
RF_END

RF_FUNC (Comp_m_Sentence, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  uintptr_t _v_len1 = _ge_arg1.get_len ();
  uintptr_t _v_len2 = 3;
  if (_v_len1 < _v_len2)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len__Sentence = (_v_len1 - _v_len2);
  if (_ge_arg1.symbol_at ((0 + 1)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (_ge_arg1.symbol_at ((0 + 1 + 1)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _v_deref__arg1 (_ge_arg1, (0 + 1));
  Expr _v_deref__arg12 (_ge_arg1, (0 + 1 + 1));
  uintptr_t _v_len3 = _v_deref__arg12.get_len ();
  uintptr_t _v_len4 = 0;
  if (_v_len3 < _v_len4)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len__last_m_Re = (_v_len3 - _v_len4);
  uintptr_t _v_len5 = _v_deref__arg1.get_len ();
  uintptr_t _v_len6 = 0;
  if (_v_len5 < (_v_len6 + 1))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len__fails = (_v_len5 - _v_len6);
  if (!_ge_arg1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _vs_tail_q_ (_ge_arg1, 0, 1);
  Expr _ve_Sentence (_ge_arg1, (0 + 1 + 1 + 1), _v_len__Sentence);
  Expr _vv_fails (_v_deref__arg1, 0, _v_len__fails);
  Expr _ve_last_m_Re (_v_deref__arg12, 0, _v_len__last_m_Re);
  {
    {
      if (_v_len__Sentence != 0)
      {
        goto _block1__branch1;
      }
      _v_res1 = empty;
      goto _block1;
    }
  _block1__branch1: {}
    {
      uintptr_t _v_len7 = _v_len__Sentence;
      uintptr_t _v_len8 = 1;
      if (_v_len7 < _v_len8)
      {
        goto _block1__branch2;
      }
      uintptr_t _v_len__Snt = (_v_len7 - _v_len8);
      if (_ve_Sentence.symbol_at (0))
      {
        goto _block1__branch2;
      }
      Expr _v_deref__Sentence (_ve_Sentence, 0);
      uintptr_t _v_len9 = _v_deref__Sentence.get_len ();
      uintptr_t _v_len10 = 1;
      if (_v_len9 < _v_len10)
      {
        goto _block1__branch2;
      }
      uintptr_t _v_len__Re = (_v_len9 - _v_len10);
      if (!_c_31.term_eq (_v_deref__Sentence, 0))
      {
        goto _block1__branch2;
      }
      Expr _ve_Snt (_ve_Sentence, (0 + 1), _v_len__Snt);
      Expr _ve_Re (_v_deref__Sentence, (0 + 1), _v_len__Re);
      {
        {
          if (_v_len__Snt != 0)
          {
            goto _block2__branch1;
          }
          if (_v_len__Re != 1)
          {
            goto _block2__branch1;
          }
          if (_ve_Re.symbol_at (0))
          {
            goto _block2__branch1;
          }
          Expr _v_deref__Re (_ve_Re, 0);
          uintptr_t _v_len11 = _v_deref__Re.get_len ();
          uintptr_t _v_len12 = 2;
          if (_v_len11 < _v_len12)
          {
            goto _block2__branch1;
          }
          uintptr_t _v_len__arg = (_v_len11 - _v_len12);
          if (!_vs_tail_q_.term_eq (_c_43, 0))
          {
            goto _block2__branch1;
          }
          if (!_c_30.term_eq (_v_deref__Re, 0))
          {
            goto _block2__branch1;
          }
          Expr _vt_name (_v_deref__Re, (0 + 1), 1);
          Expr _ve_arg (_v_deref__Re, (0 + 1 + 1), _v_len__arg);
          Expr _vs_tailcall;
          {
            {
              if (!RF_CALL (Table::In_m_Table_q_, (Fun_q_, _vt_name), /*void*/))
              {
                goto _block3__branch1;
              }
              if (_v_len__fails != 1)
              {
                goto _block2__branch1;
              }
              if (!_c_39.term_eq (_vv_fails, 0))
              {
                goto _block2__branch1;
              }
              _vs_tailcall = _c_56;
              goto _block3;
            }
          _block3__branch1: {}
            _vs_tailcall = _c_57;
          }
        _block3: {}
          Expr _vs_linkage;
          Expr _vs_tag;
          Expr _vt_pragma;
          Expr _ve_Fin;
          Expr _ve_Fout;
          if (!RF_CALL (Lookup_m_Func, _vt_name, (_vs_linkage, _vs_tag, _vt_pragma, _ve_Fin, _ve_Fout)))
          {
            goto _block2__branch1;
          }
          Expr _ge_auxcall1;
          RF_CALL (Box::_q_, Out_m_Format, _ge_auxcall1);
          if (!RF_CALL (rfp__format::Subformat_q_, (_ve_Fout, _ge_auxcall1), /*void*/))
          {
            goto _block2__branch1;
          }
          Expr _ge_last_m_Re__5;
          Expr _ve_calls;
          RF_CALL (Extract_m_Calls, _ve_arg, (_ge_last_m_Re__5, _ve_calls));
          Expr _ge_auxcall2;
          RF_CALL (rfp__format::Split_m_Re, (_ve_Fin, _ge_last_m_Re__5), _ge_auxcall2);
          Expr _ve_splited_m_Re;
          RF_CALL (Prepare_m_Res, _ge_auxcall2, _ve_splited_m_Re);
          Expr _gt_auxcall3;
          if (!RF_CALL (Access::R, (_c_58, _vv_fails), _gt_auxcall3))
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          Expr _ge_auxcall4;
          RF_CALL (Comp_m_Calls, (_gt_auxcall3 + _ve_calls), _ge_auxcall4);
          Expr _ge_auxcall5;
          RF_CALL (Box::_q_, Res_m_Vars, _ge_auxcall5);
          _v_res1 = (_ge_auxcall4 + (_vs_tailcall + _vt_name + _ve_splited_m_Re () + _ge_auxcall5 ()) ());
          goto _block2;
        }
      _block2__branch1: {}
        Expr _ge_last_m_Re__4;
        Expr _ve_calls;
        RF_CALL (Extract_m_Calls, _ve_Re, (_ge_last_m_Re__4, _ve_calls));
        Expr _gt_auxcall6;
        if (!RF_CALL (Access::R, (_c_58, _vv_fails), _gt_auxcall6))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        Expr _ve_comp_m_calls;
        RF_CALL (Comp_m_Calls, (_gt_auxcall6 + _ve_calls), _ve_comp_m_calls);
        {
          {
            if (_v_len__Snt != 0)
            {
              goto _block4__branch1;
            }
            RF_lsplit (_c_59, 0, _ve__e__e_tmp_m_rfp__compilerf_m_330_m_51, _v_lsplit__59);
            for ( ; ; RF_iter(_c_59)++)
            {
              {
                if (!RF_iter(_c_59))
                {
                  goto _block4__branch1;
                }
                uintptr_t _v_len13 = _v_lsplit__59.get_len ();
                uintptr_t _v_len14 = 1;
                if (_v_len13 < _v_len14)
                {
                  goto _block4__branch1;
                }
                uintptr_t _v_len___e__e_tmp_m_rfp__compilerf_m_330_m_61 = (_v_len13 - _v_len14);
                if (!_vs_tail_q_.term_eq (_v_lsplit__59, 0))
                {
                  goto _continue1;
                }
                Expr _ve__e__e_tmp_m_rfp__compilerf_m_330_m_61 (_v_lsplit__59, (0 + 1), _v_len___e__e_tmp_m_rfp__compilerf_m_330_m_61);
                Expr _ge_auxcall7;
                RF_CALL (Box::_q_, Out_m_Format, _ge_auxcall7);
                Expr _ve_splited_m_Re;
                RF_CALL (rfp__format::Split_m_Re, (_ge_auxcall7, _ge_last_m_Re__4), _ve_splited_m_Re);
                RF_CALL (Prepare_m_Res, _ve_splited_m_Re, _ve_splited_m_Re);
                Expr _ge_auxcall8;
                RF_CALL (Box::_q_, Res_m_Vars, _ge_auxcall8);
                Expr _ge_auxcall9;
                RF_CALL (List::Zip, (_ge_auxcall8, _ve_splited_m_Re), _ge_auxcall9);
                Expr _v_Comp_m_Assigns1;
                RF_CALL (Comp_m_Assigns, _ge_auxcall9, _v_Comp_m_Assigns1);
                _v_res1 = (_ve_comp_m_calls + _v_Comp_m_Assigns1);
                goto _exit1;
              }
          _continue1: {}
            }
          _exit1: {}
            goto _block4;
          }
        _block4__branch1: {}
          Expr _v_Comp_m_Sentence1;
          RF_CALL (Comp_m_Sentence, (_vs_tail_q_ + _vv_fails () + _ge_last_m_Re__4 () + _ve_Snt), _v_Comp_m_Sentence1);
          _v_res1 = (_ve_comp_m_calls + _v_Comp_m_Sentence1);
        }
      _block4: {}
      }
    _block2: {}
      goto _block1;
    }
  _block1__branch2: {}
    {
      uintptr_t _v_len15 = _v_len__Sentence;
      uintptr_t _v_len16 = 1;
      if (_v_len15 < _v_len16)
      {
        goto _block1__branch3;
      }
      uintptr_t _v_len__Snt2 = (_v_len15 - _v_len16);
      if (_ve_Sentence.symbol_at (0))
      {
        goto _block1__branch3;
      }
      Expr _v_deref__Sentence2 (_ve_Sentence, 0);
      uintptr_t _v_len17 = _v_deref__Sentence2.get_len ();
      uintptr_t _v_len18 = 1;
      if (_v_len17 < _v_len18)
      {
        goto _block1__branch3;
      }
      uintptr_t _v_len__He = (_v_len17 - _v_len18);
      if (!_c_60.term_eq (_v_deref__Sentence2, 0))
      {
        goto _block1__branch3;
      }
      Expr _ve_Snt (_ve_Sentence, (0 + 1), _v_len__Snt2);
      Expr _ve_He (_v_deref__Sentence2, (0 + 1), _v_len__He);
      Expr _ge_auxcall10;
      RF_CALL (Comp_m_Format, (_ve_last_m_Re, _ve_He), _ge_auxcall10);
      Expr _v_Comp_m_Sentence2;
      RF_CALL (Comp_m_Sentence, (_vs_tail_q_ + _vv_fails () + _c_61 + _ve_Snt), _v_Comp_m_Sentence2);
      _v_res1 = (_ge_auxcall10 + _v_Comp_m_Sentence2);
      goto _block1;
    }
  _block1__branch3: {}
    {
      uintptr_t _v_len19 = _v_len__Sentence;
      uintptr_t _v_len20 = 1;
      if (_v_len19 < _v_len20)
      {
        goto _block1__branch4;
      }
      uintptr_t _v_len__Snt3 = (_v_len19 - _v_len20);
      if (_ve_Sentence.symbol_at (0))
      {
        goto _block1__branch4;
      }
      Expr _v_deref__Sentence3 (_ve_Sentence, 0);
      uintptr_t _v_len21 = _v_deref__Sentence3.get_len ();
      uintptr_t _v_len22 = 1;
      if (_v_len21 < _v_len22)
      {
        goto _block1__branch4;
      }
      uintptr_t _v_len__Pattern = (_v_len21 - _v_len22);
      if (!_v_deref__Sentence3.symbol_at (0))
      {
        goto _block1__branch4;
      }
      Expr _ve_Snt (_ve_Sentence, (0 + 1), _v_len__Snt3);
      Expr _vs_dir (_v_deref__Sentence3, 0, 1);
      Expr _ve_Pattern (_v_deref__Sentence3, (0 + 1), _v_len__Pattern);
      {
        {
          if (!_vs_dir.term_eq (_c_29, 0))
          {
            goto _block5__branch1;
          }
          goto _block5;
        }
      _block5__branch1: {}
        if (!_vs_dir.term_eq (_c_62, 0))
        {
          goto _block1__branch4;
        }
      }
    _block5: {}
      Expr _ve_clashes;
      Expr _ge_Sentence__2;
      RF_CALL (Get_m_Clash_m_Sequence, (_ve_last_m_Re, _ve_Sentence), (_ve_clashes, _ge_Sentence__2));
      RF_TAILCALL (Comp_m_Clashes, (_ve_clashes, _vs_tail_q_, _vv_fails, _ge_Sentence__2), _v_res1);
      goto _block1;
    }
  _block1__branch4: {}
    {
      uintptr_t _v_len23 = _v_len__Sentence;
      uintptr_t _v_len24 = 1;
      if (_v_len23 < _v_len24)
      {
        goto _block1__branch5;
      }
      uintptr_t _v_len___e__e_tmp_m_rfp__compilerf_m_356_m_14 = (_v_len23 - _v_len24);
      if (_ve_Sentence.symbol_at (0))
      {
        goto _block1__branch5;
      }
      Expr _v_deref__Sentence4 (_ve_Sentence, 0);
      if (_v_deref__Sentence4.get_len () != 1)
      {
        goto _block1__branch5;
      }
      if (!_v_deref__Sentence4.symbol_at (0))
      {
        goto _block1__branch5;
      }
      Expr _ve__e__e_tmp_m_rfp__compilerf_m_356_m_14 (_ve_Sentence, (0 + 1), _v_len___e__e_tmp_m_rfp__compilerf_m_356_m_14);
      Expr _vs_block (_v_deref__Sentence4, 0, 1);
      RF_lsplit (_c_63, 0, _ve__e__e_tmp_m_rfp__compilerf_m_356_m_32, _v_lsplit__63);
      for ( ; ; RF_iter(_c_63)++)
      {
        {
          if (!RF_iter(_c_63))
          {
            goto _block1__branch5;
          }
          uintptr_t _v_len25 = _v_lsplit__63.get_len ();
          uintptr_t _v_len26 = 1;
          if (_v_len25 < _v_len26)
          {
            goto _block1__branch5;
          }
          uintptr_t _v_len___e__e_tmp_m_rfp__compilerf_m_356_m_42 = (_v_len25 - _v_len26);
          if (!_vs_block.term_eq (_v_lsplit__63, 0))
          {
            goto _continue2;
          }
          Expr _ve__e__e_tmp_m_rfp__compilerf_m_356_m_42 (_v_lsplit__63, (0 + 1), _v_len___e__e_tmp_m_rfp__compilerf_m_356_m_42);
          RF_CALL (StdIO::WriteLN_e_, (StdIO::StdErr, _c_64), /*void*/);
          RF_FUNC_ERROR (unexpected_fail);
        }
    _continue2: {}
      }
    _exit2: {}
    }
  _block1__branch5: {}
    {
      uintptr_t _v_len27 = _v_len__Sentence;
      uintptr_t _v_len28 = 1;
      if (_v_len27 < _v_len28)
      {
        goto _block1__branch6;
      }
      uintptr_t _v_len__Snt4 = (_v_len27 - _v_len28);
      if (_ve_Sentence.symbol_at (0))
      {
        goto _block1__branch6;
      }
      Expr _v_deref__Sentence5 (_ve_Sentence, 0);
      uintptr_t _v_len29 = _v_deref__Sentence5.get_len ();
      uintptr_t _v_len30 = 1;
      if (_v_len29 < _v_len30)
      {
        goto _block1__branch6;
      }
      uintptr_t _v_len__branches = (_v_len29 - _v_len30);
      if (!_v_deref__Sentence5.symbol_at (0))
      {
        goto _block1__branch6;
      }
      Expr _ve_Snt (_ve_Sentence, (0 + 1), _v_len__Snt4);
      Expr _vs_block (_v_deref__Sentence5, 0, 1);
      Expr _ve_branches (_v_deref__Sentence5, (0 + 1), _v_len__branches);
      Expr _ve_fatal_q_;
      {
        {
          if (!_vs_block.term_eq (_c_65, 0))
          {
            goto _block6__branch1;
          }
          _ve_fatal_q_ = _c_38;
          goto _block6;
        }
      _block6__branch1: {}
        if (!_vs_block.term_eq (_c_66, 0))
        {
          goto _block1__branch6;
        }
        _ve_fatal_q_ = empty;
      }
    _block6: {}
      Expr _ge_Snt__4;
      {
        {
          uintptr_t _v_len31 = _v_len__Snt4;
          uintptr_t _v_len32 = 1;
          if (_v_len31 < _v_len32)
          {
            goto _block7__branch1;
          }
          uintptr_t _v_len__rest = (_v_len31 - _v_len32);
          if (_ve_Snt.symbol_at (0))
          {
            goto _block7__branch1;
          }
          Expr _v_deref__Snt (_ve_Snt, 0);
          if (_v_deref__Snt.get_len () != 4)
          {
            goto _block7__branch1;
          }
          if (!_c_67.term_eq (_v_deref__Snt, 0))
          {
            goto _block7__branch1;
          }
          Expr _ve_rest (_ve_Snt, (0 + 1), _v_len__rest);
          Expr _vt_body (_v_deref__Snt, (0 + 1), 1);
          Expr _vt_format (_v_deref__Snt, (0 + 1 + 1), 1);
          Expr _vt_cond (_v_deref__Snt, (0 + 1 + 1 + 1), 1);
          _ge_Snt__4 = (_vt_format + (_c_68 + _vt_body + _vt_format + _vt_cond) () + _ve_rest);
          goto _block7;
        }
      _block7__branch1: {}
        _ge_Snt__4 = _ve_Snt;
      }
    _block7: {}
      Expr _ve_out_m_vars;
      Expr _ve_next_m_terms;
      Expr _ve_source_q_;
      Expr _ge_Snt__4__5;
      {
        {
          uintptr_t _v_len33 = _ge_Snt__4.get_len ();
          uintptr_t _v_len34 = 1;
          if (_v_len33 < _v_len34)
          {
            goto _block8__branch1;
          }
          uintptr_t _v_len__rest2 = (_v_len33 - _v_len34);
          if (_ge_Snt__4.symbol_at (0))
          {
            goto _block8__branch1;
          }
          Expr _v_deref__Snt__4 (_ge_Snt__4, 0);
          uintptr_t _v_len35 = _v_deref__Snt__4.get_len ();
          uintptr_t _v_len36 = 1;
          if (_v_len35 < _v_len36)
          {
            goto _block8__branch1;
          }
          uintptr_t _v_len__format = (_v_len35 - _v_len36);
          if (!_c_60.term_eq (_v_deref__Snt__4, 0))
          {
            goto _block8__branch1;
          }
          Expr _ve_rest (_ge_Snt__4, (0 + 1), _v_len__rest2);
          Expr _ve_format (_v_deref__Snt__4, (0 + 1), _v_len__format);
          Expr _ge_auxcall11;
          RF_CALL (rfp__vars::Vars, _ve_format, _ge_auxcall11);
          Expr _ve_vars;
          RF_CALL (Prepare_m_Vars, _ge_auxcall11, _ve_vars);
          _ve_out_m_vars = _ve_vars;
          _ve_next_m_terms = (_c_69 + (_c_60 + _ve_format) ());
          _ve_source_q_ = _c_70;
          _ge_Snt__4__5 = _ve_rest;
          goto _block8;
        }
      _block8__branch1: {}
        {
          uintptr_t _v_len37 = _ge_Snt__4.get_len ();
          uintptr_t _v_len38 = 1;
          if (_v_len37 < _v_len38)
          {
            goto _block8__branch2;
          }
          uintptr_t _v_len__rest3 = (_v_len37 - _v_len38);
          if (!_c_71.term_eq (_ge_Snt__4, 0))
          {
            goto _block8__branch2;
          }
          Expr _ve_rest (_ge_Snt__4, (0 + 1), _v_len__rest3);
          _ve_out_m_vars = empty;
          _ve_next_m_terms = _c_71;
          _ve_source_q_ = empty;
          _ge_Snt__4__5 = empty;
          goto _block8;
        }
      _block8__branch2: {}
        {
          uintptr_t _v_len39 = _ge_Snt__4.get_len ();
          uintptr_t _v_len40 = 1;
          if (_v_len39 < _v_len40)
          {
            goto _block8__branch3;
          }
          uintptr_t _v_len__rest4 = (_v_len39 - _v_len40);
          if (!_c_69.term_eq (_ge_Snt__4, 0))
          {
            goto _block8__branch3;
          }
          Expr _ve_rest (_ge_Snt__4, (0 + 1), _v_len__rest4);
          _ve_out_m_vars = empty;
          _ve_next_m_terms = _ge_Snt__4;
          _ve_source_q_ = empty;
          _ge_Snt__4__5 = empty;
          goto _block8;
        }
      _block8__branch3: {}
        uintptr_t _v_len41 = _ge_Snt__4.get_len ();
        uintptr_t _v_len42 = 0;
        if (_v_len41 < _v_len42)
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        uintptr_t _v_len___e__e_tmp_m_rfp__compilerf_m_400_m_8 = (_v_len41 - _v_len42);
        Expr _ve__e__e_tmp_m_rfp__compilerf_m_400_m_8 (_ge_Snt__4, 0, _v_len___e__e_tmp_m_rfp__compilerf_m_400_m_8);
        _ve_out_m_vars = empty;
        _ve_next_m_terms = empty;
        _ve_source_q_ = empty;
        _ge_Snt__4__5 = _ge_Snt__4;
      }
    _block8: {}
      Expr _ge_source_q___6;
      Expr _vs_tail_m_branch_q_;
      {
        {
          {
            {
              uintptr_t _v_len43 = _ve_source_q_.get_len ();
              uintptr_t _v_len44 = 0;
              if (_v_len43 < (_v_len44 + 1))
              {
                goto _block10__branch1;
              }
              uintptr_t _v_len___e__e_tmp_m_rfp__compilerf_m_409_m_23 = (_v_len43 - _v_len44);
              Expr _vv__e__e_tmp_m_rfp__compilerf_m_409_m_23 (_ve_source_q_, 0, _v_len___e__e_tmp_m_rfp__compilerf_m_409_m_23);
              goto _block10;
            }
          _block10__branch1: {}
            uintptr_t _v_len45 = _ge_Snt__4__5.get_len ();
            uintptr_t _v_len46 = 0;
            if (_v_len45 < (_v_len46 + 1))
            {
              goto _block9__branch1;
            }
            uintptr_t _v_len___e__e_tmp_m_rfp__compilerf_m_409_m_34 = (_v_len45 - _v_len46);
            Expr _vv__e__e_tmp_m_rfp__compilerf_m_409_m_34 (_ge_Snt__4__5, 0, _v_len___e__e_tmp_m_rfp__compilerf_m_409_m_34);
          }
        _block10: {}
          Expr _gt_auxcall12;
          if (!RF_CALL (Access::R, (_c_58, _vv_fails), _gt_auxcall12))
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          _ge_source_q___6 = (_c_70 + _gt_auxcall12);
          _vs_tail_m_branch_q_ = _c_72;
          goto _block9;
        }
      _block9__branch1: {}
        _ge_source_q___6 = empty;
        _vs_tail_m_branch_q_ = _vs_tail_q_;
      }
    _block9: {}
      Expr _vv_branch_m_fails ((_vv_fails + _ge_source_q___6 + _ve_fatal_q_));
      Expr _ve_decls;
      RF_CALL (rfp__vars::Vars_m_Decl, (_c_73, _ve_out_m_vars), _ve_decls);
      Expr _vt_label;
      RF_CALL (Gener_m_Label, _c_74, _vt_label);
      RF_CALL (Save_m_Snt_m_State, /*void*/, /*void*/);
      Expr _ge_branches__6 (_ve_branches);
      Expr _ve_comp_m_branches (empty);
      for ( ; ; )
      {
        {
          if (_ge_branches__6.get_len () != 1)
          {
            goto _iter1;
          }
          if (_ge_branches__6.symbol_at (0))
          {
            goto _iter1;
          }
          Expr _v_deref__branches__6 (_ge_branches__6, 0);
          uintptr_t _v_len47 = _v_deref__branches__6.get_len ();
          uintptr_t _v_len48 = 1;
          if (_v_len47 < _v_len48)
          {
            goto _iter1;
          }
          uintptr_t _v_len__branch = (_v_len47 - _v_len48);
          if (!_c_19.term_eq (_v_deref__branches__6, 0))
          {
            goto _iter1;
          }
          Expr _ve_branch (_v_deref__branches__6, (0 + 1), _v_len__branch);
          Expr _ve_last_m_branch;
          RF_CALL (Comp_m_Sentence, (_vs_tail_m_branch_q_ + _vv_branch_m_fails () + _ve_last_m_Re () + _ve_branch + _ve_next_m_terms), _ve_last_m_branch);
          RF_CALL (Pop_m_Snt_m_State, /*void*/, /*void*/);
          RF_CALL (rfp__vars::Vars_m_Reset, _ve_out_m_vars, /*void*/);
          Expr _v_Comp_m_Sentence3;
          RF_CALL (Comp_m_Sentence, (_vs_tail_q_ + _vv_fails () + _c_61 + _ge_Snt__4__5), _v_Comp_m_Sentence3);
          _v_res1 = (_ve_decls + (_c_55 + _vt_label () + _ve_comp_m_branches + _ve_last_m_branch) () + _v_Comp_m_Sentence3);
          goto _exit__iter1;
        }
      _iter1: {}
        uintptr_t _v_len49 = _ge_branches__6.get_len ();
        uintptr_t _v_len50 = 1;
        if (_v_len49 < _v_len50)
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        uintptr_t _v_len__rest_m_br = (_v_len49 - _v_len50);
        if (_ge_branches__6.symbol_at (0))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        Expr _v_deref__branches__62 (_ge_branches__6, 0);
        uintptr_t _v_len51 = _v_deref__branches__62.get_len ();
        uintptr_t _v_len52 = 1;
        if (_v_len51 < _v_len52)
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        uintptr_t _v_len__branch2 = (_v_len51 - _v_len52);
        if (!_c_19.term_eq (_v_deref__branches__62, 0))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        Expr _ve_rest_m_br (_ge_branches__6, (0 + 1), _v_len__rest_m_br);
        Expr _ve_branch (_v_deref__branches__62, (0 + 1), _v_len__branch2);
        Expr _vt_br_m_label;
        RF_CALL (Add_m_To_m_Label, (_vt_label, _c_75), _vt_br_m_label);
        Expr _ve_comp_m_br;
        RF_CALL (Comp_m_Sentence, (_vs_tail_m_branch_q_ + (_vv_branch_m_fails + (_c_76 + _vt_br_m_label) () ()) () + _ve_last_m_Re () + _ve_branch + _ve_next_m_terms), _ve_comp_m_br);
        RF_CALL (Recall_m_Snt_m_State, /*void*/, /*void*/);
        _ge_branches__6 = _ve_rest_m_br;
        _ve_comp_m_branches = (_ve_comp_m_branches + (_c_55 + _vt_br_m_label () + _ve_comp_m_br + (_c_76 + _vt_label) ()) ());
      }
    _exit__iter1: {}
      goto _block1;
    }
  _block1__branch6: {}
    {
      uintptr_t _v_len53 = _v_len__Sentence;
      uintptr_t _v_len54 = 1;
      if (_v_len53 < _v_len54)
      {
        goto _block1__branch7;
      }
      uintptr_t _v_len__Snt5 = (_v_len53 - _v_len54);
      if (_ve_Sentence.symbol_at (0))
      {
        goto _block1__branch7;
      }
      Expr _v_deref__Sentence6 (_ve_Sentence, 0);
      if (_v_deref__Sentence6.get_len () != 4)
      {
        goto _block1__branch7;
      }
      if (!_c_67.term_eq (_v_deref__Sentence6, 0))
      {
        goto _block1__branch7;
      }
      Expr _ve_Snt (_ve_Sentence, (0 + 1), _v_len__Snt5);
      Expr _vt_body (_v_deref__Sentence6, (0 + 1), 1);
      Expr _vt_format (_v_deref__Sentence6, (0 + 1 + 1), 1);
      Expr _vt_cond (_v_deref__Sentence6, (0 + 1 + 1 + 1), 1);
      RF_TAILCALL (Comp_m_Sentence, (_vs_tail_q_ + _vv_fails () + _ve_last_m_Re () + _vt_format + (_c_68 + _vt_body + _vt_format + _vt_cond) () + _ve_Snt), _v_res1);
      goto _block1;
    }
  _block1__branch7: {}
    {
      uintptr_t _v_len55 = _v_len__Sentence;
      uintptr_t _v_len56 = 1;
      if (_v_len55 < _v_len56)
      {
        goto _block1__branch8;
      }
      uintptr_t _v_len__Snt6 = (_v_len55 - _v_len56);
      if (_ve_Sentence.symbol_at (0))
      {
        goto _block1__branch8;
      }
      Expr _v_deref__Sentence7 (_ve_Sentence, 0);
      if (_v_deref__Sentence7.get_len () != 5)
      {
        goto _block1__branch8;
      }
      if (_v_deref__Sentence7.symbol_at ((0 + 1 + 1)))
      {
        goto _block1__branch8;
      }
      if (_v_deref__Sentence7.symbol_at ((0 + 1 + 1 + 1 + 1)))
      {
        goto _block1__branch8;
      }
      Expr _v_deref__deref__Sentence7 (_v_deref__Sentence7, (0 + 1 + 1));
      Expr _v_deref__deref__Sentence72 (_v_deref__Sentence7, (0 + 1 + 1 + 1 + 1));
      uintptr_t _v_len57 = _v_deref__deref__Sentence72.get_len ();
      uintptr_t _v_len58 = 1;
      if (_v_len57 < _v_len58)
      {
        goto _block1__branch8;
      }
      uintptr_t _v_len__condition = (_v_len57 - _v_len58);
      uintptr_t _v_len59 = _v_deref__deref__Sentence7.get_len ();
      uintptr_t _v_len60 = 1;
      if (_v_len59 < _v_len60)
      {
        goto _block1__branch8;
      }
      uintptr_t _v_len__body = (_v_len59 - _v_len60);
      if (!_c_68.eq (_v_deref__Sentence7, 0))
      {
        goto _block1__branch8;
      }
      if (!_c_19.term_eq (_v_deref__deref__Sentence7, 0))
      {
        goto _block1__branch8;
      }
      if (!_c_19.term_eq (_v_deref__deref__Sentence72, 0))
      {
        goto _block1__branch8;
      }
      Expr _ve_Snt (_ve_Sentence, (0 + 1), _v_len__Snt6);
      Expr _vt_format (_v_deref__Sentence7, (0 + 1 + 1 + 1), 1);
      Expr _ve_body (_v_deref__deref__Sentence7, (0 + 1), _v_len__body);
      Expr _ve_condition (_v_deref__deref__Sentence72, (0 + 1), _v_len__condition);
      if (_vt_format.symbol_at (0))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      Expr _v_deref__format (_vt_format, 0);
      uintptr_t _v_len61 = _v_deref__format.get_len ();
      uintptr_t _v_len62 = 1;
      if (_v_len61 < _v_len62)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      uintptr_t _v_len__Fe = (_v_len61 - _v_len62);
      if (!_c_60.term_eq (_v_deref__format, 0))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      Expr _ve_Fe (_v_deref__format, (0 + 1), _v_len__Fe);
      Expr _ge_auxcall13;
      RF_CALL (rfp__vars::Vars, _ve_Fe, _ge_auxcall13);
      Expr _ge_auxcall14;
      RF_CALL (Prepare_m_Vars, _ge_auxcall13, _ge_auxcall14);
      RF_CALL (rfp__vars::Vars_m_Reset, _ge_auxcall14, /*void*/);
      RF_CALL (Save_m_Snt_m_State, /*void*/, /*void*/);
      Expr _vt_label;
      RF_CALL (Gener_m_Label, _c_77, _vt_label);
      Expr _vt_exit;
      RF_CALL (Gener_m_Label, _c_78, _vt_exit);
      Expr _ve_comp_m_condition;
      RF_CALL (Comp_m_Sentence, (_vs_tail_q_ + (_vv_fails + (_c_76 + _vt_label) () ()) () + _c_61 + _ve_condition + _ve_Snt), _ve_comp_m_condition);
      RF_CALL (Pop_m_Snt_m_State, /*void*/, /*void*/);
      Expr _ve_comp_m_body;
      RF_CALL (Comp_m_Sentence, (_c_72 + _vv_fails () + _c_61 + _ve_body + _vt_format), _ve_comp_m_body);
      _v_res1 = (_c_80 + _vt_exit () + _c_79 + (_c_55 + _vt_label () + _ve_comp_m_condition + (_c_76 + _vt_exit) ()) () + _ve_comp_m_body) ();
      goto _block1;
    }
  _block1__branch8: {}
    {
      uintptr_t _v_len63 = _v_len__Sentence;
      uintptr_t _v_len64 = 1;
      if (_v_len63 < _v_len64)
      {
        goto _block1__branch9;
      }
      uintptr_t _v_len__Snt7 = (_v_len63 - _v_len64);
      if (_ve_Sentence.symbol_at (0))
      {
        goto _block1__branch9;
      }
      Expr _v_deref__Sentence8 (_ve_Sentence, 0);
      uintptr_t _v_len65 = _v_deref__Sentence8.get_len ();
      uintptr_t _v_len66 = 2;
      if (_v_len65 < _v_len66)
      {
        goto _block1__branch9;
      }
      uintptr_t _v_len__catch = (_v_len65 - _v_len66);
      if (_v_deref__Sentence8.symbol_at ((0 + 1)))
      {
        goto _block1__branch9;
      }
      Expr _v_deref__deref__Sentence8 (_v_deref__Sentence8, (0 + 1));
      uintptr_t _v_len67 = _v_deref__deref__Sentence8.get_len ();
      uintptr_t _v_len68 = 1;
      if (_v_len67 < _v_len68)
      {
        goto _block1__branch9;
      }
      uintptr_t _v_len__try = (_v_len67 - _v_len68);
      if (!_c_81.term_eq (_v_deref__Sentence8, 0))
      {
        goto _block1__branch9;
      }
      if (!_c_19.term_eq (_v_deref__deref__Sentence8, 0))
      {
        goto _block1__branch9;
      }
      Expr _ve_Snt (_ve_Sentence, (0 + 1), _v_len__Snt7);
      Expr _ve_catch (_v_deref__Sentence8, (0 + 1 + 1), _v_len__catch);
      Expr _ve_try (_v_deref__deref__Sentence8, (0 + 1), _v_len__try);
      RF_CALL (Save_m_Snt_m_State, /*void*/, /*void*/);
      Expr _vs_tail_m_in_m_trap_q_;
      {
        {
          if (!_vs_tail_q_.term_eq (_c_43, 0))
          {
            goto _block12__branch1;
          }
          _vs_tail_m_in_m_trap_q_ = _c_82;
          goto _block12;
        }
      _block12__branch1: {}
        _vs_tail_m_in_m_trap_q_ = _vs_tail_q_;
      }
    _block12: {}
      Expr _ve_comp_m_try;
      RF_CALL (Comp_m_Sentence, (_vs_tail_m_in_m_trap_q_ + _c_83 + _ve_try + _ve_Snt), _ve_comp_m_try);
      RF_CALL (Pop_m_Snt_m_State, /*void*/, /*void*/);
      Expr _vt_var;
      RF_CALL (rfp__vars::Gener_m_Err_m_Var, /*void*/, _vt_var);
      RF_CALL (rfp__vars::Set_m_Var, (_c_37, _vt_var), /*void*/);
      Expr _ve_comp_m_catch;
      RF_CALL (Comp_m_Sentence, (_vs_tail_q_ + _vv_fails () + _vt_var () + _ve_catch + _ve_Snt), _ve_comp_m_catch);
      _v_res1 = ((_c_81 + _ve_comp_m_try) () + (_c_84 + _ve_comp_m_catch) ());
      goto _block1;
    }
  _block1__branch9: {}
    {
      uintptr_t _v_len69 = _v_len__Sentence;
      uintptr_t _v_len70 = 1;
      if (_v_len69 < _v_len70)
      {
        goto _block1__branch10;
      }
      uintptr_t _v_len__Snt8 = (_v_len69 - _v_len70);
      if (!_c_85.term_eq (_ve_Sentence, 0))
      {
        goto _block1__branch10;
      }
      Expr _ve_Snt (_ve_Sentence, (0 + 1), _v_len__Snt8);
      Expr _gt_auxcall15;
      if (!RF_CALL (Access::R, (_c_58, _vv_fails), _gt_auxcall15))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      RF_TAILCALL (Comp_m_Sentence, (_vs_tail_q_ + (_vv_fails + _c_86 + _gt_auxcall15) () + _c_61 + _ve_Snt), _v_res1);
      goto _block1;
    }
  _block1__branch10: {}
    {
      uintptr_t _v_len71 = _v_len__Sentence;
      uintptr_t _v_len72 = 1;
      if (_v_len71 < _v_len72)
      {
        goto _block1__branch11;
      }
      uintptr_t _v_len__Snt9 = (_v_len71 - _v_len72);
      if (!_c_87.term_eq (_ve_Sentence, 0))
      {
        goto _block1__branch11;
      }
      Expr _ve_Snt (_ve_Sentence, (0 + 1), _v_len__Snt9);
      Expr _gv_fails__3;
      {
        {
          if (_v_len__fails < 2)
          {
            goto _block13__branch1;
          }
          RF_rsplit (_vv_fails, 0, _v_rsplit__fails, _ve__e__e_tmp_m_rfp__compilerf_m_534_m_50);
          for ( ; ; RF_iter(_vv_fails)--)
          {
            {
              if (!RF_iter(_vv_fails))
              {
                goto _block13__branch1;
              }
              uintptr_t _v_len73 = _v_rsplit__fails.get_len ();
              uintptr_t _v_len74 = 1;
              if (_v_len73 < (_v_len74 + 1))
              {
                goto _block13__branch1;
              }
              uintptr_t _v_len__earlier_m_fails = (_v_len73 - _v_len74);
              if (!_c_86.term_eq (_v_rsplit__fails, (0 + _v_len__earlier_m_fails)))
              {
                goto _continue3;
              }
              Expr _vv_earlier_m_fails (_v_rsplit__fails, 0, _v_len__earlier_m_fails);
              _gv_fails__3 = _vv_earlier_m_fails;
              goto _exit3;
            }
        _continue3: {}
          }
        _exit3: {}
          goto _block13;
        }
      _block13__branch1: {}
        if (!RF_CALL (Access::L, (_c_58, _vv_fails), _gv_fails__3))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
      }
    _block13: {}
      RF_TAILCALL (Comp_m_Sentence, (_vs_tail_q_ + _gv_fails__3 () + _c_61 + _ve_Snt), _v_res1);
      goto _block1;
    }
  _block1__branch11: {}
    {
      uintptr_t _v_len75 = _v_len__Sentence;
      uintptr_t _v_len76 = 1;
      if (_v_len75 < _v_len76)
      {
        goto _block1__branch12;
      }
      uintptr_t _v_len__Snt10 = (_v_len75 - _v_len76);
      if (!_c_32.term_eq (_ve_Sentence, 0))
      {
        goto _block1__branch12;
      }
      Expr _ve_Snt (_ve_Sentence, (0 + 1), _v_len__Snt10);
      Expr _gv_fails__3;
      {
        {
          if (_v_len__fails < 3)
          {
            goto _block14__branch1;
          }
          RF_rsplit (_vv_fails, 0, _v_rsplit__fails2, _ve__e__e_tmp_m_rfp__compilerf_m_545_m_58);
          for ( ; ; RF_iter(_vv_fails)--)
          {
            {
              if (!RF_iter(_vv_fails))
              {
                goto _block14__branch1;
              }
              uintptr_t _v_len77 = _v_rsplit__fails2.get_len ();
              uintptr_t _v_len78 = 2;
              if (_v_len77 < (_v_len78 + 1))
              {
                goto _block14__branch1;
              }
              uintptr_t _v_len__earlier_m_fails2 = (_v_len77 - _v_len78);
              if (!_c_70.term_eq (_v_rsplit__fails2, (0 + _v_len__earlier_m_fails2)))
              {
                goto _continue4;
              }
              Expr _vv_earlier_m_fails (_v_rsplit__fails2, 0, _v_len__earlier_m_fails2);
              Expr _vt_fail (_v_rsplit__fails2, (0 + _v_len__earlier_m_fails2 + 1), 1);
              _gv_fails__3 = (_vv_earlier_m_fails + _c_70 + _vt_fail);
              goto _exit4;
            }
        _continue4: {}
          }
        _exit4: {}
          goto _block14;
        }
      _block14__branch1: {}
        if (!RF_CALL (Access::L, (_c_58, _vv_fails), _gv_fails__3))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
      }
    _block14: {}
      RF_TAILCALL (Comp_m_Sentence, (_vs_tail_q_ + _gv_fails__3 () + _c_61 + _ve_Snt), _v_res1);
      goto _block1;
    }
  _block1__branch12: {}
    {
      uintptr_t _v_len79 = _v_len__Sentence;
      uintptr_t _v_len80 = 1;
      if (_v_len79 < _v_len80)
      {
        goto _block1__branch13;
      }
      uintptr_t _v_len__Snt11 = (_v_len79 - _v_len80);
      if (!_c_88.term_eq (_ve_Sentence, 0))
      {
        goto _block1__branch13;
      }
      Expr _ve_Snt (_ve_Sentence, (0 + 1), _v_len__Snt11);
      RF_TAILCALL (Comp_m_Sentence, (_vs_tail_q_ + _c_89 + _ve_last_m_Re () + _ve_Snt), _v_res1);
      goto _block1;
    }
  _block1__branch13: {}
    {
      uintptr_t _v_len81 = _v_len__Sentence;
      uintptr_t _v_len82 = 1;
      if (_v_len81 < _v_len82)
      {
        goto _block1__branch14;
      }
      uintptr_t _v_len__Snt12 = (_v_len81 - _v_len82);
      if (!_c_90.term_eq (_ve_Sentence, 0))
      {
        goto _block1__branch14;
      }
      Expr _ve_Snt (_ve_Sentence, (0 + 1), _v_len__Snt12);
      uintptr_t _v_len83 = _v_len__fails;
      uintptr_t _v_len84 = 1;
      if (_v_len83 < _v_len84)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      uintptr_t _v_len___e__e_tmp_m_rfp__compilerf_m_563_m_16 = (_v_len83 - _v_len84);
      if (_vv_fails.symbol_at ((0 + _v_len___e__e_tmp_m_rfp__compilerf_m_563_m_16)))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      Expr _v_deref__fails (_vv_fails, (0 + _v_len___e__e_tmp_m_rfp__compilerf_m_563_m_16));
      uintptr_t _v_len85 = _v_deref__fails.get_len ();
      uintptr_t _v_len86 = 0;
      if (_v_len85 < _v_len86)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      uintptr_t _v_len__last_m_fail = (_v_len85 - _v_len86);
      Expr _ve__e__e_tmp_m_rfp__compilerf_m_563_m_16 (_vv_fails, 0, _v_len___e__e_tmp_m_rfp__compilerf_m_563_m_16);
      Expr _ve_last_m_fail (_v_deref__fails, 0, _v_len__last_m_fail);
      _v_res1 = _ve_last_m_fail;
      goto _block1;
    }
  _block1__branch14: {}
    {
      uintptr_t _v_len87 = _v_len__Sentence;
      uintptr_t _v_len88 = 1;
      if (_v_len87 < _v_len88)
      {
        goto _block1__branch15;
      }
      uintptr_t _v_len__Snt13 = (_v_len87 - _v_len88);
      if (_ve_Sentence.symbol_at (0))
      {
        goto _block1__branch15;
      }
      Expr _v_deref__Sentence9 (_ve_Sentence, 0);
      if (_v_deref__Sentence9.get_len () != 2)
      {
        goto _block1__branch15;
      }
      if (_v_deref__Sentence9.symbol_at ((0 + 1)))
      {
        goto _block1__branch15;
      }
      Expr _v_deref__deref__Sentence9 (_v_deref__Sentence9, (0 + 1));
      uintptr_t _v_len89 = _v_deref__deref__Sentence9.get_len ();
      uintptr_t _v_len90 = 1;
      if (_v_len89 < _v_len90)
      {
        goto _block1__branch15;
      }
      uintptr_t _v_len__branch3 = (_v_len89 - _v_len90);
      if (!_c_91.term_eq (_v_deref__Sentence9, 0))
      {
        goto _block1__branch15;
      }
      if (!_c_19.term_eq (_v_deref__deref__Sentence9, 0))
      {
        goto _block1__branch15;
      }
      Expr _ve_Snt (_ve_Sentence, (0 + 1), _v_len__Snt13);
      Expr _ve_branch (_v_deref__deref__Sentence9, (0 + 1), _v_len__branch3);
      Expr _vt_label;
      RF_CALL (Gener_m_Label, _c_92, _vt_label);
      uintptr_t _v_len91 = _v_len__fails;
      uintptr_t _v_len92 = 1;
      if (_v_len91 < _v_len92)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      uintptr_t _v_len___e__e_tmp_m_rfp__compilerf_m_580_m_16 = (_v_len91 - _v_len92);
      if (_vv_fails.symbol_at ((0 + _v_len___e__e_tmp_m_rfp__compilerf_m_580_m_16)))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      Expr _v_deref__fails2 (_vv_fails, (0 + _v_len___e__e_tmp_m_rfp__compilerf_m_580_m_16));
      uintptr_t _v_len93 = _v_deref__fails2.get_len ();
      uintptr_t _v_len94 = 0;
      if (_v_len93 < _v_len94)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      uintptr_t _v_len__last_m_fail2 = (_v_len93 - _v_len94);
      Expr _ve__e__e_tmp_m_rfp__compilerf_m_580_m_16 (_vv_fails, 0, _v_len___e__e_tmp_m_rfp__compilerf_m_580_m_16);
      Expr _ve_last_m_fail (_v_deref__fails2, 0, _v_len__last_m_fail2);
      Expr _ge_auxcall16;
      RF_CALL (Comp_m_Sentence, (_c_72 + (_c_76 + _vt_label) () () () + _c_61 + _ve_branch), _ge_auxcall16);
      Expr _ve_comp_m_negation ((_ge_auxcall16 + _ve_last_m_fail));
      Expr _v_Comp_m_Sentence4;
      RF_CALL (Comp_m_Sentence, (_vs_tail_q_ + _vv_fails () + _c_61 + _ve_Snt), _v_Comp_m_Sentence4);
      _v_res1 = ((_c_55 + _vt_label () + _ve_comp_m_negation) () + _v_Comp_m_Sentence4);
      goto _block1;
    }
  _block1__branch15: {}
    {
      uintptr_t _v_len95 = _v_len__Sentence;
      uintptr_t _v_len96 = 1;
      if (_v_len95 < _v_len96)
      {
        goto _block1__branch16;
      }
      uintptr_t _v_len__Snt14 = (_v_len95 - _v_len96);
      if (!_c_93.term_eq (_ve_Sentence, 0))
      {
        goto _block1__branch16;
      }
      Expr _ve_Snt (_ve_Sentence, (0 + 1), _v_len__Snt14);
      RF_TAILCALL (Comp_m_Sentence, (_c_94 + _ve_Snt + _c_71), _v_res1);
      goto _block1;
    }
  _block1__branch16: {}
    {
      uintptr_t _v_len97 = _v_len__Sentence;
      uintptr_t _v_len98 = 1;
      if (_v_len97 < _v_len98)
      {
        goto _block1__branch17;
      }
      uintptr_t _v_len__Snt15 = (_v_len97 - _v_len98);
      if (!_c_71.term_eq (_ve_Sentence, 0))
      {
        goto _block1__branch17;
      }
      Expr _ve_Snt (_ve_Sentence, (0 + 1), _v_len__Snt15);
      Expr _v_Prepare_m_Res1;
      RF_CALL (Prepare_m_Res, _ve_last_m_Re (), _v_Prepare_m_Res1);
      if (_v_Prepare_m_Res1.get_len () != 1)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      if (_v_Prepare_m_Res1.symbol_at (0))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      Expr _v_deref__Prepare_m_Res1 (_v_Prepare_m_Res1, 0);
      uintptr_t _v_len99 = _v_deref__Prepare_m_Res1.get_len ();
      uintptr_t _v_len100 = 0;
      if (_v_len99 < _v_len100)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      uintptr_t _v_len__Re2 = (_v_len99 - _v_len100);
      Expr _ve_Re (_v_deref__Prepare_m_Res1, 0, _v_len__Re2);
      _v_res1 = (_c_42 + _ve_Re) ();
      goto _block1;
    }
  _block1__branch17: {}
    uintptr_t _v_len101 = _v_len__Sentence;
    uintptr_t _v_len102 = 1;
    if (_v_len101 < _v_len102)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    uintptr_t _v_len__Snt16 = (_v_len101 - _v_len102);
    if (!_c_69.term_eq (_ve_Sentence, 0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _ve_Snt (_ve_Sentence, (0 + 1), _v_len__Snt16);
    {
      {
        uintptr_t _v_len103 = _v_len__Snt16;
        uintptr_t _v_len104 = 1;
        if (_v_len103 < _v_len104)
        {
          goto _block15__branch1;
        }
        uintptr_t _v_len___e__e_tmp_m_rfp__compilerf_m_607_m_16 = (_v_len103 - _v_len104);
        if (!_c_71.term_eq (_ve_Snt, (0 + _v_len___e__e_tmp_m_rfp__compilerf_m_607_m_16)))
        {
          goto _block15__branch1;
        }
        Expr _ve__e__e_tmp_m_rfp__compilerf_m_607_m_16 (_ve_Snt, 0, _v_len___e__e_tmp_m_rfp__compilerf_m_607_m_16);
        RF_TAILCALL (Comp_m_Sentence, (_vs_tail_q_ + _vv_fails () + _ve_last_m_Re () + _c_71), _v_res1);
        goto _block15;
      }
    _block15__branch1: {}
      RF_TAILCALL (Comp_m_Sentence, (_vs_tail_q_ + _vv_fails () + _ve_last_m_Re () + _ve_Snt), _v_res1);
    }
  _block15: {}
  }
_block1: {}
RF_END

RF_FUNC (Save_m_Snt_m_State, RF_VOID, RF_VOID)
  Expr _gt_auxcall1;
  RF_CALL (rfp__vars::Vars_m_Copy_m_State, /*void*/, _gt_auxcall1);
  RF_TAILCALL (Box::Put, (Snt_m_State, _gt_auxcall1), /*void*/);
RF_END

RF_FUNC (Recall_m_Snt_m_State, RF_VOID, RF_VOID)
  Expr _ge_auxcall1;
  RF_CALL (Box::_q_, Snt_m_State, _ge_auxcall1);
  Expr _gt_auxcall2;
  if (!RF_CALL (Access::R, (_c_58, _ge_auxcall1), _gt_auxcall2))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  RF_TAILCALL (rfp__vars::Vars_m_Set_m_State, _gt_auxcall2, /*void*/);
RF_END

RF_FUNC (Pop_m_Snt_m_State, RF_VOID, RF_VOID)
  RF_CALL (Recall_m_Snt_m_State, /*void*/, /*void*/);
  Expr _ge_auxcall1;
  RF_CALL (Box::_q_, Snt_m_State, _ge_auxcall1);
  Expr _ge_auxcall2;
  if (!RF_CALL (Access::Middle, (_c_58, _c_95, _ge_auxcall1), _ge_auxcall2))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  RF_TAILCALL (Box::Store, (Snt_m_State, _ge_auxcall2), /*void*/);
RF_END

RF_FUNC (Extract_m_Calls, (RF_ARG _ge_arg1;;), (RF_RES _v_res1, _v_res2;;))
  {
    {
      uintptr_t _v_len1 = _ge_arg1.get_len ();
      uintptr_t _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__rest = (_v_len1 - _v_len2);
      if (_ge_arg1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__arg1 (_ge_arg1, 0);
      uintptr_t _v_len3 = _v_deref__arg1.get_len ();
      uintptr_t _v_len4 = 2;
      if (_v_len3 < _v_len4)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__arg = (_v_len3 - _v_len4);
      if (!_c_30.term_eq (_v_deref__arg1, 0))
      {
        goto _block1__branch1;
      }
      Expr _ve_rest (_ge_arg1, (0 + 1), _v_len__rest);
      Expr _vt_name (_v_deref__arg1, (0 + 1), 1);
      Expr _ve_arg (_v_deref__arg1, (0 + 1 + 1), _v_len__arg);
      Expr _vs_linkage;
      Expr _vs_tag;
      Expr _vt_pragma;
      Expr _ve_Fin;
      Expr _ve_Fout;
      if (!RF_CALL (Lookup_m_Func, _vt_name, (_vs_linkage, _vs_tag, _vt_pragma, _ve_Fin, _ve_Fout)))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      Expr _ve_last_m_Re;
      Expr _ve_calls;
      RF_CALL (Extract_m_Calls, _ve_arg, (_ve_last_m_Re, _ve_calls));
      Expr _ge_auxcall1;
      RF_CALL (rfp__format::Split_m_Re, (_ve_Fin, _ve_last_m_Re), _ge_auxcall1);
      Expr _ve_splited_m_Re;
      RF_CALL (Prepare_m_Res, _ge_auxcall1, _ve_splited_m_Re);
      Expr _v_RFP_m_Extract_m_Qualifiers1;
      Expr _ve_prefix;
      RF_CALL (rfp__helper::RFP_m_Extract_m_Qualifiers, _vt_name, (_v_RFP_m_Extract_m_Qualifiers1, _ve_prefix));
      Expr _vt__e__e_tmp_m_rfp__compilerf_m_656_m_41 (_v_RFP_m_Extract_m_Qualifiers1 ());
      Expr _ve_Re;
      RF_CALL (rfp__vars::Gener_m_Subst_m_Vars, (_ve_Fout, _ve_prefix), _ve_Re);
      Expr _ve_vars;
      RF_CALL (rfp__vars::Vars, _ve_Re, _ve_vars);
      Expr _v_Map1;
      if (!RF_CALL (List::Map, (_c_36, _c_37, _ve_vars), _v_Map1))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      uintptr_t _v_len5 = _v_Map1.get_len ();
      uintptr_t _v_len6 = 0;
      if (_v_len5 < _v_len6)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      uintptr_t _v_len___e__e_tmp_m_rfp__compilerf_m_659_m_53 = (_v_len5 - _v_len6);
      Expr _ve__e__e_tmp_m_rfp__compilerf_m_659_m_53 (_v_Map1, 0, _v_len___e__e_tmp_m_rfp__compilerf_m_659_m_53);
      Expr _vt_call;
      {
        {
          if (!_vs_tag.term_eq (_c_9, 0))
          {
            goto _block2__branch1;
          }
          _vt_call = (_c_96 + (_c_30 + _vt_name + _ve_splited_m_Re () + _ve_vars ()) ()) ();
          goto _block2;
        }
      _block2__branch1: {}
        _vt_call = (_c_30 + _vt_name + _ve_splited_m_Re () + _ve_vars ()) ();
      }
    _block2: {}
      Expr _ve_rest_m_Re;
      Expr _ve_rest_m_calls;
      RF_CALL (Extract_m_Calls, _ve_rest, (_ve_rest_m_Re, _ve_rest_m_calls));
      Expr _ge_auxcall2;
      RF_CALL (rfp__vars::Vars_m_Decl, (_c_35, _ve_vars), _ge_auxcall2);
      _v_res1 = (_ve_Re + _ve_rest_m_Re);
      _v_res2 = (_ve_calls + _ge_auxcall2 + _vt_call + _ve_rest_m_calls);
      goto _block1;
    }
  _block1__branch1: {}
    {
      uintptr_t _v_len7 = _ge_arg1.get_len ();
      uintptr_t _v_len8 = 1;
      if (_v_len7 < _v_len8)
      {
        goto _block1__branch2;
      }
      uintptr_t _v_len__rest2 = (_v_len7 - _v_len8);
      if (_ge_arg1.symbol_at (0))
      {
        goto _block1__branch2;
      }
      Expr _v_deref__arg12 (_ge_arg1, 0);
      uintptr_t _v_len9 = _v_deref__arg12.get_len ();
      uintptr_t _v_len10 = 1;
      if (_v_len9 < _v_len10)
      {
        goto _block1__branch2;
      }
      uintptr_t _v_len__Re = (_v_len9 - _v_len10);
      if (!_c_97.term_eq (_v_deref__arg12, 0))
      {
        goto _block1__branch2;
      }
      Expr _ve_rest (_ge_arg1, (0 + 1), _v_len__rest2);
      Expr _ve_Re (_v_deref__arg12, (0 + 1), _v_len__Re);
      Expr _ve_last_m_Re;
      Expr _ve_calls;
      RF_CALL (Extract_m_Calls, _ve_Re, (_ve_last_m_Re, _ve_calls));
      Expr _ve_rest_m_Re;
      Expr _ve_rest_m_calls;
      RF_CALL (Extract_m_Calls, _ve_rest, (_ve_rest_m_Re, _ve_rest_m_calls));
      _v_res1 = ((_c_97 + _ve_last_m_Re) () + _ve_rest_m_Re);
      _v_res2 = (_ve_calls + _ve_rest_m_calls);
      goto _block1;
    }
  _block1__branch2: {}
    {
      uintptr_t _v_len11 = _ge_arg1.get_len ();
      uintptr_t _v_len12 = 1;
      if (_v_len11 < _v_len12)
      {
        goto _block1__branch3;
      }
      uintptr_t _v_len__Re2 = (_v_len11 - _v_len12);
      Expr _vt_Rt (_ge_arg1, 0, 1);
      Expr _ve_Re (_ge_arg1, (0 + 1), _v_len__Re2);
      Expr _ve_last_m_Re;
      Expr _ve_calls;
      RF_CALL (Extract_m_Calls, _ve_Re, (_ve_last_m_Re, _ve_calls));
      _v_res1 = (_vt_Rt + _ve_last_m_Re);
      _v_res2 = _ve_calls;
      goto _block1;
    }
  _block1__branch3: {}
    if (_ge_arg1.get_len () != 0)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    _v_res1 = empty;
    _v_res2 = empty;
  }
_block1: {}
RF_END

RF_FUNC (Comp_m_Calls, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  uintptr_t _v_len1 = _ge_arg1.get_len ();
  uintptr_t _v_len2 = 1;
  if (_v_len1 < _v_len2)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len__calls = (_v_len1 - _v_len2);
  if (_ge_arg1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _v_deref__arg1 (_ge_arg1, 0);
  uintptr_t _v_len3 = _v_deref__arg1.get_len ();
  uintptr_t _v_len4 = 0;
  if (_v_len3 < _v_len4)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len__fail = (_v_len3 - _v_len4);
  Expr _ve_calls (_ge_arg1, (0 + 1), _v_len__calls);
  Expr _ve_fail (_v_deref__arg1, 0, _v_len__fail);
  {
    {
      uintptr_t _v_len5 = _v_len__calls;
      uintptr_t _v_len6 = 1;
      if (_v_len5 < _v_len6)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__rest = (_v_len5 - _v_len6);
      if (_ve_calls.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__calls (_ve_calls, 0);
      if (_v_deref__calls.get_len () != 2)
      {
        goto _block1__branch1;
      }
      if (!_c_96.term_eq (_v_deref__calls, 0))
      {
        goto _block1__branch1;
      }
      Expr _ve_rest (_ve_calls, (0 + 1), _v_len__rest);
      Expr _vt_call (_v_deref__calls, (0 + 1), 1);
      Expr _v_Comp_m_Calls1;
      RF_CALL (Comp_m_Calls, (_ve_fail () + _ve_rest), _v_Comp_m_Calls1);
      _v_res1 = ((_c_99 + (_c_98 + _vt_call) () + _ve_fail) () + _v_Comp_m_Calls1);
      goto _block1;
    }
  _block1__branch1: {}
    {
      uintptr_t _v_len7 = _v_len__calls;
      uintptr_t _v_len8 = 1;
      if (_v_len7 < _v_len8)
      {
        goto _block1__branch2;
      }
      uintptr_t _v_len__rest2 = (_v_len7 - _v_len8);
      Expr _vt_call (_ve_calls, 0, 1);
      Expr _ve_rest (_ve_calls, (0 + 1), _v_len__rest2);
      Expr _v_Comp_m_Calls2;
      RF_CALL (Comp_m_Calls, (_ve_fail () + _ve_rest), _v_Comp_m_Calls2);
      _v_res1 = (_vt_call + _v_Comp_m_Calls2);
      goto _block1;
    }
  _block1__branch2: {}
    if (_v_len__calls != 0)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    _v_res1 = empty;
  }
_block1: {}
RF_END

RF_FUNC (Prepare_m_Res, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  {
    {
      uintptr_t _v_len1 = _ge_arg1.get_len ();
      uintptr_t _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__rest = (_v_len1 - _v_len2);
      if (_ge_arg1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__arg1 (_ge_arg1, 0);
      uintptr_t _v_len3 = _v_deref__arg1.get_len ();
      uintptr_t _v_len4 = 0;
      if (_v_len3 < _v_len4)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__Re = (_v_len3 - _v_len4);
      Expr _ve_rest (_ge_arg1, (0 + 1), _v_len__rest);
      Expr _ve_Re (_v_deref__arg1, 0, _v_len__Re);
      Expr _vs__e__e_tmp_m_rfp__compilerf_m_705_m_50;
      RF_CALL (Static_m_Expr_q_, (_c_100, _ve_Re), (_vs__e__e_tmp_m_rfp__compilerf_m_705_m_50, _ve_Re));
      Expr _v_Prepare_m_Res1;
      RF_CALL (Prepare_m_Res, _ve_rest, _v_Prepare_m_Res1);
      _v_res1 = (_ve_Re () + _v_Prepare_m_Res1);
      goto _block1;
    }
  _block1__branch1: {}
    if (_ge_arg1.get_len () != 0)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    _v_res1 = empty;
  }
_block1: {}
RF_END

RF_FUNC (Static_m_Expr_q_, (RF_ARG _vs_create_q_, _ve_Re;;), (RF_RES _v_res1, _v_res2;;))
  Expr _ve_static (empty);
  Expr _ge_Re__0 (_ve_Re);
  for ( ; ; )
  {
    {
      {
        {
          if (_ge_Re__0.get_len () != 0)
          {
            goto _block1__branch1;
          }
          {
            {
              if (!_vs_create_q_.term_eq (_c_100, 0))
              {
                goto _block2__branch1;
              }
              RF_CALL (rfp__const::Create_m_Static, _ve_static, _v_res2);
              _v_res1 = _c_101;
              goto _block2;
            }
          _block2__branch1: {}
            _v_res1 = _c_101;
            _v_res2 = _ve_static;
          }
        _block2: {}
          goto _block1;
        }
      _block1__branch1: {}
        if (_ge_Re__0.get_len () != 1)
        {
          goto _iter1;
        }
        if (_ge_Re__0.symbol_at (0))
        {
          goto _iter1;
        }
        Expr _v_deref__Re__0 (_ge_Re__0, 0);
        uintptr_t _v_len1 = _v_deref__Re__0.get_len ();
        uintptr_t _v_len2 = 1;
        if (_v_len1 < _v_len2)
        {
          goto _iter1;
        }
        uintptr_t _v_len__dynamic = (_v_len1 - _v_len2);
        if (!_c_102.term_eq (_v_deref__Re__0, 0))
        {
          goto _iter1;
        }
        Expr _ve_dynamic (_v_deref__Re__0, (0 + 1), _v_len__dynamic);
        Expr _ge_auxcall1;
        RF_CALL (rfp__const::Create_m_Static, _ve_static, _ge_auxcall1);
        _v_res1 = _c_102;
        _v_res2 = (_ge_auxcall1 + _ve_dynamic);
      }
    _block1: {}
      goto _exit__iter1;
    }
  _iter1: {}
    {
      {
        uintptr_t _v_len3 = _ge_Re__0.get_len ();
        uintptr_t _v_len4 = 1;
        if (_v_len3 < _v_len4)
        {
          goto _block3__branch1;
        }
        uintptr_t _v_len__rest = (_v_len3 - _v_len4);
        Expr _vt_Rt (_ge_Re__0, 0, 1);
        Expr _ve_rest (_ge_Re__0, (0 + 1), _v_len__rest);
        Expr _v_Static_m_Term_q_1;
        Expr _v_Static_m_Term_q_2;
        RF_CALL (Static_m_Term_q_, _vt_Rt, (_v_Static_m_Term_q_1, _v_Static_m_Term_q_2));
        {
          {
            uintptr_t _v_len5 = (_v_Static_m_Term_q_2.get_len () + 1);
            uintptr_t _v_len6 = 1;
            if (_v_len5 < _v_len6)
            {
              goto _block4__branch1;
            }
            uintptr_t _v_len__st_m_Re = (_v_len5 - _v_len6);
            Expr _v_compose1 ((_v_Static_m_Term_q_1 + _v_Static_m_Term_q_2));
            if (!_c_101.term_eq (_v_compose1, 0))
            {
              goto _block4__branch1;
            }
            Expr _ve_st_m_Re (_v_compose1, (0 + 1), _v_len__st_m_Re);
            _ve_static = (_ve_static + _ve_st_m_Re);
            _ge_Re__0 = _ve_rest;
            goto _block4;
          }
        _block4__branch1: {}
          if ((_v_Static_m_Term_q_2.get_len () + 1) != 2)
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          Expr _v_compose2 ((_v_Static_m_Term_q_1 + _v_Static_m_Term_q_2));
          if (!_c_102.term_eq (_v_compose2, 0))
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          Expr _vt_dyn_m_Rt (_v_compose2, (0 + 1), 1);
          Expr _vs__e__e_tmp_m_rfp__compilerf_m_723_m_44;
          Expr _ge_rest__4;
          RF_CALL (Static_m_Expr_q_, (_c_100, _ve_rest), (_vs__e__e_tmp_m_rfp__compilerf_m_723_m_44, _ge_rest__4));
          _ge_Re__0 = (_c_102 + _vt_dyn_m_Rt + _ge_rest__4) ();
        }
      _block4: {}
        goto _block3;
      }
    _block3__branch1: {}
      _ge_Re__0 = empty;
    }
  _block3: {}
  }
_exit__iter1: {}
RF_END

RF_FUNC (Static_m_Term_q_, (RF_ARG _gt_arg1;;), (RF_RES _v_res1, _v_res2;;))
  {
    {
      if (!_gt_arg1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _vs_ymbol (_gt_arg1, 0, 1);
      _v_res1 = _c_101;
      _v_res2 = _vs_ymbol;
      goto _block1;
    }
  _block1__branch1: {}
    {
      if (_gt_arg1.symbol_at (0))
      {
        goto _block1__branch2;
      }
      Expr _v_deref__arg1 (_gt_arg1, 0);
      uintptr_t _v_len1 = _v_deref__arg1.get_len ();
      uintptr_t _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch2;
      }
      uintptr_t _v_len__Re = (_v_len1 - _v_len2);
      if (!_c_97.term_eq (_v_deref__arg1, 0))
      {
        goto _block1__branch2;
      }
      Expr _ve_Re (_v_deref__arg1, (0 + 1), _v_len__Re);
      Expr _vs_tatic_q_;
      RF_CALL (Static_m_Expr_q_, (_c_103, _ve_Re), (_vs_tatic_q_, _ve_Re));
      _v_res1 = _vs_tatic_q_;
      _v_res2 = (_c_97 + _ve_Re) ();
      goto _block1;
    }
  _block1__branch2: {}
    {
      if (_gt_arg1.symbol_at (0))
      {
        goto _block1__branch3;
      }
      Expr _v_deref__arg12 (_gt_arg1, 0);
      if (_v_deref__arg12.get_len () != 2)
      {
        goto _block1__branch3;
      }
      if (!_c_104.term_eq (_v_deref__arg12, 0))
      {
        goto _block1__branch3;
      }
      Expr _vt_name (_v_deref__arg12, (0 + 1), 1);
      RF_CALL (Ref_m_Func_q_, (_c_104 + _vt_name) (), _v_res2);
      _v_res1 = _c_101;
      goto _block1;
    }
  _block1__branch3: {}
    {
      if (_gt_arg1.symbol_at (0))
      {
        goto _block1__branch4;
      }
      Expr _v_deref__arg13 (_gt_arg1, 0);
      if (_v_deref__arg13.get_len () != 2)
      {
        goto _block1__branch4;
      }
      if (!_c_105.term_eq (_v_deref__arg13, 0))
      {
        goto _block1__branch4;
      }
      Expr _vt_name (_v_deref__arg13, (0 + 1), 1);
      RF_CALL (rfp__const::Get_m_Static, (_c_105 + _vt_name) (), _v_res2);
      _v_res1 = _c_101;
      goto _block1;
    }
  _block1__branch4: {}
    Expr _v_Prepare_m_Vars1;
    RF_CALL (Prepare_m_Vars, _gt_arg1, _v_Prepare_m_Vars1);
    if (_v_Prepare_m_Vars1.get_len () != 1)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _vt_prep_m_var (_v_Prepare_m_Vars1, 0, 1);
    _v_res1 = _c_102;
    _v_res2 = _vt_prep_m_var;
  }
_block1: {}
RF_END

RF_FUNC (Ref_m_Func_q_, (RF_ARG _gt_arg1;;), (RF_RES _v_res1;;))
  {
    {
      if (_gt_arg1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__arg1 (_gt_arg1, 0);
      if (_v_deref__arg1.get_len () != 2)
      {
        goto _block1__branch1;
      }
      if (!_c_104.term_eq (_v_deref__arg1, 0))
      {
        goto _block1__branch1;
      }
      Expr _vt_name (_v_deref__arg1, (0 + 1), 1);
      {
        {
          Expr _v_Lookup_m_Func1;
          Expr _v_Lookup_m_Func2;
          Expr _v_Lookup_m_Func3;
          Expr _v_Lookup_m_Func4;
          Expr _v_Lookup_m_Func5;
          if (!RF_CALL (Lookup_m_Func, _vt_name, (_v_Lookup_m_Func1, _v_Lookup_m_Func2, _v_Lookup_m_Func3, _v_Lookup_m_Func4, _v_Lookup_m_Func5)))
          {
            goto _block2__branch1;
          }
          {
            {
              Expr _v_compose1 ((_v_Lookup_m_Func1 + _v_Lookup_m_Func2 + _v_Lookup_m_Func3 + _v_Lookup_m_Func4 () + _v_Lookup_m_Func5 ()));
              if (!_v_compose1.symbol_at (0))
              {
                goto _block3__branch1;
              }
              if (!_v_compose1.symbol_at ((0 + 1)))
              {
                goto _block3__branch1;
              }
              if (!_c_106.eq (_v_compose1, (0 + 1 + 1 + 1)))
              {
                goto _block3__branch1;
              }
              Expr _vs_linkage (_v_compose1, 0, 1);
              Expr _vs_tag (_v_compose1, (0 + 1), 1);
              Expr _vt_pragma (_v_compose1, (0 + 1 + 1), 1);
              _v_res1 = (_vs_tag + _vt_name) ();
              goto _block3;
            }
          _block3__branch1: {}
            Expr _v_compose2 ((_v_Lookup_m_Func1 + _v_Lookup_m_Func2 + _v_Lookup_m_Func3 + _v_Lookup_m_Func4 () + _v_Lookup_m_Func5 ()));
            if (_v_compose2.symbol_at ((0 + 1 + 1 + 1)))
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            if (_v_compose2.symbol_at ((0 + 1 + 1 + 1 + 1)))
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            Expr _v_deref__compose2 (_v_compose2, (0 + 1 + 1 + 1));
            Expr _v_deref__compose22 (_v_compose2, (0 + 1 + 1 + 1 + 1));
            uintptr_t _v_len1 = _v_deref__compose22.get_len ();
            uintptr_t _v_len2 = 0;
            if (_v_len1 < _v_len2)
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            uintptr_t _v_len__Fout = (_v_len1 - _v_len2);
            uintptr_t _v_len3 = _v_deref__compose2.get_len ();
            uintptr_t _v_len4 = 0;
            if (_v_len3 < _v_len4)
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            uintptr_t _v_len__Fin = (_v_len3 - _v_len4);
            if (!_v_compose2.symbol_at (0))
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            if (!_v_compose2.symbol_at ((0 + 1)))
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            Expr _vs_linkage (_v_compose2, 0, 1);
            Expr _vs_tag (_v_compose2, (0 + 1), 1);
            Expr _vt_pragma (_v_compose2, (0 + 1 + 1), 1);
            Expr _ve_Fin (_v_deref__compose2, 0, _v_len__Fin);
            Expr _ve_Fout (_v_deref__compose22, 0, _v_len__Fout);
            {
              {
                Expr _v_Lookup1;
                if (!RF_CALL (Table::Lookup, (Stub_m_Funcs, _vt_name), _v_Lookup1))
                {
                  goto _block4__branch1;
                }
                uintptr_t _v_len5 = _v_Lookup1.get_len ();
                uintptr_t _v_len6 = 1;
                if (_v_len5 < _v_len6)
                {
                  goto _block4__branch1;
                }
                uintptr_t _v_len___e__e_tmp_m_rfp__compilerf_m_755_m_56 = (_v_len5 - _v_len6);
                Expr _vt_stub_m_name (_v_Lookup1, 0, 1);
                Expr _ve__e__e_tmp_m_rfp__compilerf_m_755_m_56 (_v_Lookup1, (0 + 1), _v_len___e__e_tmp_m_rfp__compilerf_m_755_m_56);
                _v_res1 = (_c_9 + _vt_stub_m_name) ();
                goto _block4;
              }
            _block4__branch1: {}
              Expr _vt_stub_m_name;
              RF_CALL (Stub_m_Name, _vt_name, _vt_stub_m_name);
              RF_CALL (Table::Bind, (Stub_m_Funcs, _vt_name, (_vt_stub_m_name + _vs_tag + _ve_Fin () + _ve_Fout ())), /*void*/);
              _v_res1 = (_c_9 + _vt_stub_m_name) ();
            }
          _block4: {}
          }
        _block3: {}
          goto _block2;
        }
      _block2__branch1: {}
        _v_res1 = (_c_104 + _vt_name) ();
      }
    _block2: {}
      goto _block1;
    }
  _block1__branch1: {}
    _v_res1 = _gt_arg1;
  }
_block1: {}
RF_END

RF_FUNC (Prepare_m_Vars, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  {
    {
      uintptr_t _v_len1 = _ge_arg1.get_len ();
      uintptr_t _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__rest = (_v_len1 - _v_len2);
      Expr _vt_var (_ge_arg1, 0, 1);
      Expr _ve_rest (_ge_arg1, (0 + 1), _v_len__rest);
      Expr _v_Prepare_m_Vars1;
      RF_CALL (Prepare_m_Vars, _ve_rest, _v_Prepare_m_Vars1);
      _v_res1 = (_vt_var + _v_Prepare_m_Vars1);
      goto _block1;
    }
  _block1__branch1: {}
    if (_ge_arg1.get_len () != 0)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    _v_res1 = empty;
  }
_block1: {}
RF_END

RF_FUNC (Stub_m_Name, (RF_ARG _gt_arg1;;), (RF_RES _v_res1;;))
  if (_gt_arg1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _v_deref__arg1 (_gt_arg1, 0);
  uintptr_t _v_len1 = _v_deref__arg1.get_len ();
  uintptr_t _v_len2 = 1;
  if (_v_len1 < _v_len2)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len__qualifiers = (_v_len1 - _v_len2);
  if (!_v_deref__arg1.symbol_at ((0 + _v_len__qualifiers)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _ve_qualifiers (_v_deref__arg1, 0, _v_len__qualifiers);
  Expr _vs_name (_v_deref__arg1, (0 + _v_len__qualifiers), 1);
  Expr _v_To_m_Chars1;
  RF_CALL (Convert::To_m_Chars, _vs_name, _v_To_m_Chars1);
  Expr _ge_name__1;
  {
    {
      uintptr_t _v_len3 = _v_To_m_Chars1.get_len ();
      uintptr_t _v_len4 = 2;
      if (_v_len3 < _v_len4)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__1 = (_v_len3 - _v_len4);
      if (!_c_107.term_eq (_v_To_m_Chars1, (0 + _v_len__1)))
      {
        goto _block1__branch1;
      }
      if (!_v_To_m_Chars1.symbol_at ((0 + _v_len__1 + 1)))
      {
        goto _block1__branch1;
      }
      Expr _ve_1 (_v_To_m_Chars1, 0, _v_len__1);
      Expr _vs_n (_v_To_m_Chars1, (0 + _v_len__1 + 1), 1);
      if (!RF_CALL (Class::Int_q_, _vs_n, /*void*/))
      {
        goto _block1__branch1;
      }
      Expr _v__p_1;
      RF_CALL (Arithm::_p_, (_vs_n, _c_95), _v__p_1);
      _ge_name__1 = (_ve_1 + _c_107 + _v__p_1);
      goto _block1;
    }
  _block1__branch1: {}
    uintptr_t _v_len5 = _v_To_m_Chars1.get_len ();
    uintptr_t _v_len6 = 0;
    if (_v_len5 < _v_len6)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    uintptr_t _v_len__12 = (_v_len5 - _v_len6);
    Expr _ve_1 (_v_To_m_Chars1, 0, _v_len__12);
    _ge_name__1 = (_ve_1 + _c_108);
  }
_block1: {}
  Expr _gs_auxcall1;
  RF_CALL (Convert::To_m_Word, _ge_name__1, _gs_auxcall1);
  Expr _gt_name__1 (_gs_auxcall1 ());
  {
    {
      Expr _v_Lookup_m_Func1;
      Expr _v_Lookup_m_Func2;
      Expr _v_Lookup_m_Func3;
      Expr _v_Lookup_m_Func4;
      Expr _v_Lookup_m_Func5;
      if (!RF_CALL (Lookup_m_Func, _gt_name__1, (_v_Lookup_m_Func1, _v_Lookup_m_Func2, _v_Lookup_m_Func3, _v_Lookup_m_Func4, _v_Lookup_m_Func5)))
      {
        goto _block2__branch1;
      }
      uintptr_t _v_len7 = 5;
      uintptr_t _v_len8 = 0;
      if (_v_len7 < _v_len8)
      {
        goto _block2__branch1;
      }
      uintptr_t _v_len___e__e_tmp_m_rfp__compilerf_m_796_m_29 = (_v_len7 - _v_len8);
      Expr _v_compose1 ((_v_Lookup_m_Func1 + _v_Lookup_m_Func2 + _v_Lookup_m_Func3 + _v_Lookup_m_Func4 () + _v_Lookup_m_Func5 ()));
      Expr _ve__e__e_tmp_m_rfp__compilerf_m_796_m_29 (_v_compose1, 0, _v_len___e__e_tmp_m_rfp__compilerf_m_796_m_29);
      RF_TAILCALL (Stub_m_Name, _gt_name__1, _v_res1);
      goto _block2;
    }
  _block2__branch1: {}
    _v_res1 = _gt_name__1;
  }
_block2: {}
RF_END

RF_FUNC (Prepare_m_Const, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  {
    {
      uintptr_t _v_len1 = _ge_arg1.get_len ();
      uintptr_t _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__rest = (_v_len1 - _v_len2);
      if (_ge_arg1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__arg1 (_ge_arg1, 0);
      uintptr_t _v_len3 = _v_deref__arg1.get_len ();
      uintptr_t _v_len4 = 1;
      if (_v_len3 < _v_len4)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__xpr = (_v_len3 - _v_len4);
      if (!_c_97.term_eq (_v_deref__arg1, 0))
      {
        goto _block1__branch1;
      }
      Expr _ve_rest (_ge_arg1, (0 + 1), _v_len__rest);
      Expr _ve_xpr (_v_deref__arg1, (0 + 1), _v_len__xpr);
      Expr _ge_auxcall1;
      RF_CALL (Prepare_m_Const, _ve_xpr, _ge_auxcall1);
      Expr _v_Prepare_m_Const1;
      RF_CALL (Prepare_m_Const, _ve_rest, _v_Prepare_m_Const1);
      _v_res1 = ((_c_97 + _ge_auxcall1) () + _v_Prepare_m_Const1);
      goto _block1;
    }
  _block1__branch1: {}
    {
      uintptr_t _v_len5 = _ge_arg1.get_len ();
      uintptr_t _v_len6 = 1;
      if (_v_len5 < _v_len6)
      {
        goto _block1__branch2;
      }
      uintptr_t _v_len__rest2 = (_v_len5 - _v_len6);
      Expr _vt_1 (_ge_arg1, 0, 1);
      Expr _ve_rest (_ge_arg1, (0 + 1), _v_len__rest2);
      Expr _gt_auxcall2;
      RF_CALL (Ref_m_Func_q_, _vt_1, _gt_auxcall2);
      Expr _v_Prepare_m_Const2;
      RF_CALL (Prepare_m_Const, _ve_rest, _v_Prepare_m_Const2);
      _v_res1 = (_gt_auxcall2 + _v_Prepare_m_Const2);
      goto _block1;
    }
  _block1__branch2: {}
    if (_ge_arg1.get_len () != 0)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    _v_res1 = empty;
  }
_block1: {}
RF_END

RF_FUNC (Comp_m_Assign_m_to_m_Var, (RF_ARG _vt_var, _ve_Re, _ve_assigned_m_vars;;), (RF_RES _v_res1, _v_res2;;))
  {
    {
      if (1 != _ve_Re.get_len ())
      {
        goto _block1__branch1;
      }
      if (!_ve_Re.eq (_vt_var, 0))
      {
        goto _block1__branch1;
      }
      _v_res1 = empty;
      _v_res2 = empty;
      goto _block1;
    }
  _block1__branch1: {}
    RF_CALL (rfp__vars::Vars_m_Reset, _vt_var, /*void*/);
    {
      if (!RF_CALL (rfp__vars::Substitutable_m_Var_q_, _ve_Re, /*void*/))
      {
        goto _block1__branch3;
      }
      {
        if (_ve_assigned_m_vars.get_len () < 1)
        {
          goto _negation1;
        }
        RF_lsplit (_ve_assigned_m_vars, 0, _ve__e__e_tmp_m_rfp__compilerf_m_816_m_56, _v_lsplit__assigned_m_vars);
        for ( ; ; RF_iter(_ve_assigned_m_vars)++)
        {
          {
            if (!RF_iter(_ve_assigned_m_vars))
            {
              goto _negation1;
            }
            uintptr_t _v_len1 = _v_lsplit__assigned_m_vars.get_len ();
            uintptr_t _v_len2 = 1;
            if (_v_len1 < _v_len2)
            {
              goto _negation1;
            }
            uintptr_t _v_len___e__e_tmp_m_rfp__compilerf_m_816_m_64 = (_v_len1 - _v_len2);
            if (!_vt_var.term_eq (_v_lsplit__assigned_m_vars, 0))
            {
              goto _continue1;
            }
            Expr _ve__e__e_tmp_m_rfp__compilerf_m_816_m_64 (_v_lsplit__assigned_m_vars, (0 + 1), _v_len___e__e_tmp_m_rfp__compilerf_m_816_m_64);
            goto _exit1;
          }
      _continue1: {}
        }
      _exit1: {}
        goto _block1__branch3;
      }
    _negation1: {}
      RF_CALL (rfp__vars::Gener_m_Var_m_Assign, (_vt_var, _ve_Re), /*void*/);
      _v_res1 = empty;
      _v_res2 = empty;
      goto _block1;
    }
  _block1__branch3: {}
    {
      Expr _v_Get_m_Var1;
      if (!RF_CALL (rfp__vars::Get_m_Var, (_c_50, _vt_var), _v_Get_m_Var1))
      {
        goto _block1__branch4;
      }
      if (_v_Get_m_Var1.get_len () != 1)
      {
        goto _block1__branch4;
      }
      if (!_v_Get_m_Var1.symbol_at (0))
      {
        goto _block1__branch4;
      }
      Expr _vs__e__e_tmp_m_rfp__compilerf_m_818_m_29 (_v_Get_m_Var1, 0, 1);
      Expr _ge_auxcall1;
      RF_CALL (rfp__vars::Vars_m_Print, _vt_var, _ge_auxcall1);
      Expr _ge_auxcall2;
      RF_CALL (rfp__vars::Vars, _ve_Re, _ge_auxcall2);
      _v_res1 = (_c_54 + _ge_auxcall1 + _ve_Re) ();
      _v_res2 = _ge_auxcall2;
      goto _block1;
    }
  _block1__branch4: {}
    Expr _v_Vars_m_Decl1;
    RF_CALL (rfp__vars::Vars_m_Decl, (_c_73, _vt_var), _v_Vars_m_Decl1);
    uintptr_t _v_len3 = _v_Vars_m_Decl1.get_len ();
    uintptr_t _v_len4 = 0;
    if (_v_len3 < _v_len4)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    uintptr_t _v_len___e__e_tmp_m_rfp__compilerf_m_819_m_31 = (_v_len3 - _v_len4);
    Expr _ve__e__e_tmp_m_rfp__compilerf_m_819_m_31 (_v_Vars_m_Decl1, 0, _v_len___e__e_tmp_m_rfp__compilerf_m_819_m_31);
    Expr _ge_auxcall3;
    RF_CALL (rfp__vars::Vars_m_Print, _vt_var, _ge_auxcall3);
    Expr _ge_auxcall4;
    RF_CALL (rfp__vars::Vars, _ve_Re, _ge_auxcall4);
    _v_res1 = (_c_44 + _ge_auxcall3 + _ve_Re) ();
    _v_res2 = _ge_auxcall4;
  }
_block1: {}
RF_END

RF_FUNC (Comp_m_Assigns, (RF_ARG _ve_assigns;;), (RF_RES _v_res1;;))
  Expr _ge_assigns__0 (_ve_assigns);
  Expr _ve_assigned_m_vars (empty);
  Expr _ve_comp_m_assigns (empty);
  for ( ; ; )
  {
    {
      if (_ge_assigns__0.get_len () != 0)
      {
        goto _iter1;
      }
      _v_res1 = _ve_comp_m_assigns;
      goto _exit__iter1;
    }
  _iter1: {}
    uintptr_t _v_len1 = _ge_assigns__0.get_len ();
    uintptr_t _v_len2 = 1;
    if (_v_len1 < _v_len2)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    uintptr_t _v_len__rest = (_v_len1 - _v_len2);
    if (_ge_assigns__0.symbol_at (0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _v_deref__assigns__0 (_ge_assigns__0, 0);
    if (_v_deref__assigns__0.get_len () != 2)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    if (_v_deref__assigns__0.symbol_at ((0 + 1)))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _v_deref__deref__assigns__0 (_v_deref__assigns__0, (0 + 1));
    uintptr_t _v_len3 = _v_deref__deref__assigns__0.get_len ();
    uintptr_t _v_len4 = 0;
    if (_v_len3 < _v_len4)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    uintptr_t _v_len__Re = (_v_len3 - _v_len4);
    Expr _ve_rest (_ge_assigns__0, (0 + 1), _v_len__rest);
    Expr _vt_var (_v_deref__assigns__0, 0, 1);
    Expr _ve_Re (_v_deref__deref__assigns__0, 0, _v_len__Re);
    Expr _ve_c_m_as;
    Expr _ve_a_m_vs;
    RF_CALL (Comp_m_Assign_m_to_m_Var, (_vt_var, _ve_Re, _ve_assigned_m_vars), (_ve_c_m_as, _ve_a_m_vs));
    _ge_assigns__0 = _ve_rest;
    _ve_assigned_m_vars = (_ve_assigned_m_vars + _ve_a_m_vs);
    _ve_comp_m_assigns = (_ve_comp_m_assigns + _ve_c_m_as);
  }
_exit__iter1: {}
RF_END

RF_FUNC (Gener_m_Aux_m_Var, RF_VOID, (RF_RES _v_res1;;))
  Expr _v__q_1;
  RF_CALL (Box::_q_, Aux_m_Index, _v__q_1);
  if (_v__q_1.get_len () != 1)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_v__q_1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _vs_n (_v__q_1, 0, 1);
  Expr _gs_auxcall1;
  RF_CALL (Arithm::_p_, (_vs_n, _c_95), _gs_auxcall1);
  RF_CALL (Box::Store, (Aux_m_Index, _gs_auxcall1), /*void*/);
  _v_res1 = (_c_53 + (_c_109 + _vs_n) ()) ();
RF_END

RF_FUNC (Comp_m_Format, (RF_ARG _ve_last_m_Re, _ve_He;;), (RF_RES _v_res1;;))
  Expr _ge_auxcall1;
  RF_CALL (rfp__vars::Vars, _ve_He, _ge_auxcall1);
  Expr _ve_vars;
  RF_CALL (Prepare_m_Vars, _ge_auxcall1, _ve_vars);
  Expr _ge_auxcall2;
  RF_CALL (rfp__format::Format_m_Exp, _ve_He, _ge_auxcall2);
  Expr _ge_auxcall3;
  RF_CALL (rfp__format::Split_m_Re, (_ge_auxcall2, _ve_last_m_Re), _ge_auxcall3);
  Expr _ve_splited_m_Re;
  RF_CALL (Prepare_m_Res, _ge_auxcall3, _ve_splited_m_Re);
  RF_CALL (Box::Store, (Aux_m_Index, _c_95), /*void*/);
  Expr _ve_assigns;
  RF_CALL (Create_m_Aux_m_Vars, (_ve_vars, _ve_splited_m_Re), _ve_assigns);
  RF_TAILCALL (Comp_m_Assigns, _ve_assigns, _v_res1);
RF_END

RF_FUNC (Get_m_Vars, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  if (_ge_arg1.get_len () != 1)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (_ge_arg1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _v_deref__arg1 (_ge_arg1, 0);
  uintptr_t _v_len1 = _v_deref__arg1.get_len ();
  uintptr_t _v_len2 = 0;
  if (_v_len1 < _v_len2)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len__Re = (_v_len1 - _v_len2);
  Expr _ve_Re (_v_deref__arg1, 0, _v_len__Re);
  Expr _ge_auxcall1;
  RF_CALL (rfp__vars::Vars, _ve_Re, _ge_auxcall1);
  _v_res1 = _ge_auxcall1 ();
RF_END

RF_FUNC (Create_m_Aux_m_Vars, (RF_ARG _ve_vars, _ve_splited_m_Re;;), (RF_RES _v_res1;;))
  Expr _ge_auxcall1;
  if (!RF_CALL (List::Map, (_c_110, empty, _ve_splited_m_Re), _ge_auxcall1))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _ve_list;
  RF_CALL (List::Zip, (_ge_auxcall1, _ve_vars), _ve_list);
  Expr _vs_box;
  RF_CALL (Box::Box, empty, _vs_box);
  Expr _vs_provide_m_i;
  RF_CALL (Box::Box, empty, _vs_provide_m_i);
  Expr _vs_require_m_i;
  RF_CALL (Box::Box, empty, _vs_require_m_i);
  {
    if (_ve_vars.get_len () < 1)
    {
      goto _block1__branch1;
    }
    RF_lsplit (_ve_vars, 0, _ve_1, _v_lsplit__vars);
    for ( ; ; RF_iter(_ve_vars)++)
    {
      {
        if (!RF_iter(_ve_vars))
        {
          goto _block1__branch1;
        }
        uintptr_t _v_len1 = _v_lsplit__vars.get_len ();
        uintptr_t _v_len2 = 1;
        if (_v_len1 < _v_len2)
        {
          goto _block1__branch1;
        }
        uintptr_t _v_len__2 = (_v_len1 - _v_len2);
        Expr _vt_var_m_i (_v_lsplit__vars, 0, 1);
        Expr _ve_2 (_v_lsplit__vars, (0 + 1), _v_len__2);
        {
          if (_ve_list.get_len () < 1)
          {
            goto _block2__branch1;
          }
          RF_lsplit (_ve_list, 0, _ve__e__e_tmp_m_rfp__compilerf_m_950_m_19, _v_lsplit__list);
          for ( ; ; RF_iter(_ve_list)++)
          {
            {
              if (!RF_iter(_ve_list))
              {
                goto _block2__branch1;
              }
              uintptr_t _v_len3 = _v_lsplit__list.get_len ();
              uintptr_t _v_len4 = 1;
              if (_v_len3 < _v_len4)
              {
                goto _block2__branch1;
              }
              uintptr_t _v_len___e__e_tmp_m_rfp__compilerf_m_950_m_43 = (_v_len3 - _v_len4);
              if (_v_lsplit__list.symbol_at (0))
              {
                goto _continue2;
              }
              Expr _v_deref__lsplit__list (_v_lsplit__list, 0);
              if (_v_deref__lsplit__list.get_len () != 2)
              {
                goto _continue2;
              }
              if (_v_deref__lsplit__list.symbol_at (0))
              {
                goto _continue2;
              }
              Expr _v_deref__deref__lsplit__list (_v_deref__lsplit__list, 0);
              uintptr_t _v_len5 = _v_deref__deref__lsplit__list.get_len ();
              uintptr_t _v_len6 = 0;
              if (_v_len5 < _v_len6)
              {
                goto _continue2;
              }
              uintptr_t _v_len__vars_m_Re = (_v_len5 - _v_len6);
              Expr _ve__e__e_tmp_m_rfp__compilerf_m_950_m_43 (_v_lsplit__list, (0 + 1), _v_len___e__e_tmp_m_rfp__compilerf_m_950_m_43);
              Expr _vt_var_m_j (_v_deref__lsplit__list, (0 + 1), 1);
              Expr _ve_vars_m_Re (_v_deref__deref__lsplit__list, 0, _v_len__vars_m_Re);
              {
                {
                  if (!_vt_var_m_j.term_eq (_vt_var_m_i, 0))
                  {
                    goto _block3__branch1;
                  }
                  Expr _ge_auxcall2;
                  RF_CALL (List::And, ((_ve_1 + _ve_2), _ve_vars_m_Re), _ge_auxcall2);
                  RF_CALL (Box::Put, (_vs_require_m_i, _ge_auxcall2), /*void*/);
                  goto _block3;
                }
              _block3__branch1: {}
                if (_v_len__vars_m_Re < 1)
                {
                  goto _continue2;
                }
                RF_lsplit (_ve_vars_m_Re, 0, _ve__e__e_tmp_m_rfp__compilerf_m_953_m_26, _v_lsplit__vars_m_Re);
                for ( ; ; RF_iter(_ve_vars_m_Re)++)
                {
                  {
                    if (!RF_iter(_ve_vars_m_Re))
                    {
                      goto _continue2;
                    }
                    uintptr_t _v_len7 = _v_lsplit__vars_m_Re.get_len ();
                    uintptr_t _v_len8 = 1;
                    if (_v_len7 < _v_len8)
                    {
                      goto _continue2;
                    }
                    uintptr_t _v_len___e__e_tmp_m_rfp__compilerf_m_953_m_36 = (_v_len7 - _v_len8);
                    if (!_vt_var_m_i.term_eq (_v_lsplit__vars_m_Re, 0))
                    {
                      goto _continue3;
                    }
                    Expr _ve__e__e_tmp_m_rfp__compilerf_m_953_m_36 (_v_lsplit__vars_m_Re, (0 + 1), _v_len___e__e_tmp_m_rfp__compilerf_m_953_m_36);
                    RF_CALL (Box::Put, (_vs_provide_m_i, _vt_var_m_j), /*void*/);
                    goto _exit3;
                  }
              _continue3: {}
                }
              _exit3: {}
              }
            _block3: {}
            }
        _continue2: {}
          }
        _exit2: {}
        }
      _block2__branch1: {}
        Expr _gs_auxcall3;
        RF_CALL (Access::Length, _ve_1, _gs_auxcall3);
        Expr _vt_Re_m_i;
        if (!RF_CALL (Access::L, (_gs_auxcall3, _ve_splited_m_Re), _vt_Re_m_i))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        Expr _ge_auxcall4;
        RF_CALL (Box::_q_, _vs_provide_m_i, _ge_auxcall4);
        Expr _ge_auxcall5;
        RF_CALL (Box::_q_, _vs_require_m_i, _ge_auxcall5);
        RF_CALL (Box::Put, (_vs_box, (_vt_var_m_i + _vt_Re_m_i + _ge_auxcall4 () + _ge_auxcall5 ()) ()), /*void*/);
        RF_CALL (Box::Store, (_vs_provide_m_i, empty), /*void*/);
        RF_CALL (Box::Store, (_vs_require_m_i, empty), /*void*/);
      }
  _continue1: {}
    }
  _exit1: {}
  }
_block1__branch1: {}
  Expr _ge_auxcall6;
  RF_CALL (Box::_q_, _vs_box, _ge_auxcall6);
  RF_TAILCALL (CAV, (_ge_auxcall6, empty, empty), _v_res1);
RF_END

RF_FUNC (Assign_m_Empty_m_Provides, (RF_ARG _ge_arg1;;), (RF_RES _v_res1, _v_res2;;))
  {
    {
      if (_ge_arg1.get_len () < 1)
      {
        goto _block1__branch1;
      }
      RF_lsplit (_ge_arg1, 0, _ve_1, _v_lsplit__arg1);
      for ( ; ; RF_iter(_ge_arg1)++)
      {
        {
          if (!RF_iter(_ge_arg1))
          {
            goto _block1__branch1;
          }
          uintptr_t _v_len1 = _v_lsplit__arg1.get_len ();
          uintptr_t _v_len2 = 1;
          if (_v_len1 < _v_len2)
          {
            goto _block1__branch1;
          }
          uintptr_t _v_len__2 = (_v_len1 - _v_len2);
          if (_v_lsplit__arg1.symbol_at (0))
          {
            goto _continue1;
          }
          Expr _v_deref__lsplit__arg1 (_v_lsplit__arg1, 0);
          if (_v_deref__lsplit__arg1.get_len () != 4)
          {
            goto _continue1;
          }
          if (_v_deref__lsplit__arg1.symbol_at ((0 + 1 + 1 + 1)))
          {
            goto _continue1;
          }
          Expr _v_deref__deref__lsplit__arg1 (_v_deref__lsplit__arg1, (0 + 1 + 1 + 1));
          uintptr_t _v_len3 = _v_deref__deref__lsplit__arg1.get_len ();
          uintptr_t _v_len4 = 0;
          if (_v_len3 < _v_len4)
          {
            goto _continue1;
          }
          uintptr_t _v_len__require_m_i = (_v_len3 - _v_len4);
          if (!_c_61.term_eq (_v_deref__lsplit__arg1, (0 + 1 + 1)))
          {
            goto _continue1;
          }
          Expr _ve_2 (_v_lsplit__arg1, (0 + 1), _v_len__2);
          Expr _vt_var_m_i (_v_deref__lsplit__arg1, 0, 1);
          Expr _vt_Re_m_i (_v_deref__lsplit__arg1, (0 + 1), 1);
          Expr _ve_require_m_i (_v_deref__deref__lsplit__arg1, 0, _v_len__require_m_i);
          Expr _vs_vars;
          RF_CALL (Box::Box, empty, _vs_vars);
          {
            if ((_ve_1.get_len () + _v_len__2) < 1)
            {
              goto _block2__branch1;
            }
            Expr _v_compose1 ((_ve_1 + _ve_2));
            RF_lsplit (_v_compose1, 0, _ve__e__e_tmp_m_rfp__compilerf_m_988_m_16, _v_lsplit__compose1);
            for ( ; ; RF_iter(_v_compose1)++)
            {
              {
                if (!RF_iter(_v_compose1))
                {
                  goto _block2__branch1;
                }
                uintptr_t _v_len5 = _v_lsplit__compose1.get_len ();
                uintptr_t _v_len6 = 1;
                if (_v_len5 < _v_len6)
                {
                  goto _block2__branch1;
                }
                uintptr_t _v_len___e__e_tmp_m_rfp__compilerf_m_988_m_63 = (_v_len5 - _v_len6);
                if (_v_lsplit__compose1.symbol_at (0))
                {
                  goto _continue2;
                }
                Expr _v_deref__lsplit__compose1 (_v_lsplit__compose1, 0);
                if (_v_deref__lsplit__compose1.get_len () != 4)
                {
                  goto _continue2;
                }
                if (_v_deref__lsplit__compose1.symbol_at ((0 + 1 + 1)))
                {
                  goto _continue2;
                }
                if (_v_deref__lsplit__compose1.symbol_at ((0 + 1 + 1 + 1)))
                {
                  goto _continue2;
                }
                Expr _v_deref__deref__lsplit__compose1 (_v_deref__lsplit__compose1, (0 + 1 + 1));
                Expr _v_deref__deref__lsplit__compose12 (_v_deref__lsplit__compose1, (0 + 1 + 1 + 1));
                uintptr_t _v_len7 = _v_deref__deref__lsplit__compose12.get_len ();
                uintptr_t _v_len8 = 0;
                if (_v_len7 < _v_len8)
                {
                  goto _continue2;
                }
                uintptr_t _v_len__require_m_j = (_v_len7 - _v_len8);
                uintptr_t _v_len9 = _v_deref__deref__lsplit__compose1.get_len ();
                uintptr_t _v_len10 = 0;
                if (_v_len9 < _v_len10)
                {
                  goto _continue2;
                }
                uintptr_t _v_len__provide_m_j = (_v_len9 - _v_len10);
                Expr _ve__e__e_tmp_m_rfp__compilerf_m_988_m_63 (_v_lsplit__compose1, (0 + 1), _v_len___e__e_tmp_m_rfp__compilerf_m_988_m_63);
                Expr _vt_var_m_j (_v_deref__lsplit__compose1, 0, 1);
                Expr _vt_Re_m_j (_v_deref__lsplit__compose1, (0 + 1), 1);
                Expr _ve_provide_m_j (_v_deref__deref__lsplit__compose1, 0, _v_len__provide_m_j);
                Expr _ve_require_m_j (_v_deref__deref__lsplit__compose12, 0, _v_len__require_m_j);
                Expr _ge_auxcall1;
                RF_CALL (List::Sub, (_ve_provide_m_j, _vt_var_m_i), _ge_auxcall1);
                RF_CALL (Box::Put, (_vs_vars, (_vt_var_m_j + _vt_Re_m_j + _ge_auxcall1 () + _ve_require_m_j ()) ()), /*void*/);
              }
          _continue2: {}
            }
          _exit2: {}
          }
        _block2__branch1: {}
          Expr _ge_auxcall2;
          RF_CALL (Box::_q_, _vs_vars, _ge_auxcall2);
          Expr _v_Assign_m_Empty_m_Provides1;
          RF_CALL (Assign_m_Empty_m_Provides, _ge_auxcall2, (_v_Assign_m_Empty_m_Provides1, _v_res2));
          _v_res1 = ((_vt_var_m_i + _vt_Re_m_i) () + _v_Assign_m_Empty_m_Provides1);
          goto _exit1;
        }
    _continue1: {}
      }
    _exit1: {}
      goto _block1;
    }
  _block1__branch1: {}
    _v_res1 = empty;
    _v_res2 = _ge_arg1;
  }
_block1: {}
RF_END

RF_FUNC (Delay_m_Empty_m_Requires, (RF_ARG _ge_arg1;;), (RF_RES _v_res1, _v_res2;;))
  {
    {
      if (_ge_arg1.get_len () < 1)
      {
        goto _block1__branch1;
      }
      RF_lsplit (_ge_arg1, 0, _ve_1, _v_lsplit__arg1);
      for ( ; ; RF_iter(_ge_arg1)++)
      {
        {
          if (!RF_iter(_ge_arg1))
          {
            goto _block1__branch1;
          }
          uintptr_t _v_len1 = _v_lsplit__arg1.get_len ();
          uintptr_t _v_len2 = 1;
          if (_v_len1 < _v_len2)
          {
            goto _block1__branch1;
          }
          uintptr_t _v_len__2 = (_v_len1 - _v_len2);
          Expr _vt_var (_v_lsplit__arg1, 0, 1);
          Expr _ve_2 (_v_lsplit__arg1, (0 + 1), _v_len__2);
          if (_vt_var.symbol_at (0))
          {
            goto _continue1;
          }
          Expr _v_deref__var (_vt_var, 0);
          if (_v_deref__var.get_len () != 4)
          {
            goto _continue1;
          }
          if (_v_deref__var.symbol_at ((0 + 1 + 1)))
          {
            goto _continue1;
          }
          Expr _v_deref__deref__var (_v_deref__var, (0 + 1 + 1));
          uintptr_t _v_len3 = _v_deref__deref__var.get_len ();
          uintptr_t _v_len4 = 0;
          if (_v_len3 < _v_len4)
          {
            goto _continue1;
          }
          uintptr_t _v_len__provide_m_i = (_v_len3 - _v_len4);
          if (!_c_61.term_eq (_v_deref__var, (0 + 1 + 1 + 1)))
          {
            goto _continue1;
          }
          Expr _vt_var_m_i (_v_deref__var, 0, 1);
          Expr _vt_Re_m_i (_v_deref__var, (0 + 1), 1);
          Expr _ve_provide_m_i (_v_deref__deref__var, 0, _v_len__provide_m_i);
          Expr _ve_delayed;
          Expr _ve_vars;
          RF_CALL (Delay_m_Empty_m_Requires, _ve_2, (_ve_delayed, _ve_vars));
          _v_res1 = (_vt_var + _ve_delayed);
          _v_res2 = (_ve_1 + _ve_vars);
          goto _exit1;
        }
    _continue1: {}
      }
    _exit1: {}
      goto _block1;
    }
  _block1__branch1: {}
    _v_res1 = empty;
    _v_res2 = _ge_arg1;
  }
_block1: {}
RF_END

RF_FUNC (Max_m_Require, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  if (_ge_arg1.get_len () != 2)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _vt_arg1 (_ge_arg1, 0, 1);
  Expr _vt_arg2 (_ge_arg1, (0 + 1), 1);
  if (_vt_arg1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (_vt_arg2.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _v_deref__arg1 (_vt_arg1, 0);
  Expr _v_deref__arg2 (_vt_arg2, 0);
  if (_v_deref__arg2.get_len () != 4)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (_v_deref__arg1.get_len () != 4)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (_v_deref__arg1.symbol_at ((0 + 1 + 1 + 1)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (_v_deref__arg2.symbol_at ((0 + 1 + 1 + 1)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _v_deref__deref__arg1 (_v_deref__arg1, (0 + 1 + 1 + 1));
  Expr _v_deref__deref__arg2 (_v_deref__arg2, (0 + 1 + 1 + 1));
  uintptr_t _v_len1 = _v_deref__deref__arg2.get_len ();
  uintptr_t _v_len2 = 0;
  if (_v_len1 < _v_len2)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len__require2 = (_v_len1 - _v_len2);
  uintptr_t _v_len3 = _v_deref__deref__arg1.get_len ();
  uintptr_t _v_len4 = 0;
  if (_v_len3 < _v_len4)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len__require1 = (_v_len3 - _v_len4);
  Expr _vt_var1 (_v_deref__arg1, 0, 1);
  Expr _vt_Re1 (_v_deref__arg1, (0 + 1), 1);
  Expr _vt_provide1 (_v_deref__arg1, (0 + 1 + 1), 1);
  Expr _vt_var2 (_v_deref__arg2, 0, 1);
  Expr _vt_Re2 (_v_deref__arg2, (0 + 1), 1);
  Expr _vt_provide2 (_v_deref__arg2, (0 + 1 + 1), 1);
  Expr _ve_require1 (_v_deref__deref__arg1, 0, _v_len__require1);
  Expr _ve_require2 (_v_deref__deref__arg2, 0, _v_len__require2);
  {
    {
      Expr _gs_auxcall1;
      RF_CALL (Access::Length, _ve_require1, _gs_auxcall1);
      Expr _gs_auxcall2;
      RF_CALL (Access::Length, _ve_require2, _gs_auxcall2);
      if (!RF_CALL (Compare::_lt_, (_gs_auxcall1, _gs_auxcall2), /*void*/))
      {
        goto _block1__branch1;
      }
      _v_res1 = _vt_arg2;
      goto _block1;
    }
  _block1__branch1: {}
    _v_res1 = _vt_arg1;
  }
_block1: {}
RF_END

RF_FUNC (Subst_m_Aux_m_Var, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  if (_ge_arg1.get_len () != 3)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (_ge_arg1.symbol_at ((0 + 1 + 1)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _v_deref__arg1 (_ge_arg1, (0 + 1 + 1));
  if (_v_deref__arg1.get_len () != 4)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (_v_deref__arg1.symbol_at ((0 + 1 + 1)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (_v_deref__arg1.symbol_at ((0 + 1 + 1 + 1)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _v_deref__deref__arg1 (_v_deref__arg1, (0 + 1 + 1));
  Expr _v_deref__deref__arg12 (_v_deref__arg1, (0 + 1 + 1 + 1));
  uintptr_t _v_len1 = _v_deref__deref__arg12.get_len ();
  uintptr_t _v_len2 = 0;
  if (_v_len1 < _v_len2)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len__require = (_v_len1 - _v_len2);
  uintptr_t _v_len3 = _v_deref__deref__arg1.get_len ();
  uintptr_t _v_len4 = 0;
  if (_v_len3 < _v_len4)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len__provide = (_v_len3 - _v_len4);
  Expr _vt_var (_ge_arg1, 0, 1);
  Expr _vt_aux (_ge_arg1, (0 + 1), 1);
  Expr _vt_v (_v_deref__arg1, 0, 1);
  Expr _vt_Re (_v_deref__arg1, (0 + 1), 1);
  Expr _ve_provide (_v_deref__deref__arg1, 0, _v_len__provide);
  Expr _ve_require (_v_deref__deref__arg12, 0, _v_len__require);
  {
    {
      if (!_vt_v.term_eq (_vt_var, 0))
      {
        goto _block1__branch1;
      }
      _v_res1 = empty;
      goto _block1;
    }
  _block1__branch1: {}
    Expr _ge_auxcall1;
    RF_CALL (rfp__helper::Subst, (_vt_var, _vt_aux (), _vt_Re), _ge_auxcall1);
    Expr _ge_auxcall2;
    RF_CALL (List::Sub, (_ve_provide, _vt_var), _ge_auxcall2);
    Expr _ge_auxcall3;
    RF_CALL (List::Sub, (_ve_require, _vt_var), _ge_auxcall3);
    _v_res1 = (_vt_v + _ge_auxcall1 + _ge_auxcall2 () + _ge_auxcall3 ()) ();
  }
_block1: {}
RF_END

RF_FUNC (Extract_m_Assigns, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  if (_ge_arg1.get_len () != 1)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (_ge_arg1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _v_deref__arg1 (_ge_arg1, 0);
  uintptr_t _v_len1 = _v_deref__arg1.get_len ();
  uintptr_t _v_len2 = 2;
  if (_v_len1 < _v_len2)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len___e__e_tmp_m_rfp__compilerf_m_1048_m_30 = (_v_len1 - _v_len2);
  Expr _vt_var (_v_deref__arg1, 0, 1);
  Expr _vt_Re (_v_deref__arg1, (0 + 1), 1);
  Expr _ve__e__e_tmp_m_rfp__compilerf_m_1048_m_30 (_v_deref__arg1, (0 + 1 + 1), _v_len___e__e_tmp_m_rfp__compilerf_m_1048_m_30);
  _v_res1 = (_vt_var + _vt_Re) ();
RF_END

RF_FUNC (CAV, (RF_ARG _ve_vars, _ve_assigns, _ve_delayed;;), (RF_RES _v_res1;;))
  Expr _ve_new_m_assigns;
  Expr _ge_vars__0;
  RF_CALL (Assign_m_Empty_m_Provides, _ve_vars, (_ve_new_m_assigns, _ge_vars__0));
  Expr _v_Assign_m_Empty_m_Provides1;
  Expr _ge_delayed__0;
  RF_CALL (Assign_m_Empty_m_Provides, _ve_delayed, (_v_Assign_m_Empty_m_Provides1, _ge_delayed__0));
  Expr _ge_assigns__0 ((_ve_assigns + _ve_new_m_assigns + _v_Assign_m_Empty_m_Provides1));
  Expr _v_Delay_m_Empty_m_Requires1;
  RF_CALL (Delay_m_Empty_m_Requires, _ge_vars__0, (_v_Delay_m_Empty_m_Requires1, _ge_vars__0));
  _ge_delayed__0 = (_ge_delayed__0 + _v_Delay_m_Empty_m_Requires1);
  {
    {
      uintptr_t _v_len1 = _ge_vars__0.get_len ();
      uintptr_t _v_len2 = 2;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len___e__e_tmp_m_rfp__compilerf_m_1066_m_19 = (_v_len1 - _v_len2);
      Expr _vt__e__e_tmp_m_rfp__compilerf_m_1066_m_15 (_ge_vars__0, 0, 1);
      Expr _vt__e__e_tmp_m_rfp__compilerf_m_1066_m_17 (_ge_vars__0, (0 + 1), 1);
      Expr _ve__e__e_tmp_m_rfp__compilerf_m_1066_m_19 (_ge_vars__0, (0 + 1 + 1), _v_len___e__e_tmp_m_rfp__compilerf_m_1066_m_19);
      Expr _v_Foldr11;
      RF_CALL (List::Foldr1, (_c_111, empty, _ge_vars__0), _v_Foldr11);
      if (_v_Foldr11.get_len () != 1)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      if (_v_Foldr11.symbol_at (0))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      Expr _v_deref__Foldr11 (_v_Foldr11, 0);
      uintptr_t _v_len3 = _v_deref__Foldr11.get_len ();
      uintptr_t _v_len4 = 2;
      if (_v_len3 < _v_len4)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      uintptr_t _v_len___e__e_tmp_m_rfp__compilerf_m_1067_m_53 = (_v_len3 - _v_len4);
      Expr _vt_var (_v_deref__Foldr11, 0, 1);
      Expr _vt_Re (_v_deref__Foldr11, (0 + 1), 1);
      Expr _ve__e__e_tmp_m_rfp__compilerf_m_1067_m_53 (_v_deref__Foldr11, (0 + 1 + 1), _v_len___e__e_tmp_m_rfp__compilerf_m_1067_m_53);
      Expr _vt_aux;
      RF_CALL (Gener_m_Aux_m_Var, /*void*/, _vt_aux);
      Expr _ge_assigns__0__2 ((_ge_assigns__0 + (_vt_aux + _vt_var ()) () + (_vt_var + _vt_Re) ()));
      Expr _ge_vars__0__2;
      if (!RF_CALL (List::Map, (_c_112, (_vt_var + _vt_aux), _ge_vars__0), _ge_vars__0__2))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      Expr _ge_delayed__0__2;
      if (!RF_CALL (List::Map, (_c_112, (_vt_var + _vt_aux), _ge_delayed__0), _ge_delayed__0__2))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      RF_TAILCALL (CAV, (_ge_vars__0__2, _ge_assigns__0__2, _ge_delayed__0__2), _v_res1);
      goto _block1;
    }
  _block1__branch1: {}
    Expr _v_Map1;
    if (!RF_CALL (List::Map, (_c_113, empty, (_ge_vars__0 + _ge_delayed__0)), _v_Map1))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    _v_res1 = (_ge_assigns__0 + _v_Map1);
  }
_block1: {}
RF_END

RF_FUNC (Get_m_Clash_m_Sequence, (RF_ARG _ge_arg1, _ge_arg2;;), (RF_RES _v_res1, _v_res2;;))
  uintptr_t _v_len1 = (_ge_arg2.get_len () + 1);
  uintptr_t _v_len2 = 2;
  if (_v_len1 < _v_len2)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len__Snt = (_v_len1 - _v_len2);
  Expr _v_compose1 ((_ge_arg1 () + _ge_arg2));
  if (_v_compose1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _v_deref__compose1 (_v_compose1, 0);
  uintptr_t _v_len3 = _v_deref__compose1.get_len ();
  uintptr_t _v_len4 = 0;
  if (_v_len3 < _v_len4)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len__last_m_Re = (_v_len3 - _v_len4);
  Expr _vt_Pattern (_v_compose1, (0 + 1), 1);
  Expr _ve_Snt (_v_compose1, (0 + 1 + 1), _v_len__Snt);
  Expr _ve_last_m_Re (_v_deref__compose1, 0, _v_len__last_m_Re);
  Expr _ve_clashes (empty);
  _ve_Snt = ((_c_31 + _ve_last_m_Re) () + _vt_Pattern + _ve_Snt);
  for ( ; ; )
  {
    {
      {
        Expr _ve_Re;
        {
          {
            uintptr_t _v_len5 = _ve_Snt.get_len ();
            uintptr_t _v_len6 = 2;
            if (_v_len5 < _v_len6)
            {
              goto _block2__branch1;
            }
            uintptr_t _v_len___e__e_tmp_m_rfp__compilerf_m_1095_m_31 = (_v_len5 - _v_len6);
            if (_ve_Snt.symbol_at (0))
            {
              goto _block2__branch1;
            }
            if (_ve_Snt.symbol_at ((0 + 1)))
            {
              goto _block2__branch1;
            }
            Expr _v_deref__Snt (_ve_Snt, 0);
            Expr _v_deref__Snt2 (_ve_Snt, (0 + 1));
            uintptr_t _v_len7 = _v_deref__Snt2.get_len ();
            uintptr_t _v_len8 = 1;
            if (_v_len7 < _v_len8)
            {
              goto _block2__branch1;
            }
            uintptr_t _v_len___e__e_tmp_m_rfp__compilerf_m_1095_m_28 = (_v_len7 - _v_len8);
            uintptr_t _v_len9 = _v_deref__Snt.get_len ();
            uintptr_t _v_len10 = 1;
            if (_v_len9 < _v_len10)
            {
              goto _block2__branch1;
            }
            uintptr_t _v_len__Re__4 = (_v_len9 - _v_len10);
            if (!_c_31.term_eq (_v_deref__Snt, 0))
            {
              goto _block2__branch1;
            }
            if (!_c_29.term_eq (_v_deref__Snt2, 0))
            {
              goto _block2__branch1;
            }
            Expr _ve__e__e_tmp_m_rfp__compilerf_m_1095_m_31 (_ve_Snt, (0 + 1 + 1), _v_len___e__e_tmp_m_rfp__compilerf_m_1095_m_31);
            Expr _ge_Re__4 (_v_deref__Snt, (0 + 1), _v_len__Re__4);
            Expr _ve__e__e_tmp_m_rfp__compilerf_m_1095_m_28 (_v_deref__Snt2, (0 + 1), _v_len___e__e_tmp_m_rfp__compilerf_m_1095_m_28);
            _ve_Re = _ge_Re__4;
            goto _block2;
          }
        _block2__branch1: {}
          uintptr_t _v_len11 = _ve_Snt.get_len ();
          uintptr_t _v_len12 = 2;
          if (_v_len11 < _v_len12)
          {
            goto _negation1;
          }
          uintptr_t _v_len___e__e_tmp_m_rfp__compilerf_m_1096_m_32 = (_v_len11 - _v_len12);
          if (_ve_Snt.symbol_at (0))
          {
            goto _negation1;
          }
          if (_ve_Snt.symbol_at ((0 + 1)))
          {
            goto _negation1;
          }
          Expr _v_deref__Snt3 (_ve_Snt, 0);
          Expr _v_deref__Snt4 (_ve_Snt, (0 + 1));
          uintptr_t _v_len13 = _v_deref__Snt4.get_len ();
          uintptr_t _v_len14 = 1;
          if (_v_len13 < _v_len14)
          {
            goto _negation1;
          }
          uintptr_t _v_len___e__e_tmp_m_rfp__compilerf_m_1096_m_29 = (_v_len13 - _v_len14);
          uintptr_t _v_len15 = _v_deref__Snt3.get_len ();
          uintptr_t _v_len16 = 1;
          if (_v_len15 < _v_len16)
          {
            goto _negation1;
          }
          uintptr_t _v_len__Re__42 = (_v_len15 - _v_len16);
          if (!_c_31.term_eq (_v_deref__Snt3, 0))
          {
            goto _negation1;
          }
          if (!_c_62.term_eq (_v_deref__Snt4, 0))
          {
            goto _negation1;
          }
          Expr _ve__e__e_tmp_m_rfp__compilerf_m_1096_m_32 (_ve_Snt, (0 + 1 + 1), _v_len___e__e_tmp_m_rfp__compilerf_m_1096_m_32);
          Expr _ge_Re__4 (_v_deref__Snt3, (0 + 1), _v_len__Re__42);
          Expr _ve__e__e_tmp_m_rfp__compilerf_m_1096_m_29 (_v_deref__Snt4, (0 + 1), _v_len___e__e_tmp_m_rfp__compilerf_m_1096_m_29);
          _ve_Re = _ge_Re__4;
        }
      _block2: {}
        if (!RF_CALL (Without_m_Calls_q_, _ve_Re, /*void*/))
        {
          goto _negation1;
        }
        goto _iter1;
      }
    _negation1: {}
      _v_res1 = _ve_clashes;
      _v_res2 = _ve_Snt;
      goto _exit__iter1;
    }
  _iter1: {}
    uintptr_t _v_len17 = _ve_Snt.get_len ();
    uintptr_t _v_len18 = 2;
    if (_v_len17 < _v_len18)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    uintptr_t _v_len__rest = (_v_len17 - _v_len18);
    if (_ve_Snt.symbol_at (0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    if (_ve_Snt.symbol_at ((0 + 1)))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _v_deref__Snt5 (_ve_Snt, 0);
    Expr _v_deref__Snt6 (_ve_Snt, (0 + 1));
    uintptr_t _v_len19 = _v_deref__Snt6.get_len ();
    uintptr_t _v_len20 = 1;
    if (_v_len19 < _v_len20)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    uintptr_t _v_len__Pe = (_v_len19 - _v_len20);
    uintptr_t _v_len21 = _v_deref__Snt5.get_len ();
    uintptr_t _v_len22 = 1;
    if (_v_len21 < _v_len22)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    uintptr_t _v_len__Re = (_v_len21 - _v_len22);
    if (!_c_31.term_eq (_v_deref__Snt5, 0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    if (!_v_deref__Snt6.symbol_at (0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _ve_rest (_ve_Snt, (0 + 1 + 1), _v_len__rest);
    Expr _ve_Re (_v_deref__Snt5, (0 + 1), _v_len__Re);
    Expr _vs_dir (_v_deref__Snt6, 0, 1);
    Expr _ve_Pe (_v_deref__Snt6, (0 + 1), _v_len__Pe);
    Expr _v_Prepare_m_Res1;
    RF_CALL (Prepare_m_Res, (_ve_Re () + _ve_Pe ()), _v_Prepare_m_Res1);
    if (_v_Prepare_m_Res1.get_len () != 2)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    if (_v_Prepare_m_Res1.symbol_at (0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    if (_v_Prepare_m_Res1.symbol_at ((0 + 1)))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _v_deref__Prepare_m_Res1 (_v_Prepare_m_Res1, 0);
    Expr _v_deref__Prepare_m_Res12 (_v_Prepare_m_Res1, (0 + 1));
    uintptr_t _v_len23 = _v_deref__Prepare_m_Res12.get_len ();
    uintptr_t _v_len24 = 0;
    if (_v_len23 < _v_len24)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    uintptr_t _v_len__P1 = (_v_len23 - _v_len24);
    uintptr_t _v_len25 = _v_deref__Prepare_m_Res1.get_len ();
    uintptr_t _v_len26 = 0;
    if (_v_len25 < _v_len26)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    uintptr_t _v_len__R1 = (_v_len25 - _v_len26);
    Expr _ve_R1 (_v_deref__Prepare_m_Res1, 0, _v_len__R1);
    Expr _ve_P1 (_v_deref__Prepare_m_Res12, 0, _v_len__P1);
    Expr _ge_auxcall1;
    RF_CALL (rfp__vars::Vars, (_ve_R1 + _ve_P1), _ge_auxcall1);
    Expr _v_Map1;
    if (!RF_CALL (List::Map, (_c_36, _c_114, _ge_auxcall1), _v_Map1))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    uintptr_t _v_len27 = _v_Map1.get_len ();
    uintptr_t _v_len28 = 0;
    if (_v_len27 < _v_len28)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    uintptr_t _v_len___e__e_tmp_m_rfp__compilerf_m_1090_m_64 = (_v_len27 - _v_len28);
    Expr _ve__e__e_tmp_m_rfp__compilerf_m_1090_m_64 (_v_Map1, 0, _v_len___e__e_tmp_m_rfp__compilerf_m_1090_m_64);
    _ve_clashes = (_ve_clashes + _ve_R1 () + (_vs_dir + _ve_P1) ());
    _ve_Snt = _ve_rest;
  }
_exit__iter1: {}
RF_END

RF_FUNC (Without_m_Calls_q_, (RF_ARG _ve_Re;;), RF_VOID)
  Expr _ge_Re__0 (_ve_Re);
  for ( ; ; )
  {
    {
      if (_ge_Re__0.get_len () != 0)
      {
        goto _iter1;
      }
      goto _exit__iter1;
    }
  _iter1: {}
    uintptr_t _v_len1 = _ge_Re__0.get_len ();
    uintptr_t _v_len2 = 1;
    if (_v_len1 < _v_len2)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    uintptr_t _v_len__rest = (_v_len1 - _v_len2);
    Expr _vt_Rt (_ge_Re__0, 0, 1);
    Expr _ve_rest (_ge_Re__0, (0 + 1), _v_len__rest);
    {
      {
        if (_vt_Rt.symbol_at (0))
        {
          goto _block2__branch1;
        }
        Expr _v_deref__Rt (_vt_Rt, 0);
        uintptr_t _v_len3 = _v_deref__Rt.get_len ();
        uintptr_t _v_len4 = 1;
        if (_v_len3 < _v_len4)
        {
          goto _block2__branch1;
        }
        uintptr_t _v_len___e__e_tmp_m_rfp__compilerf_m_1106_m_16 = (_v_len3 - _v_len4);
        if (!_c_30.term_eq (_v_deref__Rt, 0))
        {
          goto _block2__branch1;
        }
        Expr _ve__e__e_tmp_m_rfp__compilerf_m_1106_m_16 (_v_deref__Rt, (0 + 1), _v_len___e__e_tmp_m_rfp__compilerf_m_1106_m_16);
        RF_RETFAIL;
      }
    _block2__branch1: {}
      {
        if (_vt_Rt.symbol_at (0))
        {
          goto _block2__branch2;
        }
        Expr _v_deref__Rt2 (_vt_Rt, 0);
        uintptr_t _v_len5 = _v_deref__Rt2.get_len ();
        uintptr_t _v_len6 = 1;
        if (_v_len5 < _v_len6)
        {
          goto _block2__branch2;
        }
        uintptr_t _v_len___e__e_tmp_m_rfp__compilerf_m_1107_m_17 = (_v_len5 - _v_len6);
        if (!_c_65.term_eq (_v_deref__Rt2, 0))
        {
          goto _block2__branch2;
        }
        Expr _ve__e__e_tmp_m_rfp__compilerf_m_1107_m_17 (_v_deref__Rt2, (0 + 1), _v_len___e__e_tmp_m_rfp__compilerf_m_1107_m_17);
        RF_RETFAIL;
      }
    _block2__branch2: {}
      {
        if (_vt_Rt.symbol_at (0))
        {
          goto _block2__branch3;
        }
        Expr _v_deref__Rt3 (_vt_Rt, 0);
        uintptr_t _v_len7 = _v_deref__Rt3.get_len ();
        uintptr_t _v_len8 = 1;
        if (_v_len7 < _v_len8)
        {
          goto _block2__branch3;
        }
        uintptr_t _v_len__Re1 = (_v_len7 - _v_len8);
        if (!_c_97.term_eq (_v_deref__Rt3, 0))
        {
          goto _block2__branch3;
        }
        Expr _ve_Re1 (_v_deref__Rt3, (0 + 1), _v_len__Re1);
        if (!RF_CALL (Without_m_Calls_q_, _ve_Re1, /*void*/))
        {
          RF_RETFAIL;
        }
        goto _block2;
      }
    _block2__branch3: {}
      Expr _vt_symbol_m_or_m_var (_vt_Rt, 0, 1);
    }
  _block2: {}
    _ge_Re__0 = _ve_rest;
  }
_exit__iter1: {}
RF_END

RF_FUNC (Comp_m_Clashes, (RF_ARG _ve_clashes, _vs_tail_q_, _vv_fails, _ve_Sentence;;), (RF_RES _v_res1;;))
  RF_CALL (rfp__clashes::Init_m_Clashes, _ve_clashes, /*void*/);
  Expr _gt_auxcall1;
  if (!RF_CALL (Access::R, (_c_58, _vv_fails), _gt_auxcall1))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  RF_TAILCALL (CC, (_vs_tail_q_, _vv_fails, _gt_auxcall1, _ve_Sentence), _v_res1);
RF_END

RF_FUNC (CC, (RF_ARG _vs_tail_q_, _vv_fails, _vt_end_m_cycle, _ve_Snt;;), (RF_RES _v_res1;;))
  {
    {
      Expr _v_Domain1;
      RF_CALL (Table::Domain, rfp__clashes::Known_m_Lengths, _v_Domain1);
      uintptr_t _v_len1 = _v_Domain1.get_len ();
      uintptr_t _v_len2 = 0;
      if (_v_len1 < (_v_len2 + 1))
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__clashes = (_v_len1 - _v_len2);
      Expr _vv_clashes (_v_Domain1, 0, _v_len__clashes);
      Expr _ge_auxcall1;
      RF_CALL (CC_m_Known_m_Lengths, (_vt_end_m_cycle, _vv_clashes), _ge_auxcall1);
      Expr _v_CC1;
      RF_CALL (CC, (_vs_tail_q_, _vv_fails, _vt_end_m_cycle, _ve_Snt), _v_CC1);
      _v_res1 = (_ge_auxcall1 + _v_CC1);
      goto _block1;
    }
  _block1__branch1: {}
    {
      Expr _v_Domain2;
      RF_CALL (Table::Domain, rfp__clashes::Compute_m_Length, _v_Domain2);
      uintptr_t _v_len3 = _v_Domain2.get_len ();
      uintptr_t _v_len4 = 1;
      if (_v_len3 < _v_len4)
      {
        goto _block1__branch2;
      }
      uintptr_t _v_len___e__e_tmp_m_rfp__compilerf_m_1135_m_41 = (_v_len3 - _v_len4);
      if (_v_Domain2.symbol_at (0))
      {
        goto _block1__branch2;
      }
      Expr _v_deref__Domain2 (_v_Domain2, 0);
      if (_v_deref__Domain2.get_len () != 1)
      {
        goto _block1__branch2;
      }
      Expr _ve__e__e_tmp_m_rfp__compilerf_m_1135_m_41 (_v_Domain2, (0 + 1), _v_len___e__e_tmp_m_rfp__compilerf_m_1135_m_41);
      Expr _vt_clash (_v_deref__Domain2, 0, 1);
      Expr _gt_auxcall2;
      if (!RF_CALL (Access::R, (_c_58, _vv_fails), _gt_auxcall2))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      Expr _ge_auxcall3;
      RF_CALL (CC_m_Compute_m_Length, (_gt_auxcall2, _vt_end_m_cycle, _vt_clash), _ge_auxcall3);
      Expr _v_CC2;
      RF_CALL (CC, (_vs_tail_q_, _vv_fails, _vt_end_m_cycle, _ve_Snt), _v_CC2);
      _v_res1 = (_ge_auxcall3 + _v_CC2);
      goto _block1;
    }
  _block1__branch2: {}
    Expr _v_Domain3;
    RF_CALL (Table::Domain, rfp__clashes::Unknown_m_Lengths, _v_Domain3);
    uintptr_t _v_len5 = _v_Domain3.get_len ();
    uintptr_t _v_len6 = 0;
    if (_v_len5 < _v_len6)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    uintptr_t _v_len__clashes2 = (_v_len5 - _v_len6);
    Expr _ve_clashes (_v_Domain3, 0, _v_len__clashes2);
    Expr _ve_conds;
    RF_CALL (CC_m_Unknown_m_Lengths, (_vt_end_m_cycle, _ve_clashes), _ve_conds);
    Expr _v_Update_m_Hard_m_Parts1;
    RF_CALL (rfp__clashes::Update_m_Hard_m_Parts, /*void*/, _v_Update_m_Hard_m_Parts1);
    {
      {
        uintptr_t _v_len7 = _v_Update_m_Hard_m_Parts1.get_len ();
        uintptr_t _v_len8 = 0;
        if (_v_len7 < (_v_len8 + 1))
        {
          goto _block2__branch1;
        }
        uintptr_t _v_len__actions = (_v_len7 - _v_len8);
        Expr _vv_actions (_v_Update_m_Hard_m_Parts1, 0, _v_len__actions);
        Expr _gt_auxcall4;
        if (!RF_CALL (Access::R, (_c_58, _vv_fails), _gt_auxcall4))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        Expr _ge_auxcall5;
        RF_CALL (CC_m_Deref, (_gt_auxcall4, _vv_actions), _ge_auxcall5);
        Expr _gt_auxcall6;
        if (!RF_CALL (Access::R, (_c_58, _vv_fails), _gt_auxcall6))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        Expr _v_CC3;
        RF_CALL (CC, (_vs_tail_q_, _vv_fails, _gt_auxcall6, _ve_Snt), _v_CC3);
        _v_res1 = (_ve_conds + _ge_auxcall5 + _v_CC3);
        goto _block2;
      }
    _block2__branch1: {}
      if (_v_Update_m_Hard_m_Parts1.get_len () != 0)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      Expr _gt_auxcall7;
      if (!RF_CALL (Access::R, (_c_58, _vv_fails), _gt_auxcall7))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      Expr _ge_auxcall8;
      RF_CALL (Box::_q_, rfp__clashes::Eqs, _ge_auxcall8);
      Expr _v_CC_m_Eqs1;
      RF_CALL (CC_m_Eqs, (_gt_auxcall7, empty, _ge_auxcall8), _v_CC_m_Eqs1);
      Expr _ve_actions ((_ve_conds + _v_CC_m_Eqs1));
      RF_CALL (Box::Store, (rfp__clashes::Eqs, empty), /*void*/);
      {
        {
          Expr _ve_assign;
          if (!RF_CALL (rfp__clashes::Compose_m_Source, /*void*/, _ve_assign))
          {
            goto _block3__branch1;
          }
          Expr _gt_auxcall9;
          if (!RF_CALL (Access::R, (_c_58, _vv_fails), _gt_auxcall9))
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          Expr _ge_auxcall10;
          RF_CALL (CC_m_Eqs, (_gt_auxcall9, empty, _ve_assign), _ge_auxcall10);
          Expr _gt_auxcall11;
          if (!RF_CALL (Access::R, (_c_58, _vv_fails), _gt_auxcall11))
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          Expr _v_CC4;
          RF_CALL (CC, (_vs_tail_q_, _vv_fails, _gt_auxcall11, _ve_Snt), _v_CC4);
          _v_res1 = (_ve_actions + _ge_auxcall10 + _v_CC4);
          goto _block3;
        }
      _block3__branch1: {}
        {
          {
            Expr _vs_split;
            Expr _ve_left;
            Expr _ve_right;
            Expr _ve_len;
            Expr _vt_var;
            Expr _vt_l_m_var;
            Expr _vt_r_m_var;
            if (!RF_CALL (rfp__clashes::Get_m_Cycle, /*void*/, (_vs_split, _ve_left, _ve_right, _ve_len, _vt_var, _vt_l_m_var, _vt_r_m_var)))
            {
              goto _block4__branch1;
            }
            Expr _ve_subexpr;
            Expr _gt_var__9;
            {
              {
                if (_ve_right.get_len () != 1)
                {
                  goto _block5__branch1;
                }
                if (_ve_left.get_len () != 1)
                {
                  goto _block5__branch1;
                }
                if (!_c_58.term_eq (_ve_left, 0))
                {
                  goto _block5__branch1;
                }
                if (!_c_58.term_eq (_ve_right, 0))
                {
                  goto _block5__branch1;
                }
                _ve_subexpr = empty;
                _gt_var__9 = _vt_var;
                goto _block5;
              }
            _block5__branch1: {}
              Expr _v_Gener_m_Vars1;
              RF_CALL (rfp__vars::Gener_m_Vars, (_c_115, (_c_116 + _vt_var)), _v_Gener_m_Vars1);
              if (_v_Gener_m_Vars1.get_len () != 1)
              {
                RF_FUNC_ERROR (unexpected_fail);
              }
              Expr _vt_sub_m_var (_v_Gener_m_Vars1, 0, 1);
              _ve_subexpr = (_c_48 + _vt_sub_m_var + _vt_var + _ve_left () + (_c_117 + _ve_len () + (_ve_left + _ve_right) ()) () ()) ();
              _gt_var__9 = _vt_sub_m_var;
            }
          _block5: {}
            Expr _gt_l_m_var__10;
            Expr _gt_r_m_var__10;
            Expr _vs_iter_m_op;
            {
              {
                if (!_vs_split.term_eq (_c_118, 0))
                {
                  goto _block6__branch1;
                }
                _gt_l_m_var__10 = _vt_r_m_var;
                _gt_r_m_var__10 = _vt_l_m_var;
                _vs_iter_m_op = _c_119;
                goto _block6;
              }
            _block6__branch1: {}
              _gt_l_m_var__10 = _vt_l_m_var;
              _gt_r_m_var__10 = _vt_r_m_var;
              _vs_iter_m_op = _c_120;
            }
          _block6: {}
            Expr _vt_cont_m_label;
            RF_CALL (Gener_m_Label, _c_121, _vt_cont_m_label);
            Expr _vt_break_m_label;
            RF_CALL (Gener_m_Label, _c_122, _vt_break_m_label);
            Expr _ge_auxcall12;
            if (!RF_CALL (rfp__vars::Get_m_Var, (_c_123, _gt_l_m_var__10), _ge_auxcall12))
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            Expr _gt_auxcall13;
            if (!RF_CALL (Access::R, (_c_58, _vv_fails), _gt_auxcall13))
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            Expr _ge_auxcall14;
            RF_CALL (List::Concat, _gt_auxcall13, _ge_auxcall14);
            Expr _gt_auxcall15;
            if (!RF_CALL (Access::R, (_c_58, _vv_fails), _gt_auxcall15))
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            Expr _ge_auxcall16;
            RF_CALL (CC, (_vs_tail_q_, (_vv_fails + (_c_124 + _vt_cont_m_label) () ()), _gt_auxcall15, _ve_Snt), _ge_auxcall16);
            _v_res1 = (_ve_actions + _ve_subexpr + (_vs_split + _gt_var__9 + _ge_auxcall12 () + _gt_l_m_var__10 + _gt_r_m_var__10) () + (_c_126 + _vt_cont_m_label () + _vt_break_m_label () + _c_61 + (_vs_iter_m_op + _gt_var__9) () () + (_c_99 + (_c_125 + _gt_var__9) () + _ge_auxcall14) () + _ge_auxcall16 + (_c_76 + _vt_break_m_label) ()) ());
            goto _block4;
          }
        _block4__branch1: {}
          Expr _v_Comp_m_Sentence1;
          RF_CALL (Comp_m_Sentence, (_vs_tail_q_ + _vv_fails () + _c_61 + _ve_Snt), _v_Comp_m_Sentence1);
          _v_res1 = (_ve_actions + _v_Comp_m_Sentence1);
        }
      _block4: {}
      }
    _block3: {}
    }
  _block2: {}
  }
_block1: {}
RF_END

RF_FUNC (CC_m_Known_m_Lengths, (RF_ARG _gt_arg1, _ge_arg2;;), (RF_RES _v_res1;;))
  uintptr_t _v_len1 = (_ge_arg2.get_len () + 1);
  uintptr_t _v_len2 = 1;
  if (_v_len1 < _v_len2)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len__idxs = (_v_len1 - _v_len2);
  Expr _v_compose1 ((_gt_arg1 + _ge_arg2));
  if (_v_compose1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _v_deref__compose1 (_v_compose1, 0);
  uintptr_t _v_len3 = _v_deref__compose1.get_len ();
  uintptr_t _v_len4 = 0;
  if (_v_len3 < _v_len4)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len__fail = (_v_len3 - _v_len4);
  Expr _ve_idxs (_v_compose1, (0 + 1), _v_len__idxs);
  Expr _ve_fail (_v_deref__compose1, 0, _v_len__fail);
  {
    {
      uintptr_t _v_len5 = _v_len__idxs;
      uintptr_t _v_len6 = 1;
      if (_v_len5 < _v_len6)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__rest = (_v_len5 - _v_len6);
      if (_ve_idxs.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__idxs (_ve_idxs, 0);
      if (_v_deref__idxs.get_len () != 1)
      {
        goto _block1__branch1;
      }
      Expr _ve_rest (_ve_idxs, (0 + 1), _v_len__rest);
      Expr _vt_idx (_v_deref__idxs, 0, 1);
      RF_CALL (Box::Put, (rfp__clashes::Checked_m_Lengths, _vt_idx), /*void*/);
      Expr _v_Lookup1;
      if (!RF_CALL (Table::Lookup, (rfp__clashes::Known_m_Lengths, _vt_idx), _v_Lookup1))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      if (_v_Lookup1.get_len () != 2)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      if (_v_Lookup1.symbol_at (0))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      if (_v_Lookup1.symbol_at ((0 + 1)))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      Expr _v_deref__Lookup1 (_v_Lookup1, 0);
      Expr _v_deref__Lookup12 (_v_Lookup1, (0 + 1));
      uintptr_t _v_len7 = _v_deref__Lookup12.get_len ();
      uintptr_t _v_len8 = 0;
      if (_v_len7 < _v_len8)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      uintptr_t _v_len__len_m_Pe = (_v_len7 - _v_len8);
      uintptr_t _v_len9 = _v_deref__Lookup1.get_len ();
      uintptr_t _v_len10 = 0;
      if (_v_len9 < _v_len10)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      uintptr_t _v_len__len_m_Re = (_v_len9 - _v_len10);
      Expr _ve_len_m_Re (_v_deref__Lookup1, 0, _v_len__len_m_Re);
      Expr _ve_len_m_Pe (_v_deref__Lookup12, 0, _v_len__len_m_Pe);
      Expr _v_CC_m_Known_m_Lengths1;
      RF_CALL (CC_m_Known_m_Lengths, (_ve_fail (), _ve_rest), _v_CC_m_Known_m_Lengths1);
      _v_res1 = ((_c_127 + _ve_len_m_Re () + _ve_len_m_Pe () + _ve_fail) () + _v_CC_m_Known_m_Lengths1);
      goto _block1;
    }
  _block1__branch1: {}
    RF_CALL (rfp__helper::RFP_m_Clear_m_Table, rfp__clashes::Known_m_Lengths, /*void*/);
    _v_res1 = empty;
  }
_block1: {}
RF_END

RF_FUNC (CC_m_Compute_m_Length, (RF_ARG _gt_arg1, _gt_arg2, _gt_arg3;;), (RF_RES _v_res1;;))
  Expr _v_compose1 ((_gt_arg1 + _gt_arg2 + _gt_arg3));
  if (_v_compose1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (_v_compose1.symbol_at ((0 + 1)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _v_deref__compose1 (_v_compose1, 0);
  Expr _v_deref__compose12 (_v_compose1, (0 + 1));
  uintptr_t _v_len1 = _v_deref__compose12.get_len ();
  uintptr_t _v_len2 = 0;
  if (_v_len1 < _v_len2)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len__end_m_cycle = (_v_len1 - _v_len2);
  uintptr_t _v_len3 = _v_deref__compose1.get_len ();
  uintptr_t _v_len4 = 0;
  if (_v_len3 < _v_len4)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len__fail = (_v_len3 - _v_len4);
  Expr _vt_idx (_v_compose1, (0 + 1 + 1), 1);
  Expr _ve_fail (_v_deref__compose1, 0, _v_len__fail);
  Expr _ve_end_m_cycle (_v_deref__compose12, 0, _v_len__end_m_cycle);
  Expr _v_Lookup1;
  if (!RF_CALL (Table::Lookup, (rfp__clashes::Compute_m_Length, _vt_idx), _v_Lookup1))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (_v_Lookup1.get_len () != 4)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (_v_Lookup1.symbol_at ((0 + 1 + 1)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (_v_Lookup1.symbol_at ((0 + 1 + 1 + 1)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _v_deref__Lookup1 (_v_Lookup1, (0 + 1 + 1));
  Expr _v_deref__Lookup12 (_v_Lookup1, (0 + 1 + 1 + 1));
  uintptr_t _v_len5 = _v_deref__Lookup12.get_len ();
  uintptr_t _v_len6 = 0;
  if (_v_len5 < _v_len6)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len__subtrahend = (_v_len5 - _v_len6);
  uintptr_t _v_len7 = _v_deref__Lookup1.get_len ();
  uintptr_t _v_len8 = 0;
  if (_v_len7 < _v_len8)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len__minuend = (_v_len7 - _v_len8);
  if (!_v_Lookup1.symbol_at ((0 + 1)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _vt_var (_v_Lookup1, 0, 1);
  Expr _vs_mult (_v_Lookup1, (0 + 1), 1);
  Expr _ve_minuend (_v_deref__Lookup1, 0, _v_len__minuend);
  Expr _ve_subtrahend (_v_deref__Lookup12, 0, _v_len__subtrahend);
  Expr _ve_min;
  if (!RF_CALL (rfp__vars::Get_m_Var, (_c_123, _vt_var), _ve_min))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  {
    {
      if (_vt_var.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__var (_vt_var, 0);
      uintptr_t _v_len9 = _v_deref__var.get_len ();
      uintptr_t _v_len10 = 1;
      if (_v_len9 < _v_len10)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len___e__e_tmp_m_rfp__compilerf_m_1203_m_23 = (_v_len9 - _v_len10);
      if (!_c_128.term_eq (_v_deref__var, 0))
      {
        goto _block1__branch1;
      }
      Expr _ve__e__e_tmp_m_rfp__compilerf_m_1203_m_23 (_v_deref__var, (0 + 1), _v_len___e__e_tmp_m_rfp__compilerf_m_1203_m_23);
      RF_CALL (Table::Unbind, (rfp__clashes::Compute_m_Length, _vt_idx), /*void*/);
      _v_res1 = (_c_131 + _ve_minuend () + (_c_130 + _ve_subtrahend () + (_c_129 + _ve_min () + _vs_mult ()) () ()) () () + _ve_end_m_cycle) ();
      goto _block1;
    }
  _block1__branch1: {}
    Expr _vt_m_m_var;
    Expr _ve_m_m_assign;
    RF_CALL (rfp__vars::Create_m_Int_m_Var, (_c_132, _c_133, _ve_minuend), (_vt_m_m_var, _ve_m_m_assign));
    Expr _vt_s_m_var;
    Expr _ve_s_m_assign;
    RF_CALL (rfp__vars::Create_m_Int_m_Var, (_c_132, _c_133, _ve_subtrahend), (_vt_s_m_var, _ve_s_m_assign));
    Expr _ve_min_m_cond ((_c_131 + _vt_m_m_var () + (_c_130 + _vt_s_m_var () + (_c_129 + _ve_min () + _vs_mult ()) () ()) () () + _ve_end_m_cycle) ());
    Expr _v_Get_m_Var1;
    if (!RF_CALL (rfp__vars::Get_m_Var, (_c_134, _vt_var), _v_Get_m_Var1))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _ve_max_m_cond;
    {
      {
        if (_v_Get_m_Var1.get_len () != 0)
        {
          goto _block2__branch1;
        }
        _ve_max_m_cond = empty;
        goto _block2;
      }
    _block2__branch1: {}
      uintptr_t _v_len11 = _v_Get_m_Var1.get_len ();
      uintptr_t _v_len12 = 0;
      if (_v_len11 < _v_len12)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      uintptr_t _v_len__max = (_v_len11 - _v_len12);
      Expr _ve_max (_v_Get_m_Var1, 0, _v_len__max);
      _ve_max_m_cond = (_c_135 + _vt_m_m_var () + (_c_130 + _vt_s_m_var () + (_c_129 + _ve_max () + _vs_mult ()) () ()) () () + _ve_end_m_cycle) ();
    }
  _block2: {}
    Expr _ve_div_m_cond ((_c_136 + (_c_117 + _vt_m_m_var () + _vt_s_m_var ()) () () + _vs_mult ()) ());
    Expr _vt_len_m_var;
    Expr _ve_len_m_assign;
    RF_CALL (rfp__vars::Create_m_Int_m_Var, (_c_137, _vt_var, (_c_138 + (_c_117 + _vt_m_m_var () + _vt_s_m_var ()) () () + _vs_mult ()) ()), (_vt_len_m_var, _ve_len_m_assign));
    RF_CALL (rfp__vars::Set_m_Var, ((_c_139 + _vt_len_m_var) (), _vt_var), /*void*/);
    RF_CALL (Table::Unbind, (rfp__clashes::Compute_m_Length, _vt_idx), /*void*/);
    RF_CALL (Box::Put, (rfp__clashes::Checked_m_Lengths, _vt_idx), /*void*/);
    Expr _ve_clashes;
    if (!RF_CALL (rfp__vars::Get_m_Var, (_c_140, _vt_var), _ve_clashes))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _ge_auxcall1;
    RF_CALL (Box::_q_, rfp__clashes::Checked_m_Lengths, _ge_auxcall1);
    Expr _ge_auxcall2;
    RF_CALL (List::Sub, (_ve_clashes, _ge_auxcall1), _ge_auxcall2);
    Expr _v_Map1;
    if (!RF_CALL (List::Map, (_c_141, empty, _ge_auxcall2), _v_Map1))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    uintptr_t _v_len13 = _v_Map1.get_len ();
    uintptr_t _v_len14 = 0;
    if (_v_len13 < _v_len14)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    uintptr_t _v_len___e__e_tmp_m_rfp__compilerf_m_1236_m_75 = (_v_len13 - _v_len14);
    Expr _ve__e__e_tmp_m_rfp__compilerf_m_1236_m_75 (_v_Map1, 0, _v_len___e__e_tmp_m_rfp__compilerf_m_1236_m_75);
    _v_res1 = (_ve_m_m_assign + _ve_s_m_assign + _ve_min_m_cond + _ve_max_m_cond + (_c_127 + _ve_div_m_cond () + _c_142 + _ve_fail) () + _ve_len_m_assign);
  }
_block1: {}
RF_END

RF_FUNC (CC_m_Unknown_m_Lengths, (RF_ARG _gt_arg1, _ge_arg2;;), (RF_RES _v_res1;;))
  uintptr_t _v_len1 = (_ge_arg2.get_len () + 1);
  uintptr_t _v_len2 = 1;
  if (_v_len1 < _v_len2)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len__idxs = (_v_len1 - _v_len2);
  Expr _v_compose1 ((_gt_arg1 + _ge_arg2));
  if (_v_compose1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _v_deref__compose1 (_v_compose1, 0);
  uintptr_t _v_len3 = _v_deref__compose1.get_len ();
  uintptr_t _v_len4 = 0;
  if (_v_len3 < _v_len4)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len__fail = (_v_len3 - _v_len4);
  Expr _ve_idxs (_v_compose1, (0 + 1), _v_len__idxs);
  Expr _ve_fail (_v_deref__compose1, 0, _v_len__fail);
  {
    {
      uintptr_t _v_len5 = _v_len__idxs;
      uintptr_t _v_len6 = 1;
      if (_v_len5 < _v_len6)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__rest = (_v_len5 - _v_len6);
      if (_ve_idxs.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__idxs (_ve_idxs, 0);
      if (_v_deref__idxs.get_len () != 1)
      {
        goto _block1__branch1;
      }
      Expr _ve_rest (_ve_idxs, (0 + 1), _v_len__rest);
      Expr _vt_idx (_v_deref__idxs, 0, 1);
      Expr _v_Lookup1;
      if (!RF_CALL (Table::Lookup, (rfp__clashes::Unknown_m_Lengths, _vt_idx), _v_Lookup1))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      if (_v_Lookup1.get_len () != 4)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      if (_v_Lookup1.symbol_at (0))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      if (_v_Lookup1.symbol_at ((0 + 1)))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      if (_v_Lookup1.symbol_at ((0 + 1 + 1)))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      if (_v_Lookup1.symbol_at ((0 + 1 + 1 + 1)))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      Expr _v_deref__Lookup1 (_v_Lookup1, 0);
      Expr _v_deref__Lookup12 (_v_Lookup1, (0 + 1));
      Expr _v_deref__Lookup13 (_v_Lookup1, (0 + 1 + 1));
      Expr _v_deref__Lookup14 (_v_Lookup1, (0 + 1 + 1 + 1));
      uintptr_t _v_len7 = _v_deref__Lookup1.get_len ();
      uintptr_t _v_len8 = 0;
      if (_v_len7 < _v_len8)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      uintptr_t _v_len__len_m_Re = (_v_len7 - _v_len8);
      uintptr_t _v_len9 = _v_deref__Lookup12.get_len ();
      uintptr_t _v_len10 = 0;
      if (_v_len9 < _v_len10)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      uintptr_t _v_len__len_m_Pe = (_v_len9 - _v_len10);
      uintptr_t _v_len11 = _v_deref__Lookup14.get_len ();
      uintptr_t _v_len12 = 0;
      if (_v_len11 < _v_len12)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      uintptr_t _v_len__vars_m_Pe = (_v_len11 - _v_len12);
      uintptr_t _v_len13 = _v_deref__Lookup13.get_len ();
      uintptr_t _v_len14 = 0;
      if (_v_len13 < _v_len14)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      uintptr_t _v_len__vars_m_Re = (_v_len13 - _v_len14);
      Expr _ve_len_m_Re (_v_deref__Lookup1, 0, _v_len__len_m_Re);
      Expr _ve_len_m_Pe (_v_deref__Lookup12, 0, _v_len__len_m_Pe);
      Expr _ve_vars_m_Re (_v_deref__Lookup13, 0, _v_len__vars_m_Re);
      Expr _ve_vars_m_Pe (_v_deref__Lookup14, 0, _v_len__vars_m_Pe);
      Expr _ve_cond1;
      {
        {
          Expr _ve_max;
          if (!RF_CALL (Get_m_Max, _ve_vars_m_Re, _ve_max))
          {
            goto _block2__branch1;
          }
          Expr _ve_min;
          RF_CALL (Get_m_Min, _ve_vars_m_Pe, _ve_min);
          _ve_cond1 = (_c_131 + (_ve_len_m_Re + _ve_max) () + (_ve_len_m_Pe + _ve_min) () + _ve_fail) ();
          goto _block2;
        }
      _block2__branch1: {}
        _ve_cond1 = empty;
      }
    _block2: {}
      Expr _ve_cond2;
      {
        {
          Expr _ve_max;
          if (!RF_CALL (Get_m_Max, _ve_vars_m_Pe, _ve_max))
          {
            goto _block3__branch1;
          }
          Expr _ve_min;
          RF_CALL (Get_m_Min, _ve_vars_m_Re, _ve_min);
          _ve_cond2 = (_c_135 + (_ve_len_m_Re + _ve_min) () + (_ve_len_m_Pe + _ve_max) () + _ve_fail) ();
          goto _block3;
        }
      _block3__branch1: {}
        _ve_cond2 = empty;
      }
    _block3: {}
      Expr _v_CC_m_Unknown_m_Lengths1;
      RF_CALL (CC_m_Unknown_m_Lengths, (_ve_fail (), _ve_rest), _v_CC_m_Unknown_m_Lengths1);
      _v_res1 = (_ve_cond1 + _ve_cond2 + _v_CC_m_Unknown_m_Lengths1);
      goto _block1;
    }
  _block1__branch1: {}
    RF_CALL (rfp__helper::RFP_m_Clear_m_Table, rfp__clashes::Unknown_m_Lengths, /*void*/);
    _v_res1 = empty;
  }
_block1: {}
RF_END

RF_FUNC (Get_m_Min, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  {
    {
      uintptr_t _v_len1 = _ge_arg1.get_len ();
      uintptr_t _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__vars = (_v_len1 - _v_len2);
      Expr _vt_var (_ge_arg1, 0, 1);
      Expr _ve_vars (_ge_arg1, (0 + 1), _v_len__vars);
      Expr _ge_auxcall1;
      if (!RF_CALL (rfp__vars::Get_m_Var, (_c_123, _vt_var), _ge_auxcall1))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      Expr _v_Get_m_Min1;
      RF_CALL (Get_m_Min, _ve_vars, _v_Get_m_Min1);
      _v_res1 = (_ge_auxcall1 + _v_Get_m_Min1);
      goto _block1;
    }
  _block1__branch1: {}
    if (_ge_arg1.get_len () != 0)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    _v_res1 = empty;
  }
_block1: {}
RF_END

RF_FUNC (Get_m_Max, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  {
    {
      uintptr_t _v_len1 = _ge_arg1.get_len ();
      uintptr_t _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__vars = (_v_len1 - _v_len2);
      Expr _vt_var (_ge_arg1, 0, 1);
      Expr _ve_vars (_ge_arg1, (0 + 1), _v_len__vars);
      Expr _v_Get_m_Var1;
      if (!RF_CALL (rfp__vars::Get_m_Var, (_c_134, _vt_var), _v_Get_m_Var1))
      {
        RF_RETFAIL;
      }
      uintptr_t _v_len3 = _v_Get_m_Var1.get_len ();
      uintptr_t _v_len4 = 0;
      if (_v_len3 < (_v_len4 + 1))
      {
        RF_RETFAIL;
      }
      uintptr_t _v_len__max = (_v_len3 - _v_len4);
      Expr _vv_max (_v_Get_m_Var1, 0, _v_len__max);
      Expr _v_Get_m_Max1;
      if (!RF_CALL (Get_m_Max, _ve_vars, _v_Get_m_Max1))
      {
        RF_RETFAIL;
      }
      _v_res1 = (_vv_max + _v_Get_m_Max1);
      goto _block1;
    }
  _block1__branch1: {}
    if (_ge_arg1.get_len () != 0)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    _v_res1 = empty;
  }
_block1: {}
RF_END

RF_FUNC (Pos, (RF_ARG _ge_arg1, _gs_arg2, _ge_arg3;;), (RF_RES _v_res1;;))
  {
    {
      uintptr_t _v_len1 = (_ge_arg3.get_len () + 2);
      uintptr_t _v_len2 = 2;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__pos = (_v_len1 - _v_len2);
      Expr _v_compose1 ((_ge_arg1 () + _gs_arg2 + _ge_arg3));
      if (_v_compose1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__compose1 (_v_compose1, 0);
      uintptr_t _v_len3 = _v_deref__compose1.get_len ();
      uintptr_t _v_len4 = 0;
      if (_v_len3 < _v_len4)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__Re = (_v_len3 - _v_len4);
      if (!_c_62.term_eq (_v_compose1, (0 + 1)))
      {
        goto _block1__branch1;
      }
      Expr _ve_pos (_v_compose1, (0 + 1 + 1), _v_len__pos);
      Expr _ve_Re (_v_deref__compose1, 0, _v_len__Re);
      _v_res1 = (_c_117 + (_c_143 + _ve_Re) () () + _c_144 + _ve_pos ()) ();
      goto _block1;
    }
  _block1__branch1: {}
    uintptr_t _v_len5 = (_ge_arg3.get_len () + 2);
    uintptr_t _v_len6 = 2;
    if (_v_len5 < _v_len6)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    uintptr_t _v_len__pos2 = (_v_len5 - _v_len6);
    Expr _v_compose2 ((_ge_arg1 () + _gs_arg2 + _ge_arg3));
    if (_v_compose2.symbol_at (0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _v_deref__compose2 (_v_compose2, 0);
    uintptr_t _v_len7 = _v_deref__compose2.get_len ();
    uintptr_t _v_len8 = 0;
    if (_v_len7 < _v_len8)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    uintptr_t _v_len__Re2 = (_v_len7 - _v_len8);
    if (!_c_29.term_eq (_v_compose2, (0 + 1)))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _ve_pos (_v_compose2, (0 + 1 + 1), _v_len__pos2);
    Expr _ve_Re (_v_deref__compose2, 0, _v_len__Re2);
    _v_res1 = _ve_pos;
  }
_block1: {}
RF_END

RF_FUNC (CC_m_Deref, (RF_ARG _gt_arg1, _ge_arg2;;), (RF_RES _v_res1;;))
  uintptr_t _v_len1 = (_ge_arg2.get_len () + 1);
  uintptr_t _v_len2 = 1;
  if (_v_len1 < _v_len2)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len__actions = (_v_len1 - _v_len2);
  Expr _v_compose1 ((_gt_arg1 + _ge_arg2));
  if (_v_compose1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _v_deref__compose1 (_v_compose1, 0);
  uintptr_t _v_len3 = _v_deref__compose1.get_len ();
  uintptr_t _v_len4 = 0;
  if (_v_len3 < _v_len4)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len__fail = (_v_len3 - _v_len4);
  Expr _ve_actions (_v_compose1, (0 + 1), _v_len__actions);
  Expr _ve_fail (_v_deref__compose1, 0, _v_len__fail);
  {
    {
      uintptr_t _v_len5 = _v_len__actions;
      uintptr_t _v_len6 = 1;
      if (_v_len5 < _v_len6)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__rest = (_v_len5 - _v_len6);
      if (_ve_actions.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__actions (_ve_actions, 0);
      uintptr_t _v_len7 = _v_deref__actions.get_len ();
      uintptr_t _v_len8 = 2;
      if (_v_len7 < _v_len8)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__Re = (_v_len7 - _v_len8);
      if (_v_deref__actions.symbol_at ((0 + 1 + _v_len__Re)))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__deref__actions (_v_deref__actions, (0 + 1 + _v_len__Re));
      uintptr_t _v_len9 = _v_deref__deref__actions.get_len ();
      uintptr_t _v_len10 = 1;
      if (_v_len9 < _v_len10)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__pos = (_v_len9 - _v_len10);
      if (!_c_145.term_eq (_v_deref__actions, 0))
      {
        goto _block1__branch1;
      }
      if (!_v_deref__deref__actions.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _ve_rest (_ve_actions, (0 + 1), _v_len__rest);
      Expr _ve_Re (_v_deref__actions, (0 + 1), _v_len__Re);
      Expr _vs_dir (_v_deref__deref__actions, 0, 1);
      Expr _ve_pos (_v_deref__deref__actions, (0 + 1), _v_len__pos);
      Expr _ge_auxcall1;
      RF_CALL (Pos, (_ve_Re, _vs_dir, _ve_pos), _ge_auxcall1);
      Expr _v_CC_m_Deref1;
      RF_CALL (CC_m_Deref, (_ve_fail (), _ve_rest), _v_CC_m_Deref1);
      _v_res1 = ((_c_99 + (_c_145 + _ve_Re + _ge_auxcall1 ()) () + _ve_fail) () + _v_CC_m_Deref1);
      goto _block1;
    }
  _block1__branch1: {}
    {
      uintptr_t _v_len11 = _v_len__actions;
      uintptr_t _v_len12 = 1;
      if (_v_len11 < _v_len12)
      {
        goto _block1__branch2;
      }
      uintptr_t _v_len__rest2 = (_v_len11 - _v_len12);
      if (_ve_actions.symbol_at (0))
      {
        goto _block1__branch2;
      }
      Expr _v_deref__actions2 (_ve_actions, 0);
      uintptr_t _v_len13 = _v_deref__actions2.get_len ();
      uintptr_t _v_len14 = 3;
      if (_v_len13 < _v_len14)
      {
        goto _block1__branch2;
      }
      uintptr_t _v_len__Re2 = (_v_len13 - _v_len14);
      if (_v_deref__actions2.symbol_at ((0 + 1 + 1 + _v_len__Re2)))
      {
        goto _block1__branch2;
      }
      Expr _v_deref__deref__actions2 (_v_deref__actions2, (0 + 1 + 1 + _v_len__Re2));
      uintptr_t _v_len15 = _v_deref__deref__actions2.get_len ();
      uintptr_t _v_len16 = 1;
      if (_v_len15 < _v_len16)
      {
        goto _block1__branch2;
      }
      uintptr_t _v_len__pos2 = (_v_len15 - _v_len16);
      if (!_c_47.term_eq (_v_deref__actions2, 0))
      {
        goto _block1__branch2;
      }
      if (!_v_deref__deref__actions2.symbol_at (0))
      {
        goto _block1__branch2;
      }
      Expr _ve_rest (_ve_actions, (0 + 1), _v_len__rest2);
      Expr _vt_var (_v_deref__actions2, (0 + 1), 1);
      Expr _ve_Re (_v_deref__actions2, (0 + 1 + 1), _v_len__Re2);
      Expr _vs_dir (_v_deref__deref__actions2, 0, 1);
      Expr _ve_pos (_v_deref__deref__actions2, (0 + 1), _v_len__pos2);
      Expr _ge_auxcall2;
      RF_CALL (Pos, (_ve_Re, _vs_dir, _ve_pos), _ge_auxcall2);
      Expr _v_CC_m_Deref2;
      RF_CALL (CC_m_Deref, (_ve_fail (), _ve_rest), _v_CC_m_Deref2);
      _v_res1 = ((_c_47 + _vt_var + _ve_Re + _ge_auxcall2 ()) () + _v_CC_m_Deref2);
      goto _block1;
    }
  _block1__branch2: {}
    if (_v_len__actions != 0)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    _v_res1 = empty;
  }
_block1: {}
RF_END

RF_FUNC (CC_m_Eqs, (RF_ARG _gt_arg1, _ge_arg2, _ge_arg3;;), (RF_RES _v_res1;;))
  uintptr_t _v_len1 = (_ge_arg3.get_len () + 2);
  uintptr_t _v_len2 = 2;
  if (_v_len1 < _v_len2)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len__eqs = (_v_len1 - _v_len2);
  Expr _v_compose1 ((_gt_arg1 + _ge_arg2 () + _ge_arg3));
  if (_v_compose1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (_v_compose1.symbol_at ((0 + 1)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _v_deref__compose1 (_v_compose1, 0);
  Expr _v_deref__compose12 (_v_compose1, (0 + 1));
  uintptr_t _v_len3 = _v_deref__compose12.get_len ();
  uintptr_t _v_len4 = 0;
  if (_v_len3 < _v_len4)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len__assigns = (_v_len3 - _v_len4);
  uintptr_t _v_len5 = _v_deref__compose1.get_len ();
  uintptr_t _v_len6 = 0;
  if (_v_len5 < _v_len6)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len__fail = (_v_len5 - _v_len6);
  Expr _ve_eqs (_v_compose1, (0 + 1 + 1), _v_len__eqs);
  Expr _ve_fail (_v_deref__compose1, 0, _v_len__fail);
  Expr _ve_assigns (_v_deref__compose12, 0, _v_len__assigns);
  {
    {
      uintptr_t _v_len7 = _v_len__eqs;
      uintptr_t _v_len8 = 1;
      if (_v_len7 < _v_len8)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__rest = (_v_len7 - _v_len8);
      if (_ve_eqs.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__eqs (_ve_eqs, 0);
      if (_v_deref__eqs.get_len () != 4)
      {
        goto _block1__branch1;
      }
      if (_v_deref__eqs.symbol_at (0))
      {
        goto _block1__branch1;
      }
      if (_v_deref__eqs.symbol_at ((0 + 1)))
      {
        goto _block1__branch1;
      }
      if (_v_deref__eqs.symbol_at ((0 + 1 + 1 + 1)))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__deref__eqs (_v_deref__eqs, 0);
      Expr _v_deref__deref__eqs2 (_v_deref__eqs, (0 + 1));
      Expr _v_deref__deref__eqs3 (_v_deref__eqs, (0 + 1 + 1 + 1));
      uintptr_t _v_len9 = _v_deref__deref__eqs.get_len ();
      uintptr_t _v_len10 = 0;
      if (_v_len9 < _v_len10)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__Re = (_v_len9 - _v_len10);
      uintptr_t _v_len11 = _v_deref__deref__eqs3.get_len ();
      uintptr_t _v_len12 = 0;
      if (_v_len11 < _v_len12)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__len = (_v_len11 - _v_len12);
      uintptr_t _v_len13 = _v_deref__deref__eqs2.get_len ();
      uintptr_t _v_len14 = 1;
      if (_v_len13 < _v_len14)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__pos = (_v_len13 - _v_len14);
      if (!_v_deref__deref__eqs2.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _ve_rest (_ve_eqs, (0 + 1), _v_len__rest);
      Expr _vt_Pt (_v_deref__eqs, (0 + 1 + 1), 1);
      Expr _ve_Re (_v_deref__deref__eqs, 0, _v_len__Re);
      Expr _vs_dir (_v_deref__deref__eqs2, 0, 1);
      Expr _ve_pos (_v_deref__deref__eqs2, (0 + 1), _v_len__pos);
      Expr _ve_len (_v_deref__deref__eqs3, 0, _v_len__len);
      Expr _ve_Re_m_term;
      {
        {
          if (_v_len__Re != 1)
          {
            goto _block2__branch1;
          }
          Expr _vt__e__e_tmp_m_rfp__compilerf_m_1303_m_15 (_ve_Re, 0, 1);
          Expr _v_Get_m_Known_m_Length1;
          Expr _v_Get_m_Known_m_Length2;
          RF_CALL (rfp__clashes::Get_m_Known_m_Length, _ve_Re, (_v_Get_m_Known_m_Length1, _v_Get_m_Known_m_Length2));
          if ((_v_Get_m_Known_m_Length1.get_len () + 1) != (_v_len__len + 1))
          {
            goto _block2__branch1;
          }
          Expr _v_compose2 ((_v_Get_m_Known_m_Length1 + _v_Get_m_Known_m_Length2 ()));
          if (!_ve_len.eq (_v_compose2, 0))
          {
            goto _block2__branch1;
          }
          if (!_c_61.term_eq (_v_compose2, (0 + _v_len__len)))
          {
            goto _block2__branch1;
          }
          {
            {
              if ((_v_len__pos + 1) != 2)
              {
                goto _block3__branch1;
              }
              Expr _v_compose3 ((_vs_dir + _ve_pos));
              if (!_c_146.eq (_v_compose3, 0))
              {
                goto _block3__branch1;
              }
              goto _block3;
            }
          _block3__branch1: {}
            if ((_v_len__pos + 1) != (_v_len__len + 1))
            {
              goto _block2__branch1;
            }
            Expr _v_compose4 ((_vs_dir + _ve_pos));
            if (!_c_62.term_eq (_v_compose4, 0))
            {
              goto _block2__branch1;
            }
            if (!_ve_len.eq (_v_compose4, (0 + 1)))
            {
              goto _block2__branch1;
            }
          }
        _block3: {}
          _ve_Re_m_term = _ve_Re;
          goto _block2;
        }
      _block2__branch1: {}
        _ve_Re_m_term = empty;
      }
    _block2: {}
      Expr _vs_eq;
      {
        {
          if (_v_len__len != 1)
          {
            goto _block4__branch1;
          }
          if (!_c_95.term_eq (_ve_len, 0))
          {
            goto _block4__branch1;
          }
          _vs_eq = _c_147;
          goto _block4;
        }
      _block4__branch1: {}
        _vs_eq = _c_148;
      }
    _block4: {}
      Expr _ge_pos__4;
      RF_CALL (Pos, (_ve_Re, _vs_dir, _ve_pos), _ge_pos__4);
      {
        {
          Expr _ve_l;
          Expr _ve_r;
          {
            {
              Expr _v_Get_m_Var1;
              if (!RF_CALL (rfp__vars::Get_m_Var, (_c_149, _vt_Pt), _v_Get_m_Var1))
              {
                goto _block6__branch1;
              }
              if (_v_Get_m_Var1.get_len () != 1)
              {
                goto _block6__branch1;
              }
              if (!_c_150.term_eq (_v_Get_m_Var1, 0))
              {
                goto _block6__branch1;
              }
              _ve_l = _vt_Pt;
              _ve_r = _ve_Re;
              goto _block6;
            }
          _block6__branch1: {}
            {
              {
                if (_vt_Pt.symbol_at (0))
                {
                  goto _block7__branch1;
                }
                Expr _v_deref__Pt (_vt_Pt, 0);
                uintptr_t _v_len15 = _v_deref__Pt.get_len ();
                uintptr_t _v_len16 = 1;
                if (_v_len15 < _v_len16)
                {
                  goto _block7__branch1;
                }
                uintptr_t _v_len___e__e_tmp_m_rfp__compilerf_m_1322_m_17 = (_v_len15 - _v_len16);
                if (!_c_104.term_eq (_v_deref__Pt, 0))
                {
                  goto _block7__branch1;
                }
                Expr _ve__e__e_tmp_m_rfp__compilerf_m_1322_m_17 (_v_deref__Pt, (0 + 1), _v_len___e__e_tmp_m_rfp__compilerf_m_1322_m_17);
                goto _block7;
              }
            _block7__branch1: {}
              if (_vt_Pt.symbol_at (0))
              {
                goto _block5__branch1;
              }
              Expr _v_deref__Pt2 (_vt_Pt, 0);
              uintptr_t _v_len17 = _v_deref__Pt2.get_len ();
              uintptr_t _v_len18 = 1;
              if (_v_len17 < _v_len18)
              {
                goto _block5__branch1;
              }
              uintptr_t _v_len___e__e_tmp_m_rfp__compilerf_m_1323_m_20 = (_v_len17 - _v_len18);
              if (!_c_105.term_eq (_v_deref__Pt2, 0))
              {
                goto _block5__branch1;
              }
              Expr _ve__e__e_tmp_m_rfp__compilerf_m_1323_m_20 (_v_deref__Pt2, (0 + 1), _v_len___e__e_tmp_m_rfp__compilerf_m_1323_m_20);
            }
          _block7: {}
            {
              {
                if (!RF_CALL (rfp__vars::Var_q_, _ve_Re_m_term, /*void*/))
                {
                  goto _block8__branch1;
                }
                _ve_l = _ve_Re_m_term;
                _ve_r = _vt_Pt;
                goto _block8;
              }
            _block8__branch1: {}
              _ve_l = _vt_Pt;
              _ve_r = _ve_Re;
            }
          _block8: {}
          }
        _block6: {}
          Expr _vt_cond ((_c_99 + (_c_91 + (_vs_eq + _ve_l + _ve_r () + _ge_pos__4 ()) ()) () + _ve_fail) ());
          {
            {
              if (_v_len__assigns < 1)
              {
                goto _block9__branch1;
              }
              RF_rsplit (_ve_assigns, 0, _v_rsplit__assigns, _ve_2);
              for ( ; ; RF_iter(_ve_assigns)--)
              {
                {
                  if (!RF_iter(_ve_assigns))
                  {
                    goto _block9__branch1;
                  }
                  uintptr_t _v_len19 = _v_rsplit__assigns.get_len ();
                  uintptr_t _v_len20 = 1;
                  if (_v_len19 < _v_len20)
                  {
                    goto _block9__branch1;
                  }
                  uintptr_t _v_len__1 = (_v_len19 - _v_len20);
                  if (_v_rsplit__assigns.symbol_at ((0 + _v_len__1)))
                  {
                    goto _continue1;
                  }
                  Expr _v_deref__rsplit__assigns (_v_rsplit__assigns, (0 + _v_len__1));
                  uintptr_t _v_len21 = _v_deref__rsplit__assigns.get_len ();
                  uintptr_t _v_len22 = 2;
                  if (_v_len21 < _v_len22)
                  {
                    goto _continue1;
                  }
                  uintptr_t _v_len__def = (_v_len21 - _v_len22);
                  if (!_v_deref__rsplit__assigns.symbol_at (0))
                  {
                    goto _continue1;
                  }
                  if (!_vt_Pt.term_eq (_v_deref__rsplit__assigns, (0 + 1)))
                  {
                    goto _continue1;
                  }
                  Expr _ve_1 (_v_rsplit__assigns, 0, _v_len__1);
                  Expr _vs_op (_v_deref__rsplit__assigns, 0, 1);
                  Expr _ve_def (_v_deref__rsplit__assigns, (0 + 1 + 1), _v_len__def);
                  RF_TAILCALL (CC_m_Eqs, (_ve_fail (), (_ve_1 + (_vs_op + _vt_Pt + _ve_def) () + _vt_cond + _ve_2), _ve_rest), _v_res1);
                  goto _exit1;
                }
            _continue1: {}
              }
            _exit1: {}
              goto _block9;
            }
          _block9__branch1: {}
            Expr _v_CC_m_Eqs1;
            RF_CALL (CC_m_Eqs, (_ve_fail (), _ve_assigns, _ve_rest), _v_CC_m_Eqs1);
            _v_res1 = (_vt_cond + _v_CC_m_Eqs1);
          }
        _block9: {}
          goto _block5;
        }
      _block5__branch1: {}
        RF_CALL (rfp__vars::Set_m_Var, (_c_37, _vt_Pt), /*void*/);
        Expr _ve_cond;
        {
          {
            if (_vt_Pt.symbol_at (0))
            {
              goto _block10__branch1;
            }
            Expr _v_deref__Pt3 (_vt_Pt, 0);
            uintptr_t _v_len23 = _v_deref__Pt3.get_len ();
            uintptr_t _v_len24 = 1;
            if (_v_len23 < _v_len24)
            {
              goto _block10__branch1;
            }
            uintptr_t _v_len___e__e_tmp_m_rfp__compilerf_m_1341_m_25 = (_v_len23 - _v_len24);
            if (!_c_151.term_eq (_v_deref__Pt3, 0))
            {
              goto _block10__branch1;
            }
            Expr _ve__e__e_tmp_m_rfp__compilerf_m_1341_m_25 (_v_deref__Pt3, (0 + 1), _v_len___e__e_tmp_m_rfp__compilerf_m_1341_m_25);
            Expr _ge_auxcall1;
            RF_CALL (Pos, (_ve_Re, _vs_dir, _ge_pos__4), _ge_auxcall1);
            _ve_cond = (_c_99 + (_c_91 + (_c_145 + _ve_Re + _ge_auxcall1 ()) ()) () + _ve_fail) ();
            goto _block10;
          }
        _block10__branch1: {}
          _ve_cond = empty;
        }
      _block10: {}
        {
          {
            Expr _v_Get_m_Var2;
            if (!RF_CALL (rfp__vars::Get_m_Var, (_c_50, _vt_Pt), _v_Get_m_Var2))
            {
              goto _block11__branch1;
            }
            if (_v_Get_m_Var2.get_len () != 1)
            {
              goto _block11__branch1;
            }
            if (!_v_Get_m_Var2.symbol_at (0))
            {
              goto _block11__branch1;
            }
            Expr _vs__e__e_tmp_m_rfp__compilerf_m_1348_m_34 (_v_Get_m_Var2, 0, 1);
            Expr _v_CC_m_Eqs2;
            RF_CALL (CC_m_Eqs, (_ve_fail (), (_ve_assigns + (_c_54 + _vt_Pt + (_c_48 + _ve_Re + _ge_pos__4 () + _ve_len ()) ()) ()), _ve_rest), _v_CC_m_Eqs2);
            _v_res1 = (_ve_cond + _v_CC_m_Eqs2);
            goto _block11;
          }
        _block11__branch1: {}
          Expr _v_Vars_m_Decl1;
          RF_CALL (rfp__vars::Vars_m_Decl, (_c_73, _vt_Pt), _v_Vars_m_Decl1);
          uintptr_t _v_len25 = _v_Vars_m_Decl1.get_len ();
          uintptr_t _v_len26 = 0;
          if (_v_len25 < _v_len26)
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          uintptr_t _v_len___e__e_tmp_m_rfp__compilerf_m_1352_m_36 = (_v_len25 - _v_len26);
          Expr _ve__e__e_tmp_m_rfp__compilerf_m_1352_m_36 (_v_Vars_m_Decl1, 0, _v_len___e__e_tmp_m_rfp__compilerf_m_1352_m_36);
          Expr _v_CC_m_Eqs3;
          RF_CALL (CC_m_Eqs, (_ve_fail (), (_ve_assigns + (_c_48 + _vt_Pt + _ve_Re + _ge_pos__4 () + _ve_len ()) ()), _ve_rest), _v_CC_m_Eqs3);
          _v_res1 = (_ve_cond + _v_CC_m_Eqs3);
        }
      _block11: {}
      }
    _block5: {}
      goto _block1;
    }
  _block1__branch1: {}
    _v_res1 = (_ve_assigns + _ve_eqs);
  }
_block1: {}
RF_END

RF_FUNC (Gener_m_Label, (RF_ARG _ve_QualifiedName;;), (RF_RES _v_res1;;))
  Expr _vs_num;
  {
    {
      Expr _v_Lookup1;
      if (!RF_CALL (Table::Lookup, (Labels, _ve_QualifiedName), _v_Lookup1))
      {
        goto _block1__branch1;
      }
      if (_v_Lookup1.get_len () != 1)
      {
        goto _block1__branch1;
      }
      if (!_v_Lookup1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _gs_num__2 (_v_Lookup1, 0, 1);
      RF_CALL (Arithm::_p_, (_gs_num__2, _c_95), _vs_num);
      goto _block1;
    }
  _block1__branch1: {}
    _vs_num = _c_95;
  }
_block1: {}
  RF_CALL (Table::Bind, (Labels, _ve_QualifiedName, _vs_num), /*void*/);
  _v_res1 = (_ve_QualifiedName + _vs_num) ();
RF_END

RF_FUNC (Add_m_To_m_Label, (RF_ARG _gt_arg1, _ge_arg2;;), (RF_RES _v_res1;;))
  uintptr_t _v_len1 = (_ge_arg2.get_len () + 1);
  uintptr_t _v_len2 = 1;
  if (_v_len1 < _v_len2)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len__name = (_v_len1 - _v_len2);
  Expr _v_compose1 ((_gt_arg1 + _ge_arg2));
  if (_v_compose1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _v_deref__compose1 (_v_compose1, 0);
  uintptr_t _v_len3 = _v_deref__compose1.get_len ();
  uintptr_t _v_len4 = 0;
  if (_v_len3 < _v_len4)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  uintptr_t _v_len__label = (_v_len3 - _v_len4);
  Expr _ve_name (_v_compose1, (0 + 1), _v_len__name);
  Expr _ve_label (_v_deref__compose1, 0, _v_len__label);
  RF_TAILCALL (Gener_m_Label, (_ve_label + _c_152 + _ve_name), _v_res1);
RF_END

RF_FUNC (Lookup_m_Func, (RF_ARG _vt_Fname;;), (RF_RES _v_res1, _v_res2, _v_res3, _v_res4, _v_res5;;))
  Expr _ge_auxalt1;
  {
    {
      if (!RF_CALL (Table::Lookup, (Fun, _vt_Fname), _ge_auxalt1))
      {
        goto _block1__branch1;
      }
      goto _block1;
    }
  _block1__branch1: {}
    if (!RF_CALL (Table::Lookup, (Fun_q_, _vt_Fname), _ge_auxalt1))
    {
      RF_RETFAIL;
    }
  }
_block1: {}
  if (_ge_auxalt1.get_len () != 5)
  {
    RF_RETFAIL;
  }
  if (_ge_auxalt1.symbol_at ((0 + 1 + 1 + 1)))
  {
    RF_RETFAIL;
  }
  if (_ge_auxalt1.symbol_at ((0 + 1 + 1 + 1 + 1)))
  {
    RF_RETFAIL;
  }
  Expr _v_deref__auxalt1 (_ge_auxalt1, (0 + 1 + 1 + 1));
  Expr _v_deref__auxalt12 (_ge_auxalt1, (0 + 1 + 1 + 1 + 1));
  uintptr_t _v_len1 = _v_deref__auxalt12.get_len ();
  uintptr_t _v_len2 = 0;
  if (_v_len1 < _v_len2)
  {
    RF_RETFAIL;
  }
  uintptr_t _v_len__Fout = (_v_len1 - _v_len2);
  uintptr_t _v_len3 = _v_deref__auxalt1.get_len ();
  uintptr_t _v_len4 = 0;
  if (_v_len3 < _v_len4)
  {
    RF_RETFAIL;
  }
  uintptr_t _v_len__Fin = (_v_len3 - _v_len4);
  if (!_ge_auxalt1.symbol_at (0))
  {
    RF_RETFAIL;
  }
  if (!_ge_auxalt1.symbol_at ((0 + 1)))
  {
    RF_RETFAIL;
  }
  Expr _vs_linkage (_ge_auxalt1, 0, 1);
  Expr _vs_tag (_ge_auxalt1, (0 + 1), 1);
  Expr _vt_pragma (_ge_auxalt1, (0 + 1 + 1), 1);
  Expr _ve_Fin (_v_deref__auxalt1, 0, _v_len__Fin);
  Expr _ve_Fout (_v_deref__auxalt12, 0, _v_len__Fout);
  _v_res1 = _vs_linkage;
  _v_res2 = _vs_tag;
  _v_res3 = _vt_pragma;
  _v_res4 = _ve_Fin;
  _v_res5 = _ve_Fout;
RF_END

RF_FUNC (Set_m_Var__0, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  uintptr_t _v_len1 = _ge_arg1.get_len ();
  uintptr_t _v_len2 = 1;
  if (_v_len1 < _v_len2)
  {
    RF_ERROR (_c_153);
  }
  uintptr_t _v_len__stub1 = (_v_len1 - _v_len2);
  Expr _v_stub1 (_ge_arg1, 0, _v_len__stub1);
  Expr _v_stub2 (_ge_arg1, (0 + _v_len__stub1), 1);
  RF_CALL (rfp__vars::Set_m_Var, (_v_stub1, _v_stub2), /*void*/);
  _v_res1 = empty;
RF_END

}

namespace rfp__compile
{

static void init_ ()
{
  Fun = new rftype::StaticObject<rftype::Table>(L"Fun");
  Fun_q_ = new rftype::StaticObject<rftype::Table>(L"Fun?");
  Const = new rftype::StaticObject<rftype::Table>(L"Const");
  Object = new rftype::StaticObject<rftype::Table>(L"Object");
  Objects = new rftype::StaticObject<rftype::Table>(L"Objects");
  Stub_m_Funcs = new rftype::StaticObject<rftype::Table>(L"Stub-Funcs");
  Out_m_Format = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Out-Format");
  Res_m_Vars = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Res-Vars");
  Labels = new rftype::StaticObject<rftype::Table>(L"Labels");
  Prep_m_Vars = new rftype::StaticObject<rftype::Table>(L"Prep-Vars");
  Declarations = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Declarations");
  Trace_m_Names = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Trace-Names");
  Includes = new rftype::StaticObject<rftype::Table>(L"Includes");
  Snt_m_State = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Snt-State");
  Aux_m_Index = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Aux-Index");
  _c_0 = Expr::create<rftype::Word>("ITEMS");
  _c_1 = Expr::create<rftype::Word>("INTERFACE");
  _c_2 = Expr::create<rftype::Word>("MODULE");
  _c_3 = Expr::create<rftype::Word>("IMPORT");
  _c_4 = Expr::create<rftype::Word>("FILE");
  _c_5 = Expr::create<rftype::Word>("PRAGMA");
  _c_6 = Expr::create<rftype::Word>("INPUT");
  _c_7 = Expr::create<rftype::Word>("CONST");
  _c_16 = Expr::create<rftype::Word>("FUNC") + Expr::create<rftype::Word>("FUNC?") + Expr::create<rftype::Word>("TFUNC");
  _c_8 = Expr (_c_16, 0, 1);
  _c_9 = Expr (_c_16, 1, 1);
  _c_10 = rftype::Char::create_expr (L"wrappers");
  _c_11 = rftype::Char::create_expr (L"plus");
  _c_12 = rftype::Char::create_expr (L"refal");
  _c_13 = rftype::Char::create_expr (L"org");
  _c_14 = Expr::create<rftype::Word>("TRACE");
  _c_15 = Expr::create<rftype::Word>("EXTERN");
  _c_17 = Expr::create<rftype::Word>("DECL-FUNC");
  _c_23 = Expr::create<rftype::Word>("OBJ") + Expr::create<rftype::Word>("EXPORT");
  _c_18 = Expr (_c_23, 1, 1);
  _c_19 = Expr::create<rftype::Word>("BRANCH");
  _c_154 = Expr::create<rftype::Word>("arg") + Expr::create<rftype::Integer>("1");
  _c_20 = Expr (_c_154, 0, 1);
  _c_21 = Expr::create<rftype::Word>("CONSTEXPR");
  _c_22 = Expr::create<rftype::Word>("DECL-OBJ");
  _c_25 = Expr::create<rftype::Word>("OBJ") + Expr::create<rftype::Word>("LOCAL");
  _c_24 = Expr (_c_25, 1, 1);
  _c_26 = Expr::create_sym<rftype::Func> (Gener_m_Stub);
  _c_27 = Expr::create<rftype::Word>("stub");
  _c_28 = Expr::create<rftype::Word>("STUB");
  _c_146 = Expr::create<rftype::Word>("LEFT") + Expr::create<rftype::Integer>("0");
  _c_29 = Expr (_c_146, 0, 1);
  _c_30 = Expr::create<rftype::Word>("CALL");
  _c_31 = Expr::create<rftype::Word>("RESULT");
  _c_32 = (Expr::create<rftype::Word>("CUTALL")) ();
  _c_155 = Expr::create<rftype::Word>("EVAR") + (_c_154) ();
  _c_156 = (Expr (_c_155, 0, 1)) ();
  _c_33 = ((_c_155) ()) () + (_c_156) ();
  _c_34 = Expr::create<rftype::Word>("res");
  _c_35 = Expr::create<rftype::Word>("Result");
  _c_36 = Expr::create_sym<rftype::Func> (Set_m_Var__0);
  _c_157 = Expr::create<rftype::Word>("Instantiated?") + Expr::create<rftype::Word>("True");
  _c_37 = (_c_157) ();
  _c_38 = (Expr::create<rftype::Word>("FATAL")) ();
  _c_39 = (Expr::create<rftype::Word>("RETFAIL")) ();
  _c_40 = Expr (_c_16, 2, 1);
  _c_153 = Expr::create<rftype::Word>("Apply") + Expr::create<rftype::Word>("Apply") + Expr::create<rftype::Word>("Unexpected fail");
  _c_41 = (_c_153) ();
  _c_42 = Expr::create<rftype::Word>("ERROR");
  _c_59 = Expr::create<rftype::Word>("Tail") + Expr::create<rftype::Word>("Tail-in-Trap");
  _c_43 = Expr (_c_59, 0, 1);
  _c_44 = Expr::create<rftype::Word>("EXPR");
  _c_45 = Expr::create<rftype::Word>("DROP");
  _c_46 = Expr::create<rftype::Word>("Init");
  _c_47 = Expr::create<rftype::Word>("DEREF");
  _c_48 = Expr::create<rftype::Word>("SUBEXPR");
  _c_49 = Expr::create<rftype::Word>("DECL") + Expr::create<rftype::Word>("Expr");
  _c_50 = Expr::create<rftype::Word>("Decl");
  _c_51 = Expr::create<rftype::Word>("DECL") + Expr::create<rftype::Word>("int");
  _c_52 = Expr::create<rftype::Word>("const");
  _c_53 = Expr::create<rftype::Word>("VAR");
  _c_54 = Expr::create<rftype::Word>("ASSIGN");
  _c_55 = Expr::create<rftype::Word>("LABEL");
  _c_56 = Expr::create<rftype::Word>("TAILCALL?");
  _c_57 = Expr::create<rftype::Word>("TAILCALL");
  _c_108 = rftype::Char::create_expr (L"_") + Expr::create<rftype::Integer>("0");
  _c_58 = Expr (_c_108, 1, 1);
  _c_60 = Expr::create<rftype::Word>("FORMAT");
  _c_79 = (empty) () + (empty) ();
  _c_61 = Expr (_c_79, 0, 1);
  _c_62 = Expr::create<rftype::Word>("RIGHT");
  _c_63 = Expr::create<rftype::Word>("BLOCK") + Expr::create<rftype::Word>("BLOCK?");
  _c_64 = Expr::create<rftype::Word>("Empty block?");
  _c_65 = Expr (_c_63, 0, 1);
  _c_66 = Expr (_c_63, 1, 1);
  _c_67 = Expr::create<rftype::Word>("ITER");
  _c_68 = Expr::create<rftype::Word>("Comp") + Expr::create<rftype::Word>("Iter");
  _c_69 = (Expr::create<rftype::Word>("Comp") + Expr::create<rftype::Word>("If-not-error")) ();
  _c_70 = (Expr::create<rftype::Word>("Comp") + Expr::create<rftype::Word>("Source")) ();
  _c_71 = (Expr::create<rftype::Word>("Comp") + Expr::create<rftype::Word>("Error")) ();
  _c_94 = Expr::create<rftype::Word>("Notail") + (_c_38) () + (empty) ();
  _c_72 = Expr (_c_94, 0, 1);
  _c_73 = Expr (_c_49, 1, 1);
  _c_74 = Expr::create<rftype::Word>("block");
  _c_75 = Expr::create<rftype::Word>("branch");
  _c_76 = Expr::create<rftype::Word>("BREAK");
  _c_77 = Expr::create<rftype::Word>("iter");
  _c_78 = Expr::create<rftype::Word>("exit_iter");
  _c_80 = Expr::create<rftype::Word>("FOR") + (empty) ();
  _c_81 = Expr::create<rftype::Word>("TRY");
  _c_82 = Expr (_c_59, 1, 1);
  _c_83 = Expr (_c_94, 1, 2);
  _c_84 = Expr::create<rftype::Word>("CATCH-ERROR");
  _c_85 = (Expr::create<rftype::Word>("STAKE")) ();
  _c_86 = (Expr::create<rftype::Word>("Comp") + Expr::create<rftype::Word>("Stake")) ();
  _c_87 = (Expr::create<rftype::Word>("CUT")) ();
  _c_88 = Expr::create<rftype::Word>("NOFAIL");
  _c_89 = Expr (_c_83, 0, 1);
  _c_90 = (Expr::create<rftype::Word>("FAIL")) ();
  _c_91 = Expr::create<rftype::Word>("NOT");
  _c_92 = Expr::create<rftype::Word>("negation");
  _c_93 = (_c_42) ();
  _c_95 = Expr (_c_154, 1, 1);
  _c_96 = Expr::create<rftype::Word>("Failable");
  _c_97 = Expr::create<rftype::Word>("PAREN");
  _c_98 = Expr::create<rftype::Word>("CALL-FAILS");
  _c_99 = Expr::create<rftype::Word>("IF");
  _c_100 = Expr::create<rftype::Word>("Create");
  _c_101 = Expr::create<rftype::Word>("Static");
  _c_102 = Expr::create<rftype::Word>("Dynamic");
  _c_103 = Expr::create<rftype::Word>("Not-Create");
  _c_104 = Expr::create<rftype::Word>("REF");
  _c_105 = Expr::create<rftype::Word>("STATIC");
  _c_106 = (_c_156) () + (_c_156) ();
  _c_107 = Expr (_c_108, 0, 1);
  _c_109 = Expr::create<rftype::Word>("aux");
  _c_110 = Expr::create_sym<rftype::Func> (Get_m_Vars);
  _c_111 = Expr::create_sym<rftype::Func> (Max_m_Require);
  _c_112 = Expr::create_sym<rftype::Func> (Subst_m_Aux_m_Var);
  _c_113 = Expr::create_sym<rftype::Func> (Extract_m_Assigns);
  _c_140 = Expr::create<rftype::Word>("Clashes");
  _c_114 = (_c_140) ();
  _c_115 = (_c_53) ();
  _c_116 = Expr::create<rftype::Word>("subexpr_");
  _c_117 = Expr::create<rftype::Word>("INFIX") + Expr::create<rftype::Word>("-");
  _c_118 = Expr::create<rftype::Word>("RSPLIT");
  _c_119 = Expr::create<rftype::Word>("DEC-ITER");
  _c_120 = Expr::create<rftype::Word>("INC-ITER");
  _c_121 = Expr::create<rftype::Word>("continue");
  _c_122 = Expr::create<rftype::Word>("exit");
  _c_123 = Expr::create<rftype::Word>("Min");
  _c_124 = Expr::create<rftype::Word>("CONTINUE");
  _c_125 = Expr::create<rftype::Word>("ITER-FAILS");
  _c_126 = Expr (_c_80, 0, 1);
  _c_127 = Expr::create<rftype::Word>("IF-INT-CMP") + Expr::create<rftype::Word>("!=");
  _c_128 = Expr::create<rftype::Word>("Len-Var");
  _c_129 = Expr::create<rftype::Word>("INFIX") + Expr::create<rftype::Word>("*");
  _c_130 = Expr::create<rftype::Word>("INFIX") + Expr::create<rftype::Word>("+");
  _c_131 = Expr::create<rftype::Word>("IF-INT-CMP") + Expr::create<rftype::Word>("<");
  _c_132 = Expr::create<rftype::Word>("len");
  _c_133 = Expr::create<rftype::Word>("Aux");
  _c_134 = Expr::create<rftype::Word>("Max");
  _c_135 = Expr::create<rftype::Word>("IF-INT-CMP") + Expr::create<rftype::Word>(">");
  _c_136 = Expr::create<rftype::Word>("INFIX") + Expr::create<rftype::Word>("%");
  _c_137 = Expr::create<rftype::Word>("len_");
  _c_138 = Expr::create<rftype::Word>("INFIX") + Expr::create<rftype::Word>("/");
  _c_139 = Expr::create<rftype::Word>("Length");
  _c_141 = Expr::create_sym<rftype::Func> (rfp__clashes::Reclassify_m_Clash);
  _c_142 = (_c_58) ();
  _c_143 = Expr::create<rftype::Word>("LENGTH");
  _c_144 = (_c_95) ();
  _c_145 = Expr::create<rftype::Word>("SYMBOL?");
  _c_147 = Expr::create<rftype::Word>("TERM-EQ");
  _c_148 = Expr::create<rftype::Word>("EQ");
  _c_149 = Expr (_c_157, 0, 1);
  _c_150 = Expr (_c_157, 1, 1);
  _c_151 = Expr::create<rftype::Word>("SVAR");
  _c_152 = Expr::create<rftype::Word>("_");
}

static AtStart init_registrator_ (&init_);

}

}
