#include <rf_core.hh>
#include <refal/Arithm.hh>
#include <refal/Access.hh>
#include <refal/Class.hh>
#include <refal/CppMangle.hh>
#include <refal/Convert.hh>
#include <refal/Compare.hh>
#include <refal/Box.hh>
#include <refal/File.hh>
#include <refal/JavaMangle.hh>
#include <refal/StdIO.hh>
#include <refal/List.hh>
#include "rfp_as2as.hh"
#include "rfp_asail_cpp.hh"
#include "rfp_asail2asail.hh"
#include "rfp_asail_tpp.hh"
#include "rfp_asail_jbc.hh"
#include "rfp_asail_java.hh"
#include <refal/Table.hh>
#include <refal/Dos.hh>
#include "rfp_compile.hh"
#include "rfp_helper.hh"
#include "rfp_format.hh"
#include "rfp_err.hh"
#include "rfp_parse.hh"
#include "rfp_src.hh"
#include "rfp_lex.hh"
#include "rfp_check.hh"

namespace refal
{

using namespace rfrt;

namespace FileOutputStream
{

RF_FUNC (WriteToStream, (RF_ARG _v_arg1, _v_arg2;;), RF_VOID)
  RF_ERROR ((Expr::create<rftype::Word>("FileOutputStream") + Expr::create<rftype::Word>("WriteToStream") + Expr::create<rftype::Word>("Not available")));
RF_END

RF_FUNC (FileOutputStream, (RF_ARG _v_arg1;;), (RF_RES _v_res1;;))
  RF_ERROR ((Expr::create<rftype::Word>("FileOutputStream") + Expr::create<rftype::Word>("FileOutputStream") + Expr::create<rftype::Word>("Not available")));
RF_END

}

namespace rfpc
{

Expr RFP_m_Root;

Expr RFP_m_Default_m_Include_m_Path;

Expr RFP_m_Boot_m_Path;

Expr RFP_m_Include_m_Path;

Expr RFP_m_Token_m_Stack;

Expr RFP_m_Trace;

Expr RFP_m_Includes;

static Expr RevDate;

static Expr Options;

RF_DECL (Main);

RF_DECL (Init_m_Options);

RF_DECL (Display_m_Help);

RF_DECL (RFP_m_Parse_m_Args);

RF_DECL (RFP_m_Set_m_Path);

RF_DECL (Get_m_Ready_m_To_m_Work);

RF_DECL (RFP_m_Pretty_m_Print);

static Expr Tab;

RF_DECL (CPP_m_Pretty_m_Print);

RF_DECL (Verbose);

RF_DECL (Open_m_Channel);

RF_DECL (Extract_m_Inputs);

RF_DECL (Compilation_m_Failed);

RF_DECL (Version);

static Expr _c_0;

static Expr _c_58;

static Expr _c_54;

static Expr _c_149;

static Expr _c_1;

static Expr _c_2;

static Expr _c_3;

static Expr _c_4;

static Expr _c_5;

static Expr _c_6;

static Expr _c_7;

static Expr _c_8;

static Expr _c_9;

static Expr _c_10;

static Expr _c_11;

static Expr _c_12;

static Expr _c_13;

static Expr _c_14;

static Expr _c_150;

static Expr _c_151;

static Expr _c_152;

static Expr _c_15;

static Expr _c_55;

static Expr _c_16;

static Expr _c_18;

static Expr _c_17;

static Expr _c_19;

static Expr _c_20;

static Expr _c_153;

static Expr _c_21;

static Expr _c_22;

static Expr _c_23;

static Expr _c_24;

static Expr _c_154;

static Expr _c_25;

static Expr _c_26;

static Expr _c_27;

static Expr _c_28;

static Expr _c_29;

static Expr _c_30;

static Expr _c_31;

static Expr _c_155;

static Expr _c_32;

static Expr _c_33;

static Expr _c_34;

static Expr _c_156;

static Expr _c_35;

static Expr _c_157;

static Expr _c_36;

static Expr _c_158;

static Expr _c_37;

static Expr _c_159;

static Expr _c_38;

static Expr _c_160;

static Expr _c_39;

static Expr _c_161;

static Expr _c_40;

static Expr _c_41;

static Expr _c_42;

static Expr _c_43;

static Expr _c_44;

static Expr _c_45;

static Expr _c_46;

static Expr _c_47;

static Expr _c_162;

static Expr _c_48;

static Expr _c_49;

static Expr _c_50;

static Expr _c_51;

static Expr _c_52;

static Expr _c_53;

static Expr _c_56;

static Expr _c_57;

static Expr _c_59;

static Expr _c_60;

static Expr _c_163;

static Expr _c_61;

static Expr _c_62;

static Expr _c_63;

static Expr _c_64;

static Expr _c_90;

static Expr _c_65;

static Expr _c_66;

static Expr _c_67;

static Expr _c_68;

static Expr _c_69;

static Expr _c_70;

static Expr _c_71;

static Expr _c_72;

static Expr _c_73;

static Expr _c_74;

static Expr _c_75;

static Expr _c_92;

static Expr _c_76;

static Expr _c_77;

static Expr _c_78;

static Expr _c_79;

static Expr _c_80;

static Expr _c_81;

static Expr _c_82;

static Expr _c_83;

static Expr _c_84;

static Expr _c_85;

static Expr _c_86;

static Expr _c_87;

static Expr _c_88;

static Expr _c_89;

static Expr _c_91;

static Expr _c_93;

static Expr _c_94;

static Expr _c_95;

static Expr _c_96;

static Expr _c_97;

static Expr _c_164;

static Expr _c_165;

static Expr _c_166;

static Expr _c_167;

static Expr _c_168;

static Expr _c_169;

static Expr _c_170;

static Expr _c_171;

static Expr _c_172;

static Expr _c_173;

static Expr _c_174;

static Expr _c_175;

static Expr _c_176;

static Expr _c_177;

static Expr _c_178;

static Expr _c_179;

static Expr _c_180;

static Expr _c_181;

static Expr _c_98;

static Expr _c_99;

static Expr _c_100;

static Expr _c_101;

static Expr _c_102;

static Expr _c_103;

static Expr _c_104;

static Expr _c_105;

static Expr _c_106;

static Expr _c_107;

static Expr _c_108;

static Expr _c_109;

static Expr _c_110;

static Expr _c_111;

static Expr _c_112;

static Expr _c_113;

static Expr _c_114;

static Expr _c_115;

static Expr _c_116;

static Expr _c_117;

static Expr _c_118;

static Expr _c_119;

static Expr _c_120;

static Expr _c_121;

static Expr _c_182;

static Expr _c_183;

static Expr _c_134;

static Expr _c_122;

static Expr _c_123;

static Expr _c_124;

static Expr _c_132;

static Expr _c_129;

static Expr _c_125;

static Expr _c_126;

static Expr _c_127;

static Expr _c_128;

static Expr _c_130;

static Expr _c_131;

static Expr _c_184;

static Expr _c_133;

static Expr _c_135;

static Expr _c_136;

static Expr _c_137;

static Expr _c_138;

static Expr _c_139;

static Expr _c_140;

static Expr _c_141;

static Expr _c_142;

static Expr _c_143;

static Expr _c_144;

static Expr _c_145;

static Expr _c_146;

static Expr _c_147;

static Expr _c_148;

RF_FUNC (Main, RF_VOID, (RF_RES _v_res1;;))
  RF_CALL (Init_m_Options, /*void*/, /*void*/);
  Expr _ve_files;
  RF_CALL (RFP_m_Parse_m_Args, (empty, empty, _c_0), _ve_files);
  RF_CALL (RFP_m_Set_m_Path, /*void*/, /*void*/);
  Expr _v__q_1;
  RF_CALL (Box::_q_, File::Dir_m_Separator, _v__q_1);
  if (_v__q_1.get_len () != 1)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_v__q_1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _vs_dir_m_separator (_v__q_1, 0, 1);
  {
    {
      if (_ve_files.get_len () != 0)
      {
        goto _block1__branch1;
      }
      {
        {
          if (!RF_CALL (Table::In_m_Table_q_, (rfp__helper::RFP_m_Options, _c_1), /*void*/))
          {
            goto _block2__branch1;
          }
          _v_res1 = empty;
          goto _block2;
        }
      _block2__branch1: {}
        Expr _ge_auxcall1;
        RF_CALL (Version, /*void*/, _ge_auxcall1);
        RF_CALL (StdIO::PrintLN, (_c_2 + _ge_auxcall1), /*void*/);
        Expr _ve_start (_c_3);
        Expr _vs_st_m_len;
        RF_CALL (Access::Length, _ve_start, _vs_st_m_len);
        RF_CALL (StdIO::Print, _ve_start, /*void*/);
        Expr _vs_len;
        RF_CALL (Box::Box, empty, _vs_len);
        RF_CALL (Box::Store, (_vs_len, _vs_st_m_len), /*void*/);
        {
          Expr _v__q_2;
          RF_CALL (Box::_q_, Options, _v__q_2);
          if (_v__q_2.get_len () < 1)
          {
            goto _block3__branch1;
          }
          RF_lsplit (_v__q_2, 0, _ve__e__e_tmp_m_rfpcrf_m_91_m_29, _v_lsplit___q_2);
          for ( ; ; RF_iter(_v__q_2)++)
          {
            {
              if (!RF_iter(_v__q_2))
              {
                goto _block3__branch1;
              }
              uintptr_t _v_len1 = _v_lsplit___q_2.get_len ();
              uintptr_t _v_len2 = 1;
              if (_v_len1 < _v_len2)
              {
                goto _block3__branch1;
              }
              uintptr_t _v_len___e__e_tmp_m_rfpcrf_m_91_m_56 = (_v_len1 - _v_len2);
              if (_v_lsplit___q_2.symbol_at (0))
              {
                goto _continue1;
              }
              Expr _v_deref__lsplit___q_2 (_v_lsplit___q_2, 0);
              uintptr_t _v_len3 = _v_deref__lsplit___q_2.get_len ();
              uintptr_t _v_len4 = 2;
              if (_v_len3 < _v_len4)
              {
                goto _continue1;
              }
              uintptr_t _v_len__descr = (_v_len3 - _v_len4);
              if (_v_deref__lsplit___q_2.symbol_at (0))
              {
                goto _continue1;
              }
              Expr _v_deref__deref__lsplit___q_2 (_v_deref__lsplit___q_2, 0);
              uintptr_t _v_len5 = _v_deref__deref__lsplit___q_2.get_len ();
              uintptr_t _v_len6 = 1;
              if (_v_len5 < _v_len6)
              {
                goto _continue1;
              }
              uintptr_t _v_len___e__e_tmp_m_rfpcrf_m_91_m_42 = (_v_len5 - _v_len6);
              if (_v_deref__deref__lsplit___q_2.symbol_at (0))
              {
                goto _continue1;
              }
              Expr _v_deref__deref__deref__lsplit___q_2 (_v_deref__deref__lsplit___q_2, 0);
              uintptr_t _v_len7 = _v_deref__deref__deref__lsplit___q_2.get_len ();
              uintptr_t _v_len8 = 0;
              if (_v_len7 < _v_len8)
              {
                goto _continue1;
              }
              uintptr_t _v_len__next = (_v_len7 - _v_len8);
              Expr _ve__e__e_tmp_m_rfpcrf_m_91_m_56 (_v_lsplit___q_2, (0 + 1), _v_len___e__e_tmp_m_rfpcrf_m_91_m_56);
              Expr _vt__e__e_tmp_m_rfpcrf_m_91_m_45 (_v_deref__lsplit___q_2, (0 + 1), 1);
              Expr _ve_descr (_v_deref__lsplit___q_2, (0 + 1 + 1), _v_len__descr);
              Expr _ve__e__e_tmp_m_rfpcrf_m_91_m_42 (_v_deref__deref__lsplit___q_2, (0 + 1), _v_len___e__e_tmp_m_rfpcrf_m_91_m_42);
              Expr _ve_next (_v_deref__deref__deref__lsplit___q_2, 0, _v_len__next);
              Expr _gs_auxcall2;
              RF_CALL (Access::Length, _ve_next, _gs_auxcall2);
              if (!RF_CALL (Compare::_lt__eq_, (_gs_auxcall2, _c_4), /*void*/))
              {
                goto _continue1;
              }
              Expr _ge_next__7;
              {
                {
                  uintptr_t _v_len9 = _v_len__descr;
                  uintptr_t _v_len10 = 1;
                  if (_v_len9 < _v_len10)
                  {
                    goto _block4__branch1;
                  }
                  uintptr_t _v_len___e__e_tmp_m_rfpcrf_m_94_m_36 = (_v_len9 - _v_len10);
                  if (_ve_descr.symbol_at (0))
                  {
                    goto _block4__branch1;
                  }
                  Expr _v_deref__descr (_ve_descr, 0);
                  uintptr_t _v_len11 = _v_deref__descr.get_len ();
                  uintptr_t _v_len12 = 0;
                  if (_v_len11 < _v_len12)
                  {
                    goto _block4__branch1;
                  }
                  uintptr_t _v_len__arg = (_v_len11 - _v_len12);
                  Expr _ve__e__e_tmp_m_rfpcrf_m_94_m_36 (_ve_descr, (0 + 1), _v_len___e__e_tmp_m_rfpcrf_m_94_m_36);
                  Expr _ve_arg (_v_deref__descr, 0, _v_len__arg);
                  _ge_next__7 = (_c_7 + _ve_next + _c_6 + _ve_arg + _c_5);
                  goto _block4;
                }
              _block4__branch1: {}
                _ge_next__7 = (_c_7 + _ve_next + _c_8);
              }
            _block4: {}
              Expr _vs_n_m_len;
              RF_CALL (Access::Length, _ge_next__7, _vs_n_m_len);
              Expr _ge_auxcall3;
              RF_CALL (Box::_q_, _vs_len, _ge_auxcall3);
              Expr _gs_auxcall4;
              if (!RF_CALL (Convert::To_m_Int, _ge_auxcall3, _gs_auxcall4))
              {
                goto _continue1;
              }
              Expr _vs_new;
              RF_CALL (Arithm::_p_, (_gs_auxcall4, _vs_n_m_len), _vs_new);
              {
                {
                  if (!RF_CALL (Compare::_gt_, (_vs_new, _c_9), /*void*/))
                  {
                    goto _block5__branch1;
                  }
                  Expr _gs_auxcall5;
                  RF_CALL (Arithm::_p_, (_vs_st_m_len, _vs_n_m_len), _gs_auxcall5);
                  RF_CALL (Box::Store, (_vs_len, _gs_auxcall5), /*void*/);
                  RF_CALL (StdIO::PrintLN, empty, /*void*/);
                  Expr _ge_auxcall6;
                  RF_CALL (List::Replicate, (_vs_st_m_len, _c_10), _ge_auxcall6);
                  RF_CALL (StdIO::Print, _ge_auxcall6, /*void*/);
                  goto _block5;
                }
              _block5__branch1: {}
                RF_CALL (Box::Store, (_vs_len, _vs_new), /*void*/);
              }
            _block5: {}
              RF_CALL (StdIO::Print, _ge_next__7, /*void*/);
            }
        _continue1: {}
          }
        _exit1: {}
        }
      _block3__branch1: {}
        RF_CALL (StdIO::PrintLN, _c_11, /*void*/);
        RF_CALL (StdIO::PrintLN, empty, /*void*/);
        RF_CALL (StdIO::PrintLN_e_, (StdIO::StdErr, _c_12), /*void*/);
        _v_res1 = empty;
      }
    _block2: {}
      goto _block1;
    }
  _block1__branch1: {}
    {
      if (_ve_files.get_len () < 1)
      {
        goto _block1__branch2;
      }
      RF_lsplit (_ve_files, 0, _ve_01, _v_lsplit__files);
      for ( ; ; RF_iter(_ve_files)++)
      {
        {
          if (!RF_iter(_ve_files))
          {
            goto _block1__branch2;
          }
          uintptr_t _v_len13 = _v_lsplit__files.get_len ();
          uintptr_t _v_len14 = 1;
          if (_v_len13 < _v_len14)
          {
            goto _block1__branch2;
          }
          uintptr_t _v_len__02 = (_v_len13 - _v_len14);
          if (_v_lsplit__files.symbol_at (0))
          {
            goto _continue2;
          }
          Expr _v_deref__lsplit__files (_v_lsplit__files, 0);
          uintptr_t _v_len15 = _v_deref__lsplit__files.get_len ();
          uintptr_t _v_len16 = 0;
          if (_v_len15 < _v_len16)
          {
            goto _continue2;
          }
          uintptr_t _v_len__file = (_v_len15 - _v_len16);
          Expr _ve_02 (_v_lsplit__files, (0 + 1), _v_len__02);
          Expr _ve_file (_v_deref__lsplit__files, 0, _v_len__file);
          Expr _ve_in_m_basename;
          Expr _ve_ext;
          {
            {
              if (_v_len__file < 1)
              {
                goto _block6__branch1;
              }
              RF_rsplit (_ve_file, 0, _v_rsplit__file, _ge_ext__4);
              for ( ; ; RF_iter(_ve_file)--)
              {
                {
                  if (!RF_iter(_ve_file))
                  {
                    goto _block6__branch1;
                  }
                  uintptr_t _v_len17 = _v_rsplit__file.get_len ();
                  uintptr_t _v_len18 = 1;
                  if (_v_len17 < _v_len18)
                  {
                    goto _block6__branch1;
                  }
                  uintptr_t _v_len__basename = (_v_len17 - _v_len18);
                  if (!_c_13.term_eq (_v_rsplit__file, (0 + _v_len__basename)))
                  {
                    goto _continue3;
                  }
                  Expr _ve_basename (_v_rsplit__file, 0, _v_len__basename);
                  _ve_in_m_basename = _ve_basename;
                  _ve_ext = (_c_14 + _ge_ext__4);
                  goto _exit3;
                }
            _continue3: {}
              }
            _exit3: {}
              goto _block6;
            }
          _block6__branch1: {}
            _ve_in_m_basename = _ve_file;
            _ve_ext = empty;
          }
        _block6: {}
          Expr _ve_basename;
          {
            {
              if (_ve_01.get_len () != 0)
              {
                goto _block7__branch1;
              }
              if (!RF_CALL (Table::Lookup, (rfp__helper::RFP_m_Options, _c_15), _ve_basename))
              {
                goto _block7__branch1;
              }
              goto _block7;
            }
          _block7__branch1: {}
            _ve_basename = _ve_in_m_basename;
          }
        _block7: {}
          Expr _ve_dirname;
          Expr _ve_filename;
          {
            {
              if (_ve_basename.get_len () < 1)
              {
                goto _block8__branch1;
              }
              RF_rsplit (_ve_basename, 0, _v_rsplit__basename, _ge_filename__6);
              for ( ; ; RF_iter(_ve_basename)--)
              {
                {
                  if (!RF_iter(_ve_basename))
                  {
                    goto _block8__branch1;
                  }
                  uintptr_t _v_len19 = _v_rsplit__basename.get_len ();
                  uintptr_t _v_len20 = 1;
                  if (_v_len19 < _v_len20)
                  {
                    goto _block8__branch1;
                  }
                  uintptr_t _v_len__dirname__6 = (_v_len19 - _v_len20);
                  if (!_vs_dir_m_separator.term_eq (_v_rsplit__basename, (0 + _v_len__dirname__6)))
                  {
                    goto _continue4;
                  }
                  Expr _ge_dirname__6 (_v_rsplit__basename, 0, _v_len__dirname__6);
                  _ve_dirname = _ge_dirname__6;
                  _ve_filename = _ge_filename__6;
                  goto _exit4;
                }
            _continue4: {}
              }
            _exit4: {}
              goto _block8;
            }
          _block8__branch1: {}
            _ve_dirname = empty;
            _ve_filename = _ve_basename;
          }
        _block8: {}
          Expr _ve_headname;
          {
            {
              if (!RF_CALL (Class::Channel_q_, _ve_basename, /*void*/))
              {
                goto _block9__branch1;
              }
              _ve_headname = _ve_in_m_basename;
              goto _block9;
            }
          _block9__branch1: {}
            _ve_headname = _ve_basename;
          }
        _block9: {}
          RF_CALL (rfp__helper::Subst, (_vs_dir_m_separator, _c_16, _ve_headname), _ve_headname);
          Expr _gs_auxcall7;
          RF_CALL (Convert::To_m_Word, _ve_headname, _gs_auxcall7);
          RF_CALL (CppMangle::Rfp2Cpp, _gs_auxcall7, _ve_headname);
          Expr _ge_auxalt10;
          {
            {
              {
                {
                  if (_ve_ext.get_len () != 4)
                  {
                    goto _block11__branch1;
                  }
                  if (!_c_17.eq (_ve_ext, 0))
                  {
                    goto _block11__branch1;
                  }
                  goto _block11;
                }
              _block11__branch1: {}
                if (_ve_ext.get_len () != 5)
                {
                  goto _block10__branch1;
                }
                if (!_c_18.eq (_ve_ext, 0))
                {
                  goto _block10__branch1;
                }
              }
            _block11: {}
              RF_CALL (Verbose, (_ve_filename + _c_19), /*void*/);
              Expr _ve_tokens;
              RF_CALL (rfp__lex::RFP_m_Lexer, _ve_file, _ve_tokens);
              RF_CALL (Box::Store, (RFP_m_Token_m_Stack, _ve_tokens), /*void*/);
              Expr _vt_as;
              RF_CALL (rfp__parse::RFP_m_Parser, /*void*/, _vt_as);
              RF_CALL (Verbose, (_ve_filename + _c_20), /*void*/);
              _ge_auxalt10 = (_c_21 + _vt_as);
              goto _block10;
            }
          _block10__branch1: {}
            {
              if (_ve_ext.get_len () != 5)
              {
                goto _block10__branch2;
              }
              if (!_c_22.eq (_ve_ext, 0))
              {
                goto _block10__branch2;
              }
              Expr _vs_channel;
              RF_CALL (StdIO::Channel, /*void*/, _vs_channel);
              if (!RF_CALL (StdIO::Open_m_File, (_vs_channel, _ve_file, _c_23), /*void*/))
              {
                goto _continue2;
              }
              Expr _v_Read_e_1;
              if (!RF_CALL (StdIO::Read_e_, _vs_channel, _v_Read_e_1))
              {
                goto _continue2;
              }
              _ge_auxalt10 = (_c_21 + _v_Read_e_1);
              goto _block10;
            }
          _block10__branch2: {}
            {
              if (_ve_ext.get_len () != 5)
              {
                goto _block10__branch3;
              }
              if (!_c_24.eq (_ve_ext, 0))
              {
                goto _block10__branch3;
              }
              Expr _vs_channel;
              RF_CALL (StdIO::Channel, /*void*/, _vs_channel);
              if (!RF_CALL (StdIO::Open_m_File, (_vs_channel, _ve_file, _c_23), /*void*/))
              {
                goto _continue2;
              }
              Expr _v_Read_e_2;
              if (!RF_CALL (StdIO::Read_e_, _vs_channel, _v_Read_e_2))
              {
                goto _continue2;
              }
              _ge_auxalt10 = (_c_25 + _v_Read_e_2);
              goto _block10;
            }
          _block10__branch3: {}
            {
              if (_ve_ext.get_len () != 5)
              {
                goto _block10__branch4;
              }
              if (!_c_26.eq (_ve_ext, 0))
              {
                goto _block10__branch4;
              }
              Expr _vs_channel;
              RF_CALL (StdIO::Channel, /*void*/, _vs_channel);
              if (!RF_CALL (StdIO::Open_m_File, (_vs_channel, _ve_file, _c_23), /*void*/))
              {
                goto _continue2;
              }
              Expr _gt_auxcall8;
              if (!RF_CALL (StdIO::Read_e_, _vs_channel, _gt_auxcall8))
              {
                goto _continue2;
              }
              Expr _gt_auxcall9;
              if (!RF_CALL (StdIO::Read_e_, _vs_channel, _gt_auxcall9))
              {
                goto _continue2;
              }
              _ge_auxalt10 = (_c_28 + (_c_27 + _gt_auxcall8 + _gt_auxcall9) ());
              goto _block10;
            }
          _block10__branch4: {}
            RF_CALL (StdIO::PrintLN_e_, (StdIO::StdErr, (_c_30 + _ve_ext + _c_29 + _ve_file)), /*void*/);
            if (!RF_CALL (Compilation_m_Failed, /*void*/, /*void*/))
            {
              goto _continue2;
            }
            _ge_auxalt10 = empty;
          }
        _block10: {}
          if (_ge_auxalt10.get_len () != 2)
          {
            goto _continue2;
          }
          if (_ge_auxalt10.symbol_at ((0 + 1)))
          {
            goto _continue2;
          }
          Expr _v_deref__auxalt10 (_ge_auxalt10, (0 + 1));
          uintptr_t _v_len21 = _v_deref__auxalt10.get_len ();
          uintptr_t _v_len22 = 2;
          if (_v_len21 < _v_len22)
          {
            goto _continue2;
          }
          uintptr_t _v_len__Items = (_v_len21 - _v_len22);
          if (!_ge_auxalt10.symbol_at (0))
          {
            goto _continue2;
          }
          if (!_v_deref__auxalt10.symbol_at (0))
          {
            goto _continue2;
          }
          Expr _vs_type (_ge_auxalt10, 0, 1);
          Expr _vs_tag (_v_deref__auxalt10, 0, 1);
          Expr _vt_ModuleName (_v_deref__auxalt10, (0 + 1), 1);
          Expr _ve_Items (_v_deref__auxalt10, (0 + 1 + 1), _v_len__Items);
          {
            {
              if (!_vs_type.term_eq (_c_28, 0))
              {
                goto _block12__branch1;
              }
              goto _block12;
            }
          _block12__branch1: {}
            RF_CALL (Get_m_Ready_m_To_m_Work, _ve_Items, /*void*/);
          }
        _block12: {}
          for ( ; ; )
          {
            {
              {
                if (!_vs_type.term_eq (_c_21, 0))
                {
                  goto _block13__branch1;
                }
                {
                  {
                    if (!RF_CALL (Table::In_m_Table_q_, (rfp__helper::RFP_m_Options, _c_21), /*void*/))
                    {
                      goto _block14__branch1;
                    }
                    Expr _vs_channel;
                    Expr _vs_need_m_close_q_;
                    RF_CALL (Open_m_Channel, (_ve_basename, _c_31), (_vs_channel, _vs_need_m_close_q_));
                    RF_CALL (RFP_m_Pretty_m_Print, (_vs_channel, empty, (_vs_tag + _vt_ModuleName + _ve_Items) ()), /*void*/);
                    {
                      {
                        if (!_vs_need_m_close_q_.term_eq (_c_0, 0))
                        {
                          goto _block15__branch1;
                        }
                        RF_CALL (StdIO::Close_m_Channel, _vs_channel, /*void*/);
                        goto _block15;
                      }
                    _block15__branch1: {}
                    }
                  _block15: {}
                    goto _block14;
                  }
                _block14__branch1: {}
                }
              _block14: {}
                {
                  {
                    Expr _v__q_3;
                    RF_CALL (Box::_q_, rfp__err::Error_m_Counter, _v__q_3);
                    if (_v__q_3.get_len () != 0)
                    {
                      goto _block16__branch1;
                    }
                    goto _block16;
                  }
                _block16__branch1: {}
                  if (!RF_CALL (Compilation_m_Failed, /*void*/, /*void*/))
                  {
                    goto _continue2;
                  }
                }
              _block16: {}
                {
                  {
                    if (!RF_CALL (Table::In_m_Table_q_, (rfp__helper::RFP_m_Options, _c_32), /*void*/))
                    {
                      goto _block17__branch1;
                    }
                    goto _block17;
                  }
                _block17__branch1: {}
                  RF_CALL (Verbose, _c_33, /*void*/);
                  RF_CALL (rfp__check::RFP_m_Check, _ve_Items, /*void*/);
                  RF_CALL (Verbose, _c_34, /*void*/);
                  {
                    {
                      Expr _v__q_4;
                      RF_CALL (Box::_q_, rfp__err::Error_m_Counter, _v__q_4);
                      if (_v__q_4.get_len () != 0)
                      {
                        goto _block18__branch1;
                      }
                      goto _block18;
                    }
                  _block18__branch1: {}
                    if (!RF_CALL (Compilation_m_Failed, /*void*/, /*void*/))
                    {
                      goto _continue2;
                    }
                  }
                _block18: {}
                }
              _block17: {}
                {
                  {
                    if (!RF_CALL (Table::In_m_Table_q_, (rfp__helper::RFP_m_Options, _c_35), /*void*/))
                    {
                      goto _block19__branch1;
                    }
                    goto _block19;
                  }
                _block19__branch1: {}
                  {
                    if (!RF_CALL (Table::In_m_Table_q_, (rfp__helper::RFP_m_Options, _c_36), /*void*/))
                    {
                      goto _block19__branch2;
                    }
                    goto _block19;
                  }
                _block19__branch2: {}
                  {
                    if (!RF_CALL (Table::In_m_Table_q_, (rfp__helper::RFP_m_Options, _c_37), /*void*/))
                    {
                      goto _block19__branch3;
                    }
                    goto _block19;
                  }
                _block19__branch3: {}
                  {
                    if (!RF_CALL (Table::In_m_Table_q_, (rfp__helper::RFP_m_Options, _c_38), /*void*/))
                    {
                      goto _block19__branch4;
                    }
                    goto _block19;
                  }
                _block19__branch4: {}
                  {
                    if (!RF_CALL (Table::In_m_Table_q_, (rfp__helper::RFP_m_Options, _c_39), /*void*/))
                    {
                      goto _block19__branch5;
                    }
                    goto _block19;
                  }
                _block19__branch5: {}
                  {
                    if (!RF_CALL (Table::In_m_Table_q_, (rfp__helper::RFP_m_Options, _c_28), /*void*/))
                    {
                      goto _block19__branch6;
                    }
                    goto _block19;
                  }
                _block19__branch6: {}
                  if (!RF_CALL (Table::In_m_Table_q_, (rfp__helper::RFP_m_Options, _c_25), /*void*/))
                  {
                    goto _continue2;
                  }
                }
              _block19: {}
                Expr _ge_Items__10;
                {
                  {
                    if (!RF_CALL (Table::In_m_Table_q_, (rfp__helper::RFP_m_Options, _c_40), /*void*/))
                    {
                      goto _block20__branch1;
                    }
                    _ge_Items__10 = _ve_Items;
                    goto _block20;
                  }
                _block20__branch1: {}
                  RF_CALL (Verbose, _c_41, /*void*/);
                  Expr _ge_Items__11;
                  RF_CALL (rfp__as2as::RFP_m_As2As_m_Transform, _ve_Items, _ge_Items__11);
                  RF_CALL (Verbose, _c_42, /*void*/);
                  _ge_Items__10 = _ge_Items__11;
                }
              _block20: {}
                _vs_type = _c_25;
                _ve_Items = _ge_Items__10;
                goto _block13;
              }
            _block13__branch1: {}
              {
                if (!_vs_type.term_eq (_c_25, 0))
                {
                  goto _block13__branch2;
                }
                {
                  {
                    if (!RF_CALL (Table::In_m_Table_q_, (rfp__helper::RFP_m_Options, _c_25), /*void*/))
                    {
                      goto _block21__branch1;
                    }
                    Expr _vs_channel;
                    Expr _vs_need_m_close_q_;
                    RF_CALL (Open_m_Channel, (_ve_basename, _c_43), (_vs_channel, _vs_need_m_close_q_));
                    RF_CALL (RFP_m_Pretty_m_Print, (_vs_channel, empty, (_vs_tag + _vt_ModuleName + _ve_Items) ()), /*void*/);
                    {
                      {
                        if (!_vs_need_m_close_q_.term_eq (_c_0, 0))
                        {
                          goto _block22__branch1;
                        }
                        RF_CALL (StdIO::Close_m_Channel, _vs_channel, /*void*/);
                        goto _block22;
                      }
                    _block22__branch1: {}
                    }
                  _block22: {}
                    goto _block21;
                  }
                _block21__branch1: {}
                }
              _block21: {}
                {
                  {
                    if (!RF_CALL (Table::In_m_Table_q_, (rfp__helper::RFP_m_Options, _c_35), /*void*/))
                    {
                      goto _block23__branch1;
                    }
                    goto _block23;
                  }
                _block23__branch1: {}
                  {
                    if (!RF_CALL (Table::In_m_Table_q_, (rfp__helper::RFP_m_Options, _c_36), /*void*/))
                    {
                      goto _block23__branch2;
                    }
                    goto _block23;
                  }
                _block23__branch2: {}
                  {
                    if (!RF_CALL (Table::In_m_Table_q_, (rfp__helper::RFP_m_Options, _c_37), /*void*/))
                    {
                      goto _block23__branch3;
                    }
                    goto _block23;
                  }
                _block23__branch3: {}
                  {
                    if (!RF_CALL (Table::In_m_Table_q_, (rfp__helper::RFP_m_Options, _c_38), /*void*/))
                    {
                      goto _block23__branch4;
                    }
                    goto _block23;
                  }
                _block23__branch4: {}
                  {
                    if (!RF_CALL (Table::In_m_Table_q_, (rfp__helper::RFP_m_Options, _c_39), /*void*/))
                    {
                      goto _block23__branch5;
                    }
                    goto _block23;
                  }
                _block23__branch5: {}
                  if (!RF_CALL (Table::In_m_Table_q_, (rfp__helper::RFP_m_Options, _c_28), /*void*/))
                  {
                    goto _continue2;
                  }
                }
              _block23: {}
                RF_CALL (Verbose, _c_44, /*void*/);
                Expr _v_RFP_m_Compile1;
                RF_CALL (rfp__compile::RFP_m_Compile, _ve_Items, _v_RFP_m_Compile1);
                if (_v_RFP_m_Compile1.get_len () != 2)
                {
                  goto _continue2;
                }
                if (_v_RFP_m_Compile1.symbol_at (0))
                {
                  goto _continue2;
                }
                if (_v_RFP_m_Compile1.symbol_at ((0 + 1)))
                {
                  goto _continue2;
                }
                Expr _v_deref__RFP_m_Compile1 (_v_RFP_m_Compile1, 0);
                Expr _v_deref__RFP_m_Compile12 (_v_RFP_m_Compile1, (0 + 1));
                uintptr_t _v_len23 = _v_deref__RFP_m_Compile12.get_len ();
                uintptr_t _v_len24 = 1;
                if (_v_len23 < _v_len24)
                {
                  goto _continue2;
                }
                uintptr_t _v_len__module = (_v_len23 - _v_len24);
                uintptr_t _v_len25 = _v_deref__RFP_m_Compile1.get_len ();
                uintptr_t _v_len26 = 1;
                if (_v_len25 < _v_len26)
                {
                  goto _continue2;
                }
                uintptr_t _v_len__interf = (_v_len25 - _v_len26);
                if (!_c_45.term_eq (_v_deref__RFP_m_Compile1, 0))
                {
                  goto _continue2;
                }
                if (!_c_46.term_eq (_v_deref__RFP_m_Compile12, 0))
                {
                  goto _continue2;
                }
                Expr _ve_interf (_v_deref__RFP_m_Compile1, (0 + 1), _v_len__interf);
                Expr _ve_module (_v_deref__RFP_m_Compile12, (0 + 1), _v_len__module);
                RF_CALL (Verbose, _c_47, /*void*/);
                _vs_type = _c_28;
                _ve_Items = ((_c_45 + _vt_ModuleName + _ve_interf) () + (_c_46 + _vt_ModuleName + _ve_module) ());
                goto _block13;
              }
            _block13__branch2: {}
              if (!_vs_type.term_eq (_c_28, 0))
              {
                RF_FUNC_ERROR (unexpected_fail);
              }
              if (_ve_Items.get_len () != 2)
              {
                goto _continue2;
              }
              if (_ve_Items.symbol_at ((0 + 1)))
              {
                goto _continue2;
              }
              Expr _v_deref__Items (_ve_Items, (0 + 1));
              uintptr_t _v_len27 = _v_deref__Items.get_len ();
              uintptr_t _v_len28 = 2;
              if (_v_len27 < _v_len28)
              {
                goto _continue2;
              }
              uintptr_t _v_len__asail_m_module = (_v_len27 - _v_len28);
              if (!_c_46.term_eq (_v_deref__Items, 0))
              {
                goto _continue2;
              }
              Expr _vt_interf (_ve_Items, 0, 1);
              Expr _vt_asail_m_mod_m_name (_v_deref__Items, (0 + 1), 1);
              Expr _ve_asail_m_module (_v_deref__Items, (0 + 1 + 1), _v_len__asail_m_module);
              Expr _ve_module;
              {
                {
                  if (!RF_CALL (Table::In_m_Table_q_, (rfp__helper::RFP_m_Options, _c_48), /*void*/))
                  {
                    goto _block24__branch1;
                  }
                  _ve_module = _ve_asail_m_module;
                  goto _block24;
                }
              _block24__branch1: {}
                RF_CALL (Verbose, _c_49, /*void*/);
                Expr _ge_module__11;
                RF_CALL (rfp__asail2asail::Simplify_m_ASAIL, _ve_asail_m_module, _ge_module__11);
                RF_CALL (Verbose, _c_50, /*void*/);
                _ve_module = _ge_module__11;
              }
            _block24: {}
              {
                {
                  if (!RF_CALL (Table::In_m_Table_q_, (rfp__helper::RFP_m_Options, _c_28), /*void*/))
                  {
                    goto _block25__branch1;
                  }
                  Expr _vs_channel;
                  Expr _vs_need_m_close_q_;
                  RF_CALL (Open_m_Channel, (_ve_basename, _c_51), (_vs_channel, _vs_need_m_close_q_));
                  {
                    Expr _v_compose1 ((_vt_interf + (_c_46 + _vt_asail_m_mod_m_name + _ve_module) ()));
                    RF_lsplit (_v_compose1, 0, _ve__e__e_tmp_m_rfpcrf_m_232_m_64, _v_lsplit__compose1);
                    for ( ; ; RF_iter(_v_compose1)++)
                    {
                      {
                        if (!RF_iter(_v_compose1))
                        {
                          goto _block26__branch1;
                        }
                        uintptr_t _v_len29 = _v_lsplit__compose1.get_len ();
                        uintptr_t _v_len30 = 1;
                        if (_v_len29 < _v_len30)
                        {
                          goto _block26__branch1;
                        }
                        uintptr_t _v_len___e__e_tmp_m_rfpcrf_m_232_m_73 = (_v_len29 - _v_len30);
                        Expr _vt_item (_v_lsplit__compose1, 0, 1);
                        Expr _ve__e__e_tmp_m_rfpcrf_m_232_m_73 (_v_lsplit__compose1, (0 + 1), _v_len___e__e_tmp_m_rfpcrf_m_232_m_73);
                        RF_CALL (RFP_m_Pretty_m_Print, (_vs_channel, empty, _vt_item), /*void*/);
                      }
                  _continue5: {}
                    }
                  _exit5: {}
                  }
                _block26__branch1: {}
                  {
                    {
                      if (!_vs_need_m_close_q_.term_eq (_c_0, 0))
                      {
                        goto _block27__branch1;
                      }
                      RF_CALL (StdIO::Close_m_Channel, _vs_channel, /*void*/);
                      goto _block27;
                    }
                  _block27__branch1: {}
                  }
                _block27: {}
                  goto _block25;
                }
              _block25__branch1: {}
              }
            _block25: {}
              RF_CALL (Extract_m_Inputs, _ve_module, _ve_module);
              {
                if (!RF_CALL (Table::In_m_Table_q_, (rfp__helper::RFP_m_Options, _c_36), /*void*/))
                {
                  goto _block28__branch1;
                }
                if (_vt_interf.symbol_at (0))
                {
                  goto _block28__branch1;
                }
                Expr _v_deref__interf (_vt_interf, 0);
                uintptr_t _v_len31 = _v_deref__interf.get_len ();
                uintptr_t _v_len32 = 2;
                if (_v_len31 < (_v_len32 + 1))
                {
                  goto _block28__branch1;
                }
                uintptr_t _v_len__headers = (_v_len31 - _v_len32);
                if (!_c_45.term_eq (_v_deref__interf, 0))
                {
                  goto _block28__branch1;
                }
                Expr _vt__e__e_tmp_m_rfpcrf_m_241_m_38 (_v_deref__interf, (0 + 1), 1);
                Expr _vv_headers (_v_deref__interf, (0 + 1 + 1), _v_len__headers);
                RF_CALL (Verbose, _c_52, /*void*/);
                Expr _ve_headers;
                RF_CALL (rfp__asail__cpp::RFP_m_ASAIL_m_To_m_CPP, (_vt_asail_m_mod_m_name, _vv_headers), _ve_headers);
                RF_CALL (Verbose, _c_53, /*void*/);
                Expr _vs_channel;
                Expr _vs_need_m_close_q_;
                RF_CALL (Open_m_Channel, (_ve_basename, _c_54), (_vs_channel, _vs_need_m_close_q_));
                RF_CALL (StdIO::PrintLN_e_, (_vs_channel, (_c_56 + _ve_headname + _c_55)), /*void*/);
                RF_CALL (StdIO::PrintLN_e_, (_vs_channel, (_c_57 + _ve_headname + _c_55)), /*void*/);
                RF_CALL (StdIO::PrintLN_e_, (_vs_channel, _c_58), /*void*/);
                RF_CALL (CPP_m_Pretty_m_Print, (_c_59, _vs_channel, empty, _ve_headers), /*void*/);
                RF_CALL (StdIO::PrintLN_e_, (_vs_channel, (_c_60 + _ve_headname + _c_55)), /*void*/);
                {
                  {
                    if (!_vs_need_m_close_q_.term_eq (_c_0, 0))
                    {
                      goto _block29__branch1;
                    }
                    RF_CALL (StdIO::Close_m_Channel, _vs_channel, /*void*/);
                    goto _block29;
                  }
                _block29__branch1: {}
                }
              _block29: {}
                {
                  {
                    if (!RF_CALL (Table::In_m_Table_q_, (rfp__helper::RFP_m_Options, _c_61), /*void*/))
                    {
                      goto _block30__branch1;
                    }
                    {
                      if (!RF_CALL (Class::Channel_q_, _ve_basename, /*void*/))
                      {
                        goto _negation1;
                      }
                      goto _block30__branch1;
                    }
                  _negation1: {}
                    Expr _ve_lowname;
                    RF_CALL (Convert::To_m_Lower, _ve_filename, _ve_lowname);
                    {
                      if (_ve_filename.get_len () != _ve_lowname.get_len ())
                      {
                        goto _negation2;
                      }
                      if (!_ve_lowname.eq (_ve_filename, 0))
                      {
                        goto _negation2;
                      }
                      goto _block30__branch1;
                    }
                  _negation2: {}
                    uintptr_t _v_len33 = _ve_basename.get_len ();
                    uintptr_t _v_len34 = _ve_filename.get_len ();
                    if (_v_len33 < _v_len34)
                    {
                      goto _block28__branch1;
                    }
                    uintptr_t _v_len__dir = (_v_len33 - _v_len34);
                    if (!_ve_filename.eq (_ve_basename, (0 + _v_len__dir)))
                    {
                      goto _block28__branch1;
                    }
                    Expr _ve_dir (_ve_basename, 0, _v_len__dir);
                    Expr _ve_lowbase ((_ve_dir + _ve_lowname));
                    Expr _gs_channel__14;
                    Expr _gs_need_m_close_q___14;
                    RF_CALL (Open_m_Channel, (_ve_lowbase, _c_54), (_gs_channel__14, _gs_need_m_close_q___14));
                    Expr _ge_headname__14;
                    RF_CALL (rfp__helper::Subst, (_vs_dir_m_separator, _c_16, _ve_lowbase), _ge_headname__14);
                    Expr _gs_auxcall11;
                    RF_CALL (Convert::To_m_Word, _ge_headname__14, _gs_auxcall11);
                    RF_CALL (CppMangle::Rfp2Cpp, _gs_auxcall11, _ge_headname__14);
                    RF_CALL (StdIO::PrintLN_e_, (_gs_channel__14, (_c_56 + _ge_headname__14 + _c_55)), /*void*/);
                    RF_CALL (StdIO::PrintLN_e_, (_gs_channel__14, (_c_57 + _ge_headname__14 + _c_55)), /*void*/);
                    RF_CALL (StdIO::PrintLN_e_, (_gs_channel__14, (_c_63 + _ve_basename + _c_62)), /*void*/);
                    RF_CALL (StdIO::PrintLN_e_, (_gs_channel__14, _c_64), /*void*/);
                    RF_CALL (StdIO::PrintLN_e_, (_gs_channel__14, (_c_67 + _ve_lowname + _c_66 + _ve_filename + _c_65)), /*void*/);
                    RF_CALL (StdIO::PrintLN_e_, (_gs_channel__14, _c_68), /*void*/);
                    RF_CALL (StdIO::PrintLN_e_, (_gs_channel__14, (_c_60 + _ge_headname__14 + _c_55)), /*void*/);
                    {
                      {
                        if (!_gs_need_m_close_q___14.term_eq (_c_0, 0))
                        {
                          goto _block32__branch1;
                        }
                        RF_CALL (StdIO::Close_m_Channel, _gs_channel__14, /*void*/);
                        goto _block32;
                      }
                    _block32__branch1: {}
                    }
                  _block32: {}
                    goto _block30;
                  }
                _block30__branch1: {}
                }
              _block30: {}
              }
            _block28__branch1: {}
              {
                if (!RF_CALL (Table::In_m_Table_q_, (rfp__helper::RFP_m_Options, _c_35), /*void*/))
                {
                  goto _block28__branch2;
                }
                uintptr_t _v_len35 = _v_len__asail_m_module;
                uintptr_t _v_len36 = 0;
                if (_v_len35 < (_v_len36 + 1))
                {
                  goto _block28__branch2;
                }
                uintptr_t _v_len___e__e_tmp_m_rfpcrf_m_273_m_60 = (_v_len35 - _v_len36);
                Expr _vv__e__e_tmp_m_rfpcrf_m_273_m_60 (_ve_asail_m_module, 0, _v_len___e__e_tmp_m_rfpcrf_m_273_m_60);
                RF_CALL (Verbose, _c_69, /*void*/);
                Expr _ge_module__12;
                RF_CALL (rfp__asail__cpp::RFP_m_ASAIL_m_To_m_CPP, (_vt_asail_m_mod_m_name, _ve_module), _ge_module__12);
                RF_CALL (Verbose, _c_70, /*void*/);
                Expr _vs_channel;
                Expr _vs_need_m_close_q_;
                RF_CALL (Open_m_Channel, (_ve_basename, _c_71), (_vs_channel, _vs_need_m_close_q_));
                RF_CALL (StdIO::PrintLN_e_, (_vs_channel, _c_72), /*void*/);
                {
                  Expr _v_Domain1;
                  RF_CALL (Table::Domain, RFP_m_Includes, _v_Domain1);
                  if (_v_Domain1.get_len () < 1)
                  {
                    goto _block33__branch1;
                  }
                  RF_lsplit (_v_Domain1, 0, _ve__e__e_tmp_m_rfpcrf_m_280_m_43, _v_lsplit__Domain1);
                  for ( ; ; RF_iter(_v_Domain1)++)
                  {
                    {
                      if (!RF_iter(_v_Domain1))
                      {
                        goto _block33__branch1;
                      }
                      uintptr_t _v_len37 = _v_lsplit__Domain1.get_len ();
                      uintptr_t _v_len38 = 1;
                      if (_v_len37 < _v_len38)
                      {
                        goto _block33__branch1;
                      }
                      uintptr_t _v_len___e__e_tmp_m_rfpcrf_m_280_m_57 = (_v_len37 - _v_len38);
                      if (_v_lsplit__Domain1.symbol_at (0))
                      {
                        goto _continue6;
                      }
                      Expr _v_deref__lsplit__Domain1 (_v_lsplit__Domain1, 0);
                      uintptr_t _v_len39 = _v_deref__lsplit__Domain1.get_len ();
                      uintptr_t _v_len40 = 0;
                      if (_v_len39 < _v_len40)
                      {
                        goto _continue6;
                      }
                      uintptr_t _v_len__include = (_v_len39 - _v_len40);
                      Expr _ve__e__e_tmp_m_rfpcrf_m_280_m_57 (_v_lsplit__Domain1, (0 + 1), _v_len___e__e_tmp_m_rfpcrf_m_280_m_57);
                      Expr _ve_include (_v_deref__lsplit__Domain1, 0, _v_len__include);
                      Expr _v_Lookup1;
                      if (!RF_CALL (Table::Lookup, (RFP_m_Includes, _ve_include), _v_Lookup1))
                      {
                        goto _continue6;
                      }
                      Expr _ge_include__15;
                      {
                        {
                          uintptr_t _v_len41 = _v_Lookup1.get_len ();
                          uintptr_t _v_len42 = 1;
                          if (_v_len41 < _v_len42)
                          {
                            goto _block34__branch1;
                          }
                          uintptr_t _v_len___e__e_tmp_m_rfpcrf_m_282_m_27 = (_v_len41 - _v_len42);
                          if (!_c_73.term_eq (_v_Lookup1, 0))
                          {
                            goto _block34__branch1;
                          }
                          Expr _ve__e__e_tmp_m_rfpcrf_m_282_m_27 (_v_Lookup1, (0 + 1), _v_len___e__e_tmp_m_rfpcrf_m_282_m_27);
                          _ge_include__15 = (_c_74 + _ve_include + _c_62);
                          goto _block34;
                        }
                      _block34__branch1: {}
                        {
                          if (_v_Lookup1.get_len () < 24)
                          {
                            goto _block34__branch2;
                          }
                          if (!_c_79.term_eq (_v_Lookup1, 0))
                          {
                            goto _block34__branch2;
                          }
                          Expr _v_subexpr__Lookup1 (_v_Lookup1, (0 + 1), (_v_Lookup1.get_len () - (0 + 1 + 0)));
                          RF_lsplit (_v_subexpr__Lookup1, 0, _ve__e__e_tmp_m_rfpcrf_m_283_m_28, _v_lsplit__Lookup1);
                          for ( ; ; RF_iter(_v_subexpr__Lookup1)++)
                          {
                            {
                              if (!RF_iter(_v_subexpr__Lookup1))
                              {
                                goto _block34__branch2;
                              }
                              uintptr_t _v_len43 = _v_lsplit__Lookup1.get_len ();
                              uintptr_t _v_len44 = 23;
                              if (_v_len43 < _v_len44)
                              {
                                goto _block34__branch2;
                              }
                              uintptr_t _v_len___e__e_tmp_m_rfpcrf_m_283_m_68 = (_v_len43 - _v_len44);
                              if (!_c_78.eq (_v_lsplit__Lookup1, 0))
                              {
                                goto _continue7;
                              }
                              if (!_v_lsplit__Lookup1.symbol_at ((0 + 1 + 1 + 1)))
                              {
                                goto _continue7;
                              }
                              if (!_c_77.eq (_v_lsplit__Lookup1, (0 + 1 + 1 + 1 + 1)))
                              {
                                goto _continue7;
                              }
                              if (!_v_lsplit__Lookup1.symbol_at ((0 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1)))
                              {
                                goto _continue7;
                              }
                              if (!_c_76.eq (_v_lsplit__Lookup1, (0 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1)))
                              {
                                goto _continue7;
                              }
                              if (!_v_lsplit__Lookup1.symbol_at ((0 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1)))
                              {
                                goto _continue7;
                              }
                              if (!_c_75.eq (_v_lsplit__Lookup1, (0 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1)))
                              {
                                goto _continue7;
                              }
                              Expr _vs__e__e_tmp_m_rfpcrf_m_283_m_36 (_v_lsplit__Lookup1, (0 + 1 + 1 + 1), 1);
                              Expr _vs__e__e_tmp_m_rfpcrf_m_283_m_46 (_v_lsplit__Lookup1, (0 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1), 1);
                              Expr _vs__e__e_tmp_m_rfpcrf_m_283_m_55 (_v_lsplit__Lookup1, (0 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1), 1);
                              Expr _ve__e__e_tmp_m_rfpcrf_m_283_m_68 (_v_lsplit__Lookup1, (0 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1), _v_len___e__e_tmp_m_rfpcrf_m_283_m_68);
                              goto _continue6;
                            }
                        _continue7: {}
                          }
                        _exit7: {}
                        }
                      _block34__branch2: {}
                        uintptr_t _v_len45 = _v_Lookup1.get_len ();
                        uintptr_t _v_len46 = 1;
                        if (_v_len45 < _v_len46)
                        {
                          goto _continue6;
                        }
                        uintptr_t _v_len__path = (_v_len45 - _v_len46);
                        if (!_c_79.term_eq (_v_Lookup1, 0))
                        {
                          goto _continue6;
                        }
                        Expr _ve_path (_v_Lookup1, (0 + 1), _v_len__path);
                        _ge_include__15 = (_c_81 + _ve_path + _ve_include + _c_80);
                      }
                    _block34: {}
                      RF_CALL (StdIO::PrintLN_e_, (_vs_channel, (_c_82 + _ge_include__15)), /*void*/);
                    }
                _continue6: {}
                  }
                _exit6: {}
                }
              _block33__branch1: {}
                RF_CALL (CPP_m_Pretty_m_Print, (_c_59, _vs_channel, empty, _ge_module__12), /*void*/);
                {
                  {
                    if (!_vs_need_m_close_q_.term_eq (_c_0, 0))
                    {
                      goto _block35__branch1;
                    }
                    RF_CALL (StdIO::Close_m_Channel, _vs_channel, /*void*/);
                    goto _block35;
                  }
                _block35__branch1: {}
                }
              _block35: {}
              }
            _block28__branch2: {}
              {
                if (!RF_CALL (Table::In_m_Table_q_, (rfp__helper::RFP_m_Options, _c_39), /*void*/))
                {
                  goto _block28__branch3;
                }
                uintptr_t _v_len47 = _v_len__asail_m_module;
                uintptr_t _v_len48 = 0;
                if (_v_len47 < (_v_len48 + 1))
                {
                  goto _block28__branch3;
                }
                uintptr_t _v_len___e__e_tmp_m_rfpcrf_m_292_m_61 = (_v_len47 - _v_len48);
                Expr _vv__e__e_tmp_m_rfpcrf_m_292_m_61 (_ve_asail_m_module, 0, _v_len___e__e_tmp_m_rfpcrf_m_292_m_61);
                RF_CALL (Verbose, _c_83, /*void*/);
                Expr _ge_module__12;
                RF_CALL (rfp__asail__tpp::RFP_m_ASAIL_m_To_m_TPP, (_vt_asail_m_mod_m_name, _ve_module), _ge_module__12);
                RF_CALL (Verbose, _c_84, /*void*/);
                Expr _vs_channel;
                Expr _vs_need_m_close_q_;
                RF_CALL (Open_m_Channel, (_ve_basename, _c_85), (_vs_channel, _vs_need_m_close_q_));
                RF_CALL (StdIO::PrintLN_e_, (_vs_channel, _c_72), /*void*/);
                {
                  Expr _v_Domain2;
                  RF_CALL (Table::Domain, RFP_m_Includes, _v_Domain2);
                  if (_v_Domain2.get_len () < 1)
                  {
                    goto _block36__branch1;
                  }
                  RF_lsplit (_v_Domain2, 0, _ve__e__e_tmp_m_rfpcrf_m_299_m_43, _v_lsplit__Domain2);
                  for ( ; ; RF_iter(_v_Domain2)++)
                  {
                    {
                      if (!RF_iter(_v_Domain2))
                      {
                        goto _block36__branch1;
                      }
                      uintptr_t _v_len49 = _v_lsplit__Domain2.get_len ();
                      uintptr_t _v_len50 = 1;
                      if (_v_len49 < _v_len50)
                      {
                        goto _block36__branch1;
                      }
                      uintptr_t _v_len___e__e_tmp_m_rfpcrf_m_299_m_57 = (_v_len49 - _v_len50);
                      if (_v_lsplit__Domain2.symbol_at (0))
                      {
                        goto _continue8;
                      }
                      Expr _v_deref__lsplit__Domain2 (_v_lsplit__Domain2, 0);
                      uintptr_t _v_len51 = _v_deref__lsplit__Domain2.get_len ();
                      uintptr_t _v_len52 = 0;
                      if (_v_len51 < _v_len52)
                      {
                        goto _continue8;
                      }
                      uintptr_t _v_len__include2 = (_v_len51 - _v_len52);
                      Expr _ve__e__e_tmp_m_rfpcrf_m_299_m_57 (_v_lsplit__Domain2, (0 + 1), _v_len___e__e_tmp_m_rfpcrf_m_299_m_57);
                      Expr _ve_include (_v_deref__lsplit__Domain2, 0, _v_len__include2);
                      Expr _v_Lookup2;
                      if (!RF_CALL (Table::Lookup, (RFP_m_Includes, _ve_include), _v_Lookup2))
                      {
                        goto _continue8;
                      }
                      Expr _ge_include__15;
                      {
                        {
                          uintptr_t _v_len53 = _v_Lookup2.get_len ();
                          uintptr_t _v_len54 = 1;
                          if (_v_len53 < _v_len54)
                          {
                            goto _block37__branch1;
                          }
                          uintptr_t _v_len___e__e_tmp_m_rfpcrf_m_301_m_27 = (_v_len53 - _v_len54);
                          if (!_c_73.term_eq (_v_Lookup2, 0))
                          {
                            goto _block37__branch1;
                          }
                          Expr _ve__e__e_tmp_m_rfpcrf_m_301_m_27 (_v_Lookup2, (0 + 1), _v_len___e__e_tmp_m_rfpcrf_m_301_m_27);
                          _ge_include__15 = (_c_74 + _ve_include + _c_62);
                          goto _block37;
                        }
                      _block37__branch1: {}
                        uintptr_t _v_len55 = _v_Lookup2.get_len ();
                        uintptr_t _v_len56 = 1;
                        if (_v_len55 < _v_len56)
                        {
                          goto _continue8;
                        }
                        uintptr_t _v_len__path2 = (_v_len55 - _v_len56);
                        if (!_c_79.term_eq (_v_Lookup2, 0))
                        {
                          goto _continue8;
                        }
                        Expr _ve_path (_v_Lookup2, (0 + 1), _v_len__path2);
                        _ge_include__15 = (_c_81 + _ve_path + _ve_include + _c_80);
                      }
                    _block37: {}
                      RF_CALL (StdIO::PrintLN_e_, (_vs_channel, (_c_82 + _ge_include__15)), /*void*/);
                    }
                _continue8: {}
                  }
                _exit8: {}
                }
              _block36__branch1: {}
                RF_CALL (CPP_m_Pretty_m_Print, (_c_59, _vs_channel, empty, _ge_module__12), /*void*/);
                {
                  {
                    if (!_vs_need_m_close_q_.term_eq (_c_0, 0))
                    {
                      goto _block38__branch1;
                    }
                    RF_CALL (StdIO::Close_m_Channel, _vs_channel, /*void*/);
                    goto _block38;
                  }
                _block38__branch1: {}
                }
              _block38: {}
              }
            _block28__branch3: {}
              {
                if (!RF_CALL (Table::In_m_Table_q_, (rfp__helper::RFP_m_Options, _c_37), /*void*/))
                {
                  goto _block28__branch4;
                }
                RF_CALL (Verbose, _c_86, /*void*/);
                if (_vt_interf.symbol_at (0))
                {
                  goto _block28__branch4;
                }
                Expr _v_deref__interf2 (_vt_interf, 0);
                uintptr_t _v_len57 = _v_deref__interf2.get_len ();
                uintptr_t _v_len58 = 2;
                if (_v_len57 < _v_len58)
                {
                  goto _block28__branch4;
                }
                uintptr_t _v_len__headers2 = (_v_len57 - _v_len58);
                if (!_c_45.term_eq (_v_deref__interf2, 0))
                {
                  goto _block28__branch4;
                }
                Expr _vt__e__e_tmp_m_rfpcrf_m_312_m_38 (_v_deref__interf2, (0 + 1), 1);
                Expr _ve_headers (_v_deref__interf2, (0 + 1 + 1), _v_len__headers2);
                Expr _ve_exports;
                Expr _ge_headers__14 (_ve_headers);
                Expr _ge_exports__14 (empty);
                for ( ; ; )
                {
                  {
                    if (_ge_headers__14.get_len () != 0)
                    {
                      goto _iter2;
                    }
                    _ve_exports = _ge_exports__14;
                    goto _exit__iter2;
                  }
                _iter2: {}
                  uintptr_t _v_len59 = _ge_headers__14.get_len ();
                  uintptr_t _v_len60 = 1;
                  if (_v_len59 < _v_len60)
                  {
                    RF_FUNC_ERROR (unexpected_fail);
                  }
                  uintptr_t _v_len__rest = (_v_len59 - _v_len60);
                  if (_ge_headers__14.symbol_at (0))
                  {
                    RF_FUNC_ERROR (unexpected_fail);
                  }
                  Expr _v_deref__headers__14 (_ge_headers__14, 0);
                  if (_v_deref__headers__14.get_len () != 2)
                  {
                    RF_FUNC_ERROR (unexpected_fail);
                  }
                  if (!_v_deref__headers__14.symbol_at (0))
                  {
                    RF_FUNC_ERROR (unexpected_fail);
                  }
                  Expr _ve_rest (_ge_headers__14, (0 + 1), _v_len__rest);
                  Expr _vs_decl (_v_deref__headers__14, 0, 1);
                  Expr _vt_name (_v_deref__headers__14, (0 + 1), 1);
                  _ge_headers__14 = _ve_rest;
                  _ge_exports__14 = (_ge_exports__14 + _vt_name);
                }
              _exit__iter2: {}
                Expr _ve_java_m_module_m_name;
                Expr _ve_inputs;
                Expr _ge_module__13;
                RF_CALL (rfp__asail__java::RFP_m_ASAIL_m_To_m_Java, (_vt_asail_m_mod_m_name, _ve_exports, _ve_module), (_ve_java_m_module_m_name, _ve_inputs, _ge_module__13));
                RF_CALL (Verbose, _c_87, /*void*/);
                Expr _ge_java_m_module_m_name__14;
                {
                  {
                    if (!RF_CALL (Table::In_m_Table_q_, (rfp__helper::RFP_m_Options, _c_15), /*void*/))
                    {
                      goto _block41__branch1;
                    }
                    _ge_java_m_module_m_name__14 = _ve_basename;
                    goto _block41;
                  }
                _block41__branch1: {}
                  {
                    uintptr_t _v_len61 = _ve_dirname.get_len ();
                    uintptr_t _v_len62 = 0;
                    if (_v_len61 < (_v_len62 + 1))
                    {
                      goto _block41__branch2;
                    }
                    uintptr_t _v_len___e__e_tmp_m_rfpcrf_m_326_m_30 = (_v_len61 - _v_len62);
                    Expr _vv__e__e_tmp_m_rfpcrf_m_326_m_30 (_ve_dirname, 0, _v_len___e__e_tmp_m_rfpcrf_m_326_m_30);
                    _ge_java_m_module_m_name__14 = (_ve_dirname + _vs_dir_m_separator + _ve_java_m_module_m_name);
                    goto _block41;
                  }
                _block41__branch2: {}
                  _ge_java_m_module_m_name__14 = _ve_java_m_module_m_name;
                }
              _block41: {}
                Expr _vs_channel;
                Expr _vs_need_m_close_q_;
                RF_CALL (Open_m_Channel, (_ge_java_m_module_m_name__14, _c_88), (_vs_channel, _vs_need_m_close_q_));
                Expr _ve_package;
                {
                  {
                    Expr _v__q_5;
                    RF_CALL (Box::_q_, RFP_m_Include_m_Path, _v__q_5);
                    if (_v__q_5.get_len () < 1)
                    {
                      goto _block42__branch1;
                    }
                    RF_lsplit (_v__q_5, 0, _ve__e__e_tmp_m_rfpcrf_m_331_m_42, _v_lsplit___q_5);
                    for ( ; ; RF_iter(_v__q_5)++)
                    {
                      {
                        if (!RF_iter(_v__q_5))
                        {
                          goto _block42__branch1;
                        }
                        uintptr_t _v_len63 = _v_lsplit___q_5.get_len ();
                        uintptr_t _v_len64 = 1;
                        if (_v_len63 < _v_len64)
                        {
                          goto _block42__branch1;
                        }
                        uintptr_t _v_len___e__e_tmp_m_rfpcrf_m_331_m_52 = (_v_len63 - _v_len64);
                        if (_v_lsplit___q_5.symbol_at (0))
                        {
                          goto _continue9;
                        }
                        Expr _v_deref__lsplit___q_5 (_v_lsplit___q_5, 0);
                        uintptr_t _v_len65 = _v_deref__lsplit___q_5.get_len ();
                        uintptr_t _v_len66 = 0;
                        if (_v_len65 < _v_len66)
                        {
                          goto _continue9;
                        }
                        uintptr_t _v_len__dir2 = (_v_len65 - _v_len66);
                        Expr _ve__e__e_tmp_m_rfpcrf_m_331_m_52 (_v_lsplit___q_5, (0 + 1), _v_len___e__e_tmp_m_rfpcrf_m_331_m_52);
                        Expr _ve_dir (_v_deref__lsplit___q_5, 0, _v_len__dir2);
                        {
                          {
                            if (_ve_dirname.get_len () != _v_len__dir2)
                            {
                              goto _block43__branch1;
                            }
                            if (!_ve_dir.eq (_ve_dirname, 0))
                            {
                              goto _block43__branch1;
                            }
                            _ve_package = empty;
                            goto _block43;
                          }
                        _block43__branch1: {}
                          uintptr_t _v_len67 = _ve_dirname.get_len ();
                          uintptr_t _v_len68 = (_v_len__dir2 + 1);
                          if (_v_len67 < _v_len68)
                          {
                            goto _continue9;
                          }
                          uintptr_t _v_len__package__18 = (_v_len67 - _v_len68);
                          if (!_ve_dir.eq (_ve_dirname, 0))
                          {
                            goto _continue9;
                          }
                          if (!_vs_dir_m_separator.term_eq (_ve_dirname, (0 + _v_len__dir2)))
                          {
                            goto _continue9;
                          }
                          Expr _ge_package__18 (_ve_dirname, (0 + _v_len__dir2 + 1), _v_len__package__18);
                          _ve_package = _ge_package__18;
                        }
                      _block43: {}
                        goto _exit9;
                      }
                  _continue9: {}
                    }
                  _exit9: {}
                    goto _block42;
                  }
                _block42__branch1: {}
                  _ve_package = _ve_dirname;
                }
              _block42: {}
                {
                  {
                    uintptr_t _v_len69 = _ve_package.get_len ();
                    uintptr_t _v_len70 = 0;
                    if (_v_len69 < (_v_len70 + 1))
                    {
                      goto _block44__branch1;
                    }
                    uintptr_t _v_len___e__e_tmp_m_rfpcrf_m_339_m_30 = (_v_len69 - _v_len70);
                    Expr _vv__e__e_tmp_m_rfpcrf_m_339_m_30 (_ve_package, 0, _v_len___e__e_tmp_m_rfpcrf_m_339_m_30);
                    Expr _ge_auxcall12;
                    RF_CALL (rfp__helper::Subst, (_vs_dir_m_separator, _c_89, _ve_package), _ge_auxcall12);
                    RF_CALL (StdIO::PrintLN_e_, (_vs_channel, (_c_91 + _ge_auxcall12 + _c_90)), /*void*/);
                    goto _block44;
                  }
                _block44__branch1: {}
                }
              _block44: {}
                RF_CALL (StdIO::PrintLN_e_, (_vs_channel, _c_92), /*void*/);
                {
                  if (_ve_inputs.get_len () < 1)
                  {
                    goto _block45__branch1;
                  }
                  RF_lsplit (_ve_inputs, 0, _ve__e__e_tmp_m_rfpcrf_m_345_m_29, _v_lsplit__inputs);
                  for ( ; ; RF_iter(_ve_inputs)++)
                  {
                    {
                      if (!RF_iter(_ve_inputs))
                      {
                        goto _block45__branch1;
                      }
                      uintptr_t _v_len71 = _v_lsplit__inputs.get_len ();
                      uintptr_t _v_len72 = 1;
                      if (_v_len71 < _v_len72)
                      {
                        goto _block45__branch1;
                      }
                      uintptr_t _v_len___e__e_tmp_m_rfpcrf_m_345_m_47 = (_v_len71 - _v_len72);
                      if (_v_lsplit__inputs.symbol_at (0))
                      {
                        goto _continue10;
                      }
                      Expr _v_deref__lsplit__inputs (_v_lsplit__inputs, 0);
                      uintptr_t _v_len73 = _v_deref__lsplit__inputs.get_len ();
                      uintptr_t _v_len74 = 0;
                      if (_v_len73 < (_v_len74 + 1))
                      {
                        goto _continue10;
                      }
                      uintptr_t _v_len__java_m_module = (_v_len73 - _v_len74);
                      Expr _ve__e__e_tmp_m_rfpcrf_m_345_m_47 (_v_lsplit__inputs, (0 + 1), _v_len___e__e_tmp_m_rfpcrf_m_345_m_47);
                      Expr _vv_java_m_module (_v_deref__lsplit__inputs, 0, _v_len__java_m_module);
                      Expr _ge_java_m_module__18;
                      {
                        {
                          Expr _v_Lookup3;
                          if (!RF_CALL (Table::Lookup, (RFP_m_Includes, _vv_java_m_module), _v_Lookup3))
                          {
                            goto _block46__branch1;
                          }
                          {
                            {
                              uintptr_t _v_len75 = _v_Lookup3.get_len ();
                              uintptr_t _v_len76 = 1;
                              if (_v_len75 < _v_len76)
                              {
                                goto _block47__branch1;
                              }
                              uintptr_t _v_len___e__e_tmp_m_rfpcrf_m_347_m_27 = (_v_len75 - _v_len76);
                              if (!_c_73.term_eq (_v_Lookup3, 0))
                              {
                                goto _block47__branch1;
                              }
                              Expr _ve__e__e_tmp_m_rfpcrf_m_347_m_27 (_v_Lookup3, (0 + 1), _v_len___e__e_tmp_m_rfpcrf_m_347_m_27);
                              _ge_java_m_module__18 = (_c_93 + _vv_java_m_module);
                              goto _block47;
                            }
                          _block47__branch1: {}
                            uintptr_t _v_len77 = _v_Lookup3.get_len ();
                            uintptr_t _v_len78 = 1;
                            if (_v_len77 < _v_len78)
                            {
                              goto _block46__branch1;
                            }
                            uintptr_t _v_len__path3 = (_v_len77 - _v_len78);
                            if (!_c_79.term_eq (_v_Lookup3, 0))
                            {
                              goto _block46__branch1;
                            }
                            Expr _ve_path (_v_Lookup3, (0 + 1), _v_len__path3);
                            Expr _v__q_6;
                            RF_CALL (Box::_q_, RFP_m_Include_m_Path, _v__q_6);
                            if (_v__q_6.get_len () < 1)
                            {
                              goto _block46__branch1;
                            }
                            RF_lsplit (_v__q_6, 0, _ve__e__e_tmp_m_rfpcrf_m_349_m_48, _v_lsplit___q_6);
                            for ( ; ; RF_iter(_v__q_6)++)
                            {
                              {
                                if (!RF_iter(_v__q_6))
                                {
                                  goto _block46__branch1;
                                }
                                uintptr_t _v_len79 = _v_lsplit___q_6.get_len ();
                                uintptr_t _v_len80 = 1;
                                if (_v_len79 < _v_len80)
                                {
                                  goto _block46__branch1;
                                }
                                uintptr_t _v_len___e__e_tmp_m_rfpcrf_m_349_m_58 = (_v_len79 - _v_len80);
                                if (_v_lsplit___q_6.symbol_at (0))
                                {
                                  goto _continue11;
                                }
                                Expr _v_deref__lsplit___q_6 (_v_lsplit___q_6, 0);
                                uintptr_t _v_len81 = _v_deref__lsplit___q_6.get_len ();
                                uintptr_t _v_len82 = 0;
                                if (_v_len81 < _v_len82)
                                {
                                  goto _continue11;
                                }
                                uintptr_t _v_len__dir3 = (_v_len81 - _v_len82);
                                Expr _ve__e__e_tmp_m_rfpcrf_m_349_m_58 (_v_lsplit___q_6, (0 + 1), _v_len___e__e_tmp_m_rfpcrf_m_349_m_58);
                                Expr _ve_dir (_v_deref__lsplit___q_6, 0, _v_len__dir3);
                                Expr _ve_p;
                                {
                                  {
                                    if (_v_len__path3 != _v_len__dir3)
                                    {
                                      goto _block48__branch1;
                                    }
                                    if (!_ve_dir.eq (_ve_path, 0))
                                    {
                                      goto _block48__branch1;
                                    }
                                    _ve_p = empty;
                                    goto _block48;
                                  }
                                _block48__branch1: {}
                                  uintptr_t _v_len83 = _v_len__path3;
                                  uintptr_t _v_len84 = (_v_len__dir3 + 1);
                                  if (_v_len83 < _v_len84)
                                  {
                                    goto _continue11;
                                  }
                                  uintptr_t _v_len__p__23 = (_v_len83 - _v_len84);
                                  if (!_ve_dir.eq (_ve_path, 0))
                                  {
                                    goto _continue11;
                                  }
                                  if (!_vs_dir_m_separator.term_eq (_ve_path, (0 + _v_len__dir3)))
                                  {
                                    goto _continue11;
                                  }
                                  Expr _ge_p__23 (_ve_path, (0 + _v_len__dir3 + 1), _v_len__p__23);
                                  _ve_p = _ge_p__23;
                                }
                              _block48: {}
                                Expr _ge_auxcall13;
                                RF_CALL (rfp__helper::Subst, (_vs_dir_m_separator, _c_89, _ve_p), _ge_auxcall13);
                                Expr _gs_auxcall14;
                                RF_CALL (Convert::To_m_Word, _vv_java_m_module, _gs_auxcall14);
                                Expr _v_Rfp2Java1;
                                RF_CALL (JavaMangle::Rfp2Java, _gs_auxcall14, _v_Rfp2Java1);
                                _ge_java_m_module__18 = (_ge_auxcall13 + _v_Rfp2Java1);
                                goto _exit11;
                              }
                          _continue11: {}
                            }
                          _exit11: {}
                          }
                        _block47: {}
                          goto _block46;
                        }
                      _block46__branch1: {}
                        _ge_java_m_module__18 = _vv_java_m_module;
                      }
                    _block46: {}
                      if (_ge_java_m_module__18.get_len () < 1)
                      {
                        goto _continue10;
                      }
                      RF_lsplit (_ge_java_m_module__18, 0, _ve__e__e_tmp_m_rfpcrf_m_359_m_39, _v_lsplit__java_m_module__18);
                      for ( ; ; RF_iter(_ge_java_m_module__18)++)
                      {
                        {
                          if (!RF_iter(_ge_java_m_module__18))
                          {
                            goto _continue10;
                          }
                          uintptr_t _v_len85 = _v_lsplit__java_m_module__18.get_len ();
                          uintptr_t _v_len86 = 1;
                          if (_v_len85 < _v_len86)
                          {
                            goto _continue10;
                          }
                          uintptr_t _v_len___e__e_tmp_m_rfpcrf_m_359_m_45 = (_v_len85 - _v_len86);
                          if (!_c_13.term_eq (_v_lsplit__java_m_module__18, 0))
                          {
                            goto _continue12;
                          }
                          Expr _ve__e__e_tmp_m_rfpcrf_m_359_m_45 (_v_lsplit__java_m_module__18, (0 + 1), _v_len___e__e_tmp_m_rfpcrf_m_359_m_45);
                          goto _exit12;
                        }
                    _continue12: {}
                      }
                    _exit12: {}
                      RF_CALL (StdIO::PrintLN_e_, (_vs_channel, (_c_94 + _ge_java_m_module__18 + _c_65)), /*void*/);
                    }
                _continue10: {}
                  }
                _exit10: {}
                }
              _block45__branch1: {}
                RF_CALL (CPP_m_Pretty_m_Print, (_c_59, _vs_channel, empty, _ge_module__13), /*void*/);
                {
                  {
                    if (!_vs_need_m_close_q_.term_eq (_c_0, 0))
                    {
                      goto _block50__branch1;
                    }
                    RF_CALL (StdIO::Close_m_Channel, _vs_channel, /*void*/);
                    goto _block50;
                  }
                _block50__branch1: {}
                }
              _block50: {}
              }
            _block28__branch4: {}
              if (!RF_CALL (Table::In_m_Table_q_, (rfp__helper::RFP_m_Options, _c_38), /*void*/))
              {
                goto _continue2;
              }
              RF_CALL (Verbose, _c_95, /*void*/);
              Expr _ge_auxcall15;
              RF_CALL (List::Concat, _vt_asail_m_mod_m_name, _ge_auxcall15);
              RF_CALL (Table::Bind, (RFP_m_Includes, _ge_auxcall15, (_c_79 + _ve_dirname)), /*void*/);
              Expr _ve_dir;
              Expr _ve_package;
              {
                {
                  Expr _v__q_7;
                  RF_CALL (Box::_q_, RFP_m_Include_m_Path, _v__q_7);
                  if (_v__q_7.get_len () < 1)
                  {
                    goto _block51__branch1;
                  }
                  RF_lsplit (_v__q_7, 0, _ve__e__e_tmp_m_rfpcrf_m_370_m_42, _v_lsplit___q_7);
                  for ( ; ; RF_iter(_v__q_7)++)
                  {
                    {
                      if (!RF_iter(_v__q_7))
                      {
                        goto _block51__branch1;
                      }
                      uintptr_t _v_len87 = _v_lsplit___q_7.get_len ();
                      uintptr_t _v_len88 = 1;
                      if (_v_len87 < _v_len88)
                      {
                        goto _block51__branch1;
                      }
                      uintptr_t _v_len___e__e_tmp_m_rfpcrf_m_370_m_52 = (_v_len87 - _v_len88);
                      if (_v_lsplit___q_7.symbol_at (0))
                      {
                        goto _continue13;
                      }
                      Expr _v_deref__lsplit___q_7 (_v_lsplit___q_7, 0);
                      uintptr_t _v_len89 = _v_deref__lsplit___q_7.get_len ();
                      uintptr_t _v_len90 = 0;
                      if (_v_len89 < _v_len90)
                      {
                        goto _continue13;
                      }
                      uintptr_t _v_len__dir__14 = (_v_len89 - _v_len90);
                      Expr _ve__e__e_tmp_m_rfpcrf_m_370_m_52 (_v_lsplit___q_7, (0 + 1), _v_len___e__e_tmp_m_rfpcrf_m_370_m_52);
                      Expr _ge_dir__14 (_v_deref__lsplit___q_7, 0, _v_len__dir__14);
                      {
                        {
                          if (_ve_dirname.get_len () != _v_len__dir__14)
                          {
                            goto _block52__branch1;
                          }
                          if (!_ge_dir__14.eq (_ve_dirname, 0))
                          {
                            goto _block52__branch1;
                          }
                          _ve_dir = (_ge_dir__14 + _vs_dir_m_separator);
                          _ve_package = empty;
                          goto _block52;
                        }
                      _block52__branch1: {}
                        uintptr_t _v_len91 = _ve_dirname.get_len ();
                        uintptr_t _v_len92 = (_v_len__dir__14 + 1);
                        if (_v_len91 < _v_len92)
                        {
                          goto _continue13;
                        }
                        uintptr_t _v_len__package__16 = (_v_len91 - _v_len92);
                        if (!_ge_dir__14.eq (_ve_dirname, 0))
                        {
                          goto _continue13;
                        }
                        if (!_vs_dir_m_separator.term_eq (_ve_dirname, (0 + _v_len__dir__14)))
                        {
                          goto _continue13;
                        }
                        Expr _ge_package__16 (_ve_dirname, (0 + _v_len__dir__14 + 1), _v_len__package__16);
                        _ve_dir = (_ge_dir__14 + _vs_dir_m_separator);
                        _ve_package = _ge_package__16;
                      }
                    _block52: {}
                      goto _exit13;
                    }
                _continue13: {}
                  }
                _exit13: {}
                  goto _block51;
                }
              _block51__branch1: {}
                _ve_dir = empty;
                _ve_package = _ve_dirname;
              }
            _block51: {}
              if (_vt_interf.symbol_at (0))
              {
                goto _continue2;
              }
              Expr _v_deref__interf3 (_vt_interf, 0);
              uintptr_t _v_len93 = _v_deref__interf3.get_len ();
              uintptr_t _v_len94 = 2;
              if (_v_len93 < _v_len94)
              {
                goto _continue2;
              }
              uintptr_t _v_len__headers3 = (_v_len93 - _v_len94);
              if (!_c_45.term_eq (_v_deref__interf3, 0))
              {
                goto _continue2;
              }
              Expr _vt__e__e_tmp_m_rfpcrf_m_377_m_38 (_v_deref__interf3, (0 + 1), 1);
              Expr _ve_headers (_v_deref__interf3, (0 + 1 + 1), _v_len__headers3);
              Expr _ve_exports;
              Expr _ge_headers__15 (_ve_headers);
              Expr _ge_exports__15 (empty);
              for ( ; ; )
              {
                {
                  if (_ge_headers__15.get_len () != 0)
                  {
                    goto _iter3;
                  }
                  _ve_exports = _ge_exports__15;
                  goto _exit__iter3;
                }
              _iter3: {}
                uintptr_t _v_len95 = _ge_headers__15.get_len ();
                uintptr_t _v_len96 = 1;
                if (_v_len95 < _v_len96)
                {
                  RF_FUNC_ERROR (unexpected_fail);
                }
                uintptr_t _v_len__rest2 = (_v_len95 - _v_len96);
                if (_ge_headers__15.symbol_at (0))
                {
                  RF_FUNC_ERROR (unexpected_fail);
                }
                Expr _v_deref__headers__15 (_ge_headers__15, 0);
                if (_v_deref__headers__15.get_len () != 2)
                {
                  RF_FUNC_ERROR (unexpected_fail);
                }
                if (!_v_deref__headers__15.symbol_at (0))
                {
                  RF_FUNC_ERROR (unexpected_fail);
                }
                Expr _ve_rest (_ge_headers__15, (0 + 1), _v_len__rest2);
                Expr _vs_decl (_v_deref__headers__15, 0, 1);
                Expr _vt_name (_v_deref__headers__15, (0 + 1), 1);
                _ge_headers__15 = _ve_rest;
                _ge_exports__15 = (_ge_exports__15 + _vt_name);
              }
            _exit__iter3: {}
              {
                Expr _v_RFP_m_ASAIL_m_To_m_JBC1;
                RF_CALL (rfp__asail__jbc::RFP_m_ASAIL_m_To_m_JBC, (_vt_asail_m_mod_m_name, _ve_package, _ve_exports, _ve_module), _v_RFP_m_ASAIL_m_To_m_JBC1);
                if (_v_RFP_m_ASAIL_m_To_m_JBC1.get_len () < 1)
                {
                  goto _block55__branch1;
                }
                RF_lsplit (_v_RFP_m_ASAIL_m_To_m_JBC1, 0, _ve__e__e_tmp_m_rfpcrf_m_388_m_18, _v_lsplit__RFP_m_ASAIL_m_To_m_JBC1);
                for ( ; ; RF_iter(_v_RFP_m_ASAIL_m_To_m_JBC1)++)
                {
                  {
                    if (!RF_iter(_v_RFP_m_ASAIL_m_To_m_JBC1))
                    {
                      goto _block55__branch1;
                    }
                    uintptr_t _v_len97 = _v_lsplit__RFP_m_ASAIL_m_To_m_JBC1.get_len ();
                    uintptr_t _v_len98 = 1;
                    if (_v_len97 < _v_len98)
                    {
                      goto _block55__branch1;
                    }
                    uintptr_t _v_len___e__e_tmp_m_rfpcrf_m_388_m_52 = (_v_len97 - _v_len98);
                    if (_v_lsplit__RFP_m_ASAIL_m_To_m_JBC1.symbol_at (0))
                    {
                      goto _continue14;
                    }
                    Expr _v_deref__lsplit__RFP_m_ASAIL_m_To_m_JBC1 (_v_lsplit__RFP_m_ASAIL_m_To_m_JBC1, 0);
                    uintptr_t _v_len99 = _v_deref__lsplit__RFP_m_ASAIL_m_To_m_JBC1.get_len ();
                    uintptr_t _v_len100 = 1;
                    if (_v_len99 < _v_len100)
                    {
                      goto _continue14;
                    }
                    uintptr_t _v_len__java_m_module_m_name = (_v_len99 - _v_len100);
                    if (!_v_deref__lsplit__RFP_m_ASAIL_m_To_m_JBC1.symbol_at (0))
                    {
                      goto _continue14;
                    }
                    Expr _ve__e__e_tmp_m_rfpcrf_m_388_m_52 (_v_lsplit__RFP_m_ASAIL_m_To_m_JBC1, (0 + 1), _v_len___e__e_tmp_m_rfpcrf_m_388_m_52);
                    Expr _vs_bytecode (_v_deref__lsplit__RFP_m_ASAIL_m_To_m_JBC1, 0, 1);
                    Expr _ve_java_m_module_m_name (_v_deref__lsplit__RFP_m_ASAIL_m_To_m_JBC1, (0 + 1), _v_len__java_m_module_m_name);
                    Expr _ge_auxcall16;
                    RF_CALL (List::Intersperse, (_vs_dir_m_separator, _ve_java_m_module_m_name), _ge_auxcall16);
                    Expr _gs_auxcall17;
                    RF_CALL (Convert::To_m_Word, (_ve_dir + _ge_auxcall16 + _c_96), _gs_auxcall17);
                    Expr _gs_auxcall18;
                    RF_CALL (FileOutputStream::FileOutputStream, _gs_auxcall17, _gs_auxcall18);
                    RF_CALL (FileOutputStream::WriteToStream, (_gs_auxcall18, _vs_bytecode), /*void*/);
                  }
              _continue14: {}
                }
              _exit14: {}
              }
            _block55__branch1: {}
              RF_CALL (Verbose, _c_97, /*void*/);
              goto _continue2;
            }
          _block13: {}
          }
        _exit__iter1: {}
        }
    _continue2: {}
      }
    _exit2: {}
    }
  _block1__branch2: {}
    uintptr_t _v_len101 = _ve_files.get_len ();
    uintptr_t _v_len102 = 0;
    if (_v_len101 < _v_len102)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    uintptr_t _v_len__all_m_files_m_have_m_gone = (_v_len101 - _v_len102);
    Expr _ve_all_m_files_m_have_m_gone (_ve_files, 0, _v_len__all_m_files_m_have_m_gone);
    _v_res1 = empty;
  }
_block1: {}
RF_END

RF_FUNC (Init_m_Options, RF_VOID, RF_VOID)
  RF_TAILCALL (Box::Store, (Options, _c_98), /*void*/);
RF_END

RF_FUNC (Display_m_Help, RF_VOID, RF_VOID)
  Expr _vs_line;
  RF_CALL (Box::Box, empty, _vs_line);
  Expr _ve_start1 (_c_10);
  Expr _vs_2nd_m_col (_c_99);
  Expr _ve_start2;
  RF_CALL (List::Replicate, (_vs_2nd_m_col, _c_10), _ve_start2);
  Expr _ge_auxcall1;
  RF_CALL (Version, /*void*/, _ge_auxcall1);
  RF_CALL (StdIO::PrintLN, (_c_100 + _ge_auxcall1), /*void*/);
  RF_CALL (StdIO::PrintLN, _c_101, /*void*/);
  RF_CALL (StdIO::PrintLN, empty, /*void*/);
  RF_CALL (StdIO::PrintLN, _c_102, /*void*/);
  RF_CALL (StdIO::PrintLN, _c_103, /*void*/);
  {
    Expr _v__q_1;
    RF_CALL (Box::_q_, Options, _v__q_1);
    if (_v__q_1.get_len () < 1)
    {
      goto _block1__branch1;
    }
    RF_lsplit (_v__q_1, 0, _ve__e__e_tmp_m_rfpcrf_m_463_m_21, _v_lsplit___q_1);
    for ( ; ; RF_iter(_v__q_1)++)
    {
      {
        if (!RF_iter(_v__q_1))
        {
          goto _block1__branch1;
        }
        uintptr_t _v_len1 = _v_lsplit___q_1.get_len ();
        uintptr_t _v_len2 = 1;
        if (_v_len1 < _v_len2)
        {
          goto _block1__branch1;
        }
        uintptr_t _v_len___e__e_tmp_m_rfpcrf_m_463_m_51 = (_v_len1 - _v_len2);
        if (_v_lsplit___q_1.symbol_at (0))
        {
          goto _continue1;
        }
        Expr _v_deref__lsplit___q_1 (_v_lsplit___q_1, 0);
        uintptr_t _v_len3 = _v_deref__lsplit___q_1.get_len ();
        uintptr_t _v_len4 = 2;
        if (_v_len3 < _v_len4)
        {
          goto _continue1;
        }
        uintptr_t _v_len__descr = (_v_len3 - _v_len4);
        if (_v_deref__lsplit___q_1.symbol_at (0))
        {
          goto _continue1;
        }
        Expr _v_deref__deref__lsplit___q_1 (_v_deref__lsplit___q_1, 0);
        uintptr_t _v_len5 = _v_deref__deref__lsplit___q_1.get_len ();
        uintptr_t _v_len6 = 1;
        if (_v_len5 < _v_len6)
        {
          goto _continue1;
        }
        uintptr_t _v_len__opts = (_v_len5 - _v_len6);
        if (_v_deref__deref__lsplit___q_1.symbol_at (0))
        {
          goto _continue1;
        }
        Expr _v_deref__deref__deref__lsplit___q_1 (_v_deref__deref__lsplit___q_1, 0);
        uintptr_t _v_len7 = _v_deref__deref__deref__lsplit___q_1.get_len ();
        uintptr_t _v_len8 = 0;
        if (_v_len7 < _v_len8)
        {
          goto _continue1;
        }
        uintptr_t _v_len__op = (_v_len7 - _v_len8);
        Expr _ve__e__e_tmp_m_rfpcrf_m_463_m_51 (_v_lsplit___q_1, (0 + 1), _v_len___e__e_tmp_m_rfpcrf_m_463_m_51);
        Expr _vt__e__e_tmp_m_rfpcrf_m_463_m_40 (_v_deref__lsplit___q_1, (0 + 1), 1);
        Expr _ve_descr (_v_deref__lsplit___q_1, (0 + 1 + 1), _v_len__descr);
        Expr _ve_opts (_v_deref__deref__lsplit___q_1, (0 + 1), _v_len__opts);
        Expr _ve_op (_v_deref__deref__deref__lsplit___q_1, 0, _v_len__op);
        RF_CALL (Box::Store, (_vs_line, (_ve_start1 + _c_104 + _ve_op)), /*void*/);
        {
          if (_v_len__opts < 1)
          {
            goto _block2__branch1;
          }
          RF_lsplit (_ve_opts, 0, _ve__e__e_tmp_m_rfpcrf_m_466_m_19, _v_lsplit__opts);
          for ( ; ; RF_iter(_ve_opts)++)
          {
            {
              if (!RF_iter(_ve_opts))
              {
                goto _block2__branch1;
              }
              uintptr_t _v_len9 = _v_lsplit__opts.get_len ();
              uintptr_t _v_len10 = 1;
              if (_v_len9 < _v_len10)
              {
                goto _block2__branch1;
              }
              uintptr_t _v_len___e__e_tmp_m_rfpcrf_m_466_m_30 = (_v_len9 - _v_len10);
              if (_v_lsplit__opts.symbol_at (0))
              {
                goto _continue2;
              }
              Expr _v_deref__lsplit__opts (_v_lsplit__opts, 0);
              uintptr_t _v_len11 = _v_deref__lsplit__opts.get_len ();
              uintptr_t _v_len12 = 0;
              if (_v_len11 < _v_len12)
              {
                goto _continue2;
              }
              uintptr_t _v_len__next = (_v_len11 - _v_len12);
              Expr _ve__e__e_tmp_m_rfpcrf_m_466_m_30 (_v_lsplit__opts, (0 + 1), _v_len___e__e_tmp_m_rfpcrf_m_466_m_30);
              Expr _ve_next (_v_deref__lsplit__opts, 0, _v_len__next);
              RF_CALL (Box::Put, (_vs_line, (_c_105 + _ve_next)), /*void*/);
            }
        _continue2: {}
          }
        _exit2: {}
        }
      _block2__branch1: {}
        Expr _ge_auxalt3;
        {
          {
            uintptr_t _v_len13 = _v_len__descr;
            uintptr_t _v_len14 = 1;
            if (_v_len13 < _v_len14)
            {
              goto _block3__branch1;
            }
            uintptr_t _v_len__rest = (_v_len13 - _v_len14);
            if (_ve_descr.symbol_at (0))
            {
              goto _block3__branch1;
            }
            Expr _v_deref__descr (_ve_descr, 0);
            uintptr_t _v_len15 = _v_deref__descr.get_len ();
            uintptr_t _v_len16 = 0;
            if (_v_len15 < _v_len16)
            {
              goto _block3__branch1;
            }
            uintptr_t _v_len__params = (_v_len15 - _v_len16);
            Expr _ve_rest (_ve_descr, (0 + 1), _v_len__rest);
            Expr _ve_params (_v_deref__descr, 0, _v_len__params);
            {
              if (_v_len__params < 1)
              {
                goto _block4__branch1;
              }
              RF_lsplit (_ve_params, 0, _ve__e__e_tmp_m_rfpcrf_m_473_m_25, _v_lsplit__params);
              for ( ; ; RF_iter(_ve_params)++)
              {
                {
                  if (!RF_iter(_ve_params))
                  {
                    goto _block4__branch1;
                  }
                  uintptr_t _v_len17 = _v_lsplit__params.get_len ();
                  uintptr_t _v_len18 = 1;
                  if (_v_len17 < _v_len18)
                  {
                    goto _block4__branch1;
                  }
                  uintptr_t _v_len___e__e_tmp_m_rfpcrf_m_473_m_33 = (_v_len17 - _v_len18);
                  if (!_v_lsplit__params.symbol_at (0))
                  {
                    goto _continue3;
                  }
                  Expr _vs_par (_v_lsplit__params, 0, 1);
                  Expr _ve__e__e_tmp_m_rfpcrf_m_473_m_33 (_v_lsplit__params, (0 + 1), _v_len___e__e_tmp_m_rfpcrf_m_473_m_33);
                  Expr _ge_auxcall2;
                  RF_CALL (Convert::To_m_Chars, _vs_par, _ge_auxcall2);
                  RF_CALL (Box::Put, (_vs_line, (_c_6 + _ge_auxcall2 + _c_106)), /*void*/);
                }
            _continue3: {}
              }
            _exit3: {}
            }
          _block4__branch1: {}
            _ge_auxalt3 = _ve_rest;
            goto _block3;
          }
        _block3__branch1: {}
          _ge_auxalt3 = _ve_descr;
        }
      _block3: {}
        {
          uintptr_t _v_len19 = _ge_auxalt3.get_len ();
          uintptr_t _v_len20 = 1;
          if (_v_len19 < _v_len20)
          {
            goto _block5__branch1;
          }
          uintptr_t _v_len___e__e_tmp_m_rfpcrf_m_480_m_19 = (_v_len19 - _v_len20);
          if (!_ge_auxalt3.symbol_at (0))
          {
            goto _block5__branch1;
          }
          Expr _vs_phrase (_ge_auxalt3, 0, 1);
          Expr _ve__e__e_tmp_m_rfpcrf_m_480_m_19 (_ge_auxalt3, (0 + 1), _v_len___e__e_tmp_m_rfpcrf_m_480_m_19);
          Expr _ge_auxcall4;
          RF_CALL (Box::_q_, _vs_line, _ge_auxcall4);
          Expr _ge_auxcall5;
          RF_CALL (Box::_q_, _vs_line, _ge_auxcall5);
          Expr _gs_auxcall6;
          RF_CALL (Access::Length, _ge_auxcall5, _gs_auxcall6);
          Expr _gs_auxcall7;
          RF_CALL (Arithm::_m_, (_vs_2nd_m_col, _gs_auxcall6), _gs_auxcall7);
          Expr _ge_auxcall8;
          RF_CALL (List::Replicate, (_gs_auxcall7, _c_10), _ge_auxcall8);
          RF_CALL (StdIO::PrintLN, (_ge_auxcall4 + _ge_auxcall8 + _vs_phrase), /*void*/);
        }
      _block5__branch1: {}
        if (_ge_auxalt3.get_len () < 2)
        {
          goto _continue1;
        }
        RF_lsplit (_ge_auxalt3, 0, _ve__e__e_tmp_m_rfpcrf_m_487_m_10, _v_lsplit__auxalt3);
        for ( ; ; RF_iter(_ge_auxalt3)++)
        {
          {
            if (!RF_iter(_ge_auxalt3))
            {
              goto _continue1;
            }
            uintptr_t _v_len21 = _v_lsplit__auxalt3.get_len ();
            uintptr_t _v_len22 = 2;
            if (_v_len21 < _v_len22)
            {
              goto _continue1;
            }
            uintptr_t _v_len___e__e_tmp_m_rfpcrf_m_487_m_23 = (_v_len21 - _v_len22);
            if (!_v_lsplit__auxalt3.symbol_at (0))
            {
              goto _continue4;
            }
            if (!_v_lsplit__auxalt3.symbol_at ((0 + 1)))
            {
              goto _continue4;
            }
            Expr _vs__e__e_tmp_m_rfpcrf_m_487_m_12 (_v_lsplit__auxalt3, 0, 1);
            Expr _vs_phrase (_v_lsplit__auxalt3, (0 + 1), 1);
            Expr _ve__e__e_tmp_m_rfpcrf_m_487_m_23 (_v_lsplit__auxalt3, (0 + 1 + 1), _v_len___e__e_tmp_m_rfpcrf_m_487_m_23);
            RF_CALL (StdIO::PrintLN, (_ve_start2 + _vs_phrase), /*void*/);
          }
      _continue4: {}
        }
      _exit4: {}
      }
  _continue1: {}
    }
  _exit1: {}
  }
_block1__branch1: {}
RF_END

RF_FUNC (RFP_m_Parse_m_Args, (RF_ARG _ve_files, _ve_prevarg, _vs_index;;), (RF_RES _v_res1;;))
  {
    {
      Expr _v_Arg1;
      RF_CALL (Dos::Arg, _vs_index, _v_Arg1);
      uintptr_t _v_len1 = _v_Arg1.get_len ();
      uintptr_t _v_len2 = 0;
      if (_v_len1 < (_v_len2 + 1))
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__arg = (_v_len1 - _v_len2);
      Expr _vv_arg (_v_Arg1, 0, _v_len__arg);
      Expr _gs_index__2;
      RF_CALL (Arithm::_p_, (_vs_index, _c_0), _gs_index__2);
      Expr _v__q_1;
      RF_CALL (Box::_q_, File::Dir_m_Separator, _v__q_1);
      if (_v__q_1.get_len () != 1)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      if (!_v__q_1.symbol_at (0))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      Expr _vs_dir_m_separator (_v__q_1, 0, 1);
      {
        {
          uintptr_t _v_len3 = _ve_prevarg.get_len ();
          uintptr_t _v_len4 = 0;
          if (_v_len3 < (_v_len4 + 1))
          {
            goto _block2__branch1;
          }
          uintptr_t _v_len___e__e_tmp_m_rfpcrf_m_498_m_20 = (_v_len3 - _v_len4);
          Expr _vv__e__e_tmp_m_rfpcrf_m_498_m_20 (_ve_prevarg, 0, _v_len___e__e_tmp_m_rfpcrf_m_498_m_20);
          Expr _ge_prevarg__5;
          {
            {
              if (_ve_prevarg.get_len () != 1)
              {
                goto _block3__branch1;
              }
              if (!_c_107.term_eq (_ve_prevarg, 0))
              {
                goto _block3__branch1;
              }
              Expr _ge_auxcall1;
              RF_CALL (Box::_q_, RFP_m_Include_m_Path, _ge_auxcall1);
              RF_CALL (Box::Store, (RFP_m_Include_m_Path, (_ge_auxcall1 + _vv_arg ())), /*void*/);
              for ( ; ; )
              {
                {
                  {
                    Expr _v__q_2;
                    RF_CALL (Box::_q_, RFP_m_Include_m_Path, _v__q_2);
                    uintptr_t _v_len5 = _v__q_2.get_len ();
                    uintptr_t _v_len6 = 1;
                    if (_v_len5 < _v_len6)
                    {
                      goto _negation1;
                    }
                    uintptr_t _v_len__1 = (_v_len5 - _v_len6);
                    if (_v__q_2.symbol_at ((0 + _v_len__1)))
                    {
                      goto _negation1;
                    }
                    Expr _v_deref___q_2 (_v__q_2, (0 + _v_len__1));
                    uintptr_t _v_len7 = _v_deref___q_2.get_len ();
                    uintptr_t _v_len8 = 1;
                    if (_v_len7 < _v_len8)
                    {
                      goto _negation1;
                    }
                    uintptr_t _v_len__2 = (_v_len7 - _v_len8);
                    if (!_vs_dir_m_separator.term_eq (_v_deref___q_2, (0 + _v_len__2)))
                    {
                      goto _negation1;
                    }
                    Expr _ve_1 (_v__q_2, 0, _v_len__1);
                    Expr _ve_2 (_v_deref___q_2, 0, _v_len__2);
                    RF_CALL (Box::Store, (RFP_m_Include_m_Path, (_ve_1 + _ve_2 ())), /*void*/);
                    goto _iter1;
                  }
                _negation1: {}
                  _ge_prevarg__5 = empty;
                  goto _exit__iter1;
                }
              _iter1: {}
              }
            _exit__iter1: {}
              goto _block3;
            }
          _block3__branch1: {}
            {
              if (_ve_prevarg.get_len () != 1)
              {
                goto _block3__branch2;
              }
              if (!_c_108.term_eq (_ve_prevarg, 0))
              {
                goto _block3__branch2;
              }
              Expr _ge_auxcall2;
              RF_CALL (Box::_q_, RFP_m_Boot_m_Path, _ge_auxcall2);
              RF_CALL (Box::Store, (RFP_m_Boot_m_Path, (_ge_auxcall2 + _vv_arg ())), /*void*/);
              for ( ; ; )
              {
                {
                  {
                    Expr _v__q_3;
                    RF_CALL (Box::_q_, RFP_m_Boot_m_Path, _v__q_3);
                    uintptr_t _v_len9 = _v__q_3.get_len ();
                    uintptr_t _v_len10 = 1;
                    if (_v_len9 < _v_len10)
                    {
                      goto _negation2;
                    }
                    uintptr_t _v_len__12 = (_v_len9 - _v_len10);
                    if (_v__q_3.symbol_at ((0 + _v_len__12)))
                    {
                      goto _negation2;
                    }
                    Expr _v_deref___q_3 (_v__q_3, (0 + _v_len__12));
                    uintptr_t _v_len11 = _v_deref___q_3.get_len ();
                    uintptr_t _v_len12 = 1;
                    if (_v_len11 < _v_len12)
                    {
                      goto _negation2;
                    }
                    uintptr_t _v_len__22 = (_v_len11 - _v_len12);
                    if (!_vs_dir_m_separator.term_eq (_v_deref___q_3, (0 + _v_len__22)))
                    {
                      goto _negation2;
                    }
                    Expr _ve_1 (_v__q_3, 0, _v_len__12);
                    Expr _ve_2 (_v_deref___q_3, 0, _v_len__22);
                    RF_CALL (Box::Store, (RFP_m_Boot_m_Path, (_ve_1 + _ve_2 ())), /*void*/);
                    goto _iter2;
                  }
                _negation2: {}
                  _ge_prevarg__5 = empty;
                  goto _exit__iter2;
                }
              _iter2: {}
              }
            _exit__iter2: {}
              goto _block3;
            }
          _block3__branch2: {}
            {
              if (_ve_prevarg.get_len () != 1)
              {
                goto _block3__branch3;
              }
              if (!_c_109.term_eq (_ve_prevarg, 0))
              {
                goto _block3__branch3;
              }
              Expr _ve_items;
              {
                {
                  if (!RF_CALL (Table::Lookup, (rfp__helper::RFP_m_Options, _c_110), _ve_items))
                  {
                    goto _block8__branch1;
                  }
                  goto _block8;
                }
              _block8__branch1: {}
                _ve_items = empty;
              }
            _block8: {}
              Expr _gt_auxcall3;
              RF_CALL (rfp__parse::Make_m_Name, _vv_arg, _gt_auxcall3);
              RF_CALL (Table::Bind, (rfp__helper::RFP_m_Options, _c_110, (_ve_items + _gt_auxcall3)), /*void*/);
              _ge_prevarg__5 = empty;
              goto _block3;
            }
          _block3__branch3: {}
            {
              if (_ve_prevarg.get_len () != 1)
              {
                goto _block3__branch4;
              }
              if (!_c_111.term_eq (_ve_prevarg, 0))
              {
                goto _block3__branch4;
              }
              Expr _ve_entries;
              {
                {
                  if (!RF_CALL (Table::Lookup, (rfp__helper::RFP_m_Options, _c_112), _ve_entries))
                  {
                    goto _block9__branch1;
                  }
                  goto _block9;
                }
              _block9__branch1: {}
                _ve_entries = empty;
              }
            _block9: {}
              Expr _gt_auxcall4;
              RF_CALL (rfp__parse::Make_m_Name, _vv_arg, _gt_auxcall4);
              RF_CALL (Table::Bind, (rfp__helper::RFP_m_Options, _c_112, (_ve_entries + _gt_auxcall4)), /*void*/);
              _ge_prevarg__5 = empty;
              goto _block3;
            }
          _block3__branch4: {}
            {
              if (_ve_prevarg.get_len () != 1)
              {
                goto _block3__branch5;
              }
              if (!_c_113.term_eq (_ve_prevarg, 0))
              {
                goto _block3__branch5;
              }
              Expr _gt_auxcall5;
              RF_CALL (rfp__parse::Make_m_Name, _vv_arg, _gt_auxcall5);
              RF_CALL (Table::Bind, (RFP_m_Trace, _gt_auxcall5, empty), /*void*/);
              _ge_prevarg__5 = empty;
              goto _block3;
            }
          _block3__branch5: {}
            {
              if (_ve_prevarg.get_len () != 1)
              {
                goto _block3__branch6;
              }
              if (!_c_15.term_eq (_ve_prevarg, 0))
              {
                goto _block3__branch6;
              }
              Expr _gv_arg__7;
              {
                {
                  if (_v_len__arg != 1)
                  {
                    goto _block10__branch1;
                  }
                  if (!_c_104.term_eq (_vv_arg, 0))
                  {
                    goto _block10__branch1;
                  }
                  _gv_arg__7 = StdIO::StdOut;
                  goto _block10;
                }
              _block10__branch1: {}
                _gv_arg__7 = _vv_arg;
              }
            _block10: {}
              RF_CALL (Table::Bind, (rfp__helper::RFP_m_Options, _c_15, _gv_arg__7), /*void*/);
              _ge_prevarg__5 = empty;
              goto _block3;
            }
          _block3__branch6: {}
            {
              if (_ve_prevarg.get_len () != 1)
              {
                goto _block3__branch7;
              }
              if (!_c_114.term_eq (_ve_prevarg, 0))
              {
                goto _block3__branch7;
              }
              RF_CALL (Table::Bind, (rfp__helper::RFP_m_Options, _c_114, _vv_arg), /*void*/);
              _ge_prevarg__5 = empty;
              goto _block3;
            }
          _block3__branch7: {}
            {
              if (_ve_prevarg.get_len () != 1)
              {
                goto _block3__branch8;
              }
              if (!_c_115.term_eq (_ve_prevarg, 0))
              {
                goto _block3__branch8;
              }
              _ge_prevarg__5 = (_c_116 + _vv_arg);
              goto _block3;
            }
          _block3__branch8: {}
            uintptr_t _v_len13 = _ve_prevarg.get_len ();
            uintptr_t _v_len14 = 1;
            if (_v_len13 < _v_len14)
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            uintptr_t _v_len__mod1 = (_v_len13 - _v_len14);
            if (!_c_116.term_eq (_ve_prevarg, 0))
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            Expr _ve_mod1 (_ve_prevarg, (0 + 1), _v_len__mod1);
            RF_CALL (Table::Bind, (rfp__helper::RFP_m_Module_m_Subst, _ve_mod1, _vv_arg), /*void*/);
            _ge_prevarg__5 = empty;
          }
        _block3: {}
          RF_TAILCALL (RFP_m_Parse_m_Args, (_ve_files, _ge_prevarg__5, _gs_index__2), _v_res1);
          goto _block2;
        }
      _block2__branch1: {}
        {
          uintptr_t _v_len15 = _v_len__arg;
          uintptr_t _v_len16 = 1;
          if (_v_len15 < _v_len16)
          {
            goto _block2__branch2;
          }
          uintptr_t _v_len__opt = (_v_len15 - _v_len16);
          if (!_c_104.term_eq (_vv_arg, 0))
          {
            goto _block2__branch2;
          }
          Expr _ve_opt (_vv_arg, (0 + 1), _v_len__opt);
          {
            {
              Expr _gt_auxalt6;
              {
                {
                  Expr _v__q_4;
                  RF_CALL (Box::_q_, Options, _v__q_4);
                  if (_v__q_4.get_len () < 1)
                  {
                    goto _block12__branch1;
                  }
                  RF_lsplit (_v__q_4, 0, _ve__e__e_tmp_m_rfpcrf_m_548_m_29, _v_lsplit___q_4);
                  for ( ; ; RF_iter(_v__q_4)++)
                  {
                    {
                      if (!RF_iter(_v__q_4))
                      {
                        goto _block12__branch1;
                      }
                      uintptr_t _v_len17 = _v_lsplit___q_4.get_len ();
                      uintptr_t _v_len18 = 1;
                      if (_v_len17 < _v_len18)
                      {
                        goto _block12__branch1;
                      }
                      uintptr_t _v_len___e__e_tmp_m_rfpcrf_m_548_m_58 = (_v_len17 - _v_len18);
                      if (_v_lsplit___q_4.symbol_at (0))
                      {
                        goto _continue1;
                      }
                      Expr _v_deref__lsplit___q_4 (_v_lsplit___q_4, 0);
                      uintptr_t _v_len19 = _v_deref__lsplit___q_4.get_len ();
                      uintptr_t _v_len20 = 2;
                      if (_v_len19 < _v_len20)
                      {
                        goto _continue1;
                      }
                      uintptr_t _v_len___e__e_tmp_m_rfpcrf_m_548_m_55 = (_v_len19 - _v_len20);
                      if (_v_deref__lsplit___q_4.symbol_at (0))
                      {
                        goto _continue1;
                      }
                      Expr _v_deref__deref__lsplit___q_4 (_v_deref__lsplit___q_4, 0);
                      if (_v_deref__deref__lsplit___q_4.get_len () < 1)
                      {
                        goto _continue1;
                      }
                      Expr _ve__e__e_tmp_m_rfpcrf_m_548_m_58 (_v_lsplit___q_4, (0 + 1), _v_len___e__e_tmp_m_rfpcrf_m_548_m_58);
                      Expr _vt_action (_v_deref__lsplit___q_4, (0 + 1), 1);
                      Expr _ve__e__e_tmp_m_rfpcrf_m_548_m_55 (_v_deref__lsplit___q_4, (0 + 1 + 1), _v_len___e__e_tmp_m_rfpcrf_m_548_m_55);
                      RF_lsplit (_v_deref__deref__lsplit___q_4, 0, _ve__e__e_tmp_m_rfpcrf_m_548_m_33, _v_lsplit__deref__deref__lsplit___q_4);
                      for ( ; ; RF_iter(_v_deref__deref__lsplit___q_4)++)
                      {
                        {
                          if (!RF_iter(_v_deref__deref__lsplit___q_4))
                          {
                            goto _continue1;
                          }
                          uintptr_t _v_len21 = _v_lsplit__deref__deref__lsplit___q_4.get_len ();
                          uintptr_t _v_len22 = 1;
                          if (_v_len21 < _v_len22)
                          {
                            goto _continue1;
                          }
                          uintptr_t _v_len___e__e_tmp_m_rfpcrf_m_548_m_43 = (_v_len21 - _v_len22);
                          if (_v_lsplit__deref__deref__lsplit___q_4.symbol_at (0))
                          {
                            goto _continue2;
                          }
                          Expr _v_deref__lsplit__deref__deref__lsplit___q_4 (_v_lsplit__deref__deref__lsplit___q_4, 0);
                          if (_v_deref__lsplit__deref__deref__lsplit___q_4.get_len () != _v_len__opt)
                          {
                            goto _continue2;
                          }
                          if (!_ve_opt.eq (_v_deref__lsplit__deref__deref__lsplit___q_4, 0))
                          {
                            goto _continue2;
                          }
                          Expr _ve__e__e_tmp_m_rfpcrf_m_548_m_43 (_v_lsplit__deref__deref__lsplit___q_4, (0 + 1), _v_len___e__e_tmp_m_rfpcrf_m_548_m_43);
                          _gt_auxalt6 = _vt_action;
                          goto _exit2;
                        }
                    _continue2: {}
                      }
                    _exit2: {}
                      goto _exit1;
                    }
                _continue1: {}
                  }
                _exit1: {}
                  goto _block12;
                }
              _block12__branch1: {}
                uintptr_t _v_len23 = _v_len__opt;
                uintptr_t _v_len24 = 1;
                if (_v_len23 < _v_len24)
                {
                  goto _block11__branch1;
                }
                uintptr_t _v_len__o = (_v_len23 - _v_len24);
                if (!_c_104.term_eq (_ve_opt, 0))
                {
                  goto _block11__branch1;
                }
                Expr _ve_o (_ve_opt, (0 + 1), _v_len__o);
                Expr _v__q_5;
                RF_CALL (Box::_q_, Options, _v__q_5);
                if (_v__q_5.get_len () < 1)
                {
                  goto _block11__branch1;
                }
                RF_lsplit (_v__q_5, 0, _ve__e__e_tmp_m_rfpcrf_m_550_m_31, _v_lsplit___q_5);
                for ( ; ; RF_iter(_v__q_5)++)
                {
                  {
                    if (!RF_iter(_v__q_5))
                    {
                      goto _block11__branch1;
                    }
                    uintptr_t _v_len25 = _v_lsplit___q_5.get_len ();
                    uintptr_t _v_len26 = 1;
                    if (_v_len25 < _v_len26)
                    {
                      goto _block11__branch1;
                    }
                    uintptr_t _v_len___e__e_tmp_m_rfpcrf_m_550_m_58 = (_v_len25 - _v_len26);
                    if (_v_lsplit___q_5.symbol_at (0))
                    {
                      goto _continue3;
                    }
                    Expr _v_deref__lsplit___q_5 (_v_lsplit___q_5, 0);
                    uintptr_t _v_len27 = _v_deref__lsplit___q_5.get_len ();
                    uintptr_t _v_len28 = 2;
                    if (_v_len27 < _v_len28)
                    {
                      goto _continue3;
                    }
                    uintptr_t _v_len___e__e_tmp_m_rfpcrf_m_550_m_55 = (_v_len27 - _v_len28);
                    if (_v_deref__lsplit___q_5.symbol_at (0))
                    {
                      goto _continue3;
                    }
                    Expr _v_deref__deref__lsplit___q_5 (_v_deref__lsplit___q_5, 0);
                    if (_v_deref__deref__lsplit___q_5.get_len () < 1)
                    {
                      goto _continue3;
                    }
                    Expr _ve__e__e_tmp_m_rfpcrf_m_550_m_58 (_v_lsplit___q_5, (0 + 1), _v_len___e__e_tmp_m_rfpcrf_m_550_m_58);
                    Expr _vt_action (_v_deref__lsplit___q_5, (0 + 1), 1);
                    Expr _ve__e__e_tmp_m_rfpcrf_m_550_m_55 (_v_deref__lsplit___q_5, (0 + 1 + 1), _v_len___e__e_tmp_m_rfpcrf_m_550_m_55);
                    RF_lsplit (_v_deref__deref__lsplit___q_5, 0, _ve__e__e_tmp_m_rfpcrf_m_550_m_35, _v_lsplit__deref__deref__lsplit___q_5);
                    for ( ; ; RF_iter(_v_deref__deref__lsplit___q_5)++)
                    {
                      {
                        if (!RF_iter(_v_deref__deref__lsplit___q_5))
                        {
                          goto _continue3;
                        }
                        uintptr_t _v_len29 = _v_lsplit__deref__deref__lsplit___q_5.get_len ();
                        uintptr_t _v_len30 = 1;
                        if (_v_len29 < _v_len30)
                        {
                          goto _continue3;
                        }
                        uintptr_t _v_len___e__e_tmp_m_rfpcrf_m_550_m_43 = (_v_len29 - _v_len30);
                        if (_v_lsplit__deref__deref__lsplit___q_5.symbol_at (0))
                        {
                          goto _continue4;
                        }
                        Expr _v_deref__lsplit__deref__deref__lsplit___q_5 (_v_lsplit__deref__deref__lsplit___q_5, 0);
                        if (_v_deref__lsplit__deref__deref__lsplit___q_5.get_len () != _v_len__o)
                        {
                          goto _continue4;
                        }
                        if (!_ve_o.eq (_v_deref__lsplit__deref__deref__lsplit___q_5, 0))
                        {
                          goto _continue4;
                        }
                        Expr _ve__e__e_tmp_m_rfpcrf_m_550_m_43 (_v_lsplit__deref__deref__lsplit___q_5, (0 + 1), _v_len___e__e_tmp_m_rfpcrf_m_550_m_43);
                        _gt_auxalt6 = _vt_action;
                        goto _exit4;
                      }
                  _continue4: {}
                    }
                  _exit4: {}
                    goto _exit3;
                  }
              _continue3: {}
                }
              _exit3: {}
              }
            _block12: {}
              Expr _ge_prevarg__8;
              {
                {
                  if (_gt_auxalt6.symbol_at (0))
                  {
                    goto _block13__branch1;
                  }
                  Expr _v_deref__auxalt6 (_gt_auxalt6, 0);
                  if (_v_deref__auxalt6.get_len () != 2)
                  {
                    goto _block13__branch1;
                  }
                  if (!_c_117.term_eq (_v_deref__auxalt6, 0))
                  {
                    goto _block13__branch1;
                  }
                  if (!_v_deref__auxalt6.symbol_at ((0 + 1)))
                  {
                    goto _block13__branch1;
                  }
                  Expr _vs_option (_v_deref__auxalt6, (0 + 1), 1);
                  RF_CALL (Table::Bind, (rfp__helper::RFP_m_Options, _vs_option, empty), /*void*/);
                  _ge_prevarg__8 = empty;
                  goto _block13;
                }
              _block13__branch1: {}
                {
                  if (!_gt_auxalt6.term_eq (_c_1, 0))
                  {
                    goto _block13__branch2;
                  }
                  RF_CALL (Table::Bind, (rfp__helper::RFP_m_Options, _c_1, empty), /*void*/);
                  RF_CALL (Display_m_Help, /*void*/, /*void*/);
                  _ge_prevarg__8 = empty;
                  goto _block13;
                }
              _block13__branch2: {}
                if (!_gt_auxalt6.symbol_at (0))
                {
                  RF_FUNC_ERROR (unexpected_fail);
                }
                Expr _vs_other (_gt_auxalt6, 0, 1);
                _ge_prevarg__8 = _vs_other;
              }
            _block13: {}
              RF_TAILCALL (RFP_m_Parse_m_Args, (_ve_files, _ge_prevarg__8, _gs_index__2), _v_res1);
              goto _block11;
            }
          _block11__branch1: {}
            RF_CALL (StdIO::PrintLN_e_, (StdIO::StdErr, (_c_119 + _ve_opt + _c_118)), /*void*/);
            RF_TAILCALL (RFP_m_Parse_m_Args, (_ve_files, empty, _gs_index__2), _v_res1);
          }
        _block11: {}
          goto _block2;
        }
      _block2__branch2: {}
        RF_TAILCALL (RFP_m_Parse_m_Args, ((_ve_files + _vv_arg ()), empty, _gs_index__2), _v_res1);
      }
    _block2: {}
      goto _block1;
    }
  _block1__branch1: {}
    {
      uintptr_t _v_len31 = _ve_prevarg.get_len ();
      uintptr_t _v_len32 = 0;
      if (_v_len31 < (_v_len32 + 1))
      {
        goto _block1__branch2;
      }
      uintptr_t _v_len___e__e_tmp_m_rfpcrf_m_562_m_16 = (_v_len31 - _v_len32);
      Expr _vv__e__e_tmp_m_rfpcrf_m_562_m_16 (_ve_prevarg, 0, _v_len___e__e_tmp_m_rfpcrf_m_562_m_16);
      RF_CALL (StdIO::PrintLN_e_, (StdIO::StdErr, _c_120), /*void*/);
      RF_CALL (Dos::Exit, _c_0, /*void*/);
      _v_res1 = empty;
      goto _block1;
    }
  _block1__branch2: {}
    {
      {
        {
          {
            if (!RF_CALL (Table::In_m_Table_q_, (rfp__helper::RFP_m_Options, _c_35), /*void*/))
            {
              goto _block15__branch1;
            }
            goto _block15;
          }
        _block15__branch1: {}
          {
            if (!RF_CALL (Table::In_m_Table_q_, (rfp__helper::RFP_m_Options, _c_36), /*void*/))
            {
              goto _block15__branch2;
            }
            goto _block15;
          }
        _block15__branch2: {}
          {
            if (!RF_CALL (Table::In_m_Table_q_, (rfp__helper::RFP_m_Options, _c_39), /*void*/))
            {
              goto _block15__branch3;
            }
            goto _block15;
          }
        _block15__branch3: {}
          {
            if (!RF_CALL (Table::In_m_Table_q_, (rfp__helper::RFP_m_Options, _c_37), /*void*/))
            {
              goto _block15__branch4;
            }
            goto _block15;
          }
        _block15__branch4: {}
          {
            if (!RF_CALL (Table::In_m_Table_q_, (rfp__helper::RFP_m_Options, _c_38), /*void*/))
            {
              goto _block15__branch5;
            }
            goto _block15;
          }
        _block15__branch5: {}
          {
            if (!RF_CALL (Table::In_m_Table_q_, (rfp__helper::RFP_m_Options, _c_21), /*void*/))
            {
              goto _block15__branch6;
            }
            goto _block15;
          }
        _block15__branch6: {}
          {
            if (!RF_CALL (Table::In_m_Table_q_, (rfp__helper::RFP_m_Options, _c_25), /*void*/))
            {
              goto _block15__branch7;
            }
            goto _block15;
          }
        _block15__branch7: {}
          {
            if (!RF_CALL (Table::In_m_Table_q_, (rfp__helper::RFP_m_Options, _c_28), /*void*/))
            {
              goto _block15__branch8;
            }
            goto _block15;
          }
        _block15__branch8: {}
          if (!RF_CALL (Table::In_m_Table_q_, (rfp__helper::RFP_m_Options, _c_121), /*void*/))
          {
            goto _block14__branch1;
          }
        }
      _block15: {}
        goto _block14;
      }
    _block14__branch1: {}
      RF_CALL (Table::Bind, (rfp__helper::RFP_m_Options, _c_35, empty), /*void*/);
      RF_CALL (Table::Bind, (rfp__helper::RFP_m_Options, _c_36, empty), /*void*/);
    }
  _block14: {}
    _v_res1 = _ve_files;
  }
_block1: {}
RF_END

RF_FUNC (RFP_m_Set_m_Path, RF_VOID, RF_VOID)
  Expr _ge_auxcall1;
  RF_CALL (Box::_q_, RFP_m_Boot_m_Path, _ge_auxcall1);
  RF_CALL (Box::Store, (RFP_m_Boot_m_Path, (_ge_auxcall1 + RFP_m_Default_m_Include_m_Path)), /*void*/);
  Expr _ge_auxcall2;
  RF_CALL (Box::_q_, RFP_m_Include_m_Path, _ge_auxcall2);
  Expr _ge_auxcall3;
  RF_CALL (Box::_q_, RFP_m_Boot_m_Path, _ge_auxcall3);
  RF_TAILCALL (Box::Store, (RFP_m_Include_m_Path, (_ge_auxcall2 + _ge_auxcall3)), /*void*/);
RF_END

RF_FUNC (Get_m_Ready_m_To_m_Work, (RF_ARG _ve_Items;;), RF_VOID)
  RF_CALL (rfp__helper::RFP_m_Clear_m_Table, RFP_m_Includes, /*void*/);
  RF_CALL (rfp__helper::RFP_m_Clear_m_Table, rfp__compile::Fun, /*void*/);
  RF_CALL (rfp__helper::RFP_m_Clear_m_Table, rfp__compile::Fun_q_, /*void*/);
  RF_CALL (rfp__helper::RFP_m_Clear_m_Table, rfp__compile::Const, /*void*/);
  RF_CALL (rfp__helper::RFP_m_Clear_m_Table, rfp__compile::Object, /*void*/);
  {
    if (_ve_Items.get_len () < 1)
    {
      goto _block1__branch1;
    }
    RF_lsplit (_ve_Items, 0, _ve__e__e_tmp_m_rfpcrf_m_593_m_16, _v_lsplit__Items);
    for ( ; ; RF_iter(_ve_Items)++)
    {
      {
        if (!RF_iter(_ve_Items))
        {
          goto _block1__branch1;
        }
        uintptr_t _v_len1 = _v_lsplit__Items.get_len ();
        uintptr_t _v_len2 = 1;
        if (_v_len1 < _v_len2)
        {
          goto _block1__branch1;
        }
        uintptr_t _v_len___e__e_tmp_m_rfpcrf_m_593_m_25 = (_v_len1 - _v_len2);
        Expr _vt_Item (_v_lsplit__Items, 0, 1);
        Expr _ve__e__e_tmp_m_rfpcrf_m_593_m_25 (_v_lsplit__Items, (0 + 1), _v_len___e__e_tmp_m_rfpcrf_m_593_m_25);
        {
          {
            if (_vt_Item.symbol_at (0))
            {
              goto _block2__branch1;
            }
            Expr _v_deref__Item (_vt_Item, 0);
            uintptr_t _v_len3 = _v_deref__Item.get_len ();
            uintptr_t _v_len4 = 4;
            if (_v_len3 < _v_len4)
            {
              goto _block2__branch1;
            }
            uintptr_t _v_len__ItemBody = (_v_len3 - _v_len4);
            if (!_v_deref__Item.symbol_at (0))
            {
              goto _block2__branch1;
            }
            if (!_v_deref__Item.symbol_at ((0 + 1)))
            {
              goto _block2__branch1;
            }
            Expr _vs_Linkage (_v_deref__Item, 0, 1);
            Expr _vs_ItemType (_v_deref__Item, (0 + 1), 1);
            Expr _vt_Pragma (_v_deref__Item, (0 + 1 + 1), 1);
            Expr _vt_ItemName (_v_deref__Item, (0 + 1 + 1 + 1), 1);
            Expr _ve_ItemBody (_v_deref__Item, (0 + 1 + 1 + 1 + 1), _v_len__ItemBody);
            Expr _vs_tab;
            Expr _ve_ItemDef;
            {
              {
                if (!_vs_ItemType.term_eq (_c_122, 0))
                {
                  goto _block3__branch1;
                }
                Expr _v_Left1;
                if (!RF_CALL (Access::Left, (_c_59, _c_123, _ve_ItemBody), _v_Left1))
                {
                  goto _block2__branch1;
                }
                if (_v_Left1.get_len () != 2)
                {
                  goto _block2__branch1;
                }
                if (_v_Left1.symbol_at (0))
                {
                  goto _block2__branch1;
                }
                if (_v_Left1.symbol_at ((0 + 1)))
                {
                  goto _block2__branch1;
                }
                Expr _v_deref__Left1 (_v_Left1, 0);
                Expr _v_deref__Left12 (_v_Left1, (0 + 1));
                uintptr_t _v_len5 = _v_deref__Left12.get_len ();
                uintptr_t _v_len6 = 0;
                if (_v_len5 < _v_len6)
                {
                  goto _block2__branch1;
                }
                uintptr_t _v_len__out = (_v_len5 - _v_len6);
                uintptr_t _v_len7 = _v_deref__Left1.get_len ();
                uintptr_t _v_len8 = 0;
                if (_v_len7 < _v_len8)
                {
                  goto _block2__branch1;
                }
                uintptr_t _v_len__in = (_v_len7 - _v_len8);
                Expr _ve_in (_v_deref__Left1, 0, _v_len__in);
                Expr _ve_out (_v_deref__Left12, 0, _v_len__out);
                Expr _ge_auxcall1;
                RF_CALL (rfp__format::Format_m_Exp, _ve_in, _ge_auxcall1);
                Expr _ge_auxcall2;
                RF_CALL (rfp__format::Format_m_Exp, _ve_out, _ge_auxcall2);
                _vs_tab = rfp__compile::Fun;
                _ve_ItemDef = (_ge_auxcall1 () + _ge_auxcall2 ());
                goto _block3;
              }
            _block3__branch1: {}
              {
                if (!_vs_ItemType.term_eq (_c_124, 0))
                {
                  goto _block3__branch2;
                }
                Expr _v_Left2;
                if (!RF_CALL (Access::Left, (_c_59, _c_123, _ve_ItemBody), _v_Left2))
                {
                  goto _block2__branch1;
                }
                if (_v_Left2.get_len () != 2)
                {
                  goto _block2__branch1;
                }
                if (_v_Left2.symbol_at (0))
                {
                  goto _block2__branch1;
                }
                if (_v_Left2.symbol_at ((0 + 1)))
                {
                  goto _block2__branch1;
                }
                Expr _v_deref__Left2 (_v_Left2, 0);
                Expr _v_deref__Left22 (_v_Left2, (0 + 1));
                uintptr_t _v_len9 = _v_deref__Left22.get_len ();
                uintptr_t _v_len10 = 0;
                if (_v_len9 < _v_len10)
                {
                  goto _block2__branch1;
                }
                uintptr_t _v_len__out2 = (_v_len9 - _v_len10);
                uintptr_t _v_len11 = _v_deref__Left2.get_len ();
                uintptr_t _v_len12 = 0;
                if (_v_len11 < _v_len12)
                {
                  goto _block2__branch1;
                }
                uintptr_t _v_len__in2 = (_v_len11 - _v_len12);
                Expr _ve_in (_v_deref__Left2, 0, _v_len__in2);
                Expr _ve_out (_v_deref__Left22, 0, _v_len__out2);
                Expr _ge_auxcall3;
                RF_CALL (rfp__format::Format_m_Exp, _ve_in, _ge_auxcall3);
                Expr _ge_auxcall4;
                RF_CALL (rfp__format::Format_m_Exp, _ve_out, _ge_auxcall4);
                _vs_tab = rfp__compile::Fun;
                _ve_ItemDef = (_ge_auxcall3 () + _ge_auxcall4 ());
                goto _block3;
              }
            _block3__branch2: {}
              {
                if (!_vs_ItemType.term_eq (_c_125, 0))
                {
                  goto _block3__branch3;
                }
                Expr _v_Left3;
                if (!RF_CALL (Access::Left, (_c_59, _c_123, _ve_ItemBody), _v_Left3))
                {
                  goto _block2__branch1;
                }
                if (_v_Left3.get_len () != 2)
                {
                  goto _block2__branch1;
                }
                if (_v_Left3.symbol_at (0))
                {
                  goto _block2__branch1;
                }
                if (_v_Left3.symbol_at ((0 + 1)))
                {
                  goto _block2__branch1;
                }
                Expr _v_deref__Left3 (_v_Left3, 0);
                Expr _v_deref__Left32 (_v_Left3, (0 + 1));
                uintptr_t _v_len13 = _v_deref__Left32.get_len ();
                uintptr_t _v_len14 = 0;
                if (_v_len13 < _v_len14)
                {
                  goto _block2__branch1;
                }
                uintptr_t _v_len__out3 = (_v_len13 - _v_len14);
                uintptr_t _v_len15 = _v_deref__Left3.get_len ();
                uintptr_t _v_len16 = 0;
                if (_v_len15 < _v_len16)
                {
                  goto _block2__branch1;
                }
                uintptr_t _v_len__in3 = (_v_len15 - _v_len16);
                Expr _ve_in (_v_deref__Left3, 0, _v_len__in3);
                Expr _ve_out (_v_deref__Left32, 0, _v_len__out3);
                Expr _ge_auxcall5;
                RF_CALL (rfp__format::Format_m_Exp, _ve_in, _ge_auxcall5);
                Expr _ge_auxcall6;
                RF_CALL (rfp__format::Format_m_Exp, _ve_out, _ge_auxcall6);
                _vs_tab = rfp__compile::Fun_q_;
                _ve_ItemDef = (_ge_auxcall5 () + _ge_auxcall6 ());
                goto _block3;
              }
            _block3__branch3: {}
              {
                if (!_vs_ItemType.term_eq (_c_126, 0))
                {
                  goto _block3__branch4;
                }
                _vs_tab = rfp__compile::Const;
                _ve_ItemDef = _ve_ItemBody;
                goto _block3;
              }
            _block3__branch4: {}
              if (!_vs_ItemType.symbol_at (0))
              {
                RF_FUNC_ERROR (unexpected_fail);
              }
              Expr _vs__e__e_tmp_m_rfpcrf_m_606_m_12 (_vs_ItemType, 0, 1);
              _vs_tab = rfp__compile::Object;
              _ve_ItemDef = _ve_ItemBody;
            }
          _block3: {}
            RF_CALL (Table::Bind, (_vs_tab, _vt_ItemName, (_vs_Linkage + _vs_ItemType + _vt_Pragma + _ve_ItemDef)), /*void*/);
            goto _block2;
          }
        _block2__branch1: {}
          if (_vt_Item.symbol_at (0))
          {
            goto _continue1;
          }
          Expr _v_deref__Item2 (_vt_Item, 0);
          if (_v_deref__Item2.get_len () != 3)
          {
            goto _continue1;
          }
          if (!_c_127.term_eq (_v_deref__Item2, 0))
          {
            goto _continue1;
          }
          Expr _vt_Pragma (_v_deref__Item2, (0 + 1), 1);
          Expr _vt_FName (_v_deref__Item2, (0 + 1 + 1), 1);
          RF_CALL (Table::Bind, (rfp__compile::Fun_q_, _vt_FName, (_c_129 + _vt_Pragma + _c_128)), /*void*/);
        }
      _block2: {}
      }
  _continue1: {}
    }
  _exit1: {}
  }
_block1__branch1: {}
  {
    {
      if (!RF_CALL (Table::In_m_Table_q_, (rfp__helper::RFP_m_Options, _c_130), /*void*/))
      {
        goto _block4__branch1;
      }
      RF_CALL (Table::Bind, (rfp__compile::Fun_q_, _c_131, _c_132), /*void*/);
      RF_TAILCALL (Table::Bind, (rfp__compile::Fun, _c_133, _c_134), /*void*/);
      goto _block4;
    }
  _block4__branch1: {}
  }
_block4: {}
RF_END

RF_FUNC (RFP_m_Pretty_m_Print, (RF_ARG _vs_channel, _ve_indent, _ve_expr;;), RF_VOID)
  {
    {
      if (_ve_expr.get_len () < 1)
      {
        goto _block1__branch1;
      }
      RF_lsplit (_ve_expr, 0, _ve_0, _v_lsplit__expr);
      for ( ; ; RF_iter(_ve_expr)++)
      {
        {
          if (!RF_iter(_ve_expr))
          {
            goto _block1__branch1;
          }
          uintptr_t _v_len1 = _v_lsplit__expr.get_len ();
          uintptr_t _v_len2 = 1;
          if (_v_len1 < _v_len2)
          {
            goto _block1__branch1;
          }
          uintptr_t _v_len__2 = (_v_len1 - _v_len2);
          if (_v_lsplit__expr.symbol_at (0))
          {
            goto _continue1;
          }
          Expr _v_deref__lsplit__expr (_v_lsplit__expr, 0);
          uintptr_t _v_len3 = _v_deref__lsplit__expr.get_len ();
          uintptr_t _v_len4 = 0;
          if (_v_len3 < _v_len4)
          {
            goto _continue1;
          }
          uintptr_t _v_len__1 = (_v_len3 - _v_len4);
          Expr _ve_2 (_v_lsplit__expr, (0 + 1), _v_len__2);
          Expr _ve_1 (_v_deref__lsplit__expr, 0, _v_len__1);
          RF_CALL (StdIO::Write_e_, (_vs_channel, _ve_0), /*void*/);
          {
            {
              uintptr_t _v_len5 = _ve_indent.get_len ();
              uintptr_t _v_len6 = 0;
              if (_v_len5 < (_v_len6 + 1))
              {
                goto _block2__branch1;
              }
              uintptr_t _v_len___e__e_tmp_m_rfpcrf_m_624_m_21 = (_v_len5 - _v_len6);
              Expr _vv__e__e_tmp_m_rfpcrf_m_624_m_21 (_ve_indent, 0, _v_len___e__e_tmp_m_rfpcrf_m_624_m_21);
              RF_CALL (StdIO::PrintLN_e_, (_vs_channel, empty), /*void*/);
              goto _block2;
            }
          _block2__branch1: {}
          }
        _block2: {}
          RF_CALL (StdIO::Print_e_, (_vs_channel, (_ve_indent + _c_135)), /*void*/);
          RF_CALL (RFP_m_Pretty_m_Print, (_vs_channel, (_ve_indent + _c_136), _ve_1), /*void*/);
          {
            {
              if (_v_len__1 < 1)
              {
                goto _block3__branch1;
              }
              RF_lsplit (_ve_1, 0, _ve__e__e_tmp_m_rfpcrf_m_628_m_15, _v_lsplit__1);
              for ( ; ; RF_iter(_ve_1)++)
              {
                {
                  if (!RF_iter(_ve_1))
                  {
                    goto _block3__branch1;
                  }
                  uintptr_t _v_len7 = _v_lsplit__1.get_len ();
                  uintptr_t _v_len8 = 1;
                  if (_v_len7 < _v_len8)
                  {
                    goto _block3__branch1;
                  }
                  uintptr_t _v_len___e__e_tmp_m_rfpcrf_m_628_m_21 = (_v_len7 - _v_len8);
                  if (_v_lsplit__1.symbol_at (0))
                  {
                    goto _continue2;
                  }
                  Expr _v_deref__lsplit__1 (_v_lsplit__1, 0);
                  uintptr_t _v_len9 = _v_deref__lsplit__1.get_len ();
                  uintptr_t _v_len10 = 0;
                  if (_v_len9 < _v_len10)
                  {
                    goto _continue2;
                  }
                  uintptr_t _v_len___e__e_tmp_m_rfpcrf_m_628_m_18 = (_v_len9 - _v_len10);
                  Expr _ve__e__e_tmp_m_rfpcrf_m_628_m_21 (_v_lsplit__1, (0 + 1), _v_len___e__e_tmp_m_rfpcrf_m_628_m_21);
                  Expr _ve__e__e_tmp_m_rfpcrf_m_628_m_18 (_v_deref__lsplit__1, 0, _v_len___e__e_tmp_m_rfpcrf_m_628_m_18);
                  RF_CALL (StdIO::PrintLN_e_, (_vs_channel, empty), /*void*/);
                  RF_CALL (StdIO::Print_e_, (_vs_channel, (_ve_indent + _c_137)), /*void*/);
                  goto _exit2;
                }
            _continue2: {}
              }
            _exit2: {}
              goto _block3;
            }
          _block3__branch1: {}
            RF_CALL (StdIO::Print_e_, (_vs_channel, _c_137), /*void*/);
          }
        _block3: {}
          {
            {
              uintptr_t _v_len11 = _v_len__2;
              uintptr_t _v_len12 = 1;
              if (_v_len11 < _v_len12)
              {
                goto _block4__branch1;
              }
              uintptr_t _v_len___e__e_tmp_m_rfpcrf_m_634_m_19 = (_v_len11 - _v_len12);
              if (_ve_2.symbol_at (0))
              {
                goto _block4__branch1;
              }
              Expr _v_deref__2 (_ve_2, 0);
              uintptr_t _v_len13 = _v_deref__2.get_len ();
              uintptr_t _v_len14 = 0;
              if (_v_len13 < _v_len14)
              {
                goto _block4__branch1;
              }
              uintptr_t _v_len___e__e_tmp_m_rfpcrf_m_634_m_16 = (_v_len13 - _v_len14);
              Expr _ve__e__e_tmp_m_rfpcrf_m_634_m_19 (_ve_2, (0 + 1), _v_len___e__e_tmp_m_rfpcrf_m_634_m_19);
              Expr _ve__e__e_tmp_m_rfpcrf_m_634_m_16 (_v_deref__2, 0, _v_len___e__e_tmp_m_rfpcrf_m_634_m_16);
              goto _block4;
            }
          _block4__branch1: {}
            {
              if (_v_len__2 != 0)
              {
                goto _block4__branch2;
              }
              uintptr_t _v_len15 = _ve_indent.get_len ();
              uintptr_t _v_len16 = 0;
              if (_v_len15 < (_v_len16 + 1))
              {
                goto _block4__branch2;
              }
              uintptr_t _v_len___e__e_tmp_m_rfpcrf_m_635_m_28 = (_v_len15 - _v_len16);
              Expr _vv__e__e_tmp_m_rfpcrf_m_635_m_28 (_ve_indent, 0, _v_len___e__e_tmp_m_rfpcrf_m_635_m_28);
              goto _block4;
            }
          _block4__branch2: {}
            RF_CALL (StdIO::PrintLN_e_, (_vs_channel, empty), /*void*/);
            RF_CALL (StdIO::Print_e_, (_vs_channel, _ve_indent), /*void*/);
          }
        _block4: {}
          RF_TAILCALL (RFP_m_Pretty_m_Print, (_vs_channel, _ve_indent, _ve_2), /*void*/);
          goto _exit1;
        }
    _continue1: {}
      }
    _exit1: {}
      goto _block1;
    }
  _block1__branch1: {}
    {
      uintptr_t _v_len17 = _ve_expr.get_len ();
      uintptr_t _v_len18 = 0;
      if (_v_len17 < (_v_len18 + 1))
      {
        goto _block1__branch2;
      }
      uintptr_t _v_len__12 = (_v_len17 - _v_len18);
      Expr _vv_1 (_ve_expr, 0, _v_len__12);
      RF_TAILCALL (StdIO::Write_e_, (_vs_channel, _vv_1), /*void*/);
      goto _block1;
    }
  _block1__branch2: {}
    if (_ve_expr.get_len () != 0)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
  }
_block1: {}
RF_END

RF_FUNC (CPP_m_Pretty_m_Print, (RF_ARG _vs_inner_m_call_q_, _vs_channel, _ve_indent, _ve_expr;;), RF_VOID)
  {
    {
      if (_ve_expr.get_len () < 1)
      {
        goto _block1__branch1;
      }
      RF_lsplit (_ve_expr, 0, _ve_0, _v_lsplit__expr);
      for ( ; ; RF_iter(_ve_expr)++)
      {
        {
          if (!RF_iter(_ve_expr))
          {
            goto _block1__branch1;
          }
          uintptr_t _v_len1 = _v_lsplit__expr.get_len ();
          uintptr_t _v_len2 = 1;
          if (_v_len1 < _v_len2)
          {
            goto _block1__branch1;
          }
          uintptr_t _v_len__2 = (_v_len1 - _v_len2);
          if (_v_lsplit__expr.symbol_at (0))
          {
            goto _continue1;
          }
          Expr _v_deref__lsplit__expr (_v_lsplit__expr, 0);
          uintptr_t _v_len3 = _v_deref__lsplit__expr.get_len ();
          uintptr_t _v_len4 = 0;
          if (_v_len3 < _v_len4)
          {
            goto _continue1;
          }
          uintptr_t _v_len__1 = (_v_len3 - _v_len4);
          Expr _ve_2 (_v_lsplit__expr, (0 + 1), _v_len__2);
          Expr _ve_1 (_v_deref__lsplit__expr, 0, _v_len__1);
          {
            {
              if (!_vs_inner_m_call_q_.term_eq (_c_59, 0))
              {
                goto _block2__branch1;
              }
              RF_CALL (StdIO::PrintLN_e_, (_vs_channel, empty), /*void*/);
              goto _block2;
            }
          _block2__branch1: {}
          }
        _block2: {}
          {
            {
              if (_ve_0.get_len () != 0)
              {
                goto _block3__branch1;
              }
              {
                {
                  uintptr_t _v_len5 = _v_len__1;
                  uintptr_t _v_len6 = 1;
                  if (_v_len5 < _v_len6)
                  {
                    goto _block4__branch1;
                  }
                  uintptr_t _v_len__label = (_v_len5 - _v_len6);
                  if (!_c_138.term_eq (_ve_1, 0))
                  {
                    goto _block4__branch1;
                  }
                  Expr _ve_label (_ve_1, (0 + 1), _v_len__label);
                  uintptr_t _v_len7 = _ve_indent.get_len ();
                  uintptr_t _v_len8 = 2;
                  if (_v_len7 < _v_len8)
                  {
                    RF_FUNC_ERROR (unexpected_fail);
                  }
                  uintptr_t _v_len__ind = (_v_len7 - _v_len8);
                  if (!Tab.eq (_ve_indent, (0 + _v_len__ind)))
                  {
                    RF_FUNC_ERROR (unexpected_fail);
                  }
                  Expr _ve_ind (_ve_indent, 0, _v_len__ind);
                  RF_CALL (StdIO::PrintLN_e_, (_vs_channel, (_ve_ind + _ve_label)), /*void*/);
                  goto _block4;
                }
              _block4__branch1: {}
                {
                  if (_v_len__1 != 0)
                  {
                    goto _block4__branch2;
                  }
                  RF_CALL (StdIO::PrintLN_e_, (_vs_channel, empty), /*void*/);
                  goto _block4;
                }
              _block4__branch2: {}
                RF_CALL (CPP_m_Pretty_m_Print, (_c_0, _vs_channel, _ve_indent, _ve_1), /*void*/);
              }
            _block4: {}
              goto _block3;
            }
          _block3__branch1: {}
            RF_CALL (StdIO::PrintLN_e_, (_vs_channel, (_ve_indent + _ve_0)), /*void*/);
            RF_CALL (CPP_m_Pretty_m_Print, (_c_0, _vs_channel, (_ve_indent + Tab), _ve_1 ()), /*void*/);
          }
        _block3: {}
          RF_TAILCALL (CPP_m_Pretty_m_Print, (_vs_inner_m_call_q_, _vs_channel, _ve_indent, _ve_2), /*void*/);
          goto _exit1;
        }
    _continue1: {}
      }
    _exit1: {}
      goto _block1;
    }
  _block1__branch1: {}
    {
      uintptr_t _v_len9 = _ve_expr.get_len ();
      uintptr_t _v_len10 = 0;
      if (_v_len9 < (_v_len10 + 1))
      {
        goto _block1__branch2;
      }
      uintptr_t _v_len__12 = (_v_len9 - _v_len10);
      Expr _vv_1 (_ve_expr, 0, _v_len__12);
      RF_TAILCALL (StdIO::PrintLN_e_, (_vs_channel, (_ve_indent + _vv_1)), /*void*/);
      goto _block1;
    }
  _block1__branch2: {}
    if (_ve_expr.get_len () != 0)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
  }
_block1: {}
RF_END

RF_FUNC (Verbose, (RF_ARG _ve_string;;), RF_VOID)
  {
    {
      if (!RF_CALL (Table::In_m_Table_q_, (rfp__helper::RFP_m_Options, _c_139), /*void*/))
      {
        goto _block1__branch1;
      }
      Expr _ge_auxcall1;
      RF_CALL (Dos::Time, /*void*/, _ge_auxcall1);
      RF_TAILCALL (StdIO::PrintLN, (_ge_auxcall1 + _c_140 + _ve_string), /*void*/);
      goto _block1;
    }
  _block1__branch1: {}
  }
_block1: {}
RF_END

RF_FUNC (Open_m_Channel, (RF_ARG _ge_arg1, _ge_arg2;;), (RF_RES _v_res1, _v_res2;;))
  {
    {
      if ((_ge_arg1.get_len () + 1) != 2)
      {
        goto _block1__branch1;
      }
      Expr _v_compose1 ((_ge_arg1 + _ge_arg2 ()));
      if (_v_compose1.symbol_at ((0 + 1)))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__compose1 (_v_compose1, (0 + 1));
      uintptr_t _v_len1 = _v_deref__compose1.get_len ();
      uintptr_t _v_len2 = 0;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len___e__e_tmp_m_rfpcrf_m_672_m_12 = (_v_len1 - _v_len2);
      if (!_v_compose1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _vs_ymbol (_v_compose1, 0, 1);
      Expr _ve__e__e_tmp_m_rfpcrf_m_672_m_12 (_v_deref__compose1, 0, _v_len___e__e_tmp_m_rfpcrf_m_672_m_12);
      if (!RF_CALL (Class::Channel_q_, _vs_ymbol, /*void*/))
      {
        goto _block1__branch1;
      }
      _v_res1 = _vs_ymbol;
      _v_res2 = _c_59;
      goto _block1;
    }
  _block1__branch1: {}
    Expr _vs_channel;
    RF_CALL (StdIO::Channel, /*void*/, _vs_channel);
    {
      {
        if (!RF_CALL (StdIO::Open_m_File, (_vs_channel, (_ge_arg1 + _ge_arg2), _c_141), /*void*/))
        {
          goto _block2__branch1;
        }
        _v_res1 = _vs_channel;
        _v_res2 = _c_0;
        goto _block2;
      }
    _block2__branch1: {}
      RF_CALL (StdIO::PrintLN_e_, (StdIO::StdErr, (_c_143 + _ge_arg1 + _ge_arg2 + _c_142)), /*void*/);
      RF_CALL (Dos::Exit, _c_0, /*void*/);
      RF_FUNC_ERROR (unexpected_fail);
    }
  _block2: {}
  }
_block1: {}
RF_END

RF_FUNC (Extract_m_Inputs, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  {
    {
      uintptr_t _v_len1 = _ge_arg1.get_len ();
      uintptr_t _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__items = (_v_len1 - _v_len2);
      if (_ge_arg1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__arg1 (_ge_arg1, 0);
      uintptr_t _v_len3 = _v_deref__arg1.get_len ();
      uintptr_t _v_len4 = 2;
      if (_v_len3 < _v_len4)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__file_m_name = (_v_len3 - _v_len4);
      if (_v_deref__arg1.symbol_at ((0 + 1)))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__deref__arg1 (_v_deref__arg1, (0 + 1));
      uintptr_t _v_len5 = _v_deref__deref__arg1.get_len ();
      uintptr_t _v_len6 = 0;
      if (_v_len5 < _v_len6)
      {
        goto _block1__branch1;
      }
      uintptr_t _v_len__mod_m_name = (_v_len5 - _v_len6);
      if (!_c_144.term_eq (_v_deref__arg1, 0))
      {
        goto _block1__branch1;
      }
      Expr _ve_items (_ge_arg1, (0 + 1), _v_len__items);
      Expr _ve_file_m_name (_v_deref__arg1, (0 + 1 + 1), _v_len__file_m_name);
      Expr _ve_mod_m_name (_v_deref__deref__arg1, 0, _v_len__mod_m_name);
      Expr _v__q_1;
      RF_CALL (Box::_q_, File::Dir_m_Separator, _v__q_1);
      if (_v__q_1.get_len () != 1)
      {
        goto _block1__branch1;
      }
      if (!_v__q_1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _vs_dir_m_separator (_v__q_1, 0, 1);
      {
        {
          if (_v_len__file_m_name < 1)
          {
            goto _block2__branch1;
          }
          RF_rsplit (_ve_file_m_name, 0, _v_rsplit__file_m_name, _ve_name);
          for ( ; ; RF_iter(_ve_file_m_name)--)
          {
            {
              if (!RF_iter(_ve_file_m_name))
              {
                goto _block2__branch1;
              }
              uintptr_t _v_len7 = _v_rsplit__file_m_name.get_len ();
              uintptr_t _v_len8 = 1;
              if (_v_len7 < _v_len8)
              {
                goto _block2__branch1;
              }
              uintptr_t _v_len__path = (_v_len7 - _v_len8);
              if (!_vs_dir_m_separator.term_eq (_v_rsplit__file_m_name, (0 + _v_len__path)))
              {
                goto _continue1;
              }
              Expr _ve_path (_v_rsplit__file_m_name, 0, _v_len__path);
              {
                {
                  Expr _v__q_2;
                  RF_CALL (Box::_q_, RFP_m_Boot_m_Path, _v__q_2);
                  if (_v__q_2.get_len () < 1)
                  {
                    goto _block3__branch1;
                  }
                  RF_lsplit (_v__q_2, 0, _ve__e__e_tmp_m_rfpcrf_m_686_m_29, _v_lsplit___q_2);
                  for ( ; ; RF_iter(_v__q_2)++)
                  {
                    {
                      if (!RF_iter(_v__q_2))
                      {
                        goto _block3__branch1;
                      }
                      uintptr_t _v_len9 = _v_lsplit___q_2.get_len ();
                      uintptr_t _v_len10 = 1;
                      if (_v_len9 < _v_len10)
                      {
                        goto _block3__branch1;
                      }
                      uintptr_t _v_len___e__e_tmp_m_rfpcrf_m_686_m_47 = (_v_len9 - _v_len10);
                      if (_v_lsplit___q_2.symbol_at (0))
                      {
                        goto _continue2;
                      }
                      Expr _v_deref__lsplit___q_2 (_v_lsplit___q_2, 0);
                      uintptr_t _v_len11 = _v_deref__lsplit___q_2.get_len ();
                      uintptr_t _v_len12 = _v_len__path;
                      if (_v_len11 < _v_len12)
                      {
                        goto _continue2;
                      }
                      uintptr_t _v_len__rest = (_v_len11 - _v_len12);
                      if (!_ve_path.eq (_v_deref__lsplit___q_2, 0))
                      {
                        goto _continue2;
                      }
                      Expr _ve__e__e_tmp_m_rfpcrf_m_686_m_47 (_v_lsplit___q_2, (0 + 1), _v_len___e__e_tmp_m_rfpcrf_m_686_m_47);
                      Expr _ve_rest (_v_deref__lsplit___q_2, (0 + _v_len__path), _v_len__rest);
                      {
                        if (_v_len__rest < 1)
                        {
                          goto _block4__branch1;
                        }
                        RF_lsplit (_ve_rest, 0, _ve_1, _v_lsplit__rest);
                        for ( ; ; RF_iter(_ve_rest)++)
                        {
                          {
                            if (!RF_iter(_ve_rest))
                            {
                              goto _block4__branch1;
                            }
                            uintptr_t _v_len13 = _v_lsplit__rest.get_len ();
                            uintptr_t _v_len14 = 1;
                            if (_v_len13 < _v_len14)
                            {
                              goto _block4__branch1;
                            }
                            uintptr_t _v_len__3 = (_v_len13 - _v_len14);
                            if (!_v_lsplit__rest.symbol_at (0))
                            {
                              goto _continue3;
                            }
                            Expr _vs_2 (_v_lsplit__rest, 0, 1);
                            Expr _ve_3 (_v_lsplit__rest, (0 + 1), _v_len__3);
                            {
                              if (!_vs_dir_m_separator.term_eq (_vs_2, 0))
                              {
                                goto _block5__branch1;
                              }
                              goto _continue3;
                            }
                          _block5__branch1: {}
                            goto _continue2;
                          }
                      _continue3: {}
                        }
                      _exit3: {}
                      }
                    _block4__branch1: {}
                      RF_CALL (Table::Bind, (RFP_m_Includes, _ve_mod_m_name, (_c_73 + _ve_path + _vs_dir_m_separator)), /*void*/);
                      goto _exit2;
                    }
                _continue2: {}
                  }
                _exit2: {}
                  goto _block3;
                }
              _block3__branch1: {}
                Expr _ge_path__7;
                {
                  {
                    if (_v_len__path != 1)
                    {
                      goto _block6__branch1;
                    }
                    if (!_c_13.term_eq (_ve_path, 0))
                    {
                      goto _block6__branch1;
                    }
                    _ge_path__7 = empty;
                    goto _block6;
                  }
                _block6__branch1: {}
                  {
                    uintptr_t _v_len15 = _v_len__path;
                    uintptr_t _v_len16 = 2;
                    if (_v_len15 < _v_len16)
                    {
                      goto _block6__branch2;
                    }
                    uintptr_t _v_len__rest2 = (_v_len15 - _v_len16);
                    if (!_c_13.term_eq (_ve_path, 0))
                    {
                      goto _block6__branch2;
                    }
                    if (!_vs_dir_m_separator.term_eq (_ve_path, (0 + 1)))
                    {
                      goto _block6__branch2;
                    }
                    Expr _ve_rest (_ve_path, (0 + 1 + 1), _v_len__rest2);
                    {
                      {
                        if (_v_len__rest2 < 1)
                        {
                          goto _block7__branch1;
                        }
                        RF_lsplit (_ve_rest, 0, _ve_1, _v_lsplit__rest2);
                        for ( ; ; RF_iter(_ve_rest)++)
                        {
                          {
                            if (!RF_iter(_ve_rest))
                            {
                              goto _block7__branch1;
                            }
                            uintptr_t _v_len17 = _v_lsplit__rest2.get_len ();
                            uintptr_t _v_len18 = 1;
                            if (_v_len17 < _v_len18)
                            {
                              goto _block7__branch1;
                            }
                            uintptr_t _v_len__32 = (_v_len17 - _v_len18);
                            if (!_v_lsplit__rest2.symbol_at (0))
                            {
                              goto _continue4;
                            }
                            Expr _vs_2 (_v_lsplit__rest2, 0, 1);
                            Expr _ve_3 (_v_lsplit__rest2, (0 + 1), _v_len__32);
                            {
                              if (!_vs_dir_m_separator.term_eq (_vs_2, 0))
                              {
                                goto _negation1;
                              }
                              goto _continue4;
                            }
                          _negation1: {}
                            _ge_path__7 = (_vs_2 + _ve_3 + _vs_dir_m_separator);
                            goto _exit4;
                          }
                      _continue4: {}
                        }
                      _exit4: {}
                        goto _block7;
                      }
                    _block7__branch1: {}
                      _ge_path__7 = empty;
                    }
                  _block7: {}
                    goto _block6;
                  }
                _block6__branch2: {}
                  _ge_path__7 = (_ve_path + _vs_dir_m_separator);
                }
              _block6: {}
                RF_CALL (Table::Bind, (RFP_m_Includes, _ve_mod_m_name, (_c_79 + _ge_path__7)), /*void*/);
              }
            _block3: {}
              goto _exit1;
            }
        _continue1: {}
          }
        _exit1: {}
          goto _block2;
        }
      _block2__branch1: {}
        RF_CALL (Table::Bind, (RFP_m_Includes, _ve_mod_m_name, _c_79), /*void*/);
      }
    _block2: {}
      RF_TAILCALL (Extract_m_Inputs, _ve_items, _v_res1);
      goto _block1;
    }
  _block1__branch1: {}
    {
      {
        if (!RF_CALL (Table::In_m_Table_q_, (rfp__helper::RFP_m_Options, _c_130), /*void*/))
        {
          goto _block9__branch1;
        }
        RF_CALL (Table::Bind, (RFP_m_Includes, _c_145, _c_73), /*void*/);
        goto _block9;
      }
    _block9__branch1: {}
    }
  _block9: {}
    _v_res1 = _ge_arg1;
  }
_block1: {}
RF_END

RF_FUNC (Compilation_m_Failed, RF_VOID, RF_VOID)
  RF_TAILCALL (Dos::Exit, _c_0, /*void*/);
RF_END

RF_FUNC (Version, RF_VOID, (RF_RES _v_res1;;))
  {
    {
      if (RevDate.symbol_at (0))
      {
        goto _block1__branch1;
      }
      if (RevDate.symbol_at ((0 + 1)))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__RevDate (RevDate, 0);
      Expr _v_deref__RevDate2 (RevDate, (0 + 1));
      if (_v_deref__RevDate2.get_len () < 3)
      {
        goto _block1__branch1;
      }
      if (_v_deref__RevDate.get_len () < 3)
      {
        goto _block1__branch1;
      }
      RF_lsplit (_v_deref__RevDate, 0, _ve__e__e_tmp_m_rfpcrf_m_719_m_16, _v_lsplit__deref__RevDate);
      for ( ; ; RF_iter(_v_deref__RevDate)++)
      {
        {
          if (!RF_iter(_v_deref__RevDate))
          {
            goto _block1__branch1;
          }
          if (_v_lsplit__deref__RevDate.get_len () < 3)
          {
            goto _block1__branch1;
          }
          if (!_c_10.term_eq (_v_lsplit__deref__RevDate, 0))
          {
            goto _continue1;
          }
          Expr _v_subexpr__lsplit__deref__RevDate (_v_lsplit__deref__RevDate, (0 + 1), (_v_lsplit__deref__RevDate.get_len () - (0 + 1 + 0)));
          RF_lsplit (_v_subexpr__lsplit__deref__RevDate, 1, _vv_rev, _v_lsplit__lsplit__deref__RevDate);
          for ( ; ; RF_iter(_v_subexpr__lsplit__deref__RevDate)++)
          {
            {
              if (!RF_iter(_v_subexpr__lsplit__deref__RevDate))
              {
                goto _continue1;
              }
              uintptr_t _v_len1 = _v_lsplit__lsplit__deref__RevDate.get_len ();
              uintptr_t _v_len2 = 1;
              if (_v_len1 < _v_len2)
              {
                goto _continue1;
              }
              uintptr_t _v_len___e__e_tmp_m_rfpcrf_m_719_m_32 = (_v_len1 - _v_len2);
              if (!_c_10.term_eq (_v_lsplit__lsplit__deref__RevDate, 0))
              {
                goto _continue2;
              }
              Expr _ve__e__e_tmp_m_rfpcrf_m_719_m_32 (_v_lsplit__lsplit__deref__RevDate, (0 + 1), _v_len___e__e_tmp_m_rfpcrf_m_719_m_32);
              RF_lsplit (_v_deref__RevDate2, 0, _ve__e__e_tmp_m_rfpcrf_m_719_m_36, _v_lsplit__deref__RevDate2);
              for ( ; ; RF_iter(_v_deref__RevDate2)++)
              {
                {
                  if (!RF_iter(_v_deref__RevDate2))
                  {
                    goto _continue2;
                  }
                  if (_v_lsplit__deref__RevDate2.get_len () < 3)
                  {
                    goto _continue2;
                  }
                  if (!_c_10.term_eq (_v_lsplit__deref__RevDate2, 0))
                  {
                    goto _continue3;
                  }
                  Expr _v_subexpr__lsplit__deref__RevDate2 (_v_lsplit__deref__RevDate2, (0 + 1), (_v_lsplit__deref__RevDate2.get_len () - (0 + 1 + 0)));
                  RF_lsplit (_v_subexpr__lsplit__deref__RevDate2, 1, _vv_date, _v_lsplit__lsplit__deref__RevDate2);
                  for ( ; ; RF_iter(_v_subexpr__lsplit__deref__RevDate2)++)
                  {
                    {
                      if (!RF_iter(_v_subexpr__lsplit__deref__RevDate2))
                      {
                        goto _continue3;
                      }
                      uintptr_t _v_len3 = _v_lsplit__lsplit__deref__RevDate2.get_len ();
                      uintptr_t _v_len4 = 1;
                      if (_v_len3 < _v_len4)
                      {
                        goto _continue3;
                      }
                      uintptr_t _v_len___e__e_tmp_m_rfpcrf_m_719_m_53 = (_v_len3 - _v_len4);
                      if (!_c_10.term_eq (_v_lsplit__lsplit__deref__RevDate2, 0))
                      {
                        goto _continue4;
                      }
                      Expr _ve__e__e_tmp_m_rfpcrf_m_719_m_53 (_v_lsplit__lsplit__deref__RevDate2, (0 + 1), _v_len___e__e_tmp_m_rfpcrf_m_719_m_53);
                      _v_res1 = (_c_147 + _vv_rev + _c_146 + _vv_date);
                      goto _exit4;
                    }
                _continue4: {}
                  }
                _exit4: {}
                  goto _exit3;
                }
            _continue3: {}
              }
            _exit3: {}
              goto _exit2;
            }
        _continue2: {}
          }
        _exit2: {}
          goto _exit1;
        }
    _continue1: {}
      }
    _exit1: {}
      goto _block1;
    }
  _block1__branch1: {}
    _v_res1 = _c_148;
  }
_block1: {}
RF_END

}

namespace rfpc
{

static void init_ ()
{
  RFP_m_Root = rftype::Char::create_expr (L"/usr");
  RFP_m_Default_m_Include_m_Path = (Char::create_expr ("/usr//lib/refal-plus")) ();
  RFP_m_Boot_m_Path = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"RFP-Boot-Path");
  RFP_m_Include_m_Path = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"RFP-Include-Path");
  RFP_m_Token_m_Stack = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"RFP-Token-Stack");
  RFP_m_Trace = new rftype::StaticObject<rftype::Table>(L"RFP-Trace");
  RFP_m_Includes = new rftype::StaticObject<rftype::Table>(L"RFP-Includes");
  RevDate = (rftype::Char::create_expr (L"$Revision: 2387 $")) () + (rftype::Char::create_expr (L"$Date: 2007-02-11 10:35:05 +0300 (Sun, 11 Feb 2007) $")) ();
  Options = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Options");
  Tab = rftype::Char::create_expr (L"  ");
  _c_0 = Expr::create<rftype::Integer>("1");
  _c_58 = rftype::Char::create_expr (L"\n#include <rf_core.hh>");
  _c_54 = Expr (_c_58, 18, 3);
  _c_149 = ((Expr (_c_54, 1, 1)) () + (rftype::Char::create_expr (L"help")) ()) () + Expr::create<rftype::Word>("HELP");
  _c_1 = Expr (_c_149, 1, 1);
  _c_2 = rftype::Char::create_expr (L"Refal+ compiler ");
  _c_3 = rftype::Char::create_expr (L"Usage: rfpc");
  _c_4 = Expr::create<rftype::Integer>("3");
  _c_5 = rftype::Char::create_expr (L">]");
  _c_6 = Expr (_c_58, 9, 2);
  _c_7 = rftype::Char::create_expr (L" [-");
  _c_8 = Expr (_c_5, 1, 1);
  _c_9 = Expr::create<rftype::Integer>("64");
  _c_10 = Expr (_c_7, 0, 1);
  _c_11 = rftype::Char::create_expr (L" file ...");
  _c_12 = rftype::Char::create_expr (L"No input files specified");
  _c_13 = Expr (_c_11, 6, 1);
  _c_14 = Expr (_c_11, 5, 2);
  _c_150 = rftype::Char::create_expr (L"no-check");
  _c_151 = Expr (_c_150, 0, 2);
  _c_152 = ((Expr (_c_151, 1, 1)) ()) () + Expr::create<rftype::Word>("NAME") + (Expr::create<rftype::Word>("name| - ")) () + Expr::create<rftype::Word>("place outputs for file1 into files <name>.* or send") + Expr::create<rftype::Word>("them to stdout");
  _c_15 = Expr (_c_152, 1, 1);
  _c_55 = rftype::Char::create_expr (L"_hh__");
  _c_16 = (Expr (_c_55, 0, 1)) ();
  _c_18 = rftype::Char::create_expr (L" .rfi");
  _c_17 = Expr (_c_18, 0, 4);
  _c_19 = Expr::create<rftype::Word>(": parsing started");
  _c_20 = Expr::create<rftype::Word>(": parsing finished");
  _c_153 = Expr::create<rftype::Word>("BIND") + Expr::create<rftype::Word>("AS-REFAL");
  _c_21 = Expr (_c_153, 1, 1);
  _c_22 = rftype::Char::create_expr (L" .asr");
  _c_23 = Expr::create<rftype::Word>("R");
  _c_24 = rftype::Char::create_expr (L" .ast");
  _c_154 = Expr::create<rftype::Word>("BIND") + Expr::create<rftype::Word>("AS-TRANSFORMED");
  _c_25 = Expr (_c_154, 1, 1);
  _c_26 = rftype::Char::create_expr (L" .asi");
  _c_27 = Expr::create<rftype::Word>("AS-AIL") + Expr::create<rftype::Word>("AS-AIL");
  _c_28 = Expr (_c_27, 0, 1);
  _c_29 = Expr::create<rftype::Word>(" in ");
  _c_30 = Expr::create<rftype::Word>("Error: unknown extension");
  _c_31 = Expr (_c_22, 1, 4);
  _c_155 = Expr::create<rftype::Word>("BIND") + Expr::create<rftype::Word>("NO-CHECK");
  _c_32 = Expr (_c_155, 1, 1);
  _c_33 = Expr::create<rftype::Word>("syntax check started");
  _c_34 = Expr::create<rftype::Word>("syntax check finished");
  _c_156 = Expr::create<rftype::Word>("BIND") + Expr::create<rftype::Word>("CC");
  _c_35 = Expr (_c_156, 1, 1);
  _c_157 = Expr::create<rftype::Word>("BIND") + Expr::create<rftype::Word>("HH");
  _c_36 = Expr (_c_157, 1, 1);
  _c_158 = Expr::create<rftype::Word>("BIND") + Expr::create<rftype::Word>("JAVA");
  _c_37 = Expr (_c_158, 1, 1);
  _c_159 = Expr::create<rftype::Word>("BIND") + Expr::create<rftype::Word>("JBC");
  _c_38 = Expr (_c_159, 1, 1);
  _c_160 = Expr::create<rftype::Word>("BIND") + Expr::create<rftype::Word>("TPP");
  _c_39 = Expr (_c_160, 1, 1);
  _c_161 = Expr::create<rftype::Word>("BIND") + Expr::create<rftype::Word>("NO-TRANSFORM");
  _c_40 = Expr (_c_161, 1, 1);
  _c_41 = Expr::create<rftype::Word>("as-to-as transformation started");
  _c_42 = Expr::create<rftype::Word>("as-to-as transformation finished");
  _c_43 = Expr (_c_24, 1, 4);
  _c_44 = Expr::create<rftype::Word>("compilation to abstract imperative language started");
  _c_45 = Expr::create<rftype::Word>("INTERFACE");
  _c_46 = Expr::create<rftype::Word>("MODULE");
  _c_47 = Expr::create<rftype::Word>("compilation to abstract imperative language finished");
  _c_162 = Expr::create<rftype::Word>("BIND") + Expr::create<rftype::Word>("NO-OPTIM");
  _c_48 = Expr (_c_162, 1, 1);
  _c_49 = Expr::create<rftype::Word>("as-ail optimization started");
  _c_50 = Expr::create<rftype::Word>("as-ail optimization finished");
  _c_51 = Expr (_c_26, 1, 4);
  _c_52 = Expr::create<rftype::Word>("headers generation started");
  _c_53 = Expr::create<rftype::Word>("headers generation finished");
  _c_56 = rftype::Char::create_expr (L"#ifndef __");
  _c_57 = rftype::Char::create_expr (L"#define __");
  _c_59 = Expr::create<rftype::Integer>("0");
  _c_60 = rftype::Char::create_expr (L"\n#endif // __");
  _c_163 = Expr::create<rftype::Word>("BIND") + Expr::create<rftype::Word>("CASE-INSENSITIVE");
  _c_61 = Expr (_c_163, 1, 1);
  _c_62 = Expr (_c_58, 18, 4);
  _c_63 = Expr (_c_58, 0, 11);
  _c_64 = rftype::Char::create_expr (L"\nnamespace refal\n{");
  _c_90 = rftype::Char::create_expr (L";\n");
  _c_65 = Expr (_c_90, 0, 1);
  _c_66 = rftype::Char::create_expr (L" = ");
  _c_67 = Expr (_c_64, 0, 11);
  _c_68 = rftype::Char::create_expr (L"\n}");
  _c_69 = Expr::create<rftype::Word>("compilation from as-ail to c++ started");
  _c_70 = Expr::create<rftype::Word>("compilation from as-ail to c++ finished");
  _c_71 = rftype::Char::create_expr (L".cc");
  _c_72 = Expr (_c_58, 1, 21);
  _c_73 = Expr::create<rftype::Word>("BOOT");
  _c_74 = rftype::Char::create_expr (L"<refal/");
  _c_75 = rftype::Char::create_expr (L"wrappers");
  _c_92 = rftype::Char::create_expr (L"import org.refal.plus.*;");
  _c_76 = Expr (_c_92, 17, 4);
  _c_77 = Expr (_c_74, 1, 5);
  _c_78 = Expr (_c_92, 7, 3);
  _c_79 = Expr::create<rftype::Word>("LOCAL");
  _c_80 = rftype::Char::create_expr (L".hh\"");
  _c_81 = Expr (_c_80, 3, 1);
  _c_82 = Expr (_c_63, 1, 9);
  _c_83 = Expr::create<rftype::Word>("compilation from as-ail to T++ started");
  _c_84 = Expr::create<rftype::Word>("compilation from as-ail to T++ finished");
  _c_85 = rftype::Char::create_expr (L".tpp");
  _c_86 = Expr::create<rftype::Word>("compilation from as-ail to java started");
  _c_87 = Expr::create<rftype::Word>("compilation from as-ail to java finished");
  _c_88 = rftype::Char::create_expr (L".java");
  _c_89 = (_c_13) ();
  _c_91 = rftype::Char::create_expr (L"package ");
  _c_93 = rftype::Char::create_expr (L"org.refal.plus.library.");
  _c_94 = Expr (_c_92, 0, 7);
  _c_95 = Expr::create<rftype::Word>("compilation from as-ail to java-bytecode started");
  _c_96 = Expr::create<rftype::Word>(".class");
  _c_97 = Expr::create<rftype::Word>("compilation from as-ail to java-bytecode finished");
  _c_164 = Expr::create<rftype::Word>("dir");
  _c_165 = ((rftype::Char::create_expr (L"I")) () + (rftype::Char::create_expr (L"ipath")) ()) () + Expr::create<rftype::Word>("IPATH") + (_c_164) () + Expr::create<rftype::Word>("add <dir> to the list of directories to be searched") + Expr::create<rftype::Word>("for .rfi files");
  _c_166 = ((rftype::Char::create_expr (L"B")) () + (rftype::Char::create_expr (L"bootpath")) ()) () + Expr::create<rftype::Word>("BPATH") + (_c_164) () + Expr::create<rftype::Word>("add <dir> to the list of directories to be searched") + Expr::create<rftype::Word>("for standard library .rfi files");
  _c_167 = Expr (_c_57, 5, 2);
  _c_168 = Expr (_c_82, 2, 2);
  _c_169 = rftype::Char::create_expr (L"entry");
  _c_170 = Expr (_c_169, 1, 2);
  _c_171 = Expr::create<rftype::Word>("BIND") + Expr::create<rftype::Word>("CHECK");
  _c_172 = ((Expr (_c_12, 18, 2)) () + (rftype::Char::create_expr (L"comp-item")) ()) () + Expr::create<rftype::Word>("COMP-ITEM") + (Expr::create<rftype::Word>("item")) () + Expr::create<rftype::Word>("compile <item> only, not the whole source") + Expr::create<rftype::Word>("(may be used several times)");
  _c_173 = ((Expr (_c_167, 1, 1)) () + (_c_169) ()) () + Expr::create<rftype::Word>("ENTRY") + (Expr::create<rftype::Word>("func")) () + Expr::create<rftype::Word>("use function <func> as an entry to the program");
  _c_174 = Expr::create<rftype::Word>("BIND") + Expr::create<rftype::Word>("VERBOSE");
  _c_175 = rftype::Char::create_expr (L"as-ail");
  _c_176 = Expr::create<rftype::Word>("BIND") + Expr::create<rftype::Word>("AS-AIL");
  _c_177 = ((rftype::Char::create_expr (L"int")) ()) () + Expr::create<rftype::Word>("INT") + (Expr::create<rftype::Word>("class_name")) () + Expr::create<rftype::Word>("class to use for literal integers");
  _c_178 = ((rftype::Char::create_expr (L"replace-module")) ()) () + Expr::create<rftype::Word>("REPLACE-MODULE") + (Expr::create<rftype::Word>("m1") + Expr::create<rftype::Word>("m2")) () + Expr::create<rftype::Word>("use module <m2> instead of <m1>");
  _c_179 = Expr::create<rftype::Word>("BIND") + Expr::create<rftype::Word>("DBG");
  _c_180 = rftype::Char::create_expr (L"traceall");
  _c_181 = ((Expr (_c_180, 0, 5)) ()) () + Expr::create<rftype::Word>("TRACE") + (Expr::create<rftype::Word>("fname")) () + Expr::create<rftype::Word>("trace function <fname> (may be used several times)");
  _c_98 = (_c_165) () + (_c_166) () + (((_c_167) () + (rftype::Char::create_expr (L"no-elaborate")) ()) () + (Expr::create<rftype::Word>("BIND") + Expr::create<rftype::Word>("NO-ELABORATE")) ()) () + (((_c_168) () + (_c_150) ()) () + (_c_155) () + Expr::create<rftype::Word>("don't perform syntax check")) () + (((_c_170) () + (rftype::Char::create_expr (L"no-transform")) ()) () + (_c_161) () + Expr::create<rftype::Word>("don't perform AS-to-AS transformations")) () + (((Expr (_c_168, 1, 1)) () + (Expr (_c_150, 3, 5)) ()) () + (_c_171) () + Expr::create<rftype::Word>("check only, causes no file creation in the absence") + Expr::create<rftype::Word>("of other output control options")) () + (((_c_151) () + (rftype::Char::create_expr (L"no-optim")) ()) () + (_c_162) () + Expr::create<rftype::Word>("don't perform ASAIL-optimization")) () + (_c_172) () + (_c_173) () + (_c_149) () + (((Expr (_c_88, 3, 1)) () + (rftype::Char::create_expr (L"verbose")) ()) () + (_c_174) () + Expr::create<rftype::Word>("display information about the stages of compilation")) () + (((Expr (_c_76, 2, 1)) ()) () + (_c_163) () + Expr::create<rftype::Word>("convert all symbol-words without surrounding quotes") + Expr::create<rftype::Word>("to upper case")) () + (_c_152) () + (((Expr (_c_71, 1, 2)) ()) () + (_c_156) () + Expr::create<rftype::Word>("output C++ code")) () + (((Expr (_c_54, 1, 2)) ()) () + (_c_157) () + Expr::create<rftype::Word>("generate header files")) () + (((Expr (_c_88, 1, 1)) () + (Expr (_c_88, 1, 4)) ()) () + (_c_158) () + Expr::create<rftype::Word>("output Java code")) () + (((rftype::Char::create_expr (L"jbc")) ()) () + (_c_159) () + Expr::create<rftype::Word>("output Java byte-code")) () + (((Expr (_c_170, 1, 1)) () + (rftype::Char::create_expr (L"t++")) ()) () + (_c_160) () + Expr::create<rftype::Word>("output T++ code")) () + (((Expr (_c_22, 2, 3)) () + (rftype::Char::create_expr (L"as-refal")) ()) () + (_c_153) () + Expr::create<rftype::Word>("output Refal Abstract Syntax")) () + (((Expr (_c_43, 1, 3)) () + (rftype::Char::create_expr (L"as-transformed")) ()) () + (_c_154) () + Expr::create<rftype::Word>("output Refal Abstract Syntax after AS-to-AS") + Expr::create<rftype::Word>("transformations")) () + (((Expr (_c_51, 1, 3)) () + (_c_175) ()) () + (_c_176) () + Expr::create<rftype::Word>("output Abstract Syntax of Abstract Imperative") + Expr::create<rftype::Word>("Language")) () + (_c_177) () + (_c_178) () + (((Expr (_c_82, 6, 1)) () + (rftype::Char::create_expr (L"debug")) ()) () + (Expr::create<rftype::Word>("BIND") + Expr::create<rftype::Word>("DEBUG")) ()) () + (((rftype::Char::create_expr (L"dbg")) ()) () + (_c_179) () + Expr::create<rftype::Word>("generate text for debugger")) () + (_c_181) () + (((_c_180) ()) () + (Expr::create<rftype::Word>("BIND") + Expr::create<rftype::Word>("TRACEALL")) () + Expr::create<rftype::Word>("trace all functions")) ();
  _c_99 = Expr::create<rftype::Integer>("29");
  _c_100 = Expr::create<rftype::Word>("Refal+ compiler ");
  _c_101 = Expr::create<rftype::Word>("Copyright blah-blah-blah");
  _c_102 = Expr::create<rftype::Word>("Usage: rfpc [options] file1 [file2 ...]");
  _c_103 = Expr::create<rftype::Word>("Options:");
  _c_104 = Expr (_c_175, 2, 1);
  _c_105 = rftype::Char::create_expr (L", -");
  _c_106 = Expr (_c_5, 0, 1);
  _c_107 = Expr (_c_165, 1, 1);
  _c_108 = Expr (_c_166, 1, 1);
  _c_109 = Expr (_c_172, 1, 1);
  _c_110 = Expr::create<rftype::Word>("ITEMS");
  _c_111 = Expr (_c_173, 1, 1);
  _c_112 = Expr::create<rftype::Word>("ENTRIES");
  _c_113 = Expr (_c_181, 1, 1);
  _c_114 = Expr (_c_177, 1, 1);
  _c_115 = Expr (_c_178, 1, 1);
  _c_116 = Expr::create<rftype::Word>("REPLACE-MODULE-2");
  _c_117 = Expr (_c_176, 0, 1);
  _c_118 = Expr::create<rftype::Word>("\"");
  _c_119 = Expr::create<rftype::Word>("Unknown option \"-");
  _c_120 = Expr::create<rftype::Word>("Last option requires parameter");
  _c_121 = Expr (_c_171, 1, 1);
  _c_182 = Expr::create<rftype::Word>("PRAGMA");
  _c_183 = (Expr::create<rftype::Word>("EVAR")) ();
  _c_134 = Expr::create<rftype::Word>("IMPORT") + Expr::create<rftype::Word>("FUNC") + (_c_182) () + (_c_183) () + (empty) ();
  _c_122 = Expr (_c_134, 1, 1);
  _c_123 = Expr::create<rftype::Integer>("2");
  _c_124 = Expr::create<rftype::Word>("TFUNC");
  _c_132 = Expr::create<rftype::Word>("IMPORT") + Expr::create<rftype::Word>("FUNC?") + (_c_182) () + (_c_183) () + (empty) ();
  _c_129 = Expr (_c_132, 0, 2);
  _c_125 = Expr (_c_129, 1, 1);
  _c_126 = Expr::create<rftype::Word>("CONST");
  _c_127 = Expr::create<rftype::Word>("EXTERN");
  _c_128 = (_c_183) () + (_c_183) ();
  _c_130 = Expr (_c_179, 1, 1);
  _c_131 = (Expr::create<rftype::Word>("Debug") + Expr::create<rftype::Word>("Stop?")) ();
  _c_184 = Expr::create<rftype::Word>("Debug") + Expr::create<rftype::Word>("Debug");
  _c_133 = (_c_184) ();
  _c_135 = rftype::Char::create_expr (L"(");
  _c_136 = rftype::Char::create_expr (L"  ");
  _c_137 = rftype::Char::create_expr (L")");
  _c_138 = Expr::create<rftype::Word>("LABEL");
  _c_139 = Expr (_c_174, 1, 1);
  _c_140 = Expr::create<rftype::Word>(": ");
  _c_141 = Expr::create<rftype::Word>("W");
  _c_142 = Expr::create<rftype::Word>(" for writing");
  _c_143 = Expr::create<rftype::Word>("Error: cannot open file ");
  _c_144 = Expr::create<rftype::Word>("INPUT");
  _c_145 = Expr (_c_184, 0, 1);
  _c_146 = Expr (_c_105, 0, 2);
  _c_147 = rftype::Char::create_expr (L"2.0-beta-");
  _c_148 = rftype::Char::create_expr (L"2.0-unknown-beta");
}

static AtStart init_registrator_ (&init_);

}

rfrt::Entry rf_entry (rfpc::Main);

}
